/**
 * 资讯-要闻
 */
define(function(require, exports, module) {
	var _pageId = "#business_moduleIncrease ";
	var appUtils = require("appUtils");
	var layerUtils = require("layerUtils");
	var service_news = require("serviceNews");
	var external = require("external");
	
	var _catalogid = "";   //所属栏目ID
	var _curpage = "1";   //当前页
	var _rowofpage = "20";   //没也的行数
	var _totalPage = "1";   //后台返回的总页数
	
	var _currentCheckIndex = 0;
	
	//上下滑动组件
	var VIscroll = require("vIscroll");
	var vIscroll = {"scroll":null,"_init":false}; 
	//左右自由滑动组件
	var shIscroll = require("shIscroll");
	var mySHIscroll = null;
	
	
	//初始化
	function init() {
		
		initHIScroll();//初始化左右滑动组件函数的调用
		
		//3：直播,4：板块,5：个股,6：财经,7：国际,8：宏观,9：新股,11：基金
		_catalogid = appUtils.getSStorageInfo("toParam");
		console.log("获取到的所属栏目ID _catalogid = " + _catalogid);
		
		if(_catalogid == "" || _catalogid == null){
			layerUtils.iAlert("所属栏目ID未能成功获取!");
			return;
		}
		
		switch (_catalogid) {
			case "3":
				$(_pageId + "#news_zhibo").parent().attr("class","active").siblings().removeAttr("class");
				break;
				
			case "4":
				$(_pageId + "#news_bankuai").parent().attr("class","active").siblings().removeAttr("class");
				break;
				
			case "5":
				$(_pageId + "#news_gegu").parent().attr("class","active").siblings().removeAttr("class");
				break;
				
			case "6":
				$(_pageId + "#news_caijing").parent().attr("class","active").siblings().removeAttr("class");
				break;
		
			case "7":
				$(_pageId + "#news_guoji").parent().attr("class","active").siblings().removeAttr("class");
				break;
			
			case "8":
				$(_pageId + "#news_hongguan").parent().attr("class","active").siblings().removeAttr("class");
				break;
			
			case "9":
				$(_pageId + "#news_xingu").parent().attr("class","active").siblings().removeAttr("class");
				break;
			
			case "11":
				$(_pageId + "#news_jijin").parent().attr("class","active").siblings().removeAttr("class");
				break;
	
			default:
				$(_pageId + ".header .new_tab ul li").removeAttr("class");
				break;
		}
		
		//点击过程中的左右滑动是选中的栏目居中
		_currentCheckIndex = $(_pageId + ".header .new_tab ul li[class=active]").index();
		mySHIscroll ? mySHIscroll.scrollToElement($(_pageId + ".new_tab li").eq(_currentCheckIndex ? (_currentCheckIndex - 1) : 0), 500) : "";
		
		//查询相关模块数据
		queryModuleIncreaseData();
	}
	
	
	//事件绑定
	function bindPageEvent() {
		//首页返回键回到主页面
		appUtils.bindEvent($(_pageId + ".top_title a"), function(e) {
			external.callMessage({"moduleName":"home","funcNo": "50101"});
			e.stopPropagation();
		},"click");
		
		//头部栏目标题的事件处理
		appUtils.bindEvent($(_pageId + ".header .new_tab ul li a"), function(e) {
			//点击过程中的左右滑动是选中的栏目居中
			_currentCheckIndex = $(this).parent().index();
			mySHIscroll ? mySHIscroll.scrollToElement($(_pageId + ".new_tab li").eq(_currentCheckIndex ? (_currentCheckIndex - 1) : 0), 500) : "";
			
			var curPageCode = $("body #content div.page[data-display=block]").attr("id").replace("_","/");
			var toPage = $(this).attr("to-page").replace("_","/");
			var toParam = $(this).attr("to_param");
			if(toPage == "business/importantNews" || toPage == "business/optionalShares" || toPage == "business/shAndSz"){
				$(this).parent().removeAttr("class");
				appUtils.pageInit(curPageCode, toPage);
			}else{
				appUtils.setSStorageInfo("toParam",toParam);   //保存获取的栏目ID
				appUtils.pageInit(curPageCode, "business/moduleIncrease");
			}
			e.stopPropagation();
		},"click");
	}
	
	//查询服务器数据
	function queryModuleIncreaseData(){
		var queryModuleIncreaseDataParam = {
			"catalogid":_catalogid, //所属栏目ID  "1.自选    3.直播   4.板块  5.个股  6.财经  7.国际  8.宏观  9.新股 10.基金"
			"areacode":"",  //信息地域划分 142:大陆，110:港股，502:美股
			"curpage":_curpage,   //当前页
			"rowofpage":_rowofpage  //每页的行数
		};
		
		//请求数据
		service_news.queryModuleIncrease(queryModuleIncreaseDataParam,queryModuleIncreaseDataCallback,{
			"isLastReq":true,                
			"isShowWait":true,
			"isShowOverLay":true
	    });
		
		//请求数据回调
		function queryModuleIncreaseDataCallback(data){
			if(data.error_no == 0){
				var results = data.results;
				if(results && results != "undefined" && results.length > 0){
					_totalPage=data.results[0].totalPages;	//数据的总页数
					
					var strHtmls = "";
					for(var i=0 ; i<results.length ; i++){
						var item = results[i];
						var id = item.id;	//资讯要闻  -- 编号
						var media = item.media;					//资讯要闻  -- 媒体出处
						var infotitle = item.title;			//文章标题
						//资讯要闻  -- 文章标题
						var updatetime = item.updatetime;				//资讯要闻  -- 采集时间
						
						var yearTime = "";
						var dayTime = "";
						if(updatetime != ""){
							yearTime = updatetime.substring(0,10);
							dayTime = updatetime.substring(11,item.updatetime.length);
						}
						var time = updatetime.substring(10,16);	//设置时间格式
						strHtmls += "<li data-id="+id+" data-yearTime="+yearTime+" data-dayTime="+dayTime+"><a href=\"javascript:void(0);\"><p>"+infotitle+"</p><span style=\"float:left\">"+media+"</span><span style=\"margin-left:70px;\">"+time+"</span></a></li>";
					}
					
					if(_curpage == 1){
						//如果加载页码为1，要清空原有数据，加载第一页数据
						$(_pageId + " .pro_main ul").html(strHtmls);
					}else{
						$(_pageId + " .pro_main ul").append(strHtmls);
					}
					
					initVIScroll();   //初始化上下滑动组件
					
					/**
					 * 为每条资讯要闻 数据 绑定 详情信息
					 */
					appUtils.bindEvent($(_pageId + ".nli li"), function() {
						//获取当前你要点击的资讯要闻数据的id
						var data_id = $(this).attr("data-id");
						var data_title = $(this).find("p").text();
						var resource = $(this).find("span:eq(0)").text();
						var updateTime = $(this).attr("data-yearTime")+" "+$(this).attr("data-dayTime");
						updateTime = updateTime.substring(0,16);
						//获取当前页面的pageCode
						var curPage_Code = $("body #content div.page[data-display=block]").attr("id").replace("_","/");
						var param_data = {
								"data_title":data_title,
								"resource" : resource,
								"updateTime" : updateTime
						}
						appUtils.pageInit(curPage_Code,"business/informationDetails",{"param_data":param_data,"id":data_id,"curPage_Code":curPage_Code});
					},"click");
				}
			}else{
				layerUtils.iAlert(data.error_info);
			}
		}
	}
	
	/**
	 * 初始化上下滑动组件
	 */
	function initVIScroll(){
		if(!vIscroll._init){
			var config = {
					"isPagingType": false,		//false表示是微博那种累加形式，true表示分页形式
					"visibleHeight": $(window).height() - $(_pageId+" .top_title").height() - $(_pageId+" .new_tab").height() - 10,// 10为margin
					"container": $(_pageId+" #v_container_funds_jj"),	
					"wrapper":$(_pageId+" #v_wrapper_funds_jj"),	
					"downHandle": function() {				//下拉获取上一页数据方法
						_curpage = 1;
						queryModuleIncreaseData();
					},
					"upHandle": function() {				//上拉获取下一页数据方法
						if(_curpage < _totalPage)
						{
							_curpage++;
							queryModuleIncreaseData();
						}
					},
					"wrapperObj": null
			};
			vIscroll.scroll = new VIscroll(config); 	//初始化，需要做if(!hIscroll._init)判断
			vIscroll._init = true; 						//尽量只初始化一次，保持性能
		} else {
			vIscroll.scroll.refresh();
		}
	}
	
	//左后自由滑动组件初始化
	function initHIScroll(){
		if(!mySHIscroll){
			var config = {
				//获取两个指定的格式的对象
				wrapper: $(_pageId+" #wrapper_hMainPanel"), //wrapper对象
				container: $(_pageId+" #container_hMainPanel"), //container对象
				//滑动操作后要执行的方法
				onScrollEnd : function(){
					//滑动完成之后的处理，非必传
				}	
			};
			
			mySHIscroll = new shIscroll(config);
			//表示的就是头部导航显示的控制为四个
			$(_pageId+" #container_hMainPanel li").width($(_pageId+" #wrapper_hMainPanel").width()*0.2);
			//将滑动选中的元素li显示（在刚加载页面的时候除开第一个li元素是现实的，其他的li元素是隐藏的）
			$(_pageId+" #container_hMainPanel li").show();
		}
	}
	

	function destroy(){
//		myShIscroll.destroy();
		myShIscroll = null;
		
//		myVIscroll.destroy();
		myVIscroll = null;
		
		_curpage = "1";   //当前页
		_rowofpage = "20";   //没也的行数
		_totalPage = "1";   //后台返回的总页数
	}

	var importantNews = {
		"init": init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	
	module.exports = importantNews;
});