/**
 * 资讯-自选股
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils"), 
		layerUtils = require("layerUtils"),
		newsCommon = require("newsCommon"),
		gconfig = require("gconfig"),
		serviceNews = require("serviceNews"),
		global = gconfig.global,
		external = require("external"),
		VIscroll = require("vIscroll"),
		headFun = require("headFun"),
		_pageId = "#business_optionalShares ";
		var vIscroll = {"scroll":null,"_init":false};
		var curpage = 1;		//当前页数
		var totalPage=1;		//后台返回的总页数
		var rowofpage = 20;		//每页显示数据的条数
		var isFirstLoad = true;	//第一次加载本页面
		var start_y = "";//触摸终止点的y坐标
		var shIscroll = require("shIscroll");
		var mySHIscroll = null;
		
		var _currentCheckIndex = 0; 
	
	//页面初始化
	function init() {
		$(_pageId + "#news_zxg").parent().attr("class","active");
		
		initHIScroll();//初始化左右滑动组件函数的调用
		
		/**
		 * newsCommon中的queryMsg方法暴露出了undefined
		 * 当前表示的是将queryOptionalData方法赋给newsCommon中暴露出的queryMsg方法
		 */
		newsCommon.queryMsg = queryOptionalData;
		
		window.onRefresh = function(){
			//查询自选股数据
			queryOptionalData();
		};
		
		if(vIscroll._init){
			vIscroll.scroll.refresh();
		}
		
		newsCommon.initHeader("自选股",true,"1","2");
		
		if(isFirstLoad){
			//模拟从安卓原生中取数据
			var results_a = newsCommon.readMsgFromFile("optionalShares");
			if(typeof results_a != "undefined" && results_a != null && results_a.results){
				var results = results_a.results[0].data;
				createHtml(results);
			}
			//初始化头部,调用刷新方法,此处为实现.
			headFun.initNav();
			//设施高度，添加滚动条
//			var contHeight = $(window).height() - $(_pageId + ".new_tab").height() -1;
//			$(_pageId + " .main").css({"height": contHeight, "overflow-x": "hidden", "overflow-y": "scroll"});
			//查询自选股数据
			queryOptionalData();
		}else{
			//初始化头部,调用刷新方法,此处为实现.
			headFun.initNav();
			//设施高度，添加滚动条
//			var contHeight = $(window).height() - $(_pageId + ".new_tab").height() -1;
//			$(_pageId + " .main").css({"height": contHeight, "overflow-x": "hidden", "overflow-y": "scroll"});
		}
		
		//点击过程中的左右滑动是选中的栏目居中
		_currentCheckIndex = $(_pageId + ".header .new_tab ul li[class=active]").index();
		mySHIscroll ? mySHIscroll.scrollToElement($(_pageId + ".new_tab li").eq(_currentCheckIndex ? (_currentCheckIndex - 1) : 0), 500) : "";
		
	}
	
	function bindPageEvent() {
		
		//首页返回键回到主页面
		appUtils.bindEvent($(_pageId + ".top_title a"), function() {
			external.callMessage({"moduleName":"home","funcNo": "50101"});
		});
		
		/**
		 * 获取用户点击页面的移动坐标
		 */
		appUtils.bindEvent($(_pageId),function(e){
			var touch = event.targetTouches[0];
			var y = Number(touch.pageY); //页面触点Y坐标
			var yHeight = Number($(" #content").height());
			if(gconfig.platform == "2"){
				if(y >= (yHeight-1)){
					if($(_pageId + " .visc_flip").css("display") == "block"){
						if(vIscroll._init){
							vIscroll.scroll.refresh();
						}	        	
					}
				}
				if(y < 10){
					if($(_pageId + " .visc_flip").css("display") == "block"){
						if(vIscroll._init){
							vIscroll.scroll.refresh();
						}	        	
					}
				}
			}
		},"touchmove");
	}
	/***
	 * 查询自选股新闻
	 */
	function queryOptionalData(){
		isFirstLoad = false;
		var results = "";
		var jsonMsg = {"moduleName":"self-stock","childModuleName":"","funcNo":"60100","targetModule":"self-stock"};
		if(gconfig.platform != "0"){
			//获取安卓原生自选股数据
			 var data = external.callMessage(jsonMsg);
		}
		
		if ( typeof data.results != "undefined" && data.results!= null && data.results != "") {
			newsCommon.refreshStyle(true);
		//	var stock_msgs = stock_masgs.results;
			var stockAll = "";
			results = data.results;
//			results = {"result":"SH|000001|平安银行','SH|000002|万科A'"};
			
			for(var i = 0 ;i < results.length ;i++)
			{
				stockAll += results[i].market + "|" + results[i].code + "," ;
			}
			
			if(stockAll){
				stockAll = stockAll.substring(0,stockAll.length-1);
			}
			
			var param = {			
					"stock_code" : stockAll ,
					"curpage" : curpage,
					"rowofpage" : rowofpage,
					"catalogid" : "3"
			};
			
			$(_pageId+ " .no_data").hide();
			
			newsCommon.refreshStyle(true);
			
			serviceNews.queryNews(param,queryNews,true,false,false,function(){
				var liNum = $.trim($(_pageId+" .news_list2").html());
				if(typeof liNum == "undefined" || liNum == "" || liNum == null){
					initVIScroll(0);
					$(_pageId+ " .no_data").show();
				}
				if(vIscroll._init){
					vIscroll.scroll.refresh();
				}
				newsCommon.refreshStyle(false);
			});

		}else{
            $(_pageId+".news_list2").html("");
			initVIScroll(0);
			$(_pageId+ " .no_data").show();
		}
	}
	/**
	 * 查询自选股数据回调方法
	 * @param {Object} data 返回数据
	 */
	function queryNews(data)
	{
		if (typeof(data) != "undefined" && data != null) {
			if(data.error_no == 0)
			{
				if(typeof data.results != "undefined" && data.results != null && data.results != ""){
					isFirstLoad = false;
					var results_arr = data.results;
					if(typeof results_arr != "undefined" && results_arr != null && results_arr != ""){
						totalPage=data.results[0].totalPages;	//数据的总页数
//						curpage=data.results[0].currentPage;	//数据的当前页数
						if(curpage == 1){
							//将存入安卓原生中
							newsCommon.writeMsgToFile("optionalShares",data);
						}
						//展示数据
						createHtml(results_arr);
					}else{
						var liNum = $.trim($(_pageId+" .news_list2").html());
						if(liNum == ""){
							initVIScroll(0);
							$(_pageId+ " .no_data").show();
						}
					}
				}else{
					var liNum = $.trim($(_pageId+" .news_list2").html());
					if(typeof liNum == "undefined" || liNum == "" || liNum == null){
						initVIScroll(0);
						$(_pageId+ " .no_data").show();
					}
					//$(_pageId+".news_list2").html("<h5 style=\"font-size: 14px;\">暂无数据！</h5>");
				}
			}else{
				  layerUtils.iAlert("查询失败");
			}
		}
		 newsCommon.refreshStyle(false);
	}
	/**
	 * 生成html
	 * @param {Object} element 数据项
	 */
	function createHtml(element)
	{
		if(newsCommon.isEmptyObject(element)) return false; 
		var eleHtml = "";
		for(var i = 0;i < element.length; i++){
//			var infopubldate = element[i].infopubldate;			//资讯要闻  -- 发布时间
			var updatetime = element[i].updatetime;			//资讯要闻  -- 采集时间
			
			if(updatetime != ""){
				var yearTime = updatetime.substring(0,10);
				var dayTime = updatetime.substring(11,updatetime.length);
			}
			var time = updatetime.substring(0,16);	//设置时间格式
			var title =  element[i].title;   //objString.substring(0,num) + "..."); 
			if(title.length >=17){
				title=title.substring(0,17)+"...";
			}
			  
			eleHtml += "<div class=\"news_box\" id = "+element[i].id+" data-yearTime="+yearTime+" data-dayTime="+dayTime+">";
			eleHtml += "<div class=\"nb_title\">";
			eleHtml += "<div class=\"nb_pic\"><small>"+element[i].stock_code+"</small></div>";
			eleHtml += "<p>"+title+"</p>";
			eleHtml += "<span>"+element[i].media+"</span><em>"+time+"</em>";
			eleHtml += "</div>";
			eleHtml += "<div class=\"nb_main\">";
			eleHtml += "<h5>"+element[i].summary+"</h5>";
//			eleHtml += "		<p>"+element[i].content+"</p>";
			eleHtml += "</div>";
			eleHtml += "</div>";
		}
		$(_pageId+ " .no_data").hide();
		var num = element.length;
		if(curpage == 1){
			$(_pageId+".news_list2").html(eleHtml);
		}else{
			$(_pageId+".news_list2").append(eleHtml);
		}
		initVIScroll(num);
		/**
		 * 点击新闻概况跳转新闻详情页面
		 */
		appUtils.bindEvent($(_pageId + " .news_box"), function(e){
			var id = $(this).attr("id");
			var data_id = $(this).attr("id");
			var data_title = $(this).find("h5").text();
			var resource = $(this).find("span:eq(0)").text();
			var updateTime = $(this).attr("data-yearTime")+" "+$(this).attr("data-dayTime");
			updateTime = updateTime.substring(0,16);
			var curPage_Code = $("body #content div.page[data-display=block]").attr("id").replace("_","/");
//			if(gconfig.platform == 1){
//				var sendMsgParams = {
//						"id":data_id,		//资讯的id
//						"title":data_title,
//						"resource":resource,
//						"time":updateTime
//					};
//				var jsonMsg = {"moduleName":"news","childModuleName":"","funcNo":"50013","id":data_id,"title":data_title,"resource":resource,"time":updateTime};
//				external.callMessage(jsonMsg);
//			}else{
			
			var param_data = {
					"data_title":data_title,
					"resource" : resource,
					"updateTime" : updateTime
			}
				appUtils.pageInit(curPage_Code,"business/informationDetails",{"param_data":param_data,"curPage_Code":curPage_Code,"id":id});
				e.stopPropagation();
//			}
		},"click");
		
		newsCommon.refreshStyle(false);
	}
	
	/**
	 * 初始化上下滑动组件
	 */
	function initVIScroll(num){
		if(!vIscroll._init){
			var config = {
					"isPagingType": false,		//false表示是微博那种累加形式，true表示分页形式
					"visibleHeight": $(window).height() - $(_pageId+" .top_title").height() - $(_pageId+" .new_tab").height() - 10,// 10为margin
					"container": $(_pageId+" #v_container_funds_jj"),	
					"wrapper":$(_pageId+" #v_wrapper_funds_jj"),	
					"downHandle": function() {				//下拉获取上一页数据方法
						curpage = 1;						//上拉将当前页数设置为1
						//查询自选股数据
						queryOptionalData();				//调用查询资讯要闻数据方法
//						$(_pageId+ " .no_data").hide();
					},
					"upHandle": function() {				//上拉获取下一页数据方法
						if(curpage < totalPage)				//判断当前页数是不是小于总页数
						{
							curpage++;
							//查询自选股数据
							queryOptionalData();
						}
					},
					"wrapperObj": null
			};
			vIscroll.scroll = new VIscroll(config); 	//初始化，需要做if(!hIscroll._init)判断
			vIscroll._init = true; 						//尽量只初始化一次，保持性能
			if(num < 20 ){
				$(_pageId + ".visc_pullUp").css("display","none");
			}
		} else {
			vIscroll.scroll.refresh();
		}
	}
	
	function initHIScroll(){
		if(!mySHIscroll){
			var config = {
				//获取两个指定的格式的对象
				wrapper: $(_pageId+" #wrapper_hMainPanel"), //wrapper对象
				container: $(_pageId+" #container_hMainPanel"), //container对象
				//滑动操作后要执行的方法
				onScrollEnd : function(){
					//滑动完成之后的处理，非必传
				}	
			};
			
			mySHIscroll = new shIscroll(config);
			//表示的就是头部导航显示的控制为四个
			$(_pageId+" #container_hMainPanel li").width($(_pageId+" #wrapper_hMainPanel").width()*0.2);
			//将滑动选中的元素li显示（在刚加载页面的时候除开第一个li元素是现实的，其他的li元素是隐藏的）
			$(_pageId+" #container_hMainPanel li").show();
		}
	}
	
	function destroy()
	{
//		myShIscroll.destroy();
		myShIscroll = null;
		
		start_y = "";//触摸终止点的y坐标
		if(vIscroll._init){
			vIscroll.scroll.refresh();
		}
		curpage = 1;		//当前页数
		totalPage=1;		//后台返回的总页数
		rowofpage = 20;		//每页显示数据的条数
	}

	var optionalShares = {
		"init": init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	
	module.exports = optionalShares;
});