/**
 * 资讯-沪深
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var external = require("external");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var layerUtils = require("layerUtils");
	var _pageId = "#business_zxEdit ";
	var sortable = require("news\scripts\common\jquerySortable");

	//初始化
	function init(){
		$(_pageId+".tableList").height($(window).height()-44 -41);
		$(_pageId+'.tableList').css("overflow","auto");
		//获取头部标题对应的相关的信息数据
		queryTitleData();
	}
	
	function queryTitleData(){
		$(_pageId + ".info_dzlist").html("");
		var titleDataHtml = "";
		$($(_pageId + ".new_tab #headerScroller li")).each(function(e){
			var title = $(this).find("a").text();
			var dataHtml = 	"<ul class='info_dzlist'>" +
								"<li>" +
									"<a class='icon_radio' href='javascript:void(0);'></a>" +
									"<h5>"+title+"</h5>" +
									"<p>聚焦科技创业热点新闻</p>" +
									"<a class='info_link' href='javascript:void(0);'></a>" +
								"</li>" +
							"</ul>";
			titleDataHtml += dataHtml;
		});
		$(_pageId + ".tableList").append(titleDataHtml);
		
		//拖动排序
		var ua = navigator.userAgent;
		if(ua.indexOf("iPad") > 0 || ua.indexOf("Android") > 0 || ua.indexOf("iPhone") > 0) {
			dragen();
		} else {
			/**
			 * sortable()：方法表示将sortable变成可排序的
			 * disableSelection()：方法表示使文本不可被选中
			 * sortupdate：当排序动作结束时且元素坐标已经发生改变时触发此事件。
			 * sortstop：当排序动作结束时触发此事件
			 * tableList：表示的就是需要填充数据的div
			 * */
			$(_pageId+'.tableList').sortable().bind('sortupdate', function() {
				
			});
		}
	}
	//拖拽效果
	function dragen(){
		var dragging = false;            //判断是否按下拖动按钮
		var oldY,nowY;                   //记录按下拖动按钮时的纵坐标和拖动过程中的纵坐标
		var dragIcon;                    //被按下的拖动控件(其实就是ul)
		var screenHeight ;               //记录显示框的高度
		var height = 47;                 //每一条信息<ul>的高度
		var oldIndex,nowIndex;           //oldIndex:被按下时的序号 ,nowIndex:现在的序号
		var brothers ;					 //存放所有信息<ul>的集合
		var length;                      //记录共有几个兄弟元素
		var scrollDif = 0;               //记录由滚动条带来的差值
		var oldScroll;                   //记录点击时的scrolltop
		var moveScroll = false;          //是否滚动;
		var oldNowIndex;
		
		//点击拖动的图标要做的事情（为动态加载的数据动态的绑定事件）
		appUtils.preBindEvent($(_pageId+".tableList")," .info_link",function(e){
			dragging = true;	//表示已经按了拖动按钮
			brothers = $(_pageId + ".tableList").children();  //div中的所有的ul
			length = brothers.length;  //获取有多少个ul
			screenHeight = $(_pageId + ".tableList").height();  //获取整个现有数据的div的高度
			oldScroll = $(_pageId+".tableList").scrollTop();   //设置匹配元素的滚动条的垂直位置（当前表示的是设置为0px,因为没有传任何的参数）
			oldIndex = $(this).parent().parent().index();  //取到点击时的序号
			oldNowIndex = oldIndex;   //将点击获取的序号赋值给另外一个变量
			//通过对e的深层遍历发现clientY ,clientX在这个地方
			oldY = e["originalEvent"]["touches"][0]["clientY"];  //获取点击坐标
			this.setCapture && this.setCapture();   //事件捕捉
			dragIcon = $(this).parent().parent();   //整个ul
			return false;
		},"touchstart");

		//连续滑动时触发
		appUtils.bindEvent($(_pageId+".tableList"),function(e){
			if (dragging) {
				e.preventDefault();//阻止在移动过程中滚动条滚动影响的效果（阻止滚动）
//				clientX(返回当事件被触发时，鼠标指针的水平坐标)、clientY(返回当事件触发时，鼠标指针的垂直坐标)、screenX(当某个事件被触发时，鼠标指针的水平坐标)和screenY(返回当某个事件被触发时，鼠标指针的垂直坐标)。
				nowY = e["originalEvent"]["touches"][0]["clientY"];   //获取点击坐标
				var nowTop = nowY - oldY ; //移动的距离 = 当前坐标 - 开始坐标
				
				//控制拖动的范围
				if(nowTop >= screenHeight - (oldIndex+1) * height + oldScroll){  //一个ul的高度 * 有多少个ul + 刚开始滚动条的位置高度
					nowTop = screenHeight - (oldIndex+1) * height + oldScroll;	//移动的ul的原本的位置 = 整个div的高度　 - (点击获取的序号 +１) * 一个ul的高度  + 	初始的滚动条的高度（0）;			
					scrollDif += 5;  //滚动条带来的差值
					if(scrollDif + oldScroll > length * height - screenHeight + 30){
						scrollDif = length * height - screenHeight - oldScroll + 30; //总的ul的个数 * 每一个ul的高度 - 整个div的高度 - 初始化滚动条的高度 + 30
					}
				
				}else if(nowTop <= -oldIndex * height  + oldScroll){
					nowTop = -oldIndex * height + oldScroll;
					scrollDif -= 5;
					if(scrollDif + oldScroll < 0){
						scrollDif = -oldScroll;
					}
				}

				//计算现在序号与原序号之间的差值
				var DIF = Math.round((nowTop + scrollDif)/height);     

				nowIndex = DIF + oldIndex;		
				
				if(nowIndex > length -1){
					nowIndex = length -1;
				}
					
				else if(nowIndex < 0){
					nowIndex = 0;
				}
					
				if(nowIndex != oldNowIndex){	//1.首先初始化排序
					for(i = 0 ;i < length ; i++){
						if(i != oldIndex){
							$(brothers[i]).css("top",0);
						}
					}
					
					//2.根据nowIndex和oldIndex重新排序
					if(nowIndex != oldIndex){
						if(nowIndex > oldIndex){   
							for(i = oldIndex + 1 ;i <= nowIndex ; i++){
								$(brothers[i]).css("top",-47);
							}
						}else{
							for(i = oldIndex - 1 ;i >= nowIndex ; i --){
								$(brothers[i]).css("top",47);
							}
						}
					}
					oldNowIndex = nowIndex;
				}
				
				//3.画被拖动的按钮
				var mydate = new Date();
				var now = mydate.getTime();
				while(mydate.getTime - now < 100);
				$(_pageId+".tableList").scrollTop(scrollDif+oldScroll);
				dragIcon.css("top",nowTop + scrollDif);
				return false;
			}
		},"touchmove");

		appUtils.bindEvent($(_pageId+".tableList"),function(e){	
			if(dragging){
				
			}
		},"touchend");
	}
	
	
	//事件绑定
	function bindPageEvent() {
		//首页返回键回到主页面
		appUtils.bindEvent($(_pageId + ".top_title a"), function(e) {
			external.callMessage({"moduleName":"home","funcNo": "50101"});
			e.stopPropagation();
		},"click");
		
		//是否选中
		appUtils.bindEvent($(_pageId + ".info_dzlist li .icon_radio"), function(e) {
			var checkeds = $(this).attr("class");
			if(checkeds == "icon_radio"){
				$(this).attr("class","icon_radio checked");
			}else{
				$(this).attr("class","icon_radio");
			}
			e.stopPropagation();
		},"click");
	}
	

	function destroy(){
		myVIscroll.destroy();
		myVIscroll = null;
	}

	var zxEdit = {
		"init": init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	
	module.exports = zxEdit;
});