/**
 *
 * 开|转|理财户结果
 */
define(function(require, exports, module) {
	/* 私有业务模块的全局变量 begin */
	var appUtils = require("appUtils"),
		gconfig = require("gconfig"),
		layerUtils = require("layerUtils"),
		utilsHN2 = require("utilsHN2"),
		global = gconfig.global,
		service = require("serviceImp").getInstance(), //业务层接口，请求数据
		_pageId = "#account_accountResult";
	var pid = "";
	/* 私有业务模块的全局变量 end */


	function init() {
		initPage();
		$(_pageId + " .fix_bot:eq(0)").hide();
		$(_pageId + " .fix_bot:eq(1)").hide();
	}

	function bindPageEvent() {
		// 关闭按钮
		appUtils.bindEvent($(_pageId + " .icon_close"), function() {
			utilsHN2.closeModule("open");
		});

		// 佣金确认 
		appUtils.bindEvent($(_pageId + " .fix_bot:eq(0) .ct_btn"), function() {
			confirmCommission();
			$(_pageId + " #order_info").css("display", "block");
			$(_pageId + " .icon").css("display", "block");
			$(_pageId + " .order_succes h5:eq(0)").text("开户申请成功！");
		});
		appUtils.bindEvent($(_pageId + " .fix_bot:eq(1) .ct_btn"), function() {
//			appUtils.pageInit("account/accountResult", "account/middlePage");
			appUtils.pageInit("account/accountResult", "account/msgVerify");
			$("#bodyContent").html("");
		});
	}

	function confirmCommission() {
		var param = {
			"pid": pid
		};
		service.confirmCommission(param, function(data) {
			var error_no = data.error_no;
			var error_info = data.error_info;
			if (error_no == "0") {
				//layerUtils.iMsg(0, "佣金确认成功");
				$(_pageId + " .fix_bot:eq(0)").hide();//隐藏佣金确定按钮
				$(_pageId + " #CommissionInfo").hide(); //确认佣金后隐藏佣金信息
				showOpenAccount(); // 显示开户结果
			} else {
				layerUtils.iMsg(-1, error_info);
			}
		});
	}

	function destroy() {
		$(_pageId + " order_succes p:eq(3)").html("");
		$(_pageId + " #gdzh").html("");
		$(_pageId).remove();
		service.destroy();
		//		appUtils.clearSStorage(); // 清空所有的session
	}

	/* 初始化页面 */
	function initPage() {
		$(_pageId + " .header h3").html("开户结果");
		//开户成功图片隐藏
		$(_pageId + " .icon").css("display", "none");
		//开户成功！标识隐藏
		//$(_pageId + " .order_succes h5:eq(0)").text("开户申请成功！");
		$(_pageId + " .order_succes p:eq(0)").html("您的开户申请我们已经收到并正在受理中。");
		// 驳回后重新提交
		if (appUtils.getSStorageInfo("isBack") == "backInfo") {
			$(_pageId + " .header h3").html("开户进度");
			$(_pageId + " .order_succes h5:eq(0)").text("重新提交资料成功！");
		}
		//		$(_pageId + " .order_succes p:eq(0)").hide();
		//		$(_pageId + " .order_succes p:eq(1)").hide();
		queryAccount(); // 查询用户信息
		//		$(_pageId + " #CommissionInfo").css("display","block");
	}

	/* 获取用户信息 */
	function queryAccount() {
		var param = {
			"user_id": appUtils.getSStorageInfo("user_id")
		};
		service.queryUserInfo(param, function(data) {
			var error_no = data.error_no;
			var error_info = data.error_info;
			if (error_no == 0) {
				var res = data.results[0];
				appUtils.setSStorageInfo("recommendno1", res.recommendno); //客户经理编号
				appUtils.setSStorageInfo("recommend_name", res.recommend_name); //客户经理姓名
				appUtils.setSStorageInfo("recommend_zgzh", res.recommend_zgzh); //客户经理资格证号							
				appUtils.setSStorageInfo("fund_account", res.fund_account); // 资金账号
				appUtils.setSStorageInfo("hacnselect", res.hacnselect); // 沪基金状态
				appUtils.setSStorageInfo("zacnselect", res.zacnselect); // 深基金状态 
				appUtils.setSStorageInfo("shfund_select", res.shfund_select); // 场外沪基金状态
				appUtils.setSStorageInfo("szfund_select", res.szfund_select); // 场外深基金状态 
				appUtils.setSStorageInfo("szaselect", res.szaselect); // 深A状态
				appUtils.setSStorageInfo("shaselect", res.shaselect); // 沪A状态
				appUtils.setSStorageInfo("szaaccount", res.szaaccount); // 深A账号
				appUtils.setSStorageInfo("shaaccount", res.shaaccount); // 沪A账号
				appUtils.setSStorageInfo("zacn_account", res.zacn_account); // 深基金账号
				appUtils.setSStorageInfo("hacn_account", res.hacn_account); // 沪基金账号
				appUtils.setSStorageInfo("szfund_account", res.szfund_account); // 场外深基金账号
				appUtils.setSStorageInfo("shfund_account", res.shfund_account); // 场外沪基金账号
				//获取佣金信息
				getCommission();
			} else {
				layerUtils.iMsg(-1, error_info);
			}
		});
	}

	//获取佣金信息
	function getCommission() {
		var idno = appUtils.getSStorageInfo("idCardNo");
		var branchno = appUtils.getSStorageInfo("branchno");
		var param = {
			"idno": idno,
			"branchno": branchno,
			"third_channel": appUtils.getSStorageInfo("organization")
		};
		service.getCommissionInfo(param, function(data) {
			var error_no = data.error_no;
			var error_info = data.error_info;
			if (error_no == "0") {
				var result = data.commission;
				var result1 = data.result1;
				if (result.length == 0) {
					$(_pageId + " #CommissionInfo").hide();
				} else {
					$(_pageId + " #CommissionInfo dl:eq(0) dd").html("&nbsp; " + result[0].agcommission + "‰");
					$(_pageId + " #CommissionInfo dl:eq(1) dd").html("&nbsp; " + result[0].bgcommission + "‰");
					$(_pageId + " #CommissionInfo dl:eq(2) dd").html("&nbsp; " + result[0].jjcommission + "‰");
					$(_pageId + " #CommissionInfo dl:eq(3) dd").html("&nbsp; " + result[0].zqcommission + "‰");
					$(_pageId + " #CommissionInfo dl:eq(4) dd").html("&nbsp; " + result[0].ggtcommission + "‰");
					$(_pageId + " #CommissionInfo dl:eq(5) dd").html("&nbsp; " + result[0].gzcommission + "‰");
					$(_pageId + " #CommissionInfo dl:eq(6) dd").html("&nbsp; " + result1[0].direction);
					$(_pageId + " #CommissionInfo").show();
					pid = result[0].pid;
					if (result[0].confirm == "1") {
						showOpenAccount(); // 显示开户结果
					} else {
					$(_pageId + " .fix_bot:eq(0)").show();
						//进入页面后定位到底部展现数据
						//						$("html,body").animate({
						//scrollTop: $(_pageId + " #xd_speldl_id").offset().top
						//						}, 300);
						// $("html,body").animate({scrollTop:$(_pageId+" #xd_speldl_id").offset().top},300);
						//$("#bodyContent").scrollTop($("#bodyContent").scrollTop()+"px");
					}
				}
			} else {
				layerUtils.iMsg(-1, error_info);
			}
		});
	}

	/*//获取客户经理信息
	function getManager(){
		var recommendno=appUtils.getSStorageInfo("recommendno");
		var param={"recommendno":recommendno};
		service.getManagerInfo(param,function(data){
			var error_no=data.error_no;
			var error_info=data.error_info;
			var result=data.results;
			//alert(JSON.stringify(data));	
			if(error_no=="0")
			{
				if(result.length==0)
				{
					 $(_pageId+" #managerInfo").hide();	
					 //$(_pageId+" #managerInfo").css({"display":"none"});
				}else{								
				   $(_pageId+" #managerInfo dl:eq(0) dd").html("&nbsp; "+result[0].ygxm);
				   $(_pageId+" #managerInfo dl:eq(1) dd").html("&nbsp; "+result[0].ygbh);
				   $(_pageId+" #managerInfo dl:eq(2) dd").html("&nbsp; "+result[0].ygzh);	
				   $(_pageId+" #managerInfo").show();
				}
			}else{
				layerUtils.iMsg(-1,error_info);			
			}			
		});
	}*/

	/* 显示新开户结果 */
	function showOpenAccount() {
		// 从 session 中取资金账号和股东账号
		var shaselect = appUtils.getSStorageInfo("shaselect"), // 是否选择沪A
			szaselect = appUtils.getSStorageInfo("szaselect"), // 是否选择深A
			hacnselect = appUtils.getSStorageInfo("hacnselect"), // 是否选择沪基金
			zacnselect = appUtils.getSStorageInfo("zacnselect"), // 是否选择深基金
			shfund_select = appUtils.getSStorageInfo("shfund_select"), // 是否选择场外沪基金
			szfund_select = appUtils.getSStorageInfo("szfund_select"), // 是否选择场外深基金
			fund_account = appUtils.getSStorageInfo("fund_account"), // 资金账号
			shaaccount = appUtils.getSStorageInfo("shaaccount"), // 沪A股东账户
			szaaccount = appUtils.getSStorageInfo("szaaccount"), // 深A股东账户
			zacn_account = appUtils.getSStorageInfo("zacn_account"), // 深基金账户
			hacn_account = appUtils.getSStorageInfo("hacn_account"), // 沪基金账户
			shfund_account = appUtils.getSStorageInfo("shfund_account"), // 场外沪基金账户
			szfund_account = appUtils.getSStorageInfo("szfund_account"); // 场外深基金账户

		$(_pageId + " #custname").html(appUtils.getSStorageInfo("custname"));
		$(_pageId + " #idno").html(appUtils.getSStorageInfo("idCardNo"));
		$(_pageId + " #deparment").html(appUtils.getSStorageInfo("branchname"));

		if (appUtils.getSStorageInfo("recommendno1") != null && appUtils.getSStorageInfo("recommendno1") != "") {
			$(_pageId + " #managerInfo dl:eq(0) dd").html("&nbsp; " + appUtils.getSStorageInfo("recommendno1"));
			if (appUtils.getSStorageInfo("recommend_name") != null) {
				$(_pageId + " #managerInfo dl:eq(1) dd").html("&nbsp; " + appUtils.getSStorageInfo("recommend_name"));
			} else {
				$(_pageId + " #managerInfo dl:eq(1) dd").html("&nbsp; ");
			}
			if (appUtils.getSStorageInfo("recommend_zgzh") != null) {
				$(_pageId + " #managerInfo dl:eq(2) dd").html("&nbsp; " + appUtils.getSStorageInfo("recommend_zgzh"));
			} else {
				$(_pageId + " #managerInfo dl:eq(2) dd").html("&nbsp; ");
			}
			$(_pageId + " #managerInfo").show();
		} else {
			$(_pageId + " .order_succes #managerInfo").hide();
			//$(_pageId+" .order_succes #managerInfo").css({"display":"none"});
		}
		// 判断资金账户是否开出
		if (fund_account != null && fund_account !="" && fund_account != "null") {
			//设置按钮显示提示文字
			$(_pageId + " .order_succes h5:eq(0)").text("恭喜开户成功！");
			$(_pageId + " .order_succes p:eq(0)").hide();
			$(_pageId + " .order_succes p:eq(1)").hide();
			// 显示资金账户、股东账号的信息
			$(_pageId + " #zjzh").html("<a href='javascript:void(0)' class='copy'>复制账号</a>&nbsp;" + fund_account);
		} else {
			$(_pageId + " .order_succes p:eq(0)").show();
			$(_pageId + " .order_succes p:eq(1)").show();
			$(_pageId + " #zjzh").html("&nbsp;办理中...");
			//$(_pageId+" #zjzh").html("&nbsp;");  //
		}
		// 未开通深A
		if (szaselect == "" || szaselect == null || szaselect =="null") {
			$(_pageId + " #order_info dl:eq(4) dd").html("&nbsp;未申请");
			$(_pageId + " #order_info dl:eq(4)").hide();
		}
		// 未开通沪A
		if (shaselect == null || shaselect =="" || shaselect =="null") {
			$(_pageId + " #order_info dl:eq(5) dd").html("&nbsp;未申请");
			$(_pageId + " #order_info dl:eq(5)").hide();
		}
		// 未开通深基金
		if (zacnselect == null || zacnselect =="" || zacnselect=="null") {
			$(_pageId + " #order_info dl:eq(6) dd").html("&nbsp;未申请");
			$(_pageId + " #order_info dl:eq(6)").hide();
		}
		// 未开通沪基金
		if (hacnselect == null || hacnselect =="" || hacnselect=="null") {
			$(_pageId + " #order_info dl:eq(7) dd").html("&nbsp;未申请");
			$(_pageId + " #order_info dl:eq(7)").hide();
		}
		// 未开通场外深基金
		if (szfund_select == null || szfund_select=="" ||szfund_select=="null") {
			$(_pageId + " #order_info dl:eq(8) dd").html("&nbsp;未申请");
			$(_pageId + " #order_info dl:eq(8)").hide();
		}
		// 未开通场外沪基金
		if (shfund_select == null || shfund_select =="" || shfund_select=="null") {
			$(_pageId + " #order_info dl:eq(9) dd").html("&nbsp;未申请");
			$(_pageId + " #order_info dl:eq(9)").hide();
		}
		// 开通了深A
		if (szaselect != null && szaselect !="" && szaselect !="null") {
			// 深A已经开出账号
			if (szaaccount != null && szaaccount !="" && szaaccount !="null") {
				$(_pageId + " .order_succes p:eq(0)").hide();
				$(_pageId + " .order_succes p:eq(1)").hide();
				$(_pageId + " #order_info dl:eq(4) dd").html("&nbsp;" + szaaccount);
			} else {
				$(_pageId + " .order_succes p:eq(0)").show();
				$(_pageId + " .order_succes p:eq(1)").show();
				$(_pageId + " #order_info dl:eq(4) dd").html("&nbsp;办理中...");
				//$(_pageId+" #order_info dl:eq(1) dd").html("&nbsp;");  //
			}
		}
		// 开通了沪A
		if (shaselect != null && shaselect !="" && shaselect !="null") {
			// 沪A已经开出账号
			if (shaaccount != null && shaaccount != "" && shaaccount != "null") {
				$(_pageId + " .order_succes p:eq(0)").hide();
				$(_pageId + " .order_succes p:eq(1)").hide();
				$(_pageId + " #order_info dl:eq(5) dd").html("&nbsp;" + shaaccount);
			} else {
				$(_pageId + " .order_succes p:eq(0)").show();
				$(_pageId + " .order_succes p:eq(1)").show();
				$(_pageId + " #order_info dl:eq(5) dd").html("&nbsp;办理中...");
				//$(_pageId+" #order_info dl:eq(2) dd").html("&nbsp;");  //
			}
		}
		// 开通了深基金
		if (zacnselect != null && zacnselect != "" && zacnselect !="null") {
			// 深基金已经开出账号
			if (zacn_account != null && zacn_account !="" && zacn_account !="null") {
				$(_pageId + " .order_succes p:eq(0)").hide();
				$(_pageId + " .order_succes p:eq(1)").hide();
				$(_pageId + " #order_info dl:eq(6) dd").html("&nbsp;" + zacn_account);
			} else {
				$(_pageId + " .order_succes p:eq(0)").show();
				$(_pageId + " .order_succes p:eq(1)").show();
				$(_pageId + " #order_info dl:eq(6) dd").html("&nbsp;办理中...");
				//$(_pageId+" #order_info dl:eq(3) dd").html("&nbsp;");  //
			}
		}
		// 开通了沪基金
		if (hacnselect != null && hacnselect !="" && hacnselect !="null") {
			// 沪基金已经开出账号
			if (hacn_account != null && hacn_account !="" && hacn_account !="null") {
				$(_pageId + " .order_succes p:eq(0)").hide();
				$(_pageId + " .order_succes p:eq(1)").hide();
				$(_pageId + " #order_info dl:eq(7) dd").html("&nbsp;" + hacn_account);
			} else {
				$(_pageId + " .order_succes p:eq(0)").show();
				$(_pageId + " .order_succes p:eq(1)").show();
				$(_pageId + " #order_info dl:eq(7) dd").html("&nbsp;办理中...");
				//$(_pageId+" #order_info dl:eq(4) dd").html("&nbsp; ");  //
			}
		}
		// 开通了场外深基金
		if (szfund_select != null && szfund_select !="" && szfund_select !="null") {
			// 场外深基金已经开出账号
			if (szfund_account != null && szfund_account !="" && szfund_account !="null") {
				$(_pageId + " .order_succes p:eq(0)").hide();
				$(_pageId + " .order_succes p:eq(1)").hide();
				$(_pageId + " #order_info dl:eq(8) dd").html("&nbsp;" + szfund_account);
			} else {
				$(_pageId + " .order_succes p:eq(0)").show();
				$(_pageId + " .order_succes p:eq(1)").show();
				$(_pageId + " #order_info dl:eq(8) dd").html("&nbsp;办理中...");
				//$(_pageId+" #order_info dl:eq(5) dd").html("&nbsp; ");  //
			}
		}
		// 开通了场外沪基金
		if (shfund_select != null && shfund_select !="" && shfund_select !="null") {
			// 场外沪基金已经开出账号
			if (shfund_account != null && shfund_account !="" && shfund_account !="null") {
				$(_pageId + " .order_succes p:eq(0)").hide();
				$(_pageId + " .order_succes p:eq(1)").hide();
				$(_pageId + " #order_info dl:eq(9) dd").html("&nbsp;" + shfund_account);
			} else {
				$(_pageId + " .order_succes p:eq(0)").show();
				$(_pageId + " .order_succes p:eq(1)").show();
				$(_pageId + " #order_info dl:eq(9) dd").html("&nbsp;办理中...");
				//$(_pageId+" #order_info dl:eq(6) dd").html("&nbsp;");  //
			}
		}
		$(_pageId + " .order_succes #order_info").show();
        $(_pageId + " .fix_bot:eq(1)").show();
	}

	var accountResult = {
		"init": init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};

	module.exports = accountResult;
});