/**
 * 上传身份证照片
 */
define(function(require, exports, module) {
	/* 私有业务模块的全局变量 begin */
	var appUtils = require("appUtils"),
		service = require("serviceImp").getInstance(), //业务层接口，请求数据
		layerUtils = require("layerUtils"),
		gconfig = require("gconfig"),
		global = gconfig.global,
		serverPath = global.serverPath,
		_pageId = "#account_backUploadPhoto",
		upload_flag = "0", //用于判定是否需要校验图片上传 0 （校验）1（不校验）
		front = "0",
		back = "0",
		nohat = "0",
		photoParam = "",
		maxheight = "",
		maxwidth = "",
		images = {},
		utils = require("utils"),
		utilsHN2 = require("utilsHN2"),
		fillInformationInParam = {
			"idno": "", // 身份证号
			"custname": "", // 客户姓名
			"ethnicname": "", // 民族
			"native": "", // 证件地址
			"policeorg": "", // 签发机关
			"birthday": "", // 出生日期
			"idbegindate": "", // 证件开始日期
			"idenddate": "", // 证件结束日期
			"gender": "", // 用户性别
			"imgPath": "", // 图片的显示地址
			"imgId": "", // 图片 id 
			"branchno": "", //营业部Id
			"commission": "", //佣金套餐
			"postid": "" //邮编
		};
//	require("makeThumb");
	var external = require("external");
	/* 私有业务模块的全局变量 end */

	function init() {
		maxheight = $(_pageId + " .upload_box:eq(0)").height();
		maxwidth = $(_pageId + " .upload_box:eq(0)").width();
		if(maxwidth > "500"){
			maxwidth = "350";
		}
		initPage(); // 初始化页面
	}

	function bindPageEvent() {
		// 关闭按钮
		appUtils.bindEvent($(_pageId + " .icon_close"), function() {
			utilsHN2.closeModule("open");
		});

		/* 绑定上传正面身份证照 */
		appUtils.bindEvent($(_pageId+" .upload_main .positive"),function(e){
			$(_pageId+" .upload_main .negative").removeClass("active");
			$(_pageId+" .upload_main .headpic").removeClass("active");
			var isActive = $(this).hasClass("active");
			switchCss($(_pageId+" .upload_main .positive"), isActive, 4);
			$(_pageId+" .upload_btn h5").html("上传身份证正面");
			e.stopPropagation();
		});

		/* 绑定上传反面身份证照 */
		appUtils.bindEvent($(_pageId+" .upload_main .negative"),function(e){
			$(_pageId+" .upload_main .positive").removeClass("active");
			$(_pageId+" .upload_main .headpic").removeClass("active");
			var isActive = $(this).hasClass("active");
			switchCss($(_pageId+" .upload_main .negative"), isActive , 5);
			$(_pageId+" .upload_btn h5").html("上传身份证反面");
			e.stopPropagation();
		});

		/*人像正面 */
		appUtils.bindEvent($(_pageId+" .upload_main .headpic"),function(e){
			$(_pageId+" .upload_main .positive").removeClass("active");
			$(_pageId+" .upload_main .negative").removeClass("active");
			var isActive = $(this).hasClass("active");
			switchCss($(_pageId+" .upload_main .headpic"), isActive , 3);
			$(_pageId+" .upload_btn h5").html("上传大头像");
			e.stopPropagation();
		});

		/* 点击相册 */
		appUtils.bindEvent($(_pageId+" .upload_btn li:eq(0)"),function(e){
			// 相册上传的参数
			var phoneConfig = {
				"funcNum" : $(this).attr("media-id") == "3" ? "501526" : "501525",
				"uuid" : "index",
				"r" : Math.random(),
				"userId" : appUtils.getSStorageInfo("user_id"),
				"photoType" : $(this).attr("media-id") == "3" ? "人像正面" : "身份证",	// 影像名称
				"action" : "phone",	// 照片来源类别，phone 相册，pai 相机
				"imgType" : $(this).attr("media-id"),
				"key" : "index",	// key 和 uuid 只需要写一个
				"url" : global.serverPath,
				"clientInfo" : appUtils.getSStorageInfo("clientinfo"),	 // 从 session 中将 clientinfo 取出
				"jsessionId" : appUtils.getSStorageInfo("jsessionid"), // 从 session 中将 jsessionid 取出
				"funcNo":"60002",
				"moduleName":"open"
			};
			external.callMessage(phoneConfig);
			// 隐藏照片上传按钮
			$(_pageId+" .upload_btn").slideUp("fast");
			$(_pageId+" .upload_box").removeClass("active");
			// 将按钮的自定义属性  last-media-id 设为 当前的 media-id
			$(_pageId+" .upload_btn li").attr("last-media-id",$(_pageId+" .upload_btn li:eq(0)").attr("media-id"));
			// 将按钮的自定义属性 media-id 设为 null
			$(_pageId+" .upload_btn li").attr("media-id","null");
			e.stopPropagation();  // 阻止冒泡
		});

		/* 点击拍照 */
		appUtils.bindEvent($(_pageId+" .upload_btn li:eq(1)"),function(e){
			// 相机上传的参数
			var paiConfig = {
				"funcNum" : $(this).attr("media-id") == "3" ? "501526" : "501525",
				"uuid" : "index",
				"r" : Math.random(),
				"userId" : appUtils.getSStorageInfo("user_id"),
				"photoType" : $(this).attr("media-id") == "3" ? "人像正面" : "身份证",	// 影像名称
				"action" : "pai",	// 照片来源类别，phone 相册，pai 相机
				"imgType" : $(this).attr("media-id"),
				"key" : "index",	// key 和 uuid 只需要写一个
				"url" : global.serverPath,
				"clientInfo" : appUtils.getSStorageInfo("clientinfo"), 	// 从 session 中将 clientinfo 取出
				"jsessionId" : appUtils.getSStorageInfo("jsessionid"),	// 从 session 中将 jsessionid 取出
				"funcNo":"60002",
				"moduleName":"open"
			};
			external.callMessage(paiConfig);
			// 隐藏照片上传按钮
			$(_pageId+" .upload_btn").slideUp("fast");
			$(_pageId+" .upload_box").removeClass("active");
			// 将按钮的自定义属性  last-media-id 设为 当前的 media-id
			$(_pageId+" .upload_btn li").attr("last-media-id",$(_pageId+" .upload_btn li:eq(0)").attr("media-id"));
			// 将按钮的自定义属性 media-id 设为 null
			$(_pageId+" .upload_btn li").attr("media-id","null");
			e.stopPropagation();  // 阻止冒泡
		});

		/* 绑定同意签署协议 */
		appUtils.bindEvent($(_pageId + " .checkbox"), function() {
			$(this).toggleClass("checked");
		});

		/* 绑定下一步 */
		appUtils.bindEvent($(_pageId + " .fix_bot .ct_btn"), function() {
			if (validateBackPhoto()) {
				if (front == 1 || back == 1) {
					getAllPhoto();
				} else {
					nextStep();
				}
			}
		});
	}

	/* 合成照片 */
	function getAllPhoto() {
		var photoParam = {
			"user_id": appUtils.getSStorageInfo("user_id")
		};
		service.getAllPhoto(photoParam, function(data) {
			var error_no = data.error_no,
				error_info = data.error_info;
			if (error_no == "0") {
				nextStep();
			} else {
				layerUtils.iLoading(false);
				layerUtils.iMsg(-1, error_info); // 提示错误信息
			}
		}, false);
	}

	function validateBackPhoto() {
			// 只补全正面照
			if (front == 1 && back != 1 && nohat != 1) {
				if ($(_pageId + " .positive img").length == 0) {
					layerUtils.iMsg(-1, "请先上传正面照！");
					return false;
				}
			}
			// 只补全反面照
			if (front != 1 && back == 1 && nohat != 1) {
				if ($(_pageId + " .negative img").length == 0) {
					layerUtils.iMsg(-1, "请先上传反面照！");
					return false;
				}
			}
			// 只补全大头像
			if (front != 1 && back != 1 && nohat == 1) {
				if ($(_pageId + " .headpic img").length == 0) {
					layerUtils.iMsg(-1, "请先上传人像正面！");
					return false;
				}
			}
			// 补全正面和反面
			if (front == 1 && back == 1 && nohat != 1) {
				if ($(_pageId + " .positive img").length == 0) {
					layerUtils.iMsg(-1, "请先上传正面照！");
					return false;
				}
				if ($(_pageId + " .negative img").length == 0) {
					layerUtils.iMsg(-1, "请先上传反面照！");
					return false;
				}
			}
			// 补全正面和大头像
			if (front == 1 && back != 1 && nohat == 1) {
				if ($(_pageId + " .positive img").length == 0) {
					layerUtils.iMsg(-1, "请先上传正面照！");
					return false;
				}
				if ($(_pageId + " .headpic img").length == 0) {
					layerUtils.iMsg(-1, "请先上传人像正面！");
					return false;
				}
			}
			// 补全反面和大头像
			if (front != 1 && back == 1 && nohat == 1) {
				if ($(_pageId + " .negative img").length == 0) {
					layerUtils.iMsg(-1, "请先上传反面照！");
					return false;
				}
				if ($(_pageId + " .headpic img").length == 0) {
					layerUtils.iMsg(-1, "请先上传人像正面！");
					return false;
				}
			}
			// 三张全部补全
			if (front == 1 && back == 1 && nohat == 1) {
				if ($(_pageId + " .positive img").length == 0) {
					layerUtils.iMsg(-1, "请先上传正面照！");
					return false;
				}
				if ($(_pageId + " .negative img").length == 0) {
					layerUtils.iMsg(-1, "请先上传反面照！");
					return false;
				}
				if ($(_pageId + " .headpic img").length == 0) {
					layerUtils.iMsg(-1, "请先上传人像正面！");
					return false;
				}
			}
			return true;
		}

	/* 确认下一步 */
	function nextStep() {
		//调用提交补全资料接口
		var notifyParam = {
			"userid": appUtils.getSStorageInfo("user_id"),
			"fieldname": "photo" // 通知图片已补全
		};
		service.rejectStep(notifyParam, function(data) {
			if (data.error_no == 0) {
				appUtils.setSStorageInfo("isBack", "backInfo"); //标志重新提交资料成功
				var pwdParam = appUtils.getSStorageInfo("pwdParam");
				var thirdParam = appUtils.getSStorageInfo("thirdParam");
				var accountParam = appUtils.getSStorageInfo("accountParam");
				var videoParam = appUtils.getSStorageInfo("videoParam");
				videoParam = JSON.parse(videoParam);
				pwdParam = JSON.parse(pwdParam);
				thirdParam = JSON.parse(thirdParam);
				accountParam = JSON.parse(accountParam);
					// 需要继续驳回到视频
				if (videoParam.need_video == 1) {
					appUtils.pageInit("account/backUploadPhoto","account/videoNotice");
				}
				// 1.驳回开立账户
				else if (accountParam.need_account == 1) {
					appUtils.pageInit("account/backUploadPhoto", "account/backSignProtocol");
				}
				// 需要驳回资金或交易密码
				else if (pwdParam.needBusinessPwd == 1 || pwdParam.needFundPwd == 1) {
					appUtils.pageInit("account/backUploadPhoto", "account/backSetPwd", {}); //跳转设置密码页面
				}
				// 需要驳回到三方存管
				else if (thirdParam.needThirdDeposit == 1) {
					appUtils.pageInit("account/backUploadPhoto", "account/backThirdDepository", {}); //返回结果页
				}
				else {
					appUtils.pageInit("account/backUploadPhoto", "account/accountResult", {});
				}
			}
		});
	}

	/*初始化*/
	function initPage() {
		// 给补全信息赋值
		$(_pageId + " .upload_main .positive").hide(); //显示上传身份证正面
		photoParam = appUtils.getSStorageInfo("photoParam");
		photoParam = JSON.parse(photoParam);
		front = photoParam.needFront;
		back = photoParam.needBack;
		nohat = photoParam.needNohat;
		
		// 只补全正面照
		if (front == 1 && back != 1 && nohat != 1) {
			$(_pageId + " .upload_main .positive").show(); //显示上传身份证正面
			//			$(_pageId+" .upload_main h5:eq(0)").html("补充身份证正面影像");
		}
		// 只补全反面照
		if (front != 1 && back == 1 && nohat != 1) {
			$(_pageId + " .upload_main .negative").show(); //显示上传身份证反面
			//			$(_pageId+" .upload_main h5:eq(0)").html("补充身份证反面影像");
		}
		// 只补全大头像
		if (front != 1 && back != 1 && nohat == 1) {
			$(_pageId + " .upload_main .headpic").show(); //显示上传大头像
			//			$(_pageId+" .upload_main h5:eq(0)").html("补充大头像");
		}
		// 补全正面和反面
		if (front == 1 && back == 1 && nohat != 1) {
			$(_pageId + " .upload_main .positive").show(); //显示上传身份证正面
			$(_pageId + " .upload_main .negative").show(); //显示上传身份证反面
			//			$(_pageId+" .upload_main h5:eq(0)").html("补充身份证正、反面影像");
		}
		// 补全正面和大头像
		if (front == 1 && back != 1 && nohat == 1) {
			$(_pageId + " .upload_main .positive").show(); //显示上传身份证正面
			$(_pageId + " .upload_main .headpic").show(); //显示上传大头像
			//			$(_pageId+" .upload_main h5:eq(0)").html("补充身份证正面影像和大头像");
		}
		// 补全反面和大头像
		if (front != 1 && back == 1 && nohat == 1) {
			$(_pageId + " .upload_main .negative").show(); //显示上传身份证反面
			$(_pageId + " .upload_main .headpic").show(); //显示上传大头像
			//			$(_pageId+" .upload_main h5:eq(0)").html("补充身份证反面影像和大头像");
		}
		// 三张全部补全
		if (front == 1 && back == 1 && nohat == 1) {
			$(_pageId + " .upload_main .positive").show(); //显示上传身份证正面
			$(_pageId + " .upload_main .negative").show(); //显示上传身份证反面
			$(_pageId + " .upload_main .headpic").show(); //显示上传大头像
			//			$(_pageId+" .upload_main h5:eq(0)").html("补充以下相关影像");
		}
		if (photoParam.front_reason != "无") {
			$(_pageId + " .upload_main p:eq(1)").html(photoParam.front_reason);
		}
		if (photoParam.back_reason != "无") {
			$(_pageId + " .upload_main p:eq(3)").html(photoParam.back_reason);
		}
		if (photoParam.nohat_reason != "无") {
			$(_pageId + " .upload_main p:eq(5)").html(photoParam.nohat_reason);
		}
	}

	/**
	 * 照片上传完成后，会自动调用 imgState 方法，但是该方法只能写在 m/index.html
	 * 或者暴露给 window ，否则无法调用
	 * 已在 init 中暴露给 window
	 */
	function imgState(data)
	{
		var base64Str = (data.base64).replace(/[\n\r]*/g,"");
		if(data.error_no != 0)
		{
			layerUtils.iAlert(data.error_info);
			return;
		}
		// 身份证正面信息
		if($(_pageId+" .upload_btn li:eq(0)").attr("last-media-id") == 4)
		{
			fillInformationInParam.idno = data.results[0].idno;  // 身份证号
			fillInformationInParam.custname = data.results[0].custname;  // 客户姓名
			fillInformationInParam.native = data.results[0].native;  // 证件地址
			fillInformationInParam.addr = data.results[0].native;  // 联系地址默认为证件地址
			fillInformationInParam.ethnicname = data.results[0].ethnicname;  // 民族
			appUtils.setSStorageInfo("ethnicname",data.results[0].ethnicname);
			fillInformationInParam.birthday = data.results[0].birthday;  // 出生日期
			fillInformationInParam.gender = data.results[0].usersex;  // 用户性别
		}
		// 身份证反面信息
		if($(_pageId+" .upload_btn li:eq(0)").attr("last-media-id") == 5)
		{
			fillInformationInParam.policeorg = data.results[0].policeorg;  // 签发机关
			fillInformationInParam.idbegindate = data.results[0].idbegindate;  // 证件开始日期
			fillInformationInParam.idenddate = data.results[0].idenddate;  // 证件结束日期
		}
		var maxheight = $(_pageId+" .upload_box").height()+"px";
		$(_pageId+" .upload_box").css("height",maxheight);  //设置回显照片区域高度不变
		switch(Number($(_pageId+" .upload_btn li:eq(0)").attr("last-media-id")))
		{
			// 大头像
			case 3 :
				$(_pageId+" .headpic").text("");  // 先将  li 置空
				$(_pageId+" .headpic").append("<dd><img src=\""+base64Str+"\"/></dd>");  // 回显照片
				break;
			// 正面照
			case 4 :
				if(fillInformationInParam.idno.length == 0)
				{
					layerUtils.iAlert("身份证号码识别失败，需重新拍摄，请注意拍摄的角度和光线！",-1);
					$(_pageId+" .positive").text("");  // 先将  li 置空
					$(_pageId+" .positive").attr("uploaded","false");  // 标识图片未上传
					$(_pageId+" .positive").append("<dd><p>点击上传身份证</p><h5>正 面</h5></dd>");
					return false;
				}
				else if(fillInformationInParam.gender.length == 0)
				{
					layerUtils.iAlert("性别识别失败，需重新拍摄，请注意拍摄的角度和光线！",-1);
					$(_pageId+" .positive").text("");  // 先将  li 置空
					$(_pageId+" .positive").attr("uploaded","false");  // 标识图片未上传
					$(_pageId+" .positive").append("<dd><p>点击上传身份证</p><h5>正 面</h5></dd>");
					return false;
				}
				$(_pageId+" .positive").text("");  // 先将  li 置空
				$(_pageId+" .positive").attr("uploaded","true");  // 标识图片已经上传
				$(_pageId+" .positive").append("<dd><img src=\""+base64Str+"\"/></dd>");  // 回显图片
				break;
			// 反面照
			case 5 :
				if(fillInformationInParam.idbegindate.length == 0)
				{
					layerUtils.iAlert("身份证的有效期限识别失败，需重新拍摄，请注意拍摄的角度和光线！",-1);
					$(_pageId+" .negative").text("");  // 先将  li 置空
					$(_pageId+" .negative").attr("uploaded","false");  // 标识图片未上传
					$(_pageId+" .negative").append("<dd><p>点击上传身份证</p><h5>反 面</h5></dd>");
					return false;
				}
				else if(fillInformationInParam.idenddate.length == 0)
				{
					layerUtils.iAlert("身份证的有效期限识别失败，需重新拍摄，请注意拍摄的角度和光线！",-1);
					$(_pageId+" .negative").text("");  // 先将  li 置空
					$(_pageId+" .negative").attr("uploaded","false");  // 标识图片未上传
					$(_pageId+" .negative").append("<dd><p>点击上传身份证</p><h5>反 面</h5></dd>");
					return false;
				}
				$(_pageId+" .negative").text("");  // 先将  li 置空
				$(_pageId+" .negative").attr("uploaded","true");  // 标识图片已上传
				$(_pageId+" .negative").append("<dd><img src=\""+base64Str+"\"/></dd>");  // 回显图片
				break;
		}
		$(_pageId+" .upload_box img").css("max-height",maxheight);  //设置图片展示大小
	}

	function destroy() {
		$(_pageId).remove();
		service.destroy();
	}

	var backUploadPhoto = {
		"init": init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"imgState" : imgState
	};

	/* 暴露对外的接口 */
	module.exports = backUploadPhoto;
});