/**
 * 手机号码验证
 */
define(function(require, exports, module) {
	/* 私有业务模块的全局变量 begin */
	var appUtils = require("appUtils"),
		service = require("serviceImp").getInstance(), //业务层接口，请求数据
		global = require("gconfig").global,
		layerUtils = require("layerUtils"),
		utils = require("utils"),
		utilsHN2 = require("utilsHN2"),
		validatorUtil = require("validatorUtil"),
		startCountDown = null,
		_pageId = "#account_msgVerify";
	var psw_id = "";
	var flag = false,
		steps = ["uploadimg", "idconfirm","infoconfirm","witness","certintall","capitalacct","stkacct",
		"setpwd", "tpbank", "risksurvey", "visitsurvey","success"],
		stepMap = {
			"uploadimg": "account/uploadPhoto",
			"idconfirm": "account/personInfo",
			"infoconfirm": "account/personInfoVerify",
			"witness": "account/videoNotice",
			"certintall": "account/digitalCertificate",
			"capitalacct": "account/signProtocol",
			"stkacct": "account/signProtocol",
			"setpwd": "account/setPwd",
			"tpbank": "account/thirdDepository",
			"risksurvey": "account/riskAssessment",
			"visitsurvey": "account/openConfirm",
			"success": "account/accountResult"
		},
//		stepMap0 = {
//			"uploadimg": "account/uploadPhotoChange",
//			"witness": "account/videoNotice"
//		};
		stepMap0 = {"uploadimg":"account/uploadPhotoChange","witness":"account/digitalCertificate"};
	var external = require("external");
	var isQR_Code = false;//是否获取到扫描二维码存到手机内存的数据
	/* 私有业务模块的全局变量 end */

	function init() {
		changeTitle();//根据配置改变标题
		appUtils.clearSStorage();//清除缓存
		appUtils.setSStorageInfo("openChannel", "new");
		//如果有手机号则把手机号赋值到手机号框
		var mobileNoStr = appUtils.getSStorageInfo("mobileNoStr");
		if (mobileNoStr) {
			$(_pageId + " .phoneNum").val(mobileNoStr);
		}
		getThird_channel();//获取三方渠道
		getChannelConfig();//获取渠道配置
		getConfigXmlUrl();//获取原生xml的开户地址--------注意：如果有查询，需要在地址确定之后再去调用查询接口
		IsNeedCert();//是否需要证书
	}

	/**获取原生xml的开户地址*/
	function getConfigXmlUrl(){
		if(!global.OnlyOpen){//如果是开户。懒得调用插件获取地址，直接读js配置文件地址
			var param = {
				"funcNo":"50112",
				"serverName":"OPEN_URL"
			};
			var result = external.callMessage(param);
			console.log("50012结果："+JSON.stringify(result));
			if(result){
				var error_no = result.error_no;
				if(error_no=="0"){
					var mUrl = result.results[0].url;
					if(mUrl){
						global.serverUrl = mUrl;
						global.serverPath = mUrl+"/servlet/json";
						console.log("global.serverUrl---"+global.serverUrl);
						console.log("global.serverPath---"+global.serverPath);
					}
				}else{
//					layerUtils.iAlert("获取开户地址失败", -1);
				}
			}
		}
	}

	/**根据版本改标题*/
	function changeTitle(){
		var textTitle = global.OnlyOpen?"信达证券":"账户开立";
		$(_pageId + " header h3").html(textTitle);
		if(global.OnlyOpen){
			$(_pageId + " .icon_back").hide();
		}else{
			$(_pageId + " .icon_back").show();
		}
	}

	/**获取渠道配置*/
	function getChannelConfig(){
		// 从缓存获取用户数据
		var param = {
			"funcNo":"50043",
			"key":"channel_and_bank"
		};
		var result = external.callMessage(param);
		console.log("获取渠道配置信息："+JSON.stringify(result));
		if(result){
			var error_no = result.error_no;
			if(error_no=="0"){
				var results = result.results[0].value;
				if(results){
					global.channel_baiDu = results.channel_baiDu?results.channel_baiDu:"";
					global.depositoryBank = results.depositoryBank?results.depositoryBank:"";
				}
			}else{
//				layerUtils.iAlert("获取三方信息失败！", -1);
			}
		}
	}

	/**获取三方渠道*/
	function getThird_channel(){
	    //默认为false
		isQR_Code = false;
		// 从缓存获取用户数据
		var param = {
			"funcNo":"50043",
			"key":"qr_scan_result"
		};
		var result = external.callMessage(param);
		console.log("获取三方信息："+JSON.stringify(result));
		if(result){
			var error_no = result.error_no;
			if(error_no=="0"){
				var myUrl = result.results[0].value;
				if(myUrl){
					var organization = getQueryString(myUrl,"organization");
					var bank = getQueryString(myUrl,"bank");
					var branchno = getQueryString(myUrl,"branch");
					var referrer = getQueryString(myUrl,"referrer");
					if(organization||bank||branchno||referrer){
						isQR_Code = organization ? true : false;
						appUtils.setSStorageInfo("organization",organization);
						appUtils.setSStorageInfo("bank",bank);
						appUtils.setSStorageInfo("branchno",branchno);
						appUtils.setSStorageInfo("referrer",referrer);
					}
				}else{
					isQR_Code = false;
				}
			}else{
//				layerUtils.iAlert("获取三方信息失败！", -1);
			}
		}
	}


	function getQueryString(myUrl,param){
		var queryArr = myUrl.split("?")[1].split("&");
		var tempArr, queryObject = {}, item;
		for(var i = 0,len = queryArr.length;i<len;i++){
			item = queryArr[i];
			if(item.indexOf("=") !== -1){
				tempArr = item.split("=");
				queryObject[tempArr[0]] = tempArr[1];
			}
		}
		return queryObject[param] ? queryObject[param] : "";
	}

	/**是否需要证书*/
	function IsNeedCert(){
		if(global.IsNeedCert=="0"){//如果不是0，默认就要证书
			appUtils.setSStorageInfo("flag","0");
		}else{
			appUtils.setSStorageInfo("flag","1");
		}
	}

	function bindPageEvent() {
		// 关闭按钮
		appUtils.bindEvent($(_pageId + " .icon_back"), function() {
			utilsHN2.closeModule("open");
		});

		/* 绑定获取短信验证码事件 */
		appUtils.bindEvent($(_pageId + " .getmsg"), function() {
			var phoneNum = $(_pageId + " .phoneNum").val();
			var verify_code = $(_pageId + " .verify_code").val();
			if (phoneNum == "") {
				layerUtils.iAlert("您还未输入手机号码！", -1);
				return;
			}
			// 首先验证手机号
			if (!validatorUtil.isMobile(phoneNum)) {
				// 手机号没通过前端校验，弹出提示，并终止发送验证码的过程
				var times = phoneNum.length - 11;
				if (phoneNum.length > 11) {
					layerUtils.iAlert("您多输入&nbsp;" + times + "&nbsp;位电话号码，请重新输入！", -1);
				} else if (phoneNum.length < 11) {
					layerUtils.iAlert("您少输入&nbsp;" + Math.abs(times) + "&nbsp;位电话号码，请重新输入！", -1);
				} else {
					layerUtils.iAlert("您输入的电话号码不正确，请重新输入！", -1);
				}
				return false;
			}
			getSmsCode(phoneNum); //获取验证码
		});

		/* 绑定获取语音验证码事件 */
		appUtils.bindEvent($(_pageId+" #getVoice"),function(){
			var phoneNum =  $(_pageId+" .phoneNum").val();
			// 首先验证手机号
			if(validatorUtil.isMobile(phoneNum))
			{
				var ip=appUtils.getSStorageInfo("ip")
				var mac=appUtils.getSStorageInfo("mac")
				sendVoiceMsg(phoneNum,mac,ip); // 发送语音验证码
			}
			else
			{
				// 手机号没通过前端校验，弹出提示，并终止发送验证码的过程
				var times = phoneNum.length - 11;
				if(phoneNum.length > 11)
				{
					layerUtils.iMsg(-1,"您多输入&nbsp;"+times+"&nbsp;位电话号码，请重新输入！");
				}
				else if(phoneNum.length < 11)
				{
					layerUtils.iMsg(-1,"您少输入&nbsp;"+Math.abs(times)+"&nbsp;位电话号码，请重新输入！");
				}
				return;
			}
		});


		/* 下一步(继续开户) */
		appUtils.bindEvent($(_pageId + " .xd_fotbtn"), function() {
			//测试begin-------------
//			layerCustom();
//			return;
			//------------end

			if (validateCode()) {
				checkSmsCode(); //验证码校验
			}
		});
	}

	function validateCode() {
		if ($(_pageId + " .phoneNum").val().length == 0) {
			layerUtils.iAlert("请输入手机号！", -1);
			return false;
		}
		if (!validatorUtil.isMobile($(_pageId + " .phoneNum").val())) {
			layerUtils.iAlert("手机号码格式错误！", -1);
			return false;
		}
		if ($(_pageId + " .mobileCode").val().length == 0) {
			layerUtils.iAlert("请输入验证码！", -1);
			return false;
		}
		return true;
	}

	/**测试弹出框*/
	function layerCustom(){
		utils.layerContent("你看看你","<p>你好</p><p>你好</p><p>你好</p><p>你好</p><p>你好/<p><p>你好</p>");
	}

	function destroy() {
		// 清除计时器
		if (startCountDown != null) {
			window.clearInterval(startCountDown);
		}
		service.destroy();
		$(_pageId).remove();
	}

	/* 获取验证码 */
	function getSmsCode(phoneNum) {
		var mac = iBrowser.pc ? "02:00:5E:00:00:14" : "",
			ip = iBrowser.pc ? "192.168.1.109" : "";
		sendmsg(phoneNum, mac, ip); // 发送验证码
	}

	/* 发送验证码 */
	function sendmsg(phoneNum, mac, ip) {
		var param = {
				// 访问接口来源标识，访问来源(默认PC) 0：pc， 2：pad， 3：手机
				"op_way" : iBrowser.pc ? 0 : 3,
				"mobile_no" : phoneNum,
				"ip" : ip,
				"mac" : mac
			};
			//请求获取验证码接口
			service.getSmsCode(param,function(data){
				var error_no = data.error_no;
				var error_info = data.error_info;
				var result = data.results;
				if(error_no == "0")
				{
					$(_pageId+" #codeInfo p:eq(0)").html("如果1分钟内没有收到验证码短信，您可以通过“语音”方式获取验证码，此服务免费。");
					$(_pageId+" #codeInfo").show();

			        //后台如果返回ip地址，则本地存储用户ip地址
				    if(result[0] && result[0].ip)
				    {
					    appUtils.setSStorageInfo("ip",result[0].ip);
				    }
					// 计时器
					var sumTime = 60;
					//处理获取验证码时发生的动作
					var handleCount = function(){
						// 获取验证码之后按钮隐藏
						$(_pageId+" .getmsg").hide();
						// 显示倒计时
						$(_pageId+" .time").show();
						$(_pageId+" #codeInfo #time").show();
					    $(_pageId+" #codeInfo #getVoice").hide();
						$(_pageId+" .time").css({"background":"#AAAAAA"});
						$(_pageId+" .cert_notice").show();
						var sTime=sumTime--;
						$(_pageId+" .time").text(sTime+"秒后重发");
						$(_pageId+" #codeInfo #time").html(sTime+"秒后,获取语音验证码");
					};
					handleCount();
					startCountDown = window.setInterval(function(){
					handleCount();
					}, 1000);
					//120 秒之后清除计时器
				    var clearCountDown = setTimeout(function(){
						// 显示按钮
						$(_pageId+" .getmsg").show();
						// 隐藏倒计时
						$(_pageId+" .time").hide();
						$(_pageId+" .cert_notice").hide();
						$(_pageId+" .time").text(60);
						$(_pageId+" #codeInfo #time").hide();
						$(_pageId+" #codeInfo #time").html("60秒后,获取语音验证码");
						$(_pageId+" #codeInfo #getVoice").show();
						window.clearInterval(startCountDown);
					},60500);

					 //发送完验证码后，通过判断输入手机号是否一致，否则重新发送验证码
					 var c_phoneNum =phoneNum;
					 appUtils.bindEvent($(_pageId+" .phoneNum"),function(){
						c_phoneNum =$(_pageId+" .phoneNum").val();
					 	if(validatorUtil.isMobile(phoneNum)&&validatorUtil.isMobile(c_phoneNum))
					 	{
					 		//用户两次输入的手机号不同，重新获取验证码
					 		if(c_phoneNum!=phoneNum)
					 		{
					 			clearInterval(startCountDown);   //清除定时器
					 			clearTimeout(clearCountDown);
								$(_pageId+" .getmsg").show();  // 显示按钮
								$(_pageId+" .time").hide();  // 隐藏倒计时
								$(_pageId+" #codeInfo #time").hide();
								$(_pageId+" #codeInfo #getVoice").show();
					 		}
					 	}
					 },"input");
				}
				else
				{
					layerUtils.iAlert(error_info,-1);
					return false;
				}
			});
	}

	/* 发送验证码 */
	function sendVoiceMsg(phoneNum,mac,ip)
	{
		var param = {
			// 访问接口来源标识，访问来源(默认PC) 0：pc， 2：pad， 3：手机
			"op_way" : iBrowser.pc ? 0 : 3,
			"mobile_no" : phoneNum,
			"ip" : ip,
			"mac" : mac
		};
		//请求获取验证码接口
		service.getVoiceCode(param,function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			var code = data.code;
			var result = data.results;
			if(error_no == "0")
			{
				$(_pageId+" #codeInfo p:eq(0)").html("信达证券将向您的手机拨打电话并播报验证码，请注意接听，来电号码：95321。");
				$(_pageId+" #codeInfo #getVoice").show();
		        //后台如果返回ip地址，则本地存储用户ip地址
			    if(result[0] && result[0].ip)
			    {
				    appUtils.setSStorageInfo("ip",result[0].ip);
			    }
				// 计时器
				var sumTime = 60;
				//处理获取验证码时发生的动作
				var handleCount = function(){
					// 获取验证码之后按钮隐藏
					$(_pageId+" .getmsg").hide();
					// 显示倒计时
					$(_pageId+" .time").show();
					$(_pageId+" #codeInfo #time").show();
				    $(_pageId+" #codeInfo #getVoice").hide();
					$(_pageId+" .time").css({"background":"#AAAAAA"});
					$(_pageId+" .cert_notice").show();
					var sTime=sumTime--;
					$(_pageId+" .time").show();
					$(_pageId+" .time").text(sTime+"秒后重发");
					$(_pageId+" #codeInfo #time").html(sTime+"秒后,获取语音验证码");
				};
				handleCount();
				startCountDown = window.setInterval(function(){
				handleCount();
				}, 1000);
				//120000 秒之后清除计时器
			    var clearCountDown = setTimeout(function(){
					// 显示按钮
					$(_pageId+" .getmsg").show();
					// 隐藏倒计时
					$(_pageId+" .time").hide();
					$(_pageId+" .cert_notice").hide();
					$(_pageId+" .time").text(60);
					$(_pageId+" #codeInfo #time").hide();
					$(_pageId+" #codeInfo #time").html("60秒后,获取语音验证码");
					$(_pageId+" #codeInfo #getVoice").show();
					window.clearInterval(startCountDown);
				},60500);
				 //发送完验证码后，通过判断输入手机号是否一致，否则重新发送验证码
				 var c_phoneNum =phoneNum;
				 appUtils.bindEvent($(_pageId+" .phoneNum"),function(){
					c_phoneNum =$(_pageId+" .phoneNum").val();
				 	if(validatorUtil.isMobile(phoneNum)&&validatorUtil.isMobile(c_phoneNum))
				 	{
				 		//用户两次输入的手机号不同，重新获取验证码
				 		if(c_phoneNum!=phoneNum)
				 		{
				 			clearInterval(startCountDown);   //清除定时器
				 			clearTimeout(clearCountDown);
							$(_pageId+" .getmsg").show();  // 显示按钮
							$(_pageId+" .time").hide();  // 隐藏倒计时
							$(_pageId+" #codeInfo #time").hide();
							$(_pageId+" #codeInfo #getVoice").show();
				 		}
				 	}
				 },"input");
			}
			else
			{
				layerUtils.iAlert(error_info,-1);
				return false;
			}
		});
	}
	/* 提交验证码校验 */
	function checkSmsCode() {
		var param = {
//				"login_type": "1",
//				"weixin": appUtils.getSStorageInfo("weixin"),
//				"company": "",
				"mobile_no": $(_pageId + " .phoneNum").val(),
				"mobile_code": $(_pageId + " .mobileCode").val(),
				"login_flag": "0" // 登录业务标准，新开户0  转户1  理财户2,9一人多户
			};
			appUtils.bindEvent($(_pageId + " .mt15"), function() {

			});
			/*调用验证码校验接口*/
//			service.getOpenInfo(param, function(data) {
			service.checkSmsCode(param, function(data) {
				var error_no = data.error_no;
				var error_info = data.error_info;
				var result = data.results;
				if (error_no == "0" && result.length != 0) {
					appUtils.setSStorageInfo("_isLoginIn","true");
					// user_id保存到session
					if (result[0].user_id) {
						appUtils.setSStorageInfo("user_id", result[0].user_id);
					}
					// 身份证号保存到session
					if (result[0].idno) {
						var idno = result[0].idno;
						idno = idno.toUpperCase( );
						appUtils.setSStorageInfo("idCardNo", idno);
					}
					//手机号保存到session
					if (result[0].mobileno) {
						appUtils.setSStorageInfo("mobileNo", result[0].mobileno);
					}
					// 将客户姓名保存到 session 中
					if (result[0].custname) {
						appUtils.setSStorageInfo("custname", result[0].custname);
					}
					// 签发机关保存到session
					if (result[0].policeorg) {
						appUtils.setSStorageInfo("policeorg", result[0].policeorg);
					}
					// 证件地址保存到session
					if (result[0].native) {
						appUtils.setSStorageInfo("native", result[0].native);
					}
					// 联系地址保存到session
					if (result[0].addr) {
						appUtils.setSStorageInfo("addr", result[0].addr);
					}
					// 起始期限保存到session
					if (result[0].idbegindate) {
						appUtils.setSStorageInfo("idbegindate", result[0].idbegindate);
					}
					// 结束期限保存到session
					if (result[0].idenddate) {
						appUtils.setSStorageInfo("idenddate", result[0].idenddate);
					}
					// 邮编保存到session
					if (result[0].postid) {
						appUtils.setSStorageInfo("postid", result[0].postid);
					}
					// 职业保存到session
					if (result[0].profession_code) {
						appUtils.setSStorageInfo("profession_code", result[0].profession_code);
					}
					// 学历保存到session
					if (result[0].edu) {
						appUtils.setSStorageInfo("edu", result[0].edu);
					}
					// 将 clientinfo 保存到 session 中，用于解决壳子上传照片的权限问题
					if (result[0].clientinfo) {
						appUtils.setSStorageInfo("clientinfo", result[0].clientinfo);
					}
					// 将 jsessionid 保存到 session 中，用于解决壳子上传照片的权限问题
					if (result[0].jsessionid) {
						appUtils.setSStorageInfo("jsessionid", result[0].jsessionid);
					}
					// 将佣金id保存到session
					if (result[0].commission) {
						appUtils.setSStorageInfo("commission", result[0].commission);
					}
					// 将佣金值保存到session
					if (result[0].commissionname) {
						appUtils.setSStorageInfo("commissionname", result[0].commissionname);
					}
					// 将营业部Id保存到session
					if (result[0].branchno) {
						appUtils.setSStorageInfo("branchno", result[0].branchno);
					}
					// 将营业部名称保存到session
					if (result[0].branchname) {
						appUtils.setSStorageInfo("branchname", result[0].branchname);
					}
					// 将省份保存到session
					if (result[0].provincename) {
						appUtils.setSStorageInfo("provincename", result[0].provincename);
					}
					// 将城市保存到session
					if (result[0].cityname) {
						appUtils.setSStorageInfo("cityname", result[0].cityname);
					}
					// 将视频状态保存到session
					if (result[0].witness_flag) {
						appUtils.setSStorageInfo("witness_flag", result[0].witness_flag);
					}
					// 将公安校验保存到session
					if (result[0].police_flag) {
						appUtils.setSStorageInfo("police_flag", result[0].police_flag);
					}
					appUtils.setSStorageInfo("shaselect", result[0].shaselect); // 是否选择沪A
					appUtils.setSStorageInfo("szaselect", result[0].szaselect); // 是否选择深A
					appUtils.setSStorageInfo("hacnselect", result[0].shaselect); // 是否选择沪开放式基金
					appUtils.setSStorageInfo("zacnselect", result[0].szaselect); // 是否选择深开放式基金
					var  opacctkind_flag = result[0].opacctkind_flag;  // 开户通道的标识，0 新开户，1 转户 , 2 理财户
					// 根据 opacctkind_flag 设置 session 中的 openChannel
					if(opacctkind_flag == 0)
					{
						appUtils.setSStorageInfo("openChannel","new");
					}
					else
					{
						if(opacctkind_flag == 2)
						{
							appUtils.setSStorageInfo("finance","finance");
						}
//						appUtils.setSStorageInfo("openChannel","change");//屏蔽掉可能出现的转户问题
					}
					//判断是否驳回，若驳回 则走驳回流程
					if (addition(result[0])) {
						return false;
					} else {
						// 如果是公安验证不通过
						nextStep(result[0], opacctkind_flag);
					}
				} else {
					layerUtils.iAlert(error_info, -1);
				}
			});
	}

	/* 处理驳回补全资料的情况 */
	function addition(res) {
		//驳回情况：身份证正面、反面、大头像、账户选择、交易密码、资金密码、三方存管、转户驳回到视频见证
		var photoParam = {
			"needFront": res.need_photo_front != undefined ? res.need_photo_front : "0",
			"needBack": res.need_photo_back != undefined ? res.need_photo_back : "0",
			"needNohat": res.need_photo_nohat != undefined ? res.need_photo_nohat : "0",
			"front_reason": res.need_photo_front_reason != undefined ? res.need_photo_front_reason : "",
			"back_reason": res.need_photo_back_reason != undefined ? res.need_photo_back_reason : "",
			"nohat_reason": res.need_photo_nohat_reason != undefined ? res.need_photo_nohat_reason : ""
		};
		var accountParam = {
			"need_account": res.need_account != undefined ? res.need_account : "0"
		};
		var pwdParam = {
			"needBusinessPwd": res.need_business_password != undefined ? res.need_business_password : "0",
			"needFundPwd": res.need_fund_password != undefined ? res.need_fund_password : "0"
		};
		var thirdParam = {
			"needThirdDeposit": res.need_third_deposit != undefined ? res.need_third_deposit : "0"
		};
		var videoParam = {
			"need_video": res.need_video != undefined ? res.need_video : ""
		};
		appUtils.setSStorageInfo("videoParam", JSON.stringify(videoParam));
		appUtils.setSStorageInfo("pwdParam", JSON.stringify(pwdParam));
		appUtils.setSStorageInfo("thirdParam", JSON.stringify(thirdParam));
		appUtils.setSStorageInfo("accountParam", JSON.stringify(accountParam));
		appUtils.setSStorageInfo("photoParam", JSON.stringify(photoParam));
		// 1.补全照片
		if (photoParam["needFront"] == 1 || photoParam["needBack"] == 1) {
			appUtils.pageInit("account/msgVerify", "account/backUploadPhoto", photoParam);
			return true;
		}
				// 2.驳回视频见证
		if (videoParam["need_video"] == 1) {
			appUtils.pageInit("account/msgVerify", "account/videoNotice", videoParam);
			return true;
		}
		// 5.驳回开立账户
		if (accountParam["need_account"] == 1) {
			appUtils.pageInit("account/msgVerify", "account/backSignProtocol", accountParam);
			return true;
		}
		// 3.驳回密码设置
		if (pwdParam["needBusinessPwd"] == 1 || pwdParam["needFundPwd"] == 1) {
			appUtils.pageInit("account/msgVerify", "account/backSetPwd", pwdParam);
			return true;
		}
		// 4.驳回三方存管
		if (thirdParam["needThirdDeposit"] == 1) {
			appUtils.pageInit("account/msgVerify", "account/backThirdDepository", thirdParam);
			return true;
		}
		return false;
	}

	/* 下一步入口 */
	function nextStep(res, opacctkind_flag) {
		var pageCode = "";
		var currentStep = res["lastcomplete_step"]; //断点：上次走的最后一步
		appUtils.setSStorageInfo("currentStep", currentStep);
		if (currentStep && currentStep.length > 0) {
			var index = steps.indexOf(currentStep);
			if (index < (steps.length - 1)) {
				currentStep = steps[index + 1];
			}
            pageCode = stepMap[currentStep];
//            var index = steps.indexOf(currentStep);
//			if(index < (steps.length-1))
//			{
//				currentStep = steps[index + 1];
//			}
//			if(opacctkind_flag == "0")
//			{
//				pageCode = stepMap[currentStep];
//			}
//			else
//			{
//				pageCode = stepMap0[currentStep];
//				if(!(pageCode && pageCode.length > 0))
//				{
//					pageCode = stepMap[currentStep];
//				}
//			}
		}
		if (pageCode && pageCode.length > 0) {
//			if((res["lastcomplete_step"]=="idconfirm" || res["lastcomplete_step"]=="infoconfirm") && appUtils.getSStorageInfo("police_flag")=="0")
//			{
//				appUtils.pageInit("account/msgVerify", "account/personInfo", {});
//			}
//			else
//			{
//				appUtils.pageInit("account/msgVerify", pageCode, {});
//			}
			// 如果是直接跳转到 视频认证 页面，将 QQ 保存到 session 中
			if(pageCode == "account/videoNotice")
			{
				appUtils.setSStorageInfo("qq",res.im_code);
			}
			if(appUtils.getSStorageInfo("flag") == "0"){//如果不需要证书，不需要走到证书安装页面
				if(pageCode == "account/digitalCertificate"){
					pageCode = "account/signProtocol";
				}
			}
			if(isQR_Code){//如果是扫描二维码的
				baocuntgxx(pageCode);//传需要跳转的页面
			}
			else {
				if(global.channel_baiDu){
					baocuntgxx(pageCode);//传需要跳转的页面
            	}else{
					appUtils.pageInit("account/msgVerify",pageCode,{});
//				    appUtils.pageInit("account/msgVerify","account/thirdDepository",{});
            	}
			}
		} else {
			if(isQR_Code){//如果是扫描二维码的
				baocuntgxx();//传需要跳转的页面
			}
			else {
				if(global.channel_baiDu){
					baocuntgxx();//传需要跳转的页面
				}else{
					appUtils.pageInit("account/msgVerify", "account/selDepartment", {}); //跳转到选择营业部页
				}
			}
		}
	}

    /**渠道信息存入数据库*/
	function baocuntgxx(pageCode) {
		var referParam = "";
		if(!isQR_Code&&global.channel_baiDu){
			referParam = {
				mobileno: appUtils.getSStorageInfo("mobileNo"),
				third_channel: global.channel_baiDu
			}
		}
		if(isQR_Code){
			referParam = {
				mobileno: appUtils.getSStorageInfo("mobileNo"),
				third_channel: appUtils.getSStorageInfo("organization"),   //
				brokercode: appUtils.getSStorageInfo("referrer"),
				branchno: appUtils.getSStorageInfo("branchno"),
				banktype: appUtils.getSStorageInfo("bank"),
				fundAccount_type: appUtils.getSStorageInfo("capitalType")
			}
		}
		console.log(referParam);
		if(referParam){
			service.setUploadrefer(referParam, function(data) {
				var error_no = data.error_no;
				var error_info = data.error_info;
				if (error_no === "0") {
					if(pageCode){//需要跳转的页面
						appUtils.pageInit("account/msgVerify", pageCode);
					}else{
						appUtils.pageInit("account/msgVerify", "account/selDepartment");
					}
				} else {
					layerUtils.iLoading(false);
					layerUtils.iAlert(error_info, -1);
				}
			});
		}
	}

	var msgVerify = {
		"init": init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};

	//暴露接口
	module.exports = msgVerify;
});