/**
 * 确认个人信息
 */
define(function(require, exports, module) {
	/* 私有业务模块的全局变量 begin */
	var appUtils = require("appUtils"),
		service = require("serviceImp").getInstance(), //业务层接口，请求数据
		global = require("gconfig").global,
		layerUtils = require("layerUtils"),
		utils = require("utils"),
		utilsHN2 = require("utilsHN2"),
		validatorUtil = require("validatorUtil"),
		_pageId = "#account_personInfoVerify";
	/* 私有业务模块的全局变量 end */

	function init() {
		if (appUtils.getSStorageInfo("_prePageCode") == "account/signProtocol") {
			appUtils.pageInit("account/personInfoVerify", "account/signProtocol");
			return false;
		}
		var docuHeight = $(window).height();
		var headerHeight = $(".header").height();
		//$(_pageId+" #main_div").height($(window).height()-headerHeight).css({overflow:"auto"});
		//$(_pageId+" .user_form").css({"height":(docuHeight-headerHeight-fixbotHeight-stepboxHeight-toptitleHeight)+"px","overflow":"auto"});
		//		if (appUtils.getSStorageInfo("_prePageCode") == "account/personInfo") {
		//			var param = appUtils.getPageParam();
		//			$(_pageId + " .user_form p:eq(0)").html("姓&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;名：" + param.custname);
		//			$(_pageId + " .user_form p:eq(1)").html("身份证号：" + param.idno);
		//			$(_pageId + " .user_form p:eq(2)").html("签发机关：" + param.policeorg);
		//			$(_pageId + " .user_form p:eq(3)").html("证件地址：" + param.native);
		//			$(_pageId + " .user_form p:eq(4)").html("联系地址：" + param.addr);
		//			$(_pageId + " .user_form p:eq(5)").html("起始日期：" + param.idbegindate);
		//			$(_pageId + " .user_form p:eq(6)").html("结束日期：" + param.idenddate);
		//			getManager();
		//		} else {
		$(_pageId + " .user_form p:eq(0)").html("姓&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;名：" + appUtils.getSStorageInfo("custname"));
		$(_pageId + " .user_form p:eq(1)").html("身份证号：" + appUtils.getSStorageInfo("idCardNo"));
		$(_pageId + " .user_form p:eq(2)").html("签发机关：" + appUtils.getSStorageInfo("policeorg"));
		$(_pageId + " .user_form p:eq(3)").html("证件地址：" + appUtils.getSStorageInfo("native"));
		$(_pageId + " .user_form p:eq(4)").html("联系地址：" + appUtils.getSStorageInfo("addr"));
		$(_pageId + " .user_form p:eq(5)").html("起始日期：" + appUtils.getSStorageInfo("idbegindate"));
		$(_pageId + " .user_form p:eq(6)").html("结束日期：" + appUtils.getSStorageInfo("idenddate"));
		getCommission();
		//		}
	}

	function bindPageEvent() {
		// 关闭按钮
		appUtils.bindEvent($(_pageId + " .icon_close"), function() {
			utilsHN2.closeModule("open");
		});

			/* 绑定返回 */
			appUtils.bindEvent($(_pageId + " .header .icon_back"), function() {
//				appUtils.pageBack();
				appUtils.pageInit("account/personInfoVerify","account/personInfo",{});
			});

			appUtils.bindEvent($(_pageId + " .ct_btn"), function() {
				//跳转到视频见证页面
				appUtils.pageInit("account/personInfoVerify","account/videoNotice",{});
//				getAllPhoto(); //合成照片
//				syncCustInfo(); //同步信息
			});

		}
		/* 合成照片 */

	function getAllPhoto() {
			var photoParam = {
				"user_id": appUtils.getSStorageInfo("user_id")
			};
			service.getAllPhoto(photoParam, function(data) {
				var error_no = data.error_no,
					error_info = data.error_info;
				if (error_no == "0") {
					syncCustInfo(); //同步信息
				} else {
					layerUtils.iLoading(false);
					layerUtils.iMsg(-1, error_info); // 提示错误信息
				}
			}, false);
		}
		/**
		 * 功能： 公安验证
		 * @param user_id 用户id
		 * @param mobile_no 手机号码
		 * @param  id_no  身份证号码
		 * @param  user_name 用户姓名
		 * @returns policePhotoFlag 是否存在公安验证大头照
		 */

	function identityRecognition() {
		var param = {
			"user_id": appUtils.getSStorageInfo("user_id"),
			"mobile_no": appUtils.getSStorageInfo("mobileNo"),
			"id_no": appUtils.getSStorageInfo("idCardNo"),
			"user_name": appUtils.getSStorageInfo("custname")
		}
		service.identityRecognition(param, function(data) {
			if (data.error_no == 0) {
				var policePhotoFlag = data.results[0].policePhotoFlag;
				if (policePhotoFlag == "1") {
					// 跳转到签署协议
//					appUtils.pageInit("account/personInfoVerify", "account/postConfirmStep1", {});
					appUtils.pageInit("account/personInfoVerify", "account/videoNotice", {});
				} else {
					layerUtils.iAlert("公安验证失败，请联系客服", -1, function() {});
				}
			} else {
				layerUtils.iAlert(data.error_info, -1);
			}
		}, true, true);
	}

	function syncCustInfo() {
			var syncCustInfoParam = {
				"user_id": appUtils.getSStorageInfo("user_id"),
				"autentication_type": global.isvideo //是3姿势开户,是1单向视频
			};
			service.syncCustInfo(syncCustInfoParam, function(data) {
				if (data.error_no == 0) {
					identityRecognition(); //公安校验
//                    appUtils.pageInit("account/personInfoVerify", "account/postConfirmStep1", {});
				} else {
					layerUtils.iLoading(false);
					layerUtils.iAlert(data.error_info, -1);
				}
			}, false, true)
		}
		//获取佣金信息

	function getCommission() {
		var param = {
			"idno": appUtils.getSStorageInfo("idCardNo"),
			"branchno": appUtils.getSStorageInfo("branchno"),
			"third_channel": appUtils.getSStorageInfo("organization")
		};
		service.getCommissionInfo(param, function(data) {
			var error_no = data.error_no;
			var error_info = data.error_info;

			if (error_no == "0") {
				var result = data.commission;
				var result1 = data.result1;
				//alert("佣金信息结果集："+JSON.stringify(result));
				$(_pageId + " .user_form p:eq(10)").html("A股佣金:" + result[0].agcommission + "‰");
				$(_pageId + " .user_form p:eq(11)").html("B股佣金:" + result[0].bgcommission + "‰");
				$(_pageId + " .user_form p:eq(12)").html("基金佣金:" + result[0].jjcommission + "‰");
				$(_pageId + " .user_form p:eq(13)").html("债券佣金:" + result[0].zqcommission + "‰");
				$(_pageId + " .user_form p:eq(14)").html("港股通佣金:" + result[0].ggtcommission + "‰");
				$(_pageId + " .user_form p:eq(15)").html("股转佣金:" + result[0].gzcommission + "‰");
				$(_pageId + " .user_form p:eq(16)").html("其&#160;&#160;&#160;&#160;他(‰)：" + result1[0].direction);
				appUtils.setSStorageInfo("pid", result[0].pid);
				appUtils.setSStorageInfo("confirm", result[0].confirm);
				if (appUtils.getSStorageInfo("manager") != "" && appUtils.getSStorageInfo("manager") != null && appUtils.getSStorageInfo("manager") != "undefined" && appUtils.getSStorageInfo("manager") != undefined) {
					getManager();
				} else {
					$(_pageId + " .user_form p:eq(7)").html("客户经理姓名：无");
					$(_pageId + " .user_form p:eq(8)").html("客户经理编号：无");
					$(_pageId + " .user_form p:eq(9)").html("资&#160;&#160;&#160;格&#160;&#160;&#160;证&#160;&#160;书：无");
				}
				layerUtils.iLoading(false);
			} else {
				layerUtils.iLoading(false);
				layerUtils.iMsg(-1, error_info);
			}
		}, false);
	}

	//获取客户经理信息
	function getManager() {
		var param = {
			"recommendno": appUtils.getSStorageInfo("manager"),
			"branchno": appUtils.getSStorageInfo("branchno")
		};
		service.getManagerInfo(param, function(data) {
			var error_no = data.error_no;
			var error_info = data.error_info;
			var result = data.results;
			if (error_no == "0") {
				if (result.length == 0) {
					$(_pageId + " .user_form p:eq(7)").html("客户经理姓名：无");
					$(_pageId + " .user_form p:eq(8)").html("客户经理编号：无");
					$(_pageId + " .user_form p:eq(9)").html("资&#160;&#160;&#160;格&#160;&#160;&#160;证&#160;&#160;书：无");
				} else {
					$(_pageId + " .user_form p:eq(7)").html("客户经理姓名：" + result[0].ygxm);
					$(_pageId + " .user_form p:eq(8)").html("客户经理编号：" + result[0].ygbh);
					$(_pageId + " .user_form p:eq(9)").html("资&#160;&#160;&#160;格&#160;&#160;&#160;证&#160;&#160;书：" + result[0].ygzh);
				}
			} else {
				layerUtils.iMsg(-1, error_info);
			}
		});
	}

	function destroy() {
		service.destroy();
		$(_pageId).remove();
	}
	var personInfoVerify = {
		"init": init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};

	module.exports = personInfoVerify;

});