/**
 * 风险测评结果
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils"),
		global = require("gconfig").global,
		service = require("serviceImp").getInstance(), //业务层接口，请求数据
		protocol = "",
		cert_type = "zd", // tw:天威 zd:中登
		layerUtils = require("layerUtils"),
		utilsHN2 = require("utilsHN2"),
		_pageId = "#account_riskAssessmentResult";

	/*获取风险测评证书协议*/
	function queryRiskAssessmentAgreement() {
		var param = {
			"category_englishname": "fxxys"
		};
		service.queryProtocolList(param, function(data) {
			var error_no = data.error_no,
				results = data.results,
				error_info = data.error_info;
			allProtocols = "";
			for (var i = 0; i < results.length; i++) {
				if (error_no == 0 && data.results) {
					protocol = data.results[0];
					allProtocols += "<li><a href=\"javascript:;\" protocol-id=\"" + results[i].econtract_no + "\" id=\"protocol0" + i + "\">《" +
						results[i].econtract_name + "》</a></li>";
					$(_pageId + " .rule_list ul").html(allProtocols);
					// 预绑定查看协议的事件
					appUtils.preBindEvent($(_pageId + " .rule_list ul"), "#protocol0" + i, function(e) {
						appUtils.pageInit("account/riskAssessmentResult", "account/showProtocol", {
							"protocol_id": $(this).attr("protocol-id")
						});
						e.stopPropagation();
					});
				} else {
					layerUtils.iAlert(data.error_info);
				}
			}
		}, true, true, handleTimeout);
	}

	/* 处理请求超时 */
	function handleTimeout() {
		layerUtils.iConfirm("请求超时，是否重新加载？", function() {
			queryRiskAssessmentAgreement(); // 再次获取中登协议
		});
	}

	function init() {
		queryRiskAssessmentAgreement();
		//设置按钮显示提示文字
		if (appUtils.getSStorageInfo("openChannel") == "change") {
			if (appUtils.getSStorageInfo("finance") == "finance") {
				$(_pageId + " .fix_bot .ct_btn a").html("继续开户 >"); // 理财户
			} else {
				$(_pageId + " .fix_bot .ct_btn a").html("继续转户 >"); // 转户
			}
		} else {
			$(_pageId + " .fix_bot .ct_btn a").html("继续开户 >"); // 新开户
		}

		// 只有从 riskAssessment 跳转过来时，才设置页面的填充数据
		if (appUtils.getSStorageInfo("_prePageCode") == "account/riskAssessment") {
			var remark = appUtils.getPageParam("remark"); //风险等级
			var riskdesc = appUtils.getPageParam("riskdesc"); //风险等级描述
			var showStr = riskdesc;
			var mark_sum = appUtils.getPageParam("mark_sum"); //测试结果分值总和
			if (mark_sum < 60) {
				$(_pageId + " .user_form").show();
			} else {
				$(_pageId + " .user_form").hide();
			}
			// 清空原有内容
			$(_pageId + " div[class='test_level'] div").text("");
			$(_pageId + " div[class='test_level'] div").append(showStr);
		}
	}

	function bindPageEvent() {
		// 关闭按钮
		appUtils.bindEvent($(_pageId + " .icon_close"), function() {
			utilsHN2.closeModule("open");
		});

		// 重新测评绑定事件
		appUtils.bindEvent($(_pageId + " .test_result p:eq(1) a"), function() {
			appUtils.pageInit("account/riskAssessmentResult", "account/riskAssessment", {});
		});

		appUtils.bindEvent($(_pageId + " .rule_check .icon_check"), function() {
			$(this).toggleClass("checked"); //  切换勾选样式
		});

		/* 签署风险测评协议 */
		function signProtocl() {
			// 检查是否勾选签署协议
			if ($(_pageId + " .rule_check a").hasClass("checked")) {
				var protocolArray = new Array(), // 协议数组
					userid = appUtils.getSStorageInfo("user_id"),
					ipaddr = appUtils.getSStorageInfo("ip"),
					macaddr = appUtils.getSStorageInfo("mac"),
					protocolid = protocol.econtract_no,
					protocolname = protocol.econtract_name,
					summary = protocol.econtract_md5; // 协议内容MD5,签名摘要信息
				// 添加值到数组中
				var protocolParam = {
					"protocol_id": protocolid,
					"summary": summary
				}
				protocolArray.push(protocolParam); // 添加值到数组中
				// 签署协议
				var signProtocolParam = {
					"user_id": userid,
					"jsondata": JSON.stringify(protocolArray),
					"ipaddr": ipaddr,
					"macaddr": macaddr,
					"checksign": "0"
				};
				service.queryOpenCheckSign(signProtocolParam, callSign, false);
			} else {
				layerUtils.iMsg(-1, "请阅读并勾选同意签署以上全部协议！");
				return false;
			}
		}

		/* 验签回调函数*/
		function callSign(data) {
				// 如果有一个协议签署失败，就将签署结果设为 false
				if (data.error_no == 0) {
					if (global.needConfirm) {
						appUtils.pageInit("account/riskAssessmentResult", "account/openConfirm", {});
					} else {
						appUtils.pageInit("account/riskAssessmentResult", "account/accountResult", {});
					}
				} else {
					layerUtils.iLoading(false); // 关闭等待层。。。
					layerUtils.iAlert(data.error_info, -1);
				}
			}
			/**
			 * 9.1
			 * 风险测评结果页面进入问卷回访页面
			 */
		appUtils.bindEvent($(_pageId + " .ct_btn"), function() {
			var mark_sum = appUtils.getPageParam("mark_sum"); //测试结果分值总和
			if (mark_sum < 60) {//如果分数不是小于60，不需要签署协议
				signProtocl();
			} else {
				if(global.needConfirm)
				{
					appUtils.pageInit("account/riskAssessmentResult","account/openConfirm",{});
				}
				else
				{
					appUtils.pageInit("account/riskAssessmentResult","account/accountResult",{});
				}
			}
		});
	}

	function destroy() {}

	var riskAssessmentResult = {
		"init": init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};

	module.exports = riskAssessmentResult;
});