/**
 * 设置密码
 */
define(function(require,exports,module){
	/* 私有业务模块的全局变量 begin */
	var appUtils = require("appUtils"),
	    service = require("serviceImp").getInstance(),  //业务层接口，请求数据
		global = require("gconfig").global,
		validatorUtil = require("validatorUtil"),
		layerUtils = require("layerUtils"),
		utils = require("utils"),
		utilsHN2 = require("utilsHN2"),
		platform = require("gconfig").platform,
		protocol = null,  //保存协议
		cert_type = appUtils.getSStorageInfo("openChannel") == "new" ? "zd" : "tw", // tw:天威 zd:中登
		_pageId = "#account_setPwd";
		var isA="0";
		var external = require("external");
	/* 私有业务模块的全局变量 end */
	
	function init()
	{
		initPage();  // 初始化页面
	}
	
	function bindPageEvent()
	{
		// 关闭按钮
		appUtils.bindEvent($(_pageId + " .icon_close"), function() {
			utilsHN2.closeModule("open");
		});

		/* 点击页面隐藏键盘 */
		appUtils.bindEvent($(_pageId),function(e){
			// 关闭密码键盘
			closeKeyboard();//关闭密码键盘
			e.stopPropagation();	// 阻止冒泡
		});

		/* 点击密码框统一调用密码键盘 */
		appUtils.bindEvent($(_pageId+" .user_form input"),function(e){
			var hg = $(window).height()+100;
			 $(_pageId).css("height",hg+"px");
			OpenKeyBoard("account_setPwd",$(this));//打开密码键盘
			e.stopPropagation();	// 阻止冒泡
		});
		
		/* 是否设置资金密码与交易密码一致（隐藏显示）*/
		appUtils.bindEvent($(_pageId+" .mt15 .icon_check:eq(0)"),function(){
			if($(_pageId+" .mt15 .icon_check:eq(0)").hasClass("checked")){
				$(_pageId+" .user_form #pass3").val("");
				$(_pageId+" .user_form #pass4").val("");
			}
			$(_pageId+" .user_form h5:eq(1)").toggle();
			$(_pageId+" .user_form .circular:eq(1)").toggle();
			$(_pageId+" .user_form .mt10").toggle();
			$(_pageId+" #checkprotocol").toggle();
			$(_pageId+" .l_link").toggle();
			$(this).toggleClass("checked");
		});
		
		/* 勾选协议按钮 */
		appUtils.bindEvent($(_pageId+" #checkprotocol .icon_check:eq(0)"),function(){
			$(this).toggleClass("checked");
		});
		
		/* 查看协议内容的事件 */
		appUtils.bindEvent($(_pageId+" #protocolName"),function(){
			appUtils.pageInit("account/setPwd","account/showProtocol",{"protocol_id":$(this).attr("protocolId")});
		});
		
		//取得焦点
		/*
		appUtils.bindEvent($(_pageId+" #pass1"),function(){
		//$(this).css({"background":"#b5d3f2"});
			$(this).addClass("input_focus");
		},"focus");
		//取得焦点
		appUtils.bindEvent($(_pageId+" #pass2"),function(){
			$(this).addClass("input_focus");
		},"focus");
		//取得焦点
		appUtils.bindEvent($(_pageId+" #pass3"),function(){
			$(this).addClass("input_focus");
		},"focus");
		//取得焦点
		appUtils.bindEvent($(_pageId+" #pass4"),function(){
			$(this).addClass("input_focus");
		},"focus");
		
		
		/* 密码框绑定失去焦点事件 */

		appUtils.bindEvent($(_pageId+" #pass1"),function(){
			validatePassword($(this));
		},"blur");

        appUtils.bindEvent($("#pass1"), function(){
            $("#pass2").val("");
        },"input");
		
		
		appUtils.bindEvent($(_pageId+" #pass3"),function(){
			validatePassword($(this));
		},"blur");
        appUtils.bindEvent($("#pass3"), function(){
            $("#pass4").val("");
        },"input");
		
		
		/* 密码框绑定检验二次密码是否匹配事件 */

		appUtils.bindEvent($(_pageId+" #pass2"),function(){
			if(!validatePassword($("#pass1"))){
				$(this).blur();
			}
		},"focus");

		appUtils.bindEvent($("#pass2"), function () {
            validateSecondPassword($(this),"1");
        },"blur");
		
		appUtils.bindEvent($(_pageId+" #pass4"),function(){
            if(!validatePassword($("#pass3"))){
                $(this).blur();
            }
		},"focus");
        appUtils.bindEvent($("#pass4"),function(){
            validateSecondPassword($(this),"2");
        },"blur");



		/* 继续开户 */
		appUtils.bindEvent($(_pageId+" .ct_btn"),function(){
			if(validatePost())
			{
				postPassword();  // 不需要签署协议，直接提交密码
			}
		});
	}

	/**关闭密码键盘*/
	function closeKeyboard(){
	    console.log("关闭键盘");
		// 关闭密码键盘
		var param = {
			"funcNo":"50211",
			"moduleName":"open"
		};
		external.callMessage(param);
	}

	/**打开密码键盘*/
	function OpenKeyBoard(pageIdNow,obj){
		var param = {
			"funcNo":"50210",
			"moduleName":"open",
			"pageId":pageIdNow,
			"eleId":obj.attr("id"),
			"doneLable":"完成",
			"keyboardType":"4"
		};
		external.callMessage(param);
		console.log("打开键盘");
	}
	
	function destroy()
	{
		service.destroy();
	}
	
	/* 页面初始化 */
	function initPage()
	{
		layerUtils.iLoading(false);  // 关闭等待层。。。
		cleanPageElement();  // 清理页面元素
	}
	
	/* 清理界面元素 */
	function cleanPageElement()
	{
		$(_pageId+" .input_text input").val(""); // 清理所有的密码框
		$(_pageId+" .input_form:eq(1)").hide(); 
		$(_pageId+" .user_form h5:eq(1)").hide();
		$(_pageId+" .user_form .mt10").show();
		$(_pageId+" .mt15 .icon_check:eq(0)").addClass("checked"); //默认选中
	}
	
	/* 密码提交时校验 */
	function validatePost()
	{
		var pass1 = $(_pageId+" #pass1").val().trim();
		var pass2 = $(_pageId+" #pass2").val().trim();
		var pass3 = $(_pageId+" #pass3").val().trim();
		var pass4 = $(_pageId+" #pass4").val().trim();
		if($(_pageId+" .mt15 .icon_check:eq(0)").hasClass("checked"))
		{
			if(validatorUtil.isEmpty(pass1)||validatorUtil.isEmpty(pass2))
			{
				layerUtils.iMsg(-1,"请完成密码设置!");
				return false;	
			}
		}
		else
		{
			if((validatorUtil.isEmpty(pass1)||validatorUtil.isEmpty(pass2))&&(validatorUtil.isEmpty(pass3)||validatorUtil.isEmpty(pass4)))
			{
				layerUtils.iMsg(-1,"请完成密码设置!");
				return false;	
			}
			else if(validatorUtil.isEmpty(pass1)||validatorUtil.isEmpty(pass2))
			{
				layerUtils.iMsg(-1,"请完成交易密码设置!");
				return false;	
			}
			else if(validatorUtil.isEmpty(pass3)||validatorUtil.isEmpty(pass4))
			{
				layerUtils.iMsg(-1,"请完成资金密码设置!");
				return false;	
			}
		}
		if(pass1.length!="6")
		{
			layerUtils.iMsg(-1,"请输入6位数字交易密码，请重新输入!");
			return false;	
		}
		else if(pass1!=pass2)
		{
			$(_pageId+" #pass2").val("");
			isA="1";
			layerUtils.iMsg(-1,"交易密码与第一次不符，请重新输入!");
			return false;	
		}
		if(!$(_pageId+" .mt15 .icon_check:eq(0)").hasClass("checked"))
		{
			if(pass3.length!="6")
			{
				layerUtils.iMsg(-1,"请输入6位数字资金密码，请重新输入!");
				return false;	
			}
			else if(pass3 != pass4)
			{
				$(_pageId+" #pass4").val("");
				isA="1";
				layerUtils.iMsg(-1,"资金密码与第一次不符，请重新输入!");
				return false;	
			}
		}
		else
		{
			$(_pageId+" #pass3").val(pass1);
			$(_pageId+" #pass4").val(pass1);
		}
		return true;
	}
	
	/* 验证密码 6位数字 */
	function validatePassword(obj)
	{
		var password = obj.val().trim();

        if(password === ""){
            return false;
        }

		if(!validatorUtil.isNumeric(password) || password.length !=6)
		{
			if(isA=="0")
			{
			    layerUtils.iMsg(-1,"请输入6位数字密码");
			}else{
				isA="0";
			}			
			return false;
		}
		/**
		 * 增加弱密校验
		 * 1、出生日期的一部分
		 * 2、证件号码的一部分
		 * 3、某一字符出现的概率不能占总长度的一半以上
		 * 4、顺序递增或者递减
		 * 5、弱密表的控制值
		 * 6、移动电话的一部分
		 * 7、固定电话的一部分
		 */
		var idCardNo = appUtils.getSStorageInfo("idCardNo")?appUtils.getSStorageInfo("idCardNo"):"",
			mobileNo = appUtils.getSStorageInfo("mobileNo")?appUtils.getSStorageInfo("mobileNo"):"";
		// 判断是不是出生日期的一部分
		if(password == idCardNo.substring(6,12) || password == idCardNo.substring(8,14))
		{
			layerUtils.iAlert("密码不能是出生日期的一部分！",-1);
			// 将密码清除
			obj.val("");
			return false;
		}
		// 判断是不是证件号码的一部分
		if(idCardNo.indexOf(password) != -1)
		{
			layerUtils.iAlert("密码不能是证件号码的一部分！",-1);
			// 将密码清除
			obj.val("");
			return false;
		}
		// 判断某一字符出现的次数
		for(var i=0;i<password.length;i++)
		{
			var oneChar = password.charAt(i),
				count = 0;
			var firstPosition = 0;
			for(var j=0;j<password.length;j++)
			{
				if(oneChar == password.charAt(j))
				{
					count++;
				}
			}
			if(count >= 3)
			{
				layerUtils.iAlert("密码中&nbsp;"+oneChar+"&nbsp;出现的次数超过了三次！",-1);
				// 将密码清除
				obj.val("");
				return false;
			}
		}
		// 判断顺序递增或者递减
		var orderArray = [012345,123456,234567,345678,456789,987654,876543,765432,654321,543210];
		if(orderArray.indexOf(password) != -1)
		{
			layerUtils.iAlert("密码不能是顺序递增或者递减！",-1);
			// 将密码清除
			obj.val("");
			return false;
		}
		//判断弱密码库
		var weakpwdArr=['111111','222222','333333','444444','555555','666666','777777','888888','999999','101010','202020','303030',
					'404040','505050','606060','707070','808080','909090','101010','121212','131313','141414','151515','161616',
					'171717','181818','191919','202020','212121','232323','242424','252525','262626','272727','282828','292929',
					'303030','313131','323232','343434','353535','363636','373737','383838','393939','404040','414141','424242',
					'434343','454545','464646','474747','484848','494949','505050','515151','525252','535353','545454','565656',
					'575757','585858','595959','606060','616161','626262','636363','646464','656565','676767','686868','696969',
					'707070','717171','727272','737373','747474','757575','767676','787878','797979','808080','818181','828282',
					'838383','848484','858585','868686','878787','898989','909090','919191','929292','939393','949494','959595',
					'969696','979797','989898','123412','234523','345634','456745','567856','678967','123012','123123','234234',
					'345345','456456','567567','678678','789789','112233','111222','123412','123443','234567','123456','876543',
					'111122','222233','333344','444455','555566','666677','777788','888899','999900','111111','111122','111133',
					'111144','111155','111166','111177','111188','111199','111100'];
		if(weakpwdArr.indexOf(password) != -1)
		{
			layerUtils.iAlert("请勿输入简单组合的密码！",-1);
			// 将密码清除
			obj.val("");
			return false;
		}
		// 判断是否是移动电话的一部分
		if(mobileNo.indexOf(password) != -1)
		{
			layerUtils.iAlert("密码不能是移动电话的一部分！",-1);
			// 将密码清除
			obj.val("");
			return false;
		}

		return true;
	}
	
	/* 验证二次输入密码是否相同 */
	function validateSecondPassword(obj,i)
	{
		if(i=="1")//交易密码
		{
			var pass1 = $(_pageId+" #pass1").val().trim();
			var pass2 = $(_pageId+" #pass2").val().trim();
            if(pass2 === ""){
                return false;
            }
			if(pass1.length != 6)
			{
				layerUtils.iMsg(-1,"请输入6位数字交易密码，请重新输入!");
			}
			else if(pass1 != pass2 && pass2 != "")
			{
				layerUtils.iMsg(-1,"交易密码与第一次不符，请重新输入!");
				$(_pageId+" #pass2").val("");
			}
		}
		else  //资金密码
		{
			var pass3 = $(_pageId+" #pass3").val().trim();
			var pass4 = $(_pageId+" #pass4").val().trim();
            if(pass4 === ""){
                return false;
            }
			if(pass4.length != 6)
			{
				layerUtils.iMsg(-1,"请输入6位数字资金密码，请重新输入!");
			}
			else if(pass3 != pass4 && pass4 != "")
			{
				layerUtils.iMsg(-1,"资金密码与第一次不符，请重新输入!");
				$(_pageId+" #pass4").val("");
			}
		}
	}
	
	/**
	 * 提交交易密码，资金密码 两次单独请求
	 * 第一次提交设置交易密码 若失败 直接返回；若成功则锁定交易密码设置
	 * 第二次提交设置资金密码 若失败 程序停止，交易密码设置锁定；
	 * pwd_type 1:资金密码 2:交易密码
	 */
	function postPassword()
	{
		service.getRSAKey({}, function(data) {
			if( data.error_no==0)	//请求获取rsa公钥成功
			{
				//密码采用rsa加密
				var results = data.results[0];
				var modulus = results.modulus;
				var publicExponent =  results.publicExponent;
				var endecryptUtils = require("endecryptUtils");
				
				var tpassword = endecryptUtils.rsaEncrypt(modulus, publicExponent, $(_pageId+" #pass1").val().trim());  //交易密码
				var fpassword = endecryptUtils.rsaEncrypt(modulus, publicExponent, $(_pageId+" #pass3").val().trim());  //资金密码
				var userid = appUtils.getSStorageInfo("user_id");
				var is_same = $(_pageId+" .mt15 .icon_check:eq(0)").hasClass("checked") ? 1 : 0;  // 判断资金密码和交易密码是否一致
				var tradePasswordParam = {"user_id":userid,"acct_clientid":"","password":tpassword,"pwd_type":"2","is_same":is_same};
				var fundPasswordParam  = {"user_id":userid,"acct_clientid":"","password":fpassword,"pwd_type":"1","is_same":is_same};
				service.setAccountPwd(tradePasswordParam, function(data){
					var errorNo   = data.error_no;
					var errorInfo = data.error_info;
					if(errorNo==0)	//交易密码设置成功，锁定交易密码设置框
					{
						$(_pageId+" #pass1").attr("readonly","readonly"); //锁定密码框
						$(_pageId+" #pass2").attr("readonly","readonly");
						//第二次调用接口，提交资金密码
						service.setAccountPwd(fundPasswordParam, function(data){
							if( data.error_no==0)	//交易密码设置成功，锁定交易密码设置框
							{
								$(_pageId+" #pass3").attr("readonly","readonly");
								$(_pageId+" #pass4").attr("readonly","readonly");
								appUtils.pageInit("account/setPwd","account/thirdDepository",{});
							}
							else
							{
								layerUtils.iLoading(false);
								layerUtils.iAlert(data.error_info);
							}
						},false);
					}
					else
					{
						layerUtils.iLoading(false);
						layerUtils.iAlert(errorInfo);
						return false;
					}
				},false);
			}
			else
			{
				layerUtils.iLoading(false);
				layerUtils.iAlert(data.error_info);
			}
		}, false);
	}
	
	var setPwd = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
	
	// 暴露对外的接口
	module.exports = setPwd;
});