/**
 * 三方存管
 */
define(function(require, exports, module) {
	/* 私有业务模块的全局变量 begin */
	var appUtils = require("appUtils"),
		global = require("gconfig").global,
		platform = require("gconfig").platform,
		service = require("serviceImp").getInstance(), // 业务层接口，请求数据
		layerUtils = require("layerUtils"),
		utils = require("utils"),
		utilsHN2 = require("utilsHN2"),
		validatorUtil = require("validatorUtil"),
		zzispwd = 1, // zzispwd	密码方式，1 需要，0 不需要
		iscard = 1, // iscard	是否需要银行卡，1 需要，0 不需要
		zzbindtype = 1, // zzbindtype	判断一步二步式，1 一步，2二步
		Map = require("map"),
		fristMap = null,  //  存放所有相关协议
		countProtocol = 0, // 计算签署成功的数量
		protocolArray = new Array(),  // 存放协议签名值
		userId = appUtils.getSStorageInfo("user_id"),
		cert_type = appUtils.getSStorageInfo("openChannel") == "new" ? "zd" : "tw", // tw:天威 zd:中登
		_pageId = "#account_thirdDepository";
	var banktype_qd = "";
	var external = require("external");

	/* 私有业务模块的全局变量 end */
	function init() {
		initParams();//初始化部分该页面全局变量
		if(appUtils.getSStorageInfo("flag")  == "1"){   //1:需要证书   0:不需要证书
			initPage();  // 初始化页面并检测证书是否存在
		}else{
			banktype_qd = appUtils.getSStorageInfo("bank"); // 渠道业务默认部门号
			getBankList(); //加载银行列表
		}
	}

	//初始化部分该页面全局变量
	function initParams(){
		zzispwd = 1;  // zzispwd	密码方式，1 需要，0 不需要
		iscard = 1; // iscard	是否需要银行卡，1 需要，0 不需要
		zzbindtype = 1; // zzbindtype	判断一步二步式，1 一步，2二步
		cert_type = appUtils.getSStorageInfo("openChannel") == "new" ? "zd" : "tw"; // tw:天威 zd:中登
		Map = require("map");
		fristMap = new Map();  //  存放所有相关协议
		countProtocol = 0; // 计算签署成功的数量
		protocolArray = new Array();  // 存放协议签名值
		userId = appUtils.getSStorageInfo("user_id");
	}

	/* 初始化页面 */
	function initPage()
	{
		layerUtils.iLoading(true);  // 开启等待层。。。
		// 本页面需要用到证书，如果进入本页面时，证书不存在就下载并安装证书
		var existsParam = {
			"userId" : appUtils.getSStorageInfo("user_id"),
			"mediaId" : "certificate",
			"type" : cert_type,
			"funcNo": "60000"
		};
		var result = external.callMessage(existsParam);
		var error_no = result.error_no;
		var error_info = result.error_info;
		var result = result.results[0];
		if (error_no == "0" && result.mediaId == "") {
			utils.installCertificate(getBankList);  // 下载安装证书，并且显示证券账户和协议
		} else {
			// 关闭等待层。。。
			layerUtils.iLoading(false);
			banktype_qd = appUtils.getSStorageInfo("bank"); // 渠道业务默认部门号
			getBankList(); //加载银行列表
		}
	}

	/**关闭密码键盘*/
	function closeKeyboard(){
		console.log("关闭键盘");
		// 关闭密码键盘
		var param = {
			"funcNo":"50211",
			"moduleName":"open"
		};
		external.callMessage(param);
	}

	/**打开密码键盘*/
	function OpenKeyBoard(pageIdNow,obj){
		var param = {
			"funcNo":"50210",
			"moduleName":"open",
			"pageId":pageIdNow,
			"eleId":obj.attr("id"),
			"doneLable":"完成",
			"keyboardType":"4"
		};
		external.callMessage(param);
		console.log("打开键盘");
	}

	function bindPageEvent() {
		// 关闭按钮
		appUtils.bindEvent($(_pageId + " .icon_close"), function() {
			utilsHN2.closeModule("open");
		});

		/* 点击页面隐藏键盘 */
		appUtils.bindEvent($(_pageId), function(e) {
			$(_pageId + " #bankListPage").slideUp("fast"); // 隐藏银行卡列表
			closeKeyboard();//关闭密码键盘
			e.stopPropagation(); // 阻止冒泡
		});

		/* 签署银行相关协议  */
		appUtils.bindEvent($(_pageId + " .rule_check a"), function() {
			$(this).toggleClass("checked");
		});

		/* 选择银行绑定下拉框按钮事件  */
		appUtils.bindEvent($(_pageId + " #selectBank"), function(e) {
			closeKeyboard();//关闭密码键盘
			if (banktype_qd !== "undefined" && banktype_qd != null && banktype_qd !== "") {
				return false;
			}
			$(_pageId + " #bankListPage ul li").removeClass("active");
			$(_pageId + " #bankListPage").slideDown("fast"); // 显示银行下拉列表
			e.stopPropagation(); // 阻止冒泡
		});

		/* 选择银行卡绑定选择某银行事件 */
		appUtils.bindEvent($(_pageId + " #bankcard"), function(e) {
			validateSelectBank(); // 验证是否选择银行卡
			closeKeyboard();//关闭密码键盘
			e.stopPropagation(); // 阻止冒泡
		});

		/* 银行卡号输入控制（每四位分隔） */
		appUtils.bindEvent($(_pageId + " #bankcard"), function() {
			utils.dealIPhoneMaxLength(this, 21); // 处理iphone兼容
			utils.showBigNo(this, 2); // 调用放大镜插件
		}, "input");

		//密码框取得焦点
		appUtils.bindEvent($(_pageId + " #bankcardPwd"), function() {
			$(this).addClass("input_focus");
			//validateBankCorrect();
		}, "focus");


		/* 密码框绑定失去焦点事件 */
		appUtils.bindEvent($(_pageId + " #bankcardPwd"), function() {
			$(this).removeClass("input_focus");
		}, "blur");


		/* 银行密码输入框 */
//		appUtils.bindEvent($(_pageId + " #bankcardPwd"), function(e) {
//			validateSelectBank(); // 验证是否选择银行卡
//			e.stopPropagation(); // 阻止冒泡
//		});

		/* 银行密码输入框 */
		appUtils.bindEvent($(_pageId + " #bankcardPwd"), function(e) {
			if (!validateSelectBank()) { // 验证是否选择银行卡
				return false;
			}
			var hg = $(window).height() + 100;
			$(_pageId).css("height", hg + "px");
			OpenKeyBoard("account_thirdDepository",$(this));//打开键盘
			e.stopPropagation(); // 阻止冒泡
		});

		/* 开通三方存管按钮绑定事件 */
		appUtils.bindEvent($(_pageId + " .ct_btn"), function() {
			signProtocol(); // 提交验签，并且提交三方存管信息
		});

		window.onhashchange = function () {
			$(".xubox_layer").hide();
		}
	}

	function destroy() {
		$(_pageId + " input").val(""); // 把所有的input置空
		service.destroy();
		$(_pageId).remove();
	}

	/* 获取存管银行列表 */
	function getBankList() {
		var queryParam = {
			"bindtype": "",
			"ispwd": ""
		};
		service.queryBankList(queryParam, function(data) {
			var errorNo = data.error_no;
			var errorInfo = data.error_info;
			$(_pageId + " .sel_list ul").html(""); // 清除页面的银行列表
			if (errorNo == 0 && data.results.length != 0) {
				var results = data.results;
				var length = results.length;
				var itemElement = "";
				var selectBankInfo = ""; //session值中之后银行代码，没有银行名称，待会儿for中获取名称
				for (var i = 0; i < length; i++) {
					var item = results[i],
						bankcode = item.bankcode, // 银行代码
						bankname = item.bankname, // 银行名称
						zzbindtype = item.zzbindtype, // 绑定方式：1 一步式 2 预指定 3 同时支持两种方式
						sortnum = item.sortnum, // 排序
						smallimg = item.smallimg, // 图标
						isbuffet = item.isbuffet, // 是否支持自助
						sign_info = item.sign_info, // 提示信息简介
						brief = item.brief, // 银行简介
					zzispwd = item.zzispwd, // 密码方式：1 需要 0 不需要
					iscard = item.iscard; // 卡号方式：1 需要 0 不需要
					itemElement += "<li><span bankname='" + bankname + "' id='" + bankcode + "' " + "zzispwd=\"" + zzispwd + "\"" +
						"iscard=\"" + iscard + "\"  zzbindtype=\"" + zzbindtype + "\" sign-info=\"" + sign_info + "\">" + bankname + "</span></li>";
					//记录银行信息
					if (appUtils.getSStorageInfo("selectBankCode") && appUtils.getSStorageInfo("selectBankCode") == bankcode) {
						selectBankInfo = item;
					}
				}
				$(_pageId + " .sel_list ul").html(itemElement);

				var isBindBank = false;//是否存在指定银行，或者渠道银行
				for(var i =0; i<length; i++){
					var item = results[i];
					var bankcode = item.bankcode;  // 银行代码
					var bankname = item.bankname;  // 银行名称
					var sign_info = item.sign_info; // 提示信息简介
					//判断是否存在指定银行   渠道银行优先级高，故排在后面
					if(global.depositoryBank){//全局存管银行
						if(bankcode == global.depositoryBank){
							isBindBank = true;
							zzbindtype = item.zzbindtype; // 绑定方式：1 一步式 2 预指定 3 同时支持两种方式
							zzispwd = item.zzispwd; // 密码方式：1 需要 0 不需要
							iscard = item.iscard; // 卡号方式：1 需要 0 不需要
							$(_pageId+" .protocolshow").show();
							addBankItem(bankname, bankcode, zzbindtype, sign_info,iscard,zzispwd);
						}
					}
					//判断是否存在渠道银行
					if (banktype_qd == bankcode) {
						isBindBank = true;
						//给全局变量赋值，其他地方用的到
						zzbindtype = item.zzbindtype; // 绑定方式：1 一步式 2 预指定 3 同时支持两种方式
						zzispwd = item.zzispwd; // 密码方式：1 需要 0 不需要
						iscard = item.iscard; // 卡号方式：1 需要 0 不需要
						addBankItem(bankname, bankcode, zzbindtype, sign_info,iscard,zzispwd);
						$(_pageId + " .protocolshow").show();
					}
				}
				if(isBindBank){//如果存在指定银行
					$(_pageId + " #selectBank").unbind();//去除点击事件
				}

				//添加查看协议详细的时候的返回处理 start by 2016-2-18 12:02:54
				if(selectBankInfo){
					ShowforBack(selectBankInfo);
				}
				//end  by 2016-2-18 12:03:02

				// 选择银行添加银行事件
				appUtils.bindEvent($(_pageId + " #bankListPage ul li span"), function(e) {
					$(_pageId + " #bankListPage ul li").removeClass("active");
					$(this).parent().addClass("active");
					$(_pageId + " .protocolshow").show();
					var banckName = $(this).attr("bankname"),
						id = $(this).attr("id"),
						signInfo = $(this).attr("sign-info"); // 提示信息
					zzbindtype = $(this).attr("zzbindtype"); // 绑定方式
					zzispwd = $(this).attr("zzispwd"); // 密码方式
					iscard = $(this).attr("iscard"); // 是否需要银行卡号
					addBankItem(banckName,id,zzbindtype,signInfo,iscard,zzispwd);
					e.stopPropagation();
				});
			} else {
				layerUtils.iAlert(errorInfo, -1);
			}
		}, true, true, handleTimeout);
	}

	/**
	*从查看协议返回时的处理
	*/
	function ShowforBack(selectBankInfo){
		if(selectBankInfo){
			var banckName = selectBankInfo.bankname;
			var id = selectBankInfo.bankcode;
			var signInfo = selectBankInfo.sign_info;
			zzbindtype = selectBankInfo.zzbindtype;
			zzispwd = selectBankInfo.zzispwd;
            iscard = selectBankInfo.iscard;
			addBankItem(banckName, id, zzbindtype, signInfo, iscard, zzispwd);
			if (id) {
				$(_pageId + " .protocolshow").show(); //显示协议
			} else {
				$(_pageId + " .protocolshow").hide(); //隐藏协议
			}
		}
		//上述代码会让卡号密码设置为空
		if ((appUtils.getSStorageInfo("_prePageCode") == "account/showProtocol") || (appUtils.getSStorageInfo("_prePageCode") == "account/thirdDepository")) {
			showBankForBack();//回显
		}
	}

	/**显示根据回显*/
	function showBankForBack(){
		var bankNum = appUtils.getSStorageInfo("bankNum");
		var bankPwd = appUtils.getSStorageInfo("bankPwd", true);
		console.log(bankNum + "~~~~~~~~~~~~" + bankPwd);
		$(_pageId + " #bankcard").val(bankNum);
		$(_pageId + " #bankcardPwd").val(bankPwd);
	}

	/* 处理请求超时 */
	function handleTimeout() {
		layerUtils.iConfirm("请求超时，是否重新加载？", function() {
			getBankList(); // 再次获取银行列表
		});
	}

	/* 为选择银行列表添加选中银行数据 */
	function addBankItem(banckName, id, zzbindtype, signInfo,iscard,zzispwd) {
		// 显示银行的签约信息
		if (signInfo != "" && signInfo != "undefined" && signInfo != undefined) {
			$(_pageId + " #signInfo").html("温馨提示: " + signInfo);
		} else {
			$(_pageId + " #signInfo").html("");
		}
		$(_pageId + " #bankcard").val(""); // 清空银行卡号值
		$(_pageId + " #bankcardPwd").val(""); // 清空银行卡密码
		$(_pageId + " #selectBank").html(banckName); // 赋值银行卡名称
		$(_pageId + " #selectBank").attr("bankcode", id);
		$(_pageId + " #selectBank").attr("zzbindtype", zzbindtype);
		getDepositoryAgreement(id); // 获取银行协议内容
		if (zzbindtype == 1 || zzbindtype == 4) // 判断一步式
		{
			if (zzispwd == 0) // 不需要输入密码
			{
				$(_pageId + " #bankcardPwd").parent().hide(); // 隐藏银行密码输入框
			} else // 需要输入密码
			{
				$(_pageId + " #bankcardPwd").parent().show(); // 显示银行密码输入框
			}
			$(_pageId + " .user_form .input_form:eq(1)").show(); // 显示银行卡、密码输入框
			$(_pageId + " #bindInfo").hide(); // 隐藏预指定提示信息
		}
		if (zzbindtype == 2) // 判断预指定(二步式)
		{
			if (iscard == 1) // 需要银行卡
			{
				$(_pageId + " .user_form .input_form:eq(1)").show(); // 显示银行卡
				$(_pageId + " .user_form .input_form:eq(1) .input_text:eq(1)").hide(); // 隐藏密码
			} else // 不需要银行卡
			{
				$(_pageId + " .user_form .input_form:eq(1)").hide(); // 隐藏银行卡、密码输入框
			}
			$(_pageId + " #bindInfo").show(); // 显示预指定提示信息
		}
		$(_pageId + " #bankListPage").slideUp("fast"); // 隐藏银行下拉列表
		changeTipsForConfirm(id);//改变确认提示
	}

	/**
	*改变确认提示
	*/
	function changeTipsForConfirm(id){
		if(id=="5400"){//如果是交通银行
			$(_pageId +" .icon_check").html("我已知晓并同意签署《存管协议书》及《确认函》。");
		}else{
			$(_pageId +" .icon_check").html("我已知晓并同意上述协议");
		}
	}

	/* 签署协议 */
	function signProtocol() {
		if (!validateSelectBank()) // 验证是否选择银行
		{
			return false;
		}
		if ((iscard == 1 || iscard == "") && !validateBankCorrect()) // 验证银行卡号
		{
			return false;
		}
		if (zzispwd == 1) // 验证是否需要密码
		{
			if (!validateBankPwd()) {
				return false;
			}
		}
		if (!validateDepositProtocolSelect()) // 验证是否勾选协议
		{
			return false;
		}
		beginGetSign(); //开始获取协议签署
	}

	/**开始获取协议签署*/
	function beginGetSign(){
		var keys = fristMap.keys();  // 协议的数量
		layerUtils.iLoading(true);  // 开启等待层。。。
		var oneData = fristMap.get(keys[countProtocol]); // 取出一个协议
		if(appUtils.getSStorageInfo("flag")  == "1"){   //1:需要证书   0:不需要证书
			needCertSign(oneData,keys);//需要证书签名
		}else{
			unNeedCertSign(oneData,keys);//不需要证书签名，需要留痕
		}
	}

	/**需要证书签名*/
	function needCertSign(oneData,keys){
		var protocolid = oneData.get("protocolid"); // 协议ID
		var protocolname = oneData.get("protocolname");  //协议名称
		var summary = oneData.get("summary");  // 协议内容MD5,签名摘要信息
		var signParam = {
			"mediaId":protocolid,
			"content":summary,
			"userId":userId,
			"type": cert_type,
			"funcNo": "60001"
		};
		// 获取协议的数字签名值
		var result = external.callMessage(signParam);
		var error_no = result.error_no;
		var error_info = result.error_info;
		var result = result.results[0];
		if(error_no == "0") {
			var protocoldcsign = result.cipherText;
			// 添加值到数组中
			var protocol = {
				"protocol_id" : protocolid,
				"protocol_dcsign" : protocoldcsign,
				"summary" : summary
			};
			protocolArray.push(protocol);
			countProtocol++;
			if(countProtocol < keys.length)  // 通过比较，获取每个协议的签名值
			{
				beginGetSign();
			}
			else  // 获取完每个签名值后 进行验签
			{
				startSign();
			}
		} else {
			layerUtils.iLoading(false);  // 关闭等待层
			countProtocol = 0;  // 将签署协议的计数器置为 0
			layerUtils.iAlert(error_info);
		}
	}

	/**不需要证书签名，需要留痕*/
	function unNeedCertSign(oneData,keys){
		var protocolid = oneData.get("protocolid"); // 协议ID
		var protocolname = oneData.get("protocolname");  //协议名称
		var summary = oneData.get("summary");  // 协议内容MD5,签名摘要信息
		// 添加值到数组中
		var protocol = {
			"protocol_id" : protocolid,
			"protocol_dcsign" : "",
			"summary" : summary
		};
		protocolArray.push(protocol);
		countProtocol++;
		if(countProtocol < keys.length)  // 通过比较，获取每个协议的签名值
		{
			beginGetSign();
		}
		else  // 获取完每个签名值后 进行验签
		{
			startSign();
		}
	}

	/**开始验签*/
	function startSign(){
		// 签署协议
		var signProtocolParam = {
			"user_id" : appUtils.getSStorageInfo("user_id"),
			"jsondata" : JSON.stringify(protocolArray),
			"ipaddr" : appUtils.getSStorageInfo("ip"),
			"macaddr" : appUtils.getSStorageInfo("mac"),
			"checksign":appUtils.getSStorageInfo("flag")=="1"?"1":"0"
		};
		// 新开中登验签
		if(appUtils.getSStorageInfo("openChannel") == "new")
		{
			service.queryOpenCheckSign(signProtocolParam,postThirdDepositoryData,false);
		}
		// 转户天威验签
		else if(appUtils.getSStorageInfo("openChannel") == "change")
		{
			service.queryOpenCheckTsign(signProtocolParam,postThirdDepositoryData,false);
		}
	}

	/* 提交三方存管银行数据 */
	function postThirdDepositoryData() {
		service.getRSAKey({}, function(data) {
			if (data.error_no == 0) //请求获取rsa公钥成功
			{
				//密码采用rsa加密
				var results = data.results[0];
				var modulus = results.modulus;
				var publicExponent = results.publicExponent;
				var endecryptUtils = require("endecryptUtils");

				var bankpwd = endecryptUtils.rsaEncrypt(modulus, publicExponent, $(_pageId + " #bankcardPwd").val().trim());
				var userid = appUtils.getSStorageInfo("user_id");
				var bankcode = $(_pageId + " #selectBank").attr("bankcode");
				var bankaccount = $(_pageId + " #bankcard").val();
				var thirdDepositParam = {
					"user_id": userid,
					"acct_clientid": "",
					"acct_fndacct": "",
					"bank_code": bankcode,
					"bank_account": bankaccount,
					"bank_pwd": bankpwd,
					"op_type": $(_pageId + " #selectBank").attr("zzbindtype")
				};
				// 调用service绑定存管银行
				service.bindBank(thirdDepositParam, function(data) {
					var errorNo = data.error_no;
					var errorInfo = data.error_info;
					if (errorNo == 0) // 调用成功,跳转到风险测评页面
					{
						//start by 2014-12-10  //跳转到风险测评页面时，保留银行卡号到session

						/*appUtils.setSStorageInfo("bankPwd",$(_pageId+" #bankcardPwd").val().trim(),true);
						appUtils.setSStorageInfo("bankNum",$(_pageId+" #bankcard").val());*/
//						appUtils.setSStorageInfo("zzispwd", zzispwd);
//						appUtils.setSStorageInfo("iscard", iscard);
//						appUtils.setSStorageInfo("zzbindtype", zzbindtype);
						//end   by 2014-12-10

						//cleanPageElement();
						appUtils.pageInit("account/thirdDepository", "account/riskAssessment", {});
					} else {
						layerUtils.iLoading(false);
						layerUtils.iAlert(errorInfo, -1);
					}
				}, false);
			} else {
				layerUtils.iLoading(false);
				layerUtils.iAlert(data.error_info);
			}
		}, false);
	}

	/* 验证是否选择银行  */
	function validateSelectBank() {
		var obj = $(_pageId + " #selectBank");
		var value = obj.html();
		if (validatorUtil.isEmpty(value) || value == "请选择银行") {
			$("#bankcard").blur().val("");
            $("#bankcardPwd").blur().val("");
			layerUtils.iMsg(-1, "请选择银行");
			return false;
		}
		return true;
	}

	/* 检验银行卡填写是否正确 */
	function validateBankCorrect() {
		var bankcard = $(_pageId + " #bankcard").val();
		var bankcode = $(_pageId+" #selectBank").attr("bankcode");
		if (bankcard != null) {
			if (bankcard == "") // 验证通过的情况
			{
				// start 2015-1-7
				if (zzbindtype == 1) {
					return true;
				} else {
					layerUtils.iMsg(-1, "银行卡号不能为空！");
					return false;
				}
				// end 2015-1-7
			}
			if (!validatorUtil.isBankCode(bankcard)) {
				layerUtils.iMsg(-1, "银行卡号格式有误，请重新输入！");
				return false;
			}
			if (zzbindtype == 1) {
				if(bankcode=="5400"){//如果是交通银行
					QRHchuli();
					return false;
				}
			}
			return true;
		} else {
			layerUtils.iMsg(-1, "银行卡号不能为空！");
			return false;
		}
	}

	/**交通银行确认函*/
	function QRHchuli(){
		if(!validateDepositProtocolSelect())  // 验证是否勾选协议
		{
			return false;
		}
		getTripartiteAgreement("jtqrh"); // 获取三方确认函协议
	}

	/**获取三方确认函协议*/
	function getTripartiteAgreement(qrh){
		// 调用service查询存管银行确认函协议
		var param = {"category_englishname" : qrh};
		service.queryProtocolList(param,function(data){
			if(data.error_no == 0)
			{
				if(data.results&&data.results.length>=1)
				{
					var protocol = data.results[0];
					var protocolMap = new Map();
					protocolMap.put("protocolid",protocol.econtract_no);	//协议id
					protocolMap.put("protocolname",protocol.econtract_name);	//协议名
					protocolMap.put("summary",protocol.econtract_md5);	//协议内容MD5,签名摘要信息
					fristMap.put(1,protocolMap);

					console.log("获取确认函：" + JSON.stringify(data));
					var qrha = '<a href="javascript:void(0)" id="protocolQRHName" protocolId="'+protocol.econtract_no+'" protocolname="'+protocol.econtract_name+'" protocolMd5="'+protocol.protocolMd5+'">《' +
						protocol.econtract_name+'》</a>';
					$(_pageId+" .l_link.protocolshow").append(qrha);
					// 预绑定查看银行协议内容的事件
					appUtils.preBindEvent($(_pageId+" #protocolQRHName").parent(),"#protocolQRHName",function(){
						appUtils.setSStorageInfo("bankPwd",$(_pageId+" #bankcardPwd").val().trim(),true);
						appUtils.setSStorageInfo("bankNum",$(_pageId+" #bankcard").val());
						appUtils.setSStorageInfo("selectBankCode", "5400");
						//start 2015-1-7
//						appUtils.setSStorageInfo("zzispwd",zzispwd);
//						appUtils.setSStorageInfo("iscard",iscard);
//						appUtils.setSStorageInfo("zzbindtype",zzbindtype);
						//end 2015-1-7
						appUtils.pageInit("account/thirdDepository","account/showProtocol",{"protocol_id":$(_pageId+" #protocolQRHName").attr("protocolId")});
					});
					getProtocolInfo(protocol.econtract_no);//查询确认函协议
					//确认函
//					layerUtils.iAlert("亲！交通银行卡需要签署交通银行确认函，确定即同意签署！",0,function(){
//						beginGetSign();//开始签署协议
//					});
				}
			}
			else
			{
				layerUtils.iLoading(false);  // 关闭等待层。。。
				layerUtils.iAlert(data.error_info,-1);
			}
		},false);
	}

	/**查看协议内容*/
	function getProtocolInfo(protocol_id){
		var param = {
			"econtract_no" : protocol_id,
			"econtract_version":""
		}
		//查询协议内容
		service.getProtocolInfo(param,function(data){
			if(error_no = data.error_no)
			{
				var econtract_name = data.results[0].econtract_name;
				econtract_name = econtract_name?econtract_name:"";
				var viewContent = '<div class="top_title">'+
										'<p>'+econtract_name+'</p>'+
									'</div>'+
									'<div class="user_form">'+
										'<p id="contenttxt">'+data.results[0].econtract_content+'</p>'+
									'</div>';
				var config = {
//					'width': , //弹出层宽度
//                   	'height': , // 弹出层高度
//                    'offsetX': , //x起始坐标，一般不用传，居中显示
					'offsetY':"50%" //y起始坐标，不传默认y轴起始坐标在屏幕的30%，不是全屏显示的话一般不用传
				};
				var tapFunc = function(){
					beginGetSign();//开始签署协议
				};
				utils.layerContent(viewContent,config,"确认签署",tapFunc);
			}
			else
			{
				layerUtils.iMsg(-1, data.error_info);
			}
		});
	}

	/* 验证银行密码 */
	function validateBankPwd() {
		//验证不通过
		var cardPwd = $(_pageId + " #bankcardPwd").val();
		if (zzbindtype != 1) {
			if (!validatorUtil.isNumeric(cardPwd) || cardPwd.length != 6) {
				layerUtils.iMsg(-1, "银行卡密码有误，请重新输入！");
				return false;
			}
		}
		return true;
	}

	/* 检测勾选阅读协议 */
	function validateDepositProtocolSelect() {
		if (!$(_pageId + " .icon_check").hasClass("checked")) {
			layerUtils.iMsg(-1, "请阅读并勾选三方存管协议!");
			return false;
		}
		return true;
	}

	/* 获取存管银行签约电子协议列表 */
	function getDepositoryAgreement(bankcode) {
		$(_pageId + " #protocolName").html(""); // 清空协议
		// 调用service查询存管银行协议
		var param = {
			"econtract_no": bankcode
		};
		service.queryProtocolList(param, function(data) {
			$(_pageId + " #protocolName").html("");
			if (data.error_no == 0) {
				if (data.results && data.results.length >= 1) {
					var protocol = data.results[0];
					var protocolMap = new Map();
					protocolMap.put("protocolid",protocol.econtract_no);	//协议id
					protocolMap.put("protocolname",protocol.econtract_name);	//协议名
					protocolMap.put("summary",protocol.econtract_md5);	//协议内容MD5,签名摘要信息
					fristMap.put(0,protocolMap);

					$(_pageId + " #protocolName").html("《" + protocol.econtract_name + "》");
					$(_pageId + " #protocolName").attr("protocolId", protocol.econtract_no);
					$(_pageId + " #protocolName").attr("protocolMd5", protocol.econtract_md5);
					// 预绑定查看银行协议内容的事件
					appUtils.preBindEvent($(_pageId + " #protocolName").parent(), "#protocolName", function() {
						appUtils.setSStorageInfo("bankPwd", $(_pageId + " #bankcardPwd").val().trim(), true);
						appUtils.setSStorageInfo("bankNum", $(_pageId + " #bankcard").val());
						appUtils.setSStorageInfo("selectBankCode", $(this).attr("protocolId"));
						//start 2015-1-7

//						appUtils.setSStorageInfo("zzispwd", zzispwd);
//						appUtils.setSStorageInfo("iscard", iscard);
//						appUtils.setSStorageInfo("zzbindtype", zzbindtype);

						//end 2015-1-7

						appUtils.pageInit("account/thirdDepository", "account/showProtocol", {
							"protocol_id": $(_pageId + " #protocolName").attr("protocolId")
						});
					});
				}
			} else {
				layerUtils.iAlert(data.error_info, -1);
			}
		});
	}

	/* 清理界面元素 */
	function cleanPageElement() {
		$(_pageId + " .rule_check a").removeClass("checked"); // 取消勾选协议
		$(_pageId + " #selectBank").text("请选择银行"); // 清理银行卡的名字
		$(_pageId + " #bankcard").val(""); // 清理银行卡号
		$(_pageId + " #bankcardPwd").val(""); // 清理密码
		$(_pageId + " #protocolName").text("《券商银行投资者三方协议》"); // 清理协议名
		$(_pageId + " #signInfo").html(""); // 清除银行签约信息
	}

	var thirdDepository = {
		"init": init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};

	// 暴露对外的接口
	module.exports = thirdDepository;
});