/**
 * 视频见证注意事项
 */
define(function(require,exports,module){ 
	/* 私有业务模块的全局变量 begin */
	var appUtils = require("appUtils"),
	      service = require("serviceImp").getInstance(),  //业务层接口，请求数据
		  gconfig = require("gconfig"),
		  global = gconfig.global,
		  layerUtils = require("layerUtils"),
		  utilsHN2 = require("utilsHN2"),
		  needVideo = "",
		  _pageId = "#account_videoNotice";
	var external = require("external");
	var netWorkStatus = "NONE";
	var platform = gconfig.platform;
	// 填写资料的页面入参
    var fillInformationInParam = {
		"idno": "", // 身份证号
		"custname": "", // 客户姓名
		"ethnicname": "", // 民族
		"native": "", // 证件地址
		"policeorg": "", // 签发机关
		"birthday": "", // 出生日期
		"idbegindate": "", // 证件开始日期
		"idenddate": "", // 证件结束日期
		"gender": "", // 用户性别
		"imgPath": "", // 图片的显示地址
		"imgId": "", // 图片 id
		"branchno": "", //营业部Id
		"commission": "", //佣金套餐
		"postid": "" //邮编
	};
	/* 私有业务模块的全局变量 end */
	
	function init()
	{
		initPage(); // 初始化页面
        getVedioport(); // 获取营业部视频端口
	}
	
	function bindPageEvent()
	{
		// 关闭按钮
		appUtils.bindEvent($(_pageId + " .icon_close"), function() {
			utilsHN2.closeModule("open");
		});

		/* 绑定返回 */
		appUtils.bindEvent($(_pageId+" .header .icon_back"),function(){
			pageBack();
		});
		
		/* 重新上传照片 */
		appUtils.bindEvent($(_pageId+" .photo_again"),function(){
			var param = {
				user_id : appUtils.getSStorageInfo("user_id"),
				lastcomplete_step : "0", 
				opacctkind_flag : ""  
			};
			service.queryChangeState(param,function(data){
				var error_no = data.error_no;
				var error_info = data.error_info;
				if(error_no == 0)
				{
					appUtils.setSStorageInfo("idInfo","exist");
					appUtils.pageInit("account/videoNotice","account/uploadPhoto",{});
				}
				else
				{
					layerUtils.iLoading(false);
					layerUtils.iMsg(-1,error_info); 
				}
			});
		});
		
		/* 重新提交资料 */
		appUtils.bindEvent($(_pageId+" .info_again"),function(){
			var Flag = false;
			var currentStep = appUtils.getSStorageInfo("currentStep");
			if(currentStep == "uploadimg" || currentStep == null)
			{
				Flag = true;
			}
			else
			{
				Flag = false;
			}
			var param = {
				user_id : appUtils.getSStorageInfo("user_id"),
				lastcomplete_step : "uploadimg", 
				opacctkind_flag : ""  
			};
			service.queryChangeState(param,function(data){
				var error_no = data.error_no;
				var error_info = data.error_info;
				if(error_no == 0)
				{
					pageBack();
				}
				else
				{
					layerUtils.iLoading(false);
					layerUtils.iMsg(-1,error_info); 
				}
			}, Flag);
		});
		
		/* 申请QQ预约 */
		appUtils.bindEvent($(_pageId+" .c_link"),function(){
			appUtils.pageInit("account/videoNotice","account/orderQq",{});
		});
		
		/* 在线视频视频见证 */
		appUtils.bindEvent($(_pageId+" .ct_btn:eq(0)"),function(){
			var param = {
				"funcNo": "50030"
			};
			var result = external.callMessage(param);
			var netWorkStatus = "";
			network = result.results[0].network;
			if (network == "0") {
				netWorkStatus = "断网";
			} else if (network == "1") {
				netWorkStatus = "2G";
			} else if (network == "2") {
				netWorkStatus = "3G";
			} else if (network == "3") {
				netWorkStatus = "4G";
			} else if (network == "4") {
				netWorkStatus = "WIFI";
			} else if (network == "9") {
				netWorkStatus = "未定义";
			}
			// 如果网络是2G，给出提示
			if (netWorkStatus == "2G" || netWorkStatus == "未定义") {
				layerUtils.iAlert("你当前使用的网络网速较慢，请在3G,4G或者wifi等网路状态下进行视频见证", -1, function() {
					anychatVideoApply();
				});
			} else {
				//申请anychat视频见证
				anychatVideoApply();
			}
		});
	}
		
	/* 继续开户 */
	appUtils.bindEvent($(_pageId+" .ct_btn:eq(1)"),function(){
		queryQQOfflineState();  // 查询视频通过状态
	});
	
	//调用anychat视频见证
	function anychatVideoApply() {
		//判断URL是否为空
		var param = {
			"url": global.serverPath + ";jsessionid=" + appUtils.getSStorageInfo("jsessionid"),
			"userId": appUtils.getSStorageInfo("user_id"),
			"userName": appUtils.getSStorageInfo("custname"),
			"orgId": appUtils.getSStorageInfo("branchno"),
			"userType": "1",
			"jsessionId": appUtils.getSStorageInfo("jsessionid"),
			"netWorkStatus": netWorkStatus,
			"funcNo": "60005",
			"moduleName": "open"
		};
		external.callMessage(param);
	}
	
	function destroy()
	{
		// 页面初始化样式重置
		$(_pageId+" .header h3:eq(0)").show();
		$(_pageId+" .header h3:eq(1)").hide();
		$(_pageId+" .error_notice:eq(0)").hide();
		$(_pageId+" .error_notice:eq(1)").hide();
		$(_pageId+" .camera_notice:eq(0)").show();
		$(_pageId+" .camera_notice:eq(1)").hide();
		$(_pageId+" .photo_again").hide();
		$(_pageId+" .info_again").hide();
		$(_pageId+" .c_link").show();
		$(_pageId+" .fix_bot").show();
		$(_pageId+" .fix_bot .ct_btn:eq(0)").show();
		$(_pageId+" .fix_bot .ct_btn:eq(1)").hide();
		service.destroy();
	}
	
	/* 处理返回按钮 */
	function pageBack()
	{
		var currentStep = appUtils.getSStorageInfo("currentStep");
		// 从短信登陆进入(当前完成步骤为：已提交资料)，处理返回按钮
		if(currentStep == "idconfirm")
		{
			appUtils.setSStorageInfo("currentStep","uploadimg");
			appUtils.setSStorageInfo("personInfo","exist");  // 标记完成资料填写步骤
			//start 2015-03-09 hwh
			appUtils.pageInit("account/videoNotice","account/personInfoVerify",{});   
			//end 2015-03-09 
		}
		// 从短信登陆进入，在personInfo提交资料后，处理返回按钮
		else if(appUtils.getSStorageInfo("currentStep") == "uploadimg")
		{
			appUtils.setSStorageInfo("personInfo","exist");  // 标记完成资料填写步骤
			appUtils.pageBack();
		}
		// 正常开户流程处理返回按钮
		else
		{
			appUtils.pageBack();
		}
	}
	
	/* 初始化页面 */
	/*function initPage()
	{
		needVideo = appUtils.getPageParam("need_video");  
		if(needVideo == 1)
		{
			$(_pageId+" .main .step_box").hide();
			$(_pageId+" .main .error_notice:eq(0)").show();
		}
	}*/

	/* 初始化页面 */
	function initPage() {
		var videoParam = appUtils.getSStorageInfo("videoParam");
		if (videoParam != "" && videoParam != undefined && videoParam != null) {
			needVideo = videoParam.need_video;
		}
		if (needVideo == 1) {
			$(_pageId + " .main .step_box").hide();
			$(_pageId + " .main .error_notice:eq(0)").show();
		}
	}
	
	/* 获取营业部视频端口 */
	function getVedioport()
	{
		if(appUtils.getSStorageInfo("_prePageCode") == "account/msgVerify")
		{
			 queryQQOfflineState();  // 查询视频通过状态
		}else{
			layerUtils.iLoading(false);  //关闭等待层
		}
	}

	/* 查询离线视频通过状态 */
	function queryQQOfflineState()
	{
		var lookVedioStateParam = {
			"user_id" : appUtils.getSStorageInfo("user_id")
		};
		service.queryQQOfflineState(lookVedioStateParam,function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no == 0 && data.results.length != 0)
			{
				// 视频通过状态，0：未见证、2：已预约离线见证未完成见证、1：视频见证完成、3：见证失败
				// 未见证不需要做处理
				var witnessFlag = data.results[0].witness_flag;
				if(witnessFlag == 1)
				{
					turnPage();
				}
				else if(witnessFlag == 2)
				{
					layerUtils.iAlert("您的预约信息已经提交，我们的客服将尽快联系您！",0);
				}
				else if(witnessFlag == 3)
				{
					$(_pageId+" .c_link").show();
					$(_pageId+" .fix_bot .ct_btn:eq(0)").show();
					$(_pageId+" .fix_bot .ct_btn:eq(1)").hide();
					layerUtils.iAlert("视频见证失败，请重新申请见证！");
				}
				else if(witnessFlag == 4)
				{
					layerUtils.iAlert("资料审核中，工作人员会尽快给您回复，请耐心等候！");
				}
			}
			else
			{
				layerUtils.iAlert(data.error_info);
			}
		});
	}

	function turnPage(){
		if (appUtils.getSStorageInfo("flag") == "1") { //1:需要证书   0:不需要证书
			layerUtils.iConfirm("您的视频审核已通过，接下来即将为您安装数字证书...", function() {
				appUtils.pageInit("account/videoNotice", "account/digitalCertificate", {});
			}, function() {
				return false;
			  });
		} else {
			appUtils.pageInit("account/videoNotice", "account/signProtocol", {});
		}
	}
	
	/* 见证通过 */
	function videoSuccess()
	{
		$(_pageId+" .fix_bot .ct_btn:eq(0)").hide();
		$(_pageId+" .fix_bot .ct_btn:eq(1)").show();
		$(_pageId+" .c_link").hide();
		queryQQOfflineState();  // 查询视频通过状态
	}
	
	/* 见证不通过 */
	function videoFail(){}
	
	/* 见证被驳回 */
	function videoReject()
	{
		$(_pageId+" .header h3:eq(0)").hide();
		$(_pageId+" .header h3:eq(1)").show();
		$(_pageId+" .error_notice:eq(0)").hide();
		$(_pageId+" .error_notice:eq(1)").show();
		$(_pageId+" .camera_notice:eq(0)").hide();
		$(_pageId+" .camera_notice:eq(1)").show();
		$(_pageId+" .photo_again").show();
		$(_pageId+" .info_again").show();
		$(_pageId+" .c_link").hide();
		$(_pageId+" .fix_bot").hide();
	}

	/* 见证通过 */
	function videoSuccess() {
		if (needVideo == 1) {
			//调用提交补全资料接口
			var notifyParam = {
				"user_id": appUtils.getSStorageInfo("user_id"),
				"fieldname": "video_one" // 通知图片已补全
			};
			service.rejectStep(notifyParam, function(data) {
				if (data.error_no == 0) {
					appUtils.setSStorageInfo("isBack", "backInfo"); //标志重新提交资料成功
					var accountParam = appUtils.getSStorageInfo("accountParam");
					var pwdParam = appUtils.getSStorageInfo("pwdParam");
					var thirdParam = appUtils.getSStorageInfo("thirdParam");
					accountParam = JSON.parse(accountParam);
					pwdParam = JSON.parse(pwdParam);
					thirdParam = JSON.parse(thirdParam);
					// 需要继续驳回到开股东卡
					if (accountParam.need_account == 1) {
						appUtils.pageInit("account/backUploadPhoto", "account/backSignProtocol", accountParam);
					}
					// 需要驳回资金或交易密码
					else if (pwdParam.needBusinessPwd == 1 || pwdParam.needFundPwd == 1) {
						appUtils.pageInit("account/backUploadPhoto", "account/backSetPwd", pwdParam); //跳转设置密码页面
					}
					// 需要驳回到三方存管
					else if (thirdParam.needThirdDeposit == 1) {
						appUtils.pageInit("account/backUploadPhoto", "account/backThirdDepository", thirdParam); //返回结果页
					} else {
						appUtils.pageInit("account/backUploadPhoto", "account/accountResult", {});
					}
				} else {
					layerUtils.iAlert(data.error_info, -1);
				}
			});
		} else {
			$(_pageId + " .fix_bot .ct_btn:eq(0)").hide();
			$(_pageId + " .fix_bot .ct_btn:eq(1)").show();
			$(_pageId + " .c_link").hide();
			queryQQOfflineState(); // 查询视频通过状态
		}
	}

	/* 见证不通过 */
	function videoFail() {}

	/* 见证被驳回 */
	function videoReject() {
		$(_pageId + " .header h3:eq(0)").hide();
		$(_pageId + " .header h3:eq(1)").show();
		$(_pageId + " .error_notice:eq(0)").hide();
		$(_pageId + " .error_notice:eq(1)").show();
		$(_pageId + " .camera_notice:eq(0)").hide();
		$(_pageId + " .camera_notice:eq(1)").show();
		$(_pageId + " .photo_again").show();
		$(_pageId + " .info_again").show();
		$(_pageId + " .c_link").hide();
		$(_pageId + " .fix_bot").hide();
	}

	//视频见证判断
	function videoFlag(videoFlag) {
		var videoFlag = videoFlag.videoFlag;
		if (videoFlag == "0") {
			videoSuccess(); //视频见证通过
		} else if (videoFlag == "1") {
			//见证失败
		} else if (videoFlag == "2") {
			//见证驳回
			videoReject();
		}
	}

	/* QQ预约 */
	function qqApplay()
	{
		appUtils.pageInit("account/videoNotice","account/orderQq",{});
	}

	var videoNotice = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"pageBack" : pageBack,
		"destroy" : destroy,
		"videoFlag": videoFlag
	};
	
	// 暴露对外的接口
	module.exports = videoNotice;
});