/**
 * 微信姿势工具类
 */
define(function(require,exports,module){
	
	var appUtils = require("appUtils"),
		gconfig = require("gconfig"),
		layerUtils = require("layerUtils");
	/**
	 * 创建播放器
	 * @param introduce_src <string> 音频源
	 * @param next_src <string> 下一段语音
	 */
	function creatAudio(parent_id,introduce_src,next_src){
		var audio,audioelement;
		var bgsound_src = introduce_src;
        if(typeof bgsound_src!="undefined"){
    	   //创建语音audio
            var newElement = document.createElement('div'); 
            newElement.id='soundcontainer'; 
            document.body.appendChild(newElement); 
            var audiocontainer=document.getElementById('soundcontainer');//controls="controls" autoplay="autoplay"
            audiocontainer.innerHTML = '<audio id="bgsound" > <source src="' + bgsound_src + '" /> </audio>'; 
            audio = document.getElementById('bgsound');
            audio.src = bgsound_src;//音频
    		/*触摸页面播放音频*/
    		playSound(parent_id,null);
    		
            //介绍语音介绍，播放姿势语音提示
            audio.addEventListener('ended', function () {  
            	playSound(parent_id,next_src);
            }, false);       
       }
	}
	/**
	 *  播放器
	 *
	 */
	function playVideo(parent_id,video_src,next_src){
		var audio,audioelement;
		if(typeof video_src!="undefined"){
	    	   //创建语音audio
	            var newElement = document.createElement('div'); 
	            newElement.id="soundcontainer"; 
	            document.body.appendChild(newElement); 
	            var audiocontainer=document.getElementById("soundcontainer");//controls="controls" autoplay="autoplay"
	            audiocontainer.innerHTML = '<audio id="bgsound" > <source src="' + video_src + '" /> </audio>'; 
	            audio = document.getElementById('bgsound');
	            audio.src = video_src;//音频源
	            try{
					document.getElementById('bgsound').play();//播放
				}catch(e){
					
				}
	            //介绍语音介绍，播放姿势语音提示
	            audio.addEventListener('ended', function () {  
	            	playSound(parent_id,next_src);
	            }, false);       
	       }
        
	}
	/**
	 * 绑定播放语音
	 * @param soundUrl <string> 播放语音地址
	 */
	function playSound(parent_id,soundUrl){
		var p = navigator.platform , event = "touchstart";       
		if(p.indexOf("Win") == 0 || p.indexOf("Mac") == 0){
			event = "click";
		}
		//绑定触摸时间播放语音 PS：Android 和 IOS 禁止自动播放语音
		appUtils.bindEvent($(parent_id),function(){
			//如果播放的语音不为空就是切换到姿势提示语言
			if(typeof(soundUrl)!=undefined && soundUrl !=null){
				document.getElementById("bgsound").setAttribute("src", soundUrl);
			}
			try{
				document.getElementById('bgsound').play();//播放
			}catch(e){
				
			}

			$(parent_id).unbind(event);//删除绑定的事件
			$(parent_id).remove(event);
			$(parent_id).off(event);
			
		},event);
		
		
	}
	
	function play()
	{
		try{
			document.getElementById('bgsound').play();//播放
		}catch(e){
			
		}
		
	}
	
	function queryPostInfo(num){
		var param ={};
		param.pose_photopath = appUtils.getSStorageInfo("pose_photopath_"+(num));
		param.pose_en = appUtils.getSStorageInfo("pose_en_"+(num));
		param.pose_cn = appUtils.getSStorageInfo("pose_cn_"+(num));
		param.pose_desc = appUtils.getSStorageInfo("pose_desc_"+(num));
		param.pose_voxpath = appUtils.getSStorageInfo("pose_voxpath_"+(num));
		param.pose_desc  = param.pose_desc.replace(/(\S*?)“(\S*?)”(\S*)/,"$1“<span>$2</span>”$3");
		return param;
	}
	
	var postUtil = {
			"creatAudio" : creatAudio,
			"playSound" : playSound,
			"playVideo" : playVideo,
			"queryPostInfo":queryPostInfo,
			"play":play
		};
	module.exports = postUtil;
});