/**
 * 华南二通用工具类，将项目中的公用方法抽出来
 */
define(function(require,exports,module){
	var appUtils = require("appUtils"),
	    validatorUtil = require("validatorUtil"),
		service = require("serviceImp").getInstance(),  //业务层接口，请求数据
		layerUtils = require("layerUtils"),
		gconfig = require("gconfig"),
		global = gconfig.global;
	var external = require("external");

	/**
	 * 自定义确认框
	 * @param layerMsg 确认框的内容
	 * @param oneText 第一个按钮按钮的文本内容
	 * @param twoText 第二个按钮的文本内容
	 * @param funcOne 第一个按钮的回调函数
	 * @param funcTwo 第二个按钮的回调函数
	 */
	function layerTwoButton(layerMsg,oneText,twoText,funcOne,funcTwo){
		var viewContent = '<div class="pop_tip notice" id="utils_confirm"><span class="icon"></span><p>'+layerMsg+'</p><div class="btn"><a href="javascript:void(0);" id="utils_confirm_one">'+oneText+'</a><a href="javascript:void(0);" id="utils_confirm_two">'+twoText+'</a></div></div>';
		var iConfirm = layerUtils.layerCustom(viewContent);
		appUtils.preBindEvent($("#utils_confirm")," #utils_confirm_one",function(){
			if(funcOne)
			{
				funcOne();
			}
			layerUtils.iCustomClose();
		});
		appUtils.preBindEvent($("#utils_confirm")," #utils_confirm_two",function(){
			if(funcTwo)
			{
				funcTwo();
			}
			layerUtils.iCustomClose();
		});
	}

	/**
	 * 通过壳子调用系统日期控件
	 * @param obj dom 对象，一般传 this 即可
	 */
	function selectDate(obj) {
		var currentDateStr = $(obj).val(),
			yearParam = "",
			monthParam = "",
			dayParam = "";
		currentDateStr = currentDateStr.replace(/-/g, "/");
		// 如果是有效的日期串，解析年、月、日
		if (validatorUtil.isDate(currentDateStr)) // 如果是有效的日期串，解析年、月、日
		{
			var tempDate = new Date(currentDateStr);
			yearParam = tempDate.getFullYear() + "";
			// 0~11 的值
			monthParam = (tempDate.getMonth() + 1 + "").length == 1 ? "0" + (tempDate.getMonth() + 1) : (tempDate.getMonth() + 1) + "";
			// 1~31 的值
			dayParam = (tempDate.getDate() + "").length == 1 ? "0" + tempDate.getDate() : tempDate.getDate() + "";
		}else{//处理不是日期字符串的问题
			var tempDate = new Date();
			yearParam = tempDate.getFullYear() + "";
			// 0~11 的值
			monthParam = (tempDate.getMonth() + 1 + "").length == 1 ? "0" + (tempDate.getMonth() + 1) : (tempDate.getMonth() + 1) + "";
			// 1~31 的值
			dayParam = (tempDate.getDate() + "").length == 1 ? "0" + tempDate.getDate() : tempDate.getDate() + "";
		}
		var calendarParam = {
			"selector": $(obj).attr("id"),
			"year": yearParam,
			"month": monthParam,
			"day": dayParam,
			"moduleName":"open",
			"funcNo":"50250"
		};
		if (yearParam == "NaN") // 解析失败
		{
			calendarParam.year = "";
			calendarParam.month = "";
			calendarParam.day = "";
		}
		console.log("调用日期插件："+JSON.stringify(calendarParam));
		external.callMessage(calendarParam);
	}

	/**
	 * 通过壳子调用系统日期控件 (解决兼容手机会弹出键盘的问题)
	 * @param obj dom 对象，一般传 this 即可
	 */
	function selectDateDiv(obj) {
		var currentDateStr = $(obj).text(),
			yearParam = "",
			monthParam = "",
			dayParam = "";
		currentDateStr = currentDateStr.replace(/-/g, "/");
		// 如果是有效的日期串，解析年、月、日
		if (validatorUtil.isDate(currentDateStr)) // 如果是有效的日期串，解析年、月、日
		{
			var tempDate = new Date(currentDateStr);
			yearParam = tempDate.getFullYear() + "";
			// 0~11 的值
			monthParam = (tempDate.getMonth() + 1 + "").length == 1 ? "0" + (tempDate.getMonth() + 1) : (tempDate.getMonth() + 1) + "";
			// 1~31 的值
			dayParam = (tempDate.getDate() + "").length == 1 ? "0" + tempDate.getDate() : tempDate.getDate() + "";
		}else{//处理不是日期字符串的问题
			var tempDate = new Date();
			yearParam = tempDate.getFullYear() + "";
			// 0~11 的值
			monthParam = (tempDate.getMonth() + 1 + "").length == 1 ? "0" + (tempDate.getMonth() + 1) : (tempDate.getMonth() + 1) + "";
			// 1~31 的值
			dayParam = (tempDate.getDate() + "").length == 1 ? "0" + tempDate.getDate() : tempDate.getDate() + "";
		}
		var calendarParam = {
			"selector": $(obj).attr("id"),
			"year": yearParam,
			"month": monthParam,
			"day": dayParam,
			"moduleName":"open",
			"funcNo":"50250"
		};
		if (yearParam == "NaN") // 解析失败
		{
			calendarParam.year = "";
			calendarParam.month = "";
			calendarParam.day = "";
		}
		console.log("调用日期插件："+JSON.stringify(calendarParam));
		external.callMessage(calendarParam);
	}

	/**关闭模块*/
	function closeModule(moduleName){
		var curPageCode = appUtils.getSStorageInfo("_curPageCode");
        curPageCode = (!curPageCode || curPageCode == "null") ? "" : curPageCode;
        if(curPageCode!="account/msgVerify"){
        	layerUtils.iConfirm("您的开户流程还未走完，是否退出开户?",function(){
				exitOpen(moduleName);//退出开户
			},null,"是","否");
        }else{
			exitOpen(moduleName);//退出开户
        }
	}

	/**
	*退出开户
	*/
	function exitOpen(moduleName){
		var param = {
			"moduleName":moduleName,
			"funcNo":"50114"
		};
		param.funcNo = global.OnlyOpen?"50105":"50114";//如果是单独开户的包，只需要直接退出应用
		external.callMessage(param);
	}

	/**浮点数的乘法运算 str---需要做乘法运算的浮点数  mNum---需要乘以的位数*/
	function multiplyF(str,mNum){
		if(str){
			var needStr = str+"";//需要获取小数点位数的数字
//			var dindex = needStr.substr(needStr.indexOf(".")+1).length;//获取小数点的位数
			var dindex;
			if(needStr.indexOf(".")>-1){
				dindex = needStr.substr(needStr.indexOf(".")+1).length;//获取小数点的位数
			}else{
				dindex = 0;//默认没有小数点
			}
			if(mNum){
				mNum = parseInt(mNum);//担心不是整数数字
				var intStr = 0;
				if(needStr){
					var intString = needStr.replace(".","");//去除小数点
					intStr = intString.replace(/\b(0+)/gi,"");//去除掉字符串前面的0
				}
				var mathStr = intStr*(Math.pow(10,mNum));//乘以指定位数之后的结果
				mathStr += "";//先转化为字符串
				//根据原来小数点位数拆分数字字符串拼接成我们需要的小数
				var beforeD = mathStr.substr(0,mathStr.length-dindex);
				var afterD = mathStr.substr(mathStr.length-dindex);
				var mresult = beforeD + "." +afterD;
				mresult = parseFloat(mresult);
				return mresult;
			}else{
				return str;//没有传需要乘以的位数
			}
		}
	}

	/**
	 * 自定义确认框
	 * @param layerMsg 确认框的内容
	 * @param oneText 第一个按钮按钮的文本内容
	 * @param funcOne 第一个按钮的回调函数
	 */
	function layerContent(content,config,tapText,tapFunc){
		var viewContent = '<div id="utilContentSign" style="height: 400px;overflow:auto;background-color:white;border-radius:8px;">'+
								content+
								'<div class="one_btnbox">'+
									'<a class="sim_btn sign_confirm" id="utilContent_confirm" href="javascript:void(0)">'+tapText+'</a>'+
								'</div>'+
							'</div>';
		var iConfirm = layerUtils.layerCustom(viewContent,config);
		appUtils.preBindEvent($("#utilContentSign")," #utilContent_confirm",function(){
			if(tapFunc)
			{
				tapFunc();
			}
			layerUtils.iCustomClose();
		});
	}

	var utilsHN2 = {
		"layerTwoButton" : layerTwoButton,
		"selectDate" : selectDate,
		"selectDateDiv" : selectDateDiv,
		"closeModule" : closeModule,
		"multiplyF":multiplyF,
		"layerContent":layerContent
	};

	module.exports = utilsHN2;
});