/**
 * 投顾模块公用 js
 */
define(function(require, exports, module){
    
    var appUtils = require("appUtils");
    var layerUtils = require("layerUtils");
    var gconfig = require("gconfig"); 
    var global = gconfig.global;
    var nativePluginService = require("nativePluginService");
    var common = require("common");
    var external = require("external");
    var isSsoLoading = false;
       
    /**
     * 首次进入模块的时候，调用
     */
    function firstLoadFunc()
    {
       nativePluginService.function50100({"moduleName":gconfig.projName});
       common.firstLoadFunc();
    }
    
    /**
     *  处理会话失效
     */
    function filterLoginOut(data)
    {
       if(data.error_no == "-999")
       {
          if(!isSsoLoading)
          {
             isSsoLoading = true;
             var pro = gconfig.projName + "_credit";
             appUtils.setSStorageInfo(gconfig.projName + "_login_token","");
             appUtils.setSStorageInfo(pro + "_login_token", "");
             nativePluginService.function50040({"key": "temp_token_" + gconfig.projName,"value":""});
             nativePluginService.function50040({"key": "temp_token_" + pro, "value":""});
             reloadPageInit();
          }
       }
    }
    
    /**
     * 重新初始化js模块
     */
    function reloadPageInit()
    {
       var pageCode = getCurrentPageCode();
       hidePageContent(pageCode);
       appUtils.pageInit("",pageCode);
    }
       
	/**
	 * 每个页面校验
	 */
	function checkPermission(checkInParam)
	{
       //进行登陆检测
       var resultVo;
       //获取需要登陆判断的页面编码
       var checkLoginPage = gconfig.global.checkLoginPageCode;
       //获取不需要登陆判断的页面编码
       var notCheckLoginPage = gconfig.global.notCheckLoginPageCode;
       if(gconfig.platform != "0")
       {
	       // 判断当前页面是否需要激活才能进入
	       if( (checkLoginPage && checkLoginPage.indexOf(checkInParam.pageCode) > -1) || (notCheckLoginPage && notCheckLoginPage.indexOf(checkInParam.pageCode) < 0) )
	       {
	          // 获取壳子里的全局登陆状态，1:已经登陆； 0:代表退出
	          resultVo = nativePluginService.function50041({"key":"app_login_state"});
	          var login_state = resultVo.results[0].value;
	          // 已经统一登陆
	          
	          if(login_state == "1")
	          {
	              // 本地session为空，需要进行模拟登陆
                  var proj_login = gconfig.projName;
                  var isLoginIn = appUtils.getSStorageInfo("_isLoginIn");
            	 if (checkInParam.pageCode.indexOf("credit") > -1){
            		 proj_login = gconfig.projName + "_credit";
            	 }
                 var token = appUtils.getSStorageInfo(proj_login + "_login_token");
                 if(!token || token.length == 0)
                 {
                    resultVo = nativePluginService.function50041({"key": "temp_token_" + proj_login});
                    token = resultVo.results[0].value;
                 }
	             if(!token || token.length == 0)
	             {
//                     appUtils.clearSStorage("_isLoginIn");
//	                 reBuildSsoToken(checkInParam.pageCode);
//	                 return false;
	            	 goTologin(checkInParam.pageCode, checkInParam.param && checkInParam.param.stockCode,checkInParam.param);
	 	            return false;
	             }
	             if (checkInParam.pageCode.indexOf("credit") > -1){
	            	 if(!appUtils.getSStorageInfo("_isLoginIn_credit"))
		             {
		                 return ssoLogin(token,checkInParam.pageCode,checkInParam.param); // 模拟登陆
		             } else {
		            	 return true;
		             }
	             } else {
	            	 if(!appUtils.getSStorageInfo("_isLoginIn_stock"))
		             {
		                 return ssoLogin(token,checkInParam.pageCode,checkInParam.param); // 模拟登陆
		             } else {
		            	 return true;
		             }
	             }
                     /**
	                 // 比较本地token值与壳子token值是否相同
                     var session_token = appUtils.getSStorageInfo(gconfig.projName + "_login_token") || "";
	                 if(token == session_token)
	                 {
	                     return true;
	                 }
	                 else
	                 {
	                    return ssoLogin(token,checkInParam.pageCode); // 模拟登陆
	                 }
                     **/
	         }
	         // 未登录状态，需清理session并且跳到登陆页面
	         else
	         {
	            goTologin(checkInParam.pageCode, checkInParam.param && checkInParam.param.stockCode,checkInParam.param);
	            return false;
	         }
	      }
       }
      return true;
	}
	
    /**
     *  模拟登陆
     */
    function ssoLogin(token, pageCode, param)
    {
    	var user_type = "0",
    		proj = gconfig.projName;
    	var jsessionid = "";
    	if("ygt" == proj){
            jsessionid = external.callMessage({"key":"jsessionid","funcNo": "50041"}).results[0].value;
    	}
    	if (pageCode.indexOf("credit") > -1){
    		user_type = "b";
    		proj = gconfig.projName + "_credit";
    	}
    	
       appUtils.invokeServer(global.serverPath, {"funcNo":"600001","temp_token":token,"user_type": user_type,"jsessionid" : jsessionid}, function(data){
            if(data.error_no == 0)
            {
                appUtils.setSStorageInfo(proj + "_login_token",token);
                if (proj.indexOf("credit") > -1){
                	appUtils.setSStorageInfo("_isLoginIn_credit","true");
                } else {
                	appUtils.setSStorageInfo("_isLoginIn_stock","true");
                }
                appUtils.setSStorageInfo("_isLoginIn","true");
                common.saveSessionUserInfo(data.results, user_type);
                if(pageCode)
                {
                	
                     appUtils.pageInit("",pageCode,param);
                }
                else
                {
                     reloadPageInit(pageCode);
                }
                // 禁止信用、资金都登录后，切到“我的”，自动去到“证券交易”  刘宝-hsj -16-02-26
                nativePluginService.function50040({"key":proj+"_login_state","value":"1"});
                isSsoLoading = false;
            }
            else if(data.error_no == -1 || data.error_no == -501031 || data.error_no == -60000100)
            {
                reBuildSsoToken(pageCode);
            }
            else
            {
                appUtils.setSStorageInfo(proj + "_login_token","");
                nativePluginService.function50040({"key":"temp_token_" + proj,"value":""});
                // 增加了一个入参 pageCode  再次登录时 用来作登录的入参 刘宝-hsj -16-02-26
                common.ssoLoginFailed(data,pageCode);
            }
       },true,true);
       return false;
    }
    
    /**
    *  @Author 刘宝, 2015-07-28 21:07:11
    *
    *
    *  @return 重构SSO的Token
    */
    function reBuildSsoToken(pageCode)
    {
       var param = {};
       param["funcNo"] = "60402";
       param["moduleName"] = gconfig.projName;
       param["tokenName"] = gconfig.projName;
       if (pageCode.indexOf("credit") > -1){
    	   param["tokenName"] = gconfig.projName + "_credit";
       }
       param["toPage"] = pageCode;
       external.callMessage(param);
    }
       
    /**
     * 统一退出
     */
    function ssoLoginOut()
    {
       external.callMessage({"funcNo": "50040", "key": "common_user_id", "value": ""});
       external.callMessage({"funcNo": "50040", "key": "curr_loginid", "value": ""});
       external.callMessage({"funcNo": "50040", "key": "credit_user_id", "value": ""});
       external.callMessage({"funcNo": "50040", "key": "credit_account", "value": ""});
       external.callMessage({"funcNo": "50040", "key": "client_id", "value": ""});
       external.callMessage({"funcNo": "50040", "key": "credit_client_id", "value": ""});
       external.callMessage({"funcNo": "50040", "key": "jsessionid", "value": ""});
       var param = {};
       param["funcNo"] = "60400";
       
       param["moduleName"] = gconfig.projName;
       external.callMessage(param);
    }
       
    /**
     * 切换到登陆页面
     */
    function goTologin(pageCode ,stockCode,param)
    {
//       appUtils.clearSStorage("_isLoginIn");
       
       //发消息给原生，通知打开登陆页面重新登陆
       var url = getPageUrl(pageCode);
       hidePageContent(getPageCode(url));
       var proj = gconfig.projName;
       if (url.indexOf("credit") > -1){
    	   proj = "credit";
       }
       appUtils.clearSStorage(proj + "_login_token");
       
       //拼接传过来的param参数通过url传给原生获取-------begin
       var paramStr = "";
       if(param)
       {
           if("common" == param.type){
               proj = "common";
           }
           if("rzrqIdentify" == param.type){
               proj = "rzrqIdentify";
           }
           delete param["funcNo"];
           delete param["toPage"];
           delete param["isLoad"];
           for(var key in param)
           {
              paramStr += (key + "=" + param[key] + "&");
           }
           if(paramStr.length > 0)
           {
              paramStr = paramStr.substring(0,paramStr.length - 1);
           }
           var index0 = url.indexOf("#!/");
           var index1 = url.indexOf("?");
           if(index1 > index0)
           {
              url += ("&" + paramStr);
           }
           else
           {
              url += ("?" + paramStr);
           }
       }
       //拼接传过来的param参数通过url传给原生获取-------end
       
       var param_login = {"moduleName":"sso", "params":{"moduleName":gconfig.projName,"toPage":url,"isLoad":"0", "stock_code": stockCode, "login_type": proj}};
       nativePluginService.function50101(param_login);
    }
    
    //获取url
    function getPageUrl(pageCode)
    {
       var url = window.location.href;
       var pageCodeStr = "";
       var index = url.indexOf("#!/");
       if(url.indexOf("#!/") > 0)
       {
            pageCodeStr = url.substring(index,url.length);
       }
       if(pageCode)
       {
             pageCodeStr = ("#!/" + pageCode +".html");
       }
       if(pageCodeStr.length == 0)
       {
             pageCodeStr = ("#!/" + gconfig.defaultPage.pageCode +".html");
       }
       if(index > 0)
       {
             url = url.substring(0,index);
       }
       url += pageCodeStr;
       return url;
    }
    
    //获取页面编码
    function getPageCode(url)
    {
       var pageCode;
       if(url.split("#!/").length > 0)
       {
         pageCode = url.split("#!/")[1];
         var index = pageCode.indexOf(".");
         if(index > 0)
         {
           pageCode = pageCode.substring(0,index);
         }
       }
       return pageCode;
    }
    
    //隐藏内容
    function hidePageContent(pageCode)
    {
       var pageId = pageCode.split("/").join("_");
       $("#"+pageId).hide();
    }
    
    //检测是否要登录
    function checkLoginRight(pageCode)
    {
       var url = getPageUrl(pageCode);
       pageCode = getPageCode(url);
       // 判断当前页面是否需要激活才能进入
       //获取需要登陆判断的页面编码
       var checkLoginPage = gconfig.global.checkLoginPageCode;
       //获取不需要登陆判断的页面编码
       var notCheckLoginPage = gconfig.global.notCheckLoginPageCode;
       return((checkLoginPage && checkLoginPage.indexOf(pageCode) > -1) || (notCheckLoginPage && notCheckLoginPage.indexOf(pageCode) < 0) );
    }
    
    //获取当前的页面pageCode
    function getCurrentPageCode()
    {
       var url = getPageUrl();
       var pageCode = getPageCode(url);
       return pageCode;
    }
       
    var sso =
    {
    	"firstLoadFunc" : firstLoadFunc,
    	"checkPermission":checkPermission,
        "filterLoginOut" :filterLoginOut,
        "goTologin": goTologin,
        "ssoLoginOut": ssoLoginOut,
        "reloadPageInit": reloadPageInit,
        "checkLoginRight":checkLoginRight,
        "getCurrentPageCode":getCurrentPageCode,
        "hidePageContent" :hidePageContent
    };
    
    module.exports = sso;
});