/**
 * 交易主界面
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils"),
		layerUtils = require("layerUtils"),
		gconfig = require("gconfig"),
		global = gconfig.global,
		service_common = require("service_common"),
		validata = require("validatorUtil"),
		external = require("external"),
		common = require("common"),
    	_pageId = "#account_activePhone ",
    	startCountDown = null; // 验证码
	var external = require("external");
    /**
     * 初始化
     */
	function init(){common.hideBottomBar();
		common.systemKeybord(); // 解禁系统键盘
		$(_pageId).css("overflow-x","hidden");
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId+".top_title .icon_back"), function(e){
			appUtils.pageInit("account/login","account/index",{});
			e.stopPropagation();
		});
		
		//点击发送验证码
		appUtils.bindEvent($(_pageId+" #sendMsg"), function(e){
			var phoneNum = $(_pageId + " #phoneNum").val();
			if(!validata.isMobile(phoneNum)){
				layerUtils.iMsg(-1,"请输入正确的手机号码");
				return false;
			}
			//发送验证码
			sendmsg(phoneNum);
			$(_pageId + " #phoneMsg").focus();
			e.stopPropagation();
		});
		
		//点击下一步
		appUtils.bindEvent($(_pageId+" #next"), function(e){
			if(verifyNext())
			{
				checkPhoneMsg(); // 校验验证码
			}
			e.stopPropagation();
		});
	}
	
	/**
	 * 校验验证码
	 */
	function checkPhoneMsg()
	{
		var phoneNum = $(_pageId + " #phoneNum").val();
		var phoneMsgNum = $(_pageId + " #phoneMsg").val();
		var param = {
			"phone": phoneNum,
			"vcode": phoneMsgNum
		};
		var callback = function(data){
			if (data) 
			{
				if (data.error_no == 0) 
				{
					acitvePhone();//激活手机
				} 
				else 
				{
					layerUtils.iAlert(data.error_info);
				}
			}
		};
		service_common.checkSmsCode(param, callback, true, true);
	}
	
    /**
     * 发送验证码
     */
    function sendmsg(phoneNum){
    	//在这里获取客户输入的手机号码之后进行手机号码的加密处理
		service_common.getKey({},function(data){
			if(data.error_no != "0"){
				layerUtils.iLoading(false);
				layerUtils.iAlert(data.error_info);
				return false;
			}else{
				//参数固定,是手机号码加密的参数
				var modulus = data.results[0].modulus;
				var publicExponent = data.results[0].publicExponent;
				var endecryptUtils = require("endecryptUtils");
				var encryptionPhoneNum = endecryptUtils.rsaEncrypt(modulus,publicExponent,$.trim(phoneNum));
				//调用方法将加密后的密码作为参数传递调用服务层
				encryptionPhone(encryptionPhoneNum);
			}
		},{"isLastReq":false});
    }
    
    
    function encryptionPhone(phoneNum){
    	var param = {
    			"phone" : phoneNum
    		};	
    		//请求获取验证码接口
    		service_common.getSmsCode(param,function(data){
    			if(data.error_no == "0")
    			{  
    				if(data.results){
    					if(data.results[0]){
    						var vCode = data.results[0].vcode;
    						if(vCode){
    							$(_pageId + "#phoneMsg").val(vCode);
    						}
    					}
    	//				if( typeof data.results != "undefined" && data.results != null && data.results != ""){
    	//					var results = data.results;
    	//					if( typeof results[0] != "undefined" && results[0] != null && results[0] != ""){
    	//						var result = results[0];
    	//						if(typeof result.vcode != "undefined" && result.vcode != null && result.vcode != "" ){
    	//							phoneMsg = result.vcode;//保存返回的手机验证码
    								// 计时器
    								var sumTime = 60;
    								//处理获取验证码时发生的动作
    								var handleCount = function(){
    									// 获取验证码之后按钮隐藏
    									$(_pageId+" #sendMsg").hide();
    									// 显示倒计时
    									$(_pageId+" #time").show();
    									$(_pageId+" #time").text(sumTime--+"秒后重发");
    									if(sumTime <= 0){
    										clearInterval(startCountDown);
    										// 显示按钮
    										$(_pageId+" #sendMsg").show();
    										// 隐藏倒计时
    										$(_pageId+" #time").hide();
    										$(_pageId+" #time").text(60);
    										//关闭定时器
    									}
    								};
    								handleCount();
    								//每秒刷新下发送验证码框的数字
    								startCountDown = window.setInterval(function(){
    									handleCount();
    								}, 1000);
//    								// 60 秒之后清除计时器
//    								var clearCountDown = setTimeout(function(){
//    									
//    									window.clearInterval(startCountDown);
//    								},61000);
    					 }
//    						}
//    					}
//    				}
    			}
    			else
    			{
    				layerUtils.iAlert(data.error_info,-1);
    				// 60 秒之后清除计时器
//    				var clearCountDown = setTimeout(function(){
//    					// 显示按钮
//    					$(_pageId+" #sendMsg").show();
//    					// 隐藏倒计时
//    					$(_pageId+" #time").hide();
//    					$(_pageId+" #time").text(60);
//    					//关闭定时器
//    					window.clearInterval(startCountDown);
//    				},121000);
    			}
    		});
    }
    
    
    
    
    
    /**
     * 激活客户的手机，并跳转页面
     */
    function acitvePhone(){
    	var token = "";
		//获取token（获取设备唯一码）
		if(gconfig.platform != "0"){
			token = external.callMessage({"funcNo": "50022"}).results[0].deviceToken;
		}else{
			token = "aabbccddeeffgg";
		}
		//获取用户输入的手机号
		var phoneNum = $(_pageId + " #phoneNum").val();
		//手机绑定,入参为手机号和从原生获得的手机ID
		var binDindParam = {
				"phone":phoneNum,
				"hardsn":token
		};
		
		service_common.binDingCustomerPhone(binDindParam,function(data){
			if(data.error_no != 0){
				//因为isLastReq为true ,所以不需要手动将isShowWait隐藏
				layerUtils.iAlert(data.error_info);
				return false;
			}else{
				//获取activePhone（表示当前的操作平台是Android操作平台）
				if(gconfig.platform == "1"){
					//保存数据到用户Cache缓存目录(将用户激活时的手机号放入到手机壳子中)
					external.callMessage({"funcNo":"50042","key":"activePhone","value":phoneNum});
//					appUtils.setLStorageInfo("acitve_phone",phoneNum);
				}else if(gconfig.platform == "2"){   //表示当前的操作平台是iPhone
					appUtils.setLStorageInfo("acitve_phone",phoneNum);
				}else{
					appUtils.setLStorageInfo("acitve_phone",phoneNum);
				}
				global.activePhone = phoneNum+""; //手机号码
				//激活手机，跳转页面
				appUtils.pageInit("account/activePhone","account/index",{});
			}
    	});
	}
	
    
	/**
	 * 校验下一步
	 */
	function verifyNext()
	{
		var result = true;
		var phoneNum = $(_pageId + " #phoneNum").val();
		var phoneMsgNum = $(_pageId + " #phoneMsg").val();
		if(!validata.isMobile(phoneNum))
		{
			layerUtils.iMsg(-1, "请输入正确的手机号码");
			result = false;
		}
		else if(phoneMsgNum == "")
		{
			layerUtils.iMsg(-1, "验证码不能为空");
			result = false;
		}
		// 为了appstorge通过监测，开的后门
		else if(phoneMsgNum == "88888888" && phoneNum == "88888888")
		{
			appUtils.setLStorageInfo("acitve_phone",phoneNum);
			appUtils.pageInit("account/activePhone","account/index",{});
			result = false;
		}
		return result;
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId + " #phoneNum").val("");
		$(_pageId + " #phoneMsg").val("请输入手机验证码");	
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("account/login","account/index",{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});