/**
 * 密码修改
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var layerUtils = require("layerUtils");
	var validator = require("validatorUtil");
	var external = require("external");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var service_common = require("service_common");
	var _pageId = "#account_changeStockStation ";
	var timer = "";
	
    /**
     * 初始化
     */
	function init() {
		common.hideBottomBar();
		//从js中获取数据
		getParams();
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent() {
		//返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			appUtils.pageInit("account/changePassword","account/index",{});
		});
		//确定
		appUtils.bindEvent($(_pageId + " #confirm"), function(e){
			var hasChecked = $(_pageId + " .trading_sec").text();
			if(hasChecked){
				appUtils.pageBack();
			}else{
				layerUtils.iAlert("请选择券商站点");
				return false;
			}
		});
	}
	
	/**
	 * 获取列表参数
	 * @param {Object} obj
	 */
	function getParams() {
		var i = 1;
		timer = setInterval(function(){
			if(!BLIST){
				i = i +1;
				if(i == 10){
					layerUtils.iAlert("未获取到券商站点列表，请稍后在试",0,backPage);
					clearInterval(timer);
					return false;
				}
			}else{
				clearInterval(timer);
				showMsg(BLIST);
			}
		},500)
	}
	/**
	 * 查询数据失败，则返回上一级页面
	 */
	function backPage(){
		appUtils.pageBack();
	}
	/**
	 * 展示券商列表
	 */
	function showMsg(data){
		var html = "";
		for(var i =0;i<data.length;i++){
			var result = data[i];
			html += "<li class=\"\" id="+result.address+">"+result.name+"</li>";
		}
		$(_pageId + " #append").html(html);
		//点击券商列表
		appUtils.bindEvent($(_pageId + " #append li"), function(e){
			var adress = $(this).attr("id");
			$(this).addClass("trading_sec").siblings().removeClass("trading_sec");
			var stockStationName = $(this).text();
			global.serverPathTrade = adress;
			global.validateimg = adress.replaceAll("json","NewImage");
			if(gconfig.platform == "0"){
			appUtils.setLStorageInfo("stockStationName",stockStationName);
			appUtils.setLStorageInfo("serverPathTrade",adress);
			appUtils.setLStorageInfo("validateimg",adress.replaceAll("json","NewImage"));
			}else{
	          external.callMessage({"funcNo":"50042","key":"stockStationName","value":stockStationName});
	          external.callMessage({"funcNo":"50042","key":"serverPathTrade","value":adress});
	          external.callMessage({"funcNo":"50042","key":"validateimg","value":adress.replaceAll("json","NewImage")});
			}
			
		},"click");
	}

	function destroy(){
		if(timer){
			clearInterval(timer);
		}
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("account/changePassword","account/index",{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});