/**
 * 交易主界面
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var layerUtils = require("layerUtils");
    var _pageId = "#account_index ";
    var external = require("external");
    var common = require("common");
    var service_common = require("service_common");
    var nativePluginService = require("nativePluginService");
    var topage ="";
    var stock_userInfo = null;
    var external = require("external");
    var service_stock = require("service_stock");
    
    /**
     * 初始化
     */
	function init(){
		//显示底部导航 
		if (gconfig.platform == "1"){
			external.callMessage({"funcNo": "50108", "moduleName": "main", "flag": "1"});
		} else if (gconfig.platform == "2") {
			external.callMessage({"funcNo": "50108", "moduleName": "system", "flag": "1"});
		}
		// 普通交易首页模块
		external.callMessage({"funcNo": "50040", "key": "trade_module", "value": "stock"});
//		isChooseTradeAccess();//客户是否选择交易通道
		$(_pageId).css("overflow-x","hidden");
		stock_userInfo = appUtils.getSStorageInfo("stock_userInfo");
		if(gconfig.platform == "0"){
			if(stock_userInfo){
				$(_pageId+".top_title .logout").show();
			}else{
				$(_pageId+".top_title .logout").hide();
			}
		}else{
			// 获取壳子里的全局登陆状态，1:已经登陆； 0:代表退出
		    resultVo = nativePluginService.function50041({"key":"app_login_state"});
		    var login_state = resultVo.results[0].value;
			if(!login_state){
				$(_pageId+".top_title .logout").hide();
			}else{
				$(_pageId+".top_title .logout").show();
			}
		}
		
		var items=global["tradeList"];
		for(var i=0;i<items.length;i++){   //根据配置隐藏相应的菜单项
			if(items[i].isShow=="false"){
				$(_pageId + "#"+items[i].id).hide(); 
			}
		}
		
		$(_pageId+".main .trade_nav2").scrollTop(0);
		$(_pageId+".main .trade_nav2").css("overflow-y","auto");
		$(_pageId+" #version").html("version："+_sysVersion);
		
		// 修改首页高度问题
		var h5_height = $(window).height(),
			local_height = appUtils.getSStorageInfo("local_height");
		if (local_height){
			if (h5_height > local_height){
				h5_height = +local_height;
			}
		}
		appUtils.setSStorageInfo("local_height", h5_height);
		var height_meau = h5_height -  $(_pageId+".tab_nav").height()- $(_pageId+".header").height() - $(_pageId+".trade_nav").height() - 12;
		$(_pageId+".main .trade_nav2").height(height_meau); //查询目录添加高度
		/*setTimeout(function(){
			$(_pageId+".main .trade_nav2").height($(window).height() -  $(_pageId+".tab_nav").height()- $(_pageId+".header").height() - $(_pageId+".trade_nav").height() - 12); //查询目录添加高度
		}, 200);*/
    }
	
	/**
	 * 客户是否选择交易通道
	 */
	function isChooseTradeAccess(){
		var stockStationName = "";
		if(gconfig.platform != "0"){
			stockStationName = external.callMessage({"funcNo":"50043","key":"stockStationName"}).results[0].value;
		}else{
			stockStationName = appUtils.getLStorageInfo("stockStationName");
		}
		if(stockStationName && stockStationName != "null"){
			var serverPathTrade = "";
			var validateimg = "";
			if(gconfig.platform != "0"){
				serverPathTrade = external.callMessage({"funcNo":"50043","key":"serverPathTrade"}).results[0].value;
				validateimg = external.callMessage({"funcNo":"50043","key":"validateimg"}).results[0].value;
			}else{
				serverPathTrade = appUtils.getLStorageInfo("serverPathTrade");
				validateimg = appUtils.getLStorageInfo("validateimg");
			}
			if(serverPathTrade && validateimg  && serverPathTrade != "null" && validateimg != "null"){
				$(_pageId + " #nowStation").html("当前交易通道: "+ stockStationName);
				global.serverPathTrade = serverPathTrade;
				global.validateimg = validateimg;
			}else{
				layerUtils.iAlert("未获取到交易通道信息，请重新获取交易通道");
				return false;
			}
		}else{
			$(_pageId + " #nowStation").html("尚未选择交易通道");
			$(_pageId + " #blacCover").show();
			$(_pageId + " #noAcc").show();
			//点击确定事件
			appUtils.bindEvent($(_pageId + " #accConfirm"), function(e){
				appUtils.pageInit("account/index","account/changeStockStation");
			});
			//点击取消事件
			appUtils.bindEvent($(_pageId + " #accCancel"), function(e){
				$(_pageId + " #blacCover").hide();
				$(_pageId + " #noAcc").hide();
			});
		}
	}
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId+".top_title .icon_back"), function(e){
			external.callMessage({"moduleName":"home","funcNo": "50101"});
			e.stopPropagation();
		});
		
		//绑定顶部菜单事件
		appUtils.bindEvent($(_pageId + " .bind-click"), function(e){
			// 获取跳转的页面
			var $this = $(this),
				page = $this.attr("data-topage"),
				// 获取跳转页面参数
				param = $this.attr("param");
			appUtils.pageInit("account/index", page, {"param": param}); 
		});
		
		//主页菜单事件绑定
		appUtils.bindEvent($(_pageId + " .caidan ul li a"), function(e){
			var $this = $(this),
				to_page = $this.attr("to-page");
			if (to_page){
				topage = to_page.replaceAll("_","/"); //获取跳转的页面
				var param =  $(this).attr("param"); //获取跳转页面参数
				appUtils.pageInit("account/index", topage, {"param":param});
			}
			
			
//			if(stock_userInfo && credit_userInfo){ //当信用和普通账户都登录时
//				var fund_account_credit = JSON.parse(credit_userInfo).fund_account;
//				var fund_account_stock = JSON.parse(stock_userInfo).fund_account;
//				$(_pageId+".pop_box .pop_main dd:eq(0) label span").text("("+fund_account_stock+")");
//				$(_pageId+".pop_box .pop_main dd:eq(1) label span").text("("+fund_account_credit+")");
//				
//				if(topage=="newshare/apply"){
//					$(_pageId+".pop_box .pop_main h4 span").text("新股申购操作");
//					$(_pageId + ".backdrop").show();
//					$(_pageId + ".pop_box").show();
//				}else if(topage=="banking/transfer"){
//					$(_pageId+".pop_box .pop_main h4 span").text("银证转账操作");
//					$(_pageId + ".backdrop").show();
//					$(_pageId + ".pop_box").show();
//					appUtils.setSStorageInfo("whichPage","account/index");
//					
//					
//				}else if(topage=="account/changePassword"){
//					$(_pageId+".pop_box .pop_main h4 span").text("密码修改操作");
//					$(_pageId + ".backdrop").show();
//					$(_pageId + ".pop_box").show();
//					
//					
//					
//				}else{
//					appUtils.pageInit("account/index",topage,{"param":param}); 
//				}
//			}else if(stock_userInfo){  //仅普通账户都登录时
//				if(topage!="credit/asset/asset"){
//					appUtils.setSStorageInfo("whichAccount","stock_userInfo");
//					appUtils.setSStorageInfo("whichPage","account/index");
//					appUtils.pageInit("account/index",topage,{"param":param}); 
//				}else{
////					appUtils.pageInit("account/index","account/login",{"topage":topage});
//					appUtils.pageInit("account/index","account/login",{"param":param}); 
//				}
//			}else if(credit_userInfo){ //仅信用账户都登录时
//				var arr = ["credit/asset/asset","newshare/apply","banking/transfer","account/changePassword"];
//				if(arr.indexOf(topage) != -1){
//					appUtils.setSStorageInfo("whichAccount","credit_userInfo");
//					appUtils.setSStorageInfo("whichPage","account/index");
//					appUtils.pageInit("account/index",topage,{"param":param}); 
//				}else{
////					appUtils.pageInit("account/index","account/login",{"topage":topage});
//					appUtils.pageInit("account/index","account/login",{"param":param}); 
//				}
//			}else{  //都未登录时 客户选择操作站点不需要登陆
//				if(topage == "account/changeStockStation"){
//					appUtils.pageInit("account/index","account/changeStockStation");
//				}else{
////					appUtils.pageInit("account/index",topage,{"topage":topage});
//					appUtils.pageInit("account/index",topage,{"param":param}); 
//				}
//			}
		});
		
		
		//账户选择事件
		appUtils.bindEvent($(_pageId + ".pop_box .pop_main dd"), function(e){
			$(this).find("input").attr("checked","checked");
			$(this).siblings().find("input").attr("checked",false);
		});
		//账户选择确认事件
		appUtils.bindEvent($(_pageId + ".pop_box #sureBtn"), function(e){
			var whichAccount = "stock_userInfo";
			$(_pageId + ".backdrop").hide();
			$(_pageId + ".pop_box").hide();
			if($(_pageId+".pop_box .pop_main dd:eq(1)").find("input").attr("checked")){
				whichAccount = "credit_userInfo";
			}
			appUtils.setSStorageInfo("whichAccount",whichAccount);
			appUtils.pageInit("account/index",topage,{}); 
		});
		
		
		//注销事件
		appUtils.bindEvent($(_pageId + ".top_title .logout"), function(e){
			var tipStr = "<div class=\"pop_main\" style=\"height: 50px;margin-top: 20px;font-size:0.15rem\"><div>确定退出当前登录账号?</div></div>";
			common.btnConfirm(tipStr,function success(){
				appUtils.clearSStorage();
				stock_userInfo =null;
				$(_pageId+".top_title .logout").hide();
//				service_stock.exitTrade(exitTradeCallBack,{"isLastReq":true,"isShowWait":false});
//				function exitTradeCallBack(data){
//					if(data.error_no == 0){
//						$(_pageId+".top_title .logout").hide();
//						layerUtils.iAlert("注销成功");
//					}else{
//						layerUtils.iAlert("注销失败");
//					}
//				}
				nativePluginService.function50040({"key": "logining_time", "value": -20000.5});
				require("sso").ssoLoginOut();
			},function fail(){
				
			});
		});
		
	}
    
	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId+".pop_box .pop_main dd:eq(0) input").attr("checked","checked");
		$(_pageId+".pop_box .pop_main dd:eq(1) input").attr("checked",false);
		$(_pageId + " #blacCover").hide();
		$(_pageId + " #noAcc").hide();
		myShIscroll = null;
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});