/**
 * 交易登录
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var layerUtils = require("layerUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var service_common = require("service_common");
	var validata = require("validatorUtil");
	var external = require("external");
	var common = require("common");
	var _pageId = "#account_login ";
    var topage ="";    //记录登录后跳转的页面
    var mobilekey =""; //登录验证码标记
    var input_type = "0"; // 登录类型	0：资金账号，1：股东内码，2：资金卡号，3：银行账号，4：股东账号，5：客户编号，a：期货账号,b:融资融券,c 个股期权
    var for_where = "";
    
    /**
     * 初始化
     */
	function init() {
		common.hideBottomBar();
		common.systemKeybord(); // 解禁系统键盘
		$(_pageId).css("overflow-x","hidden");
		topage = appUtils.getPageParam("topage");//记录登录后跳转的页面
		for_where = appUtils.getSStorageInfo("_prePageCode") || "account_index";
		//融资融券
		if(for_where.indexOf("credit") > -1){
			//获取activePhone
			if(gconfig.platform == "1"){
				var accNum = external.callMessage({"funcNo":"50043","key":"creSavaAcc"}).results[0].value;
			}else{
				var accNum = appUtils.getLStorageInfo("creSavaAcc");
			}
			if(accNum  && accNum != "null" && accNum !="0"){
				$(_pageId+"#saveAcc .c1").attr("checked",true);
				$(_pageId+"#account").val(accNum);
			}else{
				$(_pageId+" #saveAcc .c1").attr("checked",false);
			}
			$(_pageId+".top_title h3").text("融资融券登录");
			$(_pageId + " .select_box p").text("融资融券账号登录").attr("id","b");
			$(_pageId + " #account").attr("placeholder","请输入融资融券账号");
			$(_pageId + " #password").attr("placeholder","请输入融资融券密码");
			$(_pageId + " .stockAHide").hide();//普通交易登陆方式下拉框隐藏，融资融券显示
			$(_pageId + " .creditHide").show();//普通交易登陆方式下拉框，融资融券显示
		}else{
			if(!topage){
				topage ="stock/stockBuy";
			}
			//获取activePhone
			if(gconfig.platform == "1"){
				var accNum = external.callMessage({"funcNo":"50043","key":"ordSavaAcc"}).results[0].value;
			}else{
				var accNum = appUtils.getLStorageInfo("ordSavaAcc");
			};
			if(accNum && accNum != "null" && accNum !="0"){
				$(_pageId+"#saveAcc .c1").attr("checked",true);
				$(_pageId+"#account").val(accNum);
			}else{
				$(_pageId+" #saveAcc .c1").attr("checked",false);
			}
			$(_pageId+".top_title h3").text("普通交易登录");
			$(_pageId + " .select_box p").text("资金账号登录").attr("id","0");
			$(_pageId + " #loginKind").show();
			$(_pageId + " .stockAHide").show();//普通交易显示登陆方式下拉框，融资融券隐藏
			$(_pageId + " .creditHide").hide();//普通交易显示登陆方式下拉框，融资融券隐藏
		}
		common.clearStateTime();
	   //获取验证码
		getTicketImg();
		
		if(gconfig.platform=="0"){ //方便pc端调试
			$(_pageId+"#password").attr("readonly",false);
		}
    }

	/**
	 * 获取验证码
	 */
	function getTicketImg(){
		var ticket_key = getRndNum(10);
		mobilekey=ticket_key;
		var randomImg = gconfig.global.validateimg +"?r="+ ticket_key+"&mobileKey="+ticket_key;
		$("#randomImg").attr("src", randomImg);
	}
	
	/**
	 * 获取随机数
	 */
	function getRndNum(n){
		  var rnd="";
		  for(var i=0;i<n;i++)
		     rnd+=Math.floor(Math.random()*10);
		  return rnd;
	}
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId+".top_title .icon_back"), function(e){
			if (for_where.indexOf("credit") > -1){
				appUtils.pageInit("account/login", "credit/index",{});
			} else {
				appUtils.pageInit("account/login", "account/index",{});
			}
			e.stopPropagation();
		});
		//保存账号按钮
		appUtils.bindEvent($(_pageId+" #saveAcc"), function(e){
			var isChecked = $(this).find("input").attr("checked");
			if(isChecked){
				$(this).find("input").attr("checked",false);
			}else{
				layerUtils.iAlert("在本机保存账号可能存在一定的风险，请您注意！",0,function(){
					$(_pageId+" #saveAcc").find("input").attr("checked",true);
				},"确认");
			}
			e.stopPropagation();
		});
		//登录
		appUtils.bindEvent($(_pageId+"#login"), function(e){
			input_type = $(_pageId+" #loginKind p").attr("id");  
			//登录校验
			if(!checkInput()){
				return false;
			};
			submitLogin();
			e.stopPropagation();
		});
		//绑定点击验证码图形
		appUtils.bindEvent($(_pageId+"#randomImg"),function(e){
			getTicketImg();
			e.stopPropagation();
		});		
		//密码输入框调用原生键盘
		appUtils.bindEvent($(_pageId+"#password"),function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50210", "pageId":"account_login", "eleId":"password", "doneLable":"done", "keyboardType":"4"});
			e.stopPropagation();
		},"click");
		//失去焦点关闭原生键盘
		appUtils.bindEvent($(_pageId+"#password"),function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50211"});
			e.stopPropagation();
		},"blur");
		//点击登陆下拉框
		appUtils.bindEvent($(_pageId  + "#loginKind"), function(e){
			$(_pageId+" #loginKind ul").slideToggle("fast");
			e.stopPropagation();	// 阻止冒泡
		});
		//点击登录下拉框选择
		appUtils.bindEvent($(_pageId + "#loginKind ul li"),function(e){
			$(_pageId+" #loginKind p").html($(this).find("a strong").html());
			$(_pageId+" #loginKind p").attr("id",$(this).attr("id"));
			var placeholderText = "请输入"+ $(this).find("a strong").html().substring(0,$(this).find("a strong").html().length-2);
			$(_pageId + " #account").attr("placeholder",placeholderText);
			input_type =$(this).attr("id");  
		});
	} 
	
	/**
	 * 校验登录账号,交易密码,手机验证码
	 */
	function checkInput(){
		if(validata.isEmpty($(_pageId+"#account").val())){
			layerUtils.iMsg(-1,"登录账号不能为空");
			layerUtils.iLoading(false);
			return false;
		}
		if(validata.isEmpty($(_pageId+"#password").val())){
			layerUtils.iMsg(-1,"密码不能为空");
			layerUtils.iLoading(false);
			return false;
		}else if(!/^[0-9]{6}$/.test($(_pageId+"#password").val())){
			layerUtils.iMsg(-1,"密码只允许输入0-9且长度为6位");
			layerUtils.iLoading(false);
			return false;
		}
		return true;
	}
	
	/**
	 * 通过短信验证,或者格式校验后登陆
	 */
	function submitLogin(){
		//登录时获取页面手机号码
		var account = $(_pageId+"#account").val();
		var password = $(_pageId+"#password").val();
		var ticket = $(_pageId+"#ticket").val();
		
		//密码加密
		service_common.getKey({},function(data){
			if(data.error_no != "0"){
				layerUtils.iLoading(false);
				layerUtils.iAlert(data.error_info);
				return false;
			}else{
				//参数固定,是密码加密的参数
				var modulus = data.results[0].modulus;
				var publicExponent = data.results[0].publicExponent;
				var endecryptUtils = require("endecryptUtils");
				password = endecryptUtils.rsaEncrypt(modulus,publicExponent,$.trim(password));
				loginFuc(); // 调用登录接口
			}
		},{"isLastReq":false});
		
		var account_type = "",
			login_type = "";
		
		if(for_where.indexOf("credit") > -1){
			account_type = "credit_userInfo";
			if(gconfig.platform=="0"){ //方便pc端调试
				login_type = "0";
			}
			else
			{
				login_type = "1";
			}
		}else{
			account_type = "stock_userInfo";
			login_type = "0";
		}
		
		var loginFuc = function(){
			//调用登录接口实现接口
			var param = {
					"entrust_way": global.entrust_way,	// 委托方式  在configuration配置 
					"input_type": input_type,		    //手机登陆
					"input_content": account,			//手机号码
					"password": password,
					"ticket":ticket,
					"content_type" : "",                // 客户标识类型
					"mobilekey":mobilekey,
					"login_type": login_type,
					"account_type":account_type
			};
			//调用登录接口得到回调数据
			service_common.login(param,function(data){
				if(data.error_no != 0){
					$(_pageId+"#password").val("");
					$(_pageId+"#ticket").val("");
					getTicketImg(); // 获取验证码
					layerUtils.iLoading(false);
					layerUtils.iAlert(data.error_info);
					return false;
					
				//此时表示的就是登陆成功
				}else{
					var tradeResults = ""; // 交易登录的结果集 results DataSet
                    if(data.DataSet){
                    	tradeResults = data.DataSet;
                    }else if(data.results){
                    	tradeResults = data.results;
                    }
					if(tradeResults && tradeResults.length > 0){
						/**
						 * 此处为保存账号逻辑
						 */
						//获取用户输入的账号
						var saveAcc = $(_pageId + " #account").val();
						//用户是否记住了账号
						var isChecked = $(_pageId+" #saveAcc .c1").attr("checked");
						
						//融资融券
		                if(for_where.indexOf("credit") > -1){
							if(isChecked){//当前表示用户记住了账号
								//将用户输入的账号保存在壳子中
								if(gconfig.platform == "1"){   
									external.callMessage({"funcNo":"50042","key":"creSavaAcc","value":saveAcc});
								}else{
									appUtils.setLStorageInfo("creSavaAcc",saveAcc);
								}
							//当前表示用户没有记住账号
							}else{
								//没有记住账号的时候将用户信息用“0”作为保存信息
								if(gconfig.platform == "1"){   
									external.callMessage({"funcNo":"50042","key":"creSavaAcc","value":"0"});//赋空值无法覆盖原来值
								}else{
									appUtils.setLStorageInfo("creSavaAcc","0");
								}
							}
							
						//非融资融券
						}else{
							//当前表示用户勾选了记住账号（记住了账号）
							if(isChecked){
								//将用户的账号放入到壳子中
								if(gconfig.platform == "1"){
									external.callMessage({"funcNo":"50042","key":"ordSavaAcc","value":saveAcc});
								}else{
									appUtils.setLStorageInfo("ordSavaAcc",saveAcc);
								}
							}else{
								//不保存用户账号，用0代替
								if(gconfig.platform == "1"){
									external.callMessage({"funcNo":"50042","key":"ordSavaAcc","value":"0"});//赋空值无法覆盖原来值
								}else{
									appUtils.setLStorageInfo("ordSavaAcc","0");
								}
							}
						}
		                //tradeResults交易登录返回的回调数据集
						tradeResults[0].password = password; //将回调后的结果集中的数据进行替换
//						tradeResults[0].fundidtype = tradeResults[1].stock_account;
						//将用户输入的密码转换成JSON格式
						var userInfo =JSON.stringify(tradeResults[0]);
//						var userInfo =JSON.stringify(tradeResults);
//						var userInfo_2 =JSON.stringify(tradeResults[1]);
//						var cre_userInfo = JSON.stringify({});
//						//不同的登录类型，不同的处理方式
//						for(var i = 0; i < tradeResults.length; i++ ){
//							var secuidtype = tradeResults[i].secuidtype;
//							if(secuidtype == 0 ){
//								tradeResults[i].password = password; // 保存交易密码
//								userInfo = JSON.stringify(tradeResults[i]);
//							}else if(secuidtype == 1){
//								tradeResults[i].password = password; // 保存交易密码
//								tradeResults[i].loginType = input_type; // 保存登陆类型
//								cre_userInfo = JSON.stringify(tradeResults[i]);
//							}
//						}
						var re_length = tradeResults.length;
						var stock_json = {};
						//融资融券（保存两种类型）
						if(for_where.indexOf("credit") > -1){
							appUtils.setSStorageInfo("credit_userInfo",userInfo);//信用中信用的
							for (var i = 0; i < re_length; i++){
								var resu= tradeResults[i];
								stock_json[resu.exchange_type] = resu.stock_account;
							}
							appUtils.setSStorageInfo("credit_stockAccount", JSON.stringify(stock_json));//信用股东账号
//							appUtils.setSStorageInfo("credit_userInfo_2",userInfo_2);//信用中信用的
//							appUtils.setSStorageInfo("creStock_userInfo",userInfo);//信用普通
//							var oStockAccount = {};  // 股东账号对象，用于存储返回的股东账号
//							for(var i=0, length = tradeResults.length; i < length; i++){
//								var exchange_type = tradeResults[i].exchange_type;  // 交易市场类别，0：深A，1：深B，2：沪A，3：沪B，4：三板，F1：郑州交易所，F2：大连交易所
//								
//								var holder_kind = tradeResults[i].holder_kind;  // 股东账户类别，0：普通账户, 1：基金账户 2：法人账户 3：回购账户 4：机构账户 5：报价转让
//								
//								var stockKey = "stock" + exchange_type + holder_kind; // 股东账号的 key
//								
//								oStockAccount[stockKey] = tradeResults[i];
//							}
//							appUtils.setSStorageInfo("StockAccount", JSON.stringify(oStockAccount), true);
						
						//非融资融券（保存一种类型即可）
						}else{
							appUtils.setSStorageInfo("stock_userInfo",userInfo);
							for (var i = 0; i < re_length; i++){
								var resu= tradeResults[i];
								stock_json[resu.exchange_type] = resu.stock_account;
							}
							appUtils.setSStorageInfo("stock_stockAccount", JSON.stringify(stock_json));//普通股东账号
						}
						
						//登录成功/失败后的广播消息
    					external.callMessage({"funcNo": "60200","flag":"0","data":{"cust_code":tradeResults[0].cust_code}});   					
    					appUtils.setSStorageInfo("clientinfo",tradeResults[0].clientinfo);
						appUtils.setSStorageInfo("jsessionid",tradeResults[0].jsessionid);
						
						//登录成功就会在框架中存入_isLoginIn  ，每个页面都会配置data-isCheckLogin="true"，通过它判断是否已经登录(重要)
						appUtils.setSStorageInfo("_isLoginIn","true");  
						
						appUtils.setSStorageInfo("_lastDoTime",new Date().getTime());
						
						if(data.DataSet3){
							global.trade_flag = data.DataSet3[0].trade_flag; //是否统一登录标识
						}
						
						common.initLogoutTime();
						common.initStateTime(); //判断是否交易时间
					    layerUtils.iLoading(false);
					    
					    //登录超时停留页面
						var loginPageCode=appUtils.getSStorageInfo("_loginInPageCode");  //超时时停留的页面
						var loginInPageParam=appUtils.getSStorageInfo("_loginInPageParam");
						
						appUtils.clearSStorage("_loginInPageCode"); 
						appUtils.clearSStorage("_loginInPageParam");
						
						if(loginPageCode && loginPageCode != ""){
							var param=JSON.parse(loginInPageParam);	
							topage=loginPageCode;
							if(topage == "credit/password/changePassword"){
								appUtils.pageInit("account/login","credit/index",param);
							}else{
								appUtils.pageInit("account/login",topage,param);
							}
						}else{
							if(topage == "credit/password/changePassword" || topage == ""){
								appUtils.pageInit("account/login","credit/index",{});
							}else{
								appUtils.pageInit("account/login",topage,{});
							}
						}
						common.apprPageBind();
//						appUtils.bindEvent($(document),function(){
//							appUtils.setSStorageInfo("_lastDoTime",new Date().getTime());
//						});
					}else{
						layerUtils.iLoading(false);
						getTicketImg(); // 获取验证码
						external.callMessage({"funcNo": "60200","flag":"1"});
						layerUtils.iAlert("登录失败！");
					}
				}
			},{"isLastReq":false});
	    };
    }
	
	function pageBack(){
		
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
	    topage ="";    //记录登录后跳转的页面
	    mobilekey =""; //登录验证码标记
	    $(_pageId+"#account").val("");
		$(_pageId+"#password").val("");
		$(_pageId+"#ticket").val("");
		external.callMessage({"moduleName":"trade","funcNo": "50211"});
		$(_pageId + " #account").attr("placeholder","请输入资金账号");
		$(_pageId + " #password").attr("placeholder","请输入交易密码");
		$(_pageId + " #loginKind ul").hide();//隐藏下拉选框
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("account/login","account/index",{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});