/**
 * 交易模块公用方法js（涉及到业务接口的调用）
 */
define(function(require, exports, module) {
    var appUtils = require("appUtils");
    var layerUtils = require("layerUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var external = require("external");
	var validata = require("validatorUtil");
	var service_common = require("service_common");
	var service_hq = require("service_hq");
	var service_stock = require("service_stock");
	var service_ggt = require("service_ggt");
	var service_credit = require("service_credit");
	var position_timer = null;
	
	
	/*==========================================普通交易持仓公共方法================================================ */
  
	/**
	 * 普通交易证券持仓查询（持仓查询，买入卖出中的股票联动）
	 */
	function queryPosition(pageId,whichPage){
		var userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
		var branch_no = userInfo.branch_no;	  //分支机构
		var fund_account = userInfo.fund_account;//资金账号
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var sessionid = userInfo.session_id;//会话号
		var param={				
			"entrust_way":entrust_way,
		    "branch_no":branch_no,
		    "fund_account":fund_account,
		    "cust_code":cust_code,
		    "sessionid":sessionid
		};
		//查询持仓数据回调
		service_stock.queryStockData(param,function(data){
			if (data && data != "undefined") {
				if(data.error_no == 0){
					var results = data.results;
					data1 =  "";
					if(results && results.length>0){
						var total_cost_balance = 0;//持仓数量X持仓成本
						var total_last_price = 0; //持仓数量X最新价
						var float_yk = 0; //浮动盈亏
						var marketJson = {"0": "SZ:", "1": "SZ:", "19": "SZ:", "9": "SH:", "10": "SH:", "15": "SH:", "17": "SH:"};
						var tMarket = "";
						for (var i=0;i<results.length;i++){
							 float_yk += Number(results[i].float_yk);//计数总浮动盈亏
							 total_cost_balance += Number(results[i].cost_amount)*Number(results[i].cost_price);
							 total_last_price += Number(results[i].cost_amount)*Number(results[i].last_price);
							 data1 += queryPositionHTML_stock(results[i]);
							 var exchange = marketJson[results[i].exchange_type];
						     tMarket += results.length - 1 === i ? exchange + "" + results[i].stock_code : exchange + "" + results[i].stock_code + "|";
						}
						$(pageId+".no_data").hide();
						console.log(tMarket);
						//将生成的HTML添加到指定的地方
						var ceTableObj = $(pageId+".fund_table .ce_table tbody");
						ceTableObj.find("tr:eq(0)").siblings().remove();
						ceTableObj.append(data1);
						// 刷新持仓市值
						if (position_timer){
							clearInterval(position_timer);
							position_timer = null;
						}
						position_timer = setInterval(function(){
							refreshNow(tMarket, pageId);
						}, 3000);
						//买入卖出事件
						appUtils.bindEvent($(pageId+".fund_table .ce_table tr"), function(e){
							var stock_code = $(this).attr("id");
							var topage = "";
							//点击卖出,跳转到买卖页面.
							if(whichPage==1){
								topage = "stock/stockBuy";
							}else if(whichPage==2){
								topage = "stock/stockSell";
							}else{
								topage = "stock/stockSell";
							}
							appUtils.pageInit("stock/stockHolding",topage,{"stockCode":stock_code});//携带的参数就是当前的股票的代码
							e.stopPropagation();
						},"click");
					//当前表示的就是没有查询到数据
					}else{ 
						$(pageId+".no_data").show();
					}
				//当前表示的就是请求服务层出现了问题
				}else{
					layerUtils.iAlert(data.error_info);
				}
			}else{
				layerUtils.iAlert("查询失败");
			}
			
		},{"isLastReq":true,"isShowWait":false,"isShowOverLay":false});
	}
	
	/**
	 * 定时刷新持仓
	 */
	function refreshNow(tMarket, _pageId){
		// 调用行情接口，获取行情现价 
		getNowPriceForTrade(function(now_price_json){
			for (var i in now_price_json){
				// 现价
				var now_price = now_price_json[i],
					$target = $(_pageId + " #" + i),
					// 当前持有数量
					cost_amount = $target.attr("data-mkt_qty"),
					// 当前成本
					cost_balance = $target.attr("data-cost_balance");
				// 现价
				$(_pageId + " #xianj_" + i).html(now_price);
				// 市值 = 现价 * 数量
				$(_pageId + " #shiz_" + i).html(Number(now_price * cost_amount).toFixed(2));
				// 盈亏 = 行情现价 * 数量 - 当前成本
				var yink = Number(now_price * cost_amount - cost_balance).toFixed(2),
				// 比例 = （行情现价*数量-当前成本）/当前成本
					bil = Number((now_price * cost_amount - cost_balance)/cost_balance * 100).toFixed(2),
					css_yb = "";
				if (yink > 0){
					css_yb = "ared";
				} else if (yink < 0){
					css_yb = "agreen";
				}
				$(_pageId + " #yingk_" + i).html(yink > 0 ? "+" + yink : yink).attr("class", css_yb);
				$(_pageId + " #bil_" + i).html(bil + "%").attr("class", css_yb);
			}
		}, tMarket);
	}
	
	/**
	 * 证券持仓HTML生成
	 */
	function queryPositionHTML_stock(element){
		var price_digit = 2;
		var css = "";
		var float_yk = Number(element.float_yk);//浮动盈亏
		if(float_yk>0){
			float_yk = "+" + float_yk.toFixed(2);
			css = "ared";
		}else if(float_yk<0){
			css = "agreen";
			float_yk = float_yk.toFixed(2);
		}
		
       var eleHtml = "";
       eleHtml += "<tr id="+element.stock_code +" data-mkt_qty="+element.cost_amount+" data-cost_balance="+element.cost_balance+">" +
       	"<td><strong>"+element.stock_name+"</strong><small>"+element.stock_code +"</small></td>"+
  		"<td>"+Number(element.stock_balance).toFixed(0)+"<br/>"+element.enable_amount+"</td>" +
  		"<td><span id='shiz_"+element.stock_code+"'>"+Number(element.market_value).toFixed(2)+"</span><span>"+element.cost_amount+ "</span></td>"+
  		"<td><span id='yingk_"+element.stock_code+"' class='"+css+"'>"+float_yk+"</span><span id='bil_"+element.stock_code+"' class='"+css+"'>"+element.float_yk_per+"%</span></td>" +
  		"<td><span>"+element.cost_price+"</span><span id='xianj_"+element.stock_code+"'>"+element.last_price+ "</span></td>"+
  		"</tr>";
       return eleHtml;
	}
	
	
	
	
	
	
	
	
	/*==========================================信用交易持仓公共方法================================================ */
	/**
	 * 信用交易证券持仓查询
	 */
	function queryHolding(pageId,whichPage){
		 return function() {//为了解决定时器不能传参数的问题	 
				var userInfo = JSON.parse(appUtils.getSStorageInfo("credit_userInfo"));
				var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
				var branch_no  = userInfo.branch_no;	//分支机构
				var fund_account = userInfo.fund_account;	//资产账户
				var cust_code = userInfo.cust_code;	//客户代码
				var sessionid= userInfo.session_id;
				var stock_account ="";
				var stock_code = "";
				var exchange_type = "";
				var param={
						"entrust_way":entrust_way,
						"branch_no":branch_no,
						"fund_account":fund_account,
						"cust_code":cust_code,
						"sessionid":sessionid,
						"stock_account":stock_account,
						"stock_code":stock_code,
						"exchange_type":exchange_type
				};
				service_credit.cc_query(param,function(data){
					if (data && data != "undefined") {
						if(data.error_no == 0){
							$(pageId+".no_data").hide();
							var results = data.results;
							var headTr = "<tr><th scope=\"col\">证券</br>代码</th> <th scope=\"col\">担保可卖</br>可卖</th><th scope=\"col\">市值</br>持仓</th><th scope=\"col\">盈亏</br>比例</th><th scope=\"col\">成本</br>现价</th></tr>";
							$(pageId+".fund_table .ce_table thead").html(headTr);
							var data = "";
							if(results && results.length>0){
								//$(pageId+".fund_table #switchTicketOrContract").height("225px");
								var total_cost_balance = 0;//持仓数量X持仓成本
								var total_last_price = 0; //持仓数量X最新价
								var float_yk = 0; //浮动盈亏
								for (var i=0;i<results.length;i++){ 
									 float_yk += Number(results[i].float_yk);//计数总浮动盈亏
									 total_cost_balance += Number(results[i].cost_amount)*Number(results[i].cost_price);
									 total_last_price += Number(results[i].cost_amount)*Number(results[i].last_price);
									 data += queryPositionHTML_credit(results[i]);
								}
								$(pageId+".fund_table .ce_table tbody").html(data);
								
								//添加总浮动盈亏
								var css = "";
								//当浮动盈亏,浮动盈亏比例大于0 时,在前面添加一个 "+" 
								if(float_yk > 0){
									float_yk = "+" + float_yk.toFixed(2);
									css = "ared";
								}else if(float_yk < 0){
									float_yk = "" + float_yk.toFixed(2);
									css = "agreen";
								}else{
									float_yk = "" + float_yk.toFixed(2);
									css = "";
								}
								$(pageId+".hold_table tr:eq(0) td:eq(1) strong").text(float_yk).attr("class",css);//盈亏
								//卖出事件
								appUtils.bindEvent($(pageId+".fund_table .ce_table tr:gt(0)"), function(e){
									var stock_code = $(this).attr("id");
									$(pageId+".input_select .select_box ul").hide();
									var topage = "";
									//点击卖出,跳转到买卖页面.
									if(whichPage==1){
										topage = "credit/order/ordinaryToBuy"; //普通买入
									}else if(whichPage==2){
										topage = "credit/order/ordinaryToSell"; //普通卖出
									}else if(whichPage==3){
										topage = "credit/order/sellTicketsRepayment"; //卖券还款
									}else if(whichPage==4){
										topage = "credit/order/buyTicketsRepay"; //买券还券
									}else if(whichPage==5){
										topage = "credit/order/financingToBuy"; //融资买入
									}else if(whichPage==6){
										topage = "credit/order/financingToSell"; //融券卖出
									}
									appUtils.pageInit("",topage,{"stockCode":stock_code,"isHold":false});
									e.stopPropagation();
								},"click");
							}else{ 
								$(pageId+".fund_table #switchTicketOrContract").height("55px");
								$(pageId+".fund_table .ce_table").html(data);
								$(pageId+".no_data").show();
							}
						}
						else{
							layerUtils.iAlert(data.error_info);
						}
					}
					else{
						  layerUtils.iAlert("查询失败");
					}
				},{"isLastReq":true,"isShowWait":false,"isShowOverLay":false});
		 };
	}
	
	/**
	 * 融资融券未了结合约查询并展示        ------------------------张金平添加
	 */
	function queryHoldingNotDo(pageId,whichPage,stockCode){
		 return function() {//为了解决定时器不能传参数的问题	 
				var userInfo = JSON.parse(appUtils.getSStorageInfo("credit_userInfo"));
				var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
				var branch_no  = userInfo.branch_no;	//分支机构
				var fund_account = userInfo.fund_account;	//资产账户
				var cust_code = userInfo.cust_code;	//客户代码
				var op_station = "";//这个不知道在那取得的       尚未解决    
				var sessionid= userInfo.session_id;
				var stock_account ="";
				var stock_code = "";
				var exchange_type = "";
				var compact_type = "0";//0是融资 1是融券
				var query_type = "0";//0是未了结  1是当日已了结
				var param={
						"entrust_way":entrust_way,
						"branch_no":branch_no,
						"fund_account":fund_account,
						"cust_code":cust_code,
						"op_station":op_station,
						"sessionid":sessionid,
						"stock_account":stock_account,
						"stock_code":stock_code,
						"exchange_type":exchange_type,
						"compact_type":compact_type,
						"query_type":query_type
				};
				//service_credit.openInterest_Query(param,function(data){
				service_credit.contractmx_query(param,function(data){
					if (data && data != "undefined") {
						if(data.error_no == 0){
							$(pageId+".no_data").hide();
							var results = data.results;
							var headTr = "<tr><th scope=\"col\" >&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</th><th>开仓日期</br>到期日期</th> <th scope=\"col\">合约编号</br>类型</th><th scope=\"col\">证券名称</br>代码</th><th scope=\"col\">待偿金额</th></tr>";
							$(pageId+".fund_table .ce_table thead").html(headTr);
							var data = "";
							if(results && results.length>0){
								//$(_pageId+".fund_table #switchTicketOrContract").height("162px");
								var float_yk = 0; //浮动盈亏
								for (var i=0;i<results.length;i++){ 
							        data+="<tr id="+results[i].stock_code +">";
							        data+="<td class='input_check' data_select_info="+results[i].compact_id+" init_date="+results[i].open_date+" exchange_type_hy="+results[i].exchange_type+" contractName="+results[i].stock_name+"></td><td>"+results[i].open_date +"<br/>"+results[i].ret_end_date +"</td>";
							        if(results[i].compact_type==0){
							        	data+="<td>"+results[i].compact_id +"<br/>融资</td>";
							        }else{
							        	data+="<td>"+results[i].compact_id +"<br/>融券</td>";
							        }
							        data+="<td>"+results[i].stock_name +"<br/>"+results[i].stock_code +"</td>";
							        data+="<td>"+Number(results[i].left_amt).toFixed(2)+"</td>";
							        data+="</tr>";
								}
								$(pageId+".fund_table .ce_table tbody").html(data);
								//卖出事件
								appUtils.bindEvent($(pageId+".fund_table .ce_table tr:gt(0)"), function(e){
									var stock_code = $(this).attr("id");
									var topage = "";
									topage = "credit/order/sellTicketsRepayment"; //卖券还款
									var $this = $(this),
									$check = $this.find(".input_check"),
									is_click = $check.hasClass("checked");
									var compact_id="";//合约编号
									var contractName="";//合约名字
									var exchangeTypeHy="";//合约市场
									if (is_click){
										compact_id="";
										contractName="";
										exchangeTypeHy="";
										$check.removeClass("checked");
										$this.css("background-color", "#ffffff");
									} else {
										$check.addClass("checked");
										$this.css("background-color", "#eff7ff");
										$this.siblings().css("background-color", "#ffffff");
										$this.siblings().find(".input_check").removeClass("checked");
										compact_id=$check.attr("data_select_info");
										contractName=$check.attr("contractName");
										init_date = $check.attr("init_date");
										exchangeTypeHy = $check.attr("exchange_type_hy");
									}
									appUtils.pageInit("",topage,{"isHold":true,"compact_id":compact_id,"contractName":contractName,"exchangeTypeHy":exchangeTypeHy,"init_date":init_date,"stockCode":stockCode});
									//$(_pageId + " #stockCode").val($this.attr("id")).trigger("input");
									e.stopPropagation();
								},"click");
							}else{ 
								$(pageId+".fund_table .ce_table thead").html(headTr);
								$(pageId+".no_data").show();
							}
						}
						else{
							layerUtils.iAlert(data.error_info);
						}
					}
					else{
						  layerUtils.iAlert("查询失败");
					}
				},{"isLastReq":true,"isShowWait":false,"isShowOverLay":false});
		 };
	}
	/**
	 * 证券持仓HTML生成
	 */
	function queryPositionHTML_credit(element){
		var css = "";
		var float_yk = Number(element.float_yk);//浮动盈亏
		var float_yk_per = element.float_yk_per;//浮动盈亏%
		if(float_yk>0){
			float_yk = "+" + float_yk.toFixed(2);
			css = "ared";
		}else if(float_yk<0){
			css = "agreen";
			float_yk = float_yk.toFixed(2);
		}
        var eleHtml = "";
        eleHtml+="<tr id="+element.stock_code +">";
        eleHtml+="<td><strong>"+element.stock_name +"</strong><small>"+element.stock_code +"</small></td>";
        eleHtml+="<td>"+Number(element.ownshare_avl)+"<br/>"+Number(element.enable_amount)+"</td>";
        eleHtml+="<td>"+Number(element.market_value).toFixed(2)+"<br/>"+element.cost_amount+"</td>";
        eleHtml+="<td><span class=\""+css+"\">"+float_yk+"</span><span class=\""+css+"\">"+float_yk_per+ "</span></td>";
        eleHtml+="<td>"+element.cost_price+"<br/>"+Number(element.last_price).toFixed(2)+"</td>";
        eleHtml+="</tr>";
        return eleHtml;
	}
	/*==========================================港股持仓公共方法================================================ */
	 /**
	 * 港股通证券持仓查询
	 */
	function queryPosition_ggt(pageId,whichPage){
		 return function() {//为了解决定时器不能传参数的问题	 
			var userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
			var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
			var branch_no = userInfo.branch_no;	
			var fund_account = userInfo.fund_account;
			var cust_code = userInfo.cust_code;//关联资产账户标志
			var sessionid = userInfo.session_id;
			var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "cust_code":cust_code,
			    "sessionid":sessionid
			};
			service_ggt.queryHolding_ggt(param,function(data){
				if (data && data != "undefined") {
					if(data.error_no == 0){
						$(pageId+".no_data").hide();
						var results = data.results;
						if(results && results.length>0){
							var total_cost_balance = 0;//持仓数量X持仓成本
							var total_last_price = 0; //持仓数量X最新价
							var data = "<tr><th scope=\"col\">证券/市值</th> <th scope=\"col\">盈亏</th><th scope=\"col\">持仓/可用</th><th scope=\"col\">成本/现价</th></tr>";
							var float_yk = 0; //浮动盈亏
							for (var i=0;i<results.length;i++){ 
								 float_yk += Number(results[i].float_yk);//计数总浮动盈亏
								 total_cost_balance += Number(results[i].cost_amount)*Number(results[i].cost_price);
								 total_last_price += Number(results[i].cost_amount)*Number(results[i].last_price);
								 data += queryPositionHTML_ggt(results[i]);
							}
							$(pageId+".fund_table .ce_table").html(data);
							
							//添加总浮动盈亏
							var css = "";
							//当浮动盈亏,浮动盈亏比例大于0 时,在前面添加一个 "+" 
							if(float_yk > 0){
								float_yk = "+" + float_yk.toFixed(2);
								css = "ared";
							}else if(float_yk < 0){
								float_yk = "" + float_yk.toFixed(2);
								css = "agreen";
							}else{
								float_yk = "" + float_yk.toFixed(2);
								css = "";
							}
							$(pageId+".hold_table tr:eq(0) td:eq(1) strong").text(float_yk).attr("class",css);//盈亏
							//卖出事件
							appUtils.bindEvent($(pageId+".fund_table .ce_table tr"), function(e){
								var stock_code = $(this).attr("id");
								var topage = "";
								//点击卖出,跳转到买卖页面.
								if(whichPage==1){
									topage = "ggt/ggtBuy";
								}else if(whichPage==2){
									topage = "ggt/ggtSell";
								}else{
									topage = "ggt/ggtSell";
								}
								appUtils.pageInit("ggt/ggtHolding",topage,{"stockCode":stock_code});
								e.stopPropagation();
							},"click");
						}else{  
							$(pageId+".no_data").show();
						}
					}
					else{
						layerUtils.iAlert(data.error_info);
					}
				}
				else{
					  layerUtils.iAlert("查询失败");
				}
			},{"isLastReq":true,"isShowWait":false,"isShowOverLay":false});
		 };
	}
	/**
	 * 证券持仓HTML生成
	 */
	function queryPositionHTML_ggt(element){
		var css = "";
		var float_yk = Number(element.float_yk);//浮动盈亏
		var float_yk_per = Number(element.float_yk_per);//浮动盈亏%
		if(float_yk>0){
			float_yk = "+" + float_yk.toFixed(2);
			float_yk_per = "+" + float_yk_per.toFixed(2);
			css = "ared";
		}else if(float_yk<0){
			css = "agreen";
		}
        var eleHtml = "";
        eleHtml+="<tr id="+element.stock_code +">";
        eleHtml+="<td><strong>"+element.stock_name +"</strong><small>"+element.market_value +"</small></td>";
        eleHtml+="<td><span class=\""+css+"\">"+float_yk+"</span><span class=\""+css+"\">"+float_yk_per+"%</span></td>";
        eleHtml+="<td>"+Number(element.hold_amount)+"<br/>"+Number(element.enable_amount)+"</td>";
        eleHtml+="<td>"+Number(element.cost_balance)+"<br/>"+Number(element.last_price)+"</td>";
        eleHtml+="</tr>";
        return eleHtml;
	}
	
	/*==========================================普通交易划转登录公共方法================================================ */
	/**
	 * 点击划转获取客户登陆信息（每次点击头部的按钮都要判断当前的用户是否是登录状态，如果是登录状态，直接跳转到对应的点击的页面）
	 */
	function isAStockLogin(){
		var stock_userInfo = JSON.parse(appUtils.getSStorageInfo("creStock_userInfo"));
		var credit_userInfo = JSON.parse(appUtils.getSStorageInfo("credit_userInfo"));
		if(credit_userInfo && stock_userInfo && stock_userInfo.cust_code == credit_userInfo.cust_code){
			var curPageCode = appUtils.getSStorageInfo("_curPageCode");
			appUtils.pageInit(curPageCode, "credit/transferred/collateralTransfer");
		}else{
			var credit_userInfo = JSON.parse(appUtils.getSStorageInfo("credit_userInfo"));
			var pdwBox = "";
			pdwBox += "<div class='cover_layer' id='inputPopLayer'>";
			pdwBox +=	"<div class='pop_confirm2' style='margin-top: -104px;'>";
			pdwBox += 		"<div style=\"  height: 0.36rem;line-height: 0.36rem;border-bottom: 1px solid #CBCBCB;\">";
			pdwBox +=			"<h3 style=\"color: #1199EE;\">登录普通交易</h3>";
			pdwBox += 		"</div>";
			pdwBox +=		"<div class='pop_main' style='border-bottom: 1px solid #CBCBCB;'>";
			pdwBox +=			"<div class='input_text2 mt10' style='border:none;'>";
			pdwBox +=				"<span style='  text-align: left;margin-left: 10px;'>客户号：</span>";
			pdwBox +=				"<div style='font-size: 16px;'id='custNo'>"+credit_userInfo.cust_code+"</div>";
			pdwBox +=			"</div>";
			pdwBox +=			"<div class='input_text2 mt10' style='padding-right: 20px;border:none;'>";
			pdwBox +=				"<span style='  text-align: left;margin-left: 10px;'>密&nbsp;&nbsp;&nbsp;&nbsp;码:</span>";
			pdwBox +=				"<input type='password' class='input_custom2' id='pwdInput' placeholder='请输入普通交易密码' maxlength='120'>"
			pdwBox +=			"</div>";
			pdwBox +=		 "</div>";
			pdwBox +=		 "<div class='btn' style='height: 45px; padding: 0px;'>";
			pdwBox +=			 "<a href='javascript:void(0)' id='confirm' style='height: 45px; line-height: 45px; width: 50%;background:rgb(242, 242, 242);color: #1199EE;'>确定</a>";
			pdwBox +=			 "<a href='javascript:void(0)' id='cancel' style='height: 45px; line-height: 45px; width: 50%; color: rgb(51, 51, 51); background: white;'>取消</a>";
			pdwBox +=		 "</div>";
			pdwBox +=	 "</div>";
			pdwBox += "</div>";
			$("body").append(pdwBox);
			setTimeout(triggerClick,500);
			//取消按钮
			appUtils.bindEvent($("#cancel"), function(e){
				$(" #inputPopLayer").remove();
				e.stopPropagation();
			},"click");
			//确定按钮
			appUtils.bindEvent($("#confirm"), function(e){
				stockALogin();
				e.stopPropagation();
			},"click");
			//密码输入框调用原生键盘
			appUtils.bindEvent($("#pwdInput"),function(e){
				external.callMessage({"moduleName":"trade","funcNo": "50210", "pageId":"inputPopLayer", "eleId":"pwdInput", "doneLable":"done", "keyboardType":"4"});
				e.stopPropagation();
			},"click");
			//失去焦点关闭原生键盘
			appUtils.bindEvent($("#pwdInput"),function(e){
				external.callMessage({"moduleName":"trade","funcNo": "50211"});
				e.stopPropagation();
			},"blur");
		}

	}
	/**
	 * 模拟点击
	 */
	function triggerClick(){
		$("#pwdInput").trigger("click");
		$("#pwdInput").focus();
	}
	/**
	 * 普通A股登陆
	 */
	function stockALogin(){
		if(!checkInput()){
			return false;
		};
		var custNo = $("#custNo").text();
		var pwd = $("#pwdInput").val();
		//密码加密
		service_common.getKey({},function(data){
			if(data.error_no != "0"){
				layerUtils.iLoading(false);
				layerUtils.iAlert(data.error_info);
				return false;
			}else{
				//参数固定,是密码加密的参数
				var modulus = data.results[0].modulus;
				var publicExponent = data.results[0].publicExponent;
				var endecryptUtils = require("endecryptUtils");
				pwd = endecryptUtils.rsaEncrypt(modulus,publicExponent,$.trim(pwd));
				loginFuc(); // 调用登录接口
			}
		},{"isLastReq":false});
		var loginFuc = function(){
			var loginParam = {
    				"entrust_way" : global.entrust_way, // 委托方式  在configuration配置   // 委托方式
    				"branch_no" : "",  // 营业部编号
    				"input_type" : "5",  // 账号类型
    				"input_content" : custNo,  // 登录账号
    				"password" : pwd,  // 交易密码
    				"ticket" : '',  // 图片验证码
    				"mobileKey" : '',  // 验证码的 mobileKey
    				"ticketFlag" : "0", // 0 不需要验证码 1 需要验证码
    				"content_type" : ""  // 客户标识类型
    		};
    	service_credit.goodsSwitchTradeLogin(loginParam,function(data){
			if(data.error_no != 0){
					$("#pwdInput").val("");
					layerUtils.iLoading(false);
					layerUtils.iAlert(data.error_info);
					return false;
			}else{
				if(data.results[0]){
					$(" #inputPopLayer").remove();
					var userInfo = data.results[0];
//					for(var i =0;i<data.results.length;i++){
//						if(data.results[i].secuidtype == "0" &&	data.results[i].exchange_type == "2"){
//							var HAuserInfo = data.results[i];
//						}else if(data.results[i].secuidtype == "0" &&	data.results[i].exchange_type == "0"){
//							var SAuserInfo = data.results[i];
//						}
//					}
					userInfo.password = pwd; // 保存交易密码
//					HAuserInfo.password = pwd; // 保存交易密码
//					SAuserInfo.password = pwd; // 保存交易密码
					appUtils.setSStorageInfo("stock_userInfo",JSON.stringify(userInfo));
//					appUtils.setSStorageInfo("HAstock_userInfo",JSON.stringify(HAuserInfo));
//					appUtils.setSStorageInfo("SZstock_userInfo",JSON.stringify(SAuserInfo));
					var curPageCode = $("body #content div.page[data-display=block]").attr("id").replaceAll("_","/");
					appUtils.pageInit(curPageCode, "credit/transferred/collateralTransfer");
				}else{
					layerUtils.iAlert("账户信息不足");
					return false;
				}
			}
    	});
	  }
	}	
	/**
	 * 校验登录账号,交易密码,手机验证码
	 */
	function checkInput(){
		if(validata.isEmpty($("#custNo").text())){
			layerUtils.iMsg(-1,"登录账号不能为空");
			return false;
		}
		if(validata.isEmpty($("#pwdInput").val())){
			layerUtils.iMsg(-1,"密码不能为空");
			return false;
		}else if($("#pwdInput").val().length != 6){
			layerUtils.iMsg(-1,"请输入6位密码");
			return false;
		}
		return true;
	}

	/* *******************/
	/**
	 * 选择确认框，只带"确认"和"取消"按钮
	 * @param conMsg 提示内容
	 * @param yesFunc 确认按钮的回调，可不传，默认只是去掉提示层
	 * @param noFunc 取消按钮的回调，可不传，默认只是去掉提示层
	 * 	callback参数支持3种形式：iConfirm("conMsg",funcName);、iConfirm("conMsg",function () {});、iConfirm("conMsg",function funcName() {});
	 * @param yesBtnWords 确认按钮的文字，可不传，默认为“确定”
	 * @param noBtnWords 取消按钮的文字，可不传，默认为“取消”
	 */
	function btnConfirm(pageId,conMsg, yesFunc, noFunc, yesBtnWords, noBtnWords){

		var viewContent = '<div class="pop_tip notice" id="pop_tip_confirm">';
		viewContent += '<span class="icon"></span>';
		viewContent += '<p><span style="display:block;text-align:center;padding:0 16px;font-size:16px;word-break:break-all;">';
		viewContent += conMsg;
		viewContent += '</span>';
		viewContent += '</p>';
		viewContent += '<div class="btn">';
		viewContent += '<a href="javascript:void(0);" id="pop_tip_confirm_yes">'+(yesBtnWords||"确 定")+'</a>';
		viewContent += '<a href="javascript:void(0);" id="pop_tip_confirm_no">'+(noBtnWords||"取消")+'</a>';
		viewContent += '</div></div>';
		$(pageId).append(viewContent);
	}
	
	/**
	 * 获取行情现价
	 */
	function getNowPriceForTrade(backFunc, tMarket){
		var param = {
				"stock_list" : tMarket
		};
		service_hq.getStockNowPrice(param, function(data){
			if (data){
				var errorNo = data.errorNo;
				if (errorNo == 0){
					var results = data.results,
						re_len = results.length,
						codetype = {},
						now_json = {};
					for (var i = 0; i < re_len; i++){
						var item = results[i],
//							stkType = item[10],//行情类别
//							keyTwonum = [0, 1, 2, 7, 9, 15, 18, 25, 26, 27],//保留两位
//							step_flag = $.inArray(stkType, keyTwonum),
						    now_price = item[2];
//							now_price = price.toFixed(3);
						now_json[""+item[1]+""] = ""+now_price+"";
						codetype[""+item[1]+""] = ""+item[10]+"";
					}
					backFunc(now_json,codetype);
				}
			}
		}, {"isLastReq": false, "isShowWait": false});
	}
	
	function clearTi(){
		if (position_timer) {
	         window.clearInterval(position_timer);
	         position_timer = null;
	     }
	}

    var base = {
    	"queryPosition":queryPosition,
    	"queryPosition_ggt":queryPosition_ggt,
    	"queryHolding":queryHolding,
    	"queryHoldingNotDo":queryHoldingNotDo,
    	"isAStockLogin":isAStockLogin,
    	"btnConfirm":btnConfirm,
    	"getNowPriceForTrade": getNowPriceForTrade,
    	"clearTi": clearTi
    };

    module.exports = base;
});