/**
 * 买入卖出操作
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var common = require("common");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var validatorUtil = require("validatorUtil");
	var layerUtils = require("layerUtils");
	var service_stock = require("service_stock");
	var service_hq = require("service_hq");
	var external = require("external");
    var userInfo = null;  //账号信息
	var price_step = 0.01; //步长
	var price_digit = 2; //小数点位数
	var fifthOrder_timer = null; //五档定时器
	var position_timer = null; //持仓定时器
	var lotsOf = 100; //每手数量
	var _stockAccount="";
	var _market ="";
	var commonFunc = require("commonFunc");
	
    /**
     * 初始化
     */
	function init(){common.hideBottomBar();

        var height_table = $(window).height() - $(_pageId+".header").height() - $(_pageId+".tab_nav").height() - $(_pageId+".trade_main").height()-25;
        $(_pageId+".fund_table").height(height_table);   //给持仓数据添加高度
		userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		var stockCode = appUtils.getPageParam("stockCode");
		//查询个股行情
		if(stockCode){
			$(_pageId+"#stockCode").val(stockCode);
			getStockInfo(stockCode);
		}
		if(position_timer != null ) {
	        window.clearInterval(position_timer);
	    }
		window.setTimeout(commonFunc.queryPosition(_pageId,1),100);
        position_timer = window.setInterval(commonFunc.queryPosition(_pageId,1), 10000);
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId+".top_title .icon_back"), function(e){
			appUtils.pageInit("stock/stockBuy","account/index",{});
			e.stopPropagation();
		});
		//股票代码输入框监听
		appUtils.bindEvent($(_pageId+"#stockCode"), function(e){
			var stockCode = $(this).val();
			if(stockCode.length == 6){
				getStockInfo(stockCode);
			}else if(stockCode.length > 6){
				$(this).val(stockCode.substring(0,6));
			}else if(stockCode.length < 6){
				clearBuyMsg();
			}
			$(_pageId+".trade_form .input_box .stat").hide();
			e.stopPropagation();
		},"keyup");
		//股票代码输入框调用原生键盘
		appUtils.bindEvent($(_pageId+"#stockCode"),function(e){
			window.keyBoardInputFunction = function(){ //原生回调
				var stockCode = $(_pageId+"#stockCode").val();
				if(stockCode.length == 6){
					getStockInfo(stockCode);
				}else if(stockCode.length > 6){
					$(this).val(stockCode.substring(0,6));
				}else if(stockCode.length < 6){
					clearBuyMsg();
				}
				$(_pageId+".trade_form .input_box .stat").hide();
			};
			external.callMessage({"moduleName":"common","source":"trade", "funcNo": "50016", "pageId":"stock_stockBuy", "eleId":"stockCode", "doneLable":"done", "type":"2"});
			e.stopPropagation();
		},"click");
		//失去焦点关闭原生键盘
		appUtils.bindEvent($(_pageId+"#stockCode"),function(e){
			external.callMessage({"moduleName":"common", "funcNo": "50015"});
			e.stopPropagation();
		},"blur");
		//股票数量输入框
		appUtils.bindEvent($(_pageId+"#stockNum"), function(e){
			totalValue();
			e.stopPropagation();
		},"input");
		//价格输入框
		appUtils.bindEvent($(_pageId+"#stockPrice"), function(e){
			totalValue();
			e.stopPropagation();
		},"input");
		//增加价格
		appUtils.bindEvent($(_pageId+".trade_main .input_box .add"),function(e){
			var stockCode = $(_pageId + "#stockCode").val();
			if(stockCode && stockCode.length>0){
				var curPrice = $(_pageId+"#stockPrice").val();
				var up_stop = $(_pageId+"#up_stop").text();
				if(curPrice == "" || !validatorUtil.isNumberFloat(curPrice)){
					$(_pageId+"#stockPrice").val("");
					return false;;
				}
				curPrice = Number(curPrice);  
				up_stop = Number(up_stop);  
				if(curPrice >= 0&&curPrice<999999999){
					if(curPrice<up_stop){
						curPrice = (parseFloat(curPrice)+parseFloat(price_step)).toFixed(price_digit);
						$(_pageId+"#stockPrice").val(curPrice);
					}else{
						$(_pageId+"#stockPrice").val(up_stop);
					}
				}
			}else{
				layerUtils.iAlert("请先输入合法的股票代码");
			}
			totalValue();
			e.stopPropagation();
		});
		//减少价格
		appUtils.bindEvent($(_pageId+".trade_main .input_box .less"),function(e){
			var stockCode = $(_pageId + "#stockCode").val();
			if(stockCode && stockCode.length>0){
				var curPrice = $(_pageId+"#stockPrice").val();
				var down_stop = $(_pageId+"#down_stop").text();
				if(curPrice == "" || !validatorUtil.isNumberFloat(curPrice)){
					$(_pageId+"#stockPrice").val("");
					return false;;
				}
				curPrice = Number(curPrice);  
				down_stop = Number(down_stop);  
				if(curPrice-price_step >= 0){
					if(curPrice>down_stop){
						curPrice=(parseFloat(curPrice)-parseFloat(price_step)).toFixed(price_digit);
						$(_pageId+"#stockPrice").val(curPrice);
					}else{
						$(_pageId+"#stockPrice").val(down_stop);
					}
				}
			}else{
				layerUtils.iAlert("请先输入合法的股票代码");
			}
			totalValue();
			e.stopPropagation();
		});
		//五档买卖盘联动
		appUtils.bindEvent($(_pageId+".five_box ul li"),function(e){
			var curPrice=$(this).find("span").text();
			if(curPrice && curPrice!="--"){
				$(this).siblings().removeClass("active");
				$(this).parent().siblings().find("li").removeClass("active");
				$(this).addClass("active");
				curPrice = isNaN(Number(curPrice)) ? 0 : curPrice;
				$(_pageId+"#stockPrice").val(curPrice);
			}
			totalValue();
			e.stopPropagation();
		});
		//下单
		appUtils.bindEvent($(_pageId+"#submitOrder"),function(e){
			vailSubmitOrder();
			e.stopPropagation();
		});
		//点击其他位置去掉五档点击效果
		appUtils.bindEvent($(_pageId),function(e){
			$(_pageId+".five_box ul li").removeClass("active");
			e.stopPropagation();
		});
		
	}
    
	//计算当前总值
	function totalValue(){
		var stockNum = $(_pageId+"#stockNum").val();
		var stockCode = $(_pageId+"#stockCode").val();
		var stockPrice = $(_pageId+"#stockPrice").val();
		if(stockCode && validatorUtil.isNumberFloat(stockPrice) && validatorUtil.isNumeric(stockNum)){
			$(_pageId+".trade_form .input_box .stat").show();
			$(_pageId+".trade_form .input_box .stat span").text("总值"+common.numToMoneyType(""+(stockPrice*stockNum).toFixed(2)));
		}else{
			$(_pageId+".trade_form .input_box .stat").hide();
		}
	}
	
	/**
	 * 获取股票列表
	 * */
	function getStockList(stockStr){
		if(stockStr != ""){
			var stockStrParam = {
				"stockStr" : stockStr
			};
			service_hq.getStockList(stockStrParam,getStockListCallBack);
		}	
	}
    //获取股票列表返回
	function getStockListCallBack(data){
		if(data.errorNo == 0){
			$(_pageId+" .mod_stock_item #stock_list").html("");
			var results = data.results;
			//显示股票列表
			if(results && results.length > 0){
				var list = "<ul style=\"z-index: 9999; position: relative;\">";
				for(var i = 0;i<results.length;i++){
					list +="<li><span>"+results[i][0]+"</span><span>"+results[i][2]+"</span></li>";
				}
				list+="</ul>";
				$(_pageId+" .mod_stock_item #stock_list").html(list);
				$(_pageId+" .mod_stock_item #stock_list").show();
				//点击列表中一只股票,查询信息
				appUtils.bindEvent($(_pageId+" .mod_stock_item #stock_list ul li"),function(e){
					//关闭下拉列表
					$(_pageId+" .mod_stock_item #stock_list").hide();
					getStockInfo($(this).find("span:eq(1)").text());
				});
			}else{
				$(_pageId+" .mod_stock_item #stock_list").hide();
			}
		}else{
			layerUtils.iAlert("获取股票列表失败");
		}
	}
	
	/**
	 * 获取股票个股行情
	 * */
	function getStockInfo(stockCode){
		if(stockCode){
			//resetBuyForm();
			if (fifthOrder_timer != null ) {
		        window.clearInterval(fifthOrder_timer);
		    }
			var stockStrParam = {
				"code_list" : stockCode
			};
			//查询个股行情
			service_hq.getStockInfo(stockStrParam,getStockInfoCallBack);
			queryMaxAmount($(_pageId+"#stockCode").val());
		}
	}
	
	/**
	 * 获取股票个股行情返回  （行情接口 20010）
	 * */
	function getStockInfoCallBack(data){
		if(data.errorNo == 0){
			var results = data.results;
			if(results && results.length>0){
				//$(_pageId+".mod_stock_item #stock_list").hide();
				$(_pageId+"#stockCode").val(""); // 每次修改股票代码，那么将初始值置为0
				var price = results[0][2] ? results[0][2]:results[0][6];
				var stkType = results[0][10];    //行情类别
				var stockVal = results[0][1];    //股票代码
				var stock_arr = [0,1,2,9,10,18]; //股票集合
				var fund_arr = [3,4,11,12,19,20];//基金集合
				var bond_arr = [6,14];    //债券集合
				var warrant_arr = [5,13]; //权证集合
				/*
				 * 上交所规定申报价格最小变动单位： 
					① A股、债券交易和债券买断式回购交易的为0.01元人民币
					② 基金、权证交易为0.001元人民币
					③ B股交易为0.001美元
					④ 债券质押式回购交易为0.005元人民币
					
					深交所规定申报价格最小变动单位：    
					① A股交易的申报价格最小变动单位为0.01元人民币
					② 基金、债券、债券质押式回购交易的申报价格最小变动单位为0.001元人民币
					③ B股交易为0.01港元。
					Fc原人 17:42:39 
					所有的ETF、lof都是0.001
				 * */
				var price_step_const = [10,12,13,4,6,19,20,3,11,16];  //最小变动单位为0.001的
				var step_flag = $.inArray(stkType, price_step_const);
				//var num = 100; 	//买卖数量变动值
				// 上海国债逆回购
				if(stockVal.substring(0,3) == "204"){
					price_step = 0.005;
					price_digit = 3;
					lotsOf = 1000;
				}

               if(step_flag == -1){ // 否则浮动为0.01
					price_step = 0.01;
					price_digit = 2;
				}else{  // 变动价格为0.001
					price_step = 0.001;
					price_digit = 3;
				}
               
				// 判断是否为债券
		       if(stkType == 6 || stkType == 14 || stockVal.substring(0,3) == "131"){
		    	   lotsOf = 10;
				}
				var yesterdayClose = results[0][6]; //昨收
				if(typeof yesterdayClose == "undefined" || yesterdayClose == ""){
					yesterdayClose = 0 ;
				}
				
				//涨停和跌停是昨收X1.1 和 X0.9
				var up_stop = (Number(yesterdayClose)*(1+0.1)).toFixed(2);
				var down_stop = (Number(yesterdayClose)*(1-0.1)).toFixed(2);
				//涨停为红色,跌停为绿色
				$(_pageId + "#up_stop").html(up_stop).attr("class","ared");
				$(_pageId + "#down_stop").html(down_stop).attr("class","agreen");
				//证券代码显示  
				$(_pageId + "#stockCode").val(results[0][1]);
				//证券名称显示
				$(_pageId + "#stockName").html(results[0][0]);
				price = price.toFixed(price_digit);
				$(_pageId + "#stockPrice").val(price);
				//保存此股票的市场类型
				//$(_pageId+ " .mod_stock_buy .fl").find("p").attr("id",results[0][9]);
				
				//保存此股票的信息
				var market = results[0][9];
				var stockCode = results[0][1];
				if(typeof market != "undefined" && market != "" && market != null && stockCode.length == "6"){
					var stockMsg = market+":"+stockCode;
					appUtils.setLStorageInfo("stockMsg",stockMsg);
				}
				//股票联动,查询股票信息，最大可卖
				//queryMaxAmount(results[0][0],results[0][1]);
				//股票联动,查询股票信息，最大可买
				//queryBuyAmount(results[0][0],results[0][1],price);
				//调用五档行情
				var stock_list = results[0][9] + ":" + results[0][1];
				window.setTimeout(setFifthOrder(stock_list),100);
				fifthOrder_timer =  window.setInterval(setFifthOrder(stock_list), 10000);//定时刷新
				
			}else{
				$(_pageId+" .mod_stock_item #stock_list").hide();
			}
		}else{
			layerUtils.iAlert(data.error_info);
		}
	}

	//五档买卖盘
	function setFifthOrder(stock_list){
		
		 return function() {//为了解决定时器不能传参数的问题	 
			 if(stock_list){
				var fifthOrder = {
					"stock_list" : stock_list
				};
				service_hq.getStockFiveStep(fifthOrder,callbackFifthOrder,{"isShowWait":false});
			 } 
		 };

	}
	//回调五档买卖盘
	function callbackFifthOrder(data){
		if(data.errorNo == 0){
			var results = data.results;
			if(results && results.length>0){
				var stock_gear = $(_pageId+" .five_box ul li");
				var yesProfit = Number(results[0][26]).toFixed(price_digit);
				/**
				 * 此处逻辑:买卖五档盘也是根据昨收作比较,将受到的五档盘颜色信息保存在集合中,在给五档盘价格赋值和样式
				 */
				//卖五档盘颜色集合
				var soldFiveOrder = [];
				for(var i = 0 ; i < 5 ; i ++){
					var fivePirce = results[0][(i+6)];
					if(yesProfit <fivePirce){
						soldFiveOrder[i] = "ared";
					}else if(yesProfit >fivePirce){
						soldFiveOrder[i] = "agreen";
					}else{
						soldFiveOrder[i] = "";
					}
				}
				//买五档盘颜色集合
				var buyFiveOrder = [];
				for(var i = 0 ; i < 5 ; i ++){
					var fivePirce = results[0][(i+16)];
					if(yesProfit <fivePirce){
						buyFiveOrder[i] = "ared";
					}else if(yesProfit >fivePirce){
						buyFiveOrder[i] = "agreen";
					}else{
						buyFiveOrder[i] = "";
					}
				}
				//卖
				stock_gear.eq(0).find("span").text(Number(results[0][6]).toFixed(price_digit)).attr("class",soldFiveOrder[4]);
				stock_gear.eq(0).find("em").text(overAMillion(results[0][11]));
				stock_gear.eq(1).find("span").text(Number(results[0][7]).toFixed(price_digit)).attr("class",soldFiveOrder[3]);
				stock_gear.eq(1).find("em").text(overAMillion(results[0][12]));
				stock_gear.eq(2).find("span").text(Number(results[0][8]).toFixed(price_digit)).attr("class",soldFiveOrder[2]);
				stock_gear.eq(2).find("em").text(overAMillion(results[0][13]));
				stock_gear.eq(3).find("span").text(Number(results[0][9]).toFixed(price_digit)).attr("class",soldFiveOrder[1]);
				stock_gear.eq(3).find("em").text(overAMillion(results[0][14]));
				stock_gear.eq(4).find("span").text(Number(results[0][10]).toFixed(price_digit)).attr("class",soldFiveOrder[0]);
				stock_gear.eq(4).find("em").text(overAMillion(results[0][15]));
				//买
				stock_gear.eq(5).find("span").text(Number(results[0][16]).toFixed(price_digit)).attr("class",buyFiveOrder[0]);
				stock_gear.eq(5).find("em").text(overAMillion(results[0][21]));
				stock_gear.eq(6).find("span").text(Number(results[0][17]).toFixed(price_digit)).attr("class",buyFiveOrder[1]);
				stock_gear.eq(6).find("em").text(overAMillion(results[0][22]));
				stock_gear.eq(7).find("span").text(Number(results[0][18]).toFixed(price_digit)).attr("class",buyFiveOrder[2]);
				stock_gear.eq(7).find("em").text(overAMillion(results[0][23]));
				stock_gear.eq(8).find("span").text(Number(results[0][19]).toFixed(price_digit)).attr("class",buyFiveOrder[3]);
				stock_gear.eq(8).find("em").text(overAMillion(results[0][24]));
				stock_gear.eq(9).find("span").text(Number(results[0][20]).toFixed(price_digit)).attr("class",buyFiveOrder[4]);
				stock_gear.eq(9).find("em").text(overAMillion(results[0][25]));
			}
		}else{
			layerUtils.iAlert(data.error_info);
		}
	}
	//数量过万改以万为单位
	function overAMillion(num){
		num = Number(num);
		if(num >= 10000){
			num = (num/10000).toFixed(2) + "万";
		}
		return num;
	}
	
	/**
	 * 查询买入可用资金最大可买数量
	 * */
	function queryMaxAmount(stockCode){
		$(_pageId+"#buyLimit").text("--");
		if(!stockCode){
			return false;
		}
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置 
		var branch_no  = userInfo.branch_no;	//分支机构
		var fund_account = userInfo.fund_account;	//资产账户
		var cust_code = userInfo.cust_code;	//客户代码
		var password = userInfo.password;
		var sessionid = userInfo.session_id;
		var entrust_bs = "0";
		var stock_code =stockCode;
		var entrust_price =$(_pageId+"#stockPrice").val();
		var param = {
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"sessionid":sessionid,
				"entrust_bs":entrust_bs,
				"stock_code":stock_code,
				"entrust_price":entrust_price,
	            "newstock_flag":""
			};
		service_stock.queryStockMaxBuy(param,queryMaxAmountCallBack,true,true);
	}

	function queryMaxAmountCallBack(data){
		if(data.error_no == 0){
			var results = data.results;
			if(results.length>0){
				$(_pageId+"#buyLimit").text(Number(results[0].stock_max_amount));
				$(_pageId+"#stockPrice").val(Number(results[0].price).toFixed(price_digit));
				$(_pageId+"#stockName").text(results[0].stock_name);
				_market=results[0].exchange_type;
				_stockAccount=results[0].stock_account;
			}
		}else{
			layerUtils.iAlert(data.error_info);
		}
	}
	/**
	 * 下单验证
	 * */
	function vailSubmitOrder()
	{	
		//验证股票代码输入是否正确
		var buy_stockCode = $(_pageId+"#stockCode").val();
		if(buy_stockCode.length == 0){
			layerUtils.iMsg(-1,"请输入股票代码");
			return false;
		}	
		if(buy_stockCode.length <5){
			layerUtils.iMsg(-1,"股票代码输入错误");
			return false;
		}	
		//验证股票价格输入是否正确
		var now_price = $(_pageId+"#stockPrice").val();
		if($.trim(now_price).length<=0||parseFloat(now_price)<=0){
			layerUtils.iMsg(-1,"请输入买入价格");
			return false;
		}else if(!validatorUtil.isNumberFloat(now_price)){
			layerUtils.iMsg(-1,"请正确输入价格");
			return false;
		}
		//验证最大可买
		var mostBuy = $(_pageId+"#buyLimit").text();
		if($.trim(mostBuy).length<=0||parseFloat(mostBuy)<=0){
			layerUtils.iMsg(-1,"最大可买为0");
			return false;
		}
		//验证买入数量
		var mountBuy = $(_pageId+"#stockNum").val();
		if(!validatorUtil.isNumeric(mountBuy)){
			layerUtils.iMsg(-1,"请输入买入数量");
			return false;
		}else if(mountBuy==0){
			layerUtils.iMsg(-1,"数量必须大于0");
			return false;
		}else if(mountBuy%Number(lotsOf)!=0){
			layerUtils.iMsg(-1,"买入数量应为"+lotsOf+"的倍数");
			return false;
		}else if(parseFloat(buyLimit)<parseFloat(mountBuy)){
			layerUtils.iMsg(-1,"最大可买数量不足");
			return false;
		}
		var secu_acc=null;//股东账户--------一般委托用

//		if(!_stockAccount||_stockAccount==""){
//			layerUtils.iMsg(-1,"没有该股票对应市场的股东卡",2);
//			return false;
//		}
//		// 判断股票、基金、权证卖出规则
//		if(action == " #sell"){
//			var maxNum = $(_pageId+action+" #numMax").attr("value"); // 最大可卖数量
//			/* 股票、基金、权证卖出数量规则一致 */
//			/* 债券卖出数量规则 */
//			if(g_is_bond){
//				if(mountBuy%10 != 0 && maxNum%10 != mountBuy%10){
//					layerUtils.iMsg(-1, "卖出数量不符合交易所规定，请重新输入");
//					return false;
//				}
//			}else if(g_is_stock || g_is_fund || g_is_warrant){
//				if(mountBuy%100 != 0 && maxNum%100 != mountBuy%100){
//					layerUtils.iMsg(-1, "卖出数量不符合交易所规定，请重新输入");
//					return false;
//				}
//			}
//		}
		var exchange_type=_market;
		var tipStr = "<div style=\"text-align: left;padding-left: 33%;color: #999;\">";
		tipStr+="操作类型：买入";
		tipStr+="<br>证券名称："+ $(_pageId+"#stockName").text();
		tipStr+="<br>证券代码："+buy_stockCode;
		tipStr+="<br>买入价格："+now_price;
		tipStr+="<br>买入数量："+mountBuy+"</div>";
		layerUtils.iConfirm(tipStr,function success(){
		var cust_code = userInfo.cust_code;	//客户代码
		var fund_account	= userInfo.fund_account;	//资产账户
		var branch_no  = userInfo.branch_no;	//分支机构
		var sessionid=userInfo.sessionid;
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置 
		var password=sessionid.password;
		var entrust_bs="0";		
		var stock_account=_stockAccount;
		var stock_code=buy_stockCode;
		var entrust_price=now_price;
		var entrust_amount=mountBuy;
		var param = {
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"sessionid":sessionid,
				"entrust_bs":entrust_bs,
				"exchange_type":exchange_type,
				"stock_account":stock_account,
				"stock_code":stock_code,
				"entrust_price":entrust_price,
				"entrust_amount":entrust_amount,
			};
		service_stock.getStockBuy(param,getStockBuyCallBack);
			
		},function fail(){
		});
	}
	/**
	 * 委托下单返回
	 * */
	function getStockBuyCallBack(data){
		if(data.error_no == 0){
			var results = data.results;
			if(results && results.length>0){
				layerUtils.iAlert(data.error_info);
				clearBuyMsg();
			}
		}else{
			layerUtils.iAlert(data.error_info);
		}
	}
	
	/**
	 * 重置买卖页面数据  
	 */
	function clearBuyMsg(){

		if (fifthOrder_timer != null ) {
	        window.clearInterval(fifthOrder_timer);
	    }
		$(_pageId+"#stockName").text("股票名称");
		$(_pageId+"#stockPrice").val("");
		$(_pageId+"#stockNum").val("");
		$(_pageId+"#buyLimit").text("--");
		$(_pageId+"#up_stop").text("--");
		$(_pageId+"#down_stop").text("--");
		$(_pageId+".five_box ul li em").text("--");
		$(_pageId+".five_box ul li span").removeClass("agreen").removeClass("ared").text("--");
		$(_pageId+".trade_form .input_box .stat").hide();
	}
	/**
	 * 销毁
	 */
	function destroy(){
		 if (position_timer != null ) {
	         window.clearInterval(position_timer);
	     }
		 clearBuyMsg();
	     userInfo = null;  //账号信息
		 price_step = 0.01; //步长
		 price_digit = 0; //小数点位数
		 fifthOrder_timer = null; //五档定时器
		 position_timer = null; //持仓定时器
		 lotsOf = 100; //每手数量
		 _stockAccount=""; //股东帐号
	     _market ="";   //交易市场
		 $(_pageId+"#stockCode").val("");
		 external.callMessage({"moduleName":"common", "funcNo": "50015"});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});