/**
 * 信用交易-总资产界面
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var	layerUtils = require("layerUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var common = require("common");
	var changeToPinyin = require("changeToPinyin");
	var	service_credit = require("service_credit");
    var _pageId = "#credit_asset_asset ";
    var assert_val ="";
    var total_debit =""; //总负债
    var assert_val ="";  //总资产
    var enable_balance =""; //可用余额
    var enable_bail_balance  ="";//可用保证金
    var per_assurescale_value = ""; //维持担保比例
    var fund_asset = ""; //现金
    var fin_debit = ""; //融资负债
    var slo_debit = ""; //融券负债
    var sum_compact_interest = ""; //合约总利息
    var market_value = ""; //证券市值
    var userInfo = null;
    
    /**
     * 初始化
     */
	function init(){common.hideBottomBar();
	    userInfo = JSON.parse(appUtils.getSStorageInfo("credit_userInfo"));
		common.bindStockEvent(_pageId);  //绑定头部菜单事件
		$(_pageId+".main .mar_stock").scrollTop(0);
		$(_pageId+".main .mar_stock").css("overflow-y","auto");
        var height_meau = $(window).height() - $(_pageId+".header").height() - $(_pageId+".main .tab_nav").outerHeight() - $(_pageId+".main .mar_limit").outerHeight() -13;
		$(_pageId+".main .mar_stock").height(height_meau); //查询目录添加高度
		queryAssetsData(); //查询资产数据
		queryHolding();  //证券持仓查询
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId+".top_title .icon_back"), function(e){
			appUtils.pageInit("credit/asset/asset","account/index",{});
			e.stopPropagation();
		});
		//显示选择
		appUtils.bindEvent($(_pageId+".mar_limit .switch_limit a"), function(e){
			$(this).addClass("active").siblings().removeClass("active");
			var type = $(this).attr("id");
			queryAssetsData(); //查询资产数据
			if(type=="total_debit"){
				$(_pageId+"#assert_val_").hide();
				$(_pageId+"#enable_bail_balance_").hide();
				$(_pageId+"#total_debit_").show();
				$(_pageId+".mar_limit .cir_box2 h5").html("<span>￥</span>"+total_debit.substring(0,total_debit.indexOf("."))+"<em>"+total_debit.substring(total_debit.indexOf("."))+"</em>");
				$(_pageId+".mar_limit .cir_atta1 h5").html("<span>￥</span>"+slo_debit.substring(0,slo_debit.indexOf("."))+"<em>"+slo_debit.substring(slo_debit.indexOf("."))+"</em>");
				$(_pageId+".mar_limit .cir_atta2 h5").html("<span>￥</span>"+sum_compact_interest.substring(0,sum_compact_interest.indexOf("."))+"<em>"+sum_compact_interest.substring(sum_compact_interest.indexOf("."))+"</em>");
				$(_pageId+".mar_limit .cir_atta3 h5").html("<span>￥</span>"+fin_debit.substring(0,fin_debit.indexOf("."))+"<em>"+fin_debit.substring(fin_debit.indexOf("."))+"</em>");
			}else if(type=="assert_val"){
				$(_pageId+"#assert_val_").show();
				$(_pageId+"#enable_bail_balance_").hide();
				$(_pageId+"#total_debit_").hide();
				$(_pageId+".mar_limit .cir_box3 h5").html("<span>￥</span>"+assert_val.substring(0,assert_val.indexOf("."))+"<em>"+assert_val.substring(assert_val.indexOf("."))+"</em>");
				$(_pageId+".mar_limit .cir_atta4 h5").html("<span>￥</span>"+fund_asset.substring(0,fund_asset.indexOf("."))+"<em>"+fund_asset.substring(fund_asset.indexOf("."))+"</em>");
				$(_pageId+".mar_limit .cir_atta5 h5").html(per_assurescale_value.substring(0,per_assurescale_value.indexOf("."))+"<em>"+per_assurescale_value.substring(per_assurescale_value.indexOf("."))+"</em>");
				$(_pageId+".mar_limit .cir_atta6 h5").html("<span>￥</span>"+market_value.substring(0,market_value.indexOf("."))+"<em>"+market_value.substring(market_value.indexOf("."))+"</em>");
			}else{
				$(_pageId+"#assert_val_").hide();
				$(_pageId+"#enable_bail_balance_").show();
				$(_pageId+"#total_debit_").hide();
				$(_pageId+".mar_limit .cir_box h5").html("<span>￥</span>"+enable_bail_balance.substring(0,enable_bail_balance.indexOf("."))+"<em>"+enable_bail_balance.substring(enable_bail_balance.indexOf("."))+"</em>");
			}
			e.stopPropagation();
		});
		//查看详情
		appUtils.bindEvent($(_pageId+".mar_limit .cir_box a"), function(e){	
			var showContent = $(this).parent().find("p").text();
			var className = $(this).attr("param");
			var param = "assert";
			if(className=="total_debit"){
				param = "debit";
			}
			appUtils.pageInit("credit/asset/asset","credit/query/creditAssetsQuery",{"param":param});
			e.stopPropagation();
		});
	}
    
	/**
	 * 总数据查询
	 */
	function queryAssetsData(){
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
		var branch_no = userInfo.branch_no;	//分支机构
		var fund_account = userInfo.fund_account;	//资产账户
		var cust_code = userInfo.cust_code;	//客户代码
		var password = userInfo.password;
		var sessionid = userInfo.session_id;
		var param = {			
			"entrust_way":entrust_way,
			"branch_no":branch_no,
			"fund_account":fund_account,
			"password":password,
			"cust_code":cust_code,
			"sessionid":sessionid
		};
		service_credit.rzrq_liabilitiesQuery(param,rzrq_liabilitiesQueryCallBack);
	}
	
	/**
	 * 资产数据调方法
	 * @param {Object} data 返回数据
	 */
	function rzrq_liabilitiesQueryCallBack(data){
		if (data) {
			if(data.error_no == 0)
			{
				var results = data.results;	
				if(results && results.length > 0){
					var data = results[0];
					
					enable_bail_balance = common.numToMoneyType(data.enable_bail_balance+""); //可用保证金
				    total_debit = common.numToMoneyType(data.total_debit+""); //总负债
				    assert_val = common.numToMoneyType(data.assert_val);  //总资产
				    enable_balance = common.numToMoneyType(data.enable_balance); //可用余额
				    per_assurescale_value = common.numToMoneyType(data.per_assurescale_value); //维持担保比例
				    fund_asset = common.numToMoneyType(data.fund_asset); //现金
				    fin_debit = common.numToMoneyType(data.fin_debit); //融资负债
				    slo_debit = common.numToMoneyType(data.slo_debit); //融券负债
				    slo_debit = common.numToMoneyType(data.slo_debit); //融券负债
				    sum_compact_interest = common.numToMoneyType(data.sum_compact_interest); //合约总利息
				    market_value = common.numToMoneyType(data.market_value); //证券市值
				    
//				    $(_pageId+".mar_limit .switch_limit a:eq(0)").addClass("active").siblings().removeClass("active");
					$(_pageId+".mar_limit .cir_box3 h5").html("<span>￥</span>"+assert_val.substring(0,assert_val.indexOf("."))+"<em>"+assert_val.substring(assert_val.indexOf("."))+"</em>");
					$(_pageId+".mar_limit .cir_atta4 h5").html("<span>￥</span>"+fund_asset.substring(0,fund_asset.indexOf("."))+"<em>"+fund_asset.substring(fund_asset.indexOf("."))+"</em>");
					$(_pageId+".mar_limit .cir_atta5 h5").html("<span>￥</span>"+per_assurescale_value.substring(0,per_assurescale_value.indexOf("."))+"<em>"+per_assurescale_value.substring(per_assurescale_value.indexOf("."))+"</em>");
					$(_pageId+".mar_limit .cir_atta6 h5").html("<span>￥</span>"+market_value.substring(0,market_value.indexOf("."))+"<em>"+market_value.substring(market_value.indexOf("."))+"</em>");

				}
			}
			else
			{
				layerUtils.iAlert(data.error_info);
			}
		}
	}
	
	/**
	 * 证券持仓查询
	 */
	function queryHolding(){
		$(_pageId+ ".no_data").hide();
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
		var branch_no  = userInfo.branch_no;	//分支机构
		var fund_account = userInfo.fund_account;	//资产账户
		var cust_code = userInfo.cust_code;	//客户代码
		var sessionid= userInfo.session_id;
		var password = userInfo.password;
		var stock_account ="";
		var stock_code = userInfo.stock_code;
		var exchange_type = "";
		var param={
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"sessionid":sessionid,
				"stock_account":stock_account,
				"stock_code":stock_code,
				"exchange_type":exchange_type
		};
		service_credit.cc_query(param,queryStockCallback);//股票查询
	}
	function queryStockCallback(data){
		if (data) {
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length > 0){
					$(_pageId+".mar_limit .mar_num").text("持有证券："+results.length+"只");
					var queryStockHtml = "";
					for(var i = 0; i < results.length; i++) {
						queryStockHtml += createqueryStockHtml(results[i]);
					}
					$(_pageId+".mar_stock").html(queryStockHtml);
					//绑定买卖下单事件
					appUtils.bindEvent($(_pageId+".mar_stock .order"), function(e){
						var stock_code= $(this).parent().attr("id");
						var toPage ="credit/order/ordinaryToBuy";
						appUtils.pageInit("credit/asset/asset",toPage,{stockCode:stock_code});
						e.stopPropagation();
					},"click");
				}else{
					$(_pageId+".mar_stock").html("");
					$(_pageId+ ".no_data").show();
				}
			}
			else{
				layerUtils.iAlert(data.error_info);
			}
		}
	}

	/**
	 * 生成股份查询html
	 * @param {Object} 结果集
	 */
	function createqueryStockHtml(element){
		var price_digit = 2;
//		require("common").decimalKeep(element.stock_code ,function(data){  //获取保留的位数
//	    	if(data){
//	    		price_digit = data;
//	    	}
//		});
		var market_name=element.exchange_type_name;
		var market="";
		var float_yk = element.float_yk;
		var css="";
		if(float_yk<0){
			css="agreen";
		}else if(float_yk>0){
			css="ared";
		}
		if(market_name.indexOf("深A")>-1||market_name.indexOf("深圳A")>-1||market_name.indexOf("深B")>-1||market_name.indexOf("深圳B")>-1){
			market="SZ";
		}else if(market_name.indexOf("沪A")>-1||market_name.indexOf("上海A")>-1||market_name.indexOf("沪B")>-1||market_name.indexOf("上海B")>-1){
			market="SH";
		}		
		var eleHtml = "";
		eleHtml += "<div class=\"part\" id="+element.stock_code+" market='"+market+"'>";
		/*eleHtml += "<a href=\"javascript:void(0);\" class=\"order\">下单</a>";*/
		eleHtml += "<h5>"+element.stock_name+"<small>"+element.stock_code+"</small></h5>";
		eleHtml += "<dl class=\"clearfix\">";
		eleHtml += "	<dt><strong class="+css+">"+Number(element.last_price).toFixed(price_digit)+"</strong><p><span class="+css+">"+Number(float_yk).toFixed(price_digit)+"</span><span class="+css+">"+element.float_yk_per+"</span></p></dt>";
		eleHtml += "    <dd><p><em>成本</em>"+Number(element.cost_price).toFixed(price_digit)+"</p><p><em>市值</em>"+Number(element.market_value).toFixed(price_digit)+"</p></dd>";
		eleHtml += "    <dd><p><em>持仓数量</em>"+Number(element.cost_amount).toFixed(0)+"</p><p><em>可用数量</em>"+element.enable_amount+"</p></dd>";
		eleHtml += "</dl>";
		eleHtml += " </div>";
		return eleHtml;
	}

	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId+"#assert_val_").show();
		$(_pageId+"#enable_bail_balance_").hide();
		$(_pageId+"#total_debit_").hide();
		$(_pageId+".mar_limit .cir_box3 h5").html("<span>￥</span>"+assert_val.substring(0,assert_val.indexOf("."))+"<em>"+assert_val.substring(assert_val.indexOf("."))+"</em>");
		$(_pageId+".mar_limit .cir_atta4 h5").html("<span>￥</span>"+fund_asset.substring(0,fund_asset.indexOf("."))+"<em>"+fund_asset.substring(fund_asset.indexOf("."))+"</em>");
		$(_pageId+".mar_limit .cir_atta5 h5").html(per_assurescale_value.substring(0,per_assurescale_value.indexOf("."))+"<em>"+per_assurescale_value.substring(per_assurescale_value.indexOf("."))+"</em>");
		$(_pageId+".mar_limit .cir_atta6 h5").html("<span>￥</span>"+market_value.substring(0,market_value.indexOf("."))+"<em>"+market_value.substring(market_value.indexOf("."))+"</em>");
		$(_pageId+".mar_limit .switch_limit a:eq(0)").addClass("active").siblings().removeClass("active");
		$(_pageId+".main .mar_stock").scrollTop(0);
		$(" #inputPopLayer").remove();
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("credit/asset/asset","account/index",{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});