/**
 * 一键归集
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var common = require("common");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var layerUtils = require("layerUtils");
	var validatorUtil = require("validatorUtil");
	var service_common = require("service_common");
	var service_stock = require("service_stock");
	var external = require("external");
    var _pageId = "#credit_bank_collection ";
    var action = "#collection ";
    var userInfo = null;
    var bankingMark = "";
    
    /**
     * 初始化
     */
	function init(){common.hideBottomBar();
		common.systemKeybord(); // 解禁系统键盘
		userInfo = JSON.parse(appUtils.getSStorageInfo("credit_userInfo"));
		queryAccountInfos();
		
		//在pc端可使用键盘输入股票代码（方便调试）
		if(gconfig.platform == "0"){ 
			$(_pageId+"#stock_password").attr("readonly",false);
		}	
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			if(gconfig.platform != "0"){ 
				bankingMark = external.callMessage({"key":"bankingMark","funcNo": "50041"}).results[0].value;
			}	
			
			if(bankingMark == "toBanking"){
				external.callMessage({"moduleName":"ygt","funcNo": "50101"});
			}else{
				appUtils.pageInit("credit/bank/collection","credit/index",{});
			}
			e.stopPropagation();	// 阻止冒泡
		});
		
		//页面切换
		appUtils.bindEvent($(_pageId + ".tab_nav ul li"), function(e){
			//resetBuyForm();
			$(this).addClass("active").siblings().removeClass("active");
			var showPage = "#"+$(this).attr("show-page");
			var hidePage = "#"+$(this).siblings().attr("show-page");
			action = showPage+" ";
			$(_pageId + hidePage).hide();
			$(_pageId + showPage).show();
			bindPageEvent(); //重新绑定事件
			resetBuyForm();
			e.stopPropagation(); // 阻止冒泡
		});
		
		//主
		appUtils.bindEvent($(_pageId + "#turnOut"), function(e){
			$(_pageId+"#turnIn ul").hide();
			$(_pageId+"#turnOut ul").slideToggle("fast");
			e.stopPropagation();	// 阻止冒泡
		});
		
		//辅
		appUtils.bindEvent($(_pageId + "#turnIn"), function(e){
			$(_pageId+"#turnOut ul").hide();
			$(_pageId+"#turnIn ul").slideToggle("fast");
			e.stopPropagation();	// 阻止冒泡
		});
		
		//选择币种
		appUtils.bindEvent($(_pageId + action + ".toggle_nav ul li"), function(e){
			//对样式进行切换
			$(this).addClass("active").siblings().removeClass("active");
			$(_pageId +"#moneyList").attr("value",$(this).attr("id"));
			e.stopPropagation();	// 阻止冒泡
		});
		
		//提交一键归集转账
		appUtils.bindEvent($(_pageId + "#collection .ce_btn a"),function(e){
			cashCollectSubmit(); //提交转账
			e.stopPropagation();	// 阻止冒泡
		});
		
		//提交资金归集转账
		appUtils.bindEvent($(_pageId  + "#cashTransfer .ce_btn a"),function(e){
			cashSweepSubmit(); //提交转账
			e.stopPropagation();	// 阻止冒泡
		});
		
		//点击其他地方隐藏下拉框
		appUtils.bindEvent($(_pageId),function(e){
			$(_pageId+"#turnOut ul").hide();	
			$(_pageId+"#turnIn ul").hide();
			e.stopPropagation();	// 阻止冒泡
		});
		
		//资金密码输入框调用原生键盘
		appUtils.bindEvent($(_pageId+"#stock_password"),function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50210", "pageId":"credit_bank_collection", "eleId":"stock_password", "doneLable":"done", "keyboardType":"4"});
			e.stopPropagation();
		},"click");
		
		//失去焦点关闭原生键盘
		appUtils.bindEvent($(_pageId+"#stock_password"),function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50211"});
			e.stopPropagation();
		},"blur");
	}
	
	/**
	 * 客户资产帐户信息查询
	 */
	function queryAccountInfos(){
		var cust_code = userInfo.cust_code;	//客户代码
		var branch_no = userInfo.branch_no;	//分支机构
		var sessionid = userInfo.session_id;
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
		var money_type="";
		var param={			
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"cust_code":cust_code,
				"sessionid":sessionid,
				"money_type":money_type,
		};
		service_common.queryAccountInfos(param,function(data){queryAccountInfosCallBack(data,param);});
	}
	function queryAccountInfosCallBack(data,param){
		if(data.error_no == 0){
			var results=data.results;
			if(results && results.length > 0){
				var listHtml = "<tr><th scope=\"col\">银行名称</th><th scope=\"col\">账户类型</th><th scope=\"col\">资金余额</th><th scope=\"col\">可转资金</th></tr>";
				var mainAccountHtml = "<ul style=\"display:none;\">";
				var fuAccountHtml = "<ul style=\"display:none;\">";
				
				for(var i = 0;i < results.length; i++) {
					var  accountType = "辅";
					if(results[i].fundseq =="0"){
						accountType = "主";
						$(_pageId+"#mainAccount").val(results[i].fundid);
						mainAccountHtml +="<li><a href=\"javascript:void(0);\">(主)<strong>"+results[i].fundid+"</strong>"+results[i].bank_name+"</a></li>";
					}else{
						fuAccountHtml +="<li><a href=\"javascript:void(0);\">(辅)<strong>"+results[i].fundid+"</strong>"+results[i].bank_name+"</a></li>";
					}
					listHtml += " <tr>";
					listHtml += "    <td>"+results[i].bank_name+"</td>";
					listHtml += "    <td>"+accountType+"<br /></td>";
					listHtml += "    <td>"+results[i].current_balance+"<br /></td>";
					listHtml += "    <td>"+results[i].fetch_balance+"<br /></td>";
					listHtml += " </tr>";
				};
				mainAccountHtml+="</ul>";
				fuAccountHtml+="</ul>";
				
				if(fuAccountHtml.indexOf("<li>") == -1){
					$(_pageId+"#turnIn").html("<p>暂未查询到您的子存管账号</p>").addClass("deleteBefore");
				}else{
					$(_pageId+"#turnIn").append(fuAccountHtml);
				}
				if(mainAccountHtml.indexOf("<li>") == -1){
					$(_pageId+"#turnOut").html("<p>暂未查询到您的主存管账号</p>").addClass("deleteBefore");
				}else{
					$(_pageId+"#turnOut").append(mainAccountHtml);
				}
				$(_pageId+".inte_table #accountList").html(listHtml);
				
				//选中下拉
				appUtils.bindEvent($(_pageId+"#turnOut ul li"),function(){
					$(_pageId+"#turnOut p").html($(this).find("a").html());
				});
				
				appUtils.bindEvent($(_pageId+"#turnIn ul li"),function(){
					$(_pageId+"#turnIn p").html($(this).find("a").html());
				});
			}
		}else{
			layerUtils.iAlert(data.error_info);
		}
	}
	
	 /**
     * 一键归集提交转账
     */
	function cashCollectSubmit(){
		var stock_password =  $(_pageId+action+"#stock_password").val();	
		if(stock_password == ""){
			layerUtils.iMsg(-1,"请输入资金密码");
			return false ;
		}else if(stock_password.length!=6){
			layerUtils.iMsg(-1,"资金密码长度为6位数");
			return false ;
		}
		var cust_code = userInfo.cust_code;	//客户代码
		var fund_account = userInfo.fund_account;	//资产账户
		var branch_no  = userInfo.branch_no;	//分支机构
		var sessionid = userInfo.session_id;
		var password = userInfo.password;
		var money_type = $(_pageId+action+"#moneyList").attr("value");
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
		var param={
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"sessionid":sessionid,
                "password":password,
				"money_type":money_type,
		};
		service_common.cashCollection(param,cashCollectionCallBack);
	}
	
	
	
	//一键归集调用服务层的回调函数返回来的数据
	function cashCollectionCallBack(data){
		//表示一键归集调用服务层成功，而且返回了信息
		if(data.error_no == 0){
			$(_pageId+action+"#stock_password").val("");
//			layerUtils.iMsg(1,data.results[0].fundeffec!=""?"归集金额 为："+data.results[0].fundeffec:"已提交转款",3);
			//数据重置方法的调用
			resetBuyForm();
			// 客户资产帐户信息查询方法的调用
			queryAccountInfos();
			layerUtils.iAlert(data.error_info);
		}
		else{
			resetBuyForm();
			layerUtils.iAlert(data.error_info);
		}
	}
	
	
	
	 /**
     * 提交资金归集转账
     */
	function cashSweepSubmit(){
		var moneyNum = $(_pageId+"#moneyNum").val(); // 转账金额
		if(moneyNum==""){
			layerUtils.iMsg(-1,"请输入转账金额");
			return false;
		}else if(!validatorUtil.isNumberFloat(moneyNum)){
			layerUtils.iMsg(-1,"转账金额请输入数字");
			return false;
		}
		var stock_password =  $(_pageId+action+"#stock_password").val();	
		if(stock_password == ""){
			layerUtils.iMsg(-1,"请输入资金密码");
			return false ;
		}else if(stock_password.length!=6){
			layerUtils.iMsg(-1,"资金密码长度为6位数");
			return false ;
		}
		var cust_code = userInfo.cust_code;	//客户代码
		var fund_account = userInfo.fund_account;	//资产账户
		var branch_no  = userInfo.branch_no;	//分支机构
		var sessionid = userInfo.session_id;
		var password = userInfo.password;
		var money_type = $(_pageId+action+"#moneyList").attr("value");
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
		var out_fundid = $(_pageId+"#turnOut p strong").text();
		var in_fundid = $(_pageId+"#turnIn p strong").text();
		var param={
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"sessionid":sessionid,
                "password":password,
				"money_type":money_type,
	      	    "out_fundid":out_fundid,
  	            "out_password":stock_password,
  	            "in_fundid":in_fundid,
  	            "tranamt":moneyNum
		};
		service_common.cashSweep(param,cashSweepCallBack);
	}
	function cashSweepCallBack(data){
		if(data.error_no == 0){
			$(_pageId+action+"#moneyNum").val("");
			$(_pageId+action+"#stock_password").val("");
			layerUtils.iMsg(1,data.results[0].outsno!=""?"转出流水号为："+data.results[0].outsno:"已提交转款",3);
			resetBuyForm();
			queryAccountInfos();
		}
		else{
			resetBuyForm();
			layerUtils.iAlert(data.error_info);
		}
	}
	
	
	//数据重置
	function resetBuyForm(){
		$(_pageId+"#moneyNum").val("");
		$(_pageId+"#stock_password").val("");
		$(_pageId+"#turnIn ul").hide();
		$(_pageId+"#turnOut ul").hide();
//		$(_pageId+"#turnOut p").text("请选择");
//		$(_pageId+"#turnIn p").text("请选择");
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId + "#moneyNum").val("");
		$(_pageId + "#mainAccount").val("");
		$(_pageId + "#accountList tr").remove();
		$(_pageId + "#stock_password").val("");
		$(_pageId + "#turnOut ul").remove();
		$(_pageId + "#turnIn ul").remove();
		$(_pageId + ".tab_nav ul li:eq(0)").addClass("active").siblings().removeClass("active");
		$(_pageId + "#turnOut p").text("请选择");
		$(_pageId + "#turnIn p").text("请选择");
		resetBuyForm();
		action="#collection ";
		$(_pageId +"#cashTransfer").hide();
		$(_pageId +"#collection").show();
		external.callMessage({"moduleName":"trade","funcNo": "50211"});
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("credit/bank/collection","credit/index",{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});