/**
 * 交易转账
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var common = require("common");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var layerUtils = require("layerUtils");
	var validatorUtil = require("validatorUtil");
	var service_common = require("service_common");
	var service_credit = require("service_credit");
	var external = require("external");
    var _pageId = "#credit_bank_transfer ";
    //转入转出按钮的定义
    var action = "#transferIn ";
	var g_need_bank_passwd = false; // 是否需要银行密码
	var g_need_fund_passwd = false; // 是否需要资金密码
	var check_need_bank_passwd = false; // 是否需要银行密码  (余额查询)
	var check_need_fund_passwd = false;// 是否需要银行密码 (余额查询)
	var userInfo = null;
	////判断用户选择那个帐户
	var witchAccount = "";
	var witch_page = "";
	var money_types = {"0":"人民币","1":"美元","2":"港币"};
	var bankingMark = "";
	var money_type = "0";
	
    /**
     * 初始化
     */
	function init(){
		common.hideBottomBar();
		common.systemKeybord(); // 解禁系统键盘
		$(_pageId).css("overflow-x","hidden");
		witch_page = "credit";
			//从session中获取客户的信息
			userInfo = JSON.parse(appUtils.getSStorageInfo("credit_userInfo"));
		
//		$(_pageId+"#moneyList").addClass("deleteBefore");
		queryAccount(); //查询存管银行
		
		if(gconfig.platform=="0"){ 
			$(_pageId+"#bank_password_out").attr("readonly",false);
			$(_pageId+"#stock_password_in").attr("readonly",false);
			$(_pageId+"#stock_password_out").attr("readonly",false);
			$(_pageId+"#bank_password_in").attr("readonly",false);
		}	
    }
	
	/**
	 * 事件绑定 
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			if(gconfig.platform != "0"){ 
				bankingMark = external.callMessage({"key":"bankingMark","funcNo": "50041"}).results[0].value;
			}	
			
			if(bankingMark == "toBanking"){
				external.callMessage({"moduleName":"ygt","funcNo": "50101"});
			}else{
					appUtils.pageInit("credit/bank/transfer","credit/index");
			}
			
			e.stopPropagation();	// 阻止冒泡
		});
		
		//流水查询
		appUtils.bindEvent($(_pageId +".top_title .noicon_text"), function(e){
			appUtils.pageInit("credit/bank/transfer","credit/bank/transferHistory");
			e.stopPropagation();	// 阻止冒泡
		});
		
		//页面切换
		appUtils.bindEvent($(_pageId + ".toggle_nav ul li"), function(e){
			resetBuyForm();
			$(this).addClass("active").siblings().removeClass("active");
			var showPage = "#"+$(this).attr("show-page");
			var hidePage = "#"+$(this).siblings().attr("show-page");
			action = showPage+" ";
			$(_pageId + hidePage).hide();
			$(_pageId + showPage).show();
			queryAccount();  //查询存管银行
			bindPageEvent(); //重新绑定事件
			e.stopPropagation(); // 阻止冒泡
		});
		
		
		//存管银行下拉框
		appUtils.bindEvent($(_pageId + action + "#bankList"), function(e){
			//$(this).addClass("active").siblings().removeClass("active");
			$(_pageId+action+"#moneyList ul").hide();
			$(_pageId+action+"#bankList ul").slideToggle("fast");
			e.stopPropagation();	// 阻止冒泡
		});
		
		
		//币种下拉框
		appUtils.bindEvent($(_pageId + action + "#moneyList"), function(e){
			//$(this).addClass("active").siblings().removeClass("active");
			$(_pageId+action+"#bankList ul").hide();
			//控制币种下拉的展开和关闭
			$(_pageId+action+"#moneyList ul").slideToggle("fast");
			
			e.stopPropagation();	// 阻止冒泡
		});
		
		
		//币种下拉框选择
		appUtils.bindEvent($(_pageId + action + "#moneyList ul li"),function(e){
//			var mainId = $(this).parent().parent().parent().parent().attr("id");
//			//当前表示的是在转出页面对币种进行选择时不同的币种之间的折换
//			if(mainId == "transferOut"){
//				
//			}
//			$(_pageId+action+"#moneyList").attr("value",$(this).attr("id"));
//			$(_pageId+action+"#moneyList p").html($(this).find("a").html());
			money_type = $(this).attr("id");
			queryAccount($(this));
			//保证金可转余额查询方法的调用(只针对转出模块)
			queryBalance();
			e.stopPropagation();
		}, "click");
		
		
		//提交转账
		appUtils.bindEvent($(_pageId + action + ".ce_btn a"),function(e){
			transferSubmit(); //提交转账
			e.stopPropagation();	// 阻止冒泡
		});
		
		//点击其他地方隐藏下拉框
		appUtils.bindEvent($(_pageId),function(e){
			if($(_pageId + action + "#moneyList ul").is(':visible')){
				$(_pageId + action +" #moneyList ul").slideToggle("fast");
			}
			if($(_pageId + action+" #bankList ul").is(':visible')){
				$(_pageId + action+" #bankList ul").slideToggle("fast");
			}	
			e.stopPropagation();	// 阻止冒泡
		});
		
		//银行密码输入框调用原生键盘
		appUtils.bindEvent($(_pageId+"#bank_password_out"),function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50210", "pageId":"credit_bank_transfer", "eleId":"bank_password_out", "doneLable":"done", "keyboardType":"4"});
			e.stopPropagation();
		},"click");
		
		//失去焦点关闭原生键盘
		appUtils.bindEvent($(_pageId+"#bank_password_out"),function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50211"});
			e.stopPropagation();
		},"blur");
		
		//资金密码输入框调用原生键盘
		appUtils.bindEvent($(_pageId+"#stock_password_out"),function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50210", "pageId":"credit_bank_transfer", "eleId":"stock_password_out", "doneLable":"done", "keyboardType":"4"});
			e.stopPropagation();
		},"click");
		
		//失去焦点关闭原生键盘
		appUtils.bindEvent($(_pageId+"#stock_password_out"),function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50211"});
			e.stopPropagation();
		},"blur");
		
		//银行密码输入框调用原生键盘
		appUtils.bindEvent($(_pageId+"#bank_password_in"),function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50210", "pageId":"credit_bank_transfer", "eleId":"bank_password_in", "doneLable":"done", "keyboardType":"4"});
			e.stopPropagation();
		},"click");
		
		//失去焦点关闭原生键盘
		appUtils.bindEvent($(_pageId+"#bank_password_in"),function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50211"});
			e.stopPropagation();
		},"blur");
		
		//资金密码输入框调用原生键盘
		appUtils.bindEvent($(_pageId+"#stock_password_in"),function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50210", "pageId":"credit_bank_transfer", "eleId":"stock_password_in", "doneLable":"done", "keyboardType":"4"});
			e.stopPropagation();
		},"click");
		
		//失去焦点关闭原生键盘
		appUtils.bindEvent($(_pageId+"#stock_password_in"),function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50211"});
			e.stopPropagation();
		},"blur");
		
		//(为查询银行余额绑定事件)
		appUtils.bindEvent($(_pageId + "#checkmoeny"), function(e){
			if(!check_need_bank_passwd && !check_need_fund_passwd){//表示在查询余额的时候两种密码都不需要
				$(_pageId + ".backdrop").hide();   //遮罩层隐藏
				$(_pageId + ".pop_box").hide();    //银行密码或者资金密码输入的整体div
				checkEnblance();
			}else{
				$(_pageId + ".backdrop").show();
				$(_pageId + ".pop_box").show();
			}
			e.stopPropagation();	// 阻止冒泡
		});
		
		//余额查询
		appUtils.bindEvent($(_pageId + ".pop_box .pop_footer a:eq(0)"), function(e){
			$(_pageId + ".backdrop").hide();
			$(_pageId + ".pop_box").hide();
			var check_bank_password = $(_pageId+"#check_bank_password").val();
			var check_fund_password = $(_pageId+"#check_fund_password").val();
			if(check_bank_password == "" && check_need_bank_passwd){
				layerUtils.iMsg(-1,"请输入银行密码");
				return false ;
			}else if(check_bank_password.length!=6 && check_need_bank_passwd){
				layerUtils.iMsg(-1,"银行密码长度为6位数");
				return false ;
			}else if(check_fund_password == "" && check_need_fund_passwd){
				layerUtils.iMsg(-1,"请输入资金密码");
				return false;
			}else if(check_fund_password.length!=6 && check_need_fund_passwd){
				layerUtils.iMsg(-1,"资金密码长度为6位数");
				return false ;
			}else{
				checkEnblance();
			}
			e.stopPropagation();	// 阻止冒泡
		});
		
		//余额查询取消
		appUtils.bindEvent($(_pageId + ".pop_box .pop_footer a:eq(1)"), function(e){
			$(_pageId + ".backdrop").hide();
			$(_pageId + ".pop_box").hide();
			$(_pageId + "#check_bank_password").val("");
			$(_pageId + "#check_fund_password").val("");
			e.stopPropagation();	// 阻止冒泡
		});
		
		//银行密码输入框
		appUtils.bindEvent($(_pageId + "#check_bank_password"), function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50210", "pageId":"credit_bank_transfer", "eleId":"check_bank_password", "doneLable":"done", "keyboardType":"4"});
			e.stopPropagation();	// 阻止冒泡
		},"click");
		
		//密码输入框
		appUtils.bindEvent($(_pageId + "#check_bank_password"), function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50211"});
			e.stopPropagation();	// 阻止冒泡
		},"blur");
		
		//资金密码输入框
		appUtils.bindEvent($(_pageId + "#check_fund_password"), function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50210", "pageId":"credit_bank_transfer", "eleId":"check_fund_password", "doneLable":"done", "keyboardType":"4"});
			e.stopPropagation();	// 阻止冒泡
		},"click");
		
		//密码输入框
		appUtils.bindEvent($(_pageId + "#check_fund_password"), function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50211"});
			e.stopPropagation();	// 阻止冒泡
		},"blur");

	}
	
    /**
     * 获取开通转帐银行账号（在进入首页的时候便会获取银行账号显示到指定的地方）
     */
	function queryAccount($dom){
		var cust_code = userInfo.cust_code;	//客户代码
		var fund_account = userInfo.fund_account;	//资产账户
		var branch_no = userInfo.branch_no;	//分支机构
		var sessionid = userInfo.session_id;
		var password = userInfo.password;
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
		var bank_code="";
		var param = {			
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"sessionid":sessionid,
				"bank_code":bank_code,
				"money_type":money_type,
				"account_type":"credit_userInfo"
				};
		
		service_common.queryAccounts(param,function(data){queryAccountCallBack(data,param,$dom);});
	}
	
	//该函数携带了回调数据和参数
	function queryAccountCallBack(data,param,$dom){
		if(data.error_no == 0){
			var results=data.results;
			console.log(data);
			console.log(results);
			if(results && results.length > 0){
				$(_pageId+"#bankList ul").remove();
				if ($dom){
					$(_pageId+action+"#moneyList").attr("value",$(this).attr("id"));
					$(_pageId+action+"#moneyList p").html($(this).find("a").html());
					money_type = $(this).attr("id");
				}
				
				var listHtml = "<ul style='display:none;'>";
				
				var rmb_bank = results[0];
				for(var i = 0;i < results.length; i++) {
					//获取账号
					var bank_accounts = results[i].bank_account;
					
					//得到处理后的账号（将中间的数据替换成“*”）
					if(bank_accounts.length>0){
						bank_accounts = bank_accounts.substring(0,4) + "****" +bank_accounts.substring(bank_accounts.length-4,bank_accounts.length);
					}
					
					listHtml += "<li id='"+results[i].bank_code+","+results[i].bank_account+"' data-type="+results[i].money_type+"><a href=\"javascript:void(0);\"><strong>"+bank_accounts+"</strong>"+results[i].bank_name+"</a></li>";
					//默认显示人民币
					if (results[i].money_type === "0"){
						rmb_bank = results[i];
					}
					money_type = results[i].money_type;
				};
				//当前表示的是转出（转出便要获取可转金额）
				if("#transferOut " == action){
					//保证金可转余额查询方法的调用(只针对转出模块)
					queryBalance();
				};
				listHtml+="</ul>";
				//显示的账号
				var bank_account = rmb_bank.bank_account;
				//得到要显示到文本框中的账号（这里不是完整显示，要对显示的账号进行一定的处理）
				if(bank_account.length>0){
					bank_account = bank_account.substring(0,4) + "****" +bank_account.substring(bank_account.length-4,bank_account.length);
				}
				//为选择银行赋相应的显示值
				$(_pageId+action+"#bankList p").html("<strong>"+bank_account+"</strong>"+rmb_bank.bank_name);
				
				//取出币种编号从数组中得到对应的币种名称并将其显示到指定的位置
				$(_pageId+action+"#moneyList p").html(money_types[rmb_bank.money_type]);
				
				//为显示币种的div添加value属性并赋相对应的属性值
				$(_pageId+action+"#moneyList").attr("value",rmb_bank.money_type);
				
				//为选择银行的div添加value属性并赋相应的属性值（银行代码和银行账户的拼接）
				$(_pageId+action+"#bankList").attr("value", rmb_bank.bank_code+","+rmb_bank.bank_account);
				
				
				
				
				//循环得到最终拼接的数据结果（HTML代码），然后将代码追加到指定的位置
				$(_pageId+action+"#bankList").append(listHtml);
				
				//继续给param参数赋值，三目运算符（转入模块是“0”，转出模块是“1”）这样的话transfer_direction属性就相当于一个标记
				param.transfer_direction = (action == "#transferIn ")?"0":"1"; // 转入方向
				param.money_type = rmb_bank.money_type;
				//将参数属性值进行了替换（覆盖）
				param.bank_code = rmb_bank.bank_code; // 第一条记录银行代码	
				
				// 查询转账银行业务信息
				queryBankInfo(param); 
				
//				// 参数的属性值进行了替换
//				param.transfer_direction = "2"; // 转入方向
//				// 查询转账银行业务信息
//				queryBankInfo(param);
				
				//选中下拉中的银行调用(有多种不同的账号功选择，当点击选择的时候便获取相对应的信息)
				appUtils.bindEvent($(_pageId+action+"#bankList ul li"),function(){
					$(_pageId+action+"#bankList").attr("value",this.id);
					
					$(_pageId+action+"#bankList p").html($(this).find("a").html());
					
					$(_pageId+action+"#moneyList p").html(money_types[$(this).attr("data-type")]);
					
					$(_pageId+action+"#moneyList").attr("value",$(this).attr("data-type"));
					
					param.bank_code = this.id.split(",")[0]; // 选中银行卡代码
					
					//继续给param参数赋值，三目运算符（转入模块是“0”，转出模块是“1”）这样的话transfer_direction属性就相当于一个标记
					param.transfer_direction = action == "#transferIn "?"0":"1"; // 转入方向	
					
					//调用此方法表示的是银行转证券还是证券转银行
					queryBankInfo(param); // 查询转账银行业务信息
					
					param.transfer_direction = "2"; // 转入方向
					
					queryBankInfo(param); //银行余额查询
					
					//当期表示的是转出
					if("#transferOut "== action){
						//保证金可转余额查询方法的调用
						queryBalance();
					}
					
				    });
				} else {
					if ($dom){
						layerUtils.iAlert("无此币种信息");
					} else {
						if (money_type === "0"){
							money_type = "1";
							queryAccount();
						} else if (money_type === "1"){
							money_type = "2";
							queryAccount();
						}
					}
				}
			//当前表示调用服务层出错
			}else {
				layerUtils.iAlert(data.error_info);
		    }
	}
	
	
	 /**
     * 保证金可转余额查询方法的定义（此方法值针对转出模块的可用余额查询）
     */
	function queryBalance(){
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;//货币 ""所有货币，0 人民币，1 港币，2 美元
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var password = userInfo.password;
		
		//下拉选中不同的币种是否存在相应的信息就是通过此处来区分和判断的
//		var money_type = $(_pageId+action+"#moneyList").attr("value");//货币 ""所有货币，0 人民币，1 港币，2 美元
		
		var sessionid = userInfo.session_id;
		var param={				
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"sessionid":sessionid,
				"password":password,
				"money_type":money_type,
				"account_type":"credit_userInfo"
		};
		
		//对登录的账户进行判断（分别调用不同的服务层方法进行可转金额的查询）
		service_credit.rzrq_liabilitiesQuery(param,queryBalanceCallBack);
	}
	//可用余额查询的回调
	function queryBalanceCallBack(data){
		if(data.error_no == 0){
			var results=data.results[0];
			if(results){
				//对登录的账户进行判断后将数据显示到指定的位置
				if(witchAccount=="credit_userInfo"){
					$(_pageId+action+".max strong").text(results.fetch_balance);
				}else{
					$(_pageId+action+".max strong").text(results.fetch_balance);
				}
			}
//			else{
//				layerUtils.iAlert(data.error_info);
//			}
		}else{
			layerUtils.iAlert(data.error_info);
			//将选中的币种回归到“人民币”
			$(_pageId+action+"#moneyList").attr("value", 0);
			$(_pageId+action+"#moneyList p").html("人民币");
		}
	}
	
	
	
	
   /**
     * 查询转帐银行业务信息 
     */
	function queryBankInfo(param){
		service_common.queryBankInfo(param, function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no == 0){
				var res = data.results[0];
				if(res){
					//查询得到回调数据
					var transfer_direction = res.transfer_direction; // 转账方向
					var fund_password_flag = res.fund_password_flag; // 资金密码标志
					var bank_password_flag = res.bank_password_flag; // 银行密码标志
					// 银行转证券
					if(transfer_direction == 0){
						if(fund_password_flag == 1){
							g_need_fund_passwd = true; 
							$(_pageId+"#transferIn #stock_password_in").parent().show();
						}else{
							g_need_fund_passwd = false; 
//							$(_pageId+"#transferIn #stock_password_in").parent().hide();
						}
						
						if(bank_password_flag == 1){
							g_need_bank_passwd = true;
							$(_pageId+"#transferIn #bank_password_in").parent().show();
						}else{
							g_need_bank_passwd = false;
//							$(_pageId+"#transferIn #bank_password_in").parent().hide();
						}
						
						
					// 证券转银行
					}else if(transfer_direction == 1){ 
						if(fund_password_flag == 1){
							g_need_fund_passwd = true;
							$(_pageId+"#transferOut #stock_password_out").parent().show();
						}else{
							g_need_fund_passwd = false;
//							$(_pageId+"#transferOut #stock_password_out").parent().hide();
						}
						
						if(bank_password_flag == 1){
							g_need_bank_passwd = true;
							$(_pageId+"#transferOut #bank_password_out").parent().show();
						}else{
							g_need_bank_passwd = false;
//							$(_pageId+"#transferOut #bank_password_out").parent().hide();
						}
					
					//查询银行余额是否需要密码
					}else if(transfer_direction == 2){
						if(bank_password_flag == 1){
							check_need_bank_passwd = true;
							$(_pageId+"#bank_box").show();
						}else{
							check_need_bank_passwd = false;
							$(_pageId+"#bank_box").hide();
						}
						
						if(fund_password_flag == 1){
							check_need_fund_passwd = true;
							$(_pageId+"#fund_box").show();
						}else{
							check_need_fund_passwd = false;
							$(_pageId+"#fund_box").hide();
						}
					}
					
				//表示查询成功但是没有得到数据
				}else{
					check_need_fund_passwd = false;
					check_need_bank_passwd = false;
				}
				
			//表示查询直接报错
			}else{
				layerUtils.iLoading(false);
				layerUtils.iAlert(error_info);
			}
			
		});
	}
	
	 /**
     * 提交转账
     */
	function transferSubmit(){
		var moneyNum = $(_pageId+action+"#moneyNum").val(); // 转账金额
		if(moneyNum==""){
			layerUtils.iMsg(-1,"请输入转账金额");
			return false;
		}else if(!validatorUtil.isNumberFloat(moneyNum)){
			layerUtils.iMsg(-1,"转账金额请输入数字");
			return false;
		}
		
		//如果是证券转银行
		if(action=="#transferOut "){
			var max_transfer=$(_pageId+action+".max strong").text(); //可转金额
			if($.trim(max_transfer).length<=0||parseFloat(max_transfer)<parseFloat(moneyNum)){
				layerUtils.iMsg(-1,"转账金额不足");
				return false;
			}
		}
		
		var fund_password = "";
		var bank_password = "";
		
		//如果是证券转银行
		if(action=="#transferOut "){
			fund_password = $(_pageId+"#stock_password_out").val();	
//			bank_password = $(_pageId+"#bank_password_out").val();	
			
			if(fund_password == "" && g_need_fund_passwd){
				layerUtils.iMsg(-1,"请输入资金密码");
				return false;
			}else if(fund_password.length!=6 && g_need_fund_passwd){
				layerUtils.iMsg(-1,"资金密码长度为6位数");
				return false ;
			}
		
		//银行转证券
		}else{
//			fund_password = $(_pageId+"#stock_password_in").val();	
			bank_password = $(_pageId+"#bank_password_in").val();	
			if(bank_password == "" && g_need_bank_passwd){
				layerUtils.iMsg(-1,"请输入银行密码");
				return false ;
			}else if(bank_password.length!=6 && g_need_bank_passwd){
				layerUtils.iMsg(-1,"银行密码长度为6位数");
				return false ;
			}
		}
		//没有传入参数，直接回调（获取秘钥对，当前的加密处理要用到此参数）
		service_common.getKey({},function(data){
			if(data.error_no != "0"){
				//将isShowWait关闭掉(圈)
				layerUtils.iLoading(false);
				layerUtils.iAlert(data.error_info);
				$(_pageId + "#check_password").val("");
				return false;
				
			//当前表示调用服务层成功
			}else{
				//得到回调后的值重新组装成参数
				var modulus = data.results[0].modulus;
				var publicExponent = data.results[0].publicExponent;
				
				var endecryptUtils = require("endecryptUtils");
				//为密码加密
				bank_password = endecryptUtils.rsaEncrypt(modulus,publicExponent,$.trim(bank_password));
				fund_password = endecryptUtils.rsaEncrypt(modulus,publicExponent,$.trim(fund_password));
				
				var bankInfo=$(_pageId+action+"#bankList").attr("value");
				var bankInfos=bankInfo.split(",");	
				var cust_code = userInfo.cust_code;	//客户代码
				var fund_account = userInfo.fund_account;	//资产账户
				var branch_no  = userInfo.branch_no;	//分支机构
				var sessionid = userInfo.sessionid;
				var bank_code = bankInfos[0];
				var client_account = bankInfos[1];
				var money_type = $(_pageId+action+"#moneyList").attr("value");
				var transfer_direction="0";
		        var password =userInfo.password;
				if(action == "#transferOut "){
					transfer_direction = "1";
				}
				var tranamt=moneyNum;
				var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
				var param={
						"entrust_way":entrust_way,
						"branch_no":branch_no,
						"fund_account":fund_account,
						"cust_code":cust_code,
						"sessionid":sessionid,
						"password":password,
						"bank_code":bank_code,
						"money_type":money_type,
						"transfer_direction":transfer_direction,
						"tranamt":tranamt,
						"fund_password":fund_password,
						"bank_password":bank_password,
						"client_account":client_account,
						"account_type":"credit_userInfo"
				};
				//在回调函数中继续请求服务层
				service_common.transfer(param,transferCallBack,{"isLastReq":true,"isShowWait":true});
			}
		},{"isLastReq":false});
	}
	
	//回调函数中回调后调用服务层的继续回调
	function transferCallBack(data){
		if(data.error_no == 0){
			$(_pageId+action+"#moneyNum").val("");
			$(_pageId+action+"#password").val("");
			//layerUtils.iAlert("转账请求已发送，流水号为："+data.results[0].serial_no+"<br/>可在转账查询中查询转账结果!");
			layerUtils.iAlert(data.error_info);
			//数据重置
			resetBuyForm();
			queryBalance();
		}else{
			resetBuyForm();
			//保证金可转余额查询方法
			queryBalance();
			layerUtils.iAlert(data.error_info);
		}
	}
	
  /**
    * 查询银行余额
    */
	function checkEnblance(){
		service_common.getKey({},function(data){
			if(data.error_no != "0"){
				//将isShowWait关闭掉(圈)
				layerUtils.iLoading(false);
				layerUtils.iAlert(data.error_info);
				$(_pageId+"#check_bank_password").val();
				$(_pageId+"#check_fund_password").val();
				return false;
			}else{
				//获得旧密码和新密码
				var check_bank_password = $(_pageId+"#check_bank_password").val();
				var check_fund_password = $(_pageId+"#check_fund_password").val();
				var modulus = data.results[0].modulus;
				var publicExponent = data.results[0].publicExponent;
				var endecryptUtils = require("endecryptUtils");
				//为旧密码和新密码加密
				check_bank_password = endecryptUtils.rsaEncrypt(modulus,publicExponent,$.trim(check_bank_password));
				check_fund_password = endecryptUtils.rsaEncrypt(modulus,publicExponent,$.trim(check_fund_password));
				var bankInfo=$(_pageId+action+"#bankList").attr("value");
				var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
				var cust_code = userInfo.cust_code;	//客户代码
				var fund_account = userInfo.fund_account;	//资产账户
				var branch_no  = userInfo.branch_no;	//分支机构
				var sessionid = userInfo.session_id;
				var password =userInfo.password;
				var bank_code = bankInfo.split(",")[0];
//				var money_type = money_type;  //  0：人民币，1：美元，2：港币
				var param={
						"entrust_way":entrust_way,
						"branch_no":branch_no,
						"fund_account":fund_account,
						"cust_code":cust_code,
						"sessionid":sessionid,
						"password":password,
						"bank_code":bank_code,
						"money_type":money_type,
						"bank_password":check_bank_password,
						"fund_password":check_fund_password,
						"account_type":"credit_userInfo"
				};
				service_common.bankBalance(param,function(data){
					if(data.error_no == 0){
						var results = data.results[0];
						if(results){
							$(_pageId+"#enblance").text(results.fundeffect);
						}
					}
					else{
						layerUtils.iAlert(data.error_info);
					}
				});
			}
		
		},{"isLastReq":false});
	}
	
	//数据重置
	function resetBuyForm(){
		$(_pageId+"#moneyNum").val("");
		$(_pageId+"#enblance").text("");
		$(_pageId+"#bank_password_in").val("");
		$(_pageId+"#stock_password_in").val("");
		$(_pageId+"#bank_password_out").val("");
		$(_pageId+"#stock_password_out").val("");
		$(_pageId+"#moneyList ul").hide();
		$(_pageId+"#moneyList p").html("人民币");
		$(_pageId+"#bankList p").html("选择银行");
		$(_pageId+"#transferOut .max strong").text("");
		$(_pageId+"#transferIn #bank_password_in").parent().show();
		$(_pageId+"#transferIn #stock_password_in").parent().show();
		$(_pageId+"#transferOut #bank_password_out").parent().show();
		$(_pageId+"#transferOut #stock_password_out").parent().show();
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		resetBuyForm();
		money_type = "0";
        $(_pageId+"#bankList ul").remove();
		$(_pageId+"#enblance").text("");
		action="#transferIn ";
		$(_pageId + "#transferOut").hide();
		$(_pageId + "#transferIn").show();
		$(_pageId + ".toggle_nav ul li:eq(0)").addClass("active");
		$(_pageId + ".toggle_nav ul li:eq(1)").removeClass("active");
		g_need_bank_passwd = false; // 是否需要银行密码
		g_need_fund_passwd = false;// 是否需要资金密码
		external.callMessage({"moduleName":"trade","funcNo": "50211"});
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("credit/bank/transfer",whichPage,{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});