/**
 * 新股-预约
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var layerUtils = require("layerUtils");
	var gconfig = require("gconfig");
	var external = require("external");
	var validator = require("validatorUtil");
	var service_stock = require("service_stock");
	var common = require("common");
	var _pageId = "#newshare_appointment ";
	var stockName = [];
	var stockCode = [];
	
    /**
     * 初始化
     */
	function init() {
		common.hideBottomBar();
		common.bindStockEvent(_pageId);
		$(_pageId+".main .fund_table").css("overflow-y","auto");
        var height_meau = $(window).height() - $(_pageId+".header").height() - $(_pageId+".tab_nav").height() - $(_pageId+".input_form").height() -15;
		$(_pageId+".main .fund_table").height(height_meau); //查询目录添加高度 
		queryMessages();
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId+".top_title .icon_back"), function(e){
			appUtils.pageInit("newshare/appointment","account/index",{});
			e.stopPropagation();
		});
		//下拉选择
		appUtils.bindEvent($(_pageId+".input_form .select_box"), function(e){
			$(_pageId+".select_box ul").slideToggle();
			e.stopPropagation();
		});
		//点击其他地方隐藏下拉框
		appUtils.bindEvent($(_pageId),function(e){
			if($(_pageId+".input_form .select_box ul").is(':visible')){
				$(_pageId+".input_form .select_box ul").slideToggle();
			}
			e.stopPropagation();	// 阻止冒泡
		});

	}
    
	/**
	 * 新股信息查询		
	 */
	function queryMessages(){
		var param = {	
		};
		service_stock.queryMakeApp(param,queryMakeAppCallBack,{"isLastReq":true,"isShowWait":true,"isShowOverLay":false});
	}
	function queryMakeAppCallBack(data){
		if(data.error_no == 0){
			$(_pageId+".fund_table #meauTr").next().html("");
			if(typeof data.results != "undefined" && data.results!= null && data.results != ""){
				var results = data.results;
				var list = ""; 
				var listHtml = "<ul style=\"display:none;\">";
				stockName = new Array();
				stockCode = new Array();
				for(var i = 0;i<results.length;i++){
					var element = results[i];
					stockName[i] = element.issuenameabbr_online;
					stockCode[i] = element.applycodeonline;
					list +=" <tr data-index="+i+" id = \"clickOn\">";
					list +="  <td><strong>"+element.issuenameabbr_online+"</strong><small>"+element.applycodeonline+"</small></td>";
					list +="  <td><span>"+element.issueprice+"</span></td>";
					list +="  <td>"+element.onlinestartdate+"</td>";
					list +=" </tr>";
					listHtml += "<li><a href=\"javascript:void(0);\"><strong>"+element.applycodeonline+"</strong>"+element.issuenameabbr_online+"</a></li>";
				}
				$(_pageId+".fund_table #meauTr").after(list);
				$(_pageId+".input_select .select_box").append(listHtml+"</ul>");
				//新股列表事件
				appUtils.bindEvent($(_pageId+" #clickOn"),function(e){
					var stockName = $(this).find("strong").text();
					var stockCode = $(this).find("small").text();
					$(_pageId +".input_select .select_box p").html("<strong>"+stockCode+"</strong>"+stockName);
				});
				//下拉列表点击事件
				appUtils.bindEvent($(_pageId+".select_box ul li"),function(){
					$(_pageId+".select_box p").html($(this).find("a").html());
				});
				
			}else{
				$(_pageId+ ".no_data").show();
			}
		}else{
			//layerUtils.iAlert("查询失败");
			$(_pageId+".fund_table #meauTr").next().html("");
			var listHtml = "<ul style=\"display:none;\">";
			var list ="";
			for(var i= 0;i<5;i++){
				
				list +=" <tr data-index="+i+" id = \"clickOn\">";
				list +="  <td><strong>"+"三木集团"+"</strong><small>"+"000632"+"</small></td>";
				list +="  <td><span>"+"8.77"+"</span></td>";
				list +="  <td>"+"2015-04-09"+"</td>";
				list +=" </tr>";
				listHtml += "<li><a href=\"javascript:void(0);\"><strong>"+"000632"+"</strong>"+"三木集团"+"</a></li>";
			}
			$(_pageId+".fund_table #meauTr").after(list);
			$(_pageId+".input_select .select_box").append(listHtml+"</ul>");
			//新股列表事件
			appUtils.bindEvent($(_pageId+" #clickOn"),function(e){
				var stockName = $(this).find("strong").text();
				var stockCode = $(this).find("small").text();
				$(_pageId +".input_select .select_box p").html("<strong>"+stockCode+"</strong>"+stockName);
			});
			//下拉列表点击事件
			appUtils.bindEvent($(_pageId+".select_box ul li"),function(){
				$(_pageId+".select_box p").html($(this).find("a").html());
			});
		}
	}

	/**
	 * 点击预约
	 */
	function make_Appointment(){
		var stock_code = $(_pageId+".select_box p strong").text();
		if(stock_code.length != "6" || !validator.isNumeric(stock_code)){
			layerUtils.iAlert("股票代码有误");
			return false;
		}
		//手机唯一标示，与原生交互获得
		if(gconfig.platform != "0"){
			var results = external.callFunction("55300","");
		}
		if(typeof results != "undefined" && results != null && results != "") {
				if(typeof results.result != "undefined" && results.result != ""){
					var from_token = results.result;
				}else{
					layerUtils.iAlert("未获取到设备ID");
					return false;
				}
		}else{
			layerUtils.iAlert("未获取到设备ID");
			return false;
		}
		var phone = "";
		var sendflag = "1";
		
		if(($(_pageId+" #isSend").attr("class"))=="btn on") {
			sendflag = "1";
			phone = appUtils.getSStorageInfo("trade_tel");	//手机号
		}else{
			phone = "";
			endflag = "0";
		}
		var chancel = "1";
		if(gconfig.platform == "2"){
			chancel = "1";	//渠道
		}else if (gconfig.platform == "1"){
			chancel = "0";	//渠道
		}
		var param = {
				"sendflag":sendflag,
				"token":from_token,
				"stockcode":stock_code,
				"chancel":"1",
				"phone":phone
			};
		service_stock.sendMessages(param,function(data){
			if(data.error_no == "0"){
				layerUtils.iAlert("预约成功");
			}else{
				layerUtils.iAlert(data.error_info);
			}
		});
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId+".fund_table #meauTr").next().html("");
		$(_pageId+".select_box p").html("请选择 ");
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("newshare/appointment","account/index",{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});