/**
 * 新股-中签查询
 */
define(function(require, exports, module) {
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var appUtils = require("appUtils");
	var layerUtils = require("layerUtils");
	var _pageId = "#credit_new_payHistoryQuery ";
	var service_credit = require("service_credit");
	var userInfo = null;
	//上下滑动组件
	var VIscroll = require("vIscroll");
	var vIscroll = {"scroll":null,"_init":false}; //上下滑动
	//左右滑动组件
    var shIscroll = require("shIscroll");
	var mySHIscroll = null;
	var common = require("common");
	
    /**
     * 初始化
     */
	function init() {
		common.hideBottomBar();
//		userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
			//从session中获取客户的信息
			userInfo = JSON.parse(appUtils.getSStorageInfo("credit_userInfo"));
		//数据查询
		queryPayHistory();
		//初始化上下滑动组件
		initVIScroll();
    }
	
	function queryPayHistory(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var password = userInfo.password;
		var exchange_type = "";
		var stock_code = "";
		var trd_date = "";
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "cust_code":cust_code,
			    "password":password,
			    "exchange_type":exchange_type,
			    "stock_code":stock_code,
			    "trd_date":trd_date
		};
		
		service_credit.queryPayHistory(param,queryPayHistoryCallback,{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":true,
			"tipsWords":"正在查询...",
			"timeOutFunc":function(){    //超时调用方法
				$(_pageId+ ".no_data").show();
	        }
		});
		
		function queryPayHistoryCallback(data){
			if(typeof(data) != undefined && typeof(data) != null) {
				if(data.error_no == 0){
					var results = data.results;
					if(results && results.length > 0){
						$(_pageId+".no_data").hide();
						var htmlData = "";
						for (var i=0;i<results.length;i++){
							htmlData += queryPayHistoryHTML(results[i]);
						}
						var ceTableObj = $(_pageId+".fund_table .ce_table tbody");
						ceTableObj.find("tr:eq(0)").siblings().remove();
						ceTableObj.append(htmlData);
					}else{
						$(_pageId+".no_data").show();
					}
				}else{
					layerUtils.iAlert(data.error_info);
				}
			}
			//初始化左右滑动组件
			myInitHIScroll();
		}
		
		//页面代码动态生成
		function queryPayHistoryHTML(results){
			var eleHtml = "";
				  eleHtml += "<tr>";
				  eleHtml += "<td><small>"+results.trd_date+"</small><br/><small>"+results.entrust_no+"</small></td>";
				  eleHtml += "<td><small>"+results.stock_code+"</small><br/><small>"+results.stock_name+"</small></td>";
				  eleHtml += "<td><small>"+results.order_price+"</small><br/><small>"+results.take_qty+"</small></td>";
				  eleHtml += "<td><small>"+results.take_date+"</small><br/><small>"+results.pay_date+"</small></td>";
				  eleHtml += "<td><small>"+results.pay_qty+"</small><br/><small>"+results.pay_amt+"</small></td>";
				  eleHtml += "<td><small>"+results.give_up_qty+"</small><br/><small>"+results.mkt_cfm_qty+"</small></td>";
				  eleHtml += "<td><small>"+results.fund_account+"</small><br/><small>"+results.stock_account+"</small></td>";
				  eleHtml += "<td><small>"+results.exchange_type_name+"</small><br/><small>"+results.board_name+"</small></td>";
				  eleHtml += "</tr>";
			return eleHtml;
		}
	}
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId+".top_title .icon_back"), function(e){
			appUtils.pageInit("credit/new/payHistoryQuery", "credit/new/more");
			e.stopPropagation();
		});
	}
	
	/**
	 * 初始化上下滑动组件
	 */
	function initVIScroll(){
		if(!vIscroll._init){
			var config = {
				"isPagingType": false,		//false表示是微博那种累加形式，true表示分页形式
				"visibleHeight": $(window).height() - $(_pageId+".top_title").height()- $(_pageId+".tab_nav").height() - 6  ,//显示内容区域的高度，当isPaingType为false时传
				"container": $(_pageId+" #v_container_funds_jj"),	
				"wrapper":$(_pageId+" #v_wrapper_funds_jj"),	
				"downHandle": function() {				//下拉获取上一页数据方法
					queryPayHistory();
				},
				"upHandle": function() {
					
				},
				"wrapperObj": null
			};
			vIscroll.scroll = new VIscroll(config); 	//初始化，需要做if(!hIscroll._init)判断
			vIscroll._init = true; 						//尽量只初始化一次，保持性能
		}else{
			vIscroll.scroll.refresh();
		}
		$(_pageId + ".visc_pullUp").css("display","none");
	}

	/**
	 * 初始化左右滑动组件
	 */
	function myInitHIScroll(){
		if(mySHIscroll){
			mySHIscroll.destroy();
			mySHIscroll = null;
		}
		if(!mySHIscroll){
			var config = {
				//获取两个指定的格式的对象
				wrapper: $(_pageId+" #wrapper_hMainPanel"), //wrapper对象
				container: $(_pageId+" #container_hMainPanel"), //container对象
				//滑动操作后要执行的方法
				onScrollEnd : function(){
					//滑动完成之后的处理，非必传
				}
			};
			mySHIscroll = new shIscroll(config);
			window.wrapperObj = config.wrapperObj;
			$(_pageId+" #wrapper_hMainPanel").css("position", "initial");
			$(_pageId+" #wrapper_hMainPanel").css("height", "48px");
		}
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId+".fund_table .ce_table tbody tr:eq(0)").siblings().remove();
		$(_pageId+".fund_table .ce_table").css("height","auto");
		//左右滑动组件
		mySHIscroll.destroy();
		mySHIscroll = null;
		//上下滑动组件
		vIscroll.scroll.destroy();
		vIscroll = {"scroll":null,"_init":false};
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});