/**
 * 新股-中签查询
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var _pageId = "#credit_new_payPrioritySetting ";
	var gconfig = require("gconfig");
	var layerUtils = require("layerUtils");
	var global = gconfig.global;
	var	service_credit = require("service_credit");
	var common = require("common");
	
    /**
     * 初始化
     */
	function init() {
		common.hideBottomBar();
		common.systemKeybord(); // 解禁系统键盘
//		userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
			//从session中获取客户的信息
			userInfo = JSON.parse(appUtils.getSStorageInfo("credit_userInfo"));
		//新股查询
		queryNewStkWithhold();
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId+".top_title .icon_back"), function(e){
			appUtils.pageInit("credit/new/payPrioritySetting","credit/new/more",{});
			e.stopPropagation();
		});
	}
    
	/**
	 * 新股中签查询
	 */
	function queryNewStkWithhold(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var sessionid = userInfo.session_id;
		var password = userInfo.password;;
		var end_time = new Date();  
		var begin_time  = new Date();	//截止时间
		begin_time.setDate(begin_time.getDate() - 30);
//		begin_time=begin_time.format("yyyy-MM-dd");
//		end_time.setDate(end_time.getDate() - 1);
//		end_time=end_time.format("yyyy-MM-dd");
		begin_time=begin_time.format("yyyyMMdd");
		end_time.setDate(end_time.getDate());
		end_time=end_time.format("yyyyMMdd");
		var param={				
			"entrust_way":entrust_way,
		    "branch_no":branch_no,
		    "fund_account":fund_account,
		    "cust_code":cust_code,
		    "password":password,
		    "sessionid":sessionid,
		    "stock_account":"",
		    "begin_date":begin_time,
		    "end_date":end_time
		};
		service_credit.success_Query(param, function(data){
			var errorNo = data.error_no,
				errorInfo = data.error_info;
			if (errorNo === "0"){
				var results = data.results,
					re_length = results.length;
				if (re_length > 0){
					var str = "";
					for(var i = 0; i < re_length; i++){
						var item = results[i],
							//中签数量
							take_qty = item.take_qty,
							//申购价格
							order_price = item.order_price,
							order_money = "--";
						if (!(isNaN(+take_qty) || isNaN(+order_price))){
							order_money = (order_price * take_qty).toFixed(2);
						}
						str += "<tr><td><strong>"+item.stock_name+"</strong><small>"+item.stock_code+"</small></td>";
						str += "<td>"+item.take_date+"</td><td><strong>"+take_qty+"</strong><small>"+order_money+"</small></td>";
						str += "<td><input type='tel' data-entrust_no="+item.entrust_no+" data-trd_date="+item.trd_date+" data-exchange_type="+item.exchange_type+" data-board="+item.board+" class='new-JK-set' /></td>";
					}
					$(_pageId + " .ce_table tbody").html(str);
					$(_pageId + " .ce_btn").show();
					//绑定提交事件
					bindSubmit();
				} else {
					$(_pageId + " .no_data").show();
				}
			} else {
				layerUtils.iAlert(errorInfo);
			}
		});
	}
	
	function bindSubmit(){
		appUtils.bindEvent($(_pageId + " .ce_btn>a"), function(e){
			var str = "",
				info = true;
			$(_pageId + " .new-JK-set").each(function(){
				var $this = $(this),
					entrust_no = $this.attr("data-entrust_no"),
					trd_date = $this.attr("data-trd_date"),
					exchange_type = $this.attr("data-exchange_type"),
					board = $this.attr("data-board"),
					val = $this.val(),
					is_num = /^\d$/g.test(val);
				if (is_num){
					val = val === "" ? " " : val;
					str += trd_date + ":" + exchange_type + ":" + board + ":" + entrust_no + ":" + val + "|";
				} else {
					info = false;
					return false;
				}
			});
			if (info){
				if (str){
					//提交设置
					setSubmit(str);
				}
			} else {
				layerUtils.iAlert("序号请设置为数字");
			}
			e.stopPropagation();
		}, "click");
	}
	
	function setSubmit(str){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no  = userInfo.branch_no;	 //分支机构
		var fund_account = userInfo.fund_account;//资产账户
		var cust_code = userInfo.cust_code;  	 //客户代码
		var sessionid = userInfo.session_id;
		var password = userInfo.password;
		var param = {
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"sessionid":sessionid,
//				"exchange_type": exchange_type,
//				"entrust_no": entrust_no,
//				"trd_date": trd_date,
//				"board": board,
//				"clearsno": val,
				"set_info": str
			};
		service_credit.setNewJK(param, function(data){
			var errorNo = data.error_no,
				errorInfo = data.error_info;
			if (errorNo === "0"){
				layerUtils.iAlert("设置委托已提交");
				$(_pageId + " .new-JK-set").val("");
			} else {
				layerUtils.iAlert(errorInfo);
			}
		});
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId + " .ce_btn").hide();
		$(_pageId + " .ce_table tbody").html("");
		$(_pageId + " .new-JK-set").val("");
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("credit/new/achieve",whichPage,{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});