/**
 *  信用交易-合约展期
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var common = require("common");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var validatorUtil = require("validatorUtil");
	var layerUtils = require("layerUtils");
	var service_credit = require("service_credit");
	var service_hq = require("service_hq");
	var external = require("external");
    var userInfo = null;  //账号信息
	var price_step = 0.01; //步长
	var price_digit = 2; //小数点位数
	var fifthOrder_timer = null; //五档定时器
	var position_timer = null; //持仓定时器
	var lotsOf = 100; //每手数量
	var _stockAccount="";
	var _market ="";
	var commonFunc = require("commonFunc");
    var _pageId = "#credit_order_contractRenewal ";
    var limitedMarketEntrust = "limited";  //判断是限价委托和是市价委托
    var enable_balance = "";
    var isChangePrice = true; //五档变化是否改变相应价格
    var _stockName = "";
    var stock_price = "";
	var up_stop = "";
	var down_stop = "";
    
    /**
     * 初始化
     */
	function init(){
		common.hideBottomBar();
		common.systemKeybord(); // 解禁系统键盘 
		$(_pageId).css("overflow-x","hidden");
        var height_table = $(window).height() - $(_pageId+".header").height() - $(_pageId+".repay_table").height() - $(_pageId+".table_head").height() - 10;
        $(_pageId + " .table_body").height(height_table).css("overflow", "auto");   //给持仓数据添加高度
		userInfo = JSON.parse(appUtils.getSStorageInfo("credit_userInfo"));
		if (!userInfo){
			appUtils.pageInit("credit/order/contractRenewal", "account/login", {});
		}
		//查询合约
		queryAgreement();
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		
		//返回按钮
		appUtils.bindEvent($(_pageId+".top_title .icon_back"), function(e){
			appUtils.pageInit("credit/order/contractRenewal","credit/index",{});
			e.stopPropagation();
		});
		
		//提交申请
		appUtils.bindEvent($(_pageId+".ce_btn>a"), function(e){
			var compact_id = $(_pageId + " #compact_id").html();
			if ((!compact_id) || (compact_id === "--")){
				layerUtils.iAlert("未选择申请合约");
			} else {
				//申请提交确认
				applySure();
			}
//			appUtils.pageInit("credit/order/contractRenewal","credit/index",{});
			e.stopPropagation();
		});
		
		//查询合约展
		appUtils.bindEvent($(_pageId + " .search_text"), function(e){
			appUtils.pageInit("credit/order/contractRenewal", "credit/query/queryRenewal", {"fromPage":"credit/order/contractRenewal"});
			e.stopPropagation();
		}, "click");
		
	}
	
	/**
	 *  未平仓合约查询
	 * 
	 */
	function queryAgreement(){
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置
		var branch_no  = userInfo.branch_no;	//分支机构
		var cust_code = userInfo.cust_code;	//客户代码
		var fund_account = userInfo.fund_account;	//
		var password = userInfo.password;
		var sessionid = userInfo.session_id;
		var param = {
				"entrust_way": entrust_way,
				"branch_no": branch_no,
				"cust_code": cust_code,
				"fund_account": fund_account,
				"password": password,
				"sessionid": sessionid,
				"compact_flag": "1",
				"compact_range": "0",
				"agreement": "1"
			};
		service_credit.contractmx_query(param, function(data){
			var errorNo = data.error_no,
				errorInfo = data.error_info;
			if (errorNo === "0"){
				var results = data.results,
					re_length = results.length;
				if (re_length > 0){
					$(_pageId + " .main .repay_table .input_select .select_box p").html("请选择合约");
					var list_str = "",
						tab_str = "";
					for (var i = 0; i < re_length; i++){
						var item = results[i],
							stock_name = item.stock_name,
							compact_id = item.compact_id,
							ret_end_date = item.ret_end_date,
							compact_type_name = item.compact_type === "0" ? "融资" : "融券";
						list_str += "<tr data-exchange_type='"+item.exchange_type+"' data-open_date='"+item.open_date+"' data-stock_name='"+stock_name+"' data-compact_id='"+compact_id+"' data-ret_end_date='"+ret_end_date+"'>" +
								"<td>" + compact_id + "</td><td>" + stock_name + "</td><td>" + ret_end_date + "</td></tr>";
						tab_str += "<tr data-exchange_type='"+item.exchange_type+"' data-open_date='"+item.open_date+"' data-stock_name='"+stock_name+"' data-compact_id='"+compact_id+"' data-ret_end_date='"+ret_end_date+"'>" +
								"<td>" + item.open_date + "<br>" + ret_end_date + "</td><td>" + compact_id + "<br>" + compact_type_name + "</td><td>" + stock_name + "<br>" + item.stock_code + "</td>" +
										"<td>" + Number(item.left_amt) + "<br>" +Number(item.left_qty)+ "</td></tr>";
					}
					$(_pageId + " .select_table tbody").html(list_str);
					$(_pageId + " .ce_table tbody").html(tab_str);
					//绑定点击事件
					bindClick();
				}else{
					$(_pageId + " .no_data").show();
					$(_pageId + " .main .repay_table .input_select .select_box p").html("暂无可展期的合约");
				}
				
			}else{
				layerUtils.iAlert(errorInfo);
			}
		});
	}
	
	/**
	 * 绑定合约选定事件
	 */
	function bindClick(){
		
		//点击选择合约
		appUtils.bindEvent($(_pageId + " .select_box"), function(e){
			$(_pageId + " .select_table").fadeToggle();
			e.stopPropagation();
		}, "click");
		
		//下拉选择点击
		appUtils.bindEvent($(_pageId + " .select_table tbody tr"), function(e){
			var $this = $(this);
			$(_pageId + " #open_date").html($this.attr("data-open_date"));
			$(_pageId + " #stock_name").html($this.attr("data-stock_name"));
			$(_pageId + " #compact_id").html($this.attr("data-compact_id"));
			$(_pageId + " #ret_end_date").html($this.attr("data-ret_end_date"));
			$(_pageId + " #ret_end_date").data("exchange_type", $this.attr("data-exchange_type"));
			$(_pageId + " .select_table").fadeToggle();
			e.stopPropagation();
		}, "click");
		
		//
		appUtils.bindEvent($(_pageId), function(){
			$(_pageId + " .select_table").hide();
		}, "click");
		
		//下部查询点击
//		appUtils.bindEvent($(_pageId + " .ce_table tbody tr"), function(e){
//			var $this = $(this);
//			$(_pageId + " #open_date").html($this.attr("data-open_date"));
//			$(_pageId + " #stock_name").html($this.attr("data-stock_name"));
//			$(_pageId + " #compact_id").html($this.attr("data-compact_id"));
//			$(_pageId + " #ret_end_date").html($this.attr("data-ret_end_date"));
//			$(_pageId + " #ret_end_date").data("exchange_type", $this.attr("data-exchange_type"));
//			$(_pageId + " .select_table").fadeToggle();
//			$(_pageId + " .main").scrollTop(0);
//			e.stopPropagation();
//		});
	}
	
	/**
	 * 
	 */
	function applySure(){
		var exchange_type = $(_pageId + " #ret_end_date").data("exchange_type"),
			stock_name = $(_pageId + " #stock_name").html(),
			compact_id = $(_pageId + " #compact_id").html();
		if(stock_name == null || stock_name == ""){
			layerUtils.iMsg(-1,"股票名字不能为空");
			return false;
		}
		if(compact_id == null || compact_id == ""){
			layerUtils.iMsg(-1,"未选择申请合约");
			return false;
		}
		var str = "<div class=\"pop_header\"><h3>确认委托<a href='javascript:void(0);' class='close'></a></h3></div><div class=\"pop_main\"><p>您是否确认委托申请？</p>";
		str += "<ul><li>股票名称: "+stock_name+"</li>";
		str += "<li>委托类型: 合约展期</li>";
		str += "<li>合约编号: "+compact_id+"</li></ul></div>";
		common.btnConfirmCrit(str, function(){
			var param = {
					"entrust_way": global.entrust_way,
					"branch_no": userInfo.branch_no,
					"open_date": $(_pageId + " #open_date").html(),
					"cust_code": userInfo.cust_code,
					"exchange_type": exchange_type,
					"compact_id": compact_id
			};
			service_credit.entrustRollover(param, function(data){
				var errorNo = data.error_no,
					errorInfo = data.error_info;
				if (errorNo === "0"){
					layerUtils.iAlert("委托已提交");
					queryAgreement();
				} else {
					layerUtils.iAlert(errorInfo);
				}
			});
		});
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId + " .main").scrollTop(0);
		$(_pageId + " .select_table tbody").html("");
		$(_pageId + " .ce_table tbody").html("");
		$(_pageId + " #open_date").html("");
		$(_pageId + " #stock_name").html("");
		$(_pageId + " #compact_id").html("");
		$(_pageId + " #ret_end_date").html("");
		$(_pageId + " #ret_end_date").data("");
		$(_pageId + " .select_table").hide();
		$(_pageId + " .main .repay_table .input_select .select_box p").html("请选择合约");
		$(_pageId + " .no_data").hide();
		compact_id = null;
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});