/**
 * 信用交易-融券卖出
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var common = require("common");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var validatorUtil = require("validatorUtil");
	var layerUtils = require("layerUtils");
	var service_credit = require("service_credit");
	var service_hq = require("service_hq");
    var commonTrade = require("commonTrade");
	var SVIscroll = require("svIscroll");
	var external = require("external");
	var svIscroll = null;
	var stockCodeArr = [];//保存股票股票代码
	var stockNameArr = [];//保存股票英文简写名称
    //var userInfo = null;  //账号信息
	var price_step = 0.01; //步长
	var price_digit = 2; //小数点位数
	var fifthOrder_timer = null; //五档定时器
	var position_timer = null; //持仓定时器
	var lotsOf = 100; //每手数量
	var _stockAccount="";
	var _market ="";
	var commonFunc = require("commonFunc");
    var _pageId = "#credit_order_financingToSell ";
    var isChangePrice = true; //五档变化是否改变相应价格
    var _stockName = "";
    var stock_price = "";
	var up_stop = "";
	var down_stop = "";
	var entrust_bs = "1";
    
    /**
     * 初始化
     */
	function init(){common.hideBottomBar();
		common.systemKeybord(); // 解禁系统键盘
		$(_pageId+".fund_table").scrollTop(0);
        var height_table = $(window).height() - $(_pageId+".header").height() - $(_pageId+".tab_nav").height() - $(_pageId+".trade_main").height()-27;
        $(_pageId+".fund_table").height(height_table);   //给持仓数据添加高度
		userInfo = JSON.parse(appUtils.getSStorageInfo("credit_userInfo"));
		var stockCode = appUtils.getPageParam("stockCode");
		//查询个股行情
		if(stockCode){
			$(_pageId+"#stockCode").val(stockCode);
//			getStockList(stockCode);
			commonTrade.getStockList(_pageId,stockCode,entrust_bs);
		}else{
			$(_pageId+".fund_table").scrollTop(0);
		}
		if(position_timer != null ) {
	        window.clearInterval(position_timer);
	    }
//		clearBuyMsg();
		commonTrade.clearBuyMsg(_pageId,entrust_bs,stockCode);
//		window.setTimeout(commonFunc.queryHolding(_pageId,6),100);
//		if(global.isTrade){
//	        position_timer = window.setInterval(commonFunc.queryHolding(_pageId,6), 10000);
//		}
		queryData();
		if(gconfig.platform=="0"){ //方便pc端调试
			$(_pageId+"#stockCode").attr("readonly",false);
		}	
    }

	
	/**
	 * 查询数据
	 */
	function queryData(stockCode)
	{
//		if(svIscroll){
//			svIscroll.destroy();
//			svIscroll = null;
//
//		}
		stockCodeArr.length = 0;//保存股票英文简写名称
		queryMsg = null;//查询后返回的结果集
		$(_pageId+ ".no_data").hide();
		$(_pageId+" .ti_table tr:eq(0)").nextAll().remove();
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	//分支机构
		var fund_account = userInfo.fund_account;	//资产账户
		var cust_code = userInfo.cust_code;	//客户代码
		var sessionid = userInfo.session_id;
		var password = userInfo.password;
		var stock_code = stockCode ? stockCode : "";
		var exchange_type = "";
		var param = {			
			"entrust_way":entrust_way,
			"branch_no":branch_no,
			"fund_account":fund_account,
			"cust_code":cust_code,
			"password":password,
			"sessionid":sessionid,
			"stock_code":stock_code,
			"exchange_type":exchange_type
		};
		service_credit.queryCanBeMargin(param,queryCallBack,{"isShowWait":false});
	}
	function queryCallBack(data)
	{
		if (data) {
			if(data.error_no == 0)
			{
				var results = data.results;	
				queryMsg = data.results;//将返回的结果集保存
				if(results && results.length > 0)
				{
//					if((!results[0].enable_amount)&&financialSecurities){
//						return false;
//					}
//					if((results[0].enable_amount)&&(!financialSecurities)){
//						return false;
//					}
					$(_pageId+" .ce_table tr:eq(0)").nextAll().remove();
					var dataHtml = "";
					for(i = 0;i < results.length; i++)
					{
						var data = results[i];
						dataHtml += createHtml(data);
					}
					$(_pageId+" .ce_table tr:eq(0)").after(dataHtml);
					
					//点击股票显示行情
					appUtils.bindEvent($(_pageId+".fund_table .ce_table tr:gt(0)"), function(e){
						var stock_code = $(this).attr("id");
						$(_pageId + " #stockCode").val(stock_code).trigger("input");						//appUtils.pageInit("","credit/order/financingToSell",{"stockCode":stock_code,"isHold":false});
						e.stopPropagation();
					},"click");
					
					
					
				}
				else{
					$(_pageId+" .ce_table tr:eq(0)").nextAll().remove();
					$(_pageId+ ".no_data").show();
				}
				
//				if(!svIscroll){
//						var config = {
//								wrapper: $(_pageId+" #fund_table"), //wrapper对象
//								container: $(_pageId+" #thedivst"), //container对象
//								containerHeight: $(window).height() - $(".top_title").outerHeight() - $(".tab_nav").outerHeight() - $(".search_box").outerHeight()
//						};
//						svIscroll = new SVIscroll(config);
//				}
				
				
			}
			else
			{
				$(_pageId+" .ce_table tr:eq(0)").nextAll().remove();
				layerUtils.iAlert(data.error_info);
			}
		}
	}
	/**
	 * 生成html
	 * @param {Object} element 数据项
	 */
	function createHtml(element)
	{
		var eleHtml = "";
		    eleHtml += "<tr id='"+element.stock_code+"'>";
			eleHtml += "<td>"+element.stock_name+"</td>";
			eleHtml += "<td>"+element.stock_code+"</td>";
			eleHtml += "<td>"+element.enable_amount+"</td>";
			eleHtml += "<td>"+element.slo_ratio+"</td>";
//			eleHtml += "<td>"+element.bail_ratio+"</td>";
     		eleHtml +="</tr>";
		return eleHtml;
	}


	
	
	
	
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId+".top_title .icon_back"), function(e){
			appUtils.pageInit("credit/order/financingToSell","credit/index",{});
			e.stopPropagation();
		});
		//导航菜单绑定事件
		appUtils.bindEvent($(_pageId + ".main .tab_nav ul li a"),function(e){
			topage = $(this).attr("to-page").replaceAll("_","/"); //获取跳转的页面
			var param =  $(this).attr("param"); //获取跳转页面参数
			appUtils.pageInit("credit/order/financingToSell",topage,{"param":param});
			e.stopPropagation();
		});
		//点击标的事件
		appUtils.bindEvent($(_pageId+".search_text"),function(e){
			appUtils.pageInit("credit/order/financingToSell","credit/query/queryCanRZBuyStock",{});
			e.stopPropagation();
		},"click");
		//股票代码输入框监听
		appUtils.bindEvent($(_pageId+"#stockCode"), function(e){
//			clearBuyMsg();
			commonTrade.clearBuyMsg(_pageId,entrust_bs,stockCode);
			e.stopPropagation();
		},"focus");
		appUtils.bindEvent($(_pageId+"#stockCode"), function(e){
			var stockCode = $(this).val();
			//clearBuyMsg();
			$(_pageId+"#stockName").text("");
			var vail=/^[A-Za-z]+$/;
			if(stockCode.length>1 && vail.test(stockCode)){
				$(_pageId+"#stockName").text("");
//				getStockList(stockCode);
				commonTrade.getStockList(_pageId,stockCode,entrust_bs);
				if(stockCode.length<2){
					$(_pageId+"#stock_list").html("");
				}
			}else if(stockCode.length>3){
				$(_pageId+"#stockName").text("");
//				getStockList(stockCode);
				commonTrade.getStockList(_pageId,stockCode,entrust_bs);
				if(stockCode.length<4){
					$(_pageId+"#stock_list").html("");
				}
			}/*else{
//				clearBuyMsg();
		        commonTrade.clearBuyMsg(_pageId,entrust_bs,stockCode);
			}*/
			//$(_pageId+".trade_form .input_box .stat").hide();
			e.stopPropagation();
		},"input");

		//股票代码输入框调用原生键盘
		appUtils.bindEvent($(_pageId+".trade_form .input_code"), function(e){
			$(_pageId+"#stockCode").focus();
			var code =$.trim($(_pageId+"#stockCode").val().substring(0,6));
			$(_pageId+"#stockCode").val(code);
			window.customKeyboardEvent = {
				keyBoardFinishFunction: function(){},
				keyBoardInputFunction: function(){
					var stockCode = $.trim($(_pageId+"#stockCode").val().substring(0,6));
//					clearBuyMsg();
					commonTrade.clearBuyMsg(_pageId,entrust_bs,stockCode);
					var vail=/^[A-Za-z]+$/;
					if(stockCode.length>1 && vail.test(stockCode)){
//						getStockList(stockCode);
						commonTrade.getStockList(_pageId,stockCode,entrust_bs);
						if(stockCode.length<2){
							$(_pageId+"#stock_list").html("");
						}
					}else if(stockCode.length>3){
//						getStockList(stockCode);
						commonTrade.getStockList(_pageId,stockCode,entrust_bs);
						if(stockCode.length<4){
							$(_pageId+"#stock_list").html("");
						}
					}else{
//						clearBuyMsg();
						commonTrade.clearBuyMsg(_pageId,entrust_bs,stockCode);
					}
					$(_pageId+".trade_form .input_box .stat").hide();
				}
			};
			external.callMessage({"moduleName":"common","source":"trade","funcNo": "50210", "pageId":"credit_order_financingToSell", "eleId":"stockCode", "doneLable":"done", "keyboardType":"2"});
			e.stopPropagation();
		},"click");

		//失去焦点关闭原生键盘
		appUtils.bindEvent($(_pageId+"#stockCode"),function(e){
			external.callMessage({"moduleName":"common","funcNo": "50211"});
			var stockCode = $.trim($(_pageId+"#stockCode").val());
			if(stockCode.length==6){
				$(_pageId+"#stockCode").val(stockCode+" "+_stockName);
			}
			e.stopPropagation();
		},"blur");
		//股票数量输入框
		appUtils.bindEvent($(_pageId+"#stockNum"), function(e){
//			totalValue();
			commonTrade.totalValue(_pageId);
			e.stopPropagation();
		},"input");
		//价格输入框
		appUtils.bindEvent($(_pageId+"#stockPrice"), function(e){
//			totalValue();
			commonTrade.totalValue(_pageId);
			var stockCode = $.trim($(_pageId+"#stockCode").val().substring(0,6));
//			queryMaxAmount(stockCode);
		    commonTrade.queryMaxAmount(_pageId,stockCode,entrust_bs);
			e.stopPropagation();
		},"blur");
		//增加价格
		appUtils.bindEvent($(_pageId+".trade_main .input_box .add"),function(e){
			var stockCode = $(_pageId + "#stockCode").val();
			if(stockCode && stockCode.length>0){
				var curPrice = $(_pageId+"#stockPrice").val();
				if(curPrice == "" || !validatorUtil.isNumberFloat(curPrice)){
					$(_pageId+"#stockPrice").val("");
					return false;;
				}
				curPrice = Number(curPrice);  
				if(curPrice >= 0&&curPrice<999999999){
					curPrice = (parseFloat(curPrice)+parseFloat(price_step)).toFixed(price_digit);
					$(_pageId+"#stockPrice").val(curPrice);
				}
			}else{
				layerUtils.iAlert("请先输入合法的股票代码");
			}
//			totalValue();
			commonTrade.totalValue(_pageId);
			var stockCode = $.trim($(_pageId+"#stockCode").val().substring(0,6));
//			queryMaxAmount(stockCode);
		    commonTrade.queryMaxAmount(_pageId,stockCode,entrust_bs);
			e.stopPropagation();
		},"touchstart");
		//减少价格
		appUtils.bindEvent($(_pageId+".trade_main .input_box .less"),function(e){
			var stockCode = $(_pageId + "#stockCode").val();
			if(stockCode && stockCode.length>0){
				var curPrice = $(_pageId+"#stockPrice").val();
				if(curPrice == "" || !validatorUtil.isNumberFloat(curPrice)){
					$(_pageId+"#stockPrice").val("");
					return false;;
				}
				curPrice = Number(curPrice);   
				if(curPrice-price_step >= 0){
					curPrice=(parseFloat(curPrice)-parseFloat(price_step)).toFixed(price_digit);
					$(_pageId+"#stockPrice").val(curPrice);
				}
			}else{
				layerUtils.iAlert("请先输入合法的股票代码");
			}
//			totalValue();
			commonTrade.totalValue(_pageId);
			var stockCode = $.trim($(_pageId+"#stockCode").val().substring(0,6));
//			queryMaxAmount(stockCode);
		    commonTrade.queryMaxAmount(_pageId,stockCode,entrust_bs);
			e.stopPropagation();
		},"touchstart");
		//五档买卖盘联动
		appUtils.bindEvent($(_pageId+".five_box ul li"),function(e){
			var curPrice=$(this).find("span").text();
			if(curPrice && curPrice!="--"){
				$(this).siblings().removeClass("active");
				$(this).parent().siblings().find("li").removeClass("active");
				$(this).addClass("active");
				curPrice = isNaN(Number(curPrice)) ? 0 : curPrice;
				$(_pageId+"#stockPrice").val(curPrice);
//				totalValue();
				commonTrade.totalValue(_pageId);
			    var stockCode = $.trim($(_pageId+"#stockCode").val().substring(0,6));
//			    queryMaxAmount(stockCode);
			    commonTrade.queryMaxAmount(_pageId,stockCode,entrust_bs);
			}
			e.stopPropagation();
		});
		//下单
		appUtils.bindEvent($(_pageId+"#submitOrder"),function(e){
			vailSubmitOrder();
			e.stopPropagation();
		});
		//点击其他位置去掉五档点击效果
		appUtils.bindEvent($(_pageId),function(e){
			$(_pageId+".five_box ul li").removeClass("active");
                        $(_pageId+"#stock_list").html("");
			e.stopPropagation();
		});
			//滚动联动
		appUtils.bindEvent($(_pageId+".input_slider .r1"), function(e){
			var buyLimit = $(_pageId+"#buyLimit").text();
			if(validatorUtil.isNumeric(buyLimit)){
				var turn = $(this).val();
				var stockNum = ((buyLimit*turn)/(100*lotsOf)).toFixed(0)*lotsOf;
				if(turn==100){
					stockNum = buyLimit;
				}
				$(_pageId+"#stockNum").val(stockNum);
//				totalValue();
				commonTrade.totalValue(_pageId);
			}
			e.stopPropagation();
		},"input");
		//现价委托和市价委托切换   
		appUtils.bindEvent($(_pageId+".button-group a"), function(e){
			//$(_pageId+".input_select .select_box ul").css("display","none");
//			$(this).addClass("current").siblings().removeClass("current");
			var stockCode=$(_pageId + "#stockCode").val();
			if($(this).index() == 0){
				if(stockCode==null || stockCode==""){
					limitedMarketEntrust = "limited";
					$(_pageId+".input_box.in").show();
					$(_pageId+".input_select.mt10").hide();
					$(_pageId+"#buyLimit").hide();
				}else{
					limitedMarketEntrust = "limited";
					$(_pageId+".input_box.in").show();
					$(_pageId+"#buyLimit").show();
					$(_pageId+".input_select.mt10").hide();
				}
			}else{
//				limitedMarketEntrust = "market";
//				$(_pageId+".input_box.in").hide();
//				$(_pageId+"#buyLimit").hide();
//				$(_pageId+".input_select.mt10").show();
//				$(_pageId + ".ce_btn small").text("");
			}
			e.stopPropagation();
		},"click");

		

	}
 
	
	//计算当前总值
//	function totalValue(){
//		var stockNum = $(_pageId+"#stockNum").val();
//		var stockCode = $.trim($(_pageId+"#stockCode").val().substring(0,6));
//		var stockPrice = $(_pageId+"#stockPrice").val();
//		if(stockCode && validatorUtil.isNumberFloat(stockPrice) && validatorUtil.isNumeric(stockNum)){
//			$(_pageId+".trade_form .input_box .stat").show();
//			$(_pageId+".trade_form .input_box .stat span").text("总值"+common.numToMoneyType(""+(stockPrice*stockNum).toFixed(2)));
//		}else{
//			$(_pageId+".trade_form .input_box .stat").hide();
//		}
//	}
//	
	
	/**
	 * 获取股票列表
	 * */
//	function getStockList(stockStr){
//		if(stockStr != ""){
//			var stockStrParam = {
//				"q" : stockStr
//			};
//			service_hq.getStockList(stockStrParam,function(data){
//				if(data.errorNo == 0){
//					$(_pageId+"#stock_list").html("");
//					var results = data.results;
//					//显示股票列表
//					if(results && results.length > 0){
//						if(results.length == 1 && stockStr.length==6){
//							$(_pageId+"#stock_list").html("");
//							var market = results[0][9];
//							var stockCode = results[0][1];
//							getStockInfo(market,stockCode);
//						}else{
//							if(results.length >= 6){
//								var selectHeight = 6 * 0.44;
//							}else{
//								selectHeight = 0.44*results.length;
//							}
//							var listHtml = "<ul style=\"display:block;overflow-y:auto;height:"+selectHeight+"rem\">";
//							for(var i = 0;i < results.length; i++) {
//								listHtml += "<li><a href=\"javascript:void(0);\" style=\"padding-left:0.20rem;\"><strong style=\"font-size:0.18rem\">"+results[i][1]+"</strong>"+results[i][0]+"</a>";
//								listHtml +=	"<span style=\"display:none;\">"+results[i][9]+"</span></li>";
//							};
//							listHtml+="</ul>";
//							$(_pageId+"#stock_list").append(listHtml);
//							appUtils.bindEvent($(_pageId+".trade_form .select_box ul li"),function(){
//								var market = $(this).find("span").text();
//								var stockCode = $(this).find("strong").text();
//								$(_pageId+"#stock_list").html("");
//								getStockInfo(market,stockCode);
//							});
//						}
//					}else{
//						layerUtils.iAlert("该股票列表不存在");
//                                                _stockName = "";
//					}
//				}else{
//					layerUtils.iAlert("获取股票列表失败");
//				}
//			},{"isShowWait":false});
//		}	
//	}
//	
//	/**
//	 * 获取股票个股行情
//	 * 
//	function getStockInfo(market,stockCode){
//		if(stockCode && market){
//			if (fifthOrder_timer != null ) {
//		        window.clearInterval(fifthOrder_timer);
//		    }
//			var stockStrParam = {
//				"stock_list" : market+":"+stockCode
//			};
//			//查询个股行情
//				service_hq.getStockNowPrice(stockStrParam,function(data){
//				    common.decimalKeep1(stockCode,function(result){  //获取保留的位数
//				    price_digit = result.keepNum;
//				    var is_bond = result.is_bond;
//			    	if(data.errorNo == 0){
//						var results = data.results;
//						if(results && results.length>0){
//	                        $(_pageId+"#stock_list").html("");
//							//$(_pageId+".mod_stock_item #stock_list").hide();
//							$(_pageId+"#stockCode").val(""); // 每次修改股票代码，那么将初始值置为0
//							bazaarCode = results[0][9];
//							if(results[0][15] == "1"){
//								layerUtils.iAlert("该股票已停牌");
//								$(_pageId+" #stockCode").text("股票名称");
//								$(_pageId+" #stockName").text("");
//								return false;
//							}
//							
//							var price = results[0][2] ? results[0][2]:results[0][6];
//							stkType = results[0][10];    //行情类别
//							var stockVal = results[0][1];    //股票代码
//
//							var price_step_const = [10,12,13,4,6,19,20,3,11,16];  //最小变动单位为0.001的
//							var step_flag = $.inArray(stkType, price_step_const);
//							var typeName = common.getStockType(stkType);
//							$(_pageId + ".trade_form .input_box label").text(typeName);
//							// 上海国债逆回购
//							if(stockVal.substring(0,3) == "204"){
//								price_step = 0.005;
//								lotsOf = 1000;
//							}
//
//			               if(step_flag == -1){ // 否则浮动为0.01
//								price_step = 0.01;
//							}else{  // 变动价格为0.001
//								price_step = 0.001;
//							}
//							var yesterdayClose = results[0][6]; //昨收
//							if(typeof yesterdayClose == "undefined" || yesterdayClose == ""){
//								yesterdayClose = 0 ;
//							}
//							if(is_bond == "1"){  //上海债券
//								$(_pageId + "#buyLimit").text("手");
//								$(_pageId + ".input_num em").text("手");
//								lotsOf = 10;
//							}else if(is_bond == "2"){  //深圳债券
//								$(_pageId + ".limit span").text("张");
//								$(_pageId + ".input_num em").text("张");
//								lotsOf = 10;
//							}else{  //其他股票
//								up_stop = Number(results[0][13]).toFixed(price_digit);
//								down_stop = Number(results[0][14]).toFixed(price_digit);
//								$(_pageId + "#up_stop").html(up_stop).attr("class","ared");
//								$(_pageId + "#down_stop").html(down_stop).attr("class","agreen");
//								
//								//$(_pageId + "#gains").html("&nbsp;"+gains).attr("class",css);//涨幅-----------------------
//								//$(_pageId + "#currentPrice").attr("class",css);//现价-------------------------------------------
//								$(_pageId + ".limit span").text("股");
//								$(_pageId + ".input_num em").text("股");
//								lotsOf = 100;
//							}
//							//证券代码显示  
//							$(_pageId + "#stockCode").val(results[0][1]);
//							$(_pageId + "#stockName").html(results[0][0]);
//							//$(_pageId + "#stockCode").blur();
//							_stockName = results[0][0];
//							//证券名称显示
//							//$(_pageId + "#stockName").html(results[0][0]);
//							stock_price = price.toFixed(price_digit);
//							//$(_pageId + "#stockPrice").val(price);
//							
//							//保存此股票的市场类型
//							//$(_pageId+ " .mod_stock_buy .fl").find("p").attr("id",results[0][9]);
//							
//							//保存此股票的信息
//							var market = results[0][9];
//							var stockCode = results[0][1];
//							if(typeof market != "undefined" && market != "" && market != null && stockCode.length == "6"){
//								var stockMsg = market+":"+stockCode;
//								appUtils.setLStorageInfo("stockMsg",stockMsg);
//							}
//							//股票联动,查询股票信息，最大可买
//							queryMaxAmount($.trim($(_pageId+"#stockCode").val().substring(0,6)));
//							//调用五档行情
//							var stock_list = results[0][9] + ":" + results[0][1];
//							if (fifthOrder_timer != null ) {
//						        window.clearInterval(fifthOrder_timer);
//						    }
//							isChangePrice = true;
//							window.setTimeout(setFifthOrder(stock_list),100);
//							if(global.isTrade){
//								fifthOrder_timer =  window.setInterval(setFifthOrder(stock_list), 10000);//定时刷新
//							}
//
//						}else{
//							$(_pageId+"#stock_list").hide();
//							clearBuyMsg();
//							layerUtils.iLoading(false);
//							layerUtils.iAlert("该股票不存在");
//	                                        	_stockName = "";
//						}
//					}else{
//						clearBuyMsg();
//						layerUtils.iAlert(data.error_info);
//					}
//				});
//				},{"isLastReq":false,"isShowWait":false});
//
//		}
//	}

//	//五档买卖盘
//	function setFifthOrder(stock_list){
//		
//		 return function() {//为了解决定时器不能传参数的问题	 
//			 if(stock_list){
//				var fifthOrder = {
//					"stock_list" : stock_list
//				};
//				service_hq.getStockFiveStep(fifthOrder,callbackFifthOrder,{"isShowWait":false});
//			 } 
//		 };
//
//	}
//	//回调五档买卖盘
//	function callbackFifthOrder(data){
//		if(data.errorNo == 0){
//			var results = data.results;
//			if(results && results.length>0){
//				$(_pageId+"#stock_list").html("");
//				var stock_gear = $(_pageId+" .five_box ul li");
//				var yesProfit = Number(results[0][26]).toFixed(price_digit);
//				if(isChangePrice){
//					var nowPrice = Number(results[0][30]).toFixed(price_digit);
//					if(nowPrice == down_stop){
//						$(_pageId + "#stockPrice").val(nowPrice);
//					}else{
//						$(_pageId + "#stockPrice").val(Number(results[0][16]).toFixed(price_digit));
//					}
//					isChangePrice = false;
//				}
//				/**
//				 * 此处逻辑:买卖五档盘也是根据昨收作比较,将受到的五档盘颜色信息保存在集合中,在给五档盘价格赋值和样式
//				 */
//				//卖五档盘颜色集合
//				var soldFiveOrder = [];
//				for(var i = 0 ; i < 5 ; i ++){
//					var fivePirce = results[0][(i+6)];
//					if(yesProfit <fivePirce){
//						soldFiveOrder[i] = "ared";
//					}else if(yesProfit >fivePirce){
//						soldFiveOrder[i] = "agreen";
//					}else{
//						soldFiveOrder[i] = "";
//					}
//				}
//				//买五档盘颜色集合
//				var buyFiveOrder = [];
//				for(var i = 0 ; i < 5 ; i ++){
//					var fivePirce = results[0][(i+16)];
//					if(yesProfit <fivePirce){
//						buyFiveOrder[i] = "ared";
//					}else if(yesProfit >fivePirce){
//						buyFiveOrder[i] = "agreen";
//					}else{
//						buyFiveOrder[i] = "";
//					}
//				}
//				//卖
//				stock_gear.eq(0).find("span").text(Number(results[0][6]).toFixed(price_digit)).attr("class",soldFiveOrder[0]);
//				stock_gear.eq(0).find("em").text(overAMillion(results[0][11]));
//				stock_gear.eq(1).find("span").text(Number(results[0][7]).toFixed(price_digit)).attr("class",soldFiveOrder[1]);
//				stock_gear.eq(1).find("em").text(overAMillion(results[0][12]));
//				stock_gear.eq(2).find("span").text(Number(results[0][8]).toFixed(price_digit)).attr("class",soldFiveOrder[2]);
//				stock_gear.eq(2).find("em").text(overAMillion(results[0][13]));
//				stock_gear.eq(3).find("span").text(Number(results[0][9]).toFixed(price_digit)).attr("class",soldFiveOrder[3]);
//				stock_gear.eq(3).find("em").text(overAMillion(results[0][14]));
//				stock_gear.eq(4).find("span").text(Number(results[0][10]).toFixed(price_digit)).attr("class",soldFiveOrder[4]);
//				stock_gear.eq(4).find("em").text(overAMillion(results[0][15]));
//				//买
//				stock_gear.eq(5).find("span").text(Number(results[0][16]).toFixed(price_digit)).attr("class",buyFiveOrder[0]);
//				stock_gear.eq(5).find("em").text(overAMillion(results[0][21]));
//				stock_gear.eq(6).find("span").text(Number(results[0][17]).toFixed(price_digit)).attr("class",buyFiveOrder[1]);
//				stock_gear.eq(6).find("em").text(overAMillion(results[0][22]));
//				stock_gear.eq(7).find("span").text(Number(results[0][18]).toFixed(price_digit)).attr("class",buyFiveOrder[2]);
//				stock_gear.eq(7).find("em").text(overAMillion(results[0][23]));
//				stock_gear.eq(8).find("span").text(Number(results[0][19]).toFixed(price_digit)).attr("class",buyFiveOrder[3]);
//				stock_gear.eq(8).find("em").text(overAMillion(results[0][24]));
//				stock_gear.eq(9).find("span").text(Number(results[0][20]).toFixed(price_digit)).attr("class",buyFiveOrder[4]);
//				stock_gear.eq(9).find("em").text(overAMillion(results[0][25]));
//			}
//		}else{
//			layerUtils.iAlert(data.error_info);
//		}
//	}
//	//数量过万改以万为单位
//	function overAMillion(num){
//		num = Number(num);
//		if(num >= 10000){
//			num = (num/10000).toFixed(2) + "万";
//		}
//		return num;
//	}
	
	/**
	 * 查询买入可用资金最大可买数量
	 * */
//	function queryMaxAmount(stockCode){
//		
//		if(!stockCode){
//			return false;
//		}
//		var entrust_way = global.entrust_way; // 委托方式  在configuration配置
//		var branch_no  = userInfo.branch_no;	//分支机构
//		var fund_account = userInfo.fund_account;	//资产账户
//		var cust_code = userInfo.cust_code;	//客户代码
//		var password = userInfo.password;
//		var sessionid = userInfo.session_id;
//		var entrust_bs = "1";
//		var stockCode = stockCode;
//		var entrust_type = "7";
//		var stock_accounts =  "";
//		var entrust_price = stock_price;
//		var param = {
//				"entrust_way":entrust_way,
//				"branch_no":branch_no,
//				"fund_account":fund_account,
//				"cust_code":cust_code,
//				"password":password,
//				"sessionid":sessionid,
//				"entrust_bs":entrust_bs,
//				"stock_code":stockCode,
//				"entrust_price":entrust_price,
//				"entrust_type":entrust_type,
//				"stock_accounts":stock_accounts
//			};
//		service_credit.stock_link(param,queryMaxAmountCallBack,{"isLastReq":true,"isShowWait":false});
//	}

//	function queryMaxAmountCallBack(data){
//		if(data.error_no == 0){
//			var results = data.results;
//			if(results.length>0){
//				$(_pageId+"#buyLimit").text(Number(results[0].stock_max_amount));
////				$(_pageId+"#stockPrice").val(Number(results[0].price).toFixed(price_digit));
////				$(_pageId+"#stockName").text(results[0].stock_name);
//				_market=results[0].exchange_type;
//				_stockAccount=results[0].stock_account;
//			}
//		}else{
//			layerUtils.iAlert(data.error_info);
//		}
//	}
	/**
	 * 下单验证
	 * */
	function vailSubmitOrder()
	{	
		//验证股票代码输入是否正确
		var buy_stockCode = $.trim($(_pageId+"#stockCode").val().substring(0,6));
		if(buy_stockCode.length == 0){
			layerUtils.iMsg(-1,"请输入股票代码");
			return false;
		}	
		if(buy_stockCode.length <5){
			layerUtils.iMsg(-1,"股票代码输入错误");
			return false;
		}	
		//验证股票价格输入是否正确
		var up_stop = $(_pageId+"#up_stop").text();
		var down_stop = $(_pageId+"#down_stop").text();
		var now_price = $(_pageId+"#stockPrice").val();
		if($.trim(now_price).length<=0||parseFloat(now_price)<=0){
			layerUtils.iMsg(-1,"请输入买入价格");
			return false;
		}else if(!validatorUtil.isNumberFloat(now_price)){
			layerUtils.iMsg(-1,"请正确输入价格");
			return false;
		}else if(parseFloat(up_stop)<parseFloat(now_price)){
			layerUtils.iMsg(-1,"委托价格不能超过涨停价");
			return false;
		}else if(parseFloat(down_stop)>parseFloat(now_price)){
			layerUtils.iMsg(-1,"委托价格不能低于跌停价");
			return false;
		}
		//验证最大卖出
		var mostBuy = $(_pageId+"#buyLimit").text();
		if($.trim(mostBuy).length<=0||parseFloat(mostBuy)<=0){
			layerUtils.iMsg(-1,"最大可卖为0");
			return false;
		}else if(!Number(mostBuy)){
			layerUtils.iMsg(-1,"可卖数量不足");
			return false;
		}
		//验证卖出数量
		var mountBuy = $(_pageId+"#stockNum").val();
		if(!validatorUtil.isNumeric(mountBuy)){
			layerUtils.iMsg(-1,"请输入卖出数量");
			return false;
		}else if(mountBuy==0){
			layerUtils.iMsg(-1,"数量必须大于0");
			return false;
		}else if(parseFloat(mostBuy)<parseFloat(mountBuy)){
			layerUtils.iMsg(-1,"最大可卖数量不足");
			return false;
		}
		var secu_acc=null;//股东账户--------一般委托用

//		if(!_stockAccount||_stockAccount==""){
//			layerUtils.iMsg(-1,"没有该股票对应市场的股东卡",2);
//			return false;
//		}
//		// 判断股票、基金、权证卖出规则
//		if(action == " #sell"){
//			var maxNum = $(_pageId+action+" #numMax").attr("value"); // 最大可卖数量
//			/* 股票、基金、权证卖出数量规则一致 */
//			/* 债券卖出数量规则 */
//			if(g_is_bond){
//				if(mountBuy%10 != 0 && maxNum%10 != mountBuy%10){
//					layerUtils.iMsg(-1, "卖出数量不符合交易所规定，请重新输入");
//					return false;
//				}
//			}else if(g_is_stock || g_is_fund || g_is_warrant){
//				if(mountBuy%100 != 0 && maxNum%100 != mountBuy%100){
//					layerUtils.iMsg(-1, "卖出数量不符合交易所规定，请重新输入");
//					return false;
//				}
//			}
//		}
		var exchange_type=_market;
//		var tipStr ="<div class=\"pop_header\">";
//		tipStr+="<h3>融券卖出</h3>";
//		tipStr+="</div>";
//		tipStr+="<div class=\"pop_main\">";
		var tipStr ="<div class=\"pop_header\">";
		tipStr+="<h3>确认委托<a href='javascript:void(0);' class='close'></a></h3>";
		tipStr+="</div>";
		tipStr+="<div class=\"pop_main\">";
		tipStr+="<p>您是否确认本笔委托？</p>";
		tipStr+="<ul>";
		tipStr+="    <li>"+$(_pageId+"#stockCode").val().substring(7)+": <em>"+buy_stockCode+"</em></li>";
		tipStr+="    <li>买卖方向: 融券卖出</li>";
		if($(_pageId+".button-group a:eq(0)").hasClass("current")){
			tipStr+="    <li>委托价格: <strong>"+now_price+"</strong></li>";
		}else if($(_pageId+".button-group a:eq(1)").hasClass("current")){
			tipStr+="    <li>市价委托: "+$(_pageId + ".select_box p").text()+"</li>";
		}
		tipStr+="    <li>委托数量: "+mountBuy+"</li>";
		tipStr+="</ul>";
		tipStr+="  </div>";
//		tipStr+="<ul>";
//		tipStr+="    <li>股东账号 <em>"+_stockAccount+"</em></li>";
//		tipStr+="    <li>证券名称 <em>"+$(_pageId+"#stockCode").val().substring(7)+"</em></li>";
//		tipStr+="    <li>证券代码 <strong>"+buy_stockCode+"</strong></li>";
//		tipStr+="    <li>委托价格 <strong>"+now_price+"</strong></li>";
//		tipStr+="    <li>委托数量 <strong>"+mountBuy+"</strong></li>";
//		tipStr+="</ul>";
//		tipStr+="  </div>";
		common.btnConfirm(tipStr,function success(){
		var cust_code = userInfo.cust_code;	//客户代码
		var fund_account	= userInfo.fund_account;	//资产账户
		var branch_no  = userInfo.branch_no;	//分支机构
		var sessionid=userInfo.sessionid;
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置
		var password= userInfo.password;
		var entrust_bs="1";		
		var entrust_type = "7";
		var stock_account=_stockAccount;
		var stockCode=buy_stockCode;
		var entrust_price=now_price;
		var entrust_amount=mountBuy;
		var param = {
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"sessionid":sessionid,
				"entrust_bs":entrust_bs,
				"entrust_type":entrust_type,
				"exchange_type":exchange_type,
				"stock_account":stock_account,
				"stock_code":stockCode,
				"entrust_price":entrust_price,
				"entrust_amount":entrust_amount
			};
		service_credit.entrust_trade(param,getStockBuyCallBack);
			
		},function fail(){
		});
	}
	/**
	 * 委托下单返回
	 * */
	function getStockBuyCallBack(data){
		if(data.error_no == 0){
			var results = data.results;
			if(results && results.length>0){
				var tipStr = "<span style='font-weight:bold;font-size: 18px;'>交易提示</span><br>交易委托已提交，委托编号："+results[0].entrust_no;
				layerUtils.iAlert(tipStr);
//				clearBuyMsg();
				commonTrade.clearBuyMsg(_pageId,entrust_bs,stockCode);
				$(_pageId + " #stockCode").val("");
			}
		}else{
			layerUtils.iAlert(data.error_info);
//			clearBuyMsg();
			commonTrade.clearBuyMsg(_pageId,entrust_bs,stockCode);
			$(_pageId + " #stockCode").val("");
		}
	}
	
	/**
	 * 重置买卖页面数据  
	 */
//	function clearBuyMsg(){
//
//		if (fifthOrder_timer != null ) {
//	        window.clearInterval(fifthOrder_timer);
//	    }
//		$(_pageId+"#stock_list").html("");
//		$(_pageId+"#stockName").text("");
//		$(_pageId+"#stockPrice").val("");
//		$(_pageId+"#stockNum").val("");
//		$(_pageId+"#buyLimit").text("--");
//		$(_pageId+"#up_stop").text("--");
//		$(_pageId+"#down_stop").text("--");
//		$(_pageId+".five_box ul li em").text("--");
//		$(_pageId+".five_box ul li span").removeClass("agreen").removeClass("ared").text("--");
//		$(_pageId+".trade_form .input_box .stat").hide();
//		$(_pageId+".five_box ul li").removeClass("active");
//		$(_pageId + ".limit span").text("股");
//		$(_pageId + ".input_num em").text("股");
//		$(_pageId + ".trade_form .select_box label").text("股票");
//		$(_pageId+".input_slider .r1").val("0");
//		isChangePrice = true;
//	}
	/**
	 * 销毁
	 */
	function destroy(){
		 if (position_timer != null ) {
	         window.clearInterval(position_timer);
	     }
//		 clearBuyMsg();
         commonTrade.clearBuyMsg(_pageId,entrust_bs,stockCode);
	     userInfo = null;  //账号信息
		 price_step = 0.01; //步长
		 price_digit = 2; //小数点位数
		 fifthOrder_timer = null; //五档定时器
		 position_timer = null; //持仓定时器
		 lotsOf = 100; //每手数量
		 _stockAccount=""; //股东帐号
	     _market ="";   //交易市场
         _stockName = "";
         stock_price = "";
		 $(_pageId+"#stockCode").val("");
		 external.callMessage({"moduleName":"common","funcNo": "50211"});
//		 $(_pageId+".fund_table .ce_table").html("");
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("credit/order/financingToSell","credit/order/mainOrder",{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
//		"pageBack": pageBack
	};
	module.exports = base;
});