/**
 * 信用交易   还息费
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var gconfig = require("gconfig");
	var validatorUtil = require("validatorUtil");
	var global = gconfig.global;
	var service_hq = require("service_hq");
	var layerUtils = require("layerUtils");
	var service_credit = require("service_credit");
    var _pageId = "#credit_order_repayInterest ";
    var external = require("external");
    var limitedMarketEntrust = "limited";
    var common = require("common");
    var service_common = require("service_common");
    var nativePluginService = require("nativePluginService");
    var commonFunc = require("commonFunc");
    var topage ="";
    //var entrust_bs = "0";
    var bazaarCode = "";   //市场代码
    var stkType = ""; //证券类型
    var external = require("external");
    var service_stock = require("service_stock");
    
    var userInfo = null;
    
    /**
     * 初始化
     */
	function init(){
		// 隐藏下面导航
		common.hideBottomBar();
		userInfo = JSON.parse(appUtils.getSStorageInfo("credit_userInfo"));
		// 给持仓数据添加高度
 		$(_pageId).css("overflow-x", "hidden");
		var height_table = $(window).height() - $(_pageId+".header").height() - $(_pageId+".tab_nav").height() - $(_pageId+".repay_table").height() - $(_pageId+".table_head").height() - 30;
	    $(_pageId + " .table_body").height(height_table).css("overflow", "auto");
		// 查询应还息费
	    queryPayData();
	    
		// 查询可用金额   mid接口为502
//		queryFundStayData();
		
		// 需还款证券查询
		openInterest();
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId + " .icon_back"), function(e){
			appUtils.pageInit("credit/order/repayInterest", "credit/index", {});
			e.stopPropagation();
		});
		
		//导航菜单绑定事件
		appUtils.bindEvent($(_pageId + " .tab_nav ul a"),function(e){
			var $this = $(this);
			if ($this.parent().attr("class")){
				return false;
			}
			// 获取跳转的页面
			var topage = $this.attr("to-page").replaceAll("_","/"),
				// 获取跳转页面参数
				param =  $this.attr("param");
			
			appUtils.pageInit("credit/order/repayInterest", topage, {"param": param});
			e.stopPropagation();
		});
		
		//负债查询跳转
		appUtils.bindEvent($(_pageId + " .search_text"), function(e){
			appUtils.pageInit("credit/order/repayInterest", "credit/query/contractInquiryQuery", {"param": 0, "compact_type": 0});
			e.stopPropagation();
		});
		
		//点击全部按钮
		appUtils.bindEvent($(_pageId + " .td_all a"), function(e){
			var total_interest = Number($(_pageId + " #total_pay").html()),
				current_usable = Number($(_pageId + " #current_usable").html());
			if (!isNaN(total_interest) && !isNaN(current_usable)){
				if(Number(total_interest)==0){
					layerUtils.iAlert("已不需要还款！");
				}else{
					if (total_interest - current_usable > 0){
						$(_pageId + " #pay_number").val(current_usable);
					} else {
						$(_pageId + " #pay_number").val(total_interest);
					}
				}
			}
			e.stopPropagation();
		});
		
		//提交委托
		appUtils.bindEvent($(_pageId+".repay_table .ce_btn"), function(e){
			var current_usable = Number($(_pageId + " #pay_number").val());
			var total_interest = Number($(_pageId + " #total_pay").html());
			// 检测输入的数据是否合法
			if (checkInput(current_usable,total_interest)){
				// 显示委托提示，委托
				showSubmitInfo(current_usable);
			}
			e.stopPropagation();
		});
	}
	
	/**
	 * 资产负债查询
	 */
	function queryPayData(){
		var user = userInfo,
			param = {
				"entrust_way": global.entrust_way,
				"branch_no": user.branch_no,
				"fund_account": user.fund_account,
				"cust_code": user.cust_code,
				"password": user.password,
				"sessionid": user.sessionid,
				"money_type": "0"
			};
		service_credit.rzrq_liabilitiesQuery(param, function(data){
			var errorNo = data.error_no,
				errorInfo = data.error_info;
			if (errorNo === "0"){
				var results = data.results,
					re_length = results.length;
				if (re_length > 0){
					var item = results[0],
						ficontract_cptl = Number(item.ficontract_cptl).toFixed(2);
					// 资金可用金额
					$(_pageId + " #current_usable").html(isNaN(ficontract_cptl) ? "--" : ficontract_cptl);
					// 融券费用总额(未还融券合约费用+未还融券合约利息及待扣收利息)
					$(_pageId + " #total_pay").html(item.slo_debt_fee);
					
				}
			} else {
				layerUtils.iAlert(errorInfo);
			}
		});
	}
	
	/**
	 * 可用资金查询
	 */
	function queryFundStayData(){
		var user = userInfo,
			param={				
				"entrust_way": global.entrust_way,
				"branch_no": user.branch_no,
				"fund_account": user.fund_account,
				"cust_code": user.cust_code,
				"password": user.password,
				"sessionid": user.sessionid,
				"money_type": "0"
			};
		service_credit.zjzh_query(param, function(data){
			var errorNo = data.error_no,
				errorInfo = data.error_info;
			if (errorNo === "0"){
				var results = data.results,
					re_length = results.length;
				if (re_length > 0){
					var item = results[0];
						
				}
			} else {
				layerUtils.iAlert(errorInfo);
			}
		}, {"isShowWait": false});
	}
	
	/**
	 * 需还款证券查询（未了结合约查询）
	 */
	function openInterest(){
		var user = userInfo,
			param = {			
				"entrust_way": global.entrust_way,
				"branch_no": user.branch_no,
				"fund_account": user.fund_account,
				"cust_code": user.cust_code,
				"password": user.password,
				"sessionid": user.sessionid,
				"compact_type": "1",//合约类型  0 融资   1 融券
				"compact_status": "0"   // 0-未了结   1-部分了结
			};
		
		service_credit.contractmx_query(param, function(data){
			var errorNo = data.error_no,
				errorInfo = data.error_info;
			if (errorNo === "0"){
				var results = data.results,
					re_length = results.length,
					str = "";
				if (re_length > 0){
					$(_pageId + " .no_data").hide();
					for (var i = 0; i < re_length; i++){
						var item = results[i],
							name = item.compact_type === "0" ? "融资" : "融券";
						str += "<tr><td>" + item.open_date + "<br />" + item.ret_end_date + "</td>";
						str += "<td>"+item.compact_id +"<br />"+name+"</td>";
						str += "<td>" + item.stock_name + "<br />" + item.stock_code + "</td>";
						str += "<td>" + item.left_qty + "<br />" + Number(item.left_int).toFixed(2) + "</td></tr>";
					}
					$(_pageId + " .ce_table tbody").html(str);
					Align(_pageId);
				} else {
					$(_pageId + " .no_data").show();
				}
			} else {
				layerUtils.iAlert(errorInfo);
			}
		}, {"isShowWait": false});
	}
	
	//对齐tbody / thead 的方法
	function Align(_pageId){
		   $(_pageId+".fund_table ").find("th").each(function(){ 
		        var idx = $(this).index();         
		        var td=$(_pageId+".fund_table tbody tr").children('td').eq(idx);
		        if(td.width()>40){
		        	$(this).width(td.width());
		        }else{
		        	 $(this).width() > td.width() ? td.width($(this).width()) : $(this).width(td.width());
		        }
		           
		        }); 
		        
	   }
	
	/**
	 * 下单验证,检测输入数据是否合法
	 */
	function checkInput(current_usable,total_interest){
		var mark = false;
		if (!current_usable){
			layerUtils.iAlert("输入还款金额不能为空");
			mark = false;
		} else if ((current_usable === "0") || isNaN(current_usable)){
			layerUtils.iAlert("输入还款金额有误");
			mark = false;
		} else {
			if(total_interest>0){
				mark=true;
			}else{
				mark=false;
				layerUtils.iAlert("已不需要还款！");
			}
		}
		return mark;
	}
	
	/**
	 * 显示委托信息, 委托
	 */
	function showSubmitInfo(current_usable){
		var tipStr = "<div class=\"pop_header\">";
		tipStr += "<h3>确认委托<a href='javascript:void(0);' class='close'></a></h3>";
		tipStr += "</div>";
		tipStr += "<div class=\"pop_main\">";
		tipStr += "<p>您是否确认本笔委托？</p>";
		tipStr += "<ul>";
		tipStr += "    <li>委托类型: 还息费</li>";
		tipStr += "    <li>委托金额: " + current_usable + "元</li>";
		tipStr += "</ul>";
		tipStr += "  </div>";
		common.btnConfirmCrit(tipStr, function success(){
			// 委托
			var user = userInfo,
				param = {
					"entrust_way": global.entrust_way,
					"branch_no": user.branch_no,
					"fund_account": user.fund_account,
					"cust_code": user.cust_code,
					"password": user.password,
					"sessionid": user.sessionid,
					"money_type": "0",
					"occur_balance": current_usable
				};
			service_credit.cashBackDirectly(param, function(data){
				var errorNo = data.error_no,
					errorInfo = data.error_info;
				if (errorNo === "0"){
					var results = data.results,
						re_length = results.length;
					if (re_length > 0){
						layerUtils.iAlert("还款委托已提交");
						$(_pageId + " #pay_number").val("");
						// 查询应还息费
					    queryPayData();
					    
						// 查询可用金额   mid接口为502
//						queryFundStayData();
						
						// 需还款证券查询
						openInterest();
					}
				} else {
					layerUtils.iAlert(errorInfo);
				}
			});
		});
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId + " #pay_number").val("");
		$(_pageId + " #total_pay").html("--");
		$(_pageId + " #current_usable").html("--");
		$(_pageId + " .table_body tbody").html("");
		$(_pageId + " .no_data").hide();
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});