/**
 * 信用交易-交易撤单
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var layerUtils = require("layerUtils");
	var service_credit = require("service_credit");
	var common = require("common"); 
	var _pageId = "#credit_order_tradeCancellation ";
	var userInfo = null;
		

    /**
     * 初始化
     */
	function init(){
		// 隐藏下面导航
		common.hideBottomBar();
		userInfo = JSON.parse(appUtils.getSStorageInfo("credit_userInfo"));
		if (!userInfo){
			appUtils.pageInit("credit/order/tradeCancellation", "credit/index", {});
		}
		setTimeout(function(){
       		// 给持仓数据添加高度
       		var height_table = $(window).height() - $(_pageId+".header").height() - 13;
       		$(_pageId+".mar_stock").height(height_table).css("overflow", "auto");   //给持仓数据添加高度
       	}, 300);
		queryCancelData(); // 撤单查询
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId+".top_title .icon_back"), function(e){
			appUtils.pageBack();
			e.stopPropagation();
		});
	}
    
	/**
	 * 撤单查询
	 */
	function queryCancelData(){
		$(_pageId + " .mar_stock").html("");
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置
		var branch_no  = userInfo.branch_no;	//分支机构
		var fund_account = userInfo.fund_account;	//资产账户
		var cust_code = userInfo.cust_code;	//客户代码
		var password = userInfo.password;
		var sessionid= userInfo.session_id;
		var stock_account ="";
		var stock_code = "";
		var entrust_bs = "";
		var exchange_type = "";
		var param={
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"sessionid":sessionid,
				"exchange_type":exchange_type,
				"stock_account":stock_account,
				"stock_code":stock_code,
				"entrust_bs":entrust_bs
		};
		service_credit.todaykcwt_query(param, queryCancelCallback);//股票查询
	}
	/**
	 * 股份查询回调方法
	 * @param {Object} data 返回数据
	 */
	function queryCancelCallback(data){
		var errorNo = data.error_no,
			errorInfo = data.error_info;
		if (errorNo === "0"){
			var results = data.results,
				re_length = results.length;
			var markets = "";
			var order_ids = "";
			if (re_length > 0){
				var queryStockHtml = "";
				for ( var i = 0; i < re_length; i++) {
					markets += results[i].exchange_type + ",";
					order_ids += results[i].entrust_no + ",";
					queryStockHtml += createHtml(results[i]);
				}
				$(_pageId+".mar_stock").html(queryStockHtml);
				//绑定撤单事件
				appUtils.bindEvent(_pageId+" .mar_stock .order", function (e){
					var $this = $(this),
						entrust_no = $this.attr("data-entrust_no"),
						exchange_type = $this.attr("data-exchange_type"),
						stock_name = $this.attr("data-stock_name"),
						entrust_amount = $this.attr("data-entrust_amount"),
						entrust_price = $this.attr("data-entrust_price"),
						entrust_name = $this.siblings("h5").find("strong").html(),
						stock_code = $this.attr("data-stock_code");
					var str = "<div class=\"pop_header\"><h3>确认委托<a href='javascript:void(0);' class='close'></a></h3></div><div class=\"pop_main\"><p>您是否确认撤单？</p>";
					str += "<ul><li>"+stock_name+": "+stock_code+"</li>";
					str += "<li>委托类型: 撤单</li>";
					str += "<li>委托价格: "+entrust_price+"</li>";
					str += "<li>委托数量: "+entrust_amount+"</li>";
					str += "<li>合同号: "+entrust_no+"</li></ul></div>";
					//撤单确认
					postCancelOrder(entrust_no, exchange_type, str);
				});
			}else{
				$(_pageId+".no_data").show();
			}
			//撤单事件
			appUtils.bindEvent($(_pageId+".noicon_text"), function(e){
				if (markets && order_ids){
					var str = "<div class=\"pop_header\"><h3>确认委托<a href='javascript:void(0);' class='close'></a></h3></div><div class=\"pop_main\"><p>您是否确认全部撤单？</p>";
					str += "</div>";
					//撤单确认
					postCancelOrder(order_ids, markets, str);
				} else {
					layerUtils.iAlert("暂无可撤单委托");
				}
			},"click");
		} else {
			layerUtils.iAlert(errorInfo);
		}
	}

	/**
	 * 生成股份查询html
	 */
	function createHtml(element){
		var btn_css = "";
		var entrust_type_name = element.entrust_type_name;
		if(entrust_type_name == "融资买入"||entrust_type_name == "担保品买入"||entrust_type_name == "担保品提交"){
			btn_css = "bg_red";
		}else if(entrust_type_name == "融券卖出"||entrust_type_name == "担保品卖出"||entrust_type_name == "担保品返回"){
			btn_css = "bg_green";
		}else if(entrust_type_name == "卖券还款"||entrust_type_name == "直接还券"||entrust_type_name == "买券还券"||entrust_type_name == "现金还款"){
			btn_css = "bg_blue";
		}else{
			btn_css = "";
		}
		if(entrust_type_name == "直接还券"){
			entrust_type_name = "现券还券";
		}
		var entrust_price = (Number(element.entrust_price) >= 0) ?  Number(element.entrust_price) : "--";
		var business_price = (Number(element.business_price) >= 0) ?  Number(element.business_price) : "--";
		var entrust_date = element.entrust_date;
		entrust_date = entrust_date.substring(2, entrust_date.length);
		entrust_date = entrust_date.replaceAll("-", "/");
		var eleHtml = "";
			eleHtml +="<div class='part part02'>";
			eleHtml +="<a href='javascript:void(0);' style='position:relative;' class='order' data-entrust_amount='"+Number(element.entrust_amount)+"' data-entrust_price='"+entrust_price+"' data-stock_name='"+element.stock_name+"' data-stock_code='"+element.stock_code+"' data-entrust_no='"+element.entrust_no+"' data-exchange_type='"+element.exchange_type+"'>撤单</a>";
			eleHtml +="<h5 style='white-space: nowrap;'><strong class='"+btn_css+"'>"+entrust_type_name+"</strong><small>委托时间:"+entrust_date+" "+element.entrust_time+"</small></h5>";
			eleHtml +="<dl class='clearfix'>";
			eleHtml +="<dt class='p10'><h3>"+element.stock_name+"</h3><p><span>"+element.stock_code+"</span></p></dt>";
			eleHtml +="<dd><p><em>委托价:</em> "+entrust_price+"</p><p><em>成交价:</em> "+business_price+"</p><p><em>合同号</em> "+element.entrust_no+"</p></dd>";
			eleHtml +="<dd><p><em>委托数:</em> "+Number(element.entrust_amount)+"</p><p><em>成交数:</em> "+Number(element.business_amount)+"</p></dd>";
			eleHtml +="</dl>";
			eleHtml +="</div>";
        return eleHtml;
	}
	
	/**
	 * 委托撤单
	 * @param $currItem 当前条目
	 */
	function postCancelOrder(entrust_no, exchange_type, str){
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;//货币 ""所有货币，0 人民币，1 港币，2 美元
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var sessionid=userInfo.session_id;
		var password= userInfo.password;
		var param={				
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"sessionid":sessionid,
				"entrust_no":entrust_no,
				"exchange_type":exchange_type
		};
		
		common.btnConfirmCrit(str, function success(){
			service_credit.credit_cancel(param, postCancelOrderCallback);
		});
	}
	/**
	 * 委托撤单回调方法
	 * @param {Object} data 返回数据
	 */
	function postCancelOrderCallback(data){
		if(data){
			var errorNo = data.error_no;
			if (errorNo == 0) {
				layerUtils.iMsg(0,"撤单成功！",2);
			}else{
				layerUtils.iAlert(data.error_info);
			}
			queryCancelData();
		}
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId + " .no_data").hide();
		$(_pageId + " .mar_stock").html("");
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageBack();
	}
	
	var base = {
			"init" : init,
			"bindPageEvent": bindPageEvent,
			"destroy": destroy,
			"pageBack": pageBack
		};
	module.exports = base;
});