/**
 * 密码修改
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var layerUtils = require("layerUtils");
	var validator = require("validatorUtil");
	var external = require("external");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var service_common = require("service_common");
	var common = require("common");
	var _pageId = "#credit_password_changePassword ";
    var userInfo = null;
    var password_new ="";
    var toPageparam = "";
    var cursor_timer = null;
	var cursor_num = 0;
	var cursor_timer_id = null;
    
    /**
     * 初始化
     */
	function init() {
		common.hideBottomBar();
		toPageparam = appUtils.getPageParam("param"); //判断用户选择哪个账户
		if(!toPageparam){
			toPageparam = appUtils.getSStorageInfo("changePasswordFlag");
			if(!toPageparam){
				toPageparam = "credit_changeMoneyPwd";
			}
		}
		if (toPageparam === "credit_changeTradePwd"){
			$(_pageId + ".top_title h3").text("交易密码修改");
			$(_pageId + "#confirmPassword").attr("placeholder","再次输入交易密码");
		} else {
			$(_pageId + ".top_title h3").text("资金密码修改");
			$(_pageId + "#confirmPassword").attr("placeholder","再次输入资金密码");
		}
		userInfo = JSON.parse(appUtils.getSStorageInfo("credit_userInfo"));
		//在pc端可使用键盘输入股票代码（方便调试）
		if(gconfig.platform=="0"){ 
			$(_pageId+"#oldPassword").attr("readonly",false);
			$(_pageId+"#newPassword").attr("readonly",false);
			$(_pageId+"#confirmPassword").attr("readonly",false);
		}	
		clearBuyMsg();
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent() {
		//返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50211"});
			appUtils.pageInit("credit/password/changePassword","credit/index",{});
			e.stopPropagation();
		});
		
		//密码修改
		appUtils.bindEvent($(_pageId + ".input_form .ce_btn"), function(e){
			//关闭原生键盘
			external.callMessage({"moduleName":"trade","funcNo": "50211"});
			if (cursor_timer != null ) {
		        window.clearInterval(cursor_timer);
		    }
			$(_pageId + ".trade_form .input_text .cursor_div .cursor em").css("opacity",0);
			//密码修改校验
			if(!checkInput()){
				return false;
			};
			
			common.btnConfirm("<div class=\"pop_main\" style=\"height: 50px;margin-top: 20px;font-size:0.15rem\"><div>您是否确认修改密码?</div></div>",changePassword,null);
			$("#pop_tip_confirm").find("p").css("padding","15px");//修改提示框的边框高度
			e.stopPropagation();
		});
		
		//原来密码
//		appUtils.bindEvent($(_pageId+"#oldPassword"),function(e){
//			external.callMessage({"moduleName":"trade","funcNo": "50210", "pageId":"credit_password_changePassword", "eleId":"oldPassword", "doneLable":"done", "keyboardType":"4"});
//			e.stopPropagation();
//		},"click");
		
		//原来密码
		appUtils.bindEvent($(_pageId+".trade_form .oldps .cursor_div"),function(e){
			if (cursor_timer != null ) {
		        window.clearInterval(cursor_timer);
		    }
			$(_pageId + ".trade_form .input_text .cursor_div .cursor em").css("opacity",0);
			cursor_timer_id = $(this).find(" .cursor em").attr("id");
			cursorTimer();
			window.customKeyboardEvent = {
				keyBoardFinishFunction: function(){},
				keyBoardInputFunction: function(keyCode){
					if($(_pageId + "#oldPassword").val().length > 6){
						$(_pageId + "#oldPassword").val($(_pageId + "#oldPassword").val().substring(0,6));
					}else{
						var temp_length = $(_pageId + "#oldPassword").val().length;
						if(temp_length == "0"){
							$(_pageId + ".oldps .cursor_div").find(".cursor div").text("");
						}else if(temp_length == "1"){
							$(_pageId + ".oldps .cursor_div").find(".cursor div").text("*");
						}else if(temp_length == "2"){
							$(_pageId + ".oldps .cursor_div").find(".cursor div").text("**");
						}else if(temp_length == "3"){
							$(_pageId + ".oldps .cursor_div").find(".cursor div").text("***");
						}else if(temp_length == "4"){
							$(_pageId + ".oldps .cursor_div").find(".cursor div").text("****");
						}else if(temp_length == "5"){
							$(_pageId + ".oldps .cursor_div").find(".cursor div").text("*****");
						}else{
							$(_pageId + ".oldps .cursor_div").find(".cursor div").text("******");
						}
					}
				}
			};
			external.callMessage({"moduleName":"trade","funcNo": "50210", "pageId":"credit_password_changePassword", "eleId":"oldPassword", "doneLable":"done", "keyboardType":"4"});
			e.stopPropagation();
		},"click");
		
		//关闭原生键盘
//		appUtils.bindEvent($(_pageId+"#oldPassword"),function(e){
//			external.callMessage({"funcNo": "50211"});
//			e.stopPropagation();
//		},"blur");
		
		//新密码
//		appUtils.bindEvent($(_pageId+"#newPassword"),function(e){
//			external.callMessage({"moduleName":"trade","funcNo": "50210", "pageId":"credit_password_changePassword", "eleId":"newPassword", "doneLable":"done", "keyboardType":"4"});
//			e.stopPropagation();
//		},"click");
		
		appUtils.bindEvent($(_pageId+".trade_form .newps .cursor_div"),function(e){
			if (cursor_timer != null ) {
		        window.clearInterval(cursor_timer);
		    }
			$(_pageId + ".trade_form .input_text .cursor_div .cursor em").css("opacity",0);
			cursor_timer_id = $(this).find(" .cursor em").attr("id");
			cursorTimer();
			window.customKeyboardEvent = {
					keyBoardFinishFunction: function(){},
					keyBoardInputFunction: function(){
						if($(_pageId + "#newPassword").val().length > 6){
							$(_pageId + "#newPassword").val($(_pageId + "#newPassword").val().substring(0,6));
						}else{
							var temp_length = $(_pageId + "#newPassword").val().length;
							if(temp_length == "0"){
								$(_pageId + ".newps .cursor_div").find(".cursor div").text("");
							}else if(temp_length == "1"){
								$(_pageId + ".newps .cursor_div").find(".cursor div").text("*");
							}else if(temp_length == "2"){
								$(_pageId + ".newps .cursor_div").find(".cursor div").text("**");
							}else if(temp_length == "3"){
								$(_pageId + ".newps .cursor_div").find(".cursor div").text("***");
							}else if(temp_length == "4"){
								$(_pageId + ".newps .cursor_div").find(".cursor div").text("****");
							}else if(temp_length == "5"){
								$(_pageId + ".newps .cursor_div").find(".cursor div").text("*****");
							}else{
								$(_pageId + ".newps .cursor_div").find(".cursor div").text("******");
							}
						}
					}
				};
			external.callMessage({"moduleName":"trade","funcNo": "50210", "pageId":"credit_password_changePassword", "eleId":"newPassword", "doneLable":"done", "keyboardType":"4"});
			e.stopPropagation();
		},"click");
		
		//关闭原生键盘
//		appUtils.bindEvent($(_pageId+"#newPassword"),function(e){
//			external.callMessage({"moduleName":"common","funcNo": "50211"});
//			e.stopPropagation();
//		},"blur");
		
		//新密码确认
//		appUtils.bindEvent($(_pageId+"#confirmPassword"),function(e){
//			external.callMessage({"moduleName":"trade","funcNo": "50210", "pageId":"credit_password_changePassword", "eleId":"confirmPassword", "doneLable":"done", "keyboardType":"4"});
//			e.stopPropagation();
//		},"click");
		
		appUtils.bindEvent($(_pageId+".trade_form .confirmps .cursor_div"),function(e){
			if (cursor_timer != null ) {
		        window.clearInterval(cursor_timer);
		    }
			$(_pageId + ".trade_form .input_text .cursor_div .cursor em").css("opacity",0);
			cursor_timer_id = $(this).find(" .cursor em").attr("id");
			cursorTimer();
			window.customKeyboardEvent = {
					keyBoardFinishFunction: function(){},
					keyBoardInputFunction: function(){
						if($(_pageId + "#confirmPassword").val().length > 6){
							$(_pageId + "#confirmPassword").val($(_pageId + "#confirmPassword").val().substring(0,6));
						}else{
							var temp_length = $(_pageId + "#confirmPassword").val().length;
							if(temp_length == "0"){
								$(_pageId + ".confirmps .cursor_div").find(".cursor div").text("");
							}else if(temp_length == "1"){
								$(_pageId + ".confirmps .cursor_div").find(".cursor div").text("*");
							}else if(temp_length == "2"){
								$(_pageId + ".confirmps .cursor_div").find(".cursor div").text("**");
							}else if(temp_length == "3"){
								$(_pageId + ".confirmps .cursor_div").find(".cursor div").text("***");
							}else if(temp_length == "4"){
								$(_pageId + ".confirmps .cursor_div").find(".cursor div").text("****");
							}else if(temp_length == "5"){
								$(_pageId + ".confirmps .cursor_div").find(".cursor div").text("*****");
							}else{
								$(_pageId + ".confirmps .cursor_div").find(".cursor div").text("******");
							}
						}
					}
				};
			external.callMessage({"moduleName":"trade","funcNo": "50210", "pageId":"credit_password_changePassword", "eleId":"confirmPassword", "doneLable":"done", "keyboardType":"4"});
			e.stopPropagation();
		},"click");
		
		//关闭原生键盘
//		appUtils.bindEvent($(_pageId+"#confirmPassword"),function(e){
//			external.callMessage({"moduleName":"common","funcNo": "50211"});
//			e.stopPropagation();
//		},"blur");
		
		//在点击非密码输入框关闭键盘
		appUtils.bindEvent($(_pageId),function(e){
		    var tag = e.srcElement || e.target;
		    if(tag.id!="oldPassword" && tag.id!="newPassword" && tag.id!="confirmPassword"){
		    	if (cursor_timer != null ) {
		    		window.clearInterval(cursor_timer);
		    	}
		    	$(_pageId + ".trade_form .input_text .cursor_div .cursor em").css("opacity",0);
		    	external.callMessage({"moduleName":"trade","funcNo": "50211"});
		    }
          e.stopPropagation();
		},"click");
	}
    
	/**
	 * 密码修改校验
	 * 不能顺增：123456 
	 * 不能顺减：987654 
	 * 一个字符不能等于或超过长度的一半：222175
	 */
	function checkInput(){
		var password_old = $(_pageId + "#oldPassword").val();
		password_new = $(_pageId + "#newPassword").val();
		var password_confirm = $(_pageId + "#confirmPassword").val();
		if(validator.isEmpty(password_old)){
			layerUtils.iAlert("原密码不能为空 ");
			return false;
		}
		if(validator.isEmpty(password_new)){
			layerUtils.iAlert("新密码不能为空 ");
			return false;
		}
		if(validator.isEmpty(password_confirm)){
			layerUtils.iAlert("确认密码不能为空 ");
			return false;
		}
		
		if(password_old.length != 6 || password_new.length != 6 || password_confirm.length != 6){
			layerUtils.iAlert("密码长度必须为6位 ");
			return false;
		}
		
		if(toPageparam.indexOf("changeTradePwd") > -1){
			if(!/^[0-9]{6}$/.test(password_old)){
				layerUtils.iAlert("原密码只允许输入0-9且长度为6位");
				return false;
			}
			if(!/^[0-9]{6}$/.test(password_new)){
				layerUtils.iAlert("新密码只允许输入0-9且长度为6位");
				return false;
			}
			if(!/^[0-9]{6}$/.test(password_confirm)){
				layerUtils.iAlert("确认密码只允许输入0-9且长度为6位");
				return false;
			}
			if(password_new == password_old){
				layerUtils.iAlert("新密码与原密码不能相同 ");
				return false;
			}
			if(password_new != password_confirm){
				layerUtils.iAlert("新密码与确认密码请保持一致 ");
				return false;
			}
			return true;
		}else{
			
			if(!/^[0-9]{6}$/.test(password_old)){
				layerUtils.iAlert("原密码只允许输入0-9且长度为6位");
				return false;
			}
			
			if(!/^[0-9]{6}$/.test(password_new)){
				layerUtils.iAlert("新密码只允许输入0-9且长度为6位");
				return false;
			}else{
				var pwdArr = [];
				for(var i=0;i<password_new.length;i++){
					var pwdSplit = password_new.substring(i,i+1);
					pwdArr[i] = pwdSplit;
				}
				
				if(Number(pwdArr[0])+1 == Number(pwdArr[1]) && Number(pwdArr[1])+1 == Number(pwdArr[2]) && Number(pwdArr[2])+1 == Number(pwdArr[3]) && Number(pwdArr[3])+1 == Number(pwdArr[4]) && Number(pwdArr[4])+1 == Number(pwdArr[5])){
					layerUtils.iAlert("新密码输入不能顺增");
					return false;
				}
				
				if(Number(pwdArr[0])-1 == Number(pwdArr[1]) && Number(pwdArr[1])-1 == Number(pwdArr[2]) && Number(pwdArr[2])-1 == Number(pwdArr[3]) && Number(pwdArr[3])-1 == Number(pwdArr[4]) && Number(pwdArr[4])-1 == Number(pwdArr[5])){
					layerUtils.iAlert("新密码输入不能顺减");
					return false;
				}
				
				var throughNum = 0;
				for(var i=0;i<pwdArr.length;i++){
					for(var j=0;j<pwdArr.length;j++){
						 if(pwdArr[i] == pwdArr[j]){
							 throughNum ++;
						 }
					}
					if(throughNum >= 3){
						layerUtils.iAlert("新密码同一个字符不能超过总密码长度的一半");
						return false;
					}
					throughNum = 0;
				}
			}
			
			if(!/^[0-9]{6}$/.test(password_confirm)){
				layerUtils.iAlert("确认密码只允许输入0-9且长度为6位");
				return false;
			}else{
				var pwdArr = [];
				for(var i=0;i<password_confirm.length;i++){
					var pwdSplit = password_confirm.substring(i,i+1);
					pwdArr[i] = pwdSplit;
				}
				
				if(Number(pwdArr[0])+1 == Number(pwdArr[1]) && Number(pwdArr[1])+1 == Number(pwdArr[2]) && Number(pwdArr[2])+1 == Number(pwdArr[3]) && Number(pwdArr[3])+1 == Number(pwdArr[4]) && Number(pwdArr[4])+1 == Number(pwdArr[5])){
					layerUtils.iAlert("确认密码输入不能顺增");
					return false;
				}
				
				if(Number(pwdArr[0])-1 == Number(pwdArr[1]) && Number(pwdArr[1])-1 == Number(pwdArr[2]) && Number(pwdArr[2])-1 == Number(pwdArr[3]) && Number(pwdArr[3])-1 == Number(pwdArr[4]) && Number(pwdArr[4])-1 == Number(pwdArr[5])){
					layerUtils.iAlert("确认密码输入不能顺减");
					return false;
				}
				
				var throughNum = 0;
				for(var i=0;i<pwdArr.length;i++){
					for(var j=0;j<pwdArr.length;j++){
						 if(pwdArr[i] == pwdArr[j]){
							 throughNum ++;
						 }
					}
					if(throughNum >= 3){
						layerUtils.iAlert("确认密码同一个字符不能超过总密码长度的一半");
						return false;
					}
					throughNum = 0;
				}
			}
			
			if(password_new == password_old){
				layerUtils.iAlert("新密码与原密码不能相同 ");
				return false;
			}
			if(password_new != password_confirm){
				layerUtils.iAlert("新密码与确认密码请保持一致 ");
				return false;
			}
			
			return true;
		}
	}

	
	/**
	 * 密码修改
	 */
	function changePassword(){
		//密码加密
		service_common.getKey({},function(data){
			if(data.error_no != "0"){
				//将isShowWait关闭掉(圈)
				layerUtils.iLoading(false);
				layerUtils.iAlert(data.error_info);
				$(_pageId + "#oldPassword").val("");
				$(_pageId + "#newPassword").val("");
			    $(_pageId + "#confirmPassword").val("");
				return false;
			}else{
				//获得旧密码和新密码
				var password_old = $(_pageId + "#oldPassword").val();
				password_new = $(_pageId + "#newPassword").val();
				var modulus = data.results[0].modulus;
				var publicExponent = data.results[0].publicExponent;
				var endecryptUtils = require("endecryptUtils");
				//为旧密码和新密码加密
				password_old = endecryptUtils.rsaEncrypt(modulus,publicExponent,$.trim(password_old));
				password_new = endecryptUtils.rsaEncrypt(modulus,publicExponent,$.trim(password_new));
				var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
				var branch_no = userInfo.branch_no;	//分支机构 
				var fund_account = userInfo.fund_account;	//资产账户
				var cust_code = userInfo.cust_code;	//客户代码
				var password_type;
				if(toPageparam.indexOf("changeTradePwd") > -1){
					password_type = "1";//交易密码
				}else{
					password_type = "0";//资金密码
				}
				var password = userInfo.password;
				var sessionid = userInfo.session_id;
				
				var param = {
						"entrust_way":entrust_way,
						"branch_no":branch_no,
						"fund_account":fund_account,
						"cust_code":cust_code,
						"sessionid":sessionid,
						"password":password,
						"passowrd_type":password_type,
						"password_old":password_old,
						"password_new":password_new,
						"account_type": "credit_userInfo"
				};
				
				service_common.updatePassword(param,updatePasswordCallBack);
				
			}
		},{"isLastReq":false});
		
	}
	
	function updatePasswordCallBack(data){
		if(data.error_no == 0){
			//需求:当客户点击确定时,才跳转到登陆页面,注意:此处的reSetting不可写为reSetting() 否则会立刻执行
			/**
			 * 终于弄明白，reSetting表示的是回调函数，此时不能写成reSetting()，当写成reSetting()时在密码修改成功就会立即执行该方法，来不及点击确定
			 * 但当前我们需要的是用户点击确定了之后才可跳转到登录页面
			 */
			
			if(toPageparam.indexOf("changeTradePwd") > -1){
				appUtils.clearSStorage();
				stock_userInfo =null;
				credit_userInfo =null;
				$(_pageId+".top_title .logout").hide();
				layerUtils.iAlert("密码修改成功,请重新登录",0,reSetting,"确定");
			}else{
				layerUtils.iAlert("密码修改成功,请重新登录", 0, function(){
					appUtils.pageInit("credit/password/changePassword","credit/index",{});
				});
			}
		}else{
			console.log(data.error_info);
			layerUtils.iAlert(data.error_info);
			clearBuyMsg();
		}
	}
	
	/**
	 * 光标显示定时器
	 */
	function cursorTimer(){
		cursor_timer =  window.setInterval(function(){
			if(cursor_num < 1){
				cursor_num = 1;
				if(cursor_timer_id == "old_em"){
					$(_pageId + ".trade_form .input_text .cursor_div .cursor #old_em").css("opacity",1);
				}else if(cursor_timer_id == "new_em"){
					$(_pageId + ".trade_form .input_text .cursor_div .cursor #new_em").css("opacity",1);
				}else{
					$(_pageId + ".trade_form .input_text .cursor_div .cursor #confirm_em").css("opacity",1);
				}
			}else{
				cursor_num = 0;
				if(cursor_timer_id == "old_em"){
					$(_pageId + ".trade_form .input_text .cursor_div .cursor #old_em").css("opacity",0);
				}else if(cursor_timer_id == "new_em"){
					$(_pageId + ".trade_form .input_text .cursor_div .cursor #new_em").css("opacity",0);
				}else{
					$(_pageId + ".trade_form .input_text .cursor_div .cursor #confirm_em").css("opacity",0);
				}
			}
		}, 600);//定时刷新
	}
	
	/**
	 * 重置session
	 */
	function reSetting(){
		//关闭弹出框
		layerUtils.iTipsClose();
		//清空客户登陆信息
		appUtils.clearSStorage("credit_userInfo");
		appUtils.pageInit("credit/password/changePassword","credit/index",{});
		require("sso").ssoLoginOut();
		clearBuyMsg();
	}
	
	/**
	 * 重置页面数据  
	 */
	function clearBuyMsg(){
		$(_pageId + "#oldPassword").val("");
		$(_pageId + "#newPassword").val("");
	    $(_pageId + "#confirmPassword").val("");
	    $(_pageId + ".confirmps .cursor_div").find(".cursor div").text("");
	    $(_pageId + ".newps .cursor_div").find(".cursor div").text("");
	    $(_pageId + ".oldps .cursor_div").find(".cursor div").text("");
	}
	
	function destroy(){
		clearBuyMsg();
		if (cursor_timer != null ) {
	        window.clearInterval(cursor_timer);
	    }
		$(_pageId + ".trade_form .input_text .cursor_div .cursor em").css("opacity",0);
		external.callMessage({"moduleName":"trade","funcNo": "50211"});
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("credit/password/changePassword","credit/index",{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});