/**
 * 信用交易-担保品证券
 */
define(function(require, exports, module) {
    var appUtils = require("appUtils");
	var	gconfig = require("gconfig");
	var global = gconfig.global;
	var	layerUtils = require("layerUtils");
	var	service_credit = require("service_credit");
	var external = require("external");
	var	_pageId = "#credit_query_collateralQuery ";
	var VIscroll = require("vIscroll");
	var vIscroll = {"scroll":null,"_init":false};		//上下滑动
	var SVIscroll = require("svIscroll");
	var svIscroll = null;
	var common = require("common");
	var service_hq = require("service_hq");
	var changeToPinyin = require("changeToPinyin");
	var userInfo = null;//保存的客户信息
	//var stockNameArr = [];//保存股票英文简写名称
	//var stockCodeArr = [];//保存股票股票代码
	var queryMsg = null;//查询后返回的结果集
	var isStockInput = false;//输入后状态
	var type = 0;//0-融资标的  1-融券标的
	var poststr = 0;//页数定位 默认显示第一页
	var num = 0;
	var stockCode = null;
	
    /**
     * 初始化
     */
	function init(){
		common.hideBottomBar();
		common.systemKeybord(); // 解禁系统键盘
		userInfo = JSON.parse(appUtils.getSStorageInfo("credit_userInfo"));
		$(_pageId).css("overflow-x","hidden");
		$(_pageId + ".visc_pullUp").css("display","none");
		queryCollateral();//查询数据
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId+" .icon_back"), function(e){
			appUtils.pageBack();
			e.stopPropagation();
		});
		//点击查询按钮
		appUtils.bindEvent($(_pageId+" #search"),function(){
			var stockCode = $(_pageId+" #stockCode").val();
			if(stockCode){
				queryCollateral(stockCode);
			}else{
				layerUtils.iAlert("请输入股票代码！");
			}
		});
		//股票代码输入框监听
		appUtils.bindEvent($(_pageId+"#stockCode"), function(e){
			$(_pageId+ ".no_data").hide();//隐藏暂无数据
			var stockCode = $(this).val();
			var vail=/^[A-Za-z]+$/;
			if(stockCode.length>1 && vail.test(stockCode)){
				isStockInput = true;
				getStockList(stockCode);
				if(stockCode.length<2){
					$(_pageId+"#stock_list").html("");
				}
			}else if(stockCode.length>3){
				isStockInput = true;
				getStockList(stockCode);
				if(stockCode.length<4){
					$(_pageId+"#stock_list").html("");
				}
			}else{
				if(isStockInput){
					isStockInput = false;
					$(_pageId+" #container").html("");
					queryCollateral();
					$(_pageId + " #stockName").text("证券名称");
				}
				$(_pageId+"#stock_list").html("");
			}
			e.stopPropagation();
		},"input");
		//股票代码输入框调用原生键盘
		appUtils.bindEvent($(_pageId+".trade_form .input_code"), function(e){
			$(_pageId+"#stockCode").focus();
			window.keyBoardInputFunction = function(){ //原生回调
				var stockCode = $(_pageId+"#stockCode").val();
				$(_pageId+"#stock_list").html("");
				var vail=/^[A-Za-z]+$/;
			if(stockCode.length>1 && vail.test(stockCode)){
				isStockInput = true;
				getStockList(stockCode);
				if(stockCode.length<2){
					$(_pageId+"#stock_list").html("");
				}
			}else if(stockCode.length>3){
				isStockInput = true;
				getStockList(stockCode);
				if(stockCode.length<4){
					$(_pageId+"#stock_list").html("");
				}
			}else{
				if(isStockInput){
					isStockInput = false;
					$(_pageId+" #container").html("");
					queryCollateral();//查询数据
				}
				$(_pageId+"#stock_list").html("");
			}
		};
			//external.callMessage({"moduleName":"trade","funcNo": "50210", "pageId":"stock_stockBuy", "eleId":"stockCode", "doneLable":"done", "keyboardType":"2"});
		e.stopPropagation();
		},"click");
		//失去焦点关闭原生键盘
		appUtils.bindEvent($(_pageId+"#stockCode"),function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50211"});
			e.stopPropagation();
		},"blur");
	}
    /**
	 * 获取股票列表
	 * */
	function getStockList(stockStr){
		if(stockStr != ""){
			var stockStrParam = {
				"q" : stockStr
			};
			service_hq.getStockList(stockStrParam,function(data){
				if(data.errorNo == 0){
					$(_pageId+"#stock_list").html("");
					var results = data.results;
					//显示股票列表
					if(results && results.length > 0){
						if(results.length >= 6){
							var selectHeight = 6 * 0.44;
						}else{
							selectHeight = 0.44*results.length;
						}
						var listHtml = "<ul style=\"display:block;overflow-y:auto;height:"+selectHeight+"rem\">";
						for(var i = 0;i < results.length; i++) {
							listHtml += "<li data-stockName="+results[i][0]+"><a href=\"javascript:void(0);\" style=\"padding-left:0.20rem;\"><strong class=\"stockcode\" style=\"font-size:0.18rem\">"+results[i][1]+"</strong><span class=\"stockname\">"+results[i][0]+"</span></a>";
							listHtml +=	"<span style=\"display:none;\">"+results[i][9]+"</span></li>";
						};
						listHtml+="</ul>";
						$(_pageId+"#stock_list").append(listHtml);
						appUtils.bindEvent($(_pageId+".trade_form .select_box ul li"),function(){
							var stockCode = $(this).find("strong.stockcode").text();
							var stockName =$(this).find("span.stockname").text();
							$(_pageId + " #stockCode").val(stockCode);
							$(_pageId + " #stockName").text(stockName);
							$(_pageId+"#stock_list").html("");
						});
						//点击其他位置隐藏股票列表
						appUtils.bindEvent($(_pageId + " .table_box"), function(e){
							$(_pageId+" #stock_list").html("");//清空股票搜索框
						},"click");
					}else{
						layerUtils.iAlert("该股票列表不存在");
						$(_pageId + " #remove").remove();
						$(_pageId + " #stockCode").val("");
						$(_pageId + " #stockName").text("证券名称");
					}
				}else{
					layerUtils.iAlert("获取股票列表失败");
					$(_pageId + " #remove").remove();
					$(_pageId + " #stockCode").val("");
					$(_pageId + " #stockName").text("证券名称");
				}
			},{"isShowWait":false});
		}	
	}
	/**
	 * 担保品数据查询
	 */
	function queryCollateral(stockCode)
	{
		queryMsg = null;//查询后返回的结果集
		$(_pageId+" .ti_table tr:eq(0)").nextAll().remove();
		$(_pageId+ ".no_data").hide();
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	//分支机构
		var fund_account = userInfo.fund_account;	//资产账户
		var cust_code = userInfo.cust_code;	//客户代码
		var stock_code = stockCode ? stockCode : "";
		var sessionid = userInfo.session_id;
		var password = userInfo.password;
		var param = {			
			"entrust_way":entrust_way,
			"branch_no":branch_no,
			"fund_account":fund_account,
			"cust_code":cust_code,
			"password":password,
			"sessionid":sessionid,
			"stock_code":stock_code,
			"poststr":poststr,
		};
		service_credit.db_query(param,function db_queryCallBack(data)
		{
			if (data) {
				if(data.error_no == 0)
				{
					var results = data.results;	
					queryMsg = data.results;//将返回的结果集保存
					if(results && results.length > 0){
						var todayDealHtml = "";
						for(i = 0;i < results.length; i++)
						{
							var data = results[i];
							todayDealHtml += createHtml(data);
						}
						$(_pageId + ".visc_pullUp").css("display","block");
						if(stockCode){
							num = 1;
							$(_pageId+" #container").html(todayDealHtml);
						}else{
							num = 20;
							$(_pageId+" #container").append(todayDealHtml);
						}
						if(!vIscroll._init){
							initVIScroll(results.length);
						}else{
							vIscroll.scroll.refresh();
							initVIScroll(num);
						}
					}else{
						$(_pageId+" #container").html("");
						$(_pageId+ ".no_data").show();
//						num = 0;
						$(_pageId+ " .visc_pullUp").hide();
					}
			 	}
				else
				{
					layerUtils.iAlert(data.error_info);	
				}
			}
		},{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function()
			{
				$(_pageId+ ".no_data").show();
				initVIScroll();
				if(vIscroll._init){
					vIscroll.scroll.refresh();
				}
			}
		});
	}
	/**
	 * 
	 * @param {Object} element
	 */
	function createHtml(element)
	{
		var eleHtml = "";
	    eleHtml += "<tr id='remove'>";
		eleHtml += "<td>"+element.stock_code+"</td>";
		eleHtml += "<td>"+element.stock_name+"</td>";
		eleHtml += "<td>"+element.exchange_type_name+"</td>";
		eleHtml += "<td>"+element.assure_ratio+"</td>";
		eleHtml +="</tr>";
		return eleHtml;
	}
	
	/**
	 * 初始化滑动组件
	 */
	function initVIScroll(num){
		if(!vIscroll._init){
			var config = {
					"isPagingType": false,//false表示是微博那种累加形式，true表示分页形式
					"visibleHeight": $(window).height()-$(_pageId+".header").height()-$(_pageId+".search_box").height()-$(_pageId+"#firstTable").height() - 16  ,//显示内容区域的高度，当isPaingType为false时传
					"container": $(_pageId+"#v_container_funds_jj"),	
					"wrapper":$(_pageId+"#v_wrapper_funds_jj"),	
					"downHandle": function() {
						 //queryMsg();//下拉获取上一页数据方法
					},
					"upHandle": function() {
						poststr = poststr+1;
						queryCollateral(stockCode);//上拉获取下一页数据方法
					},
					"wrapperObj": null
			};
			vIscroll.scroll = new VIscroll(config); 	//初始化，需要做if(!hIscroll._init)判断
			vIscroll._init = true;
			if(num < 20 ){
				$(_pageId + ".visc_pullUp").css("display","none");
			}else{
				$(_pageId + ".visc_pullUp").css("display","block");
			}
		} else {
			vIscroll.scroll.refresh();
			if(num < 20 ){
				$(_pageId + ".visc_pullUp").css("display","none");
			}else{
				$(_pageId + ".visc_pullUp").css("display","block");
			}
		}
		$(_pageId+".visc_pullDown").hide();
	}
    
    /**
	 * 生成html
	 * @param {Object} element 数据项
	 */
	/*function createSearchHtml(element)
	{
		var market = element.exchange_type;
		if(market == "0"){
			market = "深A";
		}else if(market == "1")
		{ 
			market ="深B";
		}else if(market == "2")
		{ 
			market ="沪A";
		}else if(market == "3")
		{ 
			market ="沪B";
		}else if(market == "4")
		{ 
			market ="三板";
		}else if(market == "F1")
		{ 
			market ="郑州交易所";
		}else if(market == "F2")
		{ 
			market ="大连交易所";
		}
		
		var eleHtml = "";
	    eleHtml += "<tr id='remove'>";
		eleHtml += "<td>"+element.stock_code+"</td>";
		eleHtml += "<td>"+element.stock_name+"</td>";
		eleHtml += "<td>"+market+"</td>";
		eleHtml += "<td>"+Number(element.assure_ratio*100).toFixed(2)+"%</td>";
		eleHtml +="</tr>";
		return eleHtml;
	}*/
    
    
	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId+" #stock_list").html("");//清空股票搜索框
		$(_pageId + " #stockCode").val("");
		$(_pageId + " #stockName").text("证券名称");
		isStockInput = false;//输入后状态
		$(_pageId+" #container").html("");
		$(_pageId+ ".no_data").hide();
		poststr = 0;
		if(vIscroll._init){
			vIscroll.scroll.refresh();
		}
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageBack();
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});