/**
 * 信用交易-未偿还合约查询
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var service_credit = require("service_credit");
	var common = require("common");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var layerUtils = require("layerUtils");
	var VIscroll = require("vIscroll");
    var vIscroll = {"scroll":null,"_init":false};		//上下滑动
    var _pageId = "#credit_query_contractInquiryQuery ";
    var userInfo = null;
    var queryType = null;
    	
    /**
     * 初始化
     */
	function init(){common.hideBottomBar();
		userInfo = JSON.parse(appUtils.getSStorageInfo("credit_userInfo"));
		$(_pageId).css("overflow-x","hidden");
		var height_table = $(window).height()-$(_pageId+".header").height()-3;
		$(_pageId+".main ").height(height_table).css("overflow","auto");
		//alert(userInfo);
		queryMsg();//查询信息
    }
	/**
	 * 查询信息
	 */
	function queryMsg(){
		$(_pageId+ ".no_data").hide();
		queryContractData(); //未了结合约查询
	}
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId+".top_title .icon_back"), function(e){
			appUtils.pageBack();
			e.stopPropagation();
		});
		
	}
	
	/**
	 * 未偿还合约查询
	 */
	function queryContractData(){
		$(_pageId+".main .table_box").html("");
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	//分支机构
		var fund_account = userInfo.fund_account;	//资产账户
		var cust_code = userInfo.cust_code;	//客户代码
		var sessionid = userInfo.session_id;
		var status = "0";
		var password = userInfo.password;
		var param = {			
			"entrust_way":entrust_way,
			"branch_no":branch_no,
			"fund_account":fund_account,
			"password":password,
			"cust_code":cust_code,
			"compact_status":status,
			"sessionid":sessionid
		};
		service_credit.contractmx_query(param,openInterest_QueryCallBack,
		{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){
				$(_pageId+ ".no_data").show();
				/*initVIScroll();
				if(vIscroll._init){
					vIscroll.scroll.refresh();
				}*/
		}
		});//未偿还合约查询
	}
	/**
	 * 未偿还合约数据查询回调方法
	 */
	function openInterest_QueryCallBack(data){
		if (data){
			if(data.error_no == 0){
				var results = data.results;	
				if(results && results.length > 0){
					var openInterestHtml = "";
					for(var i = 0;i < results.length; i++){
						var data = results[i];
						openInterestHtml += createHtml(data,i);
					}
					$(_pageId+".main .agreement_box").html(openInterestHtml);
					//添加绑定事件
					bindSelectClick();
				}else{
					$(_pageId+".no_data").show();
				}
				/*if(!vIscroll._init){
					initVIScroll();
				}else{
					vIscroll.scroll.refresh();
				}*/
			}
			else
			{
				layerUtils.iAlert(data.error_info);	
			}
		}
	}
	/**
	 * 生成未偿还合约html
	 * @param {Object} element 数据项
	 */
	function createHtml(element,i){
		var temp_color="";
		if(element.compact_type == "0"){
			temp_color="red";
			type = "融资买入";
		}else if(element.compact_type == "1"){
			temp_color="green";
			type = "融券卖出";
		}
			var eleHtml = "";
				eleHtml += "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" class=\"mt10\">";
				eleHtml += "<tr>";
				eleHtml += "  <th width='50%'><h5 class="+temp_color+">"+type+"</h5></th>";
				eleHtml += "  <th width='50%'><span class='name'>合约编号:</span><span class='cont'>"+element.compact_id+"</span></th>";
				eleHtml += "</tr>";
				eleHtml += "<tr>";
				eleHtml += "  <td><span class='name'>开仓日期:</span><span class='cont'>"+element.open_date+"</span></td>";
				eleHtml += "  <td><span class='name'>到期日期:</span><span class='cont'>"+element.ret_end_date+"</span></td>";
				eleHtml += "</tr>";
				eleHtml += "<tr>";
				eleHtml += "  <td><span class='name'>证券名称:</span><span class='cont'>"+element.stock_name+"</span></td>";
				eleHtml += "  <td><span class='name'>证券代码:</span><span class='cont'>"+element.stock_code+"</span></td>";
				eleHtml += "</tr>";
				eleHtml += "<tr >";
				eleHtml += "  <td><span class='name'>负债总额:</span><span class='cont'>"+element.left_amt+"</span></td>";
				eleHtml += "  <td><span class='name'>占用保证金:</span><span class='cont'>"+element.used_bail_balance+"</span></td>";
				eleHtml += "</tr>";
				eleHtml += "<tr style='display:none'>";
				eleHtml += "  <td><span class='name'>合约数量:</span><span class='cont'>"+element.compact_qty+"</span></td>";
				eleHtml += "  <td><span class='name'>未还数量:</span><span class='cont'>"+element.left_qty+"</span></td>";
				eleHtml += "</tr>";
				eleHtml += " <tr style='display:none'>";
				eleHtml += "  <td><span class='name'>合约金额:</span><span class='cont'>"+element.compact_amt_total+"</span></td>";
				eleHtml += "  <td><span class='name'>未还金额:</span><span class='cont'>"+element.left_amt_total+"</span></td>";
				eleHtml += " </tr>";
				eleHtml += "<tr style='display:none'>";
				eleHtml += "  <td><span class='name'>合约利息:</span><span class='cont'>"+element.compact_int+"</span></td>";
				eleHtml += "  <td><span class='name'>未还利息:</span><span class='cont'>"+element.left_int+"</span></td>";
				eleHtml += " </tr>";
				eleHtml += "<tr>";
				eleHtml += "  <td colspan='2' class='open' id="+element.compact_id+"><p><em></em><span>点击展开</span></p></td>";
				eleHtml += "</tr>";
				eleHtml += " </table>";
		return eleHtml;
	}
	
	//选择点击事件
	function bindSelectClick(){
		//绑定伸缩按钮
		appUtils.bindEvent($(_pageId + " .agreement_box table tr td p span"), function(e){
			var content = $(this).text();
			if(content == "点击收缩"){
				$(this).parents("table").find("tr:eq(4)").hide();
				$(this).parents("table").find("tr:eq(5)").hide();
				$(this).parents("table").find("tr:eq(6)").hide();
				$(this).text("点击展开");
				$(this).parents("td").removeClass("close").addClass("open");
			}else{
				$(this).parents("table").find("tr:eq(4)").show();
				$(this).parents("table").find("tr:eq(5)").show();
				$(this).parents("table").find("tr:eq(6)").show();
				$(this).text("点击收缩");
				$(this).parents("td").removeClass("open").addClass("close");
			}
			//e.stopPropagation();
		},"click");
	}
    
	/**
	 * 初始化滑动组件
	 */
	/*function initVIScroll(){
		if(!vIscroll._init){
			var config = {
					"isPagingType": false,//false表示是微博那种累加形式，true表示分页形式
					"visibleHeight": $(window).height() - $(_pageId+".top_title").height() - 6  ,//显示内容区域的高度，当isPaingType为false时传
					"container": $(_pageId+"#v_container_funds_jj"),	
					"wrapper":$(_pageId+"#v_wrapper_funds_jj"),	
					"downHandle": function() {
						 queryMsg();//下拉获取上一页数据方法
					},
					"upHandle": function() {	
						//上拉获取下一页数据方法
					},
					"wrapperObj": null
			};
			vIscroll.scroll = new VIscroll(config); 	//初始化，需要做if(!hIscroll._init)判断
			vIscroll._init = true;
		} else {
			vIscroll.scroll.refresh();
		}
		$(_pageId+ " .visc_pullUp").hide();
	}*/
	
	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId+".main .agreement_box").html("");
		$(_pageId+ ".no_data").hide();
		/*if(vIscroll._init){
			vIscroll.scroll.refresh();
		}*/
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageBack();
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});