/**
 * 信用交易-选择合约
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var service_credit = require("service_credit");
	var common = require("common");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var layerUtils = require("layerUtils");
	var VIscroll = require("vIscroll");
    var vIscroll = {"scroll":null,"_init":false};		//上下滑动
    var _pageId = "#credit_query_contractSelectQuery ";
    var userInfo = null;
    var query_type = null; //合约状态 0-未了结  1-已了结
    var fromPage = "";
    var compact_type="";//合约类型   0-融资  1-融券
    var compact_id = null; //被选中的合约编号
    var compact_name=null; //合约名称
    var compact_date=null; //合约日期
    var compact_initDate=null;//合约开仓日期
    var stock_code = null;//证券代码
    var stock_name = null;	
    var compact_id_bak =null;
    var compact_date_bak =null;
    var compact_initDate_bak=null;
    var stock_code_bak =null;
    var stock_name_bak =null;
    var compact_name_bak = null;
    var flag = false;//判断跳转过来时是否包含合约信息
    
    /**
     * 初始化
     */
	function init(){common.hideBottomBar();
		var height_table = $(window).height() - $(_pageId+".header").height()-$(_pageId+".fund_table thead").height();
//		$(_pageId+".fund_table tbody").height(height_table).css("overflow", "auto"); 
        $(_pageId+".fund_table tbody").css({
        	"height": height_table,
        	"overflow-y": "auto",
           	"overflow-x": "hidden"
        });   //给持仓数据添加高度
		$(_pageId).css("overflow-y","hidden");
		$(_pageId).css("overflow-x","hidden");
		query_type = appUtils.getPageParam("param");
		compact_id = null;
		compact_name=null;
		compact_date=null;
		compact_initDate=null;
		stock_code=null;
		stock_name=null;
		compact_id_bak =null;
	    compact_date_bak =null;
	    compact_initDate_bak=null;
	    stock_code_bak =null;
	    stock_name_bak =null;
	    compact_name_bak = null;
		fromPage = appUtils.getPageParam("fromPage"); //判断从那个页面跳转过来
		compact_id = appUtils.getPageParam("compact_id");
		compact_name = appUtils.getPageParam("compact_name");
		compact_date = appUtils.getPageParam("compact_date");
		compact_initDate = appUtils.getPageParam("compact_initDate");
		compact_type = appUtils.getPageParam("compact_type");
		stock_code = appUtils.getPageParam("stock_code");
		stock_name = appUtils.getPageParam("stock_name");
		//其他页面跳转过来时是否包含合约信息
		if(compact_id || stock_name){
			flag = true;
			compact_id_bak = compact_id;
		    compact_date_bak = compact_date;
		    compact_initDate_bak = compact_initDate;
		    stock_code_bak = stock_code;
		    stock_name_bak = stock_name;
		    compact_name_bak = compact_name;
		}else{
			flag = false;
		}
		userInfo = JSON.parse(appUtils.getSStorageInfo("credit_userInfo"));
		
		if(compact_type=="0"){    //融资标题
			$(_pageId + ".top_title h3").text("未还融资合约");
			$(_pageId+".tab_nav ul li:eq(0)").addClass("active").siblings().removeClass("active");
		}else if(compact_type=="1"){    //融券标题
			$(_pageId + ".top_title h3").text("未还融券合约");
			$(_pageId+".tab_nav ul li:eq(1)").addClass("active").siblings().removeClass("active");
		}
		queryMsg(query_type);//查询信息
    }
	/**
	 * 查询信息
	 */
	function queryMsg(query_type){
		$(_pageId+ ".no_data").hide();
//		if($(_pageId+".tab_nav ul li:eq(0)").hasClass("active")){
//			queryContractData(); //未偿还合约查询
//		}else{
			queryContractData(query_type); //已了结合约查询
//		}
	}
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId+".top_title .cancel_text"), function(e){
			if(fromPage == null || fromPage == ""){
				appUtils.pageInit("credit/query/contractSelectQuery","credit/order/cashPayments");
			}else{
				if(flag){
					appUtils.pageInit("credit/query/contractSelectQuery",fromPage,{"compact_id":compact_id_bak,"compact_name":compact_name_bak,"compact_date":compact_date_bak,"compact_initDate":compact_initDate,"stock_code":stock_code_bak,"stock_name":stock_name_bak});
				}else{
					appUtils.pageInit("credit/query/contractSelectQuery",fromPage,{});
				}
			}
			e.stopPropagation();
		});
		//保存按钮
		appUtils.bindEvent($(_pageId+".top_title .keep_text"), function(e){
			if(fromPage == null || fromPage == ""){
				appUtils.pageInit("credit/query/contractSelectQuery","credit/order/cashPayments");
			}else{
				if(compact_id){
					appUtils.pageInit("credit/query/contractSelectQuery",fromPage,{"compact_id":compact_id,"compact_name":compact_name,"compact_date":compact_date,"compact_initDate":compact_initDate,"stock_code":stock_code,"stock_name":stock_name});
				}else{
					layerUtils.iAlert("请选择合约");
				}
			}
			e.stopPropagation();
		});
	}
	
	/**
	 * 未偿还合约查询
	 */
	function queryContractData(status){
		$(_pageId+".main .table_box").html("");
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	//分支机构
		var fund_account = userInfo.fund_account;	//资产账户
		var cust_code = userInfo.cust_code;	//客户代码
		var sessionid = userInfo.session_id;
		var password = userInfo.password;
		var param = {			
			"entrust_way":entrust_way,
			"branch_no":branch_no,
			"fund_account":fund_account,
			"password":password,
			"cust_code":cust_code,
			"compact_status":"0",
			"stock_code":stock_code,
			"compact_type":compact_type,
			"sessionid":sessionid
		};
		service_credit.contractmx_query(param,openInterest_QueryCallBack,
		//service_credit.openInterest_Query(param,openInterest_QueryCallBack,
		{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){
				$(_pageId+ ".no_data").show();
		}
		});//未偿还合约查询
	}
	/**
	 * 未偿还合约数据查询回调方法
	 */
	function openInterest_QueryCallBack(data){
		if (data){
			if(data.error_no == 0){
				var results = data.results;	
				if(compact_type==0){
					var headTr = "<tr><th scope=\"col\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</th><th scope='col'>开仓日期<br />到期日期</th> "+
					"<th scope='col'>合约编号<br />合约类型</th><th scope='col'>证券名称<br />代码</th><th scope='col'>待偿金额<br/>待偿利息</th></tr>";
				}else{
					var headTr = "<tr><th scope=\"col\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</th><th scope='col'>开仓日期<br />到期日期</th> "+
					"<th scope='col'>合约编号<br />合约类型</th><th scope='col'>证券名称<br />代码</th><th scope='col'>待偿数量<br/>待偿利息</th></tr>";
				}
				$(_pageId+".fund_table .ce_table thead").html(headTr);
				var openInterestHtml = "";
				if(results && results.length > 0){
					for(var i = 0;i < results.length; i++){
						var data = results[i];
						openInterestHtml += createHtml(data,i);
					}
					$(_pageId+".main .fund_table .ce_table tbody").html(openInterestHtml);
					//绑定选择点击事件
					bindSelectClick();
				}else{
					$(_pageId+".main .fund_table ").hide();
					$(_pageId+".no_data").show();
				}
			}
			else
			{
				layerUtils.iAlert(data.error_info);	
			}
		}
	}
	
	
	/**
	 * 生成未偿还合约html
	 * @param {Object} element 数据项
	 */
	function createHtml(element,i){
		var eleHtml = "<tr class='select_tr' style='background-color:"+'#ffffff'+"'><td class='input_check ' data_select_info='"+element.compact_id+"' compact_name='"+element.stock_name+"' compact_date='"+element.ret_end_date+"' compact_initDate='"+element.open_date+"'</td><td>"+element.open_date+"<br />"+element.ret_end_date+"</td>";
		if(element.compact_type==0){
			eleHtml+="<td>"+element.compact_id +"<br/>融资</td>";
		}else{
		    eleHtml+="<td>"+element.compact_id +"<br/>融券</td>";
		}
		eleHtml+="<td>"+element.stock_name +"<br/>"+element.stock_code +"</td>";
		if(compact_type==0){
			eleHtml+="<td>"+Number(element.left_amt_total).toFixed(2)+"<br/>"+Number(element.left_int).toFixed(2)+"</td></tr>";
		}else{
			eleHtml+="<td>"+Number(element.left_qty).toFixed(2) +"<br/>"+Number(element.left_int).toFixed(2) +"</td></tr>";
		}
		return eleHtml;
	}
	
	//选择点击事件
	function bindSelectClick(){
		//绑定选择全选按钮
		/*appUtils.bindEvent($(_pageId + " #all_select_zjp"), function(e){
			var $this = $(this),
				is_check = $this.hasClass("checked");
			if (is_check){
				$this.removeClass("checked");
				$(_pageId + " .select_tr").css("background-color", "#ffffff");
				$(_pageId + " .select_tr .input_check").removeClass("checked");
			} else {
				$this.addClass("checked");
				$(_pageId + " .select_tr").css("background-color", "#eff7ff");
				$(_pageId + " .select_tr .input_check").addClass("checked");
			}
			e.stopPropagation();
		});*/
		//绑定选择单个按钮
		appUtils.bindEvent($(_pageId + " .select_tr "), function(e){
			var $this = $(this),
			$check = $this.find(".input_check"),
			is_click = $check.hasClass("checked");
			if (is_click){
				compact_id="";
				compact_name="";
				compact_date="";
				compact_initDate="";
				$check.removeClass("checked");
				$this.css("background-color", "#ffffff");
			} else {
				$check.addClass("checked");
				$this.css("background-color", "#eff7ff");
				$this.siblings().css("background-color", "#ffffff");
				$this.siblings().find(".input_check").removeClass("checked");
				compact_id=$check.attr("data_select_info");
				compact_name=$check.attr("compact_name");
				compact_date=$check.attr("compact_date");
				compact_initDate=$check.attr("compact_initDate");   //?
			}
			e.stopPropagation();
		});
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId+".main .fund_table .ce_table tbody").html("");
		$(_pageId+ ".no_data").hide();
		compact_id = "";
		if(vIscroll._init){
			vIscroll.scroll.refresh();
		}
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageBack();
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});