/**
 * 信用交易-资产负债汇总
 */
define(function(require,exports,module){
	var appUtils = require("appUtils");
	var	layerUtils = require("layerUtils");
	var	VIscroll = require("vIscroll");
	var gconfig = require("gconfig");
	var common = require("common");
	var global = gconfig.global;
	var	service_credit = require("service_credit");
    var	vIscroll = {"scroll":null,"_init":false};	//上下滑动
	var	_pageId = "#credit_query_creditAssetsQuery ";
	var userInfo = null;//保存的客户信息
	
	/**
	 * 初始化
	 * */
	function init(){common.hideBottomBar();
		/*var prePage = appUtils.getPageParam("param"); //获取上一个页面传过来的参数，判断展示 哪个页面	
		if(prePage && prePage=="assert"){
			$(_pageId+"#changeTitle li:eq(0)").addClass("active").siblings().removeClass("active");
			$(_pageId + ".top_title .icon_back").text("资产");
			$(_pageId + "#zc").show();
			$(_pageId + "#fz").hide();
			$(_pageId + "#sy").hide();
		}else if(prePage && prePage=="debit"){
			$(_pageId+"#changeTitle li:eq(1)").addClass("active").siblings().removeClass("active");
			$(_pageId + ".top_title .icon_back").text("资产");
			$(_pageId + "#zc").hide();
			$(_pageId + "#fz").show();
			$(_pageId + "#sy").hide();
		}*/
		userInfo = JSON.parse(appUtils.getSStorageInfo("credit_userInfo"));
		$(_pageId).css("overflow-x","hidden");
		//查询资产数据
		queryAssetsData();
	}
	
	/**
	 * 事件绑定
	 * */
	function bindPageEvent(){
		//点击查询标题名字
		/*appUtils.bindEvent($(_pageId+"#changeTitle li"), function(e){
			var titleIndex = $(this).index();
			if(titleIndex == 0){
				$(this).addClass("active").siblings().removeClass("active");
				$(_pageId + "#zc").show();
				$(_pageId + "#fz").hide();
				$(_pageId + "#sy").hide();
			}else if(titleIndex == 1){
				$(this).addClass("active").siblings().removeClass("active");
				$(_pageId + "#zc").hide();
				$(_pageId + "#fz").show();
				$(_pageId + "#sy").hide();
			}else if(titleIndex == 2){
				$(this).addClass("active").siblings().removeClass("active");
				$(_pageId + "#zc").hide();
				$(_pageId + "#fz").hide();
				$(_pageId + "#sy").show();
			}
			e.stopPropagation();
		},"click");*/
		
		//后退
		appUtils.bindEvent($(_pageId+" .icon_back"), function(e){
			//appUtils.pageInit("credit/query/creditAssetsQuery","credit/query/financingQuery",{});
			appUtils.pageBack();
			e.stopPropagation();
		});
		
	}
	/**
	 * 总数据查询
	 */
	function queryAssetsData(){
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	//分支机构
		var fund_account = userInfo.fund_account;	//资产账户
		var cust_code = userInfo.cust_code;	//客户代码
		var sessionid = userInfo.session_id;
		var password = userInfo.password;
		var param = {			
			"entrust_way":entrust_way,
			"branch_no":branch_no,
			"fund_account":fund_account,
			"password":password,
			"cust_code":cust_code,
			"sessionid":sessionid
		};
		service_credit.rzrq_liabilitiesQuery(param,rzrq_liabilitiesQueryCallBack,
			{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){
				$(_pageId + " table tr td").text("--");
			}
		});
	}
	
	/**
	 * 资产数据调方法
	 * @param {Object} data 返回数据
	 */
	function rzrq_liabilitiesQueryCallBack(data){
		if (data) {
			if(data.error_no == 0){
				var results = data.results;	
				if(results && results.length > 0){
					var data = results[0];
					//填充资产
					$(_pageId+"#zczz").text(common.numToMoneyType(data.assert_val));//信用账户总资产
					$(_pageId+"#xjzc").text(common.numToMoneyType(data.fund_asset));//现金资产
					$(_pageId+"#zqsz").text(common.numToMoneyType(data.market_value));//证券市值
					$(_pageId+"#fzze").text(common.numToMoneyType(data.total_debit));//负债总额
					$(_pageId+"#rzfz").text(common.numToMoneyType(data.fin_debit));//融资负债
					$(_pageId+"#rqfz").text(common.numToMoneyType(data.slo_debit));//融券负债
					$(_pageId+"#fzlx").text(common.numToMoneyType(data.interest_debit));//负债利息
					$(_pageId+"#wcdbbl").text(data.per_assurescale_value);//维持担保比例
					/*$(_pageId+"#zc td:eq(8)").text(data.fin_enrepaid_balance);//可用于现金还款资金
					$(_pageId+"#zc td:eq(9)").text(data.fetch_balance);//现金可取
					$(_pageId+"#zc td:eq(10)").text(data.slo_sell_balance);//融券卖出资金*/			
				}
			}
			else{
				layerUtils.iAlert(data.error_info);
			}
		}
	}
	
	/**
	 * 初始化滑动组件
	 */
	/*function initVIScroll(){
		if(!vIscroll._init){
			var config = {
					"isPagingType": false,//false表示是微博那种累加形式，true表示分页形式
					"visibleHeight": $(window).height() - $(_pageId+".top_title").outerHeight()- $(_pageId+".toggle_nav").outerHeight()  ,//显示内容区域的高度，当isPaingType为false时传
					"container": $(_pageId+"#v_container_funds_jj"),	
					"wrapper":$(_pageId+"#v_wrapper_funds_jj"),	
					"downHandle": function() {
						$(_pageId + " table tr td").text("--");
						//查询资产数据
						queryAssetsData();
					},
					"upHandle": function() {	
						//上拉获取下一页数据方法
					},
					"wrapperObj": null
			};
			vIscroll.scroll = new VIscroll(config); 	//初始化，需要做if(!hIscroll._init)判断
			vIscroll._init = true;
		} else {
			vIscroll.scroll.refresh();
		}
		$(_pageId+ ".visc_pullUp").hide();
	}*/
	
	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId + "#zc").show();
		$(_pageId + "#fz").hide();
		$(_pageId + "#sy").hide();
		$(_pageId + " table tr td").text("--");
		$(_pageId + ".top_title .icon_back").text("查询");
		$(_pageId+"#changeTitle li:eq(0)").addClass("active").siblings().removeClass("active");
		/*if(vIscroll._init){
			vIscroll.scroll.refresh();
		}*/
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageBack();
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});