/**
 * 信用交易-授信额度查询
 */
define(function(require,exports,module){
	var appUtils = require("appUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var layerUtils = require("layerUtils");
	var common = require("common");
	var VIscroll = require("vIscroll");
    var vIscroll = {"scroll":null,"_init":false};	
	var service_credit = require("service_credit");
	var _pageId = "#credit_query_creditLine ";
	var userInfo = null;//保存的客户信息
	/**
	 * 初始化
	 * */
	function init(){common.hideBottomBar();
		//获取客户保存在本地的数据
		userInfo = JSON.parse(appUtils.getSStorageInfo("credit_userInfo"));
		$(_pageId).css("overflow-x","hidden");
		querycreditLineData();//查询数据
	}
	/**
	 * 事件绑定
	 * */
	function bindPageEvent(){
		//后退
		appUtils.bindEvent($(_pageId+" .icon_back"), function(e){
			appUtils.pageBack();
			e.stopPropagation();
		});
	}
	/**
	 * 总数据查询
	 */
	function querycreditLineData(){
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	//分支机构
		var fund_account = userInfo.fund_account;	//资产账户
		var cust_code = userInfo.cust_code;	//客户代码
		var sessionid = userInfo.session_id;
		var password = userInfo.password;
		var param = {			
			"entrust_way":entrust_way,
			"branch_no":branch_no,
			"fund_account":fund_account,
			"password":password,
			"cust_code":cust_code,
			"sessionid":sessionid
		};
		service_credit.rzrq_liabilitiesQuery(param,rzrq_liabilitiesQueryCallBack);
	}
	/**
	 * 负债汇总数据方法
	 * @param {Object} data 返回数据
	 */
	function rzrq_liabilitiesQueryCallBack(data){
		if (data){
			if(data.error_no == 0){
				var results = data.results;	
				if(results && results.length > 0){
					var data = results[0];
					$(_pageId+"#sxzed").text(common.numToMoneyType(data.totalcred_quote));//授信总额度
					$(_pageId+"#kyrzed").text(common.numToMoneyType((Number(data.ficredit_avl)+Number(data.slcredit_avl)).toFixed(2)));//可用融资额度
//					var freeze_ficredit = data.freeze_ficredit || "--";
//					$(_pageId+"#djrzed").text(freeze_ficredit);//冻结融资额度
					$(_pageId+"#yyrzed").text(common.numToMoneyType((Number(data.ficredit_used)+Number(data.slcredit_used)).toFixed(2)));//已用融资额度
//					$(_pageId+"#kyrqed").text(data.slcredit_avl);//可用融券额度
//					$(_pageId+"#djrqed").text(data.freeze_slcredit);//冻结融券额度
//					$(_pageId+"#yyrqed").text(data.slcredit_used);//已用融券额度
				}
				/*if(!vIscroll._init){
					initVIScroll();
				}else{
					vIscroll.scroll.refresh();
				}*/
			}
			else{
				layerUtils.iAlert(data.error_info);	
			}
		}
	}
	
	/**
	 * 初始化滑动组件
	 */
	/*function initVIScroll(){
		if(!vIscroll._init){
			var config = {
					"isPagingType": false,//false表示是微博那种累加形式，true表示分页形式
					"visibleHeight": $(window).height() - $(_pageId+".top_title").height()- $(_pageId+".tab_nav").height()- 6  ,//显示内容区域的高度，当isPaingType为false时传
					"container": $(_pageId+"#v_container_funds_jj"),	
					"wrapper":$(_pageId+"#v_wrapper_funds_jj"),	
					"downHandle": function() {
						$(_pageId+".cred_info span").text("--");
						querycreditLineData();//下拉获取上一页数据方法
					},
					"upHandle": function() {	
						//上拉获取下一页数据方法
					},
					"wrapperObj": null
			};
			vIscroll.scroll = new VIscroll(config); 	//初始化，需要做if(!hIscroll._init)判断
			vIscroll._init = true;
		} else {
			vIscroll.scroll.refresh();
		}
		$(_pageId+ ".visc_pullUp").hide();
	}*/
	
	/**
	 * 销毁
	 * */
	function destroy(){
		$(_pageId+".cred_info span").text("--");
		/*if(vIscroll._init){
			vIscroll.scroll.refresh();
		}*/
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageBack();
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});