/**
 * 普通交易-历史查询
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var common = require("common");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var layerUtils = require("layerUtils");
	var service_credit = require("service_credit");	//上下滑动
    var _pageId = "#credit_query_dealQuery ";
    var timeLimit = 0; //默认查询当日委托数据
    var userInfo = null;
    
    /**
     * 初始化
     */
	function init(){
		common.hideBottomBar();
		$(_pageId+".no_data").hide();
		userInfo = JSON.parse(appUtils.getSStorageInfo("credit_userInfo"));
		dealEntrust(timeLimit);
		setTimeout(function(){
			var height_table = $(window).height()-$(_pageId+".header").height()-3;
			$(_pageId+".main ").height(height_table).css("overflow","auto");
		},400);
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId+".top_title .icon_back"), function(e){
			appUtils.pageBack();
			e.stopPropagation();
		});
		
		//时间按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_nav"), function(e){
			$(_pageId + ".top_title .top_nav").slideToggle("fast");
		});
		
		//时间选择
		appUtils.bindEvent($(_pageId + ".top_title .top_nav ul li a"), function(e){
			timeLimit = $(this).attr("value");
			var timeText = $(this).text();
			$(_pageId + ".top_title .top_nav").hide();
			$(_pageId + ".top_title small").text(timeText);
			dealEntrust(timeLimit);
		});
				
		//点击其他位置，隐藏下拉框
		appUtils.bindEvent($(_pageId + ".main"),function(){
			if($(_pageId + ".top_title .top_nav").is(':visible')){
				$(_pageId + ".top_title .top_nav").slideToggle("fast");
			}
		});	
		
		//关闭提示框事件
		appUtils.bindEvent($(_pageId + ".main .green_tips em"),function(){
			$(_pageId + ".main .green_tips").hide();
		});
	}
		
	/**
	 * 当日、历史委托查询
	 */
	function dealEntrust(timeLimit){
		var entrust_way=global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;
		var sessionid=userInfo.session_id;
		var password = userInfo.password;
		var exchange_type = "";
		var entrust_bs = "";  //委托标志
		var stock_account = ""; //股东代码
		var stock_code = ""; //证券代码
		
		if(timeLimit == 0){
			var param={				
					"entrust_way":entrust_way,
				    "branch_no":branch_no,
				    "fund_account":fund_account,
				    "cust_code":cust_code,
				    "password":password,
				    "sessionid":sessionid,
				    "exchange_type":exchange_type,
				    "entrust_bs":entrust_bs,
				    "stock_account":stock_account,
				    "stock_code":stock_code
				};
				//$(_pageId+ ".no_data").hide();
				service_credit.todaycj_query(param,dealEntrustCallback,
					{
					"isLastReq":true,
					"isShowWait":true,
					"isShowOverLay":false,
					"timeOutFunc":function(){
					$(_pageId+ ".no_data").show();
					}
				});				
		}else if(timeLimit == 7||timeLimit == 30||timeLimit == 90){
			var end_time = new Date();  
			var begin_time  = new Date();	//截止时间
			begin_time.setDate(begin_time.getDate() - timeLimit);
			begin_time=begin_time.format("yyyy-MM-dd");
			end_time.setDate(end_time.getDate());
			end_time=end_time.format("yyyy-MM-dd");
			var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "cust_code":cust_code,
			    "password":password,
			    "sessionid":sessionid,
			    "begin_time":begin_time,
			    "end_time":end_time,
			    "exchange_type":exchange_type,
			    "entrust_bs":entrust_bs,
			    "stock_account":stock_account,
			    "stock_code":stock_code
			};
			//$(_pageId+ ".no_data").hide();
			service_credit.queryHistoryTrade(param,dealEntrustCallback,
				{
				"isLastReq":true,
				"isShowWait":true,
				"isShowOverLay":false,
				"timeOutFunc":function(){
				$(_pageId+ ".no_data").show();
				}
			});
		}else{
			//Todo nothing
		}
	}
	/**
	 * 成交查询回调
	 */
	function dealEntrustCallback(data){
		if (typeof(data) != "undefined" && data) {
			//$(_pageId+".search_list").html("");
			if(data.error_no == 0){
				$(_pageId+".no_data").hide();
				var results = data.results;
				if(results.length>0 && results!= "undefined"){
					var data = "";
					for (var i=0;i<results.length;i++){
						data += queryEntrustHTML(results[i]);
					}
					$(_pageId+".mar_stock").html(data);
				}else{
					$(_pageId+".no_data").show();
				}
			}else{
				layerUtils.iAlert(data.error_info);
			}
		}else{
			  layerUtils.iAlert("查询失败");
		}
	}

	/**
	 * 委托查询HTML生成
	 */
	function queryEntrustHTML(element){
		//var price_digit = 2;
		var css = "";
		//var statuscss = "";
		var entrust_type_name = element.entrust_type_name;
		if(entrust_type_name == "融资买入"||entrust_type_name == "担保品买入"||entrust_type_name == "担保品提交"){
			css = "bg_red";
		}else if(entrust_type_name == "融券卖出"||entrust_type_name == "担保品卖出"||entrust_type_name == "担保品返回"){
			css = "bg_green";
		}else if(entrust_type_name == "卖券还款"||entrust_type_name == "直接还券"||entrust_type_name == "买券还券"||entrust_type_name == "现金还款"){
			css = "bg_blue";
		}else{
			css = "";
		}
		if(entrust_type_name == "直接还券"){
			entrust_type_name = "现券还券";
		}
		var business_time = element.business_date+" "+element.business_time;
        var eleHtml = "";        
        eleHtml+="<div class='part part02'><span class='stat1 have_deal'>"+element.real_status_name+"</span>"
		        +"<h5><strong class='"+css+"'>"+entrust_type_name+"</strong><small>成交时间:"+business_time+"</small></h5>"
		        +"<dl class='clearfix'>"
		        +"<dt class='p20'><h3>"+element.stock_name+"</h3><p><span>"+element.stock_code+"</span></p></dt>"
		        +"<dd class='height8'><p><em>委托价:</em>"+Number(element.entrust_price).toFixed(3)+"</p><p><em>成交价:</em>"+Number(element.business_price).toFixed(3)+"</p><p><em>合同号:</em>"+element.report_no+"</p><p><em>成交额:</em>"+element.business_balance+"</p></dd>"
		        +"<dd><p><em>委托数:</em>"+element.entrust_amount+"</p><p><em>成交数:</em>"+element.business_amount+"</p><p><em>成交号:</em>"+element.entrust_no+"</p></dd>"
		        +"</dl></div>";
        console.log(element.entrust_name);
        return eleHtml;
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		timeLimit = 0;
		$(_pageId + " .no_data").hide();
		$(_pageId + " .mar_stock").html("");
		$(_pageId + ".top_title .top_nav").hide();
		$(_pageId + " .green_tips").show();
		$(_pageId + " .top_title small").text("当日成交");	
	}		
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageBack();
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});