/**
 * 信用交易-交割单查询
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var common = require("common");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var layerUtils = require("layerUtils");
	var VIscroll = require("vIscroll");
	var service_credit = require("service_credit");
	var external = require("external");
    var vIscroll = {"scroll":null,"_init":false};		//上下滑动
    var _pageId = "#credit_query_deliveryOrderQuery ";
    var timeLimit = 0; //默认查询当日的数据
    var userInfo = null;
    var jump_flag = null; //从那个地方跳转过来的标识
    
    /**
     * 初始化
     */
	function init(){common.hideBottomBar();
		userInfo = JSON.parse(appUtils.getSStorageInfo("credit_userInfo"));
		var height_table = $(window).height() - $(_pageId+".header").height()-3;
		jump_flag = appUtils.getPageParam("param");
	    $(_pageId+".main").height(height_table).css("overflow", "auto"); 
	    $(_pageId).css("overflow-x","hidden");
		deliveryQuery(timeLimit);
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			if(jump_flag && jump_flag == "credit_financy_query"){
				appUtils.pageBack();
			}else{
				var param = {
						"funcNo":"50101",
						"moduleName":"ygt",
						"params" :{
							"topage" : "credit/creditAccount.html",//跳转url
						}
				};
				external.callMessage(param);
				setTimeout(function(){
					appUtils.pageInit("credit/query/deliveryOrderQuery","credit/index",{});
				},300);
			}
			e.stopPropagation();
		});
		//时间按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_nav"), function(e){
			$(_pageId + ".top_title .top_nav").slideToggle("fast");
			e.stopPropagation();
		});
		//时间选择
		appUtils.bindEvent($(_pageId + ".top_title .top_nav ul li a"), function(e){
			if(vIscroll._init){
				vIscroll.scroll.destroy();
				vIscroll.scroll = null;
				vIscroll._init = false;
			}
			timeLimit = $(this).attr("value");
			var timeText = $(this).text();
			$(_pageId + ".top_title .top_nav").hide();
			$(_pageId + ".top_title small").text(timeText);
			deliveryQuery(timeLimit);
		});
		//点击其他位置，隐藏下拉框
		appUtils.bindEvent($(_pageId + ".main"),function(){
			if($(_pageId + ".top_title .top_nav").is(':visible')){
				$(_pageId + ".top_title .top_nav").slideToggle("fast");
			}
		});
		//关闭提示框事件
		appUtils.bindEvent($(_pageId + ".main .green_tips em"),function(){
			$(_pageId + ".main .green_tips").hide();
		});
	}
	
	/**
	 * 交割单查询
	 */
	function deliveryQuery(timeLimit){
		$(_pageId+".search_list").html("");
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;
		var sessionid=userInfo.session_id;
		var password = userInfo.password;
		var end_time = new Date();  
		var begin_time  = new Date();	//截止时间
		if(timeLimit == 0){
			begin_time.setDate(begin_time.getDate());
			begin_time=begin_time.format("yyyy-MM-dd");
			end_time.setDate(end_time.getDate());
			end_time=end_time.format("yyyy-MM-dd");
		}else if(timeLimit == 7||timeLimit == 30||timeLimit == 90){
			begin_time.setDate(begin_time.getDate() - timeLimit);
			begin_time=begin_time.format("yyyy-MM-dd");
			end_time.setDate(end_time.getDate());
			end_time=end_time.format("yyyy-MM-dd");
		}
		var param={			
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"sessionid":sessionid,
				"password":password,
				"begin_time":begin_time,
				"end_time":end_time
			};
		$(_pageId+ ".no_data").hide();
		service_credit.statementAccount_Query(param,queryDeliveryCallback,
			{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){
				$(_pageId+ ".no_data").show();
				initVIScroll();
				if(vIscroll._init){
					vIscroll.scroll.refresh();
				}
			}
		});
	}
	/**
	 * 交割单查询回调
	 */
	function queryDeliveryCallback(data){
		if (typeof(data) != "undefined" && data) {
			$(_pageId+".agreement_box").html("");
			if(data.error_no == 0){
				$(_pageId+".no_data").hide();
				var results = data.results;
				if(results.length>0 && results!= "undefined"){
					var data = "";
					for (var i=0;i<results.length;i++){
						data += queryEntrustHTML(results[i]);
					}
					$(_pageId+".agreement_box").html(data);
					//添加绑定事件
					bindSelectClick();
				}else{
					$(_pageId+".no_data").show();
				}
				/*if(!vIscroll._init){
					initVIScroll();
				}else{
					vIscroll.scroll.refresh();
				}*/
			}
			else{
				layerUtils.iAlert(data.error_info);
			}
		}
		else{
			  layerUtils.iAlert("查询失败");
		}
	}
	
	/**
	 * 交割单查询HTML生成
	 */
	function queryEntrustHTML(element){
		var css = "";
		var entrust_type_name = element.entrust_type_name;
        var eleHtml = "";
        eleHtml+="<table width='100%' border='0' cellspacing='0' cellpadding='0' class='mt10'>";
        eleHtml+="<tr><th width='50%'><h5 class='blue'>"+entrust_type_name+"</h5></th><th width='50%'><span class='time'>清算日期:"+element.clear_date+"</span></th></tr>";
        eleHtml+="<tr><td><span class='name'>证券名称:</span><span class='cont'>"+element.stock_name+"</span></td><td><span class='name'>证券代码:</span><span class='cont'>"+element.stock_code+"</span></td></tr>";
        eleHtml+="<tr><td><span class='name'>合同号码:</span><span class='cont'>"+element.entrust_no+"</span></td><td><span class='name'>交易行为:</span><span class='cont'>"+element.entrust_name+"</span></td></tr>";
        eleHtml+="<tr><td><span class='name'>委托数量:</span><span class='cont'>"+element.entrust_amount+"</span></td><td><span class='name'>委托价格:</span><span class='cont'>"+Number(element.entrust_price).toFixed(3)+"</span></td></tr>";
        eleHtml+="<tr style='display:none'><td><span class='name'>成交数量:</span><span class='cont'>"+element.occur_amount+"</span></td><td><span class='name'>成交价格:</span><span class='cont'>"+Number(element.business_price).toFixed(3)+"</span></td></tr>";
        eleHtml+="<tr style='display:none'><td><span class='name'>成交金额:</span><span class='cont'>"+element.occur_balance+"</span></td><td><span class='name'>实&nbsp;&nbsp;收&nbsp;&nbsp;付:</span><span class='cont'>"+element.sett_amt+"</span></td></tr>";
        eleHtml+="<tr style='display:none'><td><span class='name'>本次余额:</span><span class='cont'>"+element.balance+"</span></td><td><span class='name'>本次余股:</span><span class='cont'>"+element.share_bln+"</span></td></tr>";
        eleHtml+="<tr><td colspan='2' class='open'><p><em></em><span>点击展开</span></p></td></tr></table>";
        return eleHtml;

	}
	
	/**
	 * 初始化滑动组件
	 */
	/*function initVIScroll(){
		if(!vIscroll._init){
			var config = {
					"isPagingType": false,//false表示是微博那种累加形式，true表示分页形式
					"visibleHeight": $(window).height() - $(_pageId+".top_title").height()- $(_pageId+".tab_nav").height()- 6  ,//显示内容区域的高度，当isPaingType为false时传
					"container": $(_pageId+"#v_container_funds_jj"),	
					"wrapper":$(_pageId+"#v_wrapper_funds_jj"),	
					"downHandle": function() {
						deliveryQuery(timeLimit);
					},
					"upHandle": function() {	
						//上拉获取下一页数据方法
					},
					"wrapperObj": null
			};
			vIscroll.scroll = new VIscroll(config); 	//初始化，需要做if(!hIscroll._init)判断
			vIscroll._init = true;
		} else {
			vIscroll.scroll.refresh();
		}
		$(_pageId+ " .visc_pullUp").hide();
	}*/
	
	//选择点击事件
	function bindSelectClick(){
		//绑定伸缩按钮
		appUtils.bindEvent($(_pageId + " .agreement_box table tr td p span"), function(e){
			var content = $(this).text();
			if(content == "点击收缩"){
				$(this).parents("table").find("tr:eq(4)").hide();
				$(this).parents("table").find("tr:eq(5)").hide();
				$(this).parents("table").find("tr:eq(6)").hide();
				$(this).text("点击展开");
				$(this).parents("td").removeClass("close").addClass("open");
			}else{
				$(this).parents("table").find("tr:eq(4)").show();
				$(this).parents("table").find("tr:eq(5)").show();
				$(this).parents("table").find("tr:eq(6)").show();
				$(this).text("点击收缩");
				$(this).parents("td").removeClass("open").addClass("close");
			}
			e.stopPropagation();
		});
	}
	
    
	/**
	 * 销毁
	 */
	function destroy(){
		timeLimit = 0;
		$(_pageId + " .no_data").hide();
		$(_pageId+".search_list").html("");
		$(_pageId + ".top_title .top_nav").hide();
		$(_pageId + " .green_tips").show();
		jump_flag = null; 
		$(_pageId + " .top_title small").text("当日");	
		/*$(_pageId + " .top_title small").text("一周内");	
		if(vIscroll._init){
			vIscroll.scroll.refresh();
		}*/
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageBack();
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});