/**
 * 信用交易-查询主界面
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var	layerUtils = require("layerUtils");
	var external = require("external");
    var _pageId = "#credit_query_financingQuery ";
    var common = require("common");
    
    /**
     * 初始化
     */
	function init(){common.hideBottomBar();
		common.bindStockEvent(_pageId);  //绑定头部菜单事件
		$(_pageId+".main ").css("overflow-y","auto");
		$(_pageId).css("overflow-x","hidden");
        setTimeout(function(){
        	var height_meau = $(window).height() - $(_pageId+".header").height()  -3;
        	$(_pageId+".main ").height(height_meau); //查询目录添加高度
        },400);
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId+".top_title .icon_back"), function(e){
//			appUtils.pageInit("credit/query/financingQuery","credit/index",{});
			appUtils.pageBack();
			e.stopPropagation();
		});
		//信用资产查询   (跳转到其他模块要通过原生柜台)
		appUtils.bindEvent($(_pageId+"#xyzc"),function(e){
			var param = {
					"funcNo":"50101",
					"moduleName":"ygt",
					"params" :{
						"topage" : "credit/creditAsset.html",//跳转url
						"toMark" : "tradeFinancingQuery",     //跳转标记
						"login_type" : "rzrqIdentify"
					}
				};
			external.callMessage(param);
			e.stopPropagation();
		});
		//授信额度查询
		appUtils.bindEvent($(_pageId+"#sxed"),function(e){
			appUtils.pageInit("credit/query/financingQuery","credit/query/creditLine",{});
			e.stopPropagation();
		});
		//资产负债汇总查询
		appUtils.bindEvent($(_pageId+"#fzhz"),function(e){
			appUtils.pageInit("credit/query/financingQuery","credit/query/creditAssetsQuery",{});
			e.stopPropagation();
		});
		//未了结合约查询
		appUtils.bindEvent($(_pageId+"#wljhy"),function(e){
			appUtils.pageInit("credit/query/financingQuery","credit/query/contractInquiryQuery",{});
			e.stopPropagation();
		});
		//已了结合约查询
		appUtils.bindEvent($(_pageId+"#yljhy"),function(e){
			appUtils.pageInit("credit/query/financingQuery","credit/query/contractOverQuery",{});
			e.stopPropagation();
		});

		//资金流水查询
		appUtils.bindEvent($(_pageId+"#zjls"),function(e){
			appUtils.pageInit("credit/query/financingQuery","credit/query/liabilitiesFlowQuery",{});
			e.stopPropagation();
		});
		
		//标的证券查询
		appUtils.bindEvent($(_pageId+"#bdzq"),function(e){
			appUtils.pageInit("credit/query/financingQuery","credit/query/queryCanRZBuyStock",{});
			e.stopPropagation();
		});
		
		//担保证券查询
		appUtils.bindEvent($(_pageId+"#dbzq"),function(e){
			appUtils.pageInit("credit/query/financingQuery","credit/query/collateralQuery",{});
			e.stopPropagation();
		});
		//交割单查询
		appUtils.bindEvent($(_pageId+"#jgd"),function(e){
			appUtils.pageInit("credit/query/financingQuery","credit/query/deliveryOrderQuery",{"param": "credit_financy_query"});
			e.stopPropagation();
		});
		
		//委托查询
		appUtils.bindEvent($(_pageId+"#wtcx"),function(e){
			appUtils.pageInit("credit/query/financingQuery","credit/query/orderQuery",{});
			e.stopPropagation();
		});
		
		//成交查询
		appUtils.bindEvent($(_pageId+"#cjcx"),function(e){
			appUtils.pageInit("credit/query/financingQuery","credit/query/dealQuery",{});
			e.stopPropagation();
		});
		
		//合约展期查询
		appUtils.bindEvent($(_pageId + "#hyzqcx"), function(e){
			layerUtils.iAlert("敬请期待..");
//			appUtils.pageInit("credit/query/financingQuery", "credit/query/queryRenewal", {"fromPage":"credit/query/financingQuery"});
			e.stopPropagation();
		});
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		//$(" #inputPopLayer").remove();
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	/*function pageBack(){
		appUtils.pageBack();
	}*/
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		//"pageBack": pageBack
	};
	module.exports = base;
});