/**
 * 信用交易-资金股份流水查询
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var common = require("common");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var layerUtils = require("layerUtils");
	var VIscroll = require("vIscroll");
	var service_credit = require("service_credit");
    var vIscroll = {"scroll":null,"_init":false};		//上下滑动
    var _pageId = "#credit_query_liabilitiesFlowQuery ";
    var timeLimit = 0; //默认查询当天的数据
    var userInfo = null;
    
    /**
     * 初始化
     */
	function init(){common.hideBottomBar();
		userInfo = JSON.parse(appUtils.getSStorageInfo("credit_userInfo"));
		height_table=$(window).height()-$(_pageId+"header").height()-12;
		timeLimit = 0;
		$(_pageId+".main").height(height_table).css("overflow","auto");
		$(_pageId).css("overflow-x","hidden");
		$(_pageId + ".top_title small").text("当天流水");
		liabilitiesFlowQuery(timeLimit);
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			appUtils.pageBack();
			e.stopPropagation();
		});
		//时间按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_nav"), function(e){
			$(_pageId + ".top_title .top_nav").slideToggle("fast");
		});
		//时间选择
		appUtils.bindEvent($(_pageId + ".top_title .top_nav ul li a"), function(e){
			timeLimit = $(this).attr("value");
			var timeText = $(this).text();
			$(_pageId + ".top_title .top_nav").hide();
			$(_pageId + ".top_title small").text(timeText);
			liabilitiesFlowQuery(timeLimit);
		});
		//点击其他位置，隐藏下拉框
		appUtils.bindEvent($(_pageId + ".main"),function(){
			if($(_pageId + ".top_title .top_nav").is(':visible')){
				$(_pageId + ".top_title .top_nav").slideToggle("fast");
			}
		});
		//关闭提示框事件
		appUtils.bindEvent($(_pageId + ".main .green_tips em"),function(){
			$(_pageId + ".main .green_tips").hide();
		});
	}
	
	/**
	 * 负债变动流水查询
	 */
	function liabilitiesFlowQuery(timeLimit){
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;
		var password = userInfo.password;
		var sessionid = userInfo.session_id;
		var end_time = new Date();  
		var begin_time  = new Date();	//截止时间
		begin_time.setDate(begin_time.getDate() - timeLimit);
		begin_time=begin_time.format("yyyy-MM-dd");
		end_time.setDate(end_time.getDate());
		end_time=end_time.format("yyyy-MM-dd");
		var param = {			
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"sessionid":sessionid,
				"begin_time" : begin_time,
				"end_time" : end_time
		};
		$(_pageId+ ".no_data").hide();
		service_credit.statementAccount_Query(param,liabilitiesFlowQueryCallback,
			{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){
				$(_pageId+ ".no_data").show();
			}
		});
	}
	/**
	 * 负债变动流水查询回调
	 */
	function liabilitiesFlowQueryCallback(data){
		if (typeof(data) != "undefined" && data) {
			$(_pageId+".agreement_box").html("");
			if(data.error_no == 0){
				$(_pageId+".no_data").hide();
				var results = data.results;
				if(results.length>0 && results){
					var data = "";
					var index = results.length-1;
					for (var i=index;i>=0;i--){
						data += queryFlowHTML(results[i]);
					}
					$(_pageId+".agreement_box").html(data);		
				}else{
					$(_pageId+".no_data").show();
				}
			}
			else{
				layerUtils.iAlert(data.error_info);
			}
		}
		else{
			  layerUtils.iAlert("查询失败");
		}
	}
	
	/**
	 * 委托查询HTML生成
	 */
	function queryFlowHTML(element){
		
        var eleHtml = "";
        eleHtml+="<table width='100%' border='0' cellspacing='0' cellpadding='0' class='mt10'>";
        eleHtml+="<tr><th width='50%'><h5 class='blue'>"+element.entrust_type_name+"</h5></th>";
        eleHtml+="<th width='50%'><span class='time'>发生日期:"+element.init_date.substring(0,10)+"</span></th></tr>";
        eleHtml+="<tr style='font-size:0.12rem'><td><span class='name'>发生金额:</span><span class='cont'>"+element.occur_balance+"</span></td>";
        eleHtml+="<td><span class='name'>资金余额:</span><span class='cont'>"+element.balance+"</span></td></tr></table>";
        return eleHtml;
	}
	
    
	/**
	 * 销毁
	 */
	function destroy(){		
		timeLimit = 0;
		$(_pageId+".agreement_box").html("");
		$(_pageId + ".top_title .top_nav").hide();
		$(_pageId + " .green_tips").show();
		$(_pageId + " .top_title small").text("当日流水");	
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageBack();
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});