/**
 * 普通交易-历史查询
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var common = require("common");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var layerUtils = require("layerUtils");
	var service_credit = require("service_credit");
    var _pageId = "#credit_query_orderQuery ";
    var timeLimit = 0; //默认查询当日委托数据
    var userInfo = null;
    
    /**
     * 初始化
     */
	function init(){
		common.hideBottomBar();
		$(_pageId+".no_data").hide();
		userInfo = JSON.parse(appUtils.getSStorageInfo("credit_userInfo"));
		queryEntrust(timeLimit);
		setTimeout(function(){
			var height_table = $(window).height()-$(_pageId+".header").height()-3;
			$(_pageId+".main ").height(height_table).css("overflow","auto");
		},400);
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){			
		//返回按钮
		appUtils.bindEvent($(_pageId+".top_title .icon_back"), function(e){
			appUtils.pageBack();
			e.stopPropagation();
		});
		
		//时间按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_nav"), function(e){
			$(_pageId + ".top_title .top_nav").slideToggle("fast");
		});
		
		//时间选择
		appUtils.bindEvent($(_pageId + ".top_title .top_nav ul li a"), function(e){
			timeLimit = $(this).attr("value");
			var timeText = $(this).text();
			$(_pageId + ".top_title .top_nav").hide();
			$(_pageId + ".top_title small").text(timeText);
			queryEntrust(timeLimit);
		});
				
		//点击其他位置，隐藏下拉框
		appUtils.bindEvent($(_pageId + ".main"),function(){
			if($(_pageId + ".top_title .top_nav").is(':visible')){
				$(_pageId + ".top_title .top_nav").slideToggle("fast");
			}
		});	
		
		//关闭提示框事件
		appUtils.bindEvent($(_pageId + ".main .green_tips em"),function(){
			$(_pageId + ".main .green_tips").hide();
		});
	}
	
	/**
	 * 当日委托查询回调
	 */
	function queryEntrustTodayCallback(data){
		if (typeof(data) != "undefined" && data) {
			if(data.error_no == 0){
				$(_pageId+".no_data").hide();
				var results = data.results;
				var data1 = "";
				if(results.length > 0 && results!= "undefined"){
					for (var i=0;i<results.length;i++){
						data1 += queryEntrustHTML(results[i]);
					}
					$(_pageId+".mar_stock").html(data1);
					
					//为每条当日委托记录添加绑定事件
					appUtils.preBindEvent($(_pageId + ".mar_stock"),"div",function(e){
							//获取当前委托的状态(看能否能撤单)
							//var entrusState = $(this).find("span:eq(0)").text();
							var entrust_state_name = $(this).find("span:eq(0)").text();
							var cancel_flag = $(this).find("span:eq(2)").text();	
							var is_withdraw = $(this).find("span:eq(4)").text();
							var is_withdrawn = $(this).find("span:eq(5)").text();
							//cancel_flag为0表示能撤单，1表示不能撤单，跟柜台CAN_WITHDRAW的值正好相反
							//is_withdraw为0表示未申报撤单，为1表示已申报撤单，前端控制不许重复申报
							//is_withdrawn为0表示未撤单，为1表示已撤单，前端控制不许重复申报
							if(cancel_flag == 1||is_withdraw == 1||is_withdrawn == 1){
								//layerUtils.iAlert("该委托不接受撤单！");
							}else if(cancel_flag == 0&&is_withdraw == 0&&is_withdrawn == 0){
								//获取委托编号
								var entrust_no = $(this).find("dl:eq(0) dd:eq(0) p:eq(2)").text();
								var nolen = entrust_no.length;	
								entrust_no = entrust_no.substring(4, nolen);
								var entrust_type = $(this).find("strong").text();
								var stock_name = $(this).find("dl:eq(0) dt:eq(0) h3:eq(0)").text();
								var stock_code = $(this).find("dl:eq(0) dt:eq(0) span:eq(0)").text();
								var entrust_price = $(this).find("dl:eq(0) dd:eq(0) p:eq(0)").text();
								var pricelen = entrust_price.length;	
								entrust_price = entrust_price.substring(4, pricelen);
								var entrust_amount = $(this).find("dl:eq(0) dd:eq(1) p:eq(0)").text();
								var amountlen = entrust_amount.length;
								entrust_amount = entrust_amount.substring(4, amountlen);
								var exchange_type = $(this).find("span:eq(3)").text();
								
								var tipStr ="<div class=\"pop_header\">";
								tipStr+="<h3>确认撤单<a href='javascript:void(0);' class='close'></a></h3>";
								tipStr+="</div>";
								tipStr+="<div class=\"pop_main\">";
								tipStr+="<p>您是否确认撤销本笔委托？</p>";
								tipStr+="<ul>";
								tipStr+="    <li>"+stock_name+": "+stock_code+"</li>";
								tipStr+="    <li>委托类型: "+entrust_type+"</li>";
								tipStr+="    <li>委托价格: "+entrust_price+"</li>";
								tipStr+="    <li>委托数量: "+entrust_amount+"</li>";
								tipStr+="    <li>合同编号: "+entrust_no+"</li>";
								tipStr+="</ul>";
								tipStr+="  </div>";
								//撤单确认,试用公共代码								
								common.btnConfirmCrit(tipStr,function success(){
									var entrust_way = global.entrust_way; // 委托方式  在configuration配置
									var branch_no = userInfo.branch_no;	
									var fund_account = userInfo.fund_account;//货币 ""所有货币，0 人民币，1 港币，2 美元
									var cust_code = userInfo.cust_code;//关联资产账户标志
									var sessionid=userInfo.session_id;
									var password= userInfo.password;
									var param={				
											"entrust_way":entrust_way,
											"branch_no":branch_no,
											"fund_account":fund_account,
											"cust_code":cust_code,
											"password":password,
											"sessionid":sessionid,
											"entrust_no":entrust_no,
											"exchange_type":exchange_type
									};
									service_credit.credit_cancel(param, cancelEntrustCallback);
									
								},function fail(){
								});
							}else{
								//To do nothing
							}
						//e.stopPropagation();
					},"click");
				}else{
					$(_pageId+".no_data").show();
					$(_pageId+"#mainShow").hide();
					//$(_pageId+"#mainShow").html(data1);
				}
			}else{
				layerUtils.iAlert(data.error_info);
			}
		}else{
			  layerUtils.iAlert("查询失败");
		}
	}	

	/**
	 * 委托撤单回调方法
	 * @param {Object} data 返回数据
	 */
	function cancelEntrustCallback(data){
		if(data){
			var errorNo = data.error_no;
			if (errorNo == 0) {
				layerUtils.iAlert("撤单成功",0);
				var timeLimit = 0;
				setTimeout(queryEntrust(timeLimit), 5000);
				//queryEntrust(timeLimit);
			}else{
				layerUtils.iAlert(data.error_info);
			}
			//queryCancelData();
		}
	}
	
	/**
	 * 当日、历史委托查询
	 */
	function queryEntrust(timeLimit){
		var entrust_way=global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;
		var sessionid=userInfo.session_id;
		var password = userInfo.password;
		if(timeLimit == 0){
			var param={				
					"entrust_way":entrust_way,
				    "branch_no":branch_no,
				    "fund_account":fund_account,
				    "cust_code":cust_code,
				    "password":password,
				    "sessionid":sessionid
				};
				//$(_pageId+ ".no_data").hide();
				service_credit.todaywt_query(param,queryEntrustTodayCallback,
					{
					"isLastReq":true,
					"isShowWait":true,
					"isShowOverLay":false,
					"timeOutFunc":function(){
					$(_pageId+ ".no_data").show();
					$(_pageId+"#mainShow").hide();
					}
				});				
		}else if(timeLimit == 7||timeLimit == 30||timeLimit == 90){
			var end_time = new Date();  
			var begin_time  = new Date();	//截止时间
			begin_time.setDate(begin_time.getDate() - timeLimit);
			begin_time=begin_time.format("yyyy-MM-dd");
			end_time.setDate(end_time.getDate());
			end_time=end_time.format("yyyy-MM-dd");
			var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "cust_code":cust_code,
			    "password":password,
			    "sessionid":sessionid,
			    "begin_time":begin_time,
			    "end_time":end_time
			};
			//$(_pageId+ ".no_data").hide();
			service_credit.historywt_query(param,queryEntrustCallback,
				{
				"isLastReq":true,
				"isShowWait":true,
				"isShowOverLay":false,
				"timeOutFunc":function(){
				$(_pageId+ ".no_data").show();
				$(_pageId+"#mainShow").hide();
				}
			});
		}else{
			//Todo nothing
		}
	}
	/**
	 * 历史委托查询回调
	 */
	function queryEntrustCallback(data){
		if (typeof(data) != "undefined" && data) {
			//$(_pageId+".search_list").html("");
			if(data.error_no == 0){
				$(_pageId+".no_data").hide();
				var results = data.results;
				if(results.length>0 && results!= "undefined"){
					var data = "";
					for (var i=0;i<results.length;i++){
						data += queryEntrustHTML(results[i]);
					}
					$(_pageId+".mar_stock").html(data);
				}else{
					$(_pageId+".no_data").show();
					$(_pageId+".mar_stock").hide();
				}
			}else{
				layerUtils.iAlert(data.error_info);
			}
		}else{
			  layerUtils.iAlert("查询失败");
		}
	}

	/**
	 * 委托查询HTML生成
	 */
	function queryEntrustHTML(element){
		var price_digit = 2;
		var css = "";
		var statuscss = "";
		var entrust_type_name = element.entrust_type_name || element.entrust_name;
		if(entrust_type_name == "融资买入"||entrust_type_name == "担保品买入"||entrust_type_name == "担保品提交"||entrust_type_name == "新股配售" ){
			css = "bg_red";
		}else if(entrust_type_name == "融券卖出"||entrust_type_name == "担保品卖出"||entrust_type_name == "担保品返回"){
			css = "bg_green";
		}else if(entrust_type_name == "卖券还款"||entrust_type_name == "直接还券"||entrust_type_name == "买券还券"||entrust_type_name == "现金还款"){
			css = "bg_blue";
		}else{
			css = "";
		}
		if(entrust_type_name == "直接还券"){
			entrust_type_name = "现券还券";
		}
		var entrust_state_name = element.entrust_state_name;
		if(entrust_state_name == "已报"||entrust_state_name == "已撤"||entrust_state_name == "部撤"||entrust_state_name == "已申报撤单"||entrust_state_name == "部成部撤"){
			statuscss = "no_deal";
		}else if(entrust_state_name == "已成"){
			statuscss = "have_deal";
		}else if(entrust_state_name == "部成"){
			statuscss = "section_deal";
		}else{
			statuscss = "";
		}
		var entrust_time = element.entrust_date+" "+element.entrust_time;
        var eleHtml = "";
        
        eleHtml+="<div class='part part02'><span class='stat1 "+statuscss+"'>"+element.entrust_state_name+"</span>"
        +"<h5 style='white-space: nowrap;'><strong class='"+css+"'>"+entrust_type_name+"</strong><small>委托时间:"+entrust_time+"</small></h5>"
        +"<dl class='clearfix'>"
        +"<dt class='p10'><h3>"+element.stock_name+"</h3><p><span>"+element.stock_code+"</span></p></dt>"
        +"<dd><p><em>委托价:</em>"+Number(element.entrust_price).toFixed(3)+"</p><p><em>成交价:</em>"+Number(element.business_price).toFixed(3)+"</p><p><em>合同号:</em>"+element.entrust_no+"</p></dd><span style='display:none;'>"+element.cancel_flag+"</span><span style='display:none;'>"+element.exchange_type+"</span><span style='display:none;'>"+element.is_withdraw+"</span>"+"</span><span style='display:none;'>"+element.is_withdrawn+"</span>"
        +"<dd><p><em>委托数:</em>"+element.entrust_amount+"</p><p><em>成交数:</em>"+element.business_amount+"</p></dd>"
        +"</dl></div>";
        console.log(eleHtml);
        console.log(element.entrust_name);
        return eleHtml;
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		timeLimit = 0;
		$(_pageId + " .no_data").hide();
		$(_pageId + " .mar_stock").html("");
		$(_pageId + ".top_title .top_nav").hide();
		$(_pageId + " .green_tips").show();
		$(_pageId + " .top_title small").text("当日委托");	
	}	
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageBack();
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});