/**
 * 信用交易-标的证券查询
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var service_credit = require("service_credit");
	var common = require("common");
	var layerUtils = require("layerUtils");
	var external = require("external");
	var	financialSecurities = false;
	var VIscroll = require("vIscroll");
    var vIscroll = {"scroll":null,"_init":false};		//上下滑动
    var _pageId = "#credit_query_queryCanRZBuyStock ";
    var userInfo = null;
    //var queryType = null;
	var service_hq = require("service_hq");
	var changeToPinyin = require("changeToPinyin");
	//var stockNameArr = [];//保存股票英文简写名称
	//var stockCodeArr = [];//保存股票股票代码
	var queryMsg = null;//查询后返回的结果集
	var isStockInput = false;//输入后状态
	var type = 0;//0-融资标的  1-融券标的
	var poststr = 0;//页数定位 默认显示第一页
	var num = 0;
    	
    /**
     * 初始化
     */
	function init(){
		common.hideBottomBar();
		common.systemKeybord(); // 解禁系统键盘
		userInfo = JSON.parse(appUtils.getSStorageInfo("credit_userInfo"));
		//$(_pageId+".main .visc_pullUp").hide();
		//var height_table = $(window).height()-$(_pageId+".header").height()-$(_pageId+".tab_nav").height()-$(_pageId+".search_box").height()-$(_pageId+"#firstTable").height()-12;
		//$(_pageId+"#showContent ").height(height_table).css("overflow","auto");
		$(_pageId).css("overflow-x","hidden");

//added by huangjianfeng
		type = appUtils.getPageParam("type");
        if(type == 1)
        {
			$(_pageId + " #remove").remove();
			$(_pageId + " #numRemove").remove();
			$(_pageId + " #stockCode").val("");
			$(_pageId + " #stockName").text("证券名称");
            $(_pageId + " #RQ").addClass("active");
            $(_pageId + " #RZ").removeClass("active");
			$(_pageId+" #changeName").text("保证金比例");
        }else{
        	type = 0;
        }
		queryData();//查询数据
    }
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId+".top_title .icon_back"), function(e){
			appUtils.pageBack();
			e.stopPropagation();
		});
		
		//点击查询按钮
		appUtils.bindEvent($(_pageId+" #search"),function(){
			$(_pageId + " #container").html("");
			$(_pageId+"#stock_list").html("");
			$(_pageId + ".visc_pullUp").css("display","none");
			var stockCode = $(_pageId+" #stockCode").val();
			if(stockCode){
				queryData(stockCode);
			}else{
				layerUtils.iAlert("请输入股票代码！");
			}
		});
		//融资，融券切换
		appUtils.bindEvent($(_pageId+" .tab_nav li"),function(e){
			$(_pageId+" #container").html("");
			$(_pageId + " #stockCode").val("");
			$(_pageId + " #stockName").text("证券名称");
			$(_pageId + ".visc_pullUp").css("display","none");
			$(this).addClass("active").siblings().removeClass("active");
			financialSecurities = ($(_pageId+" .tab_nav li").index($(this)) == 1);
			if(financialSecurities){
				vIscroll.scroll.refresh();
				type = 1;
				poststr = 0;
				$(_pageId+" #changeName").text("保证金比例");
			}else
			{
				type = 0;
				poststr = 0;
				vIscroll.scroll.refresh();
				$(_pageId + " #numRemove").remove();
				$(_pageId+" #changeName").text("保证金比例");
			}
			queryData();
		});
		
		//股票代码输入框监听
		appUtils.bindEvent($(_pageId+"#stockCode"), function(e){
			$(_pageId+ ".no_data").hide();//隐藏暂无数据
			var stockCode = $(this).val();
			var vail=/^[A-Za-z]+$/;
			if(stockCode.length>1 && vail.test(stockCode)){
				isStockInput = true;
				getStockList(stockCode);
				if(stockCode.length<2){
					$(_pageId+"#stock_list").html("");
				}
			}else if(stockCode.length>3){
				isStockInput = true;
				getStockList(stockCode);
				if(stockCode.length<4){
					$(_pageId+"#stock_list").html("");
				}
			}else{
				if(isStockInput){
					isStockInput = false;
					$(_pageId+" #container").html("");
					queryData();//查询数据
					$(_pageId + " #stockName").text("证券名称");
				}
				$(_pageId+"#stock_list").html("");
			}
			e.stopPropagation();
		},"input");
		//股票代码输入框调用原生键盘
		appUtils.bindEvent($(_pageId+".trade_form .input_code"), function(e){
			$(_pageId+"#stockCode").focus();
			window.keyBoardInputFunction = function(){ //原生回调
					var stockCode = $(_pageId+"#stockCode").val();
					$(_pageId+"#stock_list").html("");
					var vail=/^[A-Za-z]+$/;
				if(stockCode.length>1 && vail.test(stockCode)){
					isStockInput = true;
					getStockList(stockCode);
					if(stockCode.length<2){
						$(_pageId+"#stock_list").html("");
					}
				}else if(stockCode.length>3){
					isStockInput = true;
					getStockList(stockCode);
					if(stockCode.length<4){
						$(_pageId+"#stock_list").html("");
					}
				}else{
					if(isStockInput){
						isStockInput = false;
						$(_pageId+" #container").html("");
						queryData();//查询数据
					}
					$(_pageId+"#stock_list").html("");
				}
			};
//			external.callMessage({"moduleName":"trade","funcNo": "50210", "pageId":"credit_query_queryCanRZBuyStock", "eleId":"stockCode", "doneLable":"done", "keyboardType":"2"});
			e.stopPropagation();
		},"click");
		//失去焦点关闭原生键盘
		appUtils.bindEvent($(_pageId+"#stockCode"),function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50211"});
			e.stopPropagation();
		},"blur");
		
	}
	
	
	/**
	 * 获取股票列表
	 * */
	function getStockList(stockStr){
		if(stockStr != ""){
			var stockStrParam = {
				"q" : stockStr
			};
			service_hq.getStockList(stockStrParam,function(data){
				if(data.errorNo == 0){
					$(_pageId+"#stock_list").html("");
					var results = data.results;
					//显示股票列表
					if(results && results.length > 0){
						if(results.length >= 6){
							var selectHeight = 6 * 0.44;
						}else{
							selectHeight = 0.44*results.length;
						}
						var listHtml = "<ul style=\"display:block;overflow-y:auto;height:"+selectHeight+"rem\">";
						for(var i = 0;i < results.length; i++) {
							listHtml += "<li exchangeType="+results[i][9]+" data-stockName="+results[i][0]+"><a href=\"javascript:void(0);\" style=\"padding-left:0.20rem;\"><strong class=\"stockcode\" style=\"font-size:0.18rem\">"+results[i][1]+"</strong><span class=\"stockname\">"+results[i][0]+"</span></a>";
							listHtml +=	"<span style=\"display:none;\">"+results[i][9]+"</span></li>";
						};
						listHtml+="</ul>";
						$(_pageId+"#stock_list").append(listHtml);
						appUtils.bindEvent($(_pageId+".trade_form .select_box ul li"),function(){
							var stockCode = $(this).find("strong.stockcode").text();
							var stockName =$(this).find("span.stockname").text();
							var exchangeType = $(this).attr("exchangeType");
							$(_pageId + " #stockCode").val(stockCode);
							$(_pageId + " #stockName").text(stockName);
							$(_pageId+"#stock_list").html("");
							//searchMsgByStockCode(stockCode)
							//queryData(stockCode);
						});
						//点击其他位置隐藏股票列表
						appUtils.bindEvent($(_pageId + " .table_box"), function(e){
							$(_pageId+" #stock_list").html("");//清空股票搜索框
						},"click");
					}else{
						layerUtils.iAlert("该股票列表不存在");
						$(_pageId + " #remove").remove();
						$(_pageId + " #stockCode").val("");
						$(_pageId + " #stockName").text("证券名称");
					}
				}else{
					layerUtils.iAlert("获取股票列表失败");
					$(_pageId + " #remove").remove();
					$(_pageId + " #stockCode").val("");
					$(_pageId + " #stockName").text("证券名称");
				}
			},{"isShowWait":false});
		}	
	}
	
	
    
	
	
	/**
	 * 查询数据
	 */
	function queryData(stockCode)
	{
		//stockCodeArr.length = 0;//保存股票英文简写名称
		queryMsg = null;//查询后返回的结果集
		$(_pageId+ ".no_data").hide();
		//$(_pageId+ "#container").html("");
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	//分支机构
		var fund_account = userInfo.fund_account;	//资产账户
		var cust_code = userInfo.cust_code;	//客户代码
		var sessionid = userInfo.session_id;
		var password = userInfo.password;
		var stock_code = stockCode ? stockCode : "";
		var exchange_type = "";
		var param = {			
			"entrust_way":entrust_way,
			"branch_no":branch_no,
			"fund_account":fund_account,
			"cust_code":cust_code,
			"password":password,
			"sessionid":sessionid,
			"stock_code":stock_code,
			"exchange_type":exchange_type,
			"type":type,
			"poststr":poststr,
			//"pageNum":500
		};
		service_credit.qualificationInquiry(param,function queryCallBack(data)
		{
			if (data) {
				if(data.error_no == 0)
				{
					var results = data.results;	
					queryMsg = data.results;//将返回的结果集保存
					if(results && results.length > 0)
					{
						var dataHtml = "";
						for(i = 0;i < results.length; i++)
						{
							var data = results[i];
							dataHtml += createHtml(data);
						}
						$(_pageId + ".visc_pullUp").css("display","block");
						if(stockCode){
							num = 1;
							$(_pageId+" #container").html(dataHtml);
						}else{
							num = 20;
							$(_pageId+" #container").append(dataHtml);
						}
					}
					else{
						$(_pageId+ " .visc_pullUp").hide();
						$(_pageId+ ".no_data").show();
						num=1;
					}
					if(!vIscroll._init){
						initVIScroll(results.length);
					}else{
						vIscroll.scroll.refresh();
						initVIScroll(num);
					}
				}
				else
				{
					$(_pageId+" #container").html("");
					layerUtils.iAlert(data.error_info);
				}
			}
		},{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function()
			{
				$(_pageId+ ".no_data").show();
				initVIScroll();
				if(vIscroll._init){
					vIscroll.scroll.refresh();
				}
			}
		});
	}
	/**
	 * 生成html
	 * @param {Object} element 数据项
	 */
	function createHtml(element)
	{
		//stockCodeArr.push(element.stock_code);//将股票名称放入集合中
		var eleHtml = "";
		    eleHtml += "<tr id='"+element.stock_code+"'>";
			eleHtml += "<td style='border-left:0px;border-right:0px'>"+element.stock_code+"</td>";
			eleHtml += "<td style='border-left:0px;border-right:0px'>"+element.stock_name+"</td>";
			eleHtml += "<td style='border-left:0px;border-right:0px'>"+element.exchange_type_name+"</td>";
			eleHtml += "<td style='border-left:0px;border-right:0px'>"+element.bail_ratio+"</td>";
			eleHtml +="</tr>";
		return eleHtml;
	}
	
	/**
	 * 初始化滑动组件
	 */
	function initVIScroll(num){
		if(!vIscroll._init){
			var config = {
					"isPagingType": false,//false表示是微博那种累加形式，true表示分页形式
					"visibleHeight": $(window).height()-$(_pageId+".header").height()-$(_pageId+".tab_nav").height()-$(_pageId+".search_box").height()-$(_pageId+"#firstTable").height() - 16  ,//显示内容区域的高度，当isPaingType为false时传
					"container": $(_pageId+"#v_container_funds_jj"),	
					"wrapper":$(_pageId+"#v_wrapper_funds_jj"),	
					/*"downHandle": function() {
						 //queryMsg();//下拉获取上一页数据方法
					},*/
					"upHandle": function() {
						$(_pageId + ".visc_pullUp").css("display","block");
						poststr = poststr+1;
						queryData();//上拉获取下一页数据方法
					},
					"wrapperObj": null
			};
			vIscroll.scroll = new VIscroll(config); 	//初始化，需要做if(!hIscroll._init)判断
			vIscroll._init = true;
			if(num < 20 ){
				$(_pageId + ".visc_pullUp").css("display","none");
			}else{
				$(_pageId + ".visc_pullUp").css("display","block");
			}
		} else {
			vIscroll.scroll.refresh();
			if(num < 20 ){
				$(_pageId + ".visc_pullUp").css("display","none");
			}else{
				$(_pageId + ".visc_pullUp").css("display","block");
			}
		}
		$(_pageId+".visc_pullDown").hide();
	}
	
	
	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId+ ".no_data").hide();
		if(vIscroll._init){
			vIscroll.scroll.refresh();
		}
		poststr = 0;
		$(_pageId+" #stock_list").html("");//清空股票搜索框
		$(_pageId + " #stockCode").val("");
		$(_pageId + " #stockName").text("证券名称");
		financialSecurities = false;
		$(_pageId + " #numRemove").remove();
		$(_pageId + ".visc_pullUp").css("display","none");
		$(_pageId + " #remove").remove();
		$(_pageId+" #container").html("");
		$(_pageId+" .tab_nav li:eq(0)").addClass("active").siblings().removeClass("active");
		$(_pageId+" #changeName").text("保证金比例");
		//stockCodeArr.length = 0;//保存股票英文简写名称
		queryMsg = null;//查询后返回的结果集
	    isStockInput = false;//输入后状态
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageBack();
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});