/**
 *  信用交易-合约展期
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var common = require("common");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var layerUtils = require("layerUtils");
	var service_credit = require("service_credit");
    var _pageId = "#credit_query_queryRenewal ";
    var fromPage = "",timeLimit = "0";
    
    /**
     * 初始化
     */
	function init(){
		common.hideBottomBar();
		common.systemKeybord(); // 解禁系统键盘
        var height_table = $(window).height() - $(_pageId+".header").height() - $(_pageId+".green_tips").height();
        $(_pageId+".main").height(height_table).css("overflow", "auto");   //给持仓数据添加高度
		userInfo = JSON.parse(appUtils.getSStorageInfo("credit_userInfo"));
		if (!userInfo){
			appUtils.pageInit("credit/query/queryRenewal", "account/login", {});
		}
		fromPage = appUtils.getPageParam("fromPage"); //判断从那个页面跳转过来
		//查询合约
		queryAgreement(timeLimit);
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){		
//		//返回按钮
//		appUtils.bindEvent($(_pageId+".top_title .icon_back"), function(e){
//			if(fromPage == null || fromPage == ""){
//				appUtils.pageInit("credit/query/queryRenewal","credit/query/financingQuery");
//			}else{
//				appUtils.pageInit("credit/query/queryRenewal",fromPage,{});
//			}
//		});
		//返回按钮
		appUtils.bindEvent($(_pageId+".top_title .icon_back"), function(e){
			appUtils.pageBack();
			e.stopPropagation();
		});
		
		//提交申请
		appUtils.bindEvent($(_pageId+".ce_btn>a"), function(e){
			var compact_id = $(_pageId + " #compact_id");
			if ((!compact_id) && (compact_id === "--")){
				layerUtils.iAlert("未选择申请合约");
			} else {
				//申请提交确认
				applySure();
			}
//			appUtils.pageInit("credit/order/contractRenewal","credit/index",{});
			e.stopPropagation();
		});
		
		//查询合约展
		appUtils.bindEvent($(_pageId + " .search_text"), function(e){
			appUtils.pageInit("credit/order/contractRenewal", "credit/query/queryRenewal", {});
			e.stopPropagation();
		}, "click");
		
		//查询合约展
		appUtils.bindEvent($(_pageId + " .green_tips em"), function(e){
			$(_pageId + " .green_tips").hide();
			 var height_table = $(window).height() - $(_pageId+".header").height();
		        $(_pageId+".main").height(height_table).css("overflow", "auto");   //给持仓数据添加高度
			e.stopPropagation();
		}, "click");
		
		appUtils.bindEvent($(_pageId + " .icon_nav"), function(){
			$(_pageId + " .top_nav").slideToggle("fast");
		});
		
		appUtils.bindEvent($(_pageId + " .top_nav a"), function(e){
			var $this = $(this);
			timeLimit = $this.attr("data-value");
			$(_pageId + " .top_title small").html($this.html());
			queryAgreement(timeLimit);
			$(_pageId + " .top_nav").hide();
			e.stopPropagation();
		});
		
	}
	
	/**
	 * 查询
	 * 
	 */
	function queryAgreement(timeLimit){
		var branch_no  = userInfo.branch_no;	//分支机构
		var cust_code = userInfo.cust_code;	//客户代码
		var password = userInfo.password;
		var sessionid = userInfo.session_id;
		var fund_account = userInfo.fund_account;
		var begin_date  = new Date();
		var end_date = new Date();  //截止时间
		begin_date.setDate(begin_date.getDate() - timeLimit);
		begin_date=begin_date.format("yyyy-MM-dd");
		end_date.setDate(end_date.getDate());
		end_date=end_date.format("yyyy-MM-dd");
//		var exchange_type = userInfo.exchange_type;
		var param = {
				"entrust_way": global.entrust_way,
				"branch_no": branch_no,
				"fund_account":fund_account,
				"cust_code": cust_code,
				"password": password,
				"begin_date": begin_date,
				"end_date": end_date,
				"sessionid": sessionid
			};
		service_credit.queryRollover(param, function(data){
			var errorNo = data.error_no,
				errorInfo = data.error_info;
			if (errorNo === "0"){
				var results = data.results,
					re_length = results.length;
				if (re_length > 0){
					var tab_str = "";
					for (var i = 0; i < re_length; i++){
						var item = results[i],
							stock_name = item.stock_name,
							ret_end_date = item.ret_end_date,
							compact_type_name = item.compact_type === "0" ? "融资" : "融券";
						tab_str += "<tr>" +
								"<td>" + item.req_date + "<br>" + item.order_id + "</td><td>" + item.open_date + "<br>" + ret_end_date + "</td><td>" + stock_name + "<br>" + item.stock_code + "</td>" +
										"<td>" + item.extend_status_name + "<br>" + item.extend_status_name + "</td></tr>";
					}
					$(_pageId + " .ce_table tbody").html(tab_str);
				} else {
					$(_pageId + " .no_data").show();
				}
			}else{
				layerUtils.iAlert(errorInfo);
			}
		});
	}
	
	/**
	 * 计算时间
	 * @time 输入的时间间隔  t > 0 未来，t = 0 现在，t < 0 历史 (单位天数)
	 */
	function getBusTime(time){
		var t = time ? +time : 0,
			t_ms = t * 24 * 60 * 60 * 1000,
			d_time = +new Date(),
			result_time = d_time + t_ms,
			r_time = new Date(result_time),
			year = r_time.getFullYear(),
			month = r_time.getMonth() + 1,
			day = r_time.getDate();
		return year + "-" + month + "-" + day;
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageBack();
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		timeLimit = "0";
		$(_pageId + " .main").scrollTop(0);
		$(_pageId + " .ce_table tbody").html("");
		$(_pageId + " .green_tips").show();
		$(_pageId + " .no_data").hide();
		$(_pageId + " .top_title small").text("当日");	
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});