/**
 * 信用交易-风险通知
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var common = require("common");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var layerUtils = require("layerUtils");
	var VIscroll = require("vIscroll");
	var service_credit = require("service_credit");
    var vIscroll = {"scroll":null,"_init":false};		//上下滑动
    var _pageId = "#credit_query_riskNotification ";
    var external = require("external");
    var timeLimit = 7; //默认查询最近一周的数据
    var userInfo = null;
    var showFlag=false;
    var jump_flag = null; //判断从那个地方跳转过来的
    
    /**
     * 初始化
     */
	function init(){
		common.hideBottomBar();
		$(_pageId).css("overflow-x","hidden");
		//$(_pageId + ".top_title .top_nav02").hide();
		jump_flag = appUtils.getPageParam("param");
		userInfo = JSON.parse(appUtils.getSStorageInfo("credit_userInfo"));
		var height_table=$(window).height()-$(_pageId+".header").height()-12;
		$(_pageId+".main").height(height_table).css("overflow-y","auto");
		queryRiskInfo(timeLimit);
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			if(jump_flag && jump_flag == "credit_index_flag"){
				appUtils.pageBack();
			}else{
				var param = {
						"funcNo":"50101",
						"moduleName":"ygt",
						"params" :{
							"topage" : "credit/creditAccount.html",//跳转url
						}
				};
				external.callMessage(param);
				setTimeout(function(){
					appUtils.pageInit("credit/query/riskNotification","credit/index",{});
				},300);
			}
			e.stopPropagation();
		});
		//时间按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_nav"), function(e){
			$(_pageId + ".top_title .top_nav02").slideToggle("fast");
		});
		//时间选择
		appUtils.bindEvent($(_pageId + ".top_title .top_nav02 ul li a"), function(e){
			showFlag=true;
			timeLimit = $(this).attr("value");
			var timeText = $(this).text();
			$(_pageId + ".top_title .top_nav02").hide();
			$(_pageId + ".top_title small").text(timeText);
			queryRiskInfo(timeLimit);
		});
		//点击其他位置，隐藏下拉框
		appUtils.bindEvent($(_pageId + ".main"),function(){
			if($(_pageId + ".top_title .top_nav").is(':visible')){
				$(_pageId + ".top_title .top_nav").slideToggle("fast");
			}
		});
		//关闭提示框事件
		appUtils.bindEvent($(_pageId + ".main .green_tips em"),function(){
			$(_pageId + ".main .green_tips").hide();
		});
	}
	
	/**
	 * 风险信息查询
	 */
	function queryRiskInfo(timeLimit){
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var cust_code = userInfo.cust_code;
		var password = userInfo.password;
		var sessionid = userInfo.session_id;
		var fund_account = userInfo.fund_account;
		var end_time = new Date();  
		var begin_time  = new Date();	//截止时间
		begin_time.setDate(begin_time.getDate() - timeLimit);
		begin_time=begin_time.format("yyyy-MM-dd");
		end_time.setDate(end_time.getDate());
		end_time=end_time.format("yyyy-MM-dd");
		var param = {			
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"sessionid":sessionid,
				"begin_date" : begin_time,
				"end_date" : end_time
		};
		$(_pageId+ ".no_data").hide();
		service_credit.queryRiskInfo(param,queryRiskInfoCallBack,
			{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){
				$(_pageId+ ".no_data").show();
				/*initVIScroll();
				if(vIscroll._init){
					vIscroll.scroll.refresh();
				}*/
			}
		});
	}
	/**
	 * 风险信息回调函数
	 */
	function queryRiskInfoCallBack(data){
		if (typeof(data) != "undefined" && data) {
			$(_pageId+".risk_box").html("");
			if(data.error_no == 0){
//				$("#credit_index .caidan #riskFlag").css("display","none");
				$(_pageId+".no_data").hide();
				var results = data.results;
				if(results.length>0 && results){
					var data = "";
					var index=results.length-1;
					if(showFlag){
						for (var i=0;i<=index;i++){
							data += queryFlowHTML(results[i]);
						}
						var risk_time = results[0].occur_date;
						appUtils.setLStorageInfo("risk_time",risk_time);
					}else{
						data = "<p>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"+results[0].notice_comment+"<br/><span style='text-align:right;width:100%'>"+results[0].occur_date+"</span></p>"
						var risk_time = results[0].occur_date;
						appUtils.setLStorageInfo("risk_time",risk_time);
					}
					$(_pageId+".risk_box").append(data);		
				}else{
					$(_pageId+".no_data").show();
				}
				/*if(!vIscroll._init){
					initVIScroll(results.length);
				}else{
					$(_pageId+ " .visc_pullUp").css("display","none");
					vIscroll.scroll.refresh();
					vIscroll = {"_init":false};
					initVIScroll();
				}*/
			}
			else{
				layerUtils.iAlert(data.error_info);
			}
		}
		else{
			  layerUtils.iAlert("查询失败");
		}
	}
	
	/**
	 * 委托查询HTML生成
	 */
	function queryFlowHTML(element){
        var eleHtml = "";
        eleHtml+="<p>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"+element.notice_comment+"<br/><span style='text-align:right;width:100%;float:right;background-color: #ffffff'>"+element.occur_date+"</span></p><hr/>";
        return eleHtml;
	}
	
	/**
	 * 初始化滑动组件
	 */
	/*function initVIScroll(num){
		if(!vIscroll._init){
			var config = {
					"isPagingType": false,//false表示是微博那种累加形式，true表示分页形式
					"visibleHeight": $(window).height()-$(_pageId+".header").height()- 16  ,//显示内容区域的高度，当isPaingType为false时传
					"container": $(_pageId+"#v_container_funds_jj"),	
					"wrapper":$(_pageId+"#v_wrapper_funds_jj"),	
					"downHandle": function() {
						 //queryMsg();//下拉获取上一页数据方法
					},
					"upHandle": function() {
						$(_pageId+" .visc_pullUp").show(); 
						queryRiskInfo(40);//上拉获取下一页数据方法
					},
					"wrapperObj": null
			};
			vIscroll.scroll = new VIscroll(config); 	//初始化，需要做if(!hIscroll._init)判断
			vIscroll._init = true;
			if(num < 20 ){
				$(_pageId + ".visc_pullUp").css("display","none");
			}
		} else {
			vIscroll.scroll.refresh();
		}
		$(_pageId+" .visc_pullUp").css("display","none");
	}*/
	
    
	/**
	 * 销毁
	 */
	function destroy(){
		timeLimit = 7;
		showFlag=false;
		jump_flag = null;
		$(_pageId+".risk_box").html("");
		if(vIscroll._init){
			vIscroll.scroll.refresh();
		}
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageBack();
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});