/**
 * 信用交易-对账单查询
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var common = require("common");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var layerUtils = require("layerUtils");
	var VIscroll = require("vIscroll");
	var service_credit = require("service_credit");
    var vIscroll = {"scroll":null,"_init":false};		//上下滑动
    var _pageId = "#credit_query_statementQuery ";
    var timeLimit = 7; //默认查询最近一周的数据
    var userInfo =  null;
    	
    /**
     * 初始化
     */
	function init(){common.hideBottomBar();
		userInfo = JSON.parse(appUtils.getSStorageInfo("credit_userInfo"));
		statementQuery(timeLimit);
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			appUtils.pageBack();
			e.stopPropagation();
		});
		//时间按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_nav"), function(e){
			$(_pageId + ".top_title .top_nav").slideToggle("fast");
			e.stopPropagation();
		});
		//时间选择
		appUtils.bindEvent($(_pageId + ".top_title .top_nav ul li a"), function(e){
			timeLimit = $(this).attr("value");
			var timeText = $(this).text();
			$(_pageId + ".top_title .top_nav").hide();
			$(_pageId + ".top_title small").text(timeText);
			statementQuery(timeLimit);
		});
		//点击其他位置，隐藏下拉框
		appUtils.bindEvent($(_pageId + ".main"),function(){
			if($(_pageId + ".top_title .top_nav").is(':visible')){
				$(_pageId + ".top_title .top_nav").slideToggle("fast");
			}
		});
	}
	
	/**
	 * 对账单查询
	 */
	function statementQuery(timeLimit){
		$(_pageId+ ".no_data").hide();
		$(_pageId+".search_list").html("");
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;
		var sessionid=userInfo.session_id;
		var password = userInfo.password;
		var business_flag = "";
		var money_type = "";
		var end_time = new Date();  
		var begin_time  = new Date();	//截止时间
		begin_time.setDate(begin_time.getDate() - timeLimit);
		begin_time=begin_time.format("yyyy-MM-dd");
		end_time.setDate(end_time.getDate());
		end_time=end_time.format("yyyy-MM-dd");
		var param = {			
			"entrust_way":entrust_way,
			"branch_no":branch_no,
			"fund_account":fund_account,
			"cust_code":cust_code,
			"password":password,
			"sessionid":sessionid,
			"money_type":money_type,
			"begin_date" : begin_time,
			"end_date" : end_time,
			"business_flag" : business_flag
		};
		$(_pageId+ ".no_data").hide();
		service_credit.queryAccountFlow(param,queryStatementCallback,
			{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){
				$(_pageId+ ".no_data").show();
				initVIScroll();
				if(vIscroll._init){
					vIscroll.scroll.refresh();
				}
			}
		});
	}
	/**
	 * 对账单查询回调
	 */
	function queryStatementCallback(data){
		if (typeof(data) != "undefined" && data) {
			$(_pageId+".search_list").html("");
			if(data.error_no == 0){
				$(_pageId+".no_data").hide();
				var results = data.results;
				if(results.length>0 && results!= "undefined"){
					var data = "";
					for (var i=0;i<results.length;i++){
						data += queryEntrustHTML(results[i]);
					}
					$(_pageId+".search_list").html(data);
				}else{
					$(_pageId+".no_data").show();
				}
				if(!vIscroll._init){
					initVIScroll();
				}else{
					vIscroll.scroll.refresh();
				}
			}
			else{
				layerUtils.iAlert(data.error_info);
			}
		}
		else{
			  layerUtils.iAlert("查询失败");
		}
	}
	
	/**
	 * 委托查询HTML生成
	 */
	function queryEntrustHTML(element){
		var price_digit = 2;
//		require("common").decimalKeep(element.stock_code ,function(data){  //获取保留的位数
//	    	if(data){
//	    		price_digit = data;
//	    	}
//		});
		var css = "";
		var business_name = element.business_name;
		if(business_name == "委托买入"){
			css = "ared";
		}else if(business_name == "委托卖出"){
			css = "agreen";
		}
        var eleHtml = "";
        eleHtml+="<div class=\"part\">";
        eleHtml+="<span class=\"time\">"+element.business_date+"&nbsp</span>";
        eleHtml+="<h5 class=\""+css+"\">"+business_name+"</h5>";
        eleHtml+="<dl class=\"clearfix\">";
        eleHtml+="	<dt>"+element.stock_name+" <small>"+element.stock_code+"</small></dt>";
        eleHtml+="    <dd><em>流水编号</em>"+element.serial_no+"</dd>";
        eleHtml+="    <dd><em>发生金额</em>"+Number(element.occur_balance).toFixed(price_digit)+"</dd>";
        eleHtml+="    <dd><em>剩余金额</em>"+Number(element.enable_balance).toFixed(price_digit)+"</dd>";
        eleHtml+="    <dd><em>买卖标志</em>"+element.business_name+"</dd>";
        eleHtml+="    <dd><em>成交价格</em>"+Number(element.business_price).toFixed(price_digit)+"</dd>";
        eleHtml+="    <dd><em>成交数量</em>"+element.occur_amount+"</dd>";
        eleHtml+="    <dd><em>币种</em>"+element.money_type_name+"</dd>";
        eleHtml+="    <dd><em>股东代码</em>"+element.stock_account+"</dd>";
        eleHtml+="    <dd><em>备注</em>"+element.remark+"</dd>";
        eleHtml+="</dl>";
        eleHtml+="</div>";
        return eleHtml;
       
	}
	
	/**
	 * 初始化滑动组件
	 */
	function initVIScroll(){
		if(!vIscroll._init){
			var config = {
					"isPagingType": false,//false表示是微博那种累加形式，true表示分页形式
					"visibleHeight": $(window).height() - $(_pageId+".top_title").height()- $(_pageId+".tab_nav").height()- 6  ,//显示内容区域的高度，当isPaingType为false时传
					"container": $(_pageId+"#v_container_funds_jj"),	
					"wrapper":$(_pageId+"#v_wrapper_funds_jj"),	
					"downHandle": function() {
						statementQuery(timeLimit);//下拉获取上一页数据方法
					},
					"upHandle": function() {	
						//上拉获取下一页数据方法
					},
					"wrapperObj": null
			};
			vIscroll.scroll = new VIscroll(config); 	//初始化，需要做if(!hIscroll._init)判断
			vIscroll._init = true;
		} else {
			vIscroll.scroll.refresh();
		}
		$(_pageId+ " .visc_pullUp").hide();
	}
	
    
	/**
	 * 销毁
	 */
	function destroy(){
		
		timeLimit = 7;
		$(_pageId+".search_list").html("");
		$(_pageId + ".top_title .top_nav").hide();
		$(_pageId + " .top_title small").text("一周内");	
		if(vIscroll._init){
			vIscroll.scroll.refresh();
		}
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageBack();
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});