/**
 * 划转撤单
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
    var _pageId = "#credit_transferred_transferCancellation ";
    var	layerUtils = require("layerUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
    var VIscroll = require("vIscroll");
	var service_credit = require("service_credit");
    var vIscroll = {"scroll":null,"_init":false};		//上下滑动
    var service_common = require("service_common");
    var common = require("common");
    var creditUserInfo = null;
    var tradeUserInfo = null;
    var totalNo = ""; // 所有委托编号
    /**
     * 初始化
     */
	function init(){common.hideBottomBar();
		tradeUserInfo = JSON.parse(appUtils.getSStorageInfo("creStock_userInfo"));//获取登陆后保存的普通账户信息
		creditUserInfo = JSON.parse(appUtils.getSStorageInfo("credit_userInfo"));//获取登陆后保存的信用账户信息
		queryTransCanCancel();//查询撤单信息
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId+".top_title .icon_back"), function(e){
			appUtils.pageBack();
			e.stopPropagation();
		});
		//全部撤单
		appUtils.bindEvent($(_pageId+".noicon_text"), function(e){
			if(totalNo){
				var cancelParam = {
				"entrust_way":global.entrust_way, // 委托方式  在configuration配置
				"branch_no": creditUserInfo.branch_no, // 分支机构
				"fund_account": creditUserInfo.fund_account, // 资金账号
				"cust_code": creditUserInfo.cust_code, // 客户编号
				"password": creditUserInfo.password, // 交易密码
				"sessionid": creditUserInfo.session_id, // 会话号
				"entrust_no": totalNo, // 委托编号
				"batch_flag": "1", // 批量撤单标志（0:不是，1：是）
				"exchange_type": "" // 交易市场类别
			};
			
			common.btnConfirm("<div class=\"pop_main\" style=\"height: 50px;margin-top: 20px;font-size:0.15rem\"><div>是否全部撤单?</div></div>",function success(){
				service_credit.credit_cancel(cancelParam, CancelCallBack,{
				"isLastReq":true,
				"isShowWait":true,
				"isShowOverLay":false,
				"timeOutFunc":function(){
					$(_pageId+ ".no_data").show();
					initVIScroll();
						if(vIscroll._init){
							vIscroll.scroll.refresh();
						}
					}
				});
			},function fail(){//失败暂时不处理
				
			});
			
			}else{
				layerUtils.iAlert("无可撤单数据");
				return false;
			}
			
			e.stopPropagation();
		});
	}
    
	/**
	 * 查询撤单数据
	 */
	function  queryTransCanCancel(){
		$(_pageId + " #remove").remove();
		$(_pageId+ ".no_data").hide();
		totalNo = "";
		var queryParam = {
				entrust_way:global.entrust_way, // 委托方式  在configuration配置
				branch_no: creditUserInfo.branch_no, // 分支机构
				fund_account: creditUserInfo.fund_account, // 资金账号
				cust_code: creditUserInfo.cust_code, // 客户编号
				password: "", // 交易密码
				op_station: "", // 操作站点（见数据字典)	Y	
				sessionid: creditUserInfo.session_id, // 会话号
				exchange_type: "", // 交易市场类别（见数据字典)
				stock_account: "", // 证券账号
				stock_code: "", // 证券代码
				entrust_bs: "" // 委托标志（见数据字典)
		};
		service_credit.queryTransCanCancel(queryParam, queryCancelCallBack,
			{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){
				$(_pageId+ ".no_data").show();
				initVIScroll();
				if(vIscroll._init){
					vIscroll.scroll.refresh();
				}
			}
		});
	}
	/*
	 * 查询撤单回调
	 */
	function queryCancelCallBack(data){
		if(data.error_no == "0"){
			if(data.results[0]){
				creatCancelHtml(data.results);
			}else{
				$(_pageId+ ".no_data").show();
			}
			if(!vIscroll._init){
					initVIScroll();
			}else{
					vIscroll.scroll.refresh();
			}
		}else{
			layerUtils.iAlert(data.error_info);
		}
	}
	/**
     * 生成查询持仓函数
     * @param {Object} data
     */
    function creatCancelHtml(data){
    	var eleHtml = "";
    	for(var i=0;i<data.length;i++){
    		var price_digit = 2;
//  		require("common").decimalKeep(data[i].stock_code,function(data){  //获取保留的位数
//  	    	if(data){
//  	    		price_digit = data;
//  	    	}
//  		});
    		totalNo += data[i].entrust_no +","; //将编号拼在一起
    		var css = "";
    		var transPro = "";
    		if(data[i].entrust_bs == "76"){
    			transPro = "担保品转入";
    			css = "ared";
    		}else if(data[i].entrust_bs == "77"){
    			transPro = "担保品转出";
    			css = "agreen";
    		}
    		eleHtml += "<dl class=\"part\" id=\"remove\">"
            eleHtml +=    "<dt><span class="+css+">"+transPro+"</span><strong>"+data[i].stock_name+"</strong><small>"+data[i].stock_code+"</small></dt>"
            eleHtml +=    "<dd>"
            eleHtml +=    	"<a href=\"javascript:void(0);\" id=\"stockIn\" data-no = "+data[i].entrust_no+">撤单</a>"
            eleHtml +=    	"<p class=\"time\">"+data[i].entrust_time+"</p>"
            eleHtml +=       "<span>成本价 <em>"+Number(data[i].entrust_price).toFixed(price_digit)+"</em></span><span>委托数  <em>"+data[i].entrust_amount+"</em></span>"
            eleHtml +=  "</dd>"
            eleHtml += "</dl>"
    	}
    	totalNo = totalNo.substring(0,totalNo.length-1);//去掉编号最后的“ ，” 
		$(_pageId + ".cancel_list").html(eleHtml);
		
		//划入按钮cancelOrder
		appUtils.bindEvent($(_pageId+"#stockIn"), function(e){
			var entrust_no = $(this).attr("data-no");//委托编号
			var cancelParam = {
				"entrust_way": global.entrust_way, // 委托方式  在configuration配置
				"branch_no": creditUserInfo.branch_no, // 分支机构
				"fund_account": creditUserInfo.fund_account, // 资金账号
				"cust_code": creditUserInfo.cust_code, // 客户编号
				"password": creditUserInfo.password, // 交易密码
				"sessionid": creditUserInfo.session_id, // 会话号
				"entrust_no": entrust_no, // 委托编号
				"batch_flag": "0", // 批量撤单标志（0:不是，1：是）
				"exchange_type": "" // 交易市场类别
		};
		
			var dom = $(this).parent().parent();
			var stockCode = dom.find("dt:eq(0) small").text(); // 证券代码
			var stockName = dom.find("dt:eq(0) strong").text(); // 证券名称
			var delegateOrien = "撤单"; // 操作类型
			var delegatePrice = dom.find("dd span:eq(0) em").text(); // 委托价格
			var delegateQuantity = dom.find("dd span:eq(1) em").text(); // 委托数量
			var entrust_no = $(this).attr("data-no");
			var tipStr ="<div class=\"pop_header\">";
			tipStr+="<h3>撤单</h3>";
			tipStr+="</div>";
			tipStr+="<div class=\"pop_main\">";
			tipStr+="<ul>";
			tipStr+="    <li>证券名称 <em>"+stockName+"</em></li>";
			tipStr+="    <li>证券代码 <strong>"+stockCode+"</strong></li>";
			tipStr+="    <li>操作类型 <strong>"+delegateOrien+"</strong></li>";
			tipStr+="    <li>委托价格 <strong>"+delegatePrice+"</strong></li>";
			tipStr+="    <li>委托数量 <strong>"+delegateQuantity+"</strong></li>";
			tipStr+="    <li>委托编号 <strong>"+entrust_no+"</strong></li>";
			tipStr+="</ul>";
			tipStr+="  </div>";
			common.btnConfirm(tipStr,function success(){
				service_credit.credit_cancel(cancelParam, CancelCallBack);
				},function fail(){
			});
		
			e.stopPropagation();
		},"click");
    }
    function CancelCallBack(data){
    	if(data.error_no == "0"){
    		layerUtils.iAlert("撤单成功");
    		queryTransCanCancel();
    	}else{
    		layerUtils.iAlert(data.error_info);
    		return false;
    	}
    }    
    /**
	 * 初始化滑动组件
	 */
	function initVIScroll(){
		if(!vIscroll._init){
			var config = {
					"isPagingType": false,//false表示是微博那种累加形式，true表示分页形式
					"visibleHeight": $(window).height() - $(_pageId+".top_title").height()- 6 ,//显示内容区域的高度，当isPaingType为false时传
					"container": $(_pageId+"#v_container_funds_jj"),	
					"wrapper":$(_pageId+"#v_wrapper_funds_jj"),	
					"downHandle": function() {
						queryTransCanCancel();//下拉获取上一页数据方法
					},
					"upHandle": function() {	
						//上拉获取下一页数据方法
					},
					"wrapperObj": null
			};
			vIscroll.scroll = new VIscroll(config); 	//初始化，需要做if(!hIscroll._init)判断
			vIscroll._init = true;
		} else {
			vIscroll.scroll.refresh();
		}
		$(_pageId+ " .visc_pullUp").hide();
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId+ ".no_data").hide();
		$(_pageId + " #remove").remove();
		if(vIscroll._init){
			vIscroll.scroll.refresh();
		}
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageBack();
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});