/**
 * 基金交易-查询
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var layerUtils = require("layerUtils");
	var common = require("common");
	var VIscroll = require("vIscroll");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var vIscroll = {"scroll":null,"_init":false}; //上下滑动
	var service_fund = require("service_fund");
    var _pageId = "#fund_custFundQuery ";
    var entrustNo = ""; //撤单编号
	var exchangeType = ""; //市场类型
   
    /**
     * 初始化
     */
	function init(){common.hideBottomBar();
		common.bindStockEvent(_pageId); //绑定头部菜单事件
		custFundQuery();//客户信息查询
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			appUtils.pageBack();
		});
	}
	
	/**
	 * 查询客户绑定的信息
	 */
	function custFundQuery(){
		$(_pageId + " .fund_count").html("");
		$(_pageId+ ".no_data").hide();
		//获取保存在本地的账户信息
		var userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var password = userInfo.password;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "password":password,
			    "cust_code":cust_code
		};
		//最后一个为超时处理函数
		service_fund.getCustMsg(param,queryFundCallBack,
		{  //传给接口的json格式数据            
			"isLastReq":true,                
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){    //超时调用方法
				$(_pageId+ ".no_data").show();
				initVIScroll();
				if(vIscroll._init){
					vIscroll.scroll.refresh();
				}
			}
	    });
	}
	/**
	 * 查询客户信息回调
	 */
	function queryFundCallBack(data){
		if(data.error_no == "0"){
			if(data.results[0]){
				var results = data.results;
				creatHtml(results);
			}else{
				$(_pageId + ".fund_hold ul li:eq(2) strong").html("0"+"<span>支</span>")
				$(_pageId+ ".no_data").show();
			}
			initVIScroll();
		}else{
			layerUtils.iAlert(data.error_info);
			return false;
		}
	}
	/**
	 * 生成查询html页面
	 */
	function creatHtml(data){
		var html = "";
		for(var i=0;i<data.length;i++){
			result = data[i];
			 var status = result.holder_status//0：正常，1：锁定，2：冻结，3：挂失，4：休眠
			 switch(status){
			 	case "0":status = "正常";break;
			 	case "1":status = "锁定";break;
			 	case "2":status = "冻结";break;
			 	case "3":status = "挂失";break;
			 	case "4":status = "休眠";break;
			 	
			 }
			html += 	"<div class=\"part\">"
		    html +=        	"<span class=\"time\" >开户日期 "+result.open_date+"</span>";
		    html +=        	"<h5><i class=\"n1\"></i>"+result.company_name+"</h5>"
		    html +=            "<ul class=\"clearfix\">"
		    html +=            	"<li>基金帐号 <span>"+result.fund_account+"</span></li>"
		    html +=                "<li>公司代码 <span>"+result.fund_compeny+"</span></li>"
		    html +=                "<li>账户全名 <span>"+result.holder_name+"</span></li>"
		    html +=                "<li>账户状态 <span>"+status+"</span></li>"
		    html +=        	"</ul>"
		    html +=        "</div>"
		}
		$(_pageId + " .fund_count").html(html);
	}
	
	/**
	 * 初始化上下滑动组件
	 */
	function initVIScroll(){
		if(!vIscroll._init){
			var config = {
				"isPagingType": false,		//false表示是微博那种累加形式，true表示分页形式
				"visibleHeight": $(window).height() - $(_pageId+".top_title").height()- $(_pageId+".tab_nav").height() - 6,	//显示内容区域的高度，当isPaingType为false时传
				"container": $(_pageId+" #v_container_funds_jj"),	
				"wrapper":$(_pageId+" #v_wrapper_funds_jj"),	
				"downHandle": function() {				//下拉获取上一页数据方法
					custFundQuery();//客户信息查询
				},
				"upHandle": function() {
				},
				"wrapperObj": null
			};
			vIscroll.scroll = new VIscroll(config); 	//初始化，需要做if(!hIscroll._init)判断
			vIscroll._init = true; 						//尽量只初始化一次，保持性能
			
		}else{
			vIscroll.scroll.refresh();
		}
		$(_pageId + ".visc_pullUp").css("display","none");//隐藏"上拉加载下一页"
	}


	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId + " .fund_count").html("");
		if(vIscroll._init){
			vIscroll.scroll.refresh();
		}
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageBack();
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});