/**
 * 基金交易-申购
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var layerUtils = require("layerUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var common = require("common");
	var external = require("external");
	var validata = require("validatorUtil");
	var service_fund = require("service_fund");
	var service_stock = require("service_stock");
    var _pageId = "#fund_fundApply ";
    var userInfo = null;
    var fundCompany = "";
    var fundCode = "";
	var balance = "";
	flagFundAccount = true;   //用户是否开通基金账户
    
    /**
     * 初始化
     */
	function init(){common.hideBottomBar();
		common.systemKeybord(); // 解禁系统键盘
		common.bindStockEvent(_pageId); //绑定头部菜单事件
		userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
//		资金账户查询
		queryCapital();
		
		//在pc端可使用键盘输入股票代码（方便调试）
		if(gconfig.platform=="0"){ 
			$(_pageId+"#fundCode").attr("readonly",false);
		}	
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			appUtils.pageInit("fund/fundApply","account/index",{});
		});
		
		//基金代码输入框监听（PC端）
		appUtils.bindEvent($(_pageId+"#fundCode"), function(e){
			var fundCode = $(this).val();
			if(fundCode.length == 6){
				//调用服务层获取数据
				getFundList(fundCode);
			}else if(fundCode.length > 6){
				$(this).val(fundCode.substring(0,6));
			}else if(fundCode.length < 6){
				//重置页面的数据
//				clearBuyMsg();
			}
			$(_pageId+".trade_form .input_box .stat").hide();
			e.stopPropagation();
		},"keyup");
		
		//基金代码输入框调用原生键盘（Android或者是iOS）
		appUtils.bindEvent($(_pageId+"#fundCode"),function(e){
			window.customKeyboardEvent = {
					keyBoardFinishFunction: function(){},
					//原生键盘回调
					keyBoardInputFunction: function(){
						var fundCode = $(_pageId+"#fundCode").val();
						if(fundCode.length == 6){
							//调用服务层获取数据
							getFundList(fundCode);
						}else if(fundCode.length > 6){
							$(this).val(fundCode.substring(0,6));
						}else if(fundCode.length < 6){
//							clearBuyMsg();
						}
						$(_pageId+".trade_form .input_box .stat").hide();
					}
			};
			external.callMessage({"moduleName":"trade","funcNo": "50210", "pageId":"fund_fundApply", "eleId":"fundCode", "doneLable":"done", "keyboardType":"2"});
			e.stopPropagation();
		},"click");
		
		//失去焦点关闭原生键盘
		appUtils.bindEvent($(_pageId+"#fundCode"),function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50211"});
			e.stopPropagation();
		},"blur");
		
		//申购
		appUtils.bindEvent($(_pageId + ".input_form .ce_btn"), function(e){
			vailSubmitOrder();
			e.stopPropagation();
		});
	}
    
	/**
	 * 获取基金列表（根据用户输入的基金代码得到相对应的信息）
	 * */
	function getFundList(fundStr){
		if(fundStr!= "" && fundStr.length==6){
			$(_pageId+"#fundName").val("");
			$(_pageId+"#fundNav").val("");
			
			var entrust_way= global.entrust_way; // 委托方式  在configuration配置
			var fund_code = fundStr;
			var fund_company="";;
			var param = {
					"entrust_way":entrust_way,
					"fund_company":fund_company,
					"fund_code":fund_code
			};
			service_fund.getFundInfo(param,getFundInfoBack);
		}	
	}
	
	function getFundInfoBack(data){
		if(data.error_no == 0){
			var results = data.results;
			if(results && results.length > 0){
				 funCode = results[0].fund_code;
				 fundCompany = results[0].fund_company;   //基金公司代码
				 var nav= results[0].nav!=""?results[0].nav:"0";
				 $(_pageId+"#fundName").find("span").text(results[0].fund_name);
				 $(_pageId+"#fundNav").val(nav+"元");
			}
			else{
				layerUtils.iAlert("没有查询到对应的基金");
			}
		}else{
			layerUtils.iAlert(data.error_info);
		}
	}
	
	/**
	 * 资金账户查询
	 */
	function queryCapital(){
		//获取保存在本地的账户信息
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var money_type = "0";  //  0：人民币，1：美元，2：港币
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "cust_code":cust_code,
			    "money_type":money_type
		};
		//最后一个为超时处理函数
		service_stock.queryFundSelect(param,queryCapitalCallback);
	}
	
	/**
	 * 资金账户查询回调
	 */
	function queryCapitalCallback(data){
		if (data && data!= "undefined"){
			if(data.error_no == 0){
				var results = data.results;
				if(results[0] && results!= "undefined"){
					$(_pageId+".input_form .max strong").text(common.numToMoneyType(""+Number(results[0].enable_balance).toFixed(2)+""));//可用
				}else{
					$(_pageId+".input_form .max strong").text("--");//可用
				}
			}
			else{
				layerUtils.iAlert(data.error_info);
			}
		}
	}
	
	/**
	 * 下单验证（申购）
	 * */
	function vailSubmitOrder(){
		//验证基金代码输入是否正确
		var buy_stockCode = $(_pageId+"#fundCode").val();
		if(buy_stockCode.length == 0){
			layerUtils.iMsg(-1,"请输入基金代码");
			return false;
		}	
		if(buy_stockCode.length <5){
			layerUtils.iMsg(-1,"基金代码输入错误");
			return false;
		}	
		//验证基金份额输入是否正确
		var now_price = $(_pageId+"#fundPrice").val();
		var can_buy = $(_pageId+".input_form .max strong").text();
		if($.trim(now_price).length<=0){
			layerUtils.iMsg(-1,"请输入申购金额");
			return false;
		}else if(now_price=="0"){
			layerUtils.iMsg(-1,"申购金额不能为0");
			return false;
		}else if(!validata.isNumberFloat(now_price)||parseFloat(now_price)<0){
			layerUtils.iMsg(-1,"请正确输入申购金额");
			return false;
		}else if(Number(now_price)>Number(can_buy)){
			layerUtils.iMsg(-1,"申购金额超过可用金额");
			return false;
		}
		var tipStr ="<div class=\"pop_header\">";
		tipStr+="<h3>基金申购</h3>";
		tipStr+="</div>";
		tipStr+="<div class=\"pop_main\">";
		tipStr+="<ul>";
		tipStr+="    <li>基金名称 <em>"+ $(_pageId+" #fundName").find("span").text()+"</em></li>";
		tipStr+="    <li>基金代码 <strong>"+buy_stockCode+"</strong></li>";
		tipStr+="    <li>申购金额 <strong>"+now_price+"</strong></li>";
		tipStr+="</ul>";
		tipStr+="  </div>";
		common.btnConfirm(tipStr,function success(){
			fundCode = buy_stockCode;
			balance = now_price;
			//判断是否开户
			openFundAccount();
		},function fail(){
			
		} );
	}
	
	
	//判断是否开户方法的定义
	function openFundAccount(){
		var cust_code = userInfo.cust_code;	//客户代码
		var fund_account = userInfo.fund_account;	//资产账户
		var branch_no  = userInfo.branch_no;	//分支机构
		var sessionid=userInfo.sessionid;
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var password= userInfo.password;
		var param = {
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"sessionid":sessionid,
				"fund_code":fundCode
			};
		service_fund.openFundAccount(param,getOpenFundAccountCallBack,{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":true,
			"tipsWords":"请等待"
		});
	}
	function getOpenFundAccountCallBack(data){
		if(data.error_no == 0){
			var results = data.results;
			
			console.log("是否开通基金账户："+results[0].flag);
			
			if(results[0].flag == "1"){   //表示已经开通账户
				flagFundAccount = true;
				riskAssessment();
			}else if(results[0].flag == "0"){
				flagFundAccount = false;
				riskAssessment();
			}
		}else{
			clearBuyMsg();
			layerUtils.iAlert(data.error_info);
		}
	}
	
	
	//判断用户是否做过风险测评
	function riskAssessment(){
		var cust_code = userInfo.cust_code;	//客户代码
		var fund_account = userInfo.fund_account;	//资产账户
		var branch_no  = userInfo.branch_no;	//分支机构
		var sessionid=userInfo.sessionid;
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var password= userInfo.password;
		var param = {
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"sessionid":sessionid,
				"fund_code":fundCode
			};
		service_fund.riskAssessment(param,getriskAssessmentCallBack,{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":true,
			"tipsWords":"请等待"}
		);
	}
	function getriskAssessmentCallBack(data){
		if(data.error_no == 0){
			var results = data.results;
			
			console.log("是否做过风险测评："+results[0].flag);
			
			if(results[0].flag == "1"){   //表示已经做过风险测评
				if(flagFundAccount == true){
					purchaseBuy();
				}else{   //表示做过了基金风险测评但是没有开通基金账户
					//调开户接口进行开户
					layerUtils.iConfirm("您还未开通基金账户,是否现在开通？",function(){
						//显示风险揭示书
						var url = "https://tianxia.cindasc.com:8081/servlet/json?funcNo=1004179&agree_no=135";
						appUtils.invokeServer(url, {}, function(results){
							var resutlt = results.results[0];
							var tipStr ="<div class=\"pop_header\">";
							tipStr+="<h3>"+resutlt.agree_name+"</h3>";
							tipStr+="</div>";
							tipStr+="<div class=\"pop_main\" style='height:180px;overflow-y:scroll;'>";
							tipStr+="<ul>";
							tipStr+="    <li><em>"+resutlt.content+"</em></li>";
							tipStr+="</ul>";
							tipStr+="</div>";
							common.btnConfirm(tipStr,function(){
								//调用方法开通基金账户
								fundAccount();
							},function(){
								return;
							},"接受","取消");
						});
						//调用方法开通基金账户
//						fundAccount();
					},function(){
						
					},"开通","取消");
				}
			
			//表示没有做过风险测评
			}else{
				layerUtils.iConfirm("您还未做风险测评,现在进行风险测评？",function(){
					//到风险测评页面
					appUtils.pageInit("fund/fundSubscribe","fund/assessmentRisk",{"param":"fund/fundSubscribe"});
				},function(){
					
				},"风险测评","取消");
			}
		}else{
			clearBuyMsg();
			layerUtils.iAlert(data.error_info);
		}
	}
	
	
	//申购方法的定义
	function purchaseBuy(){
		var cust_code = userInfo.cust_code;	//客户代码
		var fund_account = userInfo.fund_account;	//资产账户
		var branch_no  = userInfo.branch_no;	//分支机构
		var sessionid=userInfo.sessionid;
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var password= userInfo.password;
		var fund_company=fundCompany;
		var fund_code=funCode;
		var param = {
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"sessionid":sessionid,
//				"fund_company":fund_company,
				"fund_code":fund_code,
				"flag":"0",
				"balance":balance
			};
		service_fund.getpurchaseBuy(param,getBuyCallBack);
	}
	//申购回调
	function getBuyCallBack(data){
		if(data.error_no == 0){
			var results = data.results;
			if(results){
				$(_pageId+"#fundPrice").val("");
				layerUtils.iAlert(data.error_info);
				clearBuyMsg();
				queryCapital();
			}
		}else if(data.error_no == "-1"){
			layerUtils.iConfirm(data.error_info,function(){
				var cust_code = userInfo.cust_code;	//客户代码
				var fund_account = userInfo.fund_account;	//资产账户
				var branch_no  = userInfo.branch_no;	//分支机构
				var sessionid=userInfo.sessionid;
				var entrust_way= global.entrust_way; // 委托方式  在configuration配置
				var password= userInfo.password;
				var fund_company=fundCompany;
				var fund_code=funCode;
				var param = {
						"entrust_way":entrust_way,
						"branch_no":branch_no,
						"fund_account":fund_account,
						"cust_code":cust_code,
						"password":password,
						"sessionid":sessionid,
//						"fund_company":fund_company,
						"fund_code":fund_code,
						"flag":"1",
						"balance":balance,
					};
				service_fund.getpurchaseBuy(param,getBuyCallBack);
			},function(){
				
			},"申购","取消");
		}else{
			clearBuyMsg();
			layerUtils.iAlert(data.error_info);
		}
	}
	
	
	//开通基金账户
	function fundAccount(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no  = userInfo.branch_no;	//分支机构
		var fund_account = userInfo.fund_account;	//资产账户
		var cust_code = userInfo.cust_code;	//客户代码
		var password= userInfo.password;
		var sessionid=userInfo.sessionid;
		var fund_company = fundCompany;   //基金公司代码（必传）
		var stock_account = "";
		var flag = "1";  
		
		var param = {
			"entrust_way":entrust_way,
			"branch_no":branch_no,
			"fund_account":fund_account,
			"cust_code":cust_code,
			"password":password,
			"sessionid":sessionid,
			"fund_company":fund_company,
			"stock_account":stock_account,
			"flag":flag
		};
		service_fund.fundAccount(param,fundAccountCallBack,{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":true,
			"tipsWords":"请等待"}
		);
	}
	
	//开通基金账户回调
	function fundAccountCallBack(data){
		if(data.error_no == 0){
			var results = data.results;
			if(results){
				layerUtils.iConfirm("基金账户成功开通,是否继续申购?",function(){
					purchaseBuy();   //继续进行申购
				},function(){
					
				},"申购","取消");
			}
		}else{
			clearBuyMsg();
			layerUtils.iAlert(data.error_info);
		}
	}

	
	/**
	 * 重置页面数据  
	 */
	function clearBuyMsg(){
		$(_pageId+"#fundPrice").val("");
		$(_pageId+"#fundNav").val("");
		$(_pageId+"#fundName").find("span").text("");
		$(_pageId+"#fundCode").val("");
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		clearBuyMsg();
		$(_pageId+"#fundCode").val("");
		external.callMessage({"moduleName":"trade","funcNo": "50211"});
		$(_pageId+".input_form .max strong").text("--");//可用
	}

	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("fund/fundApply","account/index",{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});