/**
 * 基金交易-认购
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var layerUtils = require("layerUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var common = require("common");
	var external = require("external");
	var service_fund = require("service_fund"); 
    var _pageId = "#fund_fundCastSurely ";
    var userInfo = null;
    var dateUtils = require("dateUtils");
    var fundCompany = "";
	var flagFundAccount = true;   //用户是否开通基金账户
	var fundCode = "";
    
    /**
     * 初始化
     */
	function init(){common.hideBottomBar();
		var height_table = $(window).height() - $(_pageId+".top_title").height() - $(_pageId+".tab_nav").height() - 27;
        $(_pageId+"#mainShow").height(height_table);
		userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		//基金定投查询
		queryFundCastSurely();
		//在pc端可使用键盘输入股票代码（方便调试）
		if(gconfig.platform=="0"){ 
			$(_pageId+"#fundCode").attr("readonly",false);
		}
    }
	
	function queryFundCastSurely(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var password = userInfo.password;
		var sessionid = userInfo.session_id;
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "password":password,
			    "sessionid":sessionid,
			    "cust_code":cust_code
		};
		service_fund.queryFundCastSurely(param,queryFundCastSurelyCallback,{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":true,
			"tipsWords":"请等待..."
		});
		function queryFundCastSurelyCallback(data){
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length > 0){
					$(_pageId+".no_data").hide();
					var htmlData = "";
					for (var i=0;i<results.length;i++){
						htmlData += queryFundCastSurelyHTML(results[i]);
					}
					$(_pageId + ".main #mainShow .fund_count2").html(htmlData);
					//动态绑定事件
					appUtils.preBindEvent($(_pageId),".main #mainShow .fund_count2 .part .btn a", function(e){
						var entrust_way= global.entrust_way; // 委托方式  在configuration配置
						var branch_no = userInfo.branch_no;	
						var fund_account = userInfo.fund_account;
						var cust_code = userInfo.cust_code;//关联资产账户标志
						var password = userInfo.password;
						var sessionid = userInfo.session_id;
						var stock_account = "";   //证券账号
						var allotno = $(this).parent().parent().attr("id").split(",")[0];;   //申请编号(Y)
						var fund_company = "";   //基金公司
						var fund_code = $(this).parent().parent().find("h5 small").text();   //基金代码(Y)
						var en_fund_date = $(this).parent().parent().attr("id").split(",")[1];;   //扣款允许日(Y)
						var param={				
								"entrust_way":entrust_way,
							    "branch_no":branch_no,
							    "fund_account":fund_account,
							    "password":password,
							    "sessionid":sessionid,
							    "cust_code":cust_code,
							    "stock_account":stock_account,
							    "allotno":allotno,
							    "fund_company":fund_company,
							    "fund_code":fund_code,
							    "en_fund_date":en_fund_date,
						};
						service_fund.fundUndo(param,fundUndoCallback,{
							"isLastReq":true,
							"isShowWait":true,
							"isShowOverLay":true,
							"tipsWords":"请等待..."
						});
						function fundUndoCallback(data){
							if(data.error_no == 0){
								var results = data.results;
								if(results && results.length > 0){
									layerUtils.iAlert(data.error_info);
									//基金定投查询
									queryFundCastSurely();
								}else{
									layerUtils.iAlert(data.error_info);
									//基金定投查询
									queryFundCastSurely();
								}
							}else{
								layerUtils.iAlert(data.error_info);
							}
						}
					});
				}else{
					$(_pageId+".no_data").show();
//					layerUtils.iAlert(data.error_info);
				}
			}else{
				layerUtils.iAlert(data.error_info);
			}
		}
		function queryFundCastSurelyHTML(results){
			var eleHtml = "";
			if(results.protocol_status == 4){
				eleHtml += "<div id='"+ results.allotno +","+ results.en_fund_date +"' class='part'>";
				eleHtml += "<span class='stat'>"+results.protocol_status_name+"</span>";
				eleHtml += "<h5>"+results.fund_name+"<small>"+results.fund_code+"</small></h5>";
				eleHtml += "<ul class='clearfix'>";
				eleHtml += "<li>定投金额<span>"+results.balance+"</span></li>";
				/*eleHtml += "<li>委托时间<span>"+results.init_date+"</span></li>";*/
				eleHtml += "<li>扣款日期<span>"+results.next_pay_date+"</span></li>";
				eleHtml += "<li>已投次数<span>"+results.fail_time+"</span></li>";
				/*eleHtml += "<li>开始日期<span>"+results.start_date+"</span></li>";*/
				eleHtml += "<li>截止日期<span>"+results.end_date+"</span></li>";
				eleHtml += "</ul>";
		        eleHtml += "</div>";
			}else{
				eleHtml += "<div id='"+ results.allotno +","+ results.en_fund_date +"' class='part'>";
				eleHtml += "<span class='stat'>"+results.protocol_status_name+"</span>";
				eleHtml += "<h5>"+results.fund_name+"<small>"+results.fund_code+"</small></h5>";
				eleHtml += "<ul class='clearfix'>";
				eleHtml += "<li>定投金额<span>"+results.balance+"</span></li>";
				/*eleHtml += "<li>委托时间<span>"+results.init_date+"</span></li>";*/
				eleHtml += "<li>扣款日期<span>"+results.next_pay_date+"</span></li>";
				eleHtml += "<li>已投次数<span>"+results.fail_time+"</span></li>";
				/*eleHtml += "<li>开始日期<span>"+results.start_date+"</span></li>";*/
				eleHtml += "<li>截止日期<span>"+results.end_date+"</span></li>";
				eleHtml += "</ul>";
		        eleHtml += "<p class='btn'>";
		        eleHtml += "<a href='javascript:void(0);'>撤销</a>";
		        eleHtml += "</p>";
		        eleHtml += "</div>";
			}
	        return eleHtml;
		}
	}
	
	
	//基金定投下单数据查询
	function queryReimbursementDate(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var password = userInfo.password;
		var sessionid = userInfo.session_id;
		var save_plan_cls = "";
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "password":password,
			    "sessionid":sessionid,
			    "cust_code":cust_code,
			    "save_plan_cls":save_plan_cls
		};
		service_fund.queryReimbursementDate(param,queryReimbursementDateCallback,{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":true,
			"tipsWords":"请等待..."
		});
		function queryReimbursementDateCallback(data){
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length > 0){
					var ulObj = $(_pageId + ".main #mainShow .input_form .input_select .select_box ul");
					if(results.length <= 4){
						ulObj.css("height",(0.44 * results.length)+"rem");
					}else{
						ulObj.css("height",(0.44 * 4)+"rem");
					}
					var eleHtml = "";
					for(var i=0;i<results.length;i++){
						eleHtml += "<li id='"+results[i].pay_day+"'><a href='javascript:void(0);'>"+results[i].save_plan_name+"</a></li>";
					}
					ulObj.html(eleHtml);
					
					appUtils.bindEvent($(_pageId + ".main #mainShow .input_form .input_select .select_box ul li a"), function(e){
						var liValue = $(this).text();
						$(_pageId + ".main #mainShow .input_form .input_select .select_box p").text(liValue);
						$(_pageId + ".main #mainShow .input_form .input_select .select_box p").attr("id",$(this).parent().attr("id"));
						$(_pageId + ".main #mainShow .input_form .input_select .select_box ul").css("display","none");
						e.stopPropagation();
					});
				}else{
					layerUtils.iAlert(data.error_info);
				}
			}else{
				layerUtils.iAlert(data.error_info);
			}
		}
	}
	
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		dateUtils.initDateUI("fund_fundCastSurely");   //可以设置多种属性值
		//返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			appUtils.pageInit("fund/fundCastSurely","fund/fundQuery",{});
			e.stopPropagation();
		});
		
		//标题切换
		appUtils.bindEvent($(_pageId + ".main .tab_nav ul li"), function(e){
			clearBuyMsg();
			$(this).addClass("active").siblings().removeClass("active");
//			$(_pageId + ".top_title h3").text($(this).find("a").text());
			callsQuery();
			e.stopPropagation();
		});
		
		//选择扣款日
		appUtils.bindEvent($(_pageId + ".main #mainShow .input_form .input_select .select_box"), function(e){
			var ulObj = $(_pageId+".main #mainShow .input_form .input_select .select_box ul");
			if(ulObj.css("display") == "none"){
				ulObj.css("display","block");
			}else{
				ulObj.css("display","none");
			}
			e.stopPropagation();
		});
		
		//基金代码输入框监听（PC端）
		appUtils.bindEvent($(_pageId+"#fundCode"), function(e){
			var fundCode = $(this).val();
			if(fundCode.length == 6){
				//调用服务层获取数据
				getFundList(fundCode);
			}else if(fundCode.length > 6){
				$(this).val(fundCode.substring(0,6));
			}else if(fundCode.length < 6){
				
			}
			$(_pageId+".trade_form .input_box .stat").hide();
			e.stopPropagation();
		},"keyup");
		
		//基金代码输入框调用原生键盘（Android或者是iOS）
		appUtils.bindEvent($(_pageId+"#fundCode"),function(e){
			clearBuyMsg();
			window.customKeyboardEvent = {
					keyBoardFinishFunction: function(){},
					//原生键盘回调
					keyBoardInputFunction: function(){
						var fundCode = $(_pageId+"#fundCode").val();
						if(fundCode.length == 6){
							//调用服务层获取数据
							getFundList(fundCode);
						}else if(fundCode.length > 6){
							$(this).val(fundCode.substring(0,6));
						}else if(fundCode.length < 6){
							
						}
						$(_pageId+".trade_form .input_box .stat").hide();
					}
			};
			external.callMessage({"moduleName":"trade","funcNo": "50210", "pageId":"fund_fundCastSurely", "eleId":"fundCode", "doneLable":"done", "keyboardType":"2"});
			e.stopPropagation();
		},"click");
		
		//失去焦点关闭原生键盘
		appUtils.bindEvent($(_pageId+"#fundCode"),function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50211"});
			e.stopPropagation();
		},"blur");
		
		appUtils.bindEvent($(_pageId),function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50211"});
			e.stopPropagation();
		},"blur");
		
		//提交
		appUtils.bindEvent($(_pageId+".main #mainShow .input_form .ce_btn"),function(e){
//			fundCastSurelySubmit();
			if(pageCheck() == false){
				return;
			}
			//判断用户时候开通基金账户
			openFundAccount();
			e.stopPropagation();
		},"click");
		
	}
	
	//提交前的页面校验
	function pageCheck(){
		if($(_pageId+"#fundCode").val().length != 6){
			layerUtils.iMsg(-1,"基金代码输入格式错误");
			return false;
		}
		if(!$(_pageId+"#castSurelyMoney").val()){
			layerUtils.iMsg(-1,"请输入定投金额");
			return false;
		}
		if($(_pageId+"#castSurelyMoney").val() <= 0){
			layerUtils.iMsg(-1,"定投金额应大于0");
			return false;
		}
		if(!$(_pageId+"#startDate").val()){
			layerUtils.iMsg(-1,"请选择定投开始日期");
			return false;
		}
		if(!$(_pageId+"#stopDate").val()){
			layerUtils.iMsg(-1,"请选择定投结束日期");
			return false;
		}
		if(!$(_pageId + ".main #mainShow .input_form .input_select .select_box p").attr("id")){
			layerUtils.iMsg(-1,"请选择扣款日");
			return false;
		}
	}
	
	//调用接口获得联动数据
	function getFundList(fundStr){
		if(fundStr!= "" && fundStr.length==6){
			$(_pageId+"#fundName").val("");
			$(_pageId+"#fundNav").val("");
			
			var entrust_way= global.entrust_way; // 委托方式  在configuration配置
			var fund_code = fundStr;
			var fund_company="";;
			var param = {
					"entrust_way":entrust_way,
					"fund_company":fund_company,
					"fund_code":fund_code
			};
			service_fund.getFundInfo(param,getFundInfoBack);
		}
		function getFundInfoBack(data){
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length > 0){
					 fundCompany = results[0].fund_company;
					 var nav= results[0].nav!=""?results[0].nav:"0";
					 $(_pageId+"#fundNav").val(nav+"元");
					 $(_pageId+"#fundName").val(results[0].fund_name);
					 fundCode = results[0].fund_code;
				}
				else{
					layerUtils.iAlert("没有查询到对应的基金");
				}
			}else{
				layerUtils.iAlert(data.error_info);
			}
		}
	}
	
	function callsQuery(){
		$(_pageId+".no_data").hide();
		//基金定投查询
		if($(_pageId+".main .tab_nav ul li:eq(0)").hasClass("active")){
			$(_pageId + ".main .fund_count2").css("display","block");
			$(_pageId + ".main .input_form").css("display","none");
			queryFundCastSurely();
		//基金定投下单
		}else{
			$(_pageId + ".main .fund_count2").css("display","none");
			$(_pageId + ".main .input_form").css("display","block");
			queryReimbursementDate();
		}
	}
	
	//开通基金账户
	function fundAccount(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no  = userInfo.branch_no;	//分支机构
		var fund_account = userInfo.fund_account;	//资产账户
		var cust_code = userInfo.cust_code;	//客户代码
		var password= userInfo.password;
		var sessionid=userInfo.sessionid;
		var fund_company = fundCompany;   //基金公司代码（必传）
		var stock_account = "";
		var flag = "1";  
		
		var param = {
			"entrust_way":entrust_way,
			"branch_no":branch_no,
			"fund_account":fund_account,
			"cust_code":cust_code,
			"password":password,
			"sessionid":sessionid,
			"fund_company":fund_company,
			"stock_account":stock_account,
			"flag":flag
		};
		service_fund.fundAccount(param,fundAccountCallBack,{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":true,
			"tipsWords":"请等待"}
		);
	}
	//开通基金账户回调
	function fundAccountCallBack(data){
		if(data.error_no == 0){
			var results = data.results;
			if(results){
				layerUtils.iConfirm("基金账户成功开通,是否继续下单?",function(){
					fundCastSurelySubmit();
				},function(){
					
				},"下单","取消");
			}
		}else{
			layerUtils.iAlert(data.error_info);
		}
	}
	
	
	
	//判断是否开户方法的定义
	function openFundAccount(){
		var cust_code = userInfo.cust_code;	//客户代码
		var fund_account = userInfo.fund_account;	//资产账户
		var branch_no  = userInfo.branch_no;	//分支机构
		var sessionid=userInfo.sessionid;
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var password= userInfo.password;
		var param = {
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"sessionid":sessionid,
				"fund_code":fundCode
			};
		service_fund.openFundAccount(param,getOpenFundAccountCallBack,{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":true,
			"tipsWords":"请等待"
		});
	}
	function getOpenFundAccountCallBack(data){
		if(data.error_no == 0){
			var results = data.results;
			console.log("是否开通基金账户："+results[0].flag);
			if(results[0].flag == "1"){   //表示已经开通账户
				flagFundAccount = true;
				riskAssessment();
			}else if(results[0].flag == "0"){
				flagFundAccount = false;
				riskAssessment();
			}
		}else{
			layerUtils.iAlert(data.error_info);
		}
	}
	
	//判断用户是否做过风险测评
	function riskAssessment(){
		var cust_code = userInfo.cust_code;	//客户代码
		var fund_account = userInfo.fund_account;	//资产账户
		var branch_no  = userInfo.branch_no;	//分支机构
		var sessionid=userInfo.sessionid;
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var password= userInfo.password;
		var param = {
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"sessionid":sessionid,
				"fund_code":fundCode
			};
		service_fund.riskAssessment(param,getriskAssessmentCallBack,{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":true,
			"tipsWords":"请等待"}
		);
	}
	function getriskAssessmentCallBack(data){
		if(data.error_no == 0){
			var results = data.results;
			console.log("是否做过风险测评："+results[0].flag);
			if(results[0].flag == "1"){   //表示已经做过风险测评
				if(flagFundAccount == true){
					fundCastSurelySubmit();//下单
				}else{   //表示做过了基金风险测评但是没有开通基金账户
					//调开户接口进行开户
					layerUtils.iConfirm("您还未开通基金账户,是否现在开通？",function(){
						//显示风险揭示书
						var url = "https://tianxia.cindasc.com:8081/servlet/json?funcNo=1004179&agree_no=135";
						appUtils.invokeServer(url, {}, function(results){
							var resutlt = results.results[0];
							var tipStr ="<div class=\"pop_header\">";
							tipStr+="<h3>"+resutlt.agree_name+"</h3>";
							tipStr+="</div>";
							tipStr+="<div class=\"pop_main\" style='height:180px;overflow-y:scroll;'>";
							tipStr+="<ul>";
							tipStr+="    <li><em>"+resutlt.content+"</em></li>";
							tipStr+="</ul>";
							tipStr+="</div>";
							common.btnConfirm(tipStr,function(){
								//调用方法开通基金账户
								fundAccount();
							},function(){
								return;
							},"接受","取消");
						});
						//调用方法开通基金账户
//						fundAccount();
					},function(){
						
					},"开通","取消");
				}
			//表示没有做过风险测评
			}else{
				layerUtils.iConfirm("您还未做风险测评,现在进行风险测评？",function(){
					//到风险测评页面
					appUtils.pageInit("fund/fundCastSurely","fund/assessmentRisk",{"param":"fund/fundSubscribe"});
				},function(){
					
				},"风险测评","取消");
			}
		}else{
			layerUtils.iAlert(data.error_info);
		}
	}
	
	//提交方法的定义
	function fundCastSurelySubmit(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var password = userInfo.password;
		var sessionid = userInfo.session_id;
		var fund_code = $(_pageId+"#fundCode").val();   //基金代码
		var balance = $(_pageId+"#castSurelyMoney").val();   //金额
		var start_date = $(_pageId+"#startDate").val();   //开始日期
		var end_date = $(_pageId+"#stopDate").val();   //结束日期
		var en_fund_date = $(_pageId + ".main #mainShow .input_form .input_select .select_box p").attr("id");   //每月扣款日
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "password":password,
			    "sessionid":sessionid,
			    "cust_code":cust_code,
			    "fund_code":fund_code,
			    "balance":balance,
			    "start_date":start_date,
			    "end_date":end_date,
			    "en_fund_date":en_fund_date
		};
		service_fund.fundCastSurelyModify(param,fundCastSurelyModifyCallback,{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":true,
			"tipsWords":"请等待..."
		});
		function fundCastSurelyModifyCallback(data){
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length > 0){
					clearBuyMsg();
					layerUtils.iAlert(data.error_info);
				}else{
					layerUtils.iAlert(data.error_info);
				}
			}else{
				layerUtils.iAlert(data.error_info);
			}
		}
	}
	
	
	/**
	 * 重置页面数据  
	 */
	function clearBuyMsg(){
		$(_pageId+"#fundCode").val("");
		$(_pageId+"#fundName").val("");
		$(_pageId+"#castSurelyMoney").val("");
		$(_pageId+"#startDate").val("");
		$(_pageId+"#stopDate").val("");
		$(_pageId+"#fundNav").val("");
		$(_pageId + ".main #mainShow .input_form .input_select .select_box p").attr("id","").text("请选择扣款日");
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId+".no_data").hide();
		clearBuyMsg();
	}

	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("fund/fundCastSurely","fund/fundQuery",{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});