﻿/**
 * 基金交易-历史查询
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var layerUtils = require("layerUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var common = require("common");
	var external = require("external");
	var validata = require("validatorUtil");
	var service_stock = require("service_stock");
	var service_fund = require("service_fund"); 
    var _pageId = "#fund_fundDisparkQuery ";
    var userInfo = null;
	var balance = "";
	var flagFundAccount = true;   //用户是否开通基金账户
    var fundCompany = "";
	var fund_status = ""; //基金状态  0：正常开放，1：认购时期，2：发行成功，3：发行失败，
    var fund_type = "";
    var fund_risklevel = "";
    var fundCode = "";
    
    /**
     * 初始化
     */
	function init(){common.hideBottomBar();
		//设置滑动区域的高度
		var height_table = $(window).height() - $(_pageId+".top_title").height() - $(_pageId+".search_box").height()-27;
        $(_pageId+".fund_table").height(height_table);
		userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		
		//查询可认购基金
		queryCanSubscribe();
		
		if(gconfig.platform=="0"){ 
			$(_pageId+"#fundCode").attr("readonly",false);
		}	
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			appUtils.pageInit("fund/fundDisparkQuery","fund/fundQuery",{});
			e.stopPropagation();
		});
		
		//筛选条件选择
		appUtils.bindEvent($(_pageId + ".top_title .logout"), function(e){
			$(_pageId+"#fundCode").val("");
			$(_pageId + ".top_title .top_nav").slideToggle("fast");
			e.stopPropagation();
		});
		
		//选中筛选的条件
		appUtils.bindEvent($(_pageId + ".top_title .top_nav ul li a"), function(e){
			$(_pageId + ".main .input_select .select_box p").html("请选择筛选条件");
			var searchLimit = $(this).attr("value");
			$(_pageId + ".top_title .top_nav").hide();
			$(_pageId + ".main .search_box").css({"display":"none"});
			$(_pageId + ".main .input_select").css({"display":"block"});
			var entrust_way= global.entrust_way; // 委托方式  在configuration配置
			var branch_no = userInfo.branch_no;	
			var fund_account = userInfo.fund_account;
			var password = userInfo.password;
			var sessionid = userInfo.session_id;
			var cust_code = userInfo.cust_code;//关联资产账户标志
			var type = searchLimit;   //筛选条件类型（1：基金类型 2 ：基金状态 3 ： 基金风险等级）
			var param={				
					entrust_way:entrust_way,
					branch_no:branch_no,
					fund_account:fund_account,
					cust_code:cust_code,
					password:password,
					sessionid:sessionid,
					type:type
			};
			//请求数据
			service_fund.queryDisparkFund(param,queryDisparkFundCallback,{
				"isLastReq":true,
				"isShowWait":true,
				"isShowOverLay":true,
				"tipsWords":"请等待"
			});
			function queryDisparkFundCallback(data){
				if(data.error_no == 0){
					var results = data.results;
					var ulObj = $(_pageId + ".main .input_select .select_box ul");
					if(results.length <= 4){
						ulObj.css("height",(0.44 * results.length)+"rem");
					}else{
						ulObj.css("height",(0.44 * 4)+"rem");
					}
					var returnData = "";
					for(var i=0;i<results.length;i++){
						returnData += "<li id='"+results[i].fund_condition+"'><a href='javascript:void(0);'>"+results[i].fund_condition_name+"</a></li>";
					}
					ulObj.html(returnData);
					//选中具体条件调用后台数据
					appUtils.preBindEvent($(_pageId),".main .input_select .select_box ul li",function(e){
						$(_pageId + ".main .input_select").css({"display":"none"});
						var typeValue = $(this).attr("id");
						$(_pageId + ".main .input_select .select_box p").html($(this).find("a").text());
						//请求数据
						if(searchLimit == "1"){
							fundCode = "";
							fund_status = ""; 
						    fund_type = typeValue;
						    fund_risklevel = "";
						}else if(searchLimit == "2"){
							fundCode = "";
							fund_status = typeValue; 
						    fund_type = "";
						    fund_risklevel = "";
						}else{
							fundCode = "";
							fund_status = ""; 
						    fund_type = "";
						    fund_risklevel = typeValue;
						}
						
						//调用方法请求数据
						queryCanSubscribe();
						
						//数据请求完毕后显示基金代码输入框
						$(_pageId + ".main .search_box").css({"display":"block"});
						e.stopPropagation();
					});
				}else{
					layerUtils.iAlert(data.error_info);
				}
			}
			e.stopPropagation();
		});
		
		
		//基金代码输入框调用原生键盘（Android或者是iOS）
		appUtils.bindEvent($(_pageId+"#fundCode"),function(e){
			$(_pageId+"#fundCode").val("");
			window.customKeyboardEvent = {
				keyBoardFinishFunction: function(){},
				//原生键盘回调
				keyBoardInputFunction: function(){
					var fundCode = $(_pageId+"#fundCode").val();
					if(fundCode.length == 6){
						
					}else if(fundCode.length > 6){
						$(this).val(fundCode.substring(0,6));
					}
				}
			};
			external.callMessage({"moduleName":"trade","funcNo": "50210", "pageId":"fund_fundDisparkQuery", "eleId":"fundCode", "doneLable":"done", "keyboardType":"2"});
			e.stopPropagation();
		},"click");
		
		//失去焦点关闭原生键盘
		appUtils.bindEvent($(_pageId+"#fundCode"),function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50211"});
			e.stopPropagation();
		},"blur");
		
		//点击查询根据查询条件调用后台数据
		appUtils.bindEvent($(_pageId + ".search_box .inner #search"), function(e){
			//得到文本框输入的值
			fundCode = $(_pageId + ".search_box .inner #fundCode").val();
			
			if(fundCode.length == 0){
				layerUtils.iMsg(-1,"请输入基金代码");
				return false;
			}	
			if(fundCode.length < 6){
				layerUtils.iMsg(-1,"基金代码输入错误");
				return false;
			}
			
			fund_status = ""; 
		    fund_type = "";
		    fund_risklevel = "";
			queryCanSubscribe();
			e.stopPropagation();
		});
		
		appUtils.bindEvent($(_pageId), function(e){
			$(_pageId + ".main .search_box").css({"display":"block"});
			$(_pageId + ".main .input_select").css({"display":"none"});
			$(_pageId + ".header .top_title .top_nav").css({"display":"none"});
			e.stopPropagation();
		});
	}
	
	//查询基金方法的定义
	function queryCanSubscribe(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var password = userInfo.password;
		var sessionid = userInfo.session_id;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "password":password,
			    "sessionid":sessionid,
			    "cust_code":cust_code,
			    "fund_status":fund_status,
				"fund_status" : fund_status,
			    "fund_type" : fund_type,
			    "fund_risklevel" : fund_risklevel,
			    "fund_code" : fundCode
		};
		
		//最后一个为超时处理函数
		service_fund.queryCanSubscribe(param,queryCanSubscribeCallback,{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":true,
			"tipsWords":"正在查询基金信息",
			"timeOutFunc":function(){    //超时调用方法
				$(_pageId+ ".no_data").show();
	        }
		});
	}
	
	//查询基金回调
	function queryCanSubscribeCallback(data){
		if(typeof(data) != undefined && typeof(data) != null) {
			if(data.error_no == 0){
				$(_pageId+".main .fund_table .ce_table").html("");
				var results = data.results;
				num = results.length;
				var data1 = "<tr><th scope=\"col\">基金代码/名称</th> <th scope=\"col\">基金净值</th><th scope=\"col\">基金状态</th> </tr>";
				if(results && results.length > 0){
					$(_pageId+ ".no_data").hide();
						if(data.error_no == 0){
							var results = data.results;
							if(results && results.length>0){
								for (var i=0;i<results.length;i++){ 
									 //HTML生成
									 data1 += queryPositionHTML_stock(results[i]);
								}
								function queryPositionHTML_stock(element){
							        var eleHtml = "";
							        eleHtml+="<tr id="+element.fund_company+">";
							        eleHtml+="<td style='width:150px;text-align:left;font-size:10px'><small>("+element.fund_code +")</small>"+element.fund_name +"</td>";
							        eleHtml+="<td>"+element.nav +"</td>";
							        eleHtml+="<td>"+element.fund_status_name+"</td>";
							        eleHtml+="</tr>";
							        return eleHtml;
								}
								//将生成的HTML添加到指定的地方
								$(_pageId+".main .fund_table .ce_table").html(data1);
							}
						}
					}else{
						$(_pageId+ ".no_data").show();
						$(_pageId+".main .fund_table .ce_table").html(data1);
					}
			}else{
				  layerUtils.iAlert(data.error_info);
			}
		}else{
			  layerUtils.iAlert("查询失败");
		}
	}
	
	function clearBuyMsg(){
		$(_pageId+ ".no_data").show();
		$(_pageId + ".top_title .top_nav").css("display","none");
		fund_status = ""; //基金状态  0：正常开放，1：认购时期，2：发行成功，3：发行失败，
	    fund_type = "";
	    fund_risklevel = "";
	    fundCode = "";
		$(_pageId+"#fundCode").val("");
		$(_pageId+".fund_table .ce_table").html("");
		$(_pageId + ".main .input_select .select_box p").html("请选择筛选条件");
		$(_pageId + ".main .search_box").css({"display":"block"});
		$(_pageId + ".main .input_select").css({"display":"none"});
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		clearBuyMsg();
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("fund/fundQueryHistory","fund/fundQuery",{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});