/**
 * 交易主界面
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var layerUtils = require("layerUtils");
    var _pageId = "#fund_fundGradingApply ";
    var external = require("external");
    var common = require("common");
    var external = require("external");
    var service_fund = require("service_fund"); 
    var userInfo = null;
    var fundOpertype = "1";
    
    /**
     * 初始化
     */
	function init(){common.hideBottomBar();
		userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		if(gconfig.platform=="0"){ 
			$(_pageId+"#fundCode").attr("readonly",false);
		}	
	}
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			appUtils.pageInit("fund/fundGradingApply","account/index",{});
			e.stopPropagation();
		});
		
		//标题切换
		appUtils.bindEvent($(_pageId + ".main .tab_nav ul li"), function(e){
			clearBuyMsg();
			$(this).addClass("active").siblings().removeClass("active");
			callsQuery();
			e.stopPropagation();
		});
		
		//PC端基金代码输入调用数据
		appUtils.bindEvent($(_pageId+"#fundCode"),function(e){
			var fundCode = $(_pageId+"#fundCode").val();
			if(fundCode.length == 6){
				//请求数据
				querySplitCombineData(fundCode);
			}else if(fundCode.length > 6){
				$(this).val(fundCode.substring(0,6));
			}
		},"keyup");
		
		//基金代码输入框调用原生键盘（Android或者是iOS）
		appUtils.bindEvent($(_pageId+"#fundCode"),function(e){
			clearBuyMsg();
			window.customKeyboardEvent = {
				keyBoardFinishFunction: function(){},
				//原生键盘回调
				keyBoardInputFunction: function(){
					var fundCode = $(_pageId+"#fundCode").val();
					if(fundCode.length == 6){
						//请求数据
						querySplitCombineData(fundCode);
					}else if(fundCode.length > 6){
						$(this).val(fundCode.substring(0,6));
					}
				}
			};
			external.callMessage({"moduleName":"trade","funcNo": "50210", "pageId":"fund_fundGradingApply", "eleId":"fundCode", "doneLable":"done", "keyboardType":"2"});
			e.stopPropagation();
		},"click");
		
		//失去焦点关闭原生键盘
		appUtils.bindEvent($(_pageId+"#fundCode"),function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50211"});
			e.stopPropagation();
		},"blur");
		
		//失去焦点关闭原生键盘
		appUtils.bindEvent($(_pageId),function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50211"});
			e.stopPropagation();
		},"click");
		
		//拆分和合并
		appUtils.bindEvent($(_pageId + "#mainShow .input_form .ce_btn a"),function(e){
			var fundCode = $(_pageId+"#fundCode").val();
			var entrustAmount = $(_pageId+"#entrustAmount").val();
			if(isVerification(fundCode,entrustAmount)){
				var exchangeTypeStockAccount = $(_pageId + "#mainShow .input_form .fund_name p:eq(0) span").attr("id");
				var exchangeType = exchangeTypeStockAccount.split(",")[0];
				var stockAccount = exchangeTypeStockAccount.split(",")[1];
				splitCombineSubmit(fundCode,exchangeType,stockAccount,entrustAmount);
			}
			e.stopPropagation();
		},"click");
	}
	
	function isVerification(fundCode,entrustAmount){
		if(!fundCode){
			layerUtils.iMsg(-1,"请输入基金代码");
			return false;
		}else if(fundCode.length < 6){
			layerUtils.iMsg(-1,"基金代码输入错误");
			return false;
		}
		if(!entrustAmount){
			if(fundOpertype == "1"){
				layerUtils.iMsg(-1,"请输入合并数量");
			}else{
				layerUtils.iMsg(-1,"请输入拆分数量");
			}
			return false;
		}else if(entrustAmount <= 0){
			if(fundOpertype == "1"){
				layerUtils.iMsg(-1,"合并数量必须大于0");
			}else{
				layerUtils.iMsg(-1,"拆分数量必须大于0");
			}
			return false;
		}
		return true;
	}
	
	//标题切换方法的定义
	function callsQuery(){
		clearBuyMsg();
		if($(_pageId+".main .tab_nav ul li:eq(0)").hasClass("active")){
			$(_pageId + "#mainShow .input_form .input_text:eq(1) label").text("合并数量");
			$(_pageId + "#mainShow .input_form .input_text:eq(1) input").attr("placeholder","请输入合并数量");
			$(_pageId + "#mainShow .input_form .ce_btn a").text("合并");
			fundOpertype = "1";
		}else{
			$(_pageId + "#mainShow .input_form .input_text:eq(1) label").text("拆分数量");
			$(_pageId + "#mainShow .input_form .input_text:eq(1) input").attr("placeholder","请输入拆分数量");
			$(_pageId + "#mainShow .input_form .ce_btn a").text("拆分");
			fundOpertype = "0";
		}
	}
	
	//请求数据方法的定义
	function querySplitCombineData(fundCode){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var password = userInfo.password;
		var sessionid = userInfo.session_id;
		var fund_opertype  = fundOpertype;
		var fund_code = fundCode;
		var param={				
			entrust_way:entrust_way,
			branch_no:branch_no,
			fund_account:fund_account,
			cust_code:cust_code,
			password:password,
			sessionid:sessionid,
			fund_opertype:fund_opertype,
			fund_code:fund_code
		};
		//请求数据
		service_fund.querySplitCombineData(param,querySplitCombineDataCallback,{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":true,
			"tipsWords":"请等待"
		});
		function querySplitCombineDataCallback(data){
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length > 0){
					$(_pageId + "#mainShow .input_form .fund_name p:eq(0)").html("<span id="+results[0].exchange_type+","+results[0].stock_account+">基金名称：</span>"+results[0].fund_name+"");
					$(_pageId + "#mainShow .input_form .fund_name p:eq(1)").html("<span>可用数量：</span>"+results[0].fund_max_amount+"");
				}else{
					clearBuyMsg();
					layerUtils.iAlert(data.error_info);
				}
			}else{
				clearBuyMsg();
				layerUtils.iAlert(data.error_info);
			}
		}
	}
	
	//拆分与合并方法的定义
	function splitCombineSubmit(fundCode,exchangeType,stockAccount,entrustAmount){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var password = userInfo.password;
		var sessionid = userInfo.session_id;
		var exchange_type = exchangeType;
		var stock_account = stockAccount;
		var fund_code = fundCode;
		var fund_opertype = fundOpertype;
		var entrust_amount = entrustAmount;
		var param={				
			entrust_way:entrust_way,
			branch_no:branch_no,
			fund_account:fund_account,
			cust_code:cust_code,
			password:password,
			sessionid:sessionid,
			exchange_type:exchange_type,
			stock_account:stock_account,
			fund_code:fund_code,
			fund_opertype:fund_opertype,
			entrust_amount:entrust_amount
		};
		//请求数据
		service_fund.splitCombineSubmit(param,splitCombineSubmitCallback,{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":true,
			"tipsWords":"请等待"
		});
		function splitCombineSubmitCallback(data){
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length > 0){
					layerUtils.iAlert(data.error_info);
				}else{
					layerUtils.iAlert(data.error_info);
				}
			}else{
				layerUtils.iAlert(data.error_info);
			}
		}
	}
	
	
	function clearBuyMsg(){
		$(_pageId+"#fundCode").val("");
		$(_pageId+"#entrustAmount").val("");
		$(_pageId + "#mainShow .input_form .fund_name p:eq(0)").html("<span>基金名称：</span>--");
		$(_pageId + "#mainShow .input_form .fund_name p:eq(1)").html("<span>可用数量：</span>--");
	}
	
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("fund/fundGradingApply","account/index",{});
	}
	
	
	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId+"#entrustAmount").val("");
		$(_pageId+"#fundCode").val("");
		$(_pageId + "#mainShow .input_form .fund_name p:eq(0)").html("<span>基金名称：</span>--");
		$(_pageId + "#mainShow .input_form .fund_name p:eq(1)").html("<span>可用数量：</span>--");
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});