/**
 * 基金交易-持仓
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var layerUtils = require("layerUtils");
	var common = require("common");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var VIscroll = require("vIscroll");
	var vIscroll = {"scroll":null,"_init":false}; //上下滑动
	var service_fund = require("service_fund");
	var service_stock = require("service_stock");
    var _pageId = "#fund_fundHolding ";
    var entrustNo = ""; //撤单编号
	var exchangeType = ""; //市场类型
	var fundTotalValue = 0;//基金持仓市值
	var count = 0;//判断两个接口都查询完 的标志
	var canUseMoney = 0; //可用资金
	var assert_val = 0; //总资产
	var market_val =0; //市值
    var userInfo =null;
    /**
     * 初始化
     */
	function init(){common.hideBottomBar();
		common.bindStockEvent(_pageId); //绑定头部菜单事件
		//获取保存在本地的账户信息
	    userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		queryData();//查询数据
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			appUtils.pageInit("fund/fundHolding","account/index",{});
		});
		
		//银证转行按钮
		appUtils.bindEvent($(_pageId + " #toTrans"), function(e){
			appUtils.setSStorageInfo("whichAccount","stock_userInfo");
			appUtils.setSStorageInfo("whichPage","fund/fundHolding");
			appUtils.pageInit("fund/fundHolding","banking/transfer",{});
		},"click");
		
	}
	/**
	 * 查询持仓 和 客户资金
	 */
	function queryData(){
		entrustNo = ""; //撤单编号
		exchangeType = ""; //市场类型
		fundTotalValue = 0;//基金持仓市值
		count = 0;//判断两个接口都查询完 的标志
		canUseMoney = 0; //可用资金
		assert_val = 0; //总资产
		market_val =0; //市值
		queryFundStock();//查询客户基金持仓
		queryCapital();//客户资产查询
	}
	/**
	 * 查询客户基金持仓
	 */
	function queryFundStock(){
		$(_pageId+ ".no_data").hide();
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var password = userInfo.password;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "password":password,
			    "cust_code":cust_code
		};
		//最后一个为超时处理函数
		service_fund.queryFundData(param,queryFundStockCallBack,
		{  //传给接口的json格式数据            
		"isLastReq":true,                
		"isShowWait":true,
		"isShowOverLay":false,
		"timeOutFunc":function(){    //超时调用方法
			$(_pageId + " .hold_list").html("<h3 style=\"background:#EBE9E9\">持有基金</h3>");
			$(_pageId+ ".no_data").show();
			initVIScroll();
			if(vIscroll._init){
				vIscroll.scroll.refresh();
			}
			count ++;
			if(count == 2){
				$(_pageId + ".fund_hold ul li:eq(3) strong").text(common.numToMoneyType(Number(canUseMoney).toFixed(2)));
				//$(_pageId + ".fund_hold ul li:eq(1) strong").text(common.numToMoneyType(Number(market_val).toFixed(2)));
				$(_pageId + ".fund_hold ul li:eq(0) strong").text(common.numToMoneyType(Number(assert_val).toFixed(2)));
				count = 0;
			}
		}
	    });
	}
	/**
	 * 查询持仓数据回调
	 */
	function queryFundStockCallBack(data){
		if(data.error_no == "0"){
			if(data.results[0]){
				var results = data.results;
				creatHtml(results);
			}else{
				$(_pageId + ".fund_hold ul li:eq(2) strong").html("0"+"<span>支</span>");
				$(_pageId + ".fund_hold ul li:eq(1) strong").text("--");
				$(_pageId + " .hold_list").html("<h3 style=\"background:#EBE9E9\">持有基金</h3>");
				$(_pageId+ ".no_data").show();
			}
			initVIScroll();
		}else{
			layerUtils.iAlert(data.error_info);
			return false;
		} 
			count ++;
			if(count == 2){
				$(_pageId + ".fund_hold ul li:eq(3) strong").text(common.numToMoneyType(Number(canUseMoney).toFixed(2)));
				//$(_pageId + ".fund_hold ul li:eq(1) strong").text(common.numToMoneyType(Number(market_val).toFixed(2)));
				$(_pageId + ".fund_hold ul li:eq(0) strong").text(common.numToMoneyType(Number(assert_val).toFixed(2)));
				count = 0;
			}
	}
	/**
	 * 生成持仓页面的html
	 */
	function creatHtml(data){
		var fundNum = data.length;
		$(_pageId + ".fund_hold ul li:eq(2) strong").html(fundNum+"<span>支</span>")
		var html = "<h3>持有基金</h3>";
		var css = "";
		var maket_val = 0;
		var dividendmethod = "";//分红方式
		for(var i=0;i<data.length;i++){
			var result = data[i];
			fundTotalValue += Number(data[i].market_value);
			if(data[i].income_balance > 0){
				css = "ared";
			}else if(data[i].income_balance < 0){
				css = "agreen";
			}else{
				css = "";
			}
			if(data[i].dividendmethod == "0"){
				dividendmethod = "红利转投资";
			}else{
				dividendmethod = "现金分红";
			}
			html += "<div class=\"part\" id=\"remove\">";;
	        html +=        	"<a href=\"javascript:void(0);\" class=\"link\">"+"赎回"+"</a>";
	        html +=        	"<h5><span>"+data[i].fund_name+"</span><small>"+data[i].fund_code+"</small></h5>";
	        html +=         "<ul class=\"clearfix\">";
	        html +=          	   "<li>最新净值 <span class="+css+">"+common.numToMoneyType(Number(data[i].nav))+"</span></li>";
	        html +=                "<li>分红方式 <span>"+dividendmethod+"</span>";
//	        html +=               "<a href=\"javascript:void(0);\">赎回</a></li>"
	        html +=                "<li>基金市值 <span class="+css+">"+common.numToMoneyType(Number(data[i].market_value))+"</span></li>";
	        html +=                "<li>持有份额 <span>"+Number(data[i].enable_shares)+"</span></li>";
	        html +=        	"</ul>";
	        html += "</div>";
	        maket_val += Number(data[i].market_value);
		}
		$(_pageId + ".fund_hold ul li:eq(1) strong").text(common.numToMoneyType(Number(maket_val).toFixed(2)));
		$(_pageId + " .hold_list").html(html);
		//绑定赎回事件
		appUtils.bindEvent($(_pageId+".part .link"), function(e){
			
			
			var enable_shares = parseFloat($(this).parent().find("ul li:eq(3) span").text()).toFixed(0);
			var fund_code = $(this).parent().find("h5 small").text();
			var fund_name = $(this).parent().find("h5 span").text();
			var nav = $(this).parent().find("ul li:eq(0) span").text();
            var fundInfo = {
            	"enable_shares":enable_shares,
            	"fund_code":fund_code,
            	"fund_name":fund_name,
            	"nav":nav,
            };
			appUtils.pageInit("fund/fundHolding","fund/fundRedeem",{fundInfo:fundInfo});
			e.stopPropagation();
		},"click");
	}
	/**
	 * 资金账户查询
	 */
	function queryCapital(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var password = userInfo.password;
		var cust_code = userInfo.cust_code;//关联资产账户标志、
		var money_type = "0";  //  0：人民币，1：美元，2：港币
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "password":password,
			    "cust_code":cust_code,
			    "money_type":money_type
		};
//		$(_pageId+ ".no_data").hide();
		//最后一个为超时处理函数
		service_stock.queryFundSelect(param,queryCapitalCallback,
		{  //传给接口的json格式数据            
		"isLastReq":true,                
		"isShowWait":true,
		"isShowOverLay":false,
		"timeOutFunc":function(){    //超时调用方法
			$(_pageId+ ".no_data").show();
			initVIScroll();
			if(vIscroll._init){
				vIscroll.scroll.refresh();
			}
			count ++;
			if(count == 2){
				$(_pageId + ".fund_hold ul li:eq(3) strong").text(common.numToMoneyType(Number(canUseMoney).toFixed(2)));
				//$(_pageId + ".fund_hold ul li:eq(1) strong").text(common.numToMoneyType(Number(market_val).toFixed(2)));
				$(_pageId + ".fund_hold ul li:eq(0) strong").text(common.numToMoneyType(Number(assert_val).toFixed(2)));
				count = 0;
			}
		}
		
	    });
	}
	/**
	 * 资金账户查询回调
	 */
	function queryCapitalCallback(data){
		if (data && data!= "undefined"){
			if(data.error_no == 0){
				var results = data.results;
				canUseMoney = results[0].enable_balance;
				assert_val = results[0].assert_val;	
				market_val = results[0].market_val;
			}
			else{
				layerUtils.iAlert(data.error_info);
			}
		}
			count ++;
			if(count == 2){
				$(_pageId + ".fund_hold ul li:eq(3) strong").text(common.numToMoneyType(Number(canUseMoney).toFixed(2)));
				//$(_pageId + ".fund_hold ul li:eq(1) strong").text(common.numToMoneyType(Number(market_val).toFixed(2)));
				$(_pageId + ".fund_hold ul li:eq(0) strong").text(common.numToMoneyType(Number(assert_val).toFixed(2)));
			}
	}
	
	/**
	 * 初始化上下滑动组件
	 */
	function initVIScroll(){
		if(!vIscroll._init){
			var config = {
				"isPagingType": false,		//false表示是微博那种累加形式，true表示分页形式
				"visibleHeight": $(window).height() - $(_pageId+".top_title").height()- $(_pageId+".tab_nav").height() - 7,	//显示内容区域的高度，当isPaingType为false时传
				"container": $(_pageId+" #v_container_funds_jj"),	
				"wrapper":$(_pageId+" #v_wrapper_funds_jj"),	
				"downHandle": function() {				//下拉获取上一页数据方法
					$(_pageId + " .hold_list").html("");
					$(_pageId+ ".no_data").hide();
					queryData()//查询数据
				},
				"upHandle": function() {
				},
				"wrapperObj": null
			};
			vIscroll.scroll = new VIscroll(config); 	//初始化，需要做if(!hIscroll._init)判断
			vIscroll._init = true; 						//尽量只初始化一次，保持性能
			
		}else{
			vIscroll.scroll.refresh();
		}
		$(_pageId + ".visc_pullUp").css("display","none");//隐藏"上拉加载下一页"
	}
	/**
	 * 清理数据
	 */
	function clearMsg(){
		$(_pageId + ".fund_hold ul li:eq(2) strong").html("--"+"<span>支</span>")
		$(_pageId + " .hold_list").html("");
		$(_pageId + ".fund_hold ul li:eq(3) strong").text("--");
		$(_pageId + ".fund_hold ul li:eq(1) strong").text("--");
		var totalCustMoney = Number(canUseMoney) + Number("--");
		$(_pageId + ".fund_hold ul li:eq(0) strong").text("--");
		$(_pageId+ ".no_data").hide();
	}
	/**
	 * 销毁
	 */
	function destroy(){
		clearMsg();
		fundTotalValue = 0;//基金持仓市值
		count = 0;//判断两个接口都查询完 的标志
		canUseMoney = 0; //可用资金
		if(vIscroll._init){
			vIscroll.scroll.refresh();
		}
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("fund/fundHolding","account/index",{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});