/**
 * 基金交易-今日查询
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var common = require("common");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var layerUtils = require("layerUtils");
	var VIscroll = require("vIscroll");
	var service_fund = require("service_fund");
    var vIscroll = {"scroll":null,"_init":false};		//上下滑动
    var _pageId = "#fund_fundQueryToday ";
    var userInfo = null;
    
    /**
     * 初始化
     */
	function init(){common.hideBottomBar();
		userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		queryEntrust();
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			appUtils.pageInit("fund/fundQueryToday","fund/fundQuery",{});
		});
		
	}
	
	/**
	 * 委托查询
	 */
	function queryEntrust(){
		$(_pageId+".fund_flow").html("");
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;
		var password = userInfo.password;
		var sessionid=userInfo.session_id;
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "cust_code":cust_code,
			    "password":password,
			    "sessionid":sessionid
			};
			$(_pageId+ ".no_data").hide();
			service_fund.queryTodayTrust(param,queryEntrustCallback,
				{
				"isLastReq":true,
				"isShowWait":true,
				"isShowOverLay":false,
				"timeOutFunc":function(){
					$(_pageId+ ".no_data").show();
					initVIScroll();
					if(vIscroll._init){
						vIscroll.scroll.refresh();
					}
				}
			});
	}
	/**
	 * 委托查询回调
	 */
	function queryEntrustCallback(data){
		if (typeof(data) != "undefined" && data) {
			$(_pageId+".fund_flow").html("");
			if(data.error_no == 0){
				$(_pageId+".no_data").hide();
				var results = data.results;
				if(results.length>0 && results!= "undefined"){
					var data = "";
					for (var i=0;i<results.length;i++){
						data += queryEntrustHTML(results[i]);
					}
					$(_pageId+".fund_flow").html(data);
				}else{
					$(_pageId+".no_data").show();
				}
				if(!vIscroll._init){
					initVIScroll();
				}else{
					vIscroll.scroll.refresh();
				}
			}
			else{
				layerUtils.iAlert(data.error_info);
			}
		}
		else{
			  layerUtils.iAlert("查询失败");
		}
	}
	
	/**
	 * 委托查询HTML生成
	 */
	function queryEntrustHTML(element){
		var time = element.entrust_date + " " + element.entrust_time;
		var css = "";
		var business_flag = element.business_flag;
		if(business_flag == "17" || business_flag == "20"){
			css = "ared";
		}else if(business_flag == "21"){
			css = "agreen";
		}
        var eleHtml = "";
        eleHtml+="<div class=\"part\">";
        eleHtml+="<div class=\"title\">" +
        				"<a href=\"javascript:void(0);\">"+element.entrust_status_mame+"</a>" +
        				"<strong class="+css+">"+element.business_name+"</strong>" +
        				"<small>委托时间 "+time+"</small>" +
        			"</div>";
        eleHtml+="<dl class=\"clearfix\">";
        
        eleHtml+="	<dt>"+element.fund_name+"<small>"+element.fund_code+"</small></dt>";
        
        eleHtml+="     <dd>委托份额 <span>"+parseFloat(element.shares).toFixed(2)+"</span></dd>";
        eleHtml+="     <dd>委托金额 <span>"+parseFloat(element.balance).toFixed(2)+"</span></dd>";
        
        eleHtml+="</dl>";
        eleHtml+="  </div>";
        return eleHtml;
	}
	
	/**
	 * 初始化滑动组件
	 */
	function initVIScroll(){
		if(!vIscroll._init){
			var config = {
					"isPagingType": false,//false表示是微博那种累加形式，true表示分页形式
					"visibleHeight": $(window).height() - $(_pageId+".top_title").height()- $(_pageId+".tab_nav").height()- 6  ,//显示内容区域的高度，当isPaingType为false时传
					"container": $(_pageId+"#v_container_funds_jj"),	
					"wrapper":$(_pageId+"#v_wrapper_funds_jj"),	
					"downHandle": function() {
						queryEntrust();//下拉获取上一页数据方法
					},
					"upHandle": function() {	
						//上拉获取下一页数据方法
					},
					"wrapperObj": null
			};
			vIscroll.scroll = new VIscroll(config); 	//初始化，需要做if(!hIscroll._init)判断
			vIscroll._init = true;
		} else {
			vIscroll.scroll.refresh();
		}
		$(_pageId+ ".visc_pullUp").hide();
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId+".fund_flow").html("");
		if(vIscroll._init){
			vIscroll.scroll.refresh();
		}
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("fund/fundQueryToday","fund/fundQuery",{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});