/**
 * 基金交易-赎回
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var layerUtils = require("layerUtils");
	var validata = require("validatorUtil");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var common = require("common");
	var service_fund = require("service_fund");
    var _pageId = "#fund_fundRedeem ";
    var userInfo= null;
   
    /**
     * 初始化
     */
	function init(){common.hideBottomBar();
		common.systemKeybord(); // 解禁系统键盘
		common.bindStockEvent(_pageId); //绑定头部菜单事件
		userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		var fundInfo = appUtils.getPageParam("fundInfo");
		if(fundInfo){
			$(_pageId+"#fundList p").html("<strong>"+fundInfo.fund_code+"</strong>"+fundInfo.fund_name);
			$(_pageId+"#fundNav").val(fundInfo.nav); //基金净值
			$(_pageId+".input_form .max strong").text(fundInfo.enable_shares); //可赎份额数量
		}
		//查询可赎回基金(赎回基金的下拉选择需要从后台获取数据)
		queryHoldingsQuery();
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			appUtils.pageInit("fund/fundRedeem","account/index",{});
		});
		
		//基金下拉框
		appUtils.bindEvent($(_pageId + "#fundList"), function(e){
			$(_pageId+"#fundList ul").slideToggle("fast");
			e.stopPropagation();	// 阻止冒泡
		});
		
		//点击其他地方隐藏下拉框
		appUtils.bindEvent($(_pageId),function(e){
			$(_pageId+"#fundList ul").hide();
			e.stopPropagation();	// 阻止冒泡
		});
		
		//赎回
		appUtils.bindEvent($(_pageId + ".input_form .ce_btn"), function(e){
			submitOrderFund();
			e.stopPropagation();
		});
	}
    
	/**
	 * 持仓查询
	 * 调用两个接口 股份查询，资金查询
	 */
	function queryHoldingsQuery(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	//分支机构
		var fund_account = userInfo.fund_account;	//资产账户
		var cust_code = userInfo.cust_code;	//客户代码
		var password = userInfo.password;
		var sessionid="";
		var fund_company ="";
		var fund_code ="";
		var param={
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"sessionid":sessionid,
				"fund_company":fund_company,
				"fund_code":fund_code,
		};
		service_fund.queryFundData(param,queryFundDataCallback);
	}

	//持仓查询回调方法
	function queryFundDataCallback(data){
		if (typeof(data) != undefined && typeof(data) != null) {
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length > 0){
					var listHtml = "<ul style=\"display:none;\">";
					for(var i = 0;i < results.length; i++) {
						listHtml += "<li><a href=\"javascript:void(0);\"><strong>"+results[i].fund_code+"</strong>"+results[i].fund_name+"</a>";
						listHtml +=	"<span style=\"display:none;\">"+results[i].enable_shares+"</span><span style=\"display:none;\">"+results[i].nav+"</span></li>";
					};
					listHtml+="</ul>";
					$(_pageId+"#fundList").append(listHtml);
					//选中赎回基金的下拉（回调中可直接向当前一样直接绑定事件，如果在事件绑定中是不能这样绑定事件的）
					appUtils.bindEvent($(_pageId+"#fundList ul li"),function(){
						//基金净值
						var fundNav;
						if(($(this).find("span:eq(1)").text()) != "" && ($(this).find("span:eq(1)").text()) != null){
							fundNav = parseFloat($(this).find("span:eq(1)").text()).toFixed(2);
						}else{
							fundNav = 0;
						}
						var numMax = parseFloat($(this).find("span:eq(0)").text()).toFixed(0);
						$(_pageId+"#fundList p").html($(this).find("a").html());
						$(_pageId+"#fundNav").val(fundNav); //基金净值
		    			$(_pageId+".input_form .max strong").text(numMax); //可赎份额数量
					});
					
				}else{
					$(_pageId+"#fundList p").text("暂无可赎回基金");
					$(_pageId+"#fundList").addClass("deleteBefore");
				}
			}else{
				  layerUtils.iAlert(data.error_info);
			}
		}else{
			  layerUtils.iAlert("股份查询失败");
		}
	}
	
	//下单提交基金
	function submitOrderFund(){
		var numMax =$(_pageId+".input_form .max strong").text();
		var fundNum = $(_pageId+"#fundNum").val();
		var fundNav = $(_pageId+"#fundNav").val();
		if(validata.isEmpty(fundNav)){
			layerUtils.iMsg(-1,"基金代码不能为空");
			return false;
		}
		if(validata.isEmpty(numMax)|| numMax=="0" || numMax=="--"){
			layerUtils.iMsg(-1,"可赎份额为0");
			return false;
		}
		if(validata.isEmpty(fundNum)){
			layerUtils.iMsg(-1,"赎回份额不能为空");
			return false;
		}else if(Number(fundNum)>Number(numMax)){
			layerUtils.iMsg(-1,"赎回份额不能大于可赎份额");
			return false;
		}
		var fundCode = $(_pageId+"#fundList p strong").text();
		var tipStr ="<div class=\"pop_header\">";
		tipStr+="<h3>基金赎回</h3>";
		tipStr+="</div>";
		tipStr+="<div class=\"pop_main\">";
		tipStr+="<ul>";
		tipStr+="    <li>基金名称 <em>"+$(_pageId+"#fundList p").text()+"</em></li>";
		tipStr+="    <li>基金代码 <strong>"+fundCode+"</strong></li>";
		tipStr+="    <li>赎回份额 <strong>"+fundNum+"</strong></li>";
		tipStr+="</ul>";
		tipStr+="  </div>";
		common.btnConfirm(tipStr,function success(){
			var entrust_way = global.entrust_way; // 委托方式  在configuration配置
			var branch_no  = userInfo.branch_no;      //分支机构
			var fund_account = userInfo.fund_account; //资金账号
			var cust_code = userInfo.cust_code;       //客户编号
			var password = userInfo.password;         //密码
			var sessionid = userInfo.session_id;      //会话号
			var fund_company = "";                    //基金公司
			var fund_code = fundCode; //基金代码
			var amount = fundNum;      //赎回份额
			var exceedflag = 0;                            //巨额方式
			var param = {
					"entrust_way" : entrust_way,
					"branch_no" : branch_no,
					"fund_account" : fund_account,
					"cust_code" : cust_code,
					"password" : password,
					"sessionid" :sessionid,
					"fund_company" : fund_company,
					"fund_code" : fund_code,
					"amount" : amount,
					"exceedflag" : exceedflag
			};
			service_fund.submitOrder(param,function(data){
				if(data.error_no ==0){
					layerUtils.iAlert("赎回成功");
					clearBuyMsg();
				}else{
					clearBuyMsg();
					layerUtils.iAlert(data.error_info);
				}
			});
		},function fail(){
			
		});
	}
	
	/**
	 * 重置页面数据  
	 */
	function clearBuyMsg(){
		$(_pageId+".input_form .max strong").text("--");
		$(_pageId+"#fundNum").val("");
		$(_pageId+"#fundNav").val("");
		$(_pageId+"#fundList ul").hide();
		$(_pageId+"#fundList p").text("请选择");
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		clearBuyMsg();
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("fund/fundRedeem","account/index",{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});