/**
 * 基金交易-认购
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var layerUtils = require("layerUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var common = require("common");
	var external = require("external");
	var service_fund = require("service_fund"); 
    var _pageId = "#fund_fundShareOutBonus ";
    var userInfo = null;
    
    /**
     * 初始化
     */
	function init(){common.hideBottomBar();
		var height_table = $(window).height() - $(_pageId+".top_title").height() - 27;
        $(_pageId+".fund_table").height(height_table);
		userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		queryFundShareOutBonus();
    }
	
	function queryFundShareOutBonus(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var password = userInfo.password;
		var sessionid = userInfo.session_id;
		var fund_status = "1"; //基金状态  0：正常开放，1：认购时期，2：发行成功，3：发行失败，
		var fund_company = "";
		var fund_code = "";
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "password":password,
			    "sessionid":sessionid,
			    "cust_code":cust_code,
			    "fund_status":fund_status,
			    "fund_company":fund_company,
			    "fund_code":fund_code
		};
		service_fund.queryFundShareOutBonus(param,queryFundShareOutBonusCallback,{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":true,
			"tipsWords":"请等待..."
		});
		function queryFundShareOutBonusCallback(data){
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length > 0){
					$(_pageId+".no_data").hide();;
					var htmlData = "";
					for (var i=0;i<results.length;i++){
						htmlData += queryFundShareOutBonusHTML(results[i]);
					}
					$(_pageId + ".main .fund_table3").html(htmlData);
					//动态绑定事件
					appUtils.preBindEvent($(_pageId),".fund_table3 .part .switch ul li", function(e){
						if($(this).attr("class") == "active"){
							return;
						}else{
//							$(this).addClass("active").siblings().removeClass("active");
							//获取基金代码
							var fundCode = $(this).parent().parent().siblings("dt").find("small").text();
							var dividendmethod = "";
							if($(this).index() == "0"){   //分红标志,0：红利转投   1：现金分红
								dividendmethod = "1";
							}else{
								dividendmethod = "0";
							}
							
							var promptContent = "";
							if(dividendmethod == "0"){
								promptContent = "红利转投";
							}else if(dividendmethod == "1"){
								promptContent = "现金分红";
							}
							
							layerUtils.iConfirm("您要设置基金分红方式为:"+promptContent+"?",function(){
								//分红方式的设置(调接口)
								var entrust_way= global.entrust_way; // 委托方式  在configuration配置
								var branch_no = userInfo.branch_no;	
								var fund_account = userInfo.fund_account;
								var cust_code = userInfo.cust_code;//关联资产账户标志
								var password = userInfo.password;
								var sessionid = userInfo.session_id;
								var fund_status = "1"; //基金状态  0：正常开放，1：认购时期，2：发行成功，3：发行失败，
								var fund_company = "";
								var fund_code = fundCode;
								var param={				
										"entrust_way":entrust_way,
									    "branch_no":branch_no,
									    "fund_account":fund_account,
									    "password":password,
									    "sessionid":sessionid,
									    "cust_code":cust_code,
									    "fund_status":fund_status,
									    "fund_company":fund_company,
									    "fund_code":fund_code,
									    "dividendmethod":dividendmethod
								};
								service_fund.shareOutBonusSetting(param,shareOutBonusSettingCallback,{
									"isLastReq":true,
									"isShowWait":true,
									"isShowOverLay":true,
									"tipsWords":"请等待..."
								});
								function shareOutBonusSettingCallback(data){
									if(data.error_no == 0){
										var results = data.results;
										if(results && results.length > 0){
											//重新请求数据
											queryFundShareOutBonus();
										}else{
											layerUtils.iAlert(data.error_info);
										}
									}else{
										layerUtils.iAlert(data.error_info);
									}
								}
							},function(){
								
							},"确定","取消");
						}
						e.stopPropagation();
					});
				}else{
					$(_pageId+".no_data").show();
//					layerUtils.iAlert(data.error_info);
				}
			}else{
				layerUtils.iAlert(data.error_info);
			}
		}
		function queryFundShareOutBonusHTML(results){
			var eleHtml = "";
			eleHtml += "<dl class='part clearfix'>";
			eleHtml += "<dt>"+results.fund_name+"<small>"+results.fund_code+"</small></dt>";
			eleHtml += "<dd>";
			eleHtml += "<p><span>最新净值</span><em class='ared'>"+results.enable_shares+"</em></p>";
			eleHtml += "<p><span>基金市值</span><em class='ared icon'>"+results.market_value+"</em></p>";
			eleHtml += "<p><span>持有份额</span><em>"+results.enable_shares+"</em></p>";
			eleHtml += "<p><span>现金<br>分红</span></p>";
			eleHtml += "</dd>";
			eleHtml += "<dd class='switch'>";
			eleHtml += "<ul>";
			if(results.dividendmethod == "0"){
				eleHtml += "<li><a href='javascript:void(0);'><span>现金分红</span></a></li>";
				eleHtml += "<li class='active'><a href='javascript:void(0);'><span>红利转投</span></a></li>";
			}else{
				eleHtml += "<li class='active'><a href='javascript:void(0);'><span>现金分红</span></a></li>";
				eleHtml += "<li><a href='javascript:void(0);'><span>红利转投</span></a></li>";
			}
			eleHtml += "</ul>";
			eleHtml += "</dd>";
			eleHtml += "</dl>";
			return eleHtml;
		}
	}
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			appUtils.pageInit("fund/fundShareOutBonus","fund/fundQuery",{});
			e.stopPropagation();
		});
	}
	
	/**
	 * 重置页面数据  
	 */
	function clearBuyMsg(){
		
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		
	}

	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("fund/fundShareOutBonus","fund/fundQuery",{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});