/**
 * 基金交易-认购
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var layerUtils = require("layerUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var common = require("common");
	var external = require("external");
	var validata = require("validatorUtil");
	var service_stock = require("service_stock");
	var service_fund = require("service_fund"); 
    var _pageId = "#fund_fundSubscribe ";
    var userInfo = null;
    var fund_code = "";
	var balance = "";
	flagFundAccount = true;   //用户是否开通基金账户
    var fundCompany = "";
    
    /**
     * 初始化
     */
	function init(){common.hideBottomBar();
		var height_table = $(window).height() - $(_pageId+".header").height() - $(_pageId+".tab_nav").height() - $(_pageId+".input_form").height() - 15 - 27;
        $(_pageId+".fund_table").height(height_table);   //给持仓数据添加高度
		clearBuyMsg();
		common.systemKeybord(); // 解禁系统键盘
		common.bindStockEvent(_pageId); //绑定头部菜单事件
		userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		queryCapital();//资金账户查询
		queryCanSubscribe();//查询可认购基金
		//在pc端可使用键盘输入股票代码（方便调试）
		if(gconfig.platform=="0"){ 
			$(_pageId+"#fundCode").attr("readonly",false);
		}	
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			appUtils.pageInit("fund/fundSubscribe","account/index",{});
			e.stopPropagation();
		});
		
		//基金代码输入框监听（PC端）
		appUtils.bindEvent($(_pageId+"#fundCode"), function(e){
			if($(_pageId+"#fundCode").val().length > 6){
				clearBuyMsg();
			}
			
			var fundCode = $(this).val();
			if(fundCode.length == 6){
				//调用服务层获取数据
				getFundList(fundCode);
			}else if(fundCode.length > 6){
				$(this).val(fundCode.substring(0,6));
			}else if(fundCode.length < 6){
				//重置页面的数据
//				clearBuyMsg();
			}
			$(_pageId+".trade_form .input_box .stat").hide();
			e.stopPropagation();
		},"keyup");
		
		//基金代码输入框调用原生键盘（Android或者是iOS）
		appUtils.bindEvent($(_pageId+"#fundCode"),function(e){
			if($(_pageId+"#fundCode").val().length > 6){
				clearBuyMsg();
			}
			window.customKeyboardEvent = {
					keyBoardFinishFunction: function(){},
					//原生键盘回调
					keyBoardInputFunction: function(){
						var fundCode = $(_pageId+"#fundCode").val();
						if(fundCode.length == 6){
							//调用服务层获取数据
							getFundList(fundCode);
						}else if(fundCode.length > 6){
							$(this).val(fundCode.substring(0,6));
						}
					}
			};
			external.callMessage({"moduleName":"trade","funcNo": "50210", "pageId":"fund_fundSubscribe", "eleId":"fundCode", "doneLable":"done", "keyboardType":"2"});
			e.stopPropagation();
		},"click");
		
		//失去焦点关闭原生键盘
		appUtils.bindEvent($(_pageId+"#fundCode"),function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50211"});
			e.stopPropagation();
		},"blur");
		
		
		//认购
		appUtils.bindEvent($(_pageId + ".input_form .ce_btn"), function(e){
			vailSubmitOrder();
			e.stopPropagation();
		});
	}
	
	//查询可认购基金方法的定义
	function queryCanSubscribe(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var password = userInfo.password;
		var sessionid = userInfo.session_id;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var fund_status = "1"; //基金状态  0：正常开放，1：认购时期，2：发行成功，3：发行失败，
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "password":password,
			    "sessionid":sessionid,
			    "cust_code":cust_code,
			    "fund_status":fund_status
		};
		
		//最后一个为超时处理函数
		service_fund.queryCanSubscribe(param,queryCanSubscribeCallback,{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":true,
			"tipsWords":"正在查询基金信息"
		});
	}
	//查询可认购基金回调
	function queryCanSubscribeCallback(data){
		if(typeof(data) != undefined && typeof(data) != null) {
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length > 0){
						if(data.error_no == 0){
							var results = data.results;
							if(results && results.length>0){
								var data = "<tr><th scope=\"col\">基金名称/代码</th> <th scope=\"col\">基金净值</th><th scope=\"col\">可用资金</th></tr>";
								
								for (var i=0;i<results.length;i++){ 
									 //HTML生成
									 data += queryPositionHTML_stock(results[i]);
								}
								
								function queryPositionHTML_stock(element){
							        var eleHtml = "";
							        eleHtml+="<tr id="+element.fund_company+">";
							        eleHtml+="<td style='width:150px;text-align:left;font-size:10px'><small>("+element.fund_code +")</small>"+element.fund_name +"</td>";
							        eleHtml+="<td>"+element.nav +"</td>";
							        eleHtml+="<td>"+$(_pageId + ".input_form .max strong").text()+"</td>";
							        eleHtml+="</tr>";
							        return eleHtml;
								}
								
								//将生成的HTML添加到指定的地方
								$(_pageId+".fund_table .ce_table").html(data);
								
								appUtils.bindEvent($(_pageId+".fund_table .ce_table tr"), function(e){
									clearBuyMsg();
									var fundName = $(this).find("td:eq(0)").text().replace("(","").replace(")","");
									$(_pageId + "#fundList #fundCode").val(fundName);
									$(_pageId + ".input_form #fundNav").val($(this).find("td:eq(1)").text());
									fundCompany = $(this).attr("id");
									e.stopPropagation();
								},"click");
							}
						}
					}
			}else{
				  layerUtils.iAlert(data.error_info);
			}
		}else{
			  layerUtils.iAlert("查询失败");
		}
	}

	
	/**
	 * 资金账户查询方法的定义
	 */
	function queryCapital(){
		//获取保存在本地的账户信息
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var password = userInfo.password;
		var money_type = "0";  //  0：人民币，1：美元，2：港币
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "password":password,
			    "cust_code":cust_code,
			    "money_type":money_type
		};
		//最后一个为超时处理函数
		service_stock.queryFundSelect(param,queryCapitalCallback,{
			"isLastReq":false,
			"isShowWait":false,
			"isShowOverLay":false
		});
	}
	
	/**
	 * 资金账户查询回调
	 */
	function queryCapitalCallback(data){
		if (data && data!= "undefined"){
			if(data.error_no == 0){
				var results = data.results;
				if(results && results!= "undefined"){
					$(_pageId+".input_form .max strong").text(common.numToMoneyType(""+Number(results[0].enable_balance).toFixed(2)+""));//可用
				}else{
					$(_pageId+".input_form .max strong").text("--");//可用
				}
			}
			else{
				layerUtils.iAlert(data.error_info);
			}
		}
	}
	
	/**
	 * 下单验证
	 * */
	function vailSubmitOrder(){
		//基金净值
		var fundNav = $(_pageId+"#fundNav").val();
		if(validata.isEmpty(fundNav)){
			layerUtils.iMsg(-1,"基金代码不能为空");
			return false;
		}
		//认购金额
		var now_price = $(_pageId+"#fundPrice").val();
		//当前最多可认购
		var can_buy = $(_pageId+".input_form .max strong").text();
		
		if($.trim(now_price).length<=0){
			layerUtils.iMsg(-1,"请输入认购金额");
			return false;
		}else if(now_price=="0"){
			layerUtils.iMsg(-1,"认购金额不能为0");
			return false;
		}
//		else if(Number(now_price) < 1000){
//			layerUtils.iMsg(-1,"认购金额不能少于1000");
//			return false;
//		}
		else if(!validata.isNumberFloat(now_price)||parseFloat(now_price)<0){
			layerUtils.iMsg(-1,"请正确输入认购金额");
			return false;
		}else if(Number(now_price)>Number(can_buy)){
			layerUtils.iMsg(-1,"认购金额超过可用金额");
			return false;
		}
		
		var fundCode = $(_pageId+"#fundCode").val().substring(0,6);
		var fundName = $(_pageId+"#fundCode").val().substring(6);
		var tipStr ="<div class=\"pop_header\">";
		tipStr+="<h3>基金认购</h3>";
		tipStr+="</div>";
		tipStr+="<div class=\"pop_main\">";
		tipStr+="<ul>";
		tipStr+="    <li>基金名称 <em>"+fundName+"</em></li>";
		tipStr+="    <li>基金代码 <strong>"+fundCode+"</strong></li>";
		tipStr+="    <li>认购金额 <strong>"+now_price+"</strong></li>";
		tipStr+="</ul>";
		tipStr+="  </div>";
		common.btnConfirm(tipStr,function success(){
			fund_code = fundCode;
			balance = now_price;
			//判断是否开户
			openFundAccount();
		},function fail(){
			
		});
	}
	
	//判断是否开户方法的定义
	function openFundAccount(){
		var cust_code = userInfo.cust_code;	//客户代码
		var fund_account = userInfo.fund_account;	//资产账户
		var branch_no  = userInfo.branch_no;	//分支机构
		var sessionid=userInfo.sessionid;
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var password= userInfo.password;
		var param = {
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"sessionid":sessionid,
				"fund_code":fund_code
			};
		service_fund.openFundAccount(param,getOpenFundAccountCallBack,{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":true,
			"tipsWords":"请等待"
		});
	}
	function getOpenFundAccountCallBack(data){
		if(data.error_no == 0){
			var results = data.results;
			
			console.log("是否开通基金账户："+results[0].flag);
			
			if(results[0].flag == "1"){   //表示已经开通账户
				flagFundAccount = true;
				riskAssessment();
			}else if(results[0].flag == "0"){
				flagFundAccount = false;
				riskAssessment();
			}
		}else{
			clearBuyMsg();
			layerUtils.iAlert(data.error_info);
		}
	}
	
	//判断用户是否做过风险测评
	function riskAssessment(){
		var cust_code = userInfo.cust_code;	//客户代码
		var fund_account = userInfo.fund_account;	//资产账户
		var branch_no  = userInfo.branch_no;	//分支机构
		var sessionid=userInfo.sessionid;
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var password= userInfo.password;
		var param = {
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"sessionid":sessionid,
				"fund_code":fund_code
			};
		service_fund.riskAssessment(param,getriskAssessmentCallBack,{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":true,
			"tipsWords":"请等待"}
		);
	}
	function getriskAssessmentCallBack(data){
		if(data.error_no == 0){
			var results = data.results;
			
			console.log("是否做过风险测评："+results[0].flag);
			
			if(results[0].flag == "1"){   //表示已经做过风险测评
				if(flagFundAccount == true){
					SubScriptionBuy();
				}else{   //表示做过了基金风险测评但是没有开通基金账户
					//调开户接口进行开户
					layerUtils.iConfirm("您还未开通基金账户,是否现在开通？",function(){
						//显示风险揭示书
						var url = "https://tianxia.cindasc.com:8081/servlet/json?funcNo=1004179&agree_no=135";
						appUtils.invokeServer(url, {}, function(results){
							var resutlt = results.results[0];
							var tipStr ="<div class=\"pop_header\">";
							tipStr+="<h3>"+resutlt.agree_name+"</h3>";
							tipStr+="</div>";
							tipStr+="<div class=\"pop_main\" style='height:180px;overflow-y:scroll;'>";
							tipStr+="<ul>";
							tipStr+="    <li><em>"+resutlt.content+"</em></li>";
							tipStr+="</ul>";
							tipStr+="</div>";
							common.btnConfirm(tipStr,function(){
								//调用方法开通基金账户
								fundAccount();
							},function(){
								return;
							},"接受","取消");
						});
						//调用方法开通基金账户
//						fundAccount();
					},function(){
						
					},"开通","取消");
				}
			
			//表示没有做过风险测评
			}else{
				layerUtils.iConfirm("您还未做风险测评,现在进行风险测评？",function(){
					//到风险测评页面
					appUtils.pageInit("fund/fundSubscribe","fund/assessmentRisk",{"param":"fund/fundSubscribe"});
				},function(){
					
				},"风险测评","取消");
			} 
		}else{
			clearBuyMsg();
			layerUtils.iAlert(data.error_info);
		}
	}
	
	//基金认购方法的定义
	function SubScriptionBuy(){
		var cust_code = userInfo.cust_code;	//客户代码
		var fund_account = userInfo.fund_account;	//资产账户
		var branch_no  = userInfo.branch_no;	//分支机构
		var sessionid=userInfo.sessionid;
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var password= userInfo.password;
		var amount="";
		var fund_company="";
		var flag = "0";   //是否强制下单标识，默认就是0
		var param = {
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"sessionid":sessionid,
//				"fund_company":fund_company,
				"fund_code":fund_code,
				"flag":flag,   //判断是否开户 
				"amount":amount,
				"balance":balance,
			};
		service_fund.getSubScriptionBuy(param,getBuyCallBack,{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":true,
			"tipsWords":"请等待"}
		);
	}
	
	//认购回调
	function getBuyCallBack(data){
		//表示客户开通了基金公司
		if(data.error_no == 0){ 
			var results = data.results;
			if(results){
				$(_pageId+"#fundPrice").val("");
				layerUtils.iAlert(data.error_info);
				queryCapital();
			}
		}else if(data.error_no == "-1"){   //表示强制认购
			layerUtils.iConfirm(data.error_info,function(){
				var cust_code = userInfo.cust_code;	//客户代码
				var fund_account = userInfo.fund_account;	//资产账户
				var branch_no  = userInfo.branch_no;	//分支机构
				var sessionid=userInfo.sessionid;
				var entrust_way= global.entrust_way; // 委托方式  在configuration配置
				var password= userInfo.password;
				var amount="";
				var flag = "1";   //是否强制下单标识，默认就是0
				var param = {
						"entrust_way":entrust_way,
						"branch_no":branch_no,
						"fund_account":fund_account,
						"cust_code":cust_code,
						"password":password,
						"sessionid":sessionid,
	//						"fund_company":fundCompany,
						"fund_code":fund_code,
						"flag":flag,   //判断是否开户 
						"amount":amount,
						"balance":balance,
					};
				service_fund.getSubScriptionBuy(param,getBuyCallBack,{
					"isLastReq":true,
					"isShowWait":true,
					"isShowOverLay":true,
					"tipsWords":"请等待"}
				);
			},function(){
				
			},"认购","取消");
		}else{
			clearBuyMsg();
			layerUtils.iAlert(data.error_info);
		}
	}
	
	//开通基金账户
	function fundAccount(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no  = userInfo.branch_no;	//分支机构
		var fund_account = userInfo.fund_account;	//资产账户
		var cust_code = userInfo.cust_code;	//客户代码
		var password= userInfo.password;
		var sessionid=userInfo.sessionid;
		var fund_company = fundCompany;   //基金公司代码（必传）
		var stock_account = "";
		var flag = "1";  
		
		var param = {
			"entrust_way":entrust_way,
			"branch_no":branch_no,
			"fund_account":fund_account,
			"cust_code":cust_code,
			"password":password,
			"sessionid":sessionid,
			"fund_company":fund_company,
			"stock_account":stock_account,
			"flag":flag
		};
		service_fund.fundAccount(param,fundAccountCallBack,{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":true,
			"tipsWords":"请等待"}
		);
	}
	
	//开通基金账户回调
	function fundAccountCallBack(data){
		if(data.error_no == 0){
			var results = data.results;
			if(results){
				layerUtils.iConfirm("基金账户成功开通,是否继续认购?",function(){
					SubScriptionBuy();   //继续进行认购
				},function(){
					
				},"认购","取消");
			}
		}else{
			clearBuyMsg();
			layerUtils.iAlert(data.error_info);
		}
	}
	
	
	/**
	 * 获取基金列表（根据用户输入的基金代码得到相对应的信息）
	 * */
	function getFundList(fundStr){
		if(fundStr!= "" && fundStr.length == 6){
			$(_pageId+"#fundName").val("");
			$(_pageId+"#fundNav").val("");
			var entrust_way= global.entrust_way; // 委托方式  在configuration配置
			var fund_code = fundStr;
			var fund_company="";;
			var param = {
					"entrust_way":entrust_way,
					"fund_company":fund_company,
					"fund_code":fund_code
			};
			service_fund.getFundInfo(param,getFundInfoBack);
		}	
	}
	
	function getFundInfoBack(data){
		if(data.error_no == 0){
			var results = data.results;
			if(results && results.length > 0){
				 fundCompany = results[0].fund_company;   //基金公司代码
				 var nav = results[0].nav != "" ? results[0].nav : "0";   //三目运算符得到基金净值
				 var codeName = results[0].fund_code + results[0].fund_name;
				 $(_pageId+"#fundCode").val(codeName);
				 $(_pageId+"#fundNav").val(nav+"元");   //基金净值
			}
			else{
				layerUtils.iAlert("没有查询到对应的基金");
			}
		}else{
			layerUtils.iAlert(data.error_info);
		}
	}
	
	
	/**
	 * 重置页面数据  
	 */
	function clearBuyMsg(){
		$(_pageId+"#fundCode").val("");
		$(_pageId+"#fundPrice").val("");
		$(_pageId+"#fundNav").val("");
//		$(_pageId+".fund_table .ce_table").html("");
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		 clearBuyMsg();
		 $(_pageId+".input_form .max strong").text("--");
	}

	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("fund/fundSubscribe","account/index",{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});