/**
 * 港股交易-撤单
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var layerUtils = require("layerUtils");
	var common = require("common");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var VIscroll = require("vIscroll");
	var vIscroll = {"scroll":null,"_init":false}; //上下滑动
	var service_ggt = require("service_ggt");
    var _pageId = "#ggt_ggtCancel ";
    var entrustNo = ""; //撤单编号
	var exchangeType = ""; //市场类型
    var userInfo = null;
    /**
     * 初始化
     */
	function init(){common.hideBottomBar();
		common.bindStockEvent(_pageId); //绑定头部菜单事件
		userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		queryCancellation(); //可撤单查询
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			appUtils.pageInit("ggt/ggtCancel","account/index",{});
		});
		//撤单取消
		appUtils.bindEvent($(_pageId + ".pop_footer .pop_btn a:eq(0)"), function(e){
			$(_pageId+".backdrop").hide();
			$(_pageId+".pop_box").hide();
		});
		//撤单确认
		appUtils.bindEvent($(_pageId + ".pop_footer .pop_btn a:eq(1)"), function(e){
			$(_pageId+".backdrop").hide();
			$(_pageId+".pop_box").hide();
			Cancellation();//撤单提交
		});
	}
    
	/**
	 * 可撤单查询
	 */
	function queryCancellation(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;
		var password = userInfo.password;
		var sessionid = userInfo.session_id;
		var param={				
			"entrust_way":entrust_way,
		    "branch_no":branch_no,
		    "fund_account":fund_account,
		    "cust_code":cust_code,
		    "password":password,
		    "sessionid":sessionid
		};
		//每次查询前,先将暂无数据隐藏
		$(_pageId+ ".no_data").hide();
		//最后一个函数为超时函数,在超时后,显示暂无数据,并且初始化滑动组件
		service_ggt.queryTodayTrusts_ggt(param,queryTrustDataCallback,
		{  //传给接口的json格式数据            
			"isLastReq":true,                
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){    //超时调用方法
				$(_pageId+ ".no_data").show();
				initVIScroll();
				if(vIscroll._init){
					vIscroll.scroll.refresh();
				}
	        }
		});
	}
	
	/**
	 * 可撤单查询回调
	 */
	function queryTrustDataCallback(data){
		if (typeof(data) != undefined && typeof(data) != null) {
			$(_pageId+".cancel_order").html("");
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length>0){
					var data = "";
					for (var i=0;i<results.length;i++){
						data += queryTrustDataHTML(results[i]);
					}
					$(_pageId+".cancel_order").html(data);
					//撤单事件
					appUtils.bindEvent($(_pageId+".cancel_order #cancel"), function(e){
						var entrust_no = $(this).parent().parent().attr("data-id");
						var exchange_type = $(this).attr("data-id");
						isCancellation($(this).parent().parent(),entrust_no,exchange_type);
						e.stopPropagation();
					},"click");
				}else{
					$(_pageId+ ".no_data").show();
					$(_pageId+ ".visc_pullUp").hide();
				}
				if(!vIscroll._init){
					initVIScroll();
				}else{
					vIscroll.scroll.refresh();
				}
			}
			else{
				layerUtils.iAlert(data.error_info);
			}
		}
		else{
			  layerUtils.iAlert("查询失败");
		}
	}
	/**
	 * 可撤单查询HTML生成
	 */
	function queryTrustDataHTML(element){
		var css = "";
		var entrust_name = element.entrust_name;
		if(entrust_name == "委托买入"){
			css = "ared";
		}else if(entrust_name == "委托卖出"){
			css = "agreen";
		}
		
		var eleHtml = "";
        eleHtml+="<div class=\"part\" data-id="+element.entrust_no+">";
        eleHtml+="<div class=\"title\"><span class=\""+css+"\">"+entrust_name+"</span><p>"+element.stock_name+"</p><small>"+element.stock_code+"</small></div>";
        eleHtml+="<div class=\"value\">";
        eleHtml+="<a href=\"javascript:void(0)\" id=\"cancel\" data-id="+element.exchange_type+">撤单</a>";
        eleHtml+="<span class=\"time\">"+element.entrust_time+"</span>";
        eleHtml+="<ul>";
        eleHtml+="<li>委托价 <span>"+Number(element.entrust_price).toFixed(3)+"</span></li>";
        eleHtml+="<li>委托数 <span>"+element.entrust_amount+"</span></li>";
        eleHtml+="<li>成交价 <span>"+Number(element.business_price).toFixed(3)+"</span></li>";
        eleHtml+="<li>汇率<span>"+element.exchange_rate+"</span></li>";
        eleHtml+="</ul></div></div>";
        return eleHtml;
	}
	/**
	 * 确定撤单
	 */
	function isCancellation(dom,entrust_no,exchange_type){
		entrustNo = entrust_no;
		exchangeType = exchange_type;
		$(_pageId+".backdrop").show();
		$(_pageId+".pop_box").show();
		$(_pageId+".pop_box .pop_main ul li:eq(0) em").text(dom.find("p").text());
		$(_pageId+".pop_box .pop_main ul li:eq(0) strong").text(dom.find("small").text());
		$(_pageId+".pop_box .pop_main ul li:eq(1) em").text(dom.find("span:eq(0)").text());
		$(_pageId+".pop_box .pop_main ul li:eq(2) strong").text(dom.find("li:eq(0) span").text());
		$(_pageId+".pop_box .pop_main ul li:eq(3) strong").text(dom.find("li:eq(1) span").text());
		$(_pageId+".pop_box .pop_main ul li:eq(4) strong").text(dom.find("li:eq(3) span").text());
	}
	/**
	 * 确定撤单
	 */
	function Cancellation(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;//
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var sessionid = userInfo.session_id;
		var password = userInfo.password;;
		var batch_flag = "0";
		var entrust_no = entrustNo;
		var param={				
			"entrust_way":entrust_way,
		    "branch_no":branch_no,
		    "fund_account":fund_account,
		    "cust_code":cust_code,
		    "password":password,
		    "sessionid":sessionid,
		    "entrust_no":entrust_no,
		    "batch_flag":batch_flag
		};
		service_ggt.postCancelOrder_ggt(param,postCancelOrderCallback);
	}
    //确定撤单回调
	function postCancelOrderCallback(data){
		if (typeof data != "undefined" && data != null) {
			if (data.error_no == 0) {	
				if(typeof data.results[0] != "undefined" && data.results[0] != null ){
					layerUtils.iAlert("撤单成功");
					queryCancellation();//刷新页面重新加载数据
				}
			}
			else{  
				//layerUtils.iAlert("<div style=\"display:block;text-align:center;padding:0 16px;font-size:16px;word-break:break-all;\">"+data.error_info+"</div>");
				layerUtils.iAlert(data.error_info);
			}
		}
		else{
			layerUtils.iAlert("撤单失败");
		}
	}
	
	/**
	 * 初始化上下滑动组件
	 */
	function initVIScroll(){
		if(!vIscroll._init){
			var config = {
				"isPagingType": false,		//false表示是微博那种累加形式，true表示分页形式
				"visibleHeight": $(window).height() - $(_pageId+".top_title").height()- $(_pageId+".tab_nav").height() - 6   ,//显示内容区域的高度，当isPaingType为false时传
				"container": $(_pageId+" #v_container_funds_jj"),	
				"wrapper":$(_pageId+" #v_wrapper_funds_jj"),	
				"downHandle": function() {				//下拉获取上一页数据方法
					queryCancellation();
				},
				"upHandle": function() {
				},
				"wrapperObj": null
			};
			vIscroll.scroll = new VIscroll(config); 	//初始化，需要做if(!hIscroll._init)判断
			vIscroll._init = true; 						//尽量只初始化一次，保持性能
			
		}else{
			vIscroll.scroll.refresh();
		}
		$(_pageId + ".visc_pullUp").css("display","none");
	}
	/**
	 * 销毁
	 */
	function destroy(){
	    entrustNo = "";
		exchangeType = "";
		$(_pageId+".cancel_order").html("");
		if(vIscroll._init){
			vIscroll.scroll.refresh();
		}
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("stock/stockBuy","account/index",{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});