/**
 * 港股交易-持仓
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var layerUtils = require("layerUtils");
	var common = require("common");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var service_ggt = require("service_ggt");
	var service_stock = require("service_stock");
	var VIscroll = require("vIscroll");
    var vIscroll = {"scroll":null,"_init":false}; //上下滑动
    var canBuy = 0 ;//可用
    var market_val = 0 ;//市值
    var _pageId = "#ggt_ggtHolding ";
    var position_timer = null; //持仓定时器
    var commonFunc = require("commonFunc");
    var userInfo = null;
    /**
     * 初始化
     */
	function init(){common.hideBottomBar();
		common.bindStockEvent(_pageId);  //绑定头部菜单事件
		userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		queryData();//查询持仓
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			appUtils.pageInit("ggt/ggtHolding","account/index",{});
		});
		//转账
		appUtils.bindEvent($(_pageId + "#transfer"), function(e){
			appUtils.setSStorageInfo("whichAccount","stock_userInfo");
			appUtils.setSStorageInfo("whichPage","ggt/ggtHolding");
			appUtils.pageInit("ggt/ggtHolding","banking/transfer",{});
		},"click");
	}
    
	/**
	 * 查询
	 */
	function queryData(){
		initVIScroll();
		if (position_timer != null ) {
	        window.clearInterval(position_timer);
	    }
		//查询资金账户
		queryCapital();
		//查询持仓
		if (position_timer != null ) {
	        window.clearInterval(position_timer);
	    }
		window.setTimeout(commonFunc.queryPosition_ggt(_pageId,3),100);
        position_timer = window.setInterval(commonFunc.queryPosition_ggt(_pageId,3), 10000);
	}
	/**
	 * 资金账户查询
	 */
	function queryCapital(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var password = userInfo.password;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "password":password,
			    "cust_code":cust_code
		};
		$(_pageId+ ".no_data").hide();
		//最后一个为超时处理函数
		service_ggt.queryFundSelect_ggt(param,queryCapitalCallback,
		{  //传给接口的json格式数据            
		"isLastReq":true,                
		"isShowWait":true,
		"isShowOverLay":false,
		"timeOutFunc":function(){    //超时调用方法
			$(_pageId+ ".no_data").show();
			initVIScroll();
			if(vIscroll._init){
				vIscroll.scroll.refresh();
			}
		}
	    });
	}
	/**
	 * 资金账户查询回调
	 */
	function queryCapitalCallback(data){
		if (data && data!= "undefined"){
			if(data.error_no == 0){
				var results = data.results;
				if(results && results!= "undefined"){
					$(_pageId+".hold_table tr:eq(0) td:eq(0) strong").text(common.numToMoneyType(""+Number(results[0].assert_val).toFixed(2)+""));//总资产
					$(_pageId+".hold_table tr:eq(0) td:eq(2) strong").text(common.numToMoneyType(""+Number(results[0].market_val).toFixed(2)+""));//市值
					$(_pageId+".hold_table tr:eq(1) td:eq(0) strong").text(common.numToMoneyType(""+Number(results[0].fetch_balance).toFixed(2)+""));//可取
					$(_pageId+".hold_table tr:eq(1) td:eq(1) strong").text(common.numToMoneyType(""+Number(results[0].enable_balance).toFixed(2)+""));//可用
				}else{
					$(_pageId+".hold_table tr:eq(0) td:eq(0) strong").text("--");//总资产
					$(_pageId+".hold_table tr:eq(0) td:eq(2) strong").text("--");//市值
					$(_pageId+".hold_table tr:eq(1) td:eq(0) strong").text("--");//可取
					$(_pageId+".hold_table tr:eq(1) td:eq(1) strong").text("--");//可用
				}
			}
			else{
				layerUtils.iAlert(data.error_info);
			}
		}
	}
	
	/**
	 * 初始化上下滑动组件
	 */
	function initVIScroll(){
		if(!vIscroll._init){
			var config = {
				"isPagingType": false,		//false表示是微博那种累加形式，true表示分页形式
				"visibleHeight": $(window).height() - $(_pageId+".top_title").height()- $(_pageId+".tab_nav").height() - 6  ,	//显示内容区域的高度，当isPaingType为false时传
				"container": $(_pageId+" #v_container_funds_jj"),	
				"wrapper":$(_pageId+" #v_wrapper_funds_jj"),	
				"downHandle": function() {				//下拉获取上一页数据方法
					queryData();
				},
				"upHandle": function() {
				},
				"wrapperObj": null
			};
			vIscroll.scroll = new VIscroll(config); 	//初始化，需要做if(!hIscroll._init)判断
			vIscroll._init = true; 						//尽量只初始化一次，保持性能
			
		}else{
			vIscroll.scroll.refresh();
		}
		$(_pageId + ".visc_pullUp").css("display","none");//隐藏"上拉加载下一页"
	}
	/**
	 * 销毁
	 */
	function destroy(){
		if (position_timer != null ) {
	        window.clearInterval(position_timer);
	    }
		position_timer = null;
	    canBuy = 0 ;//可用
	    market_val = 0 ;//市值
		$(_pageId+".hold_table tr:eq(0) td:eq(0) strong").text("--");//总资产
		$(_pageId+".hold_table tr:eq(0) td:eq(2) strong").text("--");//市值
		$(_pageId+".hold_table tr:eq(1) td:eq(0) strong").text("--");//可取
		$(_pageId+".hold_table tr:eq(1) td:eq(1) strong").text("--");//可用
		if(vIscroll._init){
			vIscroll.scroll.refresh();
		}
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("ggt/ggtHolding","account/index",{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});