/**
 * 港股交易-今日查询
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var common = require("common");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var layerUtils = require("layerUtils");
	var VIscroll = require("vIscroll");
	var service_ggt = require("service_ggt");
    var vIscroll = {"scroll":null,"_init":false};		//上下滑动
    var _pageId = "#ggt_ggtQueryToday ";
    var userInfo = null;
    
    /**
     * 初始化
     */
	function init(){common.hideBottomBar();
		userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		var queryType = appUtils.getPageParam("param");
		if(queryType=="entrust"){
			$(_pageId+".tab_nav ul li:eq(0)").addClass("active").siblings().removeClass("active");
		}else if(queryType=="deal"){
			$(_pageId+".tab_nav ul li:eq(1)").addClass("active").siblings().removeClass("active");
		}
		callsQuery();
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			var sCurPage = appUtils.getSStorageInfo("_curPage");
			var curPage = JSON.parse(sCurPage);
			var prePageCode = curPage.prePageCode;
			if(!prePageCode || prePageCode=="account/login"){
				prePageCode ="account/index";
			}
			appUtils.pageInit("ggt/ggtQueryToday",prePageCode,{});
		});
		//页面切换
		appUtils.bindEvent($(_pageId + ".tab_nav ul li"), function(e){
			$(this).addClass("active").siblings().removeClass("active");
			$(_pageId + ".top_title h3").text($(this).find("a").text());
			callsQuery();
		});
		
	}
    
	/**
	 * 调用查询
	 */
	function callsQuery(){
		if($(_pageId+".tab_nav ul li:eq(0)").hasClass("active")){
			$(_pageId+".search_list").html("");
			queryEntrust();
		}else{
			$(_pageId+".search_list").html("");
			queryDeal();
		}
	}
	
	/**
	 * 委托查询
	 */
	function queryEntrust(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;
		var password = userInfo.password;
		var sessionid=userInfo.session_id;
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "cust_code":cust_code,
			    "password":password,
			    "sessionid":sessionid
			};
			$(_pageId+ ".no_data").hide();
			service_ggt.queryTodayTrust_ggt(param,queryEntrustCallback,
				{
				"isLastReq":true,
				"isShowWait":true,
				"isShowOverLay":false,
				"timeOutFunc":function(){
					$(_pageId+ ".no_data").show();
					initVIScroll();
					if(vIscroll._init){
						vIscroll.scroll.refresh();
					}
				}
			});
	}
	/**
	 * 委托查询回调
	 */
	function queryEntrustCallback(data){
		if (typeof(data) != "undefined" && data) {
			$(_pageId+".search_list").html("");
			if(data.error_no == 0){
				$(_pageId+".no_data").hide();
				var results = data.results;
				if(results.length>0 && results!= "undefined"){
					var data = "";
					for (var i=0;i<results.length;i++){
						data += queryEntrustHTML(results[i]);
					}
					$(_pageId+".search_list").html(data);
				}else{
					$(_pageId+".no_data").show();
				}
				if(!vIscroll._init){
					initVIScroll();
				}else{
					vIscroll.scroll.refresh();
				}
			}
			else{
				layerUtils.iAlert(data.error_info);
			}
		}
		else{
			  layerUtils.iAlert("查询失败");
		}
	}
	
	/**
	 * 委托查询HTML生成
	 */
	function queryEntrustHTML(element){
		var css = "";
		var entrust_bs = element.entrust_bs;
		if(entrust_bs == "0"){
			css = "ared";
		}else if(entrust_bs == "1"){
			css = "agreen";
		}
        var eleHtml = "";
        eleHtml+="<div class=\"part\">";
        eleHtml+="<span class=\"time\">"+element.entrust_date+"&nbsp"+element.entrust_time+"</span>";
        eleHtml+="<h5 class=\""+css+"\">"+element.entrust_name+"</h5>";
        eleHtml+="<dl class=\"clearfix\">";
        eleHtml+="	<dt>"+element.stock_name+" <small>"+element.stock_code+"</small></dt>";
        eleHtml+="    <dd><em>编&#160;&#160;&#160;号</em>"+element.entrust_no+"</dd>";
        eleHtml+="    <dd><em>状&#160;&#160;&#160;态</em>"+element.entrust_state_name+"</dd>";
        eleHtml+="    <dd><em>委托价</em>"+Number(element.entrust_price).toFixed(3)+"</dd>";
        eleHtml+="    <dd><em>委托数</em>"+element.entrust_amount+"</dd>";
        eleHtml+="    <dd><em>汇&#160;&#160;&#160;率</em>"+Number(element.exchange_rate).toFixed(3)+"</dd>";
        eleHtml+="    <dd><em>成交数</em>"+element.business_amount+"</dd>";
        eleHtml+="</dl>";
        eleHtml+="</div>";
        return eleHtml;
	}
	
	/**
	 * 成交查询
	 */
	function queryDeal(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;//
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var sessionid = userInfo.session_id;
		var password = userInfo.password;
		var param={				
			"entrust_way":entrust_way,
		    "branch_no":branch_no,
		    "fund_account":fund_account,
		    "cust_code":cust_code,
		    "password":password,
		    "sessionid":sessionid
		};
		$(_pageId+ ".no_data").hide();
		service_ggt.queryTodayTrade_ggt(param,queryDealCallback,
		    {
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){
				$(_pageId+ ".no_data").show();
				initVIScroll();
				if(vIscroll._init){
					vIscroll.scroll.refresh();
				}
			}
		});
		
	}
	/**
	 * 成交查询回调
	 */
	function queryDealCallback(data){
		if (typeof(data) != "undefined" && data != null) {
			$(_pageId+" .tarde_hit").html("");
			if(data.error_no == 0){
				$(_pageId+".no_data").hide();
				var results = data.results;
				if(results != "undefined" && results.length>0){
					var data = "";
					for (var i=0;i<results.length;i++){
						data += queryDealHTML(results[i]);
					}
					$(_pageId+".search_list").html(data);
				}else{
					$(_pageId+".no_data").show();
				}
				if(!vIscroll._init){
					initVIScroll();
				}else{
					vIscroll.scroll.refresh();
				}
			}
			else{
				layerUtils.iAlert(data.error_info);
			}
		}
		else{
			  layerUtils.iAlert("查询失败");
		}
	}
	/**
	 * 成交查询HTML生成
	 */
	function queryDealHTML(element){
		var css = "";
		var entrust_no = element.entrust_no;
		if(entrust_no == "0"){
			css = "ared";
		}else if(entrust_no == "1"){
			css = "agreen";
		}
        var eleHtml = "";
        eleHtml+="<div class=\"part\">";
        eleHtml+="<span class=\"time\">"+element.business_date+"&nbsp"+element.business_time+"</span>";
        eleHtml+="<h5 class=\""+css+"\">"+element.entrust_name+"</h5>";
        eleHtml+="<dl class=\"clearfix\">";
        eleHtml+="	<dt>"+element.stock_name+" <small>"+element.stock_code+"</small></dt>";
        eleHtml+="    <dd><em>编&#160;&#160;&#160;号</em>"+element.entrust_no+"</dd>";
        eleHtml+="    <dd><em>金&#160;&#160;&#160;额</em>"+Number(element.business_balance).toFixed(3)+"</dd>";
        eleHtml+="    <dd><em>成交价</em>"+Number(element.business_price).toFixed(3)+"</dd>";
        eleHtml+="    <dd><em>成交数</em>"+element.business_amount+"</dd>";
        eleHtml+="</dl>";
        eleHtml+="</div>";
        return eleHtml;
	}
	
	/**
	 * 初始化滑动组件
	 */
	function initVIScroll(){
		if(!vIscroll._init){
			var config = {
					"isPagingType": false,//false表示是微博那种累加形式，true表示分页形式
					"visibleHeight": $(window).height() - $(_pageId+".top_title").height()- $(_pageId+".tab_nav").height()- 6  ,//显示内容区域的高度，当isPaingType为false时传
					"container": $(_pageId+"#v_container_funds_jj"),	
					"wrapper":$(_pageId+"#v_wrapper_funds_jj"),	
					"downHandle": function() {
						callsQuery();//下拉获取上一页数据方法
					},
					"upHandle": function() {	
						//上拉获取下一页数据方法
					},
					"wrapperObj": null
			};
			vIscroll.scroll = new VIscroll(config); 	//初始化，需要做if(!hIscroll._init)判断
			vIscroll._init = true;
		} else {
			vIscroll.scroll.refresh();
		}
		$(_pageId+ ".visc_pullUp").hide();
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId+".search_list").html("");
		if(vIscroll._init){
			vIscroll.scroll.refresh();
		}
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		var sCurPage = appUtils.getSStorageInfo("_curPage");
		var curPage = JSON.parse(sCurPage);
		var prePageCode = curPage.prePageCode;
		if(!prePageCode || prePageCode=="account/login"){
			prePageCode ="account/index";
		}
		appUtils.pageInit("ggt/ggtQueryToday",prePageCode,{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});