/**
 * 港股交易-卖入
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var common = require("common");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var validatorUtil = require("validatorUtil");
	var layerUtils = require("layerUtils");
	var service_ggt = require("service_ggt");
	var service_hq = require("service_hq");
	var external = require("external");
	var _pageId = "#ggt_ggtSell ";
    var userInfo = null;  //账号信息
	var fifthOrder_timer = null; //五档定时器
	var position_timer = null; //持仓定时器
	var _stockAccount="";
	var _market = "";
	var commonFunc = require("commonFunc");
	var isChangePrice = true; //五档变化是否改变相应价格
	var _stockName = "";
	var price_up = 0.01; //上限价差
	var price_down = 0.01; //下限价差
	var price_digit = 3; //小数点位数
	var lotsOf = 500; //每手数量
	var now_price = "";//按盘价
	
    /**
     * 初始化
     */
	function init(){common.hideBottomBar();
		common.systemKeybord(); // 解禁系统键盘
		userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		common.bindStockEvent(_pageId); //绑定头部菜单事件
        var height_table = $(window).height() - $(_pageId+".header").height() - $(_pageId+".tab_nav").height() - $(_pageId+".trade_main").height()-27;
        $(_pageId+".fund_table").height(height_table);   //给持仓数据添加高度
		var stockCode = appUtils.getPageParam("stockCode");
		//查询个股行情
		if(stockCode){
			$(_pageId+"#stockCode").val(stockCode);
			getStockList(stockCode);
		}else{
			$(_pageId+".fund_table").scrollTop(0);
		}
		if(position_timer != null ) {
	        window.clearInterval(position_timer);
	    }
	    clearBuyMsg();
		window.setTimeout(commonFunc.queryPosition_ggt(_pageId,2),100);
       		if(global.isTrade){
			position_timer = window.setInterval(commonFunc.queryPosition_ggt(_pageId,2), 10000);
		}
		if(gconfig.platform=="0"){ //方便pc端调试
			$(_pageId+"#stockCode").attr("readonly",false);
		}	
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId+".top_title .icon_back"), function(e){
			appUtils.pageInit("ggt/ggtSell","account/index",{});
			e.stopPropagation();
		});
		//股票代码输入框监听
		appUtils.bindEvent($(_pageId+"#stockCode"), function(e){
			var stockCode = $(this).val();
			clearBuyMsg();
			var vail=/^[A-Za-z]+$/;
			if(stockCode.length>1 && vail.test(stockCode)){
				getStockList(stockCode);
				if(stockCode.length<2){
					$(_pageId+"#stock_list").html("");
				}
			}else if(stockCode.length>3){
				getStockList(stockCode);
				if(stockCode.length<4){
					$(_pageId+"#stock_list").html("");
				}
			}else{
				clearBuyMsg();
			}
			$(_pageId+".ce_btn #total").hide();
			e.stopPropagation();
		},"keyup");
		//股票代码输入框调用原生键盘
		appUtils.bindEvent($(_pageId+".trade_form .input_code"), function(e){
			$(_pageId+"#stockCode").focus();
			var code =$.trim($(_pageId+"#stockCode").val().substring(0,5));
			$(_pageId+"#stockCode").val(code);
			if(gconfig.platform != "0"){
				var data = external.callMessage({"moduleName":"self-stock","funcNo": "60100", "searchKey":""});
				showStockList(data);// 显示股票列表
			}
			window.customKeyboardEvent = {
				keyBoardFinishFunction: function(){},
				keyBoardInputFunction: function(){
					var stockCode = $.trim($(_pageId+"#stockCode").val().substring(0,5));
					clearBuyMsg();
					var vail=/^[A-Za-z]+$/;
					if(stockCode.length>1 && vail.test(stockCode)){
						getStockList(stockCode);
						if(stockCode.length<2){
							$(_pageId+"#stock_list").html("");
						}
					}else if(stockCode.length>2){
						getStockList(stockCode);
						if(stockCode.length<3){
							$(_pageId+"#stock_list").html("");
						}
					}else{
						clearBuyMsg();
					}
					$(_pageId+".ce_btn #total").hide();
				}
			};
			external.callMessage({"moduleName":"trade","funcNo": "50210", "pageId":"ggt_ggtBuy", "eleId":"stockCode", "doneLable":"done", "keyboardType":"2"});
			e.stopPropagation();
		},"click");
		//失去焦点关闭原生键盘
		appUtils.bindEvent($(_pageId+"#stockCode"),function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50211"});
			var stockCode = $.trim($(_pageId+"#stockCode").val());
			if(stockCode.length==5){
				$(_pageId+"#stockCode").val(stockCode+" "+_stockName);
			}
			e.stopPropagation();
		},"blur");
		//股票数量输入框
		appUtils.bindEvent($(_pageId+"#stockNum"), function(e){
			totalValue();
			e.stopPropagation();
		},"input");
		//价格输入框
		appUtils.bindEvent($(_pageId+"#stockPrice"), function(e){
			totalValue();
			var stockCode = $.trim($(_pageId+"#stockCode").val().substring(0,6));
			queryMaxAmount(stockCode);
			e.stopPropagation();
		},"input");
		//增加价格
		appUtils.bindEvent($(_pageId+".trade_main .input_box .add"),function(e){
			var stockCode = $(_pageId + "#stockCode").val();
			if(stockCode && stockCode.length>0){
				var curPrice = $(_pageId+"#stockPrice").val();
				if(curPrice == "" || !validatorUtil.isNumberFloat(curPrice)){
					$(_pageId+"#stockPrice").val("");
					return false;;
				}
				curPrice = Number(curPrice);  
				if(curPrice >= 0&&curPrice<999999999){
				   curPrice = (parseFloat(curPrice)+parseFloat(price_up)).toFixed(price_digit);
				   $(_pageId+"#stockPrice").val(curPrice);
				}
			}else{
				layerUtils.iAlert("请先输入合法的股票代码");
			}
			totalValue();
			var stockCode = $.trim($(_pageId+"#stockCode").val().substring(0,6));
			queryMaxAmount(stockCode);
			e.stopPropagation();
		});
		//减少价格
		appUtils.bindEvent($(_pageId+".trade_main .input_box .less"),function(e){
			var stockCode = $(_pageId + "#stockCode").val();
			if(stockCode && stockCode.length>0){
				var curPrice = $(_pageId+"#stockPrice").val();
				if(curPrice == "" || !validatorUtil.isNumberFloat(curPrice)){
					$(_pageId+"#stockPrice").val("");
					return false;;
				}
				curPrice = Number(curPrice);  
				if(curPrice-price_down >= 0){
					curPrice = (parseFloat(curPrice)-parseFloat(price_down)).toFixed(price_digit);
					$(_pageId+"#stockPrice").val(curPrice);
				}
			}else{
				layerUtils.iAlert("请先输入合法的股票代码");
			}
			totalValue();
			var stockCode = $.trim($(_pageId+"#stockCode").val().substring(0,6));
			queryMaxAmount(stockCode);
			e.stopPropagation();
		});
		//五档买卖盘联动
		appUtils.bindEvent($(_pageId+".five_box ul li"),function(e){
			var curPrice=$(this).find("span").text();
			if(curPrice && curPrice!="--"){
				$(this).siblings().removeClass("active");
				$(this).parent().siblings().find("li").removeClass("active");
				$(this).addClass("active");
				curPrice = isNaN(Number(curPrice)) ? 0 : curPrice;
				$(_pageId+"#stockPrice").val(curPrice);
				totalValue();
		      	var stockCode = $.trim($(_pageId+"#stockCode").val().substring(0,6));
			    queryMaxAmount(stockCode);
			}
			e.stopPropagation();
		});
		//下单
		appUtils.bindEvent($(_pageId+"#submitOrder"),function(e){
			vailSubmitOrder();
			e.stopPropagation();
		});
		//点击其他位置去掉五档点击效果
		appUtils.bindEvent($(_pageId),function(e){
			$(_pageId+".five_box ul li").removeClass("active");
			$(_pageId+"#stock_list").html("");
			e.stopPropagation();
		});
		//滚动联动
		appUtils.bindEvent($(_pageId+".input_slider .r1"), function(e){
			var buyLimit = $(_pageId+"#buyLimit").text();
			if(validatorUtil.isNumeric(buyLimit)){
				var turn = $(this).val();
				var stockNum = ((buyLimit*turn)/(100*lotsOf)).toFixed(0)*lotsOf;
				if(turn==100){
					stockNum = buyLimit;
				}
				$(_pageId+"#stockNum").val(stockNum);
				totalValue();
			}
			e.stopPropagation();
		},"input");
	}
	
	//计算当前总值
	function totalValue(){
		var stockNum = $(_pageId+"#stockNum").val();
		var stockCode = $.trim($(_pageId+"#stockCode").val().substring(0,6));
		var stockPrice = $(_pageId+"#stockPrice").val();
		if(stockCode && validatorUtil.isNumberFloat(stockPrice) && validatorUtil.isNumeric(stockNum)){
		$(_pageId+".ce_btn #total").show();
			$(_pageId+".ce_btn #total").text("(¥"+common.numToMoneyType(""+(stockPrice*stockNum).toFixed(2))+")");
		}else{
			$(_pageId+".ce_btn #total").hide();
		}
	}
	
	/**
	 * 显示股票列表
	 * */
	function showStockList(data){
		if(data.error_no == 0){
			var results = data.results;
			if(results && results.length>0){
				$(_pageId+"#stock_list").html("");
				if(results.length == 1 && results[0].code.length==6){
					$(_pageId+"#stock_list").html("");
					var market = results[0].market;
					var stockCode = results[0].code;
					getStockInfo(market,stockCode);
				}else{
					if(results.length >= 6){
						var selectHeight = 6 * 0.44;
					}else{
						selectHeight = 0.44*results.length;
					}
					var listHtml = "<ul style=\"display:block;overflow-y:auto;height:"+selectHeight+"rem\">";
					for(var i = 0;i < results.length; i++) {
						listHtml += "<li><a href=\"javascript:void(0);\" style=\"padding-left:0.20rem;\"><strong style=\"font-size:0.18rem\">"+results[i].code+"</strong>"+results[i].name+"</a>";
						listHtml +=	"<span style=\"display:none;\">"+results[i].market+"</span></li>";
					};
					listHtml+="</ul>";
					$(_pageId+"#stock_list").append(listHtml);
					appUtils.bindEvent($(_pageId+".trade_form .select_box ul li"),function(){
						var market = $(this).find("span").text();
						var stockCode = $(this).find("strong").text();
						$(_pageId+"#stock_list").html("");
						getStockInfo(market,stockCode);
					});
				}
			}
		}
	}
	
	/**
	 * 获取股票列表
	 * */
	function getStockList(stockStr){
		if(stockStr != ""){
			if(gconfig.platform != "0"){
				var data = external.callMessage({"moduleName":"self-stock","funcNo": "60101","num":10,"searchKey":stockStr});
	            showStockList(data);
			}else{
				var stockStrParam = {
				  "q" : stockStr,
				  "type":"''"
				}; 
				service_hq.getStockList(stockStrParam,function(data){
					if(data.errorNo == 0){
						$(_pageId+"#stock_list").html("");
						var results = data.results;
						//显示股票列表
						if(results && results.length > 0){
							if(results.length == 1 && stockStr.length==5){
								$(_pageId+"#stock_list").html("");
								//var market = results[0][9];
								var stockCode = results[0][1];
								getStockInfo(stockCode);
							}else{
								if(results.length >= 6){
									var selectHeight = 6 * 0.44;
								}else{
									selectHeight = 0.44*results.length;
								}
								var listHtml = "<ul style=\"display:block;overflow-y:auto;height:"+selectHeight+"rem\">";
								for(var i = 0;i < results.length; i++) {
									listHtml += "<li><a href=\"javascript:void(0);\" style=\"padding-left:0.20rem;\"><strong style=\"font-size:0.15rem\">"+results[i][1]+"</strong>"+results[i][0]+"</a>";
									listHtml +=	"<span style=\"display:none;\">"+results[i][9]+"</span></li>";
								};
								listHtml+="</ul>";
								$(_pageId+"#stock_list").append(listHtml);
								appUtils.bindEvent($(_pageId+".trade_form .select_box ul li"),function(){
									//var market = $(this).find("span").text();
									var stockCode = $(this).find("strong").text();
									$(_pageId+"#stock_list").html("");
									getStockInfo(stockCode);
								});
							}
						}else{
							layerUtils.iAlert("该股票列表不存在");
	                        _stockName = "";
						}
					}else{
						layerUtils.iAlert("获取股票列表失败");
					}
				},{"isShowWait":false});
			}
		}	
	} 
				
	/*		
	 * 获取股票个股行情
	 * */
	function getStockInfo(stockCode){
		if(stockCode){
			if (fifthOrder_timer != null ) {
		        window.clearInterval(fifthOrder_timer);
		    }
			isChangePrice = true;
			queryMaxAmount(stockCode);
			window.setTimeout(setFifthOrder(stockCode),100);
			fifthOrder_timer = window.setInterval(setFifthOrder(stockCode),10000); 
		}
	}

	//五档买卖盘
	function setFifthOrder(stockCode){
		 return function() {//为了解决定时器不能传参数的问题	 
			 if(stockCode){
				var fifthOrder = {
					"stock_list" : stockCode
				};
				service_hq.getHqState_ggt(fifthOrder,callbackFifthOrder,{"isShowWait":false});
			 } 
		 };

	}
	//回调五档买卖盘
	function callbackFifthOrder(data){
		if (data.errorNo == 0) {
			var results = data.results;
			if (results && results.length > 0) {
				var stock_name = results[0][0];
				var stock_code = results[0][1];
				now_price = results[0][2];
				var max_price = results[0][3];
				var min_price = results[0][4];
				//证券代码显示  
				$(_pageId + "#stockCode").val(stock_code+" "+stock_name);
				_stockName = results[0][0];
				$(_pageId + "#stockCode").blur();
				$(_pageId+"#stockPrice").val(parseFloat(now_price).toFixed(3));
				$(_pageId+"#down_max").text(results[0][4]);
				$(_pageId+"#up_max").text(results[0][3]);
				var stock_gear = $(_pageId+".five_box ul li");
				var yesProfit = Number(results[0][6]);//昨收

				//卖五档盘颜色
				var soldFiveOrder = "";
			    var fivePirce = results[0][13];
				if(yesProfit <fivePirce){
					soldFiveOrder = "ared";
				}else if(yesProfit >fivePirce){
					soldFiveOrder = "agreen";
				}else{
					soldFiveOrder = "";
				}
				
				//买五档盘颜色
				var buyFiveOrder ="";
				var fivePirce = results[0][12];
				if(yesProfit <fivePirce){
					buyFiveOrder = "ared";
				}else if(yesProfit >fivePirce){
					buyFiveOrder = "agreen";
				}else{
					buyFiveOrder = "";
				}
				stock_gear.eq(4).find("span").text(Number(results[0][13]).toFixed(3)).attr("class",soldFiveOrder);
				stock_gear.eq(5).find("span").text(Number(results[0][12]).toFixed(3)).attr("class",buyFiveOrder);
			}
		}else {
			layerUtils.iAlert(data.error_info);
		}
		
	}
	
	//数量过万改以万为单位
	function overAMillion(num){
		num = Number(num);
		if(num >= 10000){
			num = (num/10000).toFixed(2) + "万";
		}
		return num;
	}
	
	/**
	 * 查询买入可用资金最大可买数量
	 * */
	function queryMaxAmount(stockCode) {
		if (!stockCode) {
			return false;
		}
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
		var branch_no = userInfo.branch_no; //分支机构
		var fund_account = userInfo.fund_account; //资产账户
		var cust_code = userInfo.cust_code; //客户代码
		var sessionid = userInfo.session_id;
		var password = userInfo.password;
		var entrust_bs = "1";
		var stock_code = stockCode;
		var entrust_price = "";
		var param = {
			"entrust_way": entrust_way,
			"branch_no": branch_no,
			"fund_account": fund_account,
			"cust_code": cust_code,
			"password":password,
			"sessionid": sessionid,
			"entrust_bs": entrust_bs,
			"stock_code": stock_code,
			"entrust_price": entrust_price
		};
		service_ggt.queryInformation_ggt(param, queryMaxAmountCallBack,{"isShowWait":false});
	}
	function queryMaxAmountCallBack(data){
		if (data.error_no == 0) {
			var results = data.results;
			if (results.length > 0) {
				price_up = results[0].up; // 现价+
				price_down = results[0].down; // 现价-
				lotsOf = results[0].buy_unit; // 数量+ -
				$(_pageId+"#buyLimit").text(Number(results[0].stock_max_amount));
			    $(_pageId+"#exchange_rate").html(Number(results[0].sell_exchange_rate));
			    queryAvailable(results[0].exchange_type); //额度查询
				_market = results[0].exchange_type; //交易市场类别（见数据字典)
				_stockAccount = results[0].stock_account; //证券账号
			}
		} else {
			layerUtils.iAlert(data.error_info);
		}
	}
	
	/**
	 * 下单验证
	 * */
	function vailSubmitOrder(){	
		//验证股票代码输入是否正确
		var buy_stockCode = $.trim($(_pageId+"#stockCode").val().substring(0,5));
		if(buy_stockCode.length == 0){
			layerUtils.iMsg(-1,"请输入股票代码");
			return false;
		}	
		if(buy_stockCode.length <4){
			layerUtils.iMsg(-1,"股票代码输入错误");
			return false;
		}	
		//验证股票价格输入是否正确
		var stockPrice = $(_pageId+"#stockPrice").val();
		if($.trim(stockPrice).length<=0||parseFloat(stockPrice)<=0){
			layerUtils.iMsg(-1,"请输入卖入价格");
			return false;
		}else if(!validatorUtil.isNumberFloat(stockPrice)){
			layerUtils.iMsg(-1,"请正确输入价格");
			return false;
		}else if(parseFloat(stockPrice)<parseFloat(now_price)/9){
			layerUtils.iMsg(-1,"委托价格不得低于按盘价的9倍");
			return false;
		}else if(parseFloat(stockPrice)>parseFloat(now_price)*9){
			layerUtils.iMsg(-1,"委托价格不得高于按盘价的9倍");
			return false;
		}
		//验证最大可卖
		var mostBuy = $(_pageId+"#buyLimit").text();
		if($.trim(mostBuy).length<=0||parseFloat(mostBuy)<=0){
			layerUtils.iMsg(-1,"最大可卖为0");
			return false;
		}
		//验证最大可卖
		var mostBuy = $(_pageId+"#buyLimit").text();
		if($.trim(mostBuy).length<=0||parseFloat(mostBuy)<=0){
			layerUtils.iMsg(-1,"最大可卖为0");
			return false;
		}
		//验证卖入数量
		var mountBuy = $(_pageId+"#stockNum").val();
		if(!validatorUtil.isNumeric(mountBuy)){
			layerUtils.iMsg(-1,"请输入卖出数量");
			return false;
		}else if(mountBuy==0){
			layerUtils.iMsg(-1,"数量必须大于0");
			return false;
		}else if(parseFloat(mostBuy)<parseFloat(mountBuy)){
			layerUtils.iMsg(-1,"最大可卖数量不足");
			return false;
		}else if(mostBuy!=mountBuy && mostBuy%Number(lotsOf)!=0){
			layerUtils.iMsg(-1,"卖出数量应为"+lotsOf+"的倍数");
			return false;
		}
		
		var exchange_type=_market;
		var tipStr ="<div class=\"pop_header\">";
		tipStr+="<h3>港股卖入</h3>";
		tipStr+="</div>";
		tipStr+="<div class=\"pop_main\">";
		tipStr+="<ul>";
		tipStr+="    <li>证券名称 <em>"+_stockName+"</em></li>";
		tipStr+="    <li>证券代码 <strong>"+buy_stockCode+"</strong></li>";
		tipStr+="    <li>委托价格 <strong>"+stockPrice+"</strong></li>";
		tipStr+="    <li>委托数量 <strong>"+mountBuy+"</strong></li>";
		tipStr+="</ul>";
		tipStr+="  </div>";
		common.btnConfirm(tipStr,function success(){
		var cust_code = userInfo.cust_code;	//客户代码
		var fund_account = userInfo.fund_account;	//资产账户
		var branch_no  = userInfo.branch_no;	//分支机构
		var sessionid=userInfo.sessionid;
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var password= userInfo.password;
		var entrust_bs="1";		
		var stock_account=_stockAccount;
		var stock_code=buy_stockCode;
		var entrust_price=stockPrice;
		var entrust_amount=mountBuy;
		var single_flag="0";
		var max_price_levels ="";
		var param = {
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"sessionid":sessionid,
				"entrust_bs":entrust_bs,
				"exchange_type":exchange_type,
				"stock_account":stock_account,
				"stock_code":stock_code,
				"entrust_price":entrust_price,
				"entrust_amount":entrust_amount,
				"single_flag": single_flag,
				"max_price_levels": max_price_levels
			};
		service_ggt.queryTrustSure_ggt(param,getStockBuyCallBack);
			
		},function fail(){
		});
	}
	
	/**
	 * 委托下单返回
	 * */
	function getStockBuyCallBack(data){
		if(data.error_no == 0){
			var results = data.results;
			if(results && results.length>0){
				layerUtils.iAlert(data.error_info);
				clearBuyMsg();
				$(_pageId + "#stockCode").val("");
			}
		}else{
			layerUtils.iAlert(data.error_info);
			clearBuyMsg();
			$(_pageId + " #stockCode").val("");
		}
	}
	
	/**
	 * 额度查询
	 * */
	function queryAvailable(exchange_type){
		var param = {
			"exchange_type":exchange_type
		};
		service_ggt.queryAvailable_ggt(param,function(data){
			if(data.error_no == 0){
				var results = data.results[0];
				if(results){
					$(_pageId + "#surplus_quota").text(results.surplus_quota);
				}
			}else{
				layerUtils.iAlert(data.error_info);
			}
		});
	}
	
	/**
	 * 重置买卖页面数据  
	 */
	function clearBuyMsg(){
		if (fifthOrder_timer != null ) {
	        window.clearInterval(fifthOrder_timer);
	    }
		$(_pageId+"#stock_list").html("");
		$(_pageId+"#stockName").text("股票名称");
		$(_pageId+"#stockPrice").val("");	
		$(_pageId+"#stockNum").val("");
		$(_pageId+"#buyLimit").text("--");
		$(_pageId+"#exchange_rate").text("--");
		$(_pageId+"#surplus_quota").text("--");
		$(_pageId+".five_box ul li em").text("--");
		$(_pageId+".five_box ul li").removeClass("active");
		$(_pageId+".five_box ul li span").removeClass("agreen").removeClass("ared").text("--");
		$(_pageId+".ce_btn #total").hide();
		$(_pageId + ".limit span").text("股");
		$(_pageId + ".input_num em").text("股");
		$(_pageId+".input_slider .r1").val("0");
		$(_pageId + ".trade_form .select_box label").text("股票");
		isChangePrice = true;
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		 if (position_timer != null ) {
	         window.clearInterval(position_timer);
	     }
		 clearBuyMsg();
	     userInfo = null;  //账号信息
	 	 price_up = 0.01; //上限价差
		 price_down = 0.01; //下限价差
		 price_digit = 3; //小数点位数
		 fifthOrder_timer = null; //五档定时器
		 position_timer = null; //持仓定时器
		 lotsOf = 100; //每手数量
		 _stockAccount=""; //股东帐号
	     _market ="";   //交易市场
         _stockName = "";
		 $(_pageId+"#stockCode").val("");
		 external.callMessage({"moduleName":"trade","funcNo": "50211"});
		 $(_pageId+".no_data").hide();
		 $(_pageId+".fund_table .ce_table").html("");
		 $(_pageId+".input_slider .r1").val("0");
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("ggt/ggtSell","account/index",{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});