/**
 * 新股-申购
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var layerUtils = require("layerUtils");
	var validator = require("validatorUtil");
	var common = require("common");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var	service_stock = require("service_stock");
	var	service_credit = require("service_credit");
	var _pageId = "#newshare_apply ";
    var userInfo =null;
    var num_step = 500; //步数
    var exchange_market = ""; //市场类别
    var whichPage = "";
    var witchAccount = "";
    var stock_account = "";
    var external = require("external");
    var _market = "";
    var _purchaseCeiling = "";
    var _endNumber = "";
    
    /**
     * 初始化
     */
	function init() {
		common.hideBottomBar();
		common.systemKeybord(); // 解禁系统键盘
		common.bindStockEvent(_pageId);
		whichPage = appUtils.getSStorageInfo("whichPage"); //判断从那个页面跳转过来
		witchAccount = appUtils.getSStorageInfo("whichAccount"); //判断用户选择那个帐户
		if(witchAccount){
			//从session中获取客户的信息
			userInfo = JSON.parse(appUtils.getSStorageInfo(witchAccount));
		}else{
			userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		}
//        var height_table = $(window).height() - $(_pageId+".header").height() - $(_pageId+".tab_nav").height() - $(_pageId+".input_form").height() - 23;
        $(_pageId+"#new-s-box").css({
        	"overflow-y": "auto",
        	"height": $(window).height() - $(_pageId+".header").height() - $(_pageId+".tab_nav").height() - $(_pageId+".order_form").height() - 30
        });
		$(_pageId+"#new-s-box").scrollTop(0);
		
		querynewAmount();//新股额度查询
		
		//在pc端可使用键盘输入股票代码（方便调试）
//		if(gconfig.platform=="0"){ 
//			
//		}	
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId+".top_title .icon_back"), function(e){
			if(whichPage == null || whichPage == ""){
				appUtils.pageInit("newshare/apply","account/index");
			}else{
				appUtils.pageInit("newshare/apply",whichPage,{});
			}
			e.stopPropagation();
		});
	}
    
	function newStockPurchase(){
		var user = userInfo,
			param = {
				"flag": "5",
				"entrust_way": global.entrust_way,
				"branch_no": user.branch_no,
				"fund_account": user.fund_account,
				"cust_code": user.cust_code,
				"sessionid": user.sessionid
			};
		service_stock.queryTodayNewShare(param,newStockPurchaseMessageCallBack);
	}
	
	function newStockPurchaseMessageCallBack(data){
		if(data.error_no == 0){
			var results = data.results;
			if( results && results.length>0){
				if(results.length >= 6){
					var selectHeight = 6 * 0.44;
				}else{
					selectHeight = 0.44 * results.length;
				}
//				var list = "<tr><th scope=\"col\">名称</th><th scope=\"col\">发行价</th><th scope=\"col\">市盈率</th><th scope=\"col\">申购日期</th></tr>";
				var list = "";
				for(var i = 0;i<results.length;i++){
					var stockName = results[i].stock_name?results[i].stock_name:"--";
					var issuePrice = results[i].issue_price?results[i].issue_price:"--";
					var item = results[i],
						subscribe_code = item.subscribe_code,
						exchange_type = item.market,
						applymax_online = +item.applymax_online,
						stock_account = item.stock_account,
						enable_amount = null;
					if(exchange_type=="19"){//深市
						enable_amount = +$(_pageId+" #SZED").text();
					}else if(exchange_type=="15"){//沪市
						enable_amount = +$(_pageId+" #SHED").text();
					}
					if (isNaN(enable_amount) || isNaN(applymax_online)){
						enable_amount = 0;
					} else {
						if (enable_amount - applymax_online > 0){
							enable_amount = applymax_online;
						}
					}
					//股票代码:交易市场:委托价格:委托数量:股东代码
					var new_info = subscribe_code+":"+exchange_type+":"+(isNaN(+issuePrice) ? "0" : issuePrice)+":"+enable_amount+":"+stock_account;
					list +="   <tr id = \"newShare\" class='newShare' style='background-color:#eff7ff'>";
					list +="     <td class='input_check checked' data-new_info='"+new_info+"'></td>";
					list +="     <td><strong>"+stockName+"</strong><small>"+subscribe_code+"</small></td>";
					list +="     <td><span>"+issuePrice+"</span></td>";
					list +="     <td><span>"+enable_amount+"</span></td>";
					list +="     <td><span>"+results[i].applymax_online+"</span></td>";
					list +="   </tr>";
				}
				$(_pageId+ ".no_data").hide();
				$(_pageId+".fund_table tbody").html(list);
				$(_pageId + " .ce_btn").show();
				//新股一键申购绑定事件
				//绑定新股点击事件
				bindNewClick();
			}else{
				$(_pageId+ ".no_data").show();
			}
		}else{
			layerUtils.iAlert(data.error_info);
		}
	}
	
	/**
	 * 新股点击事件
	 */
	function bindNewClick(){
		var select_num = 0,
			$ce_btn = $(_pageId + " .ce_btn>a");
		appUtils.bindEvent($(_pageId + " .newShare"), function(e){
			var $this = $(this),
				$check = $this.find(".input_check"),
				is_click = $check.hasClass("checked");
			if (is_click){
				$check.removeClass("checked");
				$this.css("background-color", "#ffffff");
				select_num--;
			} else {
				$check.addClass("checked");
				$this.css("background-color", "#eff7ff");
				select_num++;
			}
			e.stopPropagation();
		}, "click");
		//绑定新股全选按钮
		appUtils.bindEvent($(_pageId + " .newShare-tab .input_check"), function(e){
			var $this = $(this),
				is_check = $this.hasClass("checked");
			if (is_check){
				$this.removeClass("checked");
				$(_pageId + " .newShare").css("background-color", "#ffffff");
				$(_pageId + " .newShare .input_check").removeClass("checked");
			} else {
				$this.addClass("checked");
				$(_pageId + " .newShare").css("background-color", "#eff7ff");
				$(_pageId + " .newShare .input_check").addClass("checked");
			}
			e.stopPropagation();
		});
		//一键申购
		appUtils.bindEvent($(_pageId + " .ce_btn>a"), function(e){
			var $this = $(this),
				is_check = $this.hasClass("checked");
			var newS = [];
			$(_pageId + " tbody .checked").each(function(){
				var info = $(this).attr("data-new_info");
				newS.push(info);
			});
			var new_all = newS.join("|");
			if (new_all){
				var tipStr ="<div class=\"pop_header\">";
				tipStr+="<h3>申购确认</h3>";
				tipStr+="</div>";
				tipStr+="<div class=\"pop_main\">";
				tipStr+="<ul>";
				tipStr+="    <li>申购新股个数为：<em>"+newS.length+"</em></li>";
				tipStr+="</ul>";
				tipStr+="  </div>";
				common.btnConfirm(tipStr, function success(){
					allBuy(new_all);
				});
			} else {
				layerUtils.iAlert("未选择申购股票");
			}
//			for(){}
//			if (is_check){
//				$this.removeClass("checked");
//				$(_pageId + " .newShare").css("background-color", "#ffffff");
//				$(_pageId + " .newShare .input_check").removeClass("checked");
//			} else {
//				$this.addClass("checked");
//				$(_pageId + " .newShare").css("background-color", "#eff7ff");
//				$(_pageId + " .newShare .input_check").addClass("checked");
//			}
			e.stopPropagation();
		});
	}
	
	/**
	 * 一键申购
	 */
	function allBuy(entrustcodes){
		var user = userInfo,
			param = {
				"entrust_way": global.entrust_way,
				"branch_no": user.branch_no,
				"fund_account": user.fund_account,
				"cust_code": user.cust_code,
				"password": user.password,
				"sessionid": user.sessionid,
				"entrustcodes": entrustcodes
			};
		service_stock.allBuy(param, function(data){
			var errorNo = data.error_no,
				errorInfo = data.error_info;
			if (errorNo === "0"){
				layerUtils.iAlert("一键申购已提交,结果请在查询中查看");
			} else {
				layerUtils.iAlert(errorInfo);
			}
		});
	}
	
	/**
	 * 新股申购额度查询	
	 */
	function querynewAmount(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no  = userInfo.branch_no;	 //分支机构
		var fund_account = userInfo.fund_account;//资产账户
		var cust_code = userInfo.cust_code;  	 //客户代码
		var sessionid = userInfo.session_id;
		var password = userInfo.password;
		var param = {
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"sessionid":sessionid
			};
		
		if(witchAccount=="credit_userInfo"){
			service_credit.newAmount_Query(param,queryNewAmountCallBack, {"isLastReq": false});
		}else{
			service_stock.newAmount_Query(param,queryNewAmountCallBack, {"isLastReq": false});
		}
	}
	//新股申购额度查询回调
	function queryNewAmountCallBack(data){
		//今日新股查询
		newStockPurchase();
		if (typeof data != "undefined" && data != null) {
			if(data.error_no == 0){
				if(typeof data.results != "undefined" && data.results!= null && data.results != ""){
					var results = data.results;
					for(var i=0;i<results.length;i++){
						var exchange_type = results[i].exchange_type;
						var enable_amount = results[i].enable_amount;
						if(exchange_type=="0"){//深市
							$(_pageId+" #SZED").text(enable_amount);
						}else if(exchange_type=="2"){//沪市
							$(_pageId+" #SHED").text(enable_amount);
						}
					}
				}
			}
		}else{
			layerUtils.iLoading(false);
			layerUtils.iAlert(data.error_info);
		}
	}
		
	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId+".fund_table tbody").html("");
		$(_pageId + " .ce_btn").hide();
		$(_pageId + " #SHED").html("--");
		$(_pageId + " #SZED").html("--");
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("newshare/apply", whichPage, {});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});