/**
 * 新股申购查询
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var common = require("common");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var layerUtils = require("layerUtils");
	var VIscroll = require("vIscroll");
	var service_stock = require("service_stock");
    var vIscroll = {"scroll":null,"_init":false};		//上下滑动
    var _pageId = "#newshare_queryApply ";
    var userInfo = null;
    var queryType = null; //查询内容
    var _entrustNo = "";
    var _exchangeType = "";
    var shIscroll = require("shIscroll");
	var mySHIscroll = null;
    /**
     * 初始化
     */
	function init(){
		common.hideBottomBar();
		common.bindStockEvent(_pageId);
		whichPage = appUtils.getSStorageInfo("whichPage"); //判断从那个页面跳转过来
		witchAccount = appUtils.getSStorageInfo("whichAccount"); //判断用户选择那个帐户
		if(witchAccount){
			//从session中获取客户的信息
			userInfo = JSON.parse(appUtils.getSStorageInfo(witchAccount));
		}else{
			userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		}
		queryEntrust();
    }

	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId+".top_title .icon_back"), function(e){
			if(whichPage == null || whichPage == ""){
				appUtils.pageInit("newshare/queryApply", "account/index");
			}else{
				appUtils.pageInit("newshare/queryApply", whichPage, {});
			}
			e.stopPropagation();
		});
	}
	
	/**
	 * 委托查询
	 */
	function queryEntrust(){
		var user = userInfo,
			param = {
				"entrust_way": global.entrust_way,
			    "branch_no": user.branch_no,
			    "fund_account": user.fund_account,
			    "cust_code": user.cust_code,
			    "password": user.password,
			    //新股
			    "entrust_bs": "15",
			    "sessionid": user.session_id
			};
		service_stock.queryTodayTrust(param, function(data){
			var errorNo = data.error_no,
				errorInfo = data.error_info;
			if (errorNo === "0"){
				var results = data.results,
					re_length = results.length;
				if (re_length > 0){
					var str = "";
					for (var i = 0; i < re_length; i++){
						var item = results[i];
						str += "<tr><td><strong>" + item.stock_name + "</strong><small>" + item.stock_code + "</small></td>";
						str += "<td>" + Number(item.entrust_amount) + "</td><td>" + item.entrust_state_name + "</td><td>"+item.entrust_no+"</td></tr>";
					}
					$(_pageId + " .fund_table tbody").html(str);
				} else {
					$(_pageId + " .no_data").show();
				}
			} else {
				layerUtils.iAlert(errorInfo);
			}
		});
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId + " .no_data").hide();
		$(_pageId + " .fund_table tbody").html("");
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});