/**
 * 普通交易-当日资金流水查询
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var common = require("common");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var layerUtils = require("layerUtils");
	var VIscroll = require("vIscroll");
	var service_stock = require("service_stock");
    var vIscroll = {"scroll":null,"_init":false};		//上下滑动
    var _pageId = "#stock_moneyFlow ";
    var timeLimit = 7; //默认查询最近一周的数据
    var userInfo = null;
    
    /**
     * 初始化
     */
	function init(){common.hideBottomBar();
		userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		moneyFlow();//查询资金流水数据
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			appUtils.pageBack();
			e.stopPropagation();
		});
	}
	
	/**
	 * 当日资金流水查询
	 */
	function moneyFlow(){
		$(_pageId+".search_table .ce_table").html("");		
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;
		var password = userInfo.password;
		var sessionid = userInfo.session_id;
		var param = {			
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"sessionid":sessionid
		};
		$(_pageId+ ".no_data").hide();
		service_stock.querySameDayCapitalFlow(param,moneyFlowQueryCallback,
			{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){
				$(_pageId+ ".no_data").show();
				initVIScroll();
				if(vIscroll._init){
					vIscroll.scroll.refresh();
				}
			}
		});
	}
	/**
	 *  当日资金流水查询回调
	 */
	function moneyFlowQueryCallback(data){
		if (typeof(data) != "undefined" && data) {
			$(_pageId+".search_table .ce_table").html("");
			if(data.error_no == 0){
				$(_pageId+".no_data").hide();
				var results = data.results;
				if(results.length>0 && results!= "undefined"){
					var data = "<tr><th scope=\"col\">&nbsp;</th><th scope=\"col\">日期</th><th scope=\"col\">发生金额/业务</th><th scope=\"col\">成交价格/发生数量</th>";
					for (var i=0;i<results.length;i++){
						data += queryEntrustHTML(results[i]);
					}
					$(_pageId+".search_table .ce_table").html(data);
				}else{
					var data = "<tr><th scope=\"col\">&nbsp;</th><th scope=\"col\">日期</th><th scope=\"col\">发生金额/业务</th><th scope=\"col\">成交价格/发生数量</th>";
					$(_pageId+".search_table .ce_table").html(data);
					$(_pageId+".no_data").show();
				}
				if(!vIscroll._init){
					initVIScroll();
				}else{
					vIscroll.scroll.refresh();
				}
			}
			else{
				layerUtils.iAlert(data.error_info);
			}
		}
		else{
			  layerUtils.iAlert("查询失败");
		}
	}
	
	/**
	 * 委托查询HTML生成
	 */
	function queryEntrustHTML(element){
		var price_digit = 2;
//		require("common").decimalKeep(element.stock_code ,function(data){  //获取保留的位数
//	    	if(data){
//	    		price_digit = data;
//	    	}
//		});
		var css = "";
		var business_name = element.business_name;
		if(business_name == "委托买入"){
			css = "ared";
		}else if(business_name == "委托卖出"){
			css = "agreen";
		}
        var eleHtml = "";
//        eleHtml+="<div class=\"part\">";
//        eleHtml+="<span class=\"time\">"+element.business_date+"&nbsp</span>";
//        eleHtml+="<h5 class=\""+css+"\">"+business_name+"</h5>";
//        eleHtml+="<dl class=\"clearfix\">";
//        eleHtml+="	<dt>"+element.stock_name+" <small>"+element.stock_code+"</small></dt>";
////        eleHtml+="    <dd><em>委托编号</em>"+element.entrust_no+"</dd>";
//        eleHtml+="    <dd><em>发生金额</em>"+Number(element.occur_balance)+"</dd>";
//        eleHtml+="    <dd><em>后资金额</em>"+Number(element.enable_balance)+"</dd>";
//        eleHtml+="    <dd><em>成交价格</em>"+Number(element.business_price)+"</dd>";
////        eleHtml+="    <dd><em>成交数量</em>"+Number(element.matchqty)+"</dd>";
////        eleHtml+="    <dd><em>委托价格</em>"+Number(element.orderprice)+"</dd>";
////        eleHtml+="    <dd><em>委托数量</em>"+element.orderqty+"</dd>";
//        eleHtml+="    <dd><em>币&nbsp;&nbsp;&nbsp;&nbsp;种</em>"+element.money_type_name+"</dd>";
//        eleHtml+="    <dd><em>股东账号</em>"+element.fund_account+"</dd>";
//        eleHtml+="    <dd><em>备&nbsp;&nbsp;&nbsp;&nbsp;注</em>"+element.remark+"</dd>";
//        eleHtml+="</dl>";
//        eleHtml+="</div>";
        
        eleHtml+="<tr><td class="+css+"></td>";
        eleHtml+="<td><small>"+element.business_date +"</small></td>";
        eleHtml+="<td><span>"+Number(element.occur_balance)+"</span><span>"+element.business_name+"</span></td>";
        eleHtml+="<td><span>"+Number(element.business_price)+"</span><span>"+element.occur_amount+"</span></td>";
        eleHtml+="</tr>";
        
//      eleHtml+="<tr><td class="+css+"></td>";
//      eleHtml+="<td><small>"+element.business_date +"</small><small>"+element.entrust_no+"</small></td>";
//      eleHtml+="<td><span>"+Number(element.matchamt)+"</span><span>"+element.business_name+"</span></td>";
//      eleHtml+="<td><span>"+Number(element.business_price)+"</span><span>"+element.occur_amount+"</span></td>";
//      eleHtml+="</tr>";
        return eleHtml;
       
	}
	
	/**
	 * 初始化滑动组件
	 */
	function initVIScroll(){
		if(!vIscroll._init){
			var config = {
					"isPagingType": false,//false表示是微博那种累加形式，true表示分页形式
					"visibleHeight": $(window).height() - $(_pageId+".top_title").height()- $(_pageId+".tab_nav").height()- 6  ,//显示内容区域的高度，当isPaingType为false时传
					"container": $(_pageId+"#v_container_funds_jj"),	
					"wrapper":$(_pageId+"#v_wrapper_funds_jj"),	
					"downHandle": function() {
						moneyFlow();//下拉获取上一页数据方法
					},
					"upHandle": function() {	
						//上拉获取下一页数据方法
					},
					"wrapperObj": null
			};
			vIscroll.scroll = new VIscroll(config); 	//初始化，需要做if(!hIscroll._init)判断
			vIscroll._init = true;
		} else {
			vIscroll.scroll.refresh();
		}
		$(_pageId+ " .visc_pullUp").hide();
	}
	
    
	/**
	 * 销毁
	 */
	function destroy(){
		timeLimit = 7;
		$(_pageId+".search_table .ce_table").html("");
		$(_pageId + ".top_title .top_nav").hide();
		$(_pageId + " .top_title small").text("一周内");	
		if(vIscroll._init){
			vIscroll.scroll.refresh();
		}
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageBack();
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});