/**
 * 普通交易-买入
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var common = require("common");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var validatorUtil = require("validatorUtil");
	var layerUtils = require("layerUtils");
	var service_stock = require("service_stock");
	var service_hq = require("service_hq");
	var external = require("external");
	var _pageId = "#stock_stockBuy ";
    var userInfo = null;  //账号信息
	var price_step = 0.01; //步长
	var price_digit = 2; //小数点位数
	var fifthOrder_timer = null; //五档定时器
	var position_timer1 = null; //持仓定时器
	var lotsOf = 100; //每手数量
	var _stockAccount="";
	var _market ="";
	var commonFunc = require("commonFunc");
	var enable_balance = "";
	var isChangePrice = true; //五档变化是否改变相应价格
	var _stockName = "";
	var stock_price = ""; 
	var stkType = ""; //证券类型
	var up_stop = "";
	var down_stop = "";
	var toTrade = "";
	var bazaarCode = "";   //市场代码
	var limitedMarketEntrust = "limited";  //判断是限价委托和是市价委托
	var entrustBs = "0";
	var code_name_exch_mark = "";
	var shIscroll = require("shIscroll");
	var mySHIscroll = null;
	var stockType = "";
	var cursor_timer = null;
	var cursor_num = 0;
	var cursor_timer_id = null;
	
	
    /**
     * 初始化
     */
	function init(){common.hideBottomBar();
		//从某一个页面跳转到当前页面携带的股票代码
		var stockCode = appUtils.getPageParam("stockCode");
		if(!stockCode){
			if(appUtils.getLStorageInfo("toHqDetails") || appUtils.getLStorageInfo("toHqDetails") == "toHqDetails"){
				appUtils.setLStorageInfo("toHqDetails","");
				return;
			}
		}
		common.systemKeybord(); // 解禁系统键盘	
		userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		common.bindStockEvent(_pageId); //绑定头部菜单事件
        var height_table = $(window).height() - $(_pageId+".header").height() - $(_pageId+".tab_nav").height() - $(_pageId+".trade_main").height()-12;
        $(_pageId+"#userShow").height(height_table).css("overflow", "auto");   //给持仓数据添加高度
        toTrade = appUtils.getPageParam("toTrade");
        
		//查询个股行情
		if(stockCode){
			//从持仓中获取相应的股票代码进行个股行情的数据的详细的获取
			$(_pageId+"#stockCode").val(stockCode);
			getStockList(stockCode);
		}else{
			$(_pageId+".fund_table").scrollTop(0);//scrollTop() 方法返回或设置匹配元素的滚动条的垂直位置
		}
	    
	    //获取下方的股票列表（时时刷新）
		commonFunc.queryPosition(_pageId, 1, myInitHIScroll);
		//判断是否是交易时间（查询持仓）
       	if(global.isTrade){
			position_timer1 = window.setInterval(function(){
				commonFunc.queryPosition(_pageId,1,myInitHIScroll);
			}, 5 * 60 * 1000);
		}
       	
       	setTimeout(function(){
       		// 给持仓数据添加高度
       		$(_pageId + " #userShow").css({
       			"height": $(window).height() - $(_pageId+".header").height() - $(_pageId+".tab_nav").height() - $(_pageId+".trade_main").height()-12 + "px",
       			"overflow-y": "auto"
       		});
       	}, 300);
       	
       	//在pc端可使用键盘输入股票代码（方便调试）
		if(gconfig.platform=="0"){ 
			$(_pageId+"#stockCode").attr("readonly",false);
		}	
		
		//股票数量输入框
		appUtils.bindEvent($(_pageId+" .input_num .cursor_div"), function(e){
			cursor_timer_id = $(this).find(" .cursor em").attr("id");
//			$(_pageId + "#stockNum").prev(".cursor_div").addClass("active");
			cursorTimer();
			window.customKeyboardEvent = {
					keyBoardFinishFunction: function(){},
					keyBoardInputFunction: function(keyCode){
						var mostBuy = $(_pageId + " .stat span ").html().substring(5);//最大买入量
						var temp_num = $(_pageId+" #stockNum").val();
						if(temp_num && temp_num>1000000){
							layerUtils.iAlert("委托数量不能超过100万股/份！");
						}
						if(temp_num && temp_num>=100000000){
							$(_pageId+" #stockNum").val($(_pageId+" #stockNum").val().substring(0,8));
							$(_pageId + "#stockNum").prev(".cursor_div").find(".cursor div").text($(_pageId+" #stockNum").val());
							return false;
						}
						if(validatorUtil.isNumeric(mostBuy)){// 1 ，买入  2，卖出  3，融资买入 4，融券卖出  5，普通买入 6，普通卖出 7，买券还券 8，卖券还款
							if(keyCode == "-14" && (entrustBs%2 === 0)){ // 买入全仓
								$(_pageId+"#stockNum").val((mostBuy/lotsOf).toFixed(0)*lotsOf);
							}else if(keyCode == "-14" && (entrustBs%2 > 0)){ // 卖出全仓
								$(_pageId+"#stockNum").val(mostBuy);
							}else if(keyCode == "-12"){ // 3分之一仓
								$(_pageId+"#stockNum").val((mostBuy/(3*lotsOf)).toFixed(0)*lotsOf);
							}else if(keyCode == "-13"){ // 2分之一仓
								$(_pageId+"#stockNum").val((mostBuy/(2*lotsOf)).toFixed(0)*lotsOf);
							}else if(keyCode == "-11"){ // 4分之一仓
								$(_pageId+"#stockNum").val((mostBuy/(4*lotsOf)).toFixed(0)*lotsOf);
							}
						}else{
							if(keyCode == "-11"||keyCode == "-12"||keyCode == "-13"||keyCode == "-14"){
								$(_pageId+"#stockNum").val(0);
							}
						}
						var cur_num = $(_pageId+" #stockNum").val();
						if(Number(cur_num.substring(0,1)) == 0){
							$(_pageId+" #stockNum").val("");
						}
						$(_pageId + "#stockNum").prev(".cursor_div").find(".cursor div").text($(_pageId+" #stockNum").val());
						totalValue();
					}
				};
				var pageId = _pageId.substring(1,_pageId.length-1);
				external.callMessage({"moduleName":"trade","funcNo": "50210", "pageId": pageId, "eleId":"stockNum", "doneLable":"done", "keyboardType":"6"});
				e.stopPropagation();
		},"click");
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId+".top_title .icon_back"), function(e){
			$(_pageId+"#stockCode").val("");
			/*if(toTrade == null || toTrade == ""){
				appUtils.pageInit("banking/transfer","account/index");
				destroy();
			}else{
				external.callMessage({"moduleName":toTrade,"funcNo": "50101"});
			}*/
			appUtils.pageInit("stock/stockBuy","account/index");
			destroy();
			e.stopPropagation();	// 阻止冒泡
		});
		
		// 股票代码输入框监听
		appUtils.bindEvent($(_pageId + "#stockCode"), function(e){ // 该监听方法是为了适配浏览器
			var stockCode = $(this).val();
			clearBuyMsg(); // 重置数据
			var vail=/^[A-Za-z]+$/;
			if(stockCode.length>1 && vail.test(stockCode)){ // 当输入的长度大于1 并且为字母的时候
				getStockList(stockCode); // 查询股票列表
				if(stockCode.length<2){ // 清空股票列表
					$(_pageId + "#stock_list").html("");
				}
			}else if(stockCode.length>3){ // 当输入的长度大于3的时候
				getStockList(stockCode); // 查询股票列表
				if(stockCode.length<4){ // 清空股票列表
					$(_pageId + "#stock_list").html("");
				}
			}
			$(_pageId + ".ce_btn #total").hide();
			e.stopPropagation();
		},"keyup");
		// 股票代码输入框调用原生键盘
		appUtils.bindEvent($(_pageId + ".trade_form .input_code .cursor_div"), function(e){ // 该监听方法是为了适配原生
			cursor_timer_id = $(this).find(" .cursor em").attr("id");
			$(_pageId+"#stockCode").val("");
//			$(_pageId + "#stockCode").prev(".cursor_div").addClass("active");
			clearBuyMsg();
			cursorTimer();
			$(_pageId + "#stockCode").focus();
			var code = $.trim($(_pageId + "#stockCode").val().substring(0,6));
			$(_pageId + "#stockCode").val(code);
			if(gconfig.platform != "0"){ // 同步原生的自选股
				var data = external.callMessage({"moduleName":"self-stock","funcNo": "60100", "searchKey":"","targetModule":"self-stock"});
				var source = "1"; // 渠道来源 0表示搜索码表 1 表示同步的自选股列表
				showStockList(data,source); // 显示股票列表
			}
			window.customKeyboardEvent = {
				keyBoardFinishFunction: function(){},
				keyBoardInputFunction: function(){
					var stockCode = $.trim($(_pageId + "#stockCode").val().substring(0,6));
					clearBuyMsg();
					cursorTimer();
					var vail=/^[A-Za-z]+$/;
					if(stockCode.length>1 && vail.test(stockCode)){
						getStockList(stockCode);
						if(stockCode.length<2){
							$(_pageId + "#stock_list").html("");
						}
					}else if(stockCode.length>3){
						getStockList(stockCode);
						if(stockCode.length<4){
							$(_pageId + "#stock_list").html("");
						}
					}else{
						clearBuyMsg();
						cursorTimer();
					}
					$(_pageId+".ce_btn #total").hide();
					$(_pageId + "#stockCode").prev(".cursor_div").find(".cursor div").text(stockCode);
				}
			};
			var pageId = _pageId.substring(1,_pageId.length-1);
			external.callMessage({"moduleName":"trade","funcNo": "50210", "pageId":pageId, "eleId":"stockCode", "doneLable":"done", "keyboardType":"2"});
			e.stopPropagation();
		},"click");
		
		//失去焦点关闭原生键盘
		appUtils.bindEvent($(_pageId+"#stockCode"),function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50211"});
			var stockCode = $.trim($(_pageId+"#stockCode").val());
			if(stockCode.length==6){
				$(_pageId+"#stockCode").val(stockCode+" "+_stockName);
			}
			e.stopPropagation();
		},"blur");
		
		
		//股票数量输入框
		appUtils.bindEvent($(_pageId+" .input_num .cursor_div"), function(e){
//			$(_pageId + "#stockNum").prev(".cursor_div").addClass("active");
			cursor_timer_id = $(this).find(" .cursor em").attr("id");
			cursorTimer();
			window.customKeyboardEvent = {
					keyBoardFinishFunction: function(){},
					keyBoardInputFunction: function(keyCode){
						var mostBuy = $(_pageId + " .stat span ").html().substring(5);//最大买入量
						var temp_num = $(_pageId+" #stockNum").val();
						if(temp_num && temp_num>1000000){
							layerUtils.iAlert("委托数量不能超过100万股/份！");
						}
						if(temp_num && temp_num>=100000000){
							$(_pageId+" #stockNum").val($(_pageId+" #stockNum").val().substring(0,8));
							$(_pageId + "#stockNum").prev(".cursor_div").find(".cursor div").text($(_pageId+" #stockNum").val());
							return false;
						}
						if(validatorUtil.isNumeric(mostBuy)){// 1 ，买入  2，卖出  3，融资买入 4，融券卖出  5，普通买入 6，普通卖出 7，买券还券 8，卖券还款
							if(keyCode == "-14" && (entrustBs%2 === 0)){ // 买入全仓
								$(_pageId+"#stockNum").val((mostBuy/lotsOf).toFixed(0)*lotsOf);
							}else if(keyCode == "-14" && (entrustBs%2 > 0)){ // 卖出全仓
								$(_pageId+"#stockNum").val(mostBuy);
							}else if(keyCode == "-12"){ // 3分之一仓
								$(_pageId+"#stockNum").val((mostBuy/(3*lotsOf)).toFixed(0)*lotsOf);
							}else if(keyCode == "-13"){ // 2分之一仓
								$(_pageId+"#stockNum").val((mostBuy/(2*lotsOf)).toFixed(0)*lotsOf);
							}else if(keyCode == "-11"){ // 4分之一仓
								$(_pageId+"#stockNum").val((mostBuy/(4*lotsOf)).toFixed(0)*lotsOf);
							}
						}else{
							if(keyCode == "-11"||keyCode == "-12"||keyCode == "-13"||keyCode == "-14"){
								$(_pageId+"#stockNum").val(0);
							}
						}
						var cur_num = $(_pageId+" #stockNum").val();
						if(Number(cur_num.substring(0,1)) == 0){
							$(_pageId+" #stockNum").val("");
						}
						$(_pageId + "#stockNum").prev(".cursor_div").find(".cursor div").text($(_pageId+" #stockNum").val());
						totalValue();
					}
				};
				var pageId = _pageId.substring(1,_pageId.length-1);
				external.callMessage({"moduleName":"trade","funcNo": "50210", "pageId": pageId, "eleId":"stockNum", "doneLable":"done", "keyboardType":"6"});
				e.stopPropagation();
		},"click");
		
		//失去焦点关闭原生键盘
		appUtils.bindEvent($(_pageId+"#stockNum"),function(e){
			external.callMessage({"moduleName":"trade","funcNo": "50211"});
			e.stopPropagation();
		},"blur");
		
		//价格输入框
		appUtils.bindEvent($(_pageId+"#stockPrice"), function(e){
			var curPrice = $(this).val();
			var up_stop = Number($(_pageId+"#up_stop").html());
			var down_stop = Number($(_pageId+"#down_stop").html());
			if(Number(curPrice) == 0){
				$(this).val("");
			}else{
				if(curPrice>up_stop || curPrice<down_stop){
					layerUtils.iAlert("委托价格超过涨跌幅");
				}
			}
			stock_price = $(this).val();
			var stockCode = $.trim($(_pageId+"#stockCode").val().substring(0,6));
			queryMaxAmount(stockCode,stkType);
			totalValue();
			e.stopPropagation();
		},"blur");
		
		/*appUtils.bindEvent($(_pageId+"#stockPrice"), function(e){
			var stockCode = $.trim($(_pageId+"#stockCode").val().substring(0,6));
			queryMaxAmount(stockCode,stkType);
			e.stopPropagation();
		},"blur");*/
		
		//增加价格
		appUtils.bindEvent($(_pageId+".trade_main .input_box .add"),function(e){
			var stockCode = $(_pageId + "#stockCode").val();
			if(stockCode && stockCode.length>0){
				var curPrice = $(_pageId+"#stockPrice").val();
				if(curPrice == "" || !validatorUtil.isNumberFloat(curPrice)){
					$(_pageId+"#stockPrice").val("");
					return false;
				}
				curPrice = Number(curPrice);  
				if(curPrice >= 0&&curPrice<999999999){
					curPrice = (parseFloat(curPrice)+parseFloat(price_step)).toFixed(price_digit);
					$(_pageId+"#stockPrice").val(curPrice);
				}
				stock_price = curPrice;
			}else{
				layerUtils.iAlert("请先输入合法的股票代码");
			}
			var up_stop = Number($(_pageId+"#up_stop").html());
			var down_stop = Number($(_pageId+"#down_stop").html());
			if(stock_price>up_stop || stock_price<down_stop){
				layerUtils.iAlert("委托价格超过涨跌幅");
			}
			totalValue();
			var stockCode = $.trim($(_pageId+"#stockCode").val().substring(0,6));
			queryMaxAmount(stockCode,stkType);
			e.stopPropagation();
		},"touchstart");
		
		//减少价格
		appUtils.bindEvent($(_pageId+".trade_main .input_box .less"),function(e){
			var stockCode = $(_pageId + "#stockCode").val();
			if(stockCode && stockCode.length>0){
				var curPrice = $(_pageId+"#stockPrice").val();
				if(curPrice == "" || !validatorUtil.isNumberFloat(curPrice)){
					$(_pageId+"#stockPrice").val("");
					return false;;
				}
				curPrice = Number(curPrice);   
				if(curPrice-price_step >= 0){
					curPrice=(parseFloat(curPrice)-parseFloat(price_step)).toFixed(price_digit);
					$(_pageId+"#stockPrice").val(curPrice);
				}
				stock_price = curPrice;
			}else{
				layerUtils.iAlert("请先输入合法的股票代码");
			}
			var up_stop = Number($(_pageId+"#up_stop").html());
			var down_stop = Number($(_pageId+"#down_stop").html());
			if(stock_price>up_stop || stock_price<down_stop){
				layerUtils.iAlert("委托价格超过涨跌幅");
			}
			totalValue();
			var stockCode = $.trim($(_pageId+"#stockCode").val().substring(0,6));
			queryMaxAmount(stockCode,stkType);
			e.stopPropagation();
		},"touchstart");
		
		//五档买卖盘联动
		appUtils.bindEvent($(_pageId+".five_box ul li"),function(e){
			var curPrice=$(this).find("span").text();
			if(curPrice && curPrice!="--"){
				$(this).siblings().removeClass("active");
				$(this).parent().siblings().find("li").removeClass("active");
				$(this).addClass("active");
				curPrice = isNaN(Number(curPrice)) ? 0 : curPrice;
				$(_pageId+"#stockPrice").val(curPrice);
				totalValue();
		      	var stockCode = $.trim($(_pageId+"#stockCode").val().substring(0,6));
			    queryMaxAmount(stockCode,stkType);
			}
			e.stopPropagation();
		});
		
		//下单
		appUtils.bindEvent($(_pageId+"#submitOrder"),function(e){
			//判断是限价委托还是市价委托
			if(limitedMarketEntrust == "limited"){
				entrustBs = "0";
			}else if(limitedMarketEntrust == "market"){
				entrustBs = $(_pageId+".input_select .select_box p").attr("id");
			}
			vailSubmitOrder();
			e.stopPropagation();
		});
		
		//点击其他位置去掉五档点击效果
		appUtils.bindEvent($(_pageId),function(e){
			$(_pageId+".five_box ul li").removeClass("active");
			$(_pageId+"#stock_list").html("");
//			$(_pageId + "#stockNum").prev(".cursor_div").removeClass("active");
//			$(_pageId + "#stockCode").prev(".cursor_div").removeClass("active");
			if (cursor_timer != null ) {
		        window.clearInterval(cursor_timer);
		    }
			$(_pageId + ".trade_form .input_text .cursor_div .cursor em").css("opacity",0);
			external.callMessage({"moduleName":"trade","funcNo": "50211"});
			e.stopPropagation();
		});
		
		//滚动联动
		appUtils.bindEvent($(_pageId+".input_slider .r1"), function(e){
			//能购买的最大的数量
			var buyLimit = $(_pageId+"#buyLimit").text();
			if(validatorUtil.isNumeric(buyLimit)){
				var turn = $(this).val();
				var stockNum = ((buyLimit*turn)/(100*lotsOf)).toFixed(0)*lotsOf;
				if(turn==100){
					stockNum = buyLimit;
				}
				$(_pageId+"#stockNum").val(stockNum);
				$(_pageId+"#stockNum").attr("placeholder","最大可买"+stockNum);
				totalValue();
			}
			e.stopPropagation();
		},"input");
		
		//现价委托和市价委托切换
		appUtils.bindEvent($(_pageId+".toggle_nav ul li"), function(e){
			$(_pageId+".input_select .select_box ul").css("display","none");
			$(this).addClass("active").siblings().removeClass("active");
			if($(this).index() == 0){
				limitedMarketEntrust = "limited";
				$(_pageId+".input_box.in").show();
				$(_pageId+".input_select.mt10").hide();
				totalValue();
			}else{
				limitedMarketEntrust = "market";
				$(_pageId+".input_box.in").hide();
				$(_pageId+".input_select.mt10").show();
				$(_pageId + ".ce_btn small").text("");
			}
			e.stopPropagation();
		},"click");
		
		//市价委托展开与隐藏
		appUtils.bindEvent($(_pageId+".input_select .select_box"), function(e){
			var buy_stockCode = $.trim($(_pageId+"#stockCode").val().substring(0,6));
			if(buy_stockCode.length == 0){
				layerUtils.iMsg(-1,"请输入股票代码");
				return;
			}	
			if(buy_stockCode.length < 5){
				layerUtils.iMsg(-1,"股票代码输入错误");
				return;
			}
			if($(_pageId+"#sz").css("display") == "block" || $(_pageId+"#sh").css("display") == "block"){
				$(_pageId+"#sz").css("display","none");
				$(_pageId+"#sh").css("display","none");
			}else{
				if(bazaarCode !== "" && bazaarCode == "SZ"){
					$(_pageId+"#sz").css("display","block");
					$(_pageId+"#sh").css("display","none");
				}else if(bazaarCode !== "" && bazaarCode == "SH"){
					$(_pageId+"#sz").css("display","none");
					$(_pageId+"#sh").css("display","block");
				}
			}
			e.stopPropagation();
		},"click");
		
		//市价委托选择
		appUtils.bindEvent($(_pageId+".input_select .select_box ul li"), function(e){
			$(_pageId+".input_select .select_box p").html($(this).find("a").text()).attr("id",$(this).attr("id"));
			$(this).parent().css("display","none");
			e.stopPropagation();
		},"click");
		
		//现价涨幅调行情
		appUtils.bindEvent($(_pageId+" #dd"), function(e){
			tradeToHq($(_pageId+".trade_form p.value span:eq(1)").find("em").text().trim());
			appUtils.setLStorageInfo("toHqDetails","");
			e.stopPropagation();
		},"click");
		/*appUtils.bindEvent($(_pageId+".trade_form p.value span:eq(3)"), function(e){
			tradeToHq($(this).find("em").text().trim());
			e.stopPropagation();
		},"click");*/
	}
	
	//计算当前总值
	function totalValue(){
		if($(_pageId+".toggle_nav ul li:eq(0)").attr("class") == "active" ){
			var stockNum = $(_pageId+"#stockNum").val();
			var stockCode = $.trim($(_pageId+"#stockCode").val().substring(0,6));
			var stockPrice = $(_pageId+"#stockPrice").val();
			if(stockCode && validatorUtil.isNumberFloat(stockPrice) && validatorUtil.isNumeric(stockNum)){
			$(_pageId+".ce_btn #total").show();
				$(_pageId+".ce_btn #total").text("(¥"+common.numToMoneyType(""+(stockPrice*stockNum).toFixed(2))+")");
			}else{
				$(_pageId+".ce_btn #total").hide();
			}
		}
	}
	
	/**
	 * 显示股票列表
	 * */
	function showStockList(data,source){
		if(data.error_no == 0){
			var results = data.results;
			if(results && results.length > 0 && results != null){
				$(_pageId+"#stock_list").html("");
				if(source != "1" && results.length == 1 && $(_pageId + "#stockCode").val().length == 6){
					$(_pageId+"#stock_list").html("");
					var market = results[0].market;
					var stockCode = results[0].code;
					getStockInfo(market,stockCode);
				}else{
					if(results.length >= 6){
						var selectHeight = 6 * 0.44;
					}else{
						selectHeight = 0.44*results.length;
					}
					
					var listHtml = "<ul style=\"display:block;overflow-y:auto;height:"+selectHeight+"rem\">";
					for(var i = 0;i < results.length; i++) {
//						listHtml += "<li><a href=\"javascript:void(0);\" style=\"padding-left:0.20rem;\"><strong style=\"font-size:0.18rem\">"+results[i].code+"</strong>"+results[i].name+"</a>";
//						listHtml +=	"<span style=\"display:none;\">"+results[i].market+"</span></li>";
						
						listHtml += "<li style='text-align:center;'><a href=\"javascript:void(0);\"><strong style=\"font-size:0.18rem\">"+results[i].code+"</strong>"+results[i].name+"</a>";
						listHtml +=	"<span style=\"display:none;\">"+results[i].market+"</span></li>";
					};
					listHtml+="</ul>";
					
					$(_pageId+"#stock_list").append(listHtml);
					
					appUtils.bindEvent($(_pageId+".trade_form .select_box ul li"),function(){
						var market = $(this).find("span").text();
						var stockCode = $(this).find("strong").text();
						$(_pageId+"#stock_list").html("");
						getStockInfo(market,stockCode);
					});
				}
			}else{
				showInterfaceStockList();   //从接口中直接获取股票列表
			}
		}
	}
	
	/**
	 * stockStr：股票代码
	 * 获取股票列表（根据股票代码获取股票列表）
	 * */
	function getStockList(stockStr){
		if(stockStr != ""){
			//表示的就是从壳子里面获取数据
			if(gconfig.platform != "0"){
				//查询股票码表
				var data = external.callMessage({"moduleName":"self-stock","funcNo": "60101","num":10,"searchKey":stockStr,"targetModule":"self-stock"});
				if(data.results > 0){
					showStockList(data,"0");
				}else{
					showInterfaceStockList();
				}
	        //平台表示就是浏览器
			}else{
				showInterfaceStockList();
			}
		}
	} 
	
	//调用接口查询股票下拉列表
	function showInterfaceStockList(){
		var stockStr = $.trim($(_pageId + "#stockCode").val().substring(0,6));
		var stockStrParam = {
		  "q" : stockStr
		};
		//根据股票代码，拼音简称，中文名称查询相应的股票信息
		service_hq.getStockList(stockStrParam,function(data){
			if(data.errorNo == 0){
				$(_pageId+"#stock_list").html("");
				var results = data.results;
				//显示股票列表
				if(results && results.length > 0){
					//返回的数据的条数是1，并且股票为六位数完整代码
					if(results.length == 1 && stockStr.length==6){
						$(_pageId+"#stock_list").html("");
						var market = results[0][9];//得到当前的这只股票是上市还是深市
						var stockCode = results[0][1];//得到返回的股票代码
						Market = market;
						StockCode = stockCode;
						/**
						 * market:SZ,SH
						 * stockCode:股票代码
						 */
						getStockInfo(market,stockCode);
					}else{
						if(results.length >= 6){
							var selectHeight = 6 * 0.44;
						}else{
							selectHeight = 0.44*results.length;
						}
						var listHtml = "<ul style=\"display:block;overflow-y:auto;height:"+selectHeight+"rem\">";
						for(var i = 0;i < results.length; i++) {
//									listHtml += "<li><a href=\"javascript:void(0);\" style=\"padding-left:0.20rem;\"><strong style=\"font-size:0.15rem\">"+results[i][1]+"</strong>"+results[i][0]+"</a>";
//									listHtml +=	"<span style=\"display:none;\">"+results[i][9]+"</span></li>";
							listHtml += "<li><a href=\"javascript:void(0);\"><strong style=\"font-size:0.10rem\">"+results[i][1]+"</strong>"+results[i][0]+"</a>";
							listHtml +=	"<span style=\"display:none;\">"+results[i][9]+"</span></li>";
						};
						listHtml+="</ul>";
						$(_pageId+"#stock_list").append(listHtml);
						appUtils.bindEvent($(_pageId+".trade_form .select_box ul li"),function(){
							var market = $(this).find("span").text();
							var stockCode = $(this).find("strong").text();
							$(_pageId+"#stock_list").html("");
							getStockInfo(market,stockCode);
						});
					}
				//表示调用接口没有出错（error_no返回的是0），但是没有查找到相应的数据
				}else{
					layerUtils.iAlert("该股票列表不存在");
                    _stockName = "";
				}
			}else{
				layerUtils.iAlert("获取股票列表失败");
			}
		},{"isShowWait":false});
	}
	

	/**
	 * 获取股票个股行情
	 * */
	function getStockInfo(market,stockCode){
		if(stockCode && market){
			if (fifthOrder_timer != null ) {
		        window.clearInterval(fifthOrder_timer);
		    }
			//传递的参数是市场和股票代码的拼接
			var stockStrParam = {
				"stock_list" : market+":"+stockCode
			};
			//查询个股行情（获取股票现价）
			service_hq.getStockNowPrice(stockStrParam,function(data){
			    //price_digit：要保留的小数点的位数，is_bond：证券类型
		    	if(data.errorNo == 0){
					var results = data.results;
					if(results && results.length>0){
						code_name_exch_mark = results[0][1]+","+results[0][0]+","+results[0][10]+","+results[0][9];
						bazaarCode = results[0][9];
                        $(_pageId+"#stock_list").html("");
						//$(_pageId+".mod_stock_item #stock_list").hide();
						$(_pageId+"#stockCode").val(""); // 每次修改股票代码，那么将初始值置为0
						if(results[0][15] == "1"){
							layerUtils.iAlert("该股票已停牌");
                            $(_pageId+"#stockName").text("股票名称");
							return false;
						}
						//results[0][2]表示的是现价，results[0][6]表示的是昨收（得到今日当前的价格）
						var price = results[0][2] ? results[0][2]:results[0][6];
						stkType = results[0][10];    //行情类别（exchange_type）
						/*--------- 0 ，获取证券应该保留的小数位数----------------*/
						var stockInfo = common.decimalKeep(stkType);
                        price_digit = stockInfo["keepNum"];
						is_bond = stockInfo["is_bond"];
						/*--------- 1 ，设置证券类型 ----------------*/
						var typeName = common.getStockType(stkType);
						$(_pageId + ".trade_form .select_box label").text(typeName);
						/*--------- 2 ，设置证券价格加减步长 ------------*/
						var price_step_const = [10,12,13,4,6,19,20,3,11,16];  //最小变动单位为0.001的
						var step_flag = $.inArray(stkType, price_step_const);
		                if(step_flag == -1){ //变动价格为0.01
							price_step = 0.01;
						}else{  // 变动价格为0.001
							price_step = 0.001;
						}
						var stockVal = results[0][1]; //股票代码
						if(stockVal.substring(0,3) == "204"){ // 上海国债逆回购
							price_step = 0.005;
						}
		                /*--------- 3 ，设置证券单位及数量步长 -----------*/
						if(is_bond == "1"){  //上海债券
							$(_pageId + ".limit span").text("手");
							$(_pageId + ".input_num em").text("手");
							lotsOf = 10;
						}else if(is_bond == "2"){  //深圳债券
							$(_pageId + ".limit span").text("张");
							$(_pageId + ".input_num em").text("张");
							lotsOf = 10;
						}else{  //其他股票
							up_stop = Number(results[0][13]).toFixed(price_digit);
							down_stop = Number(results[0][14]).toFixed(price_digit);
							$(_pageId + "#up_stop").html(up_stop).attr("class","ared");
							$(_pageId + "#down_stop").html(down_stop).attr("class","agreen");
							$(_pageId + ".limit span").text("股");
							$(_pageId + ".input_num em").text("股");
							lotsOf = 100;
						}

						//证券代码显示  
						$(_pageId + "#stockCode").val(results[0][1]+" "+results[0][0]);
						_stockName = results[0][0];
						var temp_stock = results[0][1]+" "+results[0][0];
						$(_pageId + "#stockCode").prev(".cursor_div").find(".cursor div").text(temp_stock);
						$(_pageId + "#stockCode").blur();
						//证券名称显示
						//$(_pageId + "#stockName").html(results[0][0]);
						stock_price = price.toFixed(price_digit);
						//$(_pageId + "#stockPrice").val(price);
						//保存此股票的市场类型
						//$(_pageId+ " .mod_stock_buy .fl").find("p").attr("id",results[0][9]);
						
						//保存此股票的信息
						var market = results[0][9];
						var stockCode = results[0][1];
						if(typeof market != "undefined" && market != "" && market != null && stockCode.length == "6"){
							var stockMsg = market+":"+stockCode;
							appUtils.setLStorageInfo("stockMsg",stockMsg);
						}
						//股票联动,查询股票信息，最大可买
						queryMaxAmount($.trim($(_pageId+"#stockCode").val().substring(0,6)),stkType);
						
						//调用五档行情
						var stock_list = results[0][9] + ":" + results[0][1];
						
						if (fifthOrder_timer != null ) {
					        window.clearInterval(fifthOrder_timer);
					    }
						isChangePrice = true;
						window.setTimeout(setFifthOrder(stock_list),100);
						if(global.isTrade){
							fifthOrder_timer =  window.setInterval(setFifthOrder(stock_list), 10000);//定时刷新
						}
					}else{
						$(_pageId+" .mod_stock_item #stock_list").hide();
						clearBuyMsg();
						layerUtils.iLoading(false);
						layerUtils.iAlert("该股票不存在");
                        _stockName = "";
					}
				}else{
					clearBuyMsg();
					layerUtils.iAlert(data.error_info);
				}
			},{"isLastReq":false,"isShowWait":false});
		}
	}
	
	//五档买卖盘
	function setFifthOrder(stock_list){
		 return function() {//为了解决定时器不能传参数的问题	 
			 if(stock_list){
				var fifthOrder = {
					"stock_list" : stock_list
				};
				service_hq.getStockFiveStep(fifthOrder,callbackFifthOrder,{"isShowWait":false});
			 } 
		 };

	}
	//回调五档买卖盘
	function callbackFifthOrder(data){
		if(data.errorNo == 0){
			var results = data.results;
			if(results && results.length>0){
				//现价
				$(_pageId + "#currentPrice").html("&nbsp;"+results[0][30].toFixed(2));
				stockType = results[0][2];
				//涨幅
				var gains = Number(results[0][36]);
				
				var css = "";
				if(gains == 0){
					css = "";
					gains = "0.00%";
				}else{
					if(gains > 0){
						css = "ared";
						gains = gains+"";
						gains = Number(gains.substring(gains.indexOf(".")+1,gains.indexOf(".")+3))+"."+gains.substring(gains.indexOf(".")+3,gains.indexOf(".")+5)+"%";
					}else{
						css = "agreen";
						gains = gains+"";
						gains = "-"+Number(gains.substring(gains.indexOf(".")+1,gains.indexOf(".")+3))+"."+gains.substring(gains.indexOf(".")+3,gains.indexOf(".")+5)+"%";
					}
				}
				$(_pageId + "#gains").html("&nbsp;"+gains).attr("class",css);
				$(_pageId + "#currentPrice").attr("class",css);
//				$(_pageId + "#dd").show().css("color","#0389d2");
				
				$(_pageId+"#stock_list").html("");
				var stock_gear = $(_pageId+" .five_box ul li");
				//昨收
				var yesProfit = Number(results[0][26]).toFixed(price_digit);
				if(isChangePrice){
					//股票现价
					var nowPrice = Number(results[0][30]).toFixed(price_digit);
					var sell_one = Number(results[0][15]);//卖一的数量
					if(nowPrice == up_stop || sell_one == 0){   //如果现价和涨停价相等，取现价
						$(_pageId + "#stockPrice").val(nowPrice);
					}else{   //如果现价和涨停价不相等，取卖一的价格
						$(_pageId + "#stockPrice").val(Number(results[0][10]).toFixed(price_digit));   //results[0][10]).toFixed(price_digit)表示的是卖价1
					}
					isChangePrice = false;
				}
				/**
				 * 此处逻辑:买卖五档盘也是根据昨收作比较,将受到的五档盘颜色信息保存在集合中,在给五档盘价格赋值和样式
				 */
				//卖五档盘颜色集合
				var soldFiveOrder = [];
				for(var i = 0 ; i < 5 ; i ++){   //卖价5,4,3,2,1
					var fivePirce = results[0][(i+6)];
					if(yesProfit < fivePirce){
						soldFiveOrder[i] = "ared";
					}else if(yesProfit >fivePirce){
						soldFiveOrder[i] = "agreen";
					}else{
						soldFiveOrder[i] = "";
					}
				}
				//买五档盘颜色集合
				var buyFiveOrder = [];
				for(var i = 0 ; i < 5 ; i ++){   //买价1,2,3,4,5
					var fivePirce = results[0][(i+16)];
					if(yesProfit < fivePirce){
						buyFiveOrder[i] = "ared";
					}else if(yesProfit >fivePirce){
						buyFiveOrder[i] = "agreen";
					}else{
						buyFiveOrder[i] = "";
					}
				}
				//卖
				stock_gear.eq(0).find("span").text(Number(results[0][6]).toFixed(price_digit)).attr("class",soldFiveOrder[0]);
				stock_gear.eq(0).find("em").text(overAMillion(results[0][11]));
				stock_gear.eq(1).find("span").text(Number(results[0][7]).toFixed(price_digit)).attr("class",soldFiveOrder[1]);
				stock_gear.eq(1).find("em").text(overAMillion(results[0][12]));
				stock_gear.eq(2).find("span").text(Number(results[0][8]).toFixed(price_digit)).attr("class",soldFiveOrder[2]);
				stock_gear.eq(2).find("em").text(overAMillion(results[0][13]));
				stock_gear.eq(3).find("span").text(Number(results[0][9]).toFixed(price_digit)).attr("class",soldFiveOrder[3]);
				stock_gear.eq(3).find("em").text(overAMillion(results[0][14]));
				stock_gear.eq(4).find("span").text(Number(results[0][10]).toFixed(price_digit)).attr("class",soldFiveOrder[4]);
				stock_gear.eq(4).find("em").text(overAMillion(results[0][15]));
				//买
				stock_gear.eq(5).find("span").text(Number(results[0][16]).toFixed(price_digit)).attr("class",buyFiveOrder[0]);
				stock_gear.eq(5).find("em").text(overAMillion(results[0][21]));
				stock_gear.eq(6).find("span").text(Number(results[0][17]).toFixed(price_digit)).attr("class",buyFiveOrder[1]);
				stock_gear.eq(6).find("em").text(overAMillion(results[0][22]));
				stock_gear.eq(7).find("span").text(Number(results[0][18]).toFixed(price_digit)).attr("class",buyFiveOrder[2]);
				stock_gear.eq(7).find("em").text(overAMillion(results[0][23]));
				stock_gear.eq(8).find("span").text(Number(results[0][19]).toFixed(price_digit)).attr("class",buyFiveOrder[3]);
				stock_gear.eq(8).find("em").text(overAMillion(results[0][24]));
				stock_gear.eq(9).find("span").text(Number(results[0][20]).toFixed(price_digit)).attr("class",buyFiveOrder[4]);
				stock_gear.eq(9).find("em").text(overAMillion(results[0][25]));
			}
		}else{
			if (fifthOrder_timer != null ) {
		        window.clearInterval(fifthOrder_timer);
		    }
			layerUtils.iAlert(data.error_info);
		}
	}
	//数量过万改以万为单位
	function overAMillion(num){
		num = Number(num);
		if(num >= 10000){
			num = (num/10000).toFixed(2) + "万";
		}
		return num;
	}
	
	/**
	 * 查询买入可用资金最大可买数量
	 * stockCode：股票代码
	 * stkType：exchange_type
	 * */
	function queryMaxAmount(stockCode,stkType){
		if(!stockCode){
			return false;
		}
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no  = userInfo.branch_no;	//分支机构
		var fund_account = userInfo.fund_account;	//资产账户
		var cust_code = userInfo.cust_code;	//客户代码
		var password = userInfo.password;
		var sessionid = userInfo.session_id;
		var entrust_bs = "0";
		var stock_code =stockCode;
		var entrust_price = stock_price;
		var exchange_type = stkType;
		var account = JSON.parse(appUtils.getSStorageInfo("stock_stockAccount"));
		var stk = "19";
		if ((stkType == "9")||(stkType == "11")||(stkType == "12")||(stkType == "13")||(stkType == "14")||(stkType == "15")||(stkType == "16")||(stkType == "20")||(stkType == "25")||(stkType == "26")||(stkType == "27")||(stkType == "30")||(stkType == "65")||(stkType == "66")){
			stk = "15";
		} else if (stkType == "10"){
			stk = "10";
		} else if (stkType == "17"){
			stk = "17";
		}
		var param = {
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"sessionid":sessionid,
				"entrust_bs":entrust_bs,
				"stock_code":stock_code,
				"entrust_price":entrust_price,
	            "newstock_flag":"",
	            "exchange_type":exchange_type,
	            "stock_account": account[stk]
			};
		service_stock.queryStockMaxBuy(param,queryMaxAmountCallBack,{"isLastReq":true,"isShowWait":false});
	}
	function queryMaxAmountCallBack(data){
		if(data.error_no == 0){
			var results = data.results;
			if(results.length>0){
				$(_pageId+"#buyLimit").text(Number(results[0].stock_max_amount));
				enable_balance = Number(results[0].enable_balance);
				$(_pageId+".stat").show();
				$(_pageId+".stat span").text("最大可买:"+results[0].stock_max_amount);
				//$(_pageId+"#stockPrice").val(Number(results[0].price).toFixed(price_digit));
				//$(_pageId+"#stockName").text(results[0].stock_name);
				_market=results[0].exchange_type;
				_stockAccount=results[0].stock_account;
			}
		}else{
			$(_pageId+"#stockNum").blur();
			layerUtils.iAlert(data.error_info);
		}
	}
	
	
	
	/**
	 * 下单验证
	 * */
	function vailSubmitOrder(){
		//验证股票代码输入是否正确
		var buy_stockCode = $.trim($(_pageId+"#stockCode").val().substring(0,6));
		if(buy_stockCode.length == 0){
			layerUtils.iMsg(-1,"请输入股票代码");
			return false;
		}	
		if(buy_stockCode.length <5){
			layerUtils.iMsg(-1,"股票代码输入错误");
			return false;
		}
		
		//验证股票价格输入是否正确
		var now_price = $(_pageId+"#stockPrice").val();
		var up_stop = $(_pageId+"#up_stop").text();
		var down_stop = $(_pageId+"#down_stop").text();
		if($.trim(now_price).length<=0 || parseFloat(now_price)<=0){
			layerUtils.iMsg(-1,"请输入买入价格");
			return false;
		}else if(!validatorUtil.isNumberFloat(now_price)){
			layerUtils.iMsg(-1,"请正确输入价格");
			return false;
		}
//		else if(parseFloat(up_stop) < parseFloat(now_price)){
//			layerUtils.iMsg(-1,"委托价格不能超过涨停价");
//			$(_pageId+"#stockName").text("股票名称");
//			return false;
//		}else if(parseFloat(down_stop) > parseFloat(now_price)){
//			layerUtils.iMsg(-1,"委托价格不能低于跌停价");
//			return false;
//		}
		
		//验证最大可买
		var mostBuy = $(_pageId+"#buyLimit").text();
		/*if($.trim(mostBuy).length<=0 || parseFloat(mostBuy)<=0){
			layerUtils.iMsg(-1,"最大可买为0");
//			return false;
		}*/
		
		//验证买入数量
		var mountBuy = $(_pageId+"#stockNum").val();
		if(!validatorUtil.isNumeric(mountBuy)){
			layerUtils.iMsg(-1,"请输入买入数量");
			return false;
		}else if(mountBuy==0){
			layerUtils.iMsg(-1,"数量必须大于0");
			return false;
		}
//		else if(mountBuy%Number(lotsOf)!=0){
//			layerUtils.iMsg(-1,"买入数量应为"+lotsOf+"的倍数");
//			return false;
//		}else if(parseFloat(buyLimit)<parseFloat(mountBuy)){
//			layerUtils.iMsg(-1,"最大可买数量不足");
//			return false;
//		}else if(mountBuy>=1000000){
//			layerUtils.iMsg(-1,"买入数量必须小于100万股");
//			return false;
//		}
		
		if($(_pageId+".toggle_nav ul li:eq(1)").attr("class") == "active"){
			if($(_pageId + ".select_box p").text().replaceAll(" ","") == "--"){
				layerUtils.iMsg(-1,"请选择委托方式");
				return false;
			}
		}
		
		
		var exchange_type=_market;
		if(!exchange_type){
			layerUtils.iMsg(-1,"市场类别不能为空！");
			return false;
		}
		var tipStr ="<div class=\"pop_header\">";
		tipStr+="<h3>委托买入</h3>";
		tipStr+="</div>";
		tipStr+="<div class=\"pop_main\">";
		tipStr+="<ul>";
	    tipStr+="    <li>证券名称 <em>"+$(_pageId+"#stockCode").val().substring(7)+"</em></li>";
		tipStr+="    <li>证券代码 <strong>"+buy_stockCode+"</strong></li>";
		
		if($(_pageId+".toggle_nav ul li:eq(0)").attr("class") == "active"){
			tipStr+="    <li>委托价格 <strong>"+now_price+"</strong></li>";
		}else if($(_pageId+".toggle_nav ul li:eq(1)").attr("class") == "active"){
			tipStr+="    <li>市价委托 <strong>"+$(_pageId + ".select_box p").text()+"</strong></li>";
		}
		
		tipStr+="    <li>委托数量 <strong>"+mountBuy+"</strong></li>";
		tipStr+="</ul>";
		tipStr+="  </div>";
		
		common.btnConfirm(tipStr,function success(){
			var cust_code = userInfo.cust_code;	//客户代码
			var fund_account = userInfo.fund_account;	//资产账户
			var branch_no  = userInfo.branch_no;	//分支机构
			var sessionid=userInfo.session_id;
			var entrust_way= global.entrust_way; // 委托方式  在configuration配置
			var password=userInfo.password;
			var entrust_bs = entrustBs;		
			var stock_account=_stockAccount;
			var stock_code=buy_stockCode;
			var entrust_price=now_price;
			var entrust_amount=mountBuy;
			var param = {
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"sessionid":sessionid,
				"entrust_bs":entrust_bs,
				"exchange_type":exchange_type,
				"stock_account":stock_account,
				"stock_code":stock_code,
				"entrust_price":entrust_price,
				"entrust_amount":entrust_amount,
			};
			service_stock.getStockBuy(param,getStockBuyCallBack);
		},function fail(){
			
		});
	}
	
	/**
	 * 委托下单返回
	 * */
	function getStockBuyCallBack(data){
		if(data.error_no == 0){
			var results = data.results;
			if(results && results.length>0){
				//再次调用持仓查询
				commonFunc.queryPosition(_pageId,1);
				layerUtils.iAlert(data.error_info);
				clearBuyMsg();
				$(_pageId + "#stockCode").val("");
			}
		}else{
			layerUtils.iAlert(data.error_info);
			clearBuyMsg();
			$(_pageId + " #stockCode").val("");
		}
	}
	
	function tradeToHq(emValue){
		if(emValue == "--"){
			return;
		}
		appUtils.setLStorageInfo("toHqDetails","toHqDetails");
		var cnemArr = code_name_exch_mark.split(",");
		external.callMessage({"funcNo": "50101","moduleName":"tradeToHq","params":{"stock_code":cnemArr[0],"stock_name":cnemArr[1],"exchange_type":cnemArr[2],"market":cnemArr[3]}});
	}
	
	/**
	 * 重置买卖页面数据  
	 */
	function clearBuyMsg(){
//		$(_pageId + "#dd").hide();
		$(_pageId + "#currentPrice").html("&nbsp;--");
		$(_pageId + "#gains").html("&nbsp;--");
		if (fifthOrder_timer != null ) {
	        window.clearInterval(fifthOrder_timer);
	    }
		if (cursor_timer != null ) {
	        window.clearInterval(cursor_timer);
	        $(_pageId + ".trade_form .input_text .cursor_div .cursor em").css("opacity",0);
	    }
		cursor_num = 0;
		$(_pageId+".stat").hide();
		$(_pageId+".stat span").text("最大可买--");
		$(_pageId+".input_select .select_box p").html("--");
		$(_pageId + "#stockNum").prev(".cursor_div").find(".cursor div").text("");
		$(_pageId + "#stockCode").prev(".cursor_div").find(".cursor div").text("");
		$(_pageId+"#stock_list").html("");
		$(_pageId+"#stockName").text("股票名称");
		_market = "";
		$(_pageId+"#stockPrice").val("");	
		$(_pageId+"#stockNum").val("");
		$(_pageId+"#buyLimit").text("--");
		$(_pageId+"#up_stop").text("--");
		$(_pageId+"#down_stop").text("--");
		$(_pageId+".five_box ul li em").text("--");
		$(_pageId+".five_box ul li").removeClass("active");
		$(_pageId+".five_box ul li span").removeClass("agreen").removeClass("ared").text("--");
		$(_pageId+".ce_btn #total").hide();
		$(_pageId + ".limit span").text("股");
		$(_pageId + ".input_num em").text("股");
		$(_pageId+".input_slider .r1").val("0");
		$(_pageId + ".trade_form .select_box label").text("股票");
		$(_pageId+"#stockNum").attr("placeholder","");
		isChangePrice = true;
	}
	
	//左右自由滑动组件
	function myInitHIScroll(){
		if(mySHIscroll){
			mySHIscroll.destroy();
			mySHIscroll = null;
		}
		if(!mySHIscroll){
			var config = {
				//获取两个指定的格式的对象
				wrapper: $(_pageId+" #wrapper_hMainPanel"), //wrapper对象
				container: $(_pageId+" #container_hMainPanel"), //container对象
				//滑动操作后要执行的方法
				onScrollEnd : function(){
					//滑动完成之后的处理，非必传
				}
			};
			mySHIscroll = new shIscroll(config);
			window.wrapperObj = config.wrapperObj;
			$(_pageId+" #wrapper_hMainPanel").css("position", "initial");
		}
	}
	
	/**
	 * 光标显示定时器
	 */
	function cursorTimer(){
		cursor_timer =  window.setInterval(function(){
			if(cursor_num < 1){
				cursor_num = 1;
				if(cursor_timer_id == "stock_em"){
					$(_pageId + ".trade_form .input_text .cursor_div .cursor #stock_em").css("opacity",1);
				}else{
					$(_pageId + ".trade_form .input_text .cursor_div .cursor #num_em").text("");
					$(_pageId + ".trade_form .input_text .cursor_div .cursor #num_em").css("opacity",1);
				}
			}else{
				cursor_num = 0;
				if(cursor_timer_id == "stock_em"){
					$(_pageId + ".trade_form .input_text .cursor_div .cursor #stock_em").css("opacity",0);
				}else{
					$(_pageId + ".trade_form .input_text .cursor_div .cursor #num_em").text("");
					$(_pageId + ".trade_form .input_text .cursor_div .cursor #num_em").css("opacity",0);
				}
			}
		}, 700);//定时刷新
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId+".fund_table .ce_table tbody tr:eq(0)").siblings().remove();
		$(_pageId+".fund_table .ce_table").css("height","auto");
//		$(_pageId + "#dd").hide();
		limitedMarketEntrust = "limited";  //判断是限价委托和是市价委托
		entrustBs = "0";
		$(_pageId+".input_box.in").show();
		$(_pageId+".input_select.mt10").hide();
		 $(_pageId+".input_select .select_box p").html("--");
		 $(_pageId+".toggle_nav ul li:eq(0)").addClass("active").siblings().removeClass("active");
		 if (position_timer1 != null ) {
	         window.clearInterval(position_timer1);
	     }
		 commonFunc.clearTi();
		 clearBuyMsg();
	     userInfo = null;  //账号信息
		 price_step = 0.01; //步长
		 price_digit = 2; //小数点位数
		 fifthOrder_timer = null; //五档定时器
		 position_timer1 = null; //持仓定时器
		 lotsOf = 100; //每手数量
		 _stockAccount=""; //股东帐号
	     _market ="";   //交易市场
         _stockName = "";
         stock_price = "";
		 $(_pageId+"#stockCode").val("");
		 external.callMessage({"moduleName":"trade","funcNo": "50211"});
		 $(_pageId+".no_data").hide();
		 $(_pageId+".input_slider .r1").val("0");
		 $(_pageId + "#currentPrice").html("&nbsp;--");
		 $(_pageId + "#gains").html("&nbsp;--");
		 $(_pageId+".input_box.in").show();
		 $(_pageId + ".trade_form .input_text .cursor_div .cursor em").css("opacity",0);
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("stock/stockBuy","account/index",{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});