/**
 * 普通交易-撤单
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var layerUtils = require("layerUtils");
	var common = require("common");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var VIscroll = require("vIscroll");
	var vIscroll = {"scroll":null,"_init":false}; //上下滑动
	var service_stock = require("service_stock");
	var service_hq = require("service_hq");
    var _pageId = "#stock_stockCancel ";
    var entrustNo = ""; //撤单编号
	var exchangeType = ""; //市场类型
    var userInfo = null;
    var stock_name = "";
    var stock_code = "";
    var stock_num = "";  
    var stock_direction = "";
    var stock_account = "";
    var trPart;
    
    var shIscroll = require("shIscroll");
	var mySHIscroll = null;
	
    
    /**
     * 初始化
     */
	function init(){common.hideBottomBar();
		common.bindStockEvent(_pageId); //绑定头部菜单事件
		userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		queryCancellation(); //可撤单查询
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			appUtils.pageInit("stock/stockCancel","account/index",{});
		});
		
		//撤单取消
		appUtils.bindEvent($(_pageId + ".pop_footer .pop_btn a:eq(1)"), function(e){
			$(_pageId+".backdrop").hide();
			$(_pageId+".pop_box").hide();
		});
		
		//撤单确认
		appUtils.bindEvent($(_pageId + ".pop_footer .pop_btn a:eq(0)"), function(e){
			$(_pageId+".backdrop").hide();
			$(_pageId+".pop_box").hide();
			Cancellation();//撤单提交
		});
	}
    
	/**
	 * 可撤单查询
	 */
	function queryCancellation(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;
		var password = userInfo.password;
		var sessionid = userInfo.session_id;
		var param={				
			"entrust_way":entrust_way,
		    "branch_no":branch_no,
		    "fund_account":fund_account,
		    "cust_code":cust_code,
		    "password":password,
		    "sessionid":sessionid
		};
		//每次查询前,先将暂无数据隐藏
		$(_pageId+ ".no_data").hide();
		//最后一个函数为超时函数,在超时后,显示暂无数据,并且初始化滑动组件
		service_stock.queryTrustData(param,queryTrustDataCallback,{  //传给接口的json格式数据            
			"isLastReq":true,   
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){    //超时调用方法
				$(_pageId+ ".no_data").show();
				//初始化滑动组件
				initVIScroll();
				if(vIscroll._init){
					vIscroll.scroll.refresh();
				}
	        }
		});
	}
	
	/**
	 * 可撤单查询回调
	 */
	function queryTrustDataCallback(data){
		if (typeof(data) != undefined && typeof(data) != null) {
			if(data.error_no == 0){
				var results = data.results;
				var data1 = "";
				data1 += "<table border='0' cellspacing='0' cellpadding='0' class='ce_table' style='margin-top:-15px;padding-left:0px;table-layout:fixed;' id='table1'>";
				data1 += "<tbody>";
			    data1 += "<tr>";
			    data1 += "<th scope='col' style='padding-top: 24px;'>方向</th>";
			    data1 += "<th scope='col' style='padding-top: 24px;'>证券/代码 </th>";
			    data1 += "<th scope='col' style='padding-top: 24px;'>委托价/成交价</th>";
			    data1 += "<th scope='col' style='padding-top: 24px;'>委托数/成交数</th>";
			    data1 += "<th scope='col' style='padding-top: 24px;'>状态/时间</th>";
			    data1 += "<th scope='col' style='padding-top: 24px;'>合同号/日期 </th>";
			    data1 += "</tr>";
				if(results && results.length>0){
					for (var i=0;i<results.length;i++){
						data1 += queryTrustDataHTML(results[i]);
					}
					data1 += "</tbody>";
					data1 += "</table>";
					$(_pageId+"#container_hMainPanel").html(data1);
					
					//撤单事件
					appUtils.bindEvent($(_pageId+"#userShow .ce_table .part"), function(e){
						trPart = $(this);
						var entrust_no = $(this).attr("data-id");
						//获取市场类型（修复）
						var exchange_type = $(this).attr("data-exchange_type");
						stock_direction = $(this).attr("data-entrust_bs");
						stock_account =  $(this).attr("data-stock_account");
						//调用方法将市场类型（exchange_type）传过去
						isCancellation($(this),entrust_no,exchange_type);
						e.stopPropagation();
					},"click");
				}else{
					$(_pageId+ ".no_data").show();
					$(_pageId+ ".visc_pullUp").hide();
					$(_pageId+"#container_hMainPanel").html(data1);
				}
			}else{
				layerUtils.iAlert(data.error_info);
			}
		}else{
			  layerUtils.iAlert("查询失败");
		}
		if(!vIscroll._init){
			initVIScroll();
		}else{
//			vIscroll.scroll.refresh();
		}
		myInitHIScroll();
	}
	/**
	 * 可撤单查询HTML生成
	 */
	function queryTrustDataHTML(element){
		var price_digit = 2;
		var css = "";
		var entrust_name = "";
		var userShow = "";
		if(element.entrust_bs == "0"||element.entrust_bs == "4"||element.entrust_bs == "62"||element.entrust_bs == "64"||element.entrust_bs == "66"||element.entrust_bs == "68"||element.entrust_bs == "70" || element.entrust_bs == "14"){
			css = "buy_icon";
			entrust_name ="委托买入";
		}else if(element.entrust_bs == "1"||element.entrust_bs == "5"||element.entrust_bs == "63"||element.entrust_bs == "65"||element.entrust_bs == "67"||element.entrust_bs == "69"||element.entrust_bs == "71"){
			css = "sell_icon";
			entrust_name ="委托卖出";
		}
		if(element.entrust_name && element.entrust_name!==" " && element.entrust_name!==""){
			entrust_name = element.entrust_name;
		}
		userShow = element.stock_name+","+element.stock_code+","+entrust_name+","+element.entrust_price+","+element.entrust_amount+","+element.business_amount;
		var eleHtml = "";
		
        eleHtml+="<tr data-userShow='"+userShow+"' class=\"part\" data-exchange_type="+element.exchange_type+" data-id="+element.entrust_no+" data-entrust_bs="+element.entrust_bs+" data-stock_account="+element.stock_account+">";
        eleHtml+="<td class='"+css+"'><span style='display:none'>"+element.entrust_name+"</span></td>";
        eleHtml+="<td><strong>"+element.stock_name +"</strong><small>"+element.stock_code+"</small><span style=\"display:none\">"+element.stock_code+"</span></td>";
        eleHtml+="<td><span>"+Number(element.entrust_price).toFixed(price_digit)+"</span><span>"+Number(element.business_price).toFixed(price_digit)+"</span></td>";
        eleHtml+="<td><span>"+element.entrust_amount+"</span><span>"+element.business_amount+"</span></td>";
        eleHtml+="<td><span>"+element.entrust_state_name+"</span><span>"+element.entrust_time+"</span></td>";
        eleHtml+="<td><span>"+element.entrust_no+"</span><span>"+element.entrust_date+"</span></td>";
        eleHtml+="</tr>";
        return eleHtml;
	}
	/**
	 * 点击显示需要撤单的信息
	 */
	function isCancellation(dom,entrust_no,exchange_type){
		var trObjData = dom.attr("data-userShow");
		var trData = trObjData.split(",");
		entrustNo = entrust_no;
		exchangeType = exchange_type;
		$(_pageId+".backdrop").show();
		$(_pageId+".pop_box").show();
		
		$(_pageId+".pop_box .pop_main ul li:eq(0) em").text(trData[0]);
		$(_pageId+".pop_box .pop_main ul li:eq(0) strong").text(trData[1]);
		$(_pageId+".pop_box .pop_main ul li:eq(1) em").text(trData[2]);
		$(_pageId+".pop_box .pop_main ul li:eq(2) strong").text(trData[3]);
		$(_pageId+".pop_box .pop_main ul li:eq(3) strong").text(trData[4]);
		$(_pageId+".pop_box .pop_main ul li:eq(4) strong").text(trData[5]);
		
		stock_name = trData[0];
		stock_code = trData[1];
		stock_num = trData[3];
	}
	
	
	/**
	 * 确定撤单(显示点击的撤单的信息后点击确定后调用的方法的定义)
	 */
	function Cancellation(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;//
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var sessionid = userInfo.session_id;
		var password = userInfo.password;
		var batch_flag = "0";
		var entrust_no = entrustNo;
		var exchange_type = exchangeType;
		
		var param={				
			"entrust_way":entrust_way,
		    "branch_no":branch_no,
		    "fund_account":fund_account,
		    "cust_code":cust_code,
		    "password":password,
		    "sessionid":sessionid,
		    "entrust_no":entrust_no,
		    "batch_flag":batch_flag,
		    "exchange_type":exchange_type
		};
		service_stock.postCancelOrder(param,postCancelOrderCallback);
	}
    //确定撤单回调
	function postCancelOrderCallback(data){
		if (typeof data != "undefined" && data != null) {
			if (data.error_no == 0) {	
				if(typeof data.results[0] != "undefined" && data.results[0] != null ){
					//layerUtils.iAlert("撤单成功",function success(){stockTadeagain();});
//					var tipStr = "<div class=\"pop_main\" style=\"height: 50px;margin-top: 20px;font-size:0.15rem\"><div>撤单成功,是否市价追单?</div></div>";
//					common.btnConfirm(tipStr,function success(){
//							if(stock_direction == "0"){
//								appUtils.pageInit("stock/stockCancel","stock/stockBuy",{"stockCode":stock_code,"stockNum":stock_num});
//							}else{
//								appUtils.pageInit("stock/stockCancel","stock/stockSell",{"stockCode":stock_code,"stockNum":stock_num});
//							}
//						},
//						function fail(){
//							
//						}
//					);
					//stockTadeagain(); //市价追买追卖
					trPart.remove();
					layerUtils.iAlert(data.error_info);
				}else{
					layerUtils.iAlert(data.error_info);
				}
				queryCancellation(); //可撤单查询
			}else{  
				//layerUtils.iAlert("<div style=\"display:block;text-align:center;padding:0 16px;font-size:16px;word-break:break-all;\">"+data.error_info+"</div>");
				queryCancellation(); //可撤单查询
				layerUtils.iAlert(data.error_info);
			}
		}else{
			layerUtils.iAlert("撤单失败");
		}
		$(_pageId+"#table1").height(0);
		$(_pageId+"#table2").height(0);
	}
	
	/**
	 * 市价追买追卖
	 */
	function stockTadeagain(){
		var market_ = "";
		if(exchangeType == "0"){
			market_ = "SZ";
		}else if(exchangeType == "2"){
			market_ = "SH";
		}
		var stock_list = market_+":"+stock_code;
		var fifthOrder = {
				"stock_list" : stock_list
			};
			service_hq.getStockFiveStep(fifthOrder,function(data){
				if(data.errorNo == 0){
					var results = data.results;
					if(results && results.length>0){
						var stock_price = "";
						if(stock_direction == "0"){
							stock_price = Number(results[0][10]).toFixed(3);
							stock_direction = "市价追买";
						}else{
							stock_price = Number(results[0][16]).toFixed(3);
							stock_direction = "市价追卖";
						}
						var tipStr ="<div class=\"pop_header\">";
						tipStr+="<h3>"+stock_direction+"</h3>";
						tipStr+="</div>";
						tipStr+="<div class=\"pop_main\">";
						tipStr+="<ul>";
						tipStr+="    <li>证券名称 <em>"+stock_name+"</em></li>";
						tipStr+="    <li>证券代码 <strong>"+stock_code+"</strong></li>";
						tipStr+="    <li>委托价格 <strong>"+stock_price+"</strong></li>";
						tipStr+="    <li>委托数量 <strong>"+stock_num+"</strong></li>";
						tipStr+="</ul>";
						tipStr+="  </div>";
						common.btnConfirm(tipStr,function success(){
							var cust_code = userInfo.cust_code;	//客户代码
							var fund_account = userInfo.fund_account;	//资产账户
							var branch_no = userInfo.branch_no;	//分支机构
							var sessionid = userInfo.session_id;
							var entrust_way = global.entrust_way; // 委托方式  在configuration配置
							var password = userInfo.password;
							var entrust_bs = "0";		
							var entrust_price = stock_price;
							var entrust_amount = stock_num;
							var exchange_type = exchangeType;
							var param = {
									"entrust_way":entrust_way,
									"branch_no":branch_no,
									"fund_account":fund_account,
									"cust_code":cust_code,
									"password":password,
									"sessionid":sessionid,
									"entrust_bs":entrust_bs,
									"exchange_type":exchange_type,
									"stock_account":stock_account,
									"stock_code":stock_code,
									"entrust_price":entrust_price,
									"entrust_amount":entrust_amount,
								};
							service_stock.getStockBuy(param,function(data){
								if(data.error_no == 0){
									var results = data.results;
									if(results && results.length>0){
										layerUtils.iAlert(data.error_info);
									}
								}else{
									layerUtils.iAlert(data.error_info);
								}
							});
						},function fail(){
						});
					}
				}else{
					layerUtils.iAlert(data.error_info);
				}
			},{"isShowWait":false});
	}
	
	
	/**
	 * 初始化上下滑动组件
	 */
	function initVIScroll(){
		if(!vIscroll._init){
			var config = {
				"isPagingType": false,		//false表示是微博那种累加形式，true表示分页形式
				"visibleHeight": $(window).height() - $(_pageId+".header").height()- $(_pageId+".tab_nav").height() - 7,//显示内容区域的高度，当isPaingType为false时传
				"container": $(_pageId+" #v_container_funds_jj"),	
				"wrapper":$(_pageId+" #v_wrapper_funds_jj"),	
				"downHandle": function() {				//下拉获取上一页数据方法
					queryCancellation();
				},
				"upHandle": function() {
					
				},
				"wrapperObj": null
			};
			vIscroll.scroll = new VIscroll(config); 	//初始化，需要做if(!hIscroll._init)判断
			vIscroll._init = true; 						//尽量只初始化一次，保持性能
		}else{
			vIscroll.scroll.refresh();
		}
		$(_pageId + ".visc_pullUp").css("display","none");
	}
	
	
	//左右自由滑动组件
	function myInitHIScroll(){
		//if(!mySHIscroll){
			var config = {
				//获取两个指定的格式的对象
				wrapper: $(_pageId+" #wrapper_hMainPanel"), //wrapper对象
				container: $(_pageId+" #container_hMainPanel"), //container对象
				//滑动操作后要执行的方法
				onScrollEnd : function(){
					//滑动完成之后的处理，非必传
				}	
			};
			mySHIscroll = new shIscroll(config);
			window.wrapperObj = config.wrapperObj
			// 初始化table间距
		    $(_pageId+" #container_hMainPanel table").width($(_pageId+" #wrapper_hMainPanel div:eq(0)").width());
			var widthAll = $(_pageId+" #container_hMainPanel table").width();
			var $text = $(_pageId+" #container_hMainPanel table tr th");
			$text.each(function(){
				var textLen = $(this).text().length;
				var MAXLEN =32;
				$(this).width(widthAll*textLen*0.8/MAXLEN);
			});
			$(_pageId+" #wrapper_hMainPanel").css("position", "initial");
			var mainPanelHeight = $(_pageId+" #container_hMainPanel").height() + (+$(_pageId+" #container_hMainPanel").css("margin-top").slice(0, -2));
			$(_pageId+" #wrapper_hMainPanel").css("position", "initial").css("height", mainPanelHeight);
			//表示的就是头部导航显示的控制为四个
//			$(_pageId+" #container_hMainPanel th").width($(_pageId+" #wrapper_hMainPanel").width()*0.25);
//			//将滑动选中的元素li显示（在刚加载页面的时候除开第一个li元素是现实的，其他的li元素是隐藏的）
//			$(_pageId+" #container_hMainPanel th").show();
		//}
	}
	
	
	/**
	 * 销毁
	 */
	function destroy(){
	    entrustNo = "";
		exchangeType = "";
	    stock_name = "";
	    stock_code = "";
	    stock_num = "";  
	    stock_direction = "";
	    stock_account = "";
		$(_pageId+".search_table .ce_table").html("");
		mySHIscroll = null;
		if(vIscroll._init){
			vIscroll.scroll.refresh();
		}
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("stock/stockCancel","account/index",{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});