/**
 * 普通交易-持仓
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var layerUtils = require("layerUtils");
	var common = require("common");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var service_stock = require("service_stock");
	var VIscroll = require("vIscroll");
    var vIscroll = {"scroll":null,"_init":false}; //上下滑动
    var hIscroll = require("hIscroll");
    var initHIscroll = {"scroll":null,"_init":false}; 
    var canBuy = 0 ;//可用
    var market_val = 0 ;//市值
    var _pageId = "#stock_stockHolding ";
    var position_timer = null; //持仓定时器
    var position_timer1 = null; //持仓定时器
    var commonFunc = require("commonFunc");
    var userInfo = null;
    
    var shIscroll = require("shIscroll");
	var mySHIscroll = null;
    
    /**
     * 初始化
     */
	function init(){
		common.hideBottomBar();
		common.bindStockEvent(_pageId);  //绑定头部菜单事件
		userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		queryData();//查询持仓（页面所有数据的查询入口）
		//左右滑动组件
		initHIScroll();
		//上下滑动组件方法的调用
		initVIScroll();
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			appUtils.pageInit("stock/stockHolding","account/index",{});
			e.stopPropagation();
		});
		//转账
		appUtils.bindEvent($(_pageId + "#transfer"), function(e){
			appUtils.setSStorageInfo("whichAccount","stock_userInfo");
			appUtils.setSStorageInfo("whichPage","stock/stockHolding");
			appUtils.pageInit("stock/stockHolding","banking/transfer",{});
			e.stopPropagation();
		},"click");
	}
    
	/**
	 * 查询
	 */
	function queryData(){
		if (position_timer1 != null ) {
	        window.clearInterval(position_timer1);
	        position_timer1 = null;
	    }
		//查询资金账户
		queryCapital("0");
		
		//查询持仓
		queryPosition();
	}
	
	/**
	 * 资金账户查询
	 */
	function queryCapital(ids){
		var moneyType;
		if(ids != undefined && ids != null && ids != ""){
			moneyType = ids;
		}
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var password = userInfo.password;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "password":password,
			    "cust_code":cust_code,
			    "money_type":moneyType
		};
		//最后一个为超时处理函数
		service_stock.queryFundSelect(param,queryCapitalCallback,
		{  //传给接口的json格式数据            
		"isLastReq":true,                
		"isShowWait":false,
		"isShowOverLay":false
	    });
	}
	/**
	 * 资金账户查询回调
	 */
	function queryCapitalCallback(data){
		if (data && data!= "undefined"){
			if(data.error_no == 0){
				var results = data.results;
				if(results && results!= "undefined" && results.length >0){
					for(var i=0;i<results.length;i++){
						if(results[i].money_type=="0"){
							$(_pageId+"#RMB .hold_table tr:eq(0) td:eq(0) strong").text(common.numToMoneyType(""+Number(results[i].assert_val).toFixed(2)+""));//总资产
							$(_pageId+"#RMB .hold_table tr:eq(0) td:eq(2) strong").text(common.numToMoneyType(""+Number(results[i].market_val).toFixed(2)+""));//市值
							$(_pageId+"#RMB .hold_table tr:eq(1) td:eq(0) strong").text(common.numToMoneyType(""+Number(results[i].fetch_balance).toFixed(2)+""));//可取
							$(_pageId+"#RMB .hold_table tr:eq(1) td:eq(1) strong").text(common.numToMoneyType(""+Number(results[i].enable_balance).toFixed(2)+""));//可用
						}else if(results[i].money_type=="2"){
							$(_pageId+"#HKD .hold_table tr:eq(0) td:eq(0) strong").text(common.numToMoneyType(""+Number(results[i].assert_val).toFixed(2)+""));//总资产
							$(_pageId+"#HKD .hold_table tr:eq(0) td:eq(2) strong").text(common.numToMoneyType(""+Number(results[i].market_val).toFixed(2)+""));//市值
							$(_pageId+"#HKD .hold_table tr:eq(1) td:eq(0) strong").text(common.numToMoneyType(""+Number(results[i].fetch_balance).toFixed(2)+""));//可取
							$(_pageId+"#HKD .hold_table tr:eq(1) td:eq(1) strong").text(common.numToMoneyType(""+Number(results[i].enable_balance).toFixed(2)+""));//可用
						}else if(results[i].money_type=="1"){
							$(_pageId+"#Dollar .hold_table tr:eq(0) td:eq(0) strong").text(common.numToMoneyType(""+Number(results[i].assert_val).toFixed(2)+""));//总资产
							$(_pageId+"#Dollar .hold_table tr:eq(0) td:eq(2) strong").text(common.numToMoneyType(""+Number(results[i].market_val).toFixed(2)+""));//市值
							$(_pageId+"#Dollar .hold_table tr:eq(1) td:eq(0) strong").text(common.numToMoneyType(""+Number(results[i].fetch_balance).toFixed(2)+""));//可取
							$(_pageId+"#Dollar .hold_table tr:eq(1) td:eq(1) strong").text(common.numToMoneyType(""+Number(results[i].enable_balance).toFixed(2)+""));//可用
						}
					}
				}else{
					$(_pageId+".hold_table tr:eq(0) td:eq(0) strong").text("--");//总资产 
					$(_pageId+".hold_table tr:eq(0) td:eq(2) strong").text("--");//市值
					$(_pageId+".hold_table tr:eq(1) td:eq(0) strong").text("--");//可取
					$(_pageId+".hold_table tr:eq(1) td:eq(1) strong").text("--");//可用
				}
			}
			else{
				layerUtils.iAlert(data.error_info);
			}
		}
	}
	
	function queryPosition(){
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var sessionid = userInfo.session_id;
		var param={				
			"entrust_way":entrust_way,
		    "branch_no":branch_no,
		    "fund_account":fund_account,
		    "cust_code":cust_code,
		    "sessionid":sessionid
		};
		//查询股票的持仓数据服务层的调用
		service_stock.queryStockData(param,function(data){
			if (data && data != "undefined") {
				if(data.error_no == 0){
					var results = data.results;
					var data1 = "<tr><th scope='col'>证券/代码</th>";
				     data1+= "<th scope='col'>股份余额/可用</th>";
				     data1+= "<th scope='col'>市值/当前持仓</th>";
				     data1+= "<th scope='col'>盈亏/比例</th>";
				     data1+= "<th scope='col'>成本价/现价</th></tr>";
					if(results && results.length>0){
						var total_cost_balance = 0;//持仓数量X持仓成本
						var total_last_price = 0; //持仓数量X最新价
						var float_yk = 0; //浮动盈亏
						var marketJson = {"0": "SZ:", "1": "SZ:", "19": "SZ:", "9": "SH:", "10": "SH:", "15": "SH:", "17": "SH:"};
						var tMarket = "";
						for (var i=0;i<results.length;i++){ 
							 float_yk += Number(results[i].float_yk);//计数总浮动盈亏
							 total_cost_balance += Number(results[i].cost_amount)*Number(results[i].cost_price);
							 total_last_price += Number(results[i].cost_amount)*Number(results[i].last_price);
							 data1 += queryPositionHTML_stock(results[i]);
							 var exchange = marketJson[results[i].exchange_type];
						     tMarket += results.length - 1 === i ? exchange + "" + results[i].stock_code : exchange + "" + results[i].stock_code + "|";
						}
						$(_pageId+".no_data").hide();
						$(_pageId+".fund_table #table1").html(data1);
						//添加总浮动盈亏
						var css = "";
						var sign = "";
						//当浮动盈亏,浮动盈亏比例大于0 时,在前面添加一个 "+" 
						if(float_yk > 0){
							sign = "+";
							float_yk = "" + float_yk.toFixed(2);
							css = "ared";
						}else if(float_yk < 0){
							float_yk = "" + float_yk.toFixed(2);
							css = "agreen";
						}else{
							float_yk = "" + float_yk.toFixed(2);
							css = "";
						}
						$(_pageId+".hold_table tr:eq(0) td:eq(1) strong").text(sign + common.numToMoneyType(""+float_yk)).attr("class",css);//盈亏
						//卖出事件
						console.log(tMarket);
						// 刷新持仓市值
						if (position_timer){
							clearInterval(position_timer);
							position_timer = null;
						}
						position_timer = setInterval(function(){
							refreshNow(tMarket);
						}, 3000);
						appUtils.bindEvent($(_pageId+".fund_table .ce_table tr"), function(e){
							var stock_code = $(this).attr("id");
							var topage = "stock/stockSell";
							//点击卖出,跳转到买卖页面.
							appUtils.pageInit("stock/stockHolding",topage,{"stockCode":stock_code});
							e.stopPropagation();
						},"click");
					}else{

						$(_pageId+".no_data").show();
						$(_pageId+".fund_table #table1").html(data1);

					}
				}else{
					layerUtils.iAlert(data.error_info);
				}
			}else{
				layerUtils.iAlert("查询失败");
			}
			
			if(!vIscroll._init){
				initVIScroll();
			}else{
				vIscroll.scroll.refresh();
			}
			//左右自由滑动组件初始化
			myInitHIScroll();
		},{"isLastReq":true,"isShowWait":false,"isShowOverLay":false});
		// 5 分钟刷新持仓
		if (position_timer1){
			clearTimeout(position_timer1);
			position_timer = null;
		}
		position_timer = setTimeout(function(){
			queryPosition(_pageId, whichPage);
		}, 5 * 60 * 1000);
	}
	
	/**
	 * 定时刷新持仓
	 */
	function refreshNow(tMarket){
		// 调用行情接口，获取行情现价 
		commonFunc.getNowPriceForTrade(function(now_price_json){
			for (var i in now_price_json){
				// 现价
				var now_price = now_price_json[i],
					$target = $(_pageId + " #" + i),
					// 当前持有数量
					cost_amount = $target.attr("data-mkt_qty"),
					// 当前成本
					cost_balance = $target.attr("data-cost_balance");
				// 现价
				$(_pageId + " #xianj_" + i).html(now_price);
				// 市值 = 现价 * 数量
				$(_pageId + " #shiz_" + i).html(Number(now_price * cost_amount).toFixed(2));
				// 盈亏 = 行情现价 * 数量 - 当前成本
				var yink = Number(now_price * cost_amount - cost_balance).toFixed(2),
				// 比例 = （行情现价*数量-当前成本）/当前成本
					bil = Number((now_price * cost_amount - cost_balance)/cost_balance * 100).toFixed(2),
					css_yb = "";
				if (yink > 0){
					css_yb = "ared";
				} else if (yink < 0){
					css_yb = "agreen";
				}
				$(_pageId + " #yingk_" + i).html(yink > 0 ? "+" + yink : yink).attr("class", css_yb);
				$(_pageId + " #bil_" + i).html(bil + "%").attr("class", css_yb);
			}
		}, tMarket);
	}
	/**
	 * 证券持仓HTML生成
	 */
	function queryPositionHTML_stock(element){ 		
		var price_digit = 2;
		var css = "";
		var float_yk = Number(element.float_yk);//浮动盈亏
		if(float_yk>0){
			float_yk = "+" + float_yk.toFixed(2);
			css = "ared";
		}else if(float_yk<0){
			css = "agreen";
			float_yk = float_yk.toFixed(2);
		}
		
       var eleHtml = "";
//       eleHtml += "<tr id="+element.stock_code +">" +
//       		"<td><strong>"+element.stock_name+"</strong><small>"+element.stock_code +"</small></td>"+
//       		"<td>"+Number(element.stock_balance).toFixed(0)+"<br/>"+element.enable_amount+"</td>" +
//       		"<td>"+Number(element.market_value).toFixed(price_digit)+"<br/>"+element.cost_amount+"</td>" +
//       		"<td><span class='"+css+"'>"+float_yk+"</span><span class='"+css+"'>"+element.float_yk_per+"%</span></td>" +
//       		"<td>"+element.cost_price+"<br/>"+element.last_price+"</td>" +
//       		"</tr>";
       eleHtml += "<tr id="+element.stock_code +" data-mkt_qty="+element.cost_amount+" data-cost_balance="+element.cost_balance+">" +
      	"<td><strong>"+element.stock_name+"</strong><small>"+element.stock_code +"</small></td>"+
 		"<td>"+Number(element.stock_balance).toFixed(0)+"<br/>"+element.enable_amount+"</td>" +
 		"<td><span id='shiz_"+element.stock_code+"'>"+Number(element.market_value).toFixed(2)+"</span><span>"+element.cost_amount+ "</span></td>"+
 		"<td><span id='yingk_"+element.stock_code+"' class='"+css+"'>"+float_yk+"</span><span id='bil_"+element.stock_code+"' class='"+css+"'>"+element.float_yk_per+"%</span></td>" +
 		"<td><span>"+element.cost_price+"</span><span id='xianj_"+element.stock_code+"'>"+element.last_price+ "</span></td>"+
 		"</tr>";
       return eleHtml;
	}
	
	/**
	 * 初始化上下滑动组件
	 */
	function initVIScroll(){
		if(!vIscroll._init){
			var config = {
				"isPagingType": false,		//false表示是微博那种累加形式，true表示分页形式
				"visibleHeight": $(window).height() - $(_pageId+".top_title").height()- $(_pageId+".tab_nav").height() + 56,	//显示内容区域的高度，当isPaingType为false时传
				"container": $(_pageId+" #v_container_funds_jj"),	
				"wrapper":$(_pageId+" #v_wrapper_funds_jj"),	
				"downHandle": function() {				//下拉获取上一页数据方法
					queryData();
				},
				"upHandle": function() {
				},
				"wrapperObj": null
			};
			vIscroll.scroll = new VIscroll(config); 	//初始化，需要做if(!hIscroll._init)判断
			vIscroll._init = true; 						//尽量只初始化一次，保持性能
			
		}else{
			vIscroll.scroll.refresh();
		}
		$(_pageId + ".visc_pullUp").css("display","none");//隐藏"上拉加载下一页"
	}
	
	/*
	 * ，初始化左右滑动组件
	 */
	function initHIScroll(){
		if(!initHIscroll._init){
			var config = {
					wrapper: $('#stock_stockHolding #wrapper_div'), //wrapper对象
					scroller: $('#stock_stockHolding #scroller_div'), //scroller对象
					perCount: 1,  //每个可视区域显示的子元素
					showTab: true, //是否有导航点
					tabDiv: $("#stock_stockHolding .dot"), //导航点集合对象
					auto: false, //是否自动播放
					interval: null, //自动播放定时器
					idxPage: 1, //记录当前scroll滚动到第几个page
					wrapperObj: null,
					onScrollEnd :function(e){//滑动后的回调函数
						$(_pageId+".dot em").each(function(e){
							var ems = $(this).attr("class");
							if(ems == "current active"){
								var ids = $(this).attr("id");
								//查询资金账户
								queryCapital(ids);
							}else{
							}
						});
					}
				};
			initHIscroll.scroll = new hIscroll(config); //初始化，需要做if(!hIscroll._init)判断
			initHIscroll._init = true; //尽量只初始化一次，保持性能
		} 
	}
	
	
	//左右自由滑动组件
	function myInitHIScroll(){
		if(mySHIscroll){
			mySHIscroll.destroy();
			mySHIscroll = null;
		}
		if(!mySHIscroll){
			var config = {
				//获取两个指定的格式的对象
				wrapper: $(_pageId+" #wrapper_hMainPanel"), //wrapper对象
				container: $(_pageId+" #container_hMainPanel"), //container对象
				//滑动操作后要执行的方法
				onScrollEnd : function(){
					//滑动完成之后的处理，非必传
				}	
			};
			mySHIscroll = new shIscroll(config);
			window.wrapperObj = config.wrapperObj;
			$(_pageId+" #container_hMainPanel table").width($(_pageId+" #wrapper_hMainPanel div:eq(0)").width());
			var widthAll = $(_pageId+" #container_hMainPanel table").width();
			var $text = $(_pageId+" #container_hMainPanel table tr th");
			$text.each(function(){
				var textLen = $(this).text().length;
				var MAXLEN = 29;
				$(this).width(widthAll*textLen*0.8/MAXLEN);
			});
			$(_pageId+" #wrapper_hMainPanel").css("position", "initial");
			var mainPanelHeight = $(_pageId+" #container_hMainPanel").height() + (+$(_pageId+" #container_hMainPanel").css("margin-top").slice(0, -2));
			$(_pageId+" #wrapper_hMainPanel").css("position", "initial").css("height", mainPanelHeight);
		}
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId+" #wrapper_hMainPanel").css("height", "initial").find("#table1").css("height", "initial");
		if (position_timer != null ) {
	        window.clearInterval(position_timer);
	        position_timer = null;
	    }
		if (position_timer1) {
	        window.clearTimeout(position_timer1);
	        position_timer1 = null;
	    }
	    canBuy = 0 ;//可用
	    market_val = 0 ;//市值
		$(_pageId+".hold_table tr:eq(0) td:eq(0) strong").text("--");//总资产
		$(_pageId+".hold_table tr:eq(0) td:eq(1) strong").text("--");//总盈亏
		$(_pageId+".hold_table tr:eq(0) td:eq(2) strong").text("--");//市值
		$(_pageId+".hold_table tr:eq(1) td:eq(0) strong").text("--");//可取
		$(_pageId+".hold_table tr:eq(1) td:eq(1) strong").text("--");//可用
		$(_pageId+".fund_table #table1").html("");
		$(_pageId+".no_data").hide();
		if(vIscroll._init){
			vIscroll.scroll.refresh();
		}

	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageInit("stock/stockHolding","account/index",{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});