/**
 * 普通交易-今日查询
 */
define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var common = require("common");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var layerUtils = require("layerUtils");
	var VIscroll = require("vIscroll");
	var service_stock = require("service_stock");
    var vIscroll = {"scroll":null,"_init":false};		//上下滑动
    var _pageId = "#stock_stockQueryToday ";
    var userInfo = null;
    var queryType = null; //查询内容
    var _entrustNo = "";
    var _exchangeType = "";
    var shIscroll = require("shIscroll");
	var mySHIscroll = null;
    /**
     * 初始化
     */
	function init(){common.hideBottomBar();
		userInfo = JSON.parse(appUtils.getSStorageInfo("stock_userInfo"));
		queryType = appUtils.getPageParam("param");
		if(queryType=="entrust_index"){
			$(_pageId + ".top_title .icon_back").text("");
			$(_pageId + ".top_title h3").text("当日委托");
			$(_pageId+".tab_nav ul li:eq(0)").addClass("active").siblings().removeClass("active");
		}else if(queryType=="entrust_query"){
			$(_pageId + ".top_title .icon_back").text("");
			$(_pageId + ".top_title h3").text("当日委托");
			$(_pageId+".tab_nav ul li:eq(0)").addClass("active").siblings().removeClass("active");
		}else if(queryType=="deal_index"){
			$(_pageId + ".top_title .icon_back").text("");
			$(_pageId + ".top_title h3").text("当日成交");
			$(_pageId+".tab_nav ul li:eq(1)").addClass("active").siblings().removeClass("active");
		}else if(queryType=="deal_query"){
			$(_pageId + ".top_title .icon_back").text("");
			$(_pageId + ".top_title h3").text("当日成交");
			$(_pageId+".tab_nav ul li:eq(1)").addClass("active").siblings().removeClass("active");
		}
		$(_pageId+"#table1").height(0);
		$(_pageId+"#table2").height(0);
		callsQuery();
    }

	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		appUtils.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			var sCurPage = appUtils.getSStorageInfo("_curPage");
			var curPage = JSON.parse(sCurPage);
			var prePageCode = curPage.prePageCode;
			if(!prePageCode || prePageCode=="account/login"){
				prePageCode ="account/index";
			}
			appUtils.pageInit("stock/stockQueryToday",prePageCode,{});
		});
		
		//页面切换
		appUtils.bindEvent($(_pageId + ".tab_nav ul li"), function(e){
			if(vIscroll._init){
				vIscroll.scroll.destroy();
				vIscroll.scroll = null;
				vIscroll._init = false;
			}
			$(this).addClass("active").siblings().removeClass("active");
			$(_pageId + ".top_title h3").text($(this).find("a").text());
			
			$(_pageId+"#table1").height(0);
			$(_pageId+"#table2").height(0);
			
			//判断是点击的哪个标题跳转到对应的页面
			var flag = $(_pageId+".tab_nav ul li:eq(0)").hasClass("active");
			if(flag){
				$(_pageId+".search_table .ce_table").html("");
				queryType = "entrust_query";
				queryEntrust();
			}else{
				$(_pageId+".search_table .ce_table").html("");
				queryType = "deal_query";
				queryDeal();
			}
		});
		
		//撤单取消
		appUtils.bindEvent($(_pageId + ".pop_footer .pop_btn a:eq(1)"), function(e){
			$(_pageId+".backdrop").hide();
			$(_pageId+".pop_box").hide();
		});
		
		//撤单确认
		appUtils.bindEvent($(_pageId + ".pop_footer .pop_btn a:eq(0)"), function(e){
			$(_pageId+".backdrop").hide();
			$(_pageId+".pop_box").hide();
			Cancellation(_entrustNo,_exchangeType);//撤单提交
		});
	}
    
	/**
	 * 调用查询
	 */
	function callsQuery(){
		if(queryType=="entrust_query" || queryType=="entrust_index" ){
			$(_pageId+".search_table .ce_table").html("");
			queryEntrust();
		}else{
			$(_pageId+".search_table .ce_table").html("");
			queryDeal();
		}
	}
	
	
	/**
	 * 委托查询
	 */
	function queryEntrust(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;
		var password = userInfo.password;;
		var sessionid=userInfo.session_id;
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "cust_code":cust_code,
			    "password":password,
			    "sessionid":sessionid
			};
			$(_pageId+ ".no_data").hide();
			service_stock.queryTodayTrust(param,queryEntrustCallback,
				{
				"isLastReq":true,
				"isShowWait":true,
				"isShowOverLay":false,
				"timeOutFunc":function(){
					$(_pageId+ ".no_data").show();
					initVIScroll();
				}
			});
	}
	
	/**
	 * 委托查询回调
	 */
	function queryEntrustCallback(data){
		if (typeof(data) != "undefined" && data) {
			$(_pageId+".search_table .ce_table").html("");
			if(data.error_no == 0){
				$(_pageId+".no_data").hide();
				var results = data.results;
				var data1 = "";
				data1 += "<div id='wrapper_hMainPanel' data-iscrollPageId='stock_stockQueryToday'>";
				data1 += "<div>";
				data1 += "<div class='search_table mt10' id='container_hMainPanel'>";
				data1 += "<table border='0' cellspacing='0' cellpadding='0' class='ce_table' style='margin-top:-15px;padding-left:0px;table-layout:fixed;width:450px;' id='table1'>";
				data1 += "<tbody>";
				data1 += "<tr><th scope='col' style='padding-top: 24px;'>方向</th><th scope='col' style='padding-top: 24px;'>证券/代码</th><th scope=\"col\" style='padding-top: 24px;'>委托价/均价</th><th scope=\"col\" style='padding-top: 24px;'>委托数/成交</th><th scope=\"col\" style='padding-top: 24px;'>成交金额/状态</th><th scope=\"col\" style='padding-top: 24px;'>合同编号/日期</th></tr>";
				if(results.length > 0 && results!= "undefined"){
					for (var i=0;i<results.length;i++){
						data1 += queryEntrustHTML(results[i]);
					}
					data1 += "</tbody>";
					data1 += "</table>";
					data1 += "</div>";
					data1 += "</div>";
					data1 += "</div>";
					$(_pageId+"#mainShow").html(data1);
					
					//为每条当日委托记录添加绑定事件
					appUtils.preBindEvent($(_pageId + ".search_table .ce_table"),"tr",function(e){
						if(queryType=="entrust_query" || queryType=="entrust_index"){
							//获取当前委托的状态(看能否能撤单)
							var entrusState = $(this).find("td:eq(4) span:eq(1)").text();
							var codeNoArray = $(this).attr("id").split(",");
							//获取委托编号
							var entrustNo = codeNoArray[0];
							_entrustNo = entrustNo;//全局变量，撤单时要用到这个参数
							//获取证券编号
							var stockCodes = codeNoArray[1];
							
							var exchangeType = codeNoArray[2];
							_exchangeType = exchangeType;
							
							//获取证券名称
							var entrustName = $(this).find("td:eq(1) strong").text();
							//委托价格
							var businessPrice = $(this).find("td:eq(2)").find("span:eq(0)").text();
							//委托数量
							var businessAmount = $(this).find("td:eq(3)").find("span:eq(0)").text();
							//成交数量
							var entrustAmount = $(this).find("td:eq(3)").find("span:eq(1)").text();
							
							//委托买入还是委托卖出
							var stockEntrust = $(this).find("td:first").attr("class");
							var entName = "";
							if(stockEntrust == "buy_icon"){
								entName ="委托买入";
							}else{
								entName ="委托卖出";
							}
							
							if(entrusState == "已成" || entrusState == "已撤" || entrusState == "部撤"){
								layerUtils.iAlert("该委托不接受撤单！");
							}else{
								isCancellation(entrustName,stockCodes,entName,businessPrice,businessAmount,entrustAmount);
							}
						
						}
						e.stopPropagation();
					},"click");
				}else{
					$(_pageId+".no_data").show();
					data1 += "</tbody>";
					data1 += "</table>";
					data1 += "</div>";
					data1 += "</div>";
					data1 += "</div>";
					$(_pageId+"#mainShow").html(data1);
				}
				myInitHIScroll();
			}else{
				layerUtils.iAlert(data.error_info);
			}
		}
		else{
			  layerUtils.iAlert("查询失败");
		}
//		myInitHIScroll();
		if(!vIscroll._init){
			initVIScroll();
		}else{
			//vIscroll.scroll.refresh();
		}
	}
	
	
	/**
	 * 点击显示需要撤单的信息
	 */
	function isCancellation(entrustName,entrustNo,enName,businessPrice,businessAmount,entrustAmount){
		$(_pageId+".backdrop").show();
		$(_pageId+".pop_box").show();
		$(_pageId+".pop_box .pop_main ul li:eq(0) em").text(entrustName);
		$(_pageId+".pop_box .pop_main ul li:eq(0) strong").text(entrustNo);
		$(_pageId+".pop_box .pop_main ul li:eq(1) em").text(enName);
		$(_pageId+".pop_box .pop_main ul li:eq(2) strong").text(businessPrice);
		$(_pageId+".pop_box .pop_main ul li:eq(3) strong").text(businessAmount);
		$(_pageId+".pop_box .pop_main ul li:eq(4) strong").text(entrustAmount);
	}
	
	/**
	 * 委托查询HTML生成
	 */
	function queryEntrustHTML(element){
		var price_digit = 2;
		var css = "";
		var entrust_name = "";
		if(element.entrust_bs == "0"||element.entrust_bs == "4"||element.entrust_bs == "62"||element.entrust_bs == "64"||element.entrust_bs == "66"||element.entrust_bs == "68"||element.entrust_bs == "70" || element.entrust_bs == "14"){
			css = "buy_icon";
			entrust_name ="委托买入";
		}else if(element.entrust_bs == "1"||element.entrust_bs == "5"||element.entrust_bs == "63"||element.entrust_bs == "65"||element.entrust_bs == "67"||element.entrust_bs == "69"||element.entrust_bs == "71"){
			css = "sell_icon";
			entrust_name ="委托卖出";
		}else{
			css = "";
		}
		if(element.entrust_name && element.entrust_name!==" " && element.entrust_name!==""){
			entrust_name = element.entrust_name;
		}
        var eleHtml = "";
        eleHtml+="<tr id='"+element.entrust_no+","+element.stock_code+","+element.exchange_type+"'>"
        eleHtml+="<td class='"+css+"'></td><td><strong>"+element.stock_name +"</strong><small>"+element.stock_code+"</small></td>";
        eleHtml+="<td><span>"+Number(element.entrust_price).toFixed(price_digit)+"</span><span>"+Number(element.business_price).toFixed(price_digit)+"</span></td>";
        eleHtml+="<td><span>"+element.entrust_amount+"</span><span>"+element.business_amount+"</span></td>";
        
        if(element.entrust_bs == 0 || element.entrust_bs == 1){
        	eleHtml+="<td><span>"+element.business_balance+"</span><span>"+element.entrust_state_name+"</span></td>";
        }else{
        	eleHtml+="<td><span style='font-size:12px;'>"+element.entrust_name+"</span><span>"+element.entrust_state_name+"</span></td>";
        }
        
        eleHtml+="<td><span>"+element.entrust_no+"</span><span>"+element.entrust_date+"</span></td>";
        eleHtml+="</tr>";
        console.log(element.entrust_name);
        return eleHtml;
	}
	
	/**
	 * 成交查询
	 */
	function queryDeal(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;//
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var password = userInfo.password;
		var sessionid = userInfo.session_id;
		var param={				
			"entrust_way":entrust_way,
		    "branch_no":branch_no,
		    "fund_account":fund_account,
		    "cust_code":cust_code,
		    "password":password,
		    "sessionid":sessionid
		};
		$(_pageId+ ".no_data").hide();
		service_stock.queryTodayTrade(param,queryDealCallback,
		    {
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){
				$(_pageId+ ".no_data").show();
				initVIScroll();
				if(vIscroll._init){
					vIscroll.scroll.refresh();
				}
			}
		});
	}
	/**
	 * 成交查询回调
	 */
	function queryDealCallback(data){
		if (typeof(data) != "undefined" && data != null) {
			$(_pageId+" .tarde_hit").html("");
			if(data.error_no == 0){
				$(_pageId+".no_data").hide();
				var results = data.results;
				var data1 = "";
				data1 += "<div id='wrapper_hMainPanel' data-iscrollPageId='stock_stockQueryToday'>";
				data1 += "<div>";
				data1 += "<div class='search_table mt10' id='container_hMainPanel'>";
				data1 += "<table border='0' cellspacing='0' cellpadding='0' class='ce_table' style='margin-top:-15px;padding-left:0px;table-layout:fixed;' id='table1'>";
				data1 += "<tbody>";
				data1 += "<tr><th scope='col' style='padding-top: 24px;'>方向</th><th scope='col' style='padding-top: 24px;'>证券/代码</th><th scope=\"col\" style='padding-top: 24px;'>成交数/成交价</th><th scope=\"col\" style='padding-top: 24px;'>成交金额/状态</th><th scope=\"col\" style='padding-top: 24px;'>合同号/日期</th></tr>";
				if(results != "undefined" && results.length>0){
					for (var i=0;i<results.length;i++){
						data1 += queryDealHTML(results[i]);
					}
					data1 += "</tbody>";
					data1 += "</table>";
					data1 += "</div>";
					data1 += "</div>";
					data1 += "</div>";
					$(_pageId+"#mainShow").html(data1);
				}else{
					$(_pageId+".no_data").show();
					data1 += "</tbody>";
					data1 += "</table>";
					data1 += "</div>";
					data1 += "</div>";
					data1 += "</div>";
					$(_pageId+"#mainShow").html(data1);
				}
				myInitHIScroll();
			}else{
				layerUtils.iAlert(data.error_info);
			}
		}else{
			  layerUtils.iAlert("查询失败");
		}
		if(!vIscroll._init){
			initVIScroll();
		}else{
			//vIscroll.scroll.refresh();
		}
	}
	/**
	 * 成交查询HTML生成
	 */
	function queryDealHTML(element){
		var price_digit = 2;
		var css = "";
		var entrust_name = "";
		if(element.entrust_bs == "0"||element.entrust_bs == "4"||element.entrust_bs == "62"||element.entrust_bs == "64"||element.entrust_bs == "66"||element.entrust_bs == "68"||element.entrust_bs == "70"){
			css = "buy_icon";
			entrust_name ="委托买入";
		}else if(element.entrust_bs == "1"||element.entrust_bs == "5"||element.entrust_bs == "63"||element.entrust_bs == "65"||element.entrust_bs == "67"||element.entrust_bs == "69"||element.entrust_bs == "71"){
			css = "sell_icon";
			entrust_name ="委托卖出";
		}else{
			css = "";
		}
		if(element.entrust_name && element.entrust_name!==" " && element.entrust_name!==""){
			entrust_name = element.entrust_name;
		}
        var eleHtml = "";
        eleHtml+="<tr>";
        eleHtml+="<td class='"+css+"'></td><td><strong>"+element.stock_name +"</strong><small>"+element.stock_code+"</small></td>";
        eleHtml+="<td><span>"+element.business_amount+"</span><span>"+Number(element.business_price).toFixed(price_digit)+"</span></td>";
        eleHtml+="<td><span>"+Number(element.business_balance).toFixed(price_digit)+"</span><span>"+element.real_status_name+"</span></td>";
        eleHtml+="<td><span>"+element.entrust_no+"</span><span>"+element.business_date+"</span></td>";
        eleHtml+="</tr>";
        return eleHtml;

	}
	
	/**
	 * 确定撤单(显示点击的撤单的信息后点击确定后调用的方法的定义)
	 */
	function Cancellation(entrustNo,exchangeType){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;//
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var sessionid = userInfo.session_id;
		var password = userInfo.password;
		var batch_flag = "0";
		var entrust_no = entrustNo;
		var exchange_type = exchangeType;
		var param={				
			"entrust_way":entrust_way,
		    "branch_no":branch_no,
		    "fund_account":fund_account,
		    "cust_code":cust_code,
		    "password":password,
		    "sessionid":sessionid,
		    "entrust_no":entrust_no,
		    "batch_flag":batch_flag,
		    "exchange_type":exchange_type
		};
		service_stock.postCancelOrder(param,postCancelOrderCallback);
	}
    //确定撤单回调
	function postCancelOrderCallback(data){
		if (typeof data != "undefined" && data != null) {
			if (data.error_no == 0) {
				//表示撤单成功
				if(typeof data.results[0] != "undefined" && data.results[0] != null ){
					$(_pageId + ".search_table .ce_table tbody").remove();
					setTimeout(callsQuery,800);
					layerUtils.iAlert(data.error_info);
				}else{
					layerUtils.iAlert(data.error_info);
				}
			}else{  
				//layerUtils.iAlert("<div style=\"display:block;text-align:center;padding:0 16px;font-size:16px;word-break:break-all;\">"+data.error_info+"</div>");
				layerUtils.iAlert(data.error_info);
			}
		}else{
			layerUtils.iAlert("撤单失败");
		}
	}
	
	/**
	 * 初始化滑动组件
	 */
	function initVIScroll(){
		if(!vIscroll._init){
			var config = {
					"isPagingType": false,//false表示是微博那种累加形式，true表示分页形式
					"visibleHeight": $(window).height() - $(_pageId+".top_title").height()- $(_pageId+".tab_nav").height() - 7,//显示内容区域的高度，当isPaingType为false时传
					"container": $(_pageId+"#v_container_funds_jj"),	
					"wrapper":$(_pageId+"#v_wrapper_funds_jj"),	
					"downHandle": function() {
						callsQuery();//下拉获取上一页数据方法
					},
					"upHandle": function() {	
						//上拉获取下一页数据方法
					},
					"wrapperObj": null
			};
			vIscroll.scroll = new VIscroll(config); 	//初始化，需要做if(!hIscroll._init)判断
			vIscroll._init = true;
		} else {
//			vIscroll.scroll.refresh();
		}
		$(_pageId+ ".visc_pullUp").hide();
	}
	
	//左右自由滑动组件
	function myInitHIScroll(){
		if(mySHIscroll){
			mySHIscroll.destroy();
			mySHIscroll = null;
		}
		var config = {
				//获取两个指定的格式的对象
				wrapper: $(_pageId+" #wrapper_hMainPanel"), //wrapper对象
				container: $(_pageId+" #container_hMainPanel"), //container对象
				//滑动操作后要执行的方法
				onScrollEnd : function(){
					//滑动完成之后的处理，非必传
				}	
		};
		mySHIscroll = new shIscroll(config);
		// 初始化table间距
	    $(_pageId+" #container_hMainPanel table").width($(_pageId+" #wrapper_hMainPanel div:eq(0)").width());
		var widthAll = $(_pageId+" #container_hMainPanel table").width();
		var $text = $(_pageId+" #container_hMainPanel table tr th");
		var MAXLEN = 31;
		if(queryType=="entrust_query" || queryType=="entrust_index" ){
			MAXLEN = 31;
		}else{
			MAXLEN = 27;
		}
		$text.each(function(){
			var textLen = $(this).text().length;
			$(this).width(widthAll*textLen*0.8/MAXLEN);
		});
		var mainPanelHeight = $(_pageId+" #container_hMainPanel").height() + (+$(_pageId+" #container_hMainPanel").css("margin-top").slice(0, -2));
		$(_pageId+" #wrapper_hMainPanel").css("position", "initial").css("height", mainPanelHeight);
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId+"#mainShow").html("");
		$(_pageId+".search_table .ce_table").html("");
		if(vIscroll._init){
			vIscroll.scroll.refresh();
		}
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		var sCurPage = appUtils.getSStorageInfo("_curPage");
		var curPage = JSON.parse(sCurPage);
		var prePageCode = curPage.prePageCode;
		if(!prePageCode || prePageCode=="account/login"){
			prePageCode ="account/index";
		}
		appUtils.pageInit("stock/stockQueryToday",prePageCode,{});
	}
	
	var base = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});