/**
 * 这里写模块内部的消息处理函数，供原生回调H5
 */
define(function(require, exports, module){
	var	gconfig = require("gconfig");
	var	global = gconfig.global;
	var appUtils = require("appUtils");
	var	layerUtils = require("layerUtils");
	var service_stock = require("service_stock");
	var oMyMsgFunction = {}; // 暴露给外部的对象
	var msgFunction = require("msgFunction"); // 加载 plugins 目录里面公用的 msgFunction
	
	/*将本文件里面的函数和 plugins 目录里面公用的 msgFunction 中的函数进行合并操作*/
	msgFunction.conbine(oMyMsgFunction);
	/*将本文件里面的函数和 plugins 目录里面公用的 msgFunction 中的函数进行合并操作，请务必将这句代码放在模块最前面*/
	
	/**
	 * 公用		
	 * 弹出通讯录，用于选择联系人的信息，选择完毕后回调H5
	 * 说明：通讯录插件的调用必须要写在页面UI的事件处理函数中，否则多模块开发原生无法获取到当前激活的模块从而导致无法回调H5
	 * @param funcNo 50223
	 * @param name String 名称 Y
	 * @param phone String 手机号码 Y
	 */
	oMyMsgFunction.function50223 = function(paramMap) 
	{
		var selPhoneCallback = window.selPhoneCallback; // 选择电话联系人的回调函数
		if(selPhoneCallback)
		{
			selPhoneCallback(paramMap);
		}
	};
	
	/**
	 * 公用		
	 * 日期控件回调H5
	 * 说明：日期控件的调用必须要写在页面UI的事件处理函数中，否则多模块开发原生无法获取到当前激活的模块从而导致无法回调H5
	 * @param funcNo 50251
	 * @param date String 日期 Y
	 * @param selector String H5的元素选择器 N
	 */
	oMyMsgFunction.function50251 = function(paramMap) 
	{
		paramMap = paramMap || {};
		var selDateCallback = window.selDateCallback; // 选择日期的回调函数
		if(selDateCallback)
		{
			selDateCallback(paramMap);
		}
	};
	
	/**
	 * reqParam[@"funcNo"] = @"50104"; //功能号
     * reqParam[@"moduleName"] = moduleName;
     * reqParam[@"theme"] = @(theme);  //主题
	 * 公用		
	 * 设置系统软件的主题风格
	 * @param funcNo 50104
	 * @param theme String 主题颜色(见数据字典) Y 0：红色，1：蓝色，2：黑色，3：黄色，9：绿色
	 */
	oMyMsgFunction.function50104 = function(paramMap) {
//		if(paramMap){
//			var $appCss = $("head>link[href*='" + gconfig.firstLoadCss[0] + "']");
//			//颜色值数组
//			var skinMap = {0: "red", 1: "blue", 2: "black", 3: "yellow", 9: "green"};
//			
//			//require("gconfig").global.*颜色值的拼接
//			var href = gconfig.cssPath + "style_" + skinMap[paramMap.theme] + ".css";
//			
//			gconfig.firstLoadCss[0] = href; // 修改当前皮肤对应的 css
//			$appCss.attr("href", href);
//			var originalOverflow = $("body").css("overflow");
//			$("body").css("overflow", "auto"); // 强制浏览器重绘
//			$("body").css("overflow", originalOverflow);
//		}
	};

	/**
	 * 公用		
	 * 原生的信息提示框回调H5
	 * @param funcNo 50111
	 * @param flag	String	业务标志	N
	 */
	oMyMsgFunction.function50111 = function(paramMap) 
	{
		if(paramMap)
		{
			layerUtils.iAlert(paramMap.flag);
		}
	};

	/**
	 * 公用		
	 * 通知H5分享后的状态
	 * @param funcNo 50232
	 * @param shareType	String	分享平台（数据字典）	Y
	 * @param flag	String	分享状态（0：失败，1：成功)	Y
	 * @param info	String	备注信息	N
	 */
	oMyMsgFunction.function50232 = function(paramMap) 
	{
		if(paramMap)
		{
			layerUtils.iAlert("通知H5分享后的状态50232" + JSON.stringify(paramMap));
		}
	};
	
	/**
	 * 公用		
	 * 验证手势密码中忘记密码，修改账号回调H5
	 * @param funcNo 50262
	 * @param type	String	类型(0：忘记密码，1：修改账号）	N
	 */
	oMyMsgFunction.function50262 = function(paramMap) 
	{
		if(paramMap)
		{
			layerUtils.iAlert("验证手势密码中忘记密码，修改账号回调H550262" + JSON.stringify(paramMap));
		}
	};

	/**
	 * 公用		
	 * 扫描图片二维码的内容回调给H5页面	
	 * @param funcNo 50272
	 * @param content	String	内容	Y
	 */
	oMyMsgFunction.function50272 = function(paramMap) 
	{
		if(paramMap)
		{
			layerUtils.iAlert("扫描图片二维码的内容回调给H5页面	50272" + JSON.stringify(paramMap));
		}
	};
	
	/**
	 * 行情跳转买卖			
	 * @param funcNo 50272
	 * @param content	String	内容	Y
	 */
	oMyMsgFunction.function60250 = function(paramMap) 
	{
		try{
			var type = paramMap.type;//买卖类型
			var code = paramMap.code;//股票代码
			var market = paramMap.market;//市场
			var toTrade = paramMap.toTrade;//市场
			var param = {"stockCode":code};
			appUtils.setSStorageInfo("_loginInPageParam",JSON.stringify(param));
			switch (type){
				// 普通买入
				case "buy":
					appUtils.setSStorageInfo("_loginInPageCode","stock/stockBuy");
					appUtils.pageInit(null,"stock/stockBuy",{"stockCode":code,"toTrade":toTrade});
					break;
				// 担保买入
				case "dbbuy":
					appUtils.setSStorageInfo("_loginInPageCode", "credit/order/ordinaryToBuy");
					appUtils.pageInit(null, "credit/order/ordinaryToBuy", {"stockCode": code, "toTrade": toTrade});
					break;
				// 融资买入
				case "rzbuy":
					appUtils.setSStorageInfo("_loginInPageCode", "credit/order/financingToBuy");
					appUtils.pageInit(null, "credit/order/financingToBuy", {"stockCode": code, "toTrade": toTrade});
					break;
				// 买券还券
				case "quanbuy":
					appUtils.setSStorageInfo("_loginInPageCode", "credit/order/buyTicketsRepay");
					appUtils.pageInit(null, "credit/order/buyTicketsRepay", {"stockCode": code, "toTrade": toTrade});
					break;
					//担保卖出
				case "dbsell":
					appUtils.setSStorageInfo("_loginInPageCode", "credit/order/ordinaryToSell");
					appUtils.pageInit(null, "credit/order/ordinaryToSell", {"stockCode": code, "toTrade": toTrade});
					break;
					//融资卖出
				case "rzsell":
					appUtils.setSStorageInfo("_loginInPageCode", "credit/order/financingToSell");
					appUtils.pageInit(null, "credit/order/financingToSell", {"stockCode": code, "toTrade": toTrade});
					break;
					//卖券还款
				case "quansell":
					appUtils.setSStorageInfo("_loginInPageCode", "credit/order/sellTicketsRepayment");
					appUtils.pageInit(null, "credit/order/sellTicketsRepayment", {"stockCode": code, "toTrade": toTrade});
					break;
				// 普通买入
				default:
					appUtils.setSStorageInfo("_loginInPageCode","stock/stockSell");
					appUtils.pageInit(null,"stock/stockSell",{"stockCode":code,"toTrade":toTrade});
					break;
			}
		}catch(e){
			console.log("H5获取股票买卖传入数据解析JSON出错"+e.message);
	    }
	};
	
	/**
	 * 原生跳转H5模块
	 * @param paramMap json格式参数
	 */
	oMyMsgFunction.function60251 = function(paramMap) 
	{
		try{
			var funcModules ={"0":"newshare/apply",
					          "1":"credit/asset/asset", 
					          "2":"ggt/ggtBuy",
					          "3":"fund/fundApply",
					          "4":"otc/otcProducts",
					          "5":"",
					          "6":"banking/transfer",
					          "7":"banking/collection",
					          "8":"account/changePassword",
					          "9":""
			                   };
			var funcModule = paramMap.funcModule;//功能模块
			var userInfo = paramMap.userInfo;//用户信息
			var loginType = paramMap.loginType;//账户类别
			appUtils.setSStorageInfo("clientinfo",userInfo.clientinfo);
			appUtils.setSStorageInfo("jsessionid",userInfo.jsessionid);
			appUtils.setSStorageInfo("_isLoginIn","true");
			appUtils.setSStorageInfo("_lastDoTime",new Date().getTime());
			var topage = funcModules[funcModule];
			userInfo = JSON.stringify(userInfo);
			if(loginType=="0"){
				appUtils.setSStorageInfo("stock_userInfo",userInfo);
			}else{
				appUtils.setSStorageInfo("credit_userInfo",userInfo);
			}
		    //登录超时停留页面
			var loginPageCode=appUtils.getSStorageInfo("_loginInPageCode");  //超时时停留的页面
			var loginInPageParam=appUtils.getSStorageInfo("_loginInPageParam");
			appUtils.clearSStorage("_loginInPageCode"); 
			appUtils.clearSStorage("_loginInPageParam");
			if(loginPageCode && loginPageCode!=""){
				var param=JSON.parse(loginInPageParam);	
				topage=loginPageCode;
				appUtils.pageInit(null,topage,param);
			}else{
				appUtils.pageInit(null,topage,{});
			}

		}catch(e){
			console.log("原生跳转H5模块传入数据解析JSON出错"+e.message);
	    }
	};
       
      
       /**
        *模块切换初始化
        */
       oMyMsgFunction.function50113 = function(param)
       {
       var toPage = param ? param["toPage"] : null;
       if(toPage && toPage == "default"){
    	   toPage = gconfig.defaultPage.pageCode;
       }
       require.async("sso",function(module){
                     if(toPage && toPage.length > 0)
                     {
                     var index = toPage.indexOf(".");
                     if(index > 0){
                     toPage = toPage.substring(0,index);
                     }
                     var curPageCode = module.getCurrentPageCode();
                     if(curPageCode != toPage){
                     module.hidePageContent(curPageCode);
                     }
                     appUtils.pageInit("",toPage,param);
                     }
                     else
                     {
                     module.reloadPageInit();
                     }
                     });
       };
       
       /**
        *超时回调函数
        */
        oMyMsgFunction.function60609 = function(param)
          {
               if(param.error_no == 0)
               {
               require.async("sso",function(module){
            	   			module.ssoLoginOut();
                      });
               }
               else
               {
               layerUtils.iAlert(param.error_info);
               }
          }
        
        /**
         *统一退出回调
         */
        oMyMsgFunction.function60401 = function(param)
        {
 		  if(param.error_no == 0)
 		  {
 			  require.async("sso",function(module){
 			     module.goTologin();
 			 });
 		  }
 		  else
 		  {
 		   	 layerUtils.iAlert(param.error_info);
 		  }
        }

        /**
         *  系统退出
         */
        oMyMsgFunction.function60403 = function(param)
        {
            appUtils.clearSStorage("_isLogin");
            appUtils.clearSStorage(gconfig.projName + "_login_token");
            require.async("common",function(module){
                 module.clearSessionUserInfo();
            });
            require.async("sso",function(module){
                var prevPageCode = module.getCurrentPageCode();
                appUtils.pageInit(prevPageCode,"account/index");
            });
            //调用退出登录接口，请求服务器，失效session
            service_stock.exitTrade(exitTradeCallBack,{"isLastReq":true,"isShowWait":false});
			function exitTradeCallBack(data){
				if(data.error_no == 0){
					$("#account_index .top_title .logout").hide();
//					layerUtils.iAlert("注销成功");
				}else{
//					layerUtils.iAlert("注销失败");
				}
			}
        }
	
	module.exports = oMyMsgFunction;
});