define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var validata = require("validatorUtil");
	var layerUtils = require("layerUtils");
	var _pageId ="#asset_bills";
	var mobileService = require("mobileService");
	var common = require("common");
	var chartsUtils = require("highChartsUtils");
	var utils = require("utils");
	var external = require("external");
	var nativePluginService = require("nativePluginService");
	
	var moneyType="0";

	//账单页面
	function init() {
		common.cleanPageElement(_pageId);
		common.hideTabBar();
		initData();
		queryBills("0");
	}
	
	function initData(){
		appUtils.setSStorageInfo("tab_type","stock_tab");
		//普通首页模块
		external.callMessage({"funcNo": "50040", "key": "trade_module", "value": "stock"});
		window.selDateCallback = selDateCallback;
		var date = new Date().format("yyyy-MM-dd") //得到当前日期
		$(_pageId+" #startDate").val(date);
		$(_pageId+" #endDate").val(date);
		//初始化状态信息
		$(_pageId+" #RMB").addClass("active").siblings().removeClass("active");
		$(_pageId+" #RMB_dzd_tablist").show();
		$(_pageId+" #RMB_dzd_tablist #collect").addClass("active").siblings().removeClass("active");
		$(_pageId+" #HKD_dzd_tablist").hide();
		$(_pageId+" #USD_dzd_tablist").hide();
		$(_pageId+" #RMB_totalPie").show();
		$(_pageId+" #RMB_totalPie #RMB_income_container").html("");
		$(_pageId+" #RMB_totalPie #RMB_expenditure_container").html("");
		$(_pageId+" #RMB_billDetails").html("");

        $(_pageId+" #HKD_totalPie").hide();
		$(_pageId+" #HKD_totalPie #HKD_income_container").html("");
		$(_pageId+" #HKD_totalPie #HKD_expenditure_container").html("");
		$(_pageId+" #HKD_billDetails").html("");

		$(_pageId+" #USD_totalPie").hide();
		$(_pageId+" #USD_totalPie #USD_income_container").html("");
		$(_pageId+" #USD_totalPie #USD_expenditure_container").html("");
		$(_pageId+" #USD_billDetails").html("");
	}

	/*查询账户账单信息*/
	function queryBills(moneytype){
		//开始的时间
		var startDate = $(_pageId+" #startDate").val();
//		var startDate = "2015-09-20";
		//结束的时间
		var endDate = $(_pageId+" #endDate").val();
		var param ={
			"user_id" : appUtils.getSStorageInfo("user_id"),
			"moneytype" : moneytype,				//0 : RMB  1：港币 2：美元
			"begin_date" : startDate,
			"end_date" : endDate
		};
		mobileService.queryBillInfo(param,function(data){
			var error_no = data.error_no;
		    var error_info = data.error_info;
			var countResult = data.countResult;															//数据统计
			var transactionRecords = data.transactionRecords;
			if(error_no == 0){
				showCountData(countResult,moneytype);
				showDetailInfo(transactionRecords,moneytype);
			}
			else{
//				layerUtils.iAlert(error_info,-1);
				layerUtils.iMsg(-1, error_info);
				return false;
			}
		},{isShowWait:false});
	}
	
	function showCountData(countResult,moneytype){
		//1、显示统计数据
		if("undefined" != countResult && null != countResult && "" != countResult){
			var totalIncome = common.formatMoney(countResult[0].totalIncome);					//总收入
			var totalExpenditure = common.formatMoney(countResult[0].totalExpenditure);			//总支出
			var count = common.formatMoney(countResult[0].count,0);								//总笔数
			var totalSellOut = common.formatMoney(countResult[0].totalSellOut);					//卖出总值
			var totalTransferIncome = common.formatMoney(countResult[0].totalTransferIncome);	//转入总值
			var totalOtherIn = common.formatMoney(countResult[0].totalOtherIn);					//其他收入总值
			var totalRedeem = common.formatMoney(countResult[0].totalRedeem);					//赎回总值
			var totalInterest = common.formatMoney(countResult[0].totalInterest);				//利息总值
			var totalPurchase = common.formatMoney(countResult[0].totalPurchase);				//买入总值
			var totalTransferOut = common.formatMoney(countResult[0].totalTransferOut);			//转出总值
			var totalApplyPurchase = common.formatMoney(countResult[0].totalApplyPurchase);		//申购总值
			var totalOtherOut = common.formatMoney(countResult[0].totalOtherOut);				//其他支出总值
			var sellOutPro = +countResult[0].sellOutPro;										//卖出总值比例
			var transferIncomePro = +countResult[0].transferIncomePro;							//转入总值比例
			var otherInPro = +countResult[0].otherInPro;										//其他收入入总值比例
			var redeemPro = +countResult[0].redeemPro;											//赎回总值比例
			var interestPro = +countResult[0].interestPro;										//利息总值比例
			var purchasePro = +countResult[0].purchasePro;										//买入总值比例
			var transferOutPro = +countResult[0].transferOutPro;								//转出总值比例
			var applyPurchasePron = +countResult[0].applyPurchasePron;							//申购总值比例
			var otherOutPro = +countResult[0].otherOutPro;										//其他支出总值比例
			
			$(_pageId+" #income").html(totalIncome);
			$(_pageId+" #expenditure").html(totalExpenditure);
			$(_pageId+" #count").html(count);
			var fund_account = appUtils.getSStorageInfo("curr_loginid");						//主资金账号
			$(_pageId+" #fundAccount").html("<span>资金账号：（主）"+fund_account+"</span>");
			/*********收入资金分割**********/
			var formatIncome = parseFloat(countResult[0].totalIncome);
			if(formatIncome == 0){
				if(moneytype == 0){
					//显示人民币汇总、隐藏明细
					$(_pageId+" #RMB_totalPie").show();
					$(_pageId+" #RMB_billDetails").hide();
					$(_pageId+" #RMB_income_container").html("").hide();
					//隐藏港币和美元汇总和明细
					$(_pageId+" #HKD_totalPie").hide();
					$(_pageId+" #HKD_billDetails").hide();
					$(_pageId+" #USD_totalPie").hide();
					$(_pageId+" #USD_billDetails").hide();
				}else if(moneytype == 1){
					//显示港币汇总、隐藏明细
					$(_pageId+" #HKD_totalPie").show();
					$(_pageId+" #HKD_billDetails").hide();
					$(_pageId+" #HKD_income_container").html("").hide();
					//隐藏人民币和美元汇总和明细
					$(_pageId+" #RMB_totalPie").hide();
					$(_pageId+" #RMB_billDetails").hide();
					$(_pageId+" #USD_totalPie").hide();
					$(_pageId+" #USD_billDetails").hide();
				}else if(moneytype == 2){
					//显示美元汇总、隐藏明细
					$(_pageId+" #USD_totalPie").show();
					$(_pageId+" #USD_billDetails").hide();
					$(_pageId+" #USD_income_container").html("").hide();
					//隐藏人民币和美元汇总和明细
					$(_pageId+" #HKD_totalPie").hide();
					$(_pageId+" #HKD_billDetails").hide();
					$(_pageId+" #RMB_totalPie").hide();
					$(_pageId+" #RMB_billDetails").hide();
				}
			}
			else{
				var formatTotalIncome = numberFormat(formatIncome);
				var unit = unitFormat(formatIncome);
				var format_totalSellOut = totalFormat(formatIncome,countResult[0].totalSellOut);					//卖出总值
				var format_totalTransferIncome = totalFormat(formatIncome,countResult[0].totalTransferIncome);	//转入总值
				var format_totalOtherIn = totalFormat(formatIncome,countResult[0].totalOtherIn);					//其他收入总值
				var format_totalRedeem = totalFormat(formatIncome,countResult[0].totalRedeem);					//赎回总值
				var format_totalInterest = totalFormat(formatIncome,countResult[0].totalInterest);				//利息总值
				//显示收入资金圆饼图
				var income_data = [{
					name: "卖出",
					sliced: false,
					color: "#ec644c",
					y: sellOutPro
				},{
					name: "转入",
					sliced: false,
					color: "#fa931a",
					y: transferIncomePro
				},{
					name: "其他",
					sliced: false,
					color: "#F2C490",
					y: otherInPro
				},{
					name: "基金赎回",
					sliced: false,
					color: "#72aceb",
					y: redeemPro
				},{
					name: "利息",
					sliced: false,
					color: "#d14baa",
					y: interestPro
				}];
				var validData = [];
				for(var i = 0;i<income_data.length;i++){
					if(income_data[i].y != 0){
						validData.push(income_data[i]);
					}
				}
				var text = "<span style=\"font-weight:bold;font-size:0.12rem;\">"+formatTotalIncome+"</span><br/><span style=\"text-align:center;color:#394a5a;font-family:Microsoft YaHei;font-size: 0.08rem;\">收入资金("+unit+")</span>"
				var options={
					m_title: text,		//设置中间圆内显示文字内容
					distance: 12,		//设置线条长度(标签与图像元素之间的间距)
					over_show: false		//鼠标悬浮是否显示数据
				};
				if(moneytype == 0){
					//显示人民币汇总、隐藏明细
					$(_pageId+" #RMB_totalPie").show();
					$(_pageId+" #RMB_billDetails").hide();
					$(_pageId+" #RMB_income_container").show();
					chartsUtils.drawIncomePie("#RMB_income_container", validData, options,format_totalSellOut,format_totalTransferIncome,format_totalOtherIn,format_totalRedeem,format_totalInterest);		//调用展示饼状图处理方法
					//隐藏港币和美元汇总和明细
					$(_pageId+" #HKD_totalPie").hide();
					$(_pageId+" #HKD_billDetails").hide();
					$(_pageId+" #USD_totalPie").hide();
					$(_pageId+" #USD_billDetails").hide();
				}else if(moneytype == 1){
					//显示港币汇总、隐藏明细
					$(_pageId+" #HKD_totalPie").show();
					$(_pageId+" #HKD_billDetails").hide();
					$(_pageId+" #HKD_income_container").show();
					chartsUtils.drawIncomePie("#HKD_income_container", validData, options,format_totalSellOut,format_totalTransferIncome,format_totalOtherIn,format_totalRedeem,format_totalInterest);		//调用展示饼状图处理方法
					//隐藏人民币和美元汇总和明细
					$(_pageId+" #RMB_totalPie").hide();
					$(_pageId+" #RMB_billDetails").hide();
					$(_pageId+" #USD_totalPie").hide();
					$(_pageId+" #USD_billDetails").hide();
				}else if(moneytype == 2){
					//显示美元汇总、隐藏明细
					$(_pageId+" #USD_totalPie").show();
					$(_pageId+" #USD_income_container").show();
					$(_pageId+" #USD_billDetails").hide();
					chartsUtils.drawIncomePie("#USD_income_container", validData, options,format_totalSellOut,format_totalTransferIncome,format_totalOtherIn,format_totalRedeem,format_totalInterest);		//调用展示饼状图处理方法
					//隐藏人民币和美元汇总和明细
					$(_pageId+" #HKD_totalPie").hide();
					$(_pageId+" #HKD_billDetails").hide();
					$(_pageId+" #RMB_totalPie").hide();
					$(_pageId+" #RMB_billDetails").hide();
				}
			}
			
			/*********支出资金分割**********/
			var formatExp = parseFloat(countResult[0].totalExpenditure);
			if(formatExp == 0){
				if(moneytype == 0){
					//显示人民币汇总、隐藏明细
					$(_pageId+" #RMB_totalPie").show();
					$(_pageId+" #RMB_billDetails").hide();
					$(_pageId+" #RMB_expenditure_container").html("").hide();
					//隐藏港币和美元汇总和明细
					$(_pageId+" #HKD_totalPie").hide();
					$(_pageId+" #HKD_billDetails").hide();
					$(_pageId+" #USD_totalPie").hide();
					$(_pageId+" #USD_billDetails").hide();
				}else if(moneytype == 1){
					//显示港币汇总、隐藏明细
					$(_pageId+" #HKD_totalPie").show();
					$(_pageId+" #HKD_billDetails").hide();
					$(_pageId+" #HKD_expenditure_container").html("").hide();
					//隐藏人民币和美元汇总和明细
					$(_pageId+" #RMB_totalPie").hide();
					$(_pageId+" #RMB_billDetails").hide();
					$(_pageId+" #USD_totalPie").hide();
					$(_pageId+" #USD_billDetails").hide();
				}else if(moneytype == 2){
					//显示美元汇总、隐藏明细
					$(_pageId+" #USD_totalPie").show();
					$(_pageId+" #USD_billDetails").hide();
					$(_pageId+" #USD_expenditure_container").html("").hide();
					//隐藏人民币和美元汇总和明细
					$(_pageId+" #HKD_totalPie").hide();
					$(_pageId+" #HKD_billDetails").hide();
					$(_pageId+" #RMB_totalPie").hide();
					$(_pageId+" #RMB_billDetails").hide();
				}
			}
			else{
				var formatTotalExe = numberFormat(formatExp);
				var unit = unitFormat(formatExp);
				var format_totalPurchase = totalFormat(formatExp,countResult[0].totalPurchase);				//买入总值
				var format_totalTransferOut = totalFormat(formatExp,countResult[0].totalTransferOut);			//转出总值
				var format_totalApplyPurchase = totalFormat(formatExp,countResult[0].totalApplyPurchase);		//申购总值
				var format_totalOtherOut = totalFormat(formatExp,countResult[0].totalOtherOut);				//其他支出总值	
				$(_pageId+" #expenditure_container").show();
				//显示支出圆饼图
				var expenditure_data = [{
					name: "买入",
					sliced: false,
					color: "#32c9d7",
					y: purchasePro
				},{
					name: "转出",
					sliced: false,
					color: "#4c8df1",
					y: transferOutPro
				},{
					name: "基金认申",
					sliced: false,
					color: "#afbdb9",
					y: applyPurchasePron
				},{
					name: "其他",
					sliced: false,
					color: "#2ce9f9",
					y: otherOutPro
				}];
				var changeData = [];
				for(var j = 0;j<expenditure_data.length;j++){
					if(expenditure_data[j].y != 0){
						changeData.push(expenditure_data[j]);
					}
				}
				var text = "<span style=\"font-weight: bold;font-size:0.12rem;\">"+formatTotalExe+"</span><br/><span style=\"text-align:center;color:#394a5a;font-family:Microsoft YaHei;font-size: 0.08rem;\">支出资金("+unit+")</span>"
				var options={
					m_title: text,		//设置中间圆内显示文字内容
					distance: 12,		//设置线条长度(标签与图像元素之间的间距)
					over_show: false		//鼠标悬浮是否显示数据
				};
				if(moneytype == 0){
					//显示人民币汇总、隐藏明细
					$(_pageId+" #RMB_totalPie").show();
					$(_pageId+" #RMB_expenditure_container").show();
					$(_pageId+" #RMB_billDetails").hide();
					chartsUtils.drawExpenditurePie("#RMB_expenditure_container", changeData, options,format_totalPurchase,format_totalTransferOut,format_totalApplyPurchase,format_totalOtherOut);		//调用展示饼状图处理方法
					//隐藏港币和美元汇总和明细
					$(_pageId+" #HKD_totalPie").hide();
					$(_pageId+" #HKD_billDetails").hide();
					$(_pageId+" #USD_totalPie").hide();
					$(_pageId+" #USD_billDetails").hide();
				}else if(moneytype == 1){
					//显示港币汇总、隐藏明细
					$(_pageId+" #HKD_totalPie").show();
					$(_pageId+" #HKD_billDetails").hide();
					$(_pageId+" #HKD_expenditure_container").show();
					chartsUtils.drawExpenditurePie("#HKD_expenditure_container", changeData, options,format_totalPurchase,format_totalTransferOut,format_totalApplyPurchase,format_totalOtherOut);		//调用展示饼状图处理方法
					//隐藏人民币和美元汇总和明细
					$(_pageId+" #RMB_totalPie").hide();
					$(_pageId+" #RMB_billDetails").hide();
					$(_pageId+" #USD_totalPie").hide();
					$(_pageId+" #USD_billDetails").hide();
				}else if(moneytype == 2){
					//显示美元汇总、隐藏明细
					$(_pageId+" #USD_totalPie").show();
					$(_pageId+" #USD_expenditure_container").show();
					$(_pageId+" #USD_billDetails").hide();
					chartsUtils.drawExpenditurePie("#USD_expenditure_container", changeData, options,format_totalPurchase,format_totalTransferOut,format_totalApplyPurchase,format_totalOtherOut);		//调用展示饼状图处理方法
					//隐藏人民币和美元汇总和明细
					$(_pageId+" #HKD_totalPie").hide();
					$(_pageId+" #HKD_billDetails").hide();
					$(_pageId+" #RMB_totalPie").hide();
					$(_pageId+" #RMB_billDetails").hide();
				}
			}
		}	
	}
	
	function totalFormat(total,number){
		var formatNumber = "";
		if(String(total).indexOf("-") != -1){
			total = String(total).substr(1,total.length);
		}
		if(total >= 1000000){
			formatNumber =  common.formatMoney(Math.round(number/10000).toFixed(2))+'万元';
		}
		else{
			formatNumber =  common.formatMoney(number)+'元';
		}
		return formatNumber;
	}

	function numberFormat(number){
		var formatNumber = "";
		var result = number;
		if(String(number).indexOf("-") != -1){
			number = String(number).substr(1,number.length);
		}
		if(number >= 1000000){
			formatNumber =  common.formatMoney(Math.round(result/10000).toFixed(2));
		}
		else{
			formatNumber = common.formatMoney(result);
		}
		return formatNumber;
	}
	
	function unitFormat(money){
		var unit = "";
		if(String(money).indexOf("-") != -1){
			money = String(money).substr(1,money.length);
		}
		if(money >= 1000000){
			unit = "万元";
		}
		else{
			unit = "元";
		}
		return unit;
	}
	
	function showDetailInfo(transactionRecords,moneytype){
		//显示账单明细信息
		if("undefined" != transactionRecords && null != transactionRecords && "" != transactionRecords){
			var param = {			
				"enum_type": "BIZCODE"
			};
			mobileService.queryFundation(param, function(data){
				var error_no = data.error_no;
				var error_info = data.error_info;
				var results = data.results;
				var elementHtml = "";
				if(error_no == "0"){
					var arr = "0";
					if(undefined !=  results){
						for(var i = 0;i<transactionRecords.length;i++){
							for(var k=0;k<results.length;k++){
								var item_name = results[k].item_name;
								var item_value = results[k].item_value;
								var stkname = transactionRecords[i].stkname == undefined || 
												  transactionRecords[i].stkname == null || 
												  transactionRecords[i].stkname == "" ? "无": transactionRecords[i].stkname;												//证券名称
									
								var stkcode = transactionRecords[i].stkcode == undefined ||
											  transactionRecords[i].stkcode == null || 
											  transactionRecords[i].stkcode == "" ? "无": transactionRecords[i].stkcode;											//证券代码
								
								var businesscode = transactionRecords[i].businesscode == undefined ||
											  transactionRecords[i].businesscode == null || 
											  transactionRecords[i].businesscode == "" ? "无": transactionRecords[i].businesscode;	//业务编号

								var transacttime = transactionRecords[i].transacttime == undefined ||
											  transactionRecords[i].transacttime == null || 
											  transactionRecords[i].transacttime == "" ? "无": transactionRecords[i].transacttime;									//成交时间
								
								var businessprice = transactionRecords[i].businessprice == undefined ||
											  transactionRecords[i].businessprice == null || 
											  transactionRecords[i].businessprice == "" ? "0.00": common.formatMoney(transactionRecords[i].businessprice);			//发生金额
								
								var transactnumber = transactionRecords[i].transactnumber == undefined ||
											  transactionRecords[i].transactnumber == null || 
											  transactionRecords[i].transactnumber == "" ? "0": transactionRecords[i].transactnumber;								//成交数量
								
								var transactprice = transactionRecords[i].transactprice == undefined ||
											  transactionRecords[i].transactprice == null || 
											  transactionRecords[i].transactprice == "" ? "0.00": common.formatMoney(transactionRecords[i].transactprice);			//成交金额
								
								var stampduty = transactionRecords[i].stampduty == undefined ||
											  transactionRecords[i].stampduty == null || 
											  transactionRecords[i].stampduty == "" ? "0.00": common.formatMoney(transactionRecords[i].stampduty);					//印花税
								
								var transferfee = transactionRecords[i].transferfee == undefined ||
											  transactionRecords[i].transferfee == null || 
											  transactionRecords[i].transferfee == "" ? "0.00": common.formatMoney(transactionRecords[i].transferfee);				//过户税
								
								var clearfee = transactionRecords[i].clearfee == undefined ||
											  transactionRecords[i].clearfee == null || 
											  transactionRecords[i].clearfee == "" ? "0.00": common.formatMoney(transactionRecords[i].clearfee);						//清算费
								
								var hkrate = transactionRecords[i].hkrate == undefined ||
											  transactionRecords[i].hkrate == null || 
											  transactionRecords[i].hkrate == "" ? "0.00": common.formatMoney(transactionRecords[i].hkrate);							//港股通汇率
								
								var fundbalance = transactionRecords[i].fundbalance == undefined ||
											  transactionRecords[i].fundbalance == null || 
											  transactionRecords[i].fundbalance == "" ? "0.00": common.formatMoney(transactionRecords[i].fundbalance);				//资金余额
								
								var trdcode = transactionRecords[i].trdcode == undefined ||
											  transactionRecords[i].trdcode == null || 
											  transactionRecords[i].trdcode == "" ? "无": transactionRecords[i].trdcode;											//交易账号
								
								var tradefee = transactionRecords[i].tradefee == undefined ||
											  transactionRecords[i].tradefee == null || 
											  transactionRecords[i].tradefee == "" ? "0.00" : transactionRecords[i].tradefee;											//交易规费
								
								var commission	= transactionRecords[i].commission == undefined ||
											  transactionRecords[i].commission == null || 
											  transactionRecords[i].commission == "" ? 0.00: transactionRecords[i].commission;							//佣金/手续费
								
								var systemuser_fee	= transactionRecords[i].systemuser_fee == undefined ||
											  transactionRecords[i].systemuser_fee == null || 
											  transactionRecords[i].systemuser_fee == ""?  0.00: transactionRecords[i].systemuser_fee;						//系统使用费
								
								var contract_no	= transactionRecords[i].contract_no == undefined ||
												  transactionRecords[i].contract_no == null || 
												  transactionRecords[i].contract_no == "" ? "无": transactionRecords[i].contract_no;	
								
								var allData = {
			 						"stkname" : stkname,
			 						"stkcode" : stkcode,
			 						"businesscode" : businesscode,
			 						"transacttime" : transacttime,
			 						"businessprice" : businessprice,
			 						"transactnumber" : transactnumber,
			 						"transactprice" : transactprice,
			 						"stampduty" : stampduty,
			 						"transferfee" : transferfee,
			 						"clearfee" : clearfee,
			 						"hkrate" : hkrate,
			 						"fundbalance" : fundbalance,
			 						"trdcode" : trdcode,
			 						"tradefee" : tradefee,
			 						"commission" : commission,
			 						"systemuser_fee" : systemuser_fee,
			 						"contract_no" : contract_no
			 					}
								var formatPrice = parseFloat(businessprice);
								if(businesscode == item_value){
			 						arr++;
									if(formatPrice >= 0){
										elementHtml += showDetailFuc("three",allData,item_name,arr,moneytype);
									}else{
										elementHtml += showDetailFuc("one",allData,item_name,arr,moneytype);
									}
									break;
								}
								else if(k == results.length -1){
									arr++;
									if(formatPrice >= 0){
										elementHtml += showDetailFuc("three",allData,businesscode,arr,moneytype);
									}else{
										elementHtml += showDetailFuc("one",allData,businesscode,arr,moneytype);
									}
								}
							}
						}
						if(moneytype == 0){
							$(_pageId+" #RMB_billDetails").html(elementHtml);
						}else if(moneytype == 1){
							$(_pageId+" #HKD_billDetails").html(elementHtml);
						}else if(moneytype == 2){
							$(_pageId+" #USD_billDetails").html(elementHtml);
						}
					}
				} else {
//					layerUtils.iAlert(error_info,-1);
					layerUtils.iMsg(-1, error_info);
					return false;
				}
			},{isShowWait:false});
		}	
		else{
			if(moneytype == 0){
				$(_pageId+" #RMB_billDetails").html("");
			}else if(moneytype == 1){
				$(_pageId+" #HKD_billDetails").html("");
			}else if(moneytype == 2){
				$(_pageId+" #USD_billDetails").html("");
			}
		}
	}
	
	function showDetailFuc(className,allData,item_name,k,moneytype){
		var elements = "";
		elements += "<div class=\"ele\">";
		elements += "<div class=\"dzd_minxi clearfix\"><div class=\"left\"><p><a class=\"dzd_btn "+className+"\" href=\"javascript:void(0);\">"+item_name+"</a></p><p class=\"dm_name\">"+allData.stkname+"（"+allData.stkcode+"）</p><p class=\"time\">"+allData.transacttime+"</p></div><div class=\"right\"><p>发生资金：<span>"+allData.businessprice+"</span></p><p>成交数量：<span>"+allData.transactnumber+"</span></p></div><a id=\"ele"+k+"\"  class=\"dzd_link\" href=\"javascript:void(0);\"></a></div>";
		elements += "<div id=\"list"+k+"\" class=\"mixi_list\" style=\"display:none\">";
        elements += "<ul class=\"clearfix\">";
        elements += "<li><span class=\"tit\">交易账号：</span><p>"+allData.trdcode+"</p></li>";
        elements += "<li><span class=\"tit\">成交价格：</span><p>"+allData.transactprice+"</p></li>";
        elements += "<li><span class=\"tit\">合同号码：</span><p>"+allData.contract_no+"</p></li>";
        elements += "<li><span class=\"tit\">佣金：</span><p>"+allData.commission+"</p></li>";
        elements += "        <li><span class=\"tit\">印花税：</span><p>"+allData.stampduty+"</p></li>";
        elements += "       <li><span class=\"tit\">过户费：</span><p>"+allData.transferfee+"</p></li>";
        elements += "     <li><span class=\"tit\">清算费：</span><p>"+allData.clearfee+"</p></li>";
        elements += "    <li><span class=\"tit\">交易规费：</span><p>"+allData.tradefee+"</p></li>";
        elements += "      <li><span class=\"tit\">系统使用费：</span><p>"+allData.systemuser_fee+"</p></li>";
        elements += "    <li><span class=\"tit\">港股汇率：</span><p>"+allData.hkrate+"</p></li>";
        elements += "     <li><span class=\"tit\">资金余额：</span><p>"+allData.fundbalance+"</p></li>";
        elements += " </ul>";
        elements += " </div>";
        elements += " </div>";
        //预绑定人民币下拉切换按钮
		appUtils.preBindEvent($(_pageId+" #RMB_billDetails"),"#ele"+k,function(e){
			if($(this).hasClass("active")){
				$(this).removeClass("active");
				$(_pageId+" #RMB_billDetails #list"+k).hide();
			}
			else{
				$(this).addClass("active");
				$(_pageId+" #RMB_billDetails #list"+k).show();
			}
		});
		//预绑定港币明细下拉切换按钮
		appUtils.preBindEvent($(_pageId+" #HKD_billDetails"),"#ele"+k,function(e){
			if($(this).hasClass("active")){
				$(this).removeClass("active");
				$(_pageId+" #HKD_billDetails #list"+k).hide();
			}
			else{
				$(this).addClass("active");
				$(_pageId+" #HKD_billDetails #list"+k).show();
			}
		});
		//预绑定美元明细下拉切换按钮
		appUtils.preBindEvent($(_pageId+" #USD_billDetails"),"#ele"+k,function(e){
			if($(this).hasClass("active")){
				$(this).removeClass("active");
				$(_pageId+" #USD_billDetails #list"+k).hide();
			}
			else{
				$(this).addClass("active");
				$(_pageId+" #USD_billDetails #list"+k).show();
			}
		});
        return elements;
	}
	function bindPageEvent() {
		//返回
		appUtils.bindEvent($(_pageId + " .icon_back"), function(){
             appUtils.pageInit("asset/bills","myAccount/index",{});
		});

		//证券交易
		appUtils.bindEvent($(_pageId+" #zqjy"), function(e){
			appUtils.setSStorageInfo("tab_type","stock_tab");
		});

		// 绑定融资融券
		appUtils.bindEvent($(_pageId+" #rzrq"), function(){
			appUtils.setSStorageInfo("tab_type","credit_tab");
			// 信用首页模块
			external.callMessage({"funcNo": "50040", "key": "trade_module", "value": "credit"});
			var credit_accouont = nativePluginService.function50041({"key":"CREDIT_LOGIN_STATE"}).results[0].value;     	//1、已登录
			if("1" == credit_accouont){
				appUtils.pageInit("asset/bills", "credit/creditAccount", {});
			}else{
				layerUtils.iAlert("您还没有登录信用账户，请先登录！","0",function(){
					appUtils.pageInit("asset/bills", "credit/creditAccount", {});
				});
			}
		});
		
		// 绑定人民币切换
		appUtils.bindEvent($(_pageId+" #RMB"), function(){
			$(this).addClass("active").siblings().removeClass("active");
			$(_pageId+" #RMB_dzd_tablist #collect").addClass("active").siblings().removeClass("active");
			$(_pageId+" #RMB_dzd_tablist").show();
			$(_pageId+" #HKD_dzd_tablist").hide();
			$(_pageId+" #USD_dzd_tablist").hide();
			queryBills("0");
			moneyType="0";
		});
		
		// 绑定港币切换
		appUtils.bindEvent($(_pageId+" #HKD"), function(){
			$(this).addClass("active").siblings().removeClass("active");
			$(_pageId+" #HKD_dzd_tablist #collect").addClass("active").siblings().removeClass("active");
			$(_pageId+" #HKD_dzd_tablist").show();
			$(_pageId+" #RMB_dzd_tablist").hide();
			$(_pageId+" #USD_dzd_tablist").hide();
			queryBills("1");
			moneyType="1";
		});
		
		// 绑定美元切换
		appUtils.bindEvent($(_pageId+" #USD"), function(){
			$(this).addClass("active").siblings().removeClass("active");
			$(_pageId+" #USD_dzd_tablist #collect").addClass("active").siblings().removeClass("active");
			$(_pageId+" #USD_dzd_tablist").show();
			$(_pageId+" #HKD_dzd_tablist").hide();
			$(_pageId+" #RMB_dzd_tablist").hide();
			queryBills("2");
			moneyType="2";
		});
		
		//人民币汇总
		appUtils.bindEvent($(_pageId +" #RMB_dzd_tablist #collect"), function(){
			$(this).addClass("active").siblings().removeClass("active");
			$(_pageId+" #RMB_totalPie").show();
			$(_pageId+" #RMB_billDetails").hide();
			$(_pageId+" #HKD_totalPie").hide();
			$(_pageId+" #HKD_billDetails").hide();
			$(_pageId+" #USD_totalPie").hide();
			$(_pageId+" #USD_billDetails").hide();
		});
		
		//人民币明细
		appUtils.bindEvent($(_pageId + " #RMB_dzd_tablist #details"), function(){
			$(this).addClass("active").siblings().removeClass("active");
			$(_pageId+" #RMB_billDetails").show();
			$(_pageId+" #RMB_totalPie").hide();
			$(_pageId+" #HKD_totalPie").hide();
			$(_pageId+" #HKD_billDetails").hide();
			$(_pageId+" #USD_totalPie").hide();
			$(_pageId+" #USD_billDetails").hide();
		});
		
		//港币汇总
		appUtils.bindEvent($(_pageId +" #HKD_dzd_tablist #collect"), function(){
			$(this).addClass("active").siblings().removeClass("active");
			$(_pageId+" #HKD_totalPie").show();
			$(_pageId+" #HKD_billDetails").hide();
			$(_pageId+" #RMB_totalPie").hide();
			$(_pageId+" #RMB_billDetails").hide();
			$(_pageId+" #USD_totalPie").hide();
			$(_pageId+" #USD_billDetails").hide();
		});
		
		//港币明细
		appUtils.bindEvent($(_pageId + " #HKD_dzd_tablist #details"), function(){
			$(this).addClass("active").siblings().removeClass("active");
			$(_pageId+" #HKD_billDetails").show();
			$(_pageId+" #HKD_totalPie").hide();
			$(_pageId+" #RMB_totalPie").hide();
			$(_pageId+" #RMB_billDetails").hide();
			$(_pageId+" #USD_totalPie").hide();
			$(_pageId+" #USD_billDetails").hide();
		});
		
		//美元汇总
		appUtils.bindEvent($(_pageId +" #USD_dzd_tablist #collect"), function(){
			$(this).addClass("active").siblings().removeClass("active");
			$(_pageId+" #USD_totalPie").show();
			$(_pageId+" #USD_billDetails").hide();
			$(_pageId+" #RMB_totalPie").hide();
			$(_pageId+" #RMB_billDetails").hide();
			$(_pageId+" #HKD_totalPie").hide();
			$(_pageId+" #HKD_billDetails").hide();
		});
		
		//美元明细
		appUtils.bindEvent($(_pageId + " #USD_dzd_tablist #details"), function(){
			$(this).addClass("active").siblings().removeClass("active");
			$(_pageId+" #USD_billDetails").show();
			$(_pageId+" #USD_totalPie").hide();
			$(_pageId+" #RMB_totalPie").hide();
			$(_pageId+" #RMB_billDetails").hide();
			$(_pageId+" #HKD_totalPie").hide();
			$(_pageId+" #HKD_billDetails").hide();
		});
		
		/* 绑定选择日期的事件 */
		appUtils.bindEvent($(_pageId+" input[date-plugin='true']"),function(e){
			utils.selectDate(this);  // 通过壳子调用系统的日历插件 
		});
		
		/* 绑定查询 */
		appUtils.bindEvent($(_pageId+" #query"),function(e){
			if($(_pageId+" #RMB").hasClass("active")){
				moneyType = 0;
			}
			if(moneyType == 0){
				$(_pageId+" #RMB_dzd_tablist #collect").addClass("active").siblings().removeClass("active");
			}else if(moneyType == 1){
				$(_pageId+" #HKD_dzd_tablist #collect").addClass("active").siblings().removeClass("active");
			}else if(moneyType == 2){
				$(_pageId+" #USD_dzd_tablist #collect").addClass("active").siblings().removeClass("active");
			}
			queryBills(moneyType);
		});
	}

	/* 日历的回调函数 */
	function selDateCallback(data) {
		// 回调数据中的 data 是字符串，需解析
		if (typeof(data) == "string") {
			data = JSON.parse(data);
		}
		$(_pageId + " #"+data.selector).val(data.date);
	}

	function destroy(){
		external.callMessage({"funcNo": "50040", "key": "trade_module", "value": ""});
		mobileService.destroy();
	}
	
	var bills = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"selDateCallback": selDateCallback,
		"destroy": destroy
	};
	module.exports = bills;
});
