define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var external = require("external");
	var _pageId ="#asset_index";
	var common = require("common");
	var mobileService = require("mobileService");
	var layerUtils = require("layerUtils");
	var gconfig = require("gconfig");
	var nativePluginService = require("nativePluginService");

	function init() {
		//去掉框架中的display的block样式，本身css已经处理了
		$("#content .page").each(function(){
			if($(this).attr("data-display") == "block"){
				$(this).css({"display":""});
			}
		});
		common.cleanPageElement(_pageId);
		common.hideTabBar();
		cleanPageElement();
		queryAssetList("0");
	}

	function cleanPageElement(){
		appUtils.setSStorageInfo("tab_type","stock_tab");
		//普通首页模块
        external.callMessage({"funcNo": "50040", "key": "trade_module", "value": "stock"});
        external.callMessage({"funcNo": "50040", "key": "ygt_module", "value": "stock"});
		$(_pageId+" #RMB").addClass("active").siblings().removeClass("active");
        $(_pageId+" #rmb_category #li_blockDetail").addClass("active").siblings().removeClass("active");
        $(_pageId+" #rmb_category #block_detail").show();
		$(_pageId+" #rmb_category #fund_detail").hide();
		$(_pageId+" #rmb_category #out_fund_detail").hide();
		$(_pageId+" #rmb_category #bond_back_detail").hide();
		if(appUtils.getSStorageInfo("_prePageCode") != "index/index"){
			if(gconfig.platform != "0"){
				var user_id = external.callMessage({"key":"common_user_id","funcNo": "50041"}).results[0].value;
				if("" != user_id && null != user_id && undefined != user_id){
					appUtils.setSStorageInfo("user_id",user_id);
				}
				var curr_loginid = external.callMessage({"key":"curr_loginid","funcNo": "50041"}).results[0].value;
				if("" != curr_loginid && null != curr_loginid && undefined != curr_loginid){
					appUtils.setSStorageInfo("curr_loginid",curr_loginid);
				}
			}
		}
	}

	//查询人民币资产信息
	function queryAssetList(money_type){
		var param = {
			"user_id":appUtils.getSStorageInfo("user_id"),					//用户ID
//			"fund_account":appUtils.getSStorageInfo("curr_loginid"),		//资金帐号
			"moneytype":money_type											//货币类型:0：人民币，1：港币,2：美元
		};
		mobileService.queryAssetList(param, function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			var countData = data.countData;									//统计数据
			var assetInfoList = data.assetInfoList;							//资产明细
			var stockDetailList = data.stockDetailList;						//股票明细
			var fundDetailList = data.fundDetailList;						//场外基金持仓
			var bondReDetailList = data.bondReDetailList;					//债券回购持仓
			if(error_no == "0"){
				showTotalData(countData,money_type);
				showStockDetail(stockDetailList,money_type);
				showOutFund(fundDetailList,money_type);
				showBondInfo(bondReDetailList,money_type);
				showFundDetail(assetInfoList,money_type);
			}
			else{
				dealBusExc(money_type);
				layerUtils.iLoading(false);  // 关闭等待层。。。
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
				return false;
			}
		},{isShowWait:false});
	}
	
	//1、显示统计数据
	function showTotalData(countData,money_type){
		if("undefined" != countData && null != countData && "" != countData){
			var available_balance = countData[0].available_balance == undefined || countData[0].available_balance == null || countData[0].available_balance == "" ? "0.00" : common.formatMoney(countData[0].available_balance);	//资金可用
			var fetch_balance = countData[0].fetch_balance == undefined || countData[0].fetch_balance == null || countData[0].fetch_balance == "" ? "0.00" : common.formatMoney(countData[0].fetch_balance);			//资金可取
			var hk_balance = countData[0].hk_balance || countData[0].hk_balance == null || countData[0].hk_balance == "" ? "0.00" : common.formatMoney(countData[0].hk_balance);				//港股通可用
			var marketvalue = common.formatMoney(countData[0].marketvalue);				//资产总值
			var fundbal = common.formatMoney(countData[0].fundbal);						//资金余额
			var count_stockdetail = common.formatMoney(countData[0].stkvalue);			//证券市值
			var count_funddetail = common.formatMoney(countData[0].count_funddetail);	//场外基金市值
			var count_bondReDetail = common.formatMoney(countData[0].count_bondReDetail);//债券回购市值
			//RMB显示下面所有信息，HKD和USD不显示港股通可用、场外基金市值、债券回购市值
			if(money_type == "0"){
				$(_pageId+" #RMB_assetInfo").show();
				$(_pageId+" #rmb_category").show();
				$(_pageId+" #HKD_assetInfo").hide();
				$(_pageId+" #hkd_category").hide();
				$(_pageId+" #USD_assetInfo").hide();
				$(_pageId+" #usd_category").hide();
				$(_pageId+" #RMB_assetInfo #marketvalue").html(marketvalue);
				$(_pageId+" #RMB_assetInfo #fundbal").html(fundbal);
				$(_pageId+" #RMB_assetInfo #available_balance").html(available_balance);
				$(_pageId+" #RMB_assetInfo #hk_balance").html(hk_balance);
				$(_pageId+" #RMB_assetInfo #fetch_balance").html(fetch_balance);
				$(_pageId+" #RMB_assetInfo #stkvalue").html(count_stockdetail);
                $(_pageId+" #RMB_assetInfo #out_fund").html(count_funddetail);
				$(_pageId+" #RMB_assetInfo #bond_back").html(count_bondReDetail);
			}else if(money_type == "1"){
				$(_pageId+" #HKD_assetInfo").show();
				$(_pageId+" #hkd_category").show();
				$(_pageId+" #RMB_assetInfo").hide();
				$(_pageId+" #rmb_category").hide();
				$(_pageId+" #USD_assetInfo").hide();
				$(_pageId+" #usd_category").hide();
				$(_pageId+" #HKD_assetInfo #marketvalue").html(marketvalue);
				$(_pageId+" #HKD_assetInfo #fundbal").html(fundbal);
				$(_pageId+" #HKD_assetInfo #available_balance").html(available_balance);
				$(_pageId+" #HKD_assetInfo #fetch_balance").html(fetch_balance);
				$(_pageId+" #HKD_assetInfo #stkvalue").html(count_stockdetail);
			}else if(money_type == "2"){
				$(_pageId+" #USD_assetInfo").show();
				$(_pageId+" #usd_category").show();
				$(_pageId+" #RMB_assetInfo").hide();
				$(_pageId+" #rmb_category").hide();
				$(_pageId+" #HKD_assetInfo").hide();
				$(_pageId+" #hkd_category").hide();
				$(_pageId+" #USD_assetInfo #marketvalue").html(marketvalue);
				$(_pageId+" #USD_assetInfo #fundbal").html(fundbal);
				$(_pageId+" #USD_assetInfo #available_balance").html(available_balance);
				$(_pageId+" #USD_assetInfo #fetch_balance").html(fetch_balance);
				$(_pageId+" #USD_assetInfo #stkvalue").html(count_stockdetail);
			}
		}	
	}
	
	//2、显示资金明细，首先查询证券资金帐号对应的银行信息，再去匹配资产列表里面的资金帐号
	function showFundDetail(assetInfoList,money_type){
		var bank_param = {
			"user_id":appUtils.getSStorageInfo("user_id"),
			"zj_account":appUtils.getSStorageInfo("curr_loginid"),
			"flag_status":"0"
		};
		mobileService.getBankList(bank_param, function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			var results = data.results;
			var headElement = "";
			var htmlElement = "";
			var elments = "";
			var underline_tr = "<tr><td></td><td></td><td></td><td></td></tr>";
			if(error_no == "0"){
				if("undefined" != results && null != results && "" != results){
					for(var i=0;i<results.length;i++){
						var fund_account = data.results[i].fund_account;	//资金账号
						if("undefined" != assetInfoList && null != assetInfoList && "" != assetInfoList){
							for(var j=0;j<assetInfoList.length;j++){
								if(fund_account == assetInfoList[j].fund_account){
									var bank_name = data.results[i].bank_name;			//银行名称
									var is_main_card = data.results[i].is_main_card;	//是否是主卡：0：否，1：是
									var typeName = "主";
									if(is_main_card == 0){
										typeName = "辅";
									}
									else if(is_main_card == 1){
										typeName = "主";
									}
									var available_balance = common.formatMoney(assetInfoList[j].available_balance);			//资金可用
									var fetch_balance = common.formatMoney(assetInfoList[j].fetch_balance);					//资金可取
									if(money_type == "0"){
										htmlElement += "<tr><td><span>"+fund_account+"（"+typeName+"）</span><br><span>"+bank_name+"</span></td><td><span>"+available_balance+"</span><br><span>"+fetch_balance+"</span></td><td><a id=\"transfer\" class=\"mx_btn\" href=\"javascript:void(0);\">转账</a><a id=\"collection\" class=\"mx_btn\" href=\"javascript:void(0);\">归集</a></td><td></td></tr>";
									}else{
										htmlElement += "<tr><td><span>"+fund_account+"（"+typeName+"）</span><br><span>"+bank_name+"</span></td><td><span>"+available_balance+"</span><br><span>"+fetch_balance+"</span></td><td><a id=\"transfer\" class=\"mx_btn\" href=\"javascript:void(0);\">转账</a></td><td></td></tr>";
									}
								}
								appUtils.preBindEvent($(_pageId+" #fund_detail"),"#transfer",function(e){
									 var param = {
										"funcNo":"50101",
										"moduleName":"trade",
										"params" :{
											"topage" : "banking/transfer.html",//跳转url
											"bankingMark" : "toBanking"
										}
									};
									external.callMessage(param);
								});
								appUtils.preBindEvent($(_pageId+" #fund_detail"),"#collection",function(e){
									var param = {
										"funcNo":"50101",
										"moduleName":"trade",
										"params" :{
											"topage" : "banking/collection.html",//跳转url
											"bankingMark" : "toBanking"
										}
									};
									external.callMessage(param);
								});
							}
						}
					}

				}
				headElement ='<tr><th width="40%">资金账号/银行</th><th width="32%">可用/可取</th><th width="28%">操作</th><th></th></tr>';
				elments = headElement + htmlElement+underline_tr;
				if(money_type == "0"){
					$(_pageId+" #rmb_category #fund_detail").html(elments);
				}else if(money_type == "1"){
					$(_pageId+" #hkd_category #fund_detail").html(elments);
				}else if(money_type == "2"){
					$(_pageId+" #usd_category #fund_detail").html(elments);
				}
			} else {
				var headElement ='<tr><th width="40%">资金账号/银行</th><th width="32%">可用/可取</th><th width="28%">操作</th><th></th></tr>';
				$(_pageId+" #rmb_category #fund_detail").html(headElement);
				$(_pageId+" #hkd_category #fund_detail").html(headElement);
				$(_pageId+" #usd_category #fund_detail").html(headElement);
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
				return false;
			}
		},{isShowWait:false});	
	}
	
	//3、显示股票明细
	function showStockDetail(stockDetailList,money_type){
		var stockHead = '<tr><th width="25%">证券/代码</th><th width="25%">持仓/市值</th><th width="25%">盈亏/比例</th><th width="25%">成本/市价</th></tr>';
		var stockHtml = "";
		var stockElements = "";
		var underline_tr = "<tr><td></td><td></td><td></td><td></td></tr>";
		if("undefined" != stockDetailList && null != stockDetailList && "" != stockDetailList){
			for(var k=0;k<stockDetailList.length;k++){
				var stkname = stockDetailList[k].stkname;								//证券名称
				var stkcode = stockDetailList[k].stkcode;								//证券代码
				var stkcount = stockDetailList[k].stkcount;								//持仓
				var mktval = stockDetailList[k].mktval == undefined || stockDetailList[k].mktval == null || stockDetailList[k].mktval == "" ? "0" : common.formatMoney(stockDetailList[k].mktval);				//市值
				var income = stockDetailList[k].income == undefined || stockDetailList[k].income == null || stockDetailList[k].income == "" ? "0.00" : common.formatMoney(stockDetailList[k].income);			    //盈亏
				var income_rate = stockDetailList[k].income_rate;   					//盈亏百分比，单位%
				var costprice = stockDetailList[k].costprice;	    					//成本价
				var lastprice = stockDetailList[k].lastprice;	    					//市价
				if(income_rate>=0){
					stockHtml += "<tr id=\"stock_id\"><td><strong>"+stkname+"</strong><small>"+stkcode+"</small></td><td><h5>"+stkcount+"</h5><p>"+mktval+"</p></td><td><h5 class=\"ared\">"+income+"</h5><p class=\"ared\">"+income_rate+"%</p></td><td><h5>"+costprice+"</h5><p>"+lastprice+"</p></td></tr>";
				}
				else{
					stockHtml += "<tr id=\"stock_id\"><td><strong>"+stkname+"</strong><small>"+stkcode+"</small></td><td><h5>"+stkcount+"</h5><p>"+mktval+"</p></td><td><h5 class=\"agreen\">"+income+"</h5><p class=\"agreen\">"+income_rate+"%</p></td><td><h5>"+costprice+"</h5><p>"+lastprice+"</p></td></tr>";
				}
			}
		}
		stockElements = stockHead+stockHtml+underline_tr;
		if(money_type == "0"){
			$(_pageId+" #rmb_category #block_detail").html(stockElements);
			$(_pageId+" #rmb_category #block_detail").show();
			appUtils.preBindEvent($(_pageId+" #rmb_category #block_detail"),"#stock_id",function(e){
				 var param = {
					"funcNo":"50101",
					"moduleName":"trade",
					"params" :{
						"topage" : "stock/stockSell.html",								//跳转url
						"stockCode"  : $(this).find("td:first-child p").text(),			//股票代码
						"bankingMark" : "toStockSell"
					}
				};
				external.callMessage(param);
			});
		}else if(money_type == "1"){
			$(_pageId+" #hkd_category #block_detail").html(stockElements);
			$(_pageId+" #hkd_category #block_detail").show();
			appUtils.preBindEvent($(_pageId+" #hkd_category #block_detail"),"#stock_id",function(e){
				 var param = {
					"funcNo":"50101",
					"moduleName":"trade",
					"params" :{
						"topage" : "stock/stockSell.html",								//跳转url
						"stockCode"  : $(this).find("td:first-child p").text(),			//股票代码
						"bankingMark" : "toStockSell"
					}
				};
				external.callMessage(param);
			});
		}else if(money_type == "2"){
			$(_pageId+" #usd_category #block_detail").html(stockElements);
			$(_pageId+" #usd_category #block_detail").show();
			appUtils.preBindEvent($(_pageId+" #usd_category #block_detail"),"#stock_id",function(e){
				 var param = {
					"funcNo":"50101",
					"moduleName":"trade",
					"params" :{
						"topage" : "stock/stockSell.html",								//跳转url
						"stockCode"  : $(this).find("td:first-child p").text(),			//股票代码
						"bankingMark" : "toStockSell"
					}
				};
				external.callMessage(param);
			});
		}
	}
	
	//4、显示场外基金
	function showOutFund(fundDetailList,money_type){
		var fundHead = '<tr><th width="25%">产品名称</th><th width="25%">公司/代码</th><th width="25%">余额/可用</th><th width="25%">净值/市值</th></tr>';
		var fundHtml = "";
        var fundElements = "";
        var underline_tr = "<tr><td></td><td></td><td></td><td></td></tr>";
		if("undefined" != fundDetailList && null != fundDetailList && "" != fundDetailList){
			for(var f=0;f<fundDetailList.length;f++){
				var taname = fundDetailList[f].taname;									//产品名称
				var tacode = fundDetailList[f].tacode;									//基金公司
				var ofcode = fundDetailList[f].ofcode;									//基金代码
				var fundname =fundDetailList[f].fundname;							    //基金名称
				var ofbal = fundDetailList[f].ofbal == undefined || fundDetailList[f].ofbal == null || fundDetailList[f].ofbal == "" ? "0.00" : common.formatMoney(fundDetailList[f].ofbal);				//基金余额
				var ofavl = fundDetailList[f].ofavl == undefined || fundDetailList[f].ofavl == null || fundDetailList[f].ofavl == "" ? "0.00" : common.formatMoney(fundDetailList[f].ofavl);				//可用数
				var netValue = fundDetailList[f].netValue == undefined ? "0.0" : common.formatMoney(fundDetailList[f].netValue);		    //基金净值
				var marketvalue = common.formatMoney(fundDetailList[f].marketvalue);	//基金证券市值
				fundHtml += "<tr><td><h5>"+fundname+"</h5></td><td><h5>"+taname+"</h5><p>"+ofcode+"</p></td><td><h5>"+ofbal+"</h5><p>"+ofavl+"</p></td><td><h5>"+netValue+"</h5><p>"+marketvalue+"</p></tr>";
			}
			fundElements = fundHead+fundHtml+underline_tr;
            $(_pageId+" #out_fund_detail").html(fundElements);
		}
		fundElements = fundHead+fundHtml+underline_tr;
		if(money_type == "0"){
			$(_pageId+" #rmb_category #out_fund_detail").html(fundElements);
		}else if(money_type == "1"){
			$(_pageId+" #hkd_category #out_fund_detail").html(fundElements);
		}else if(money_type == "2"){
			$(_pageId+" #usd_category #out_fund_detail").html(fundElements);
		}	
	}
	
	//5、显示债券回购
	function showBondInfo(bondReDetailList,money_type){
		var bondHead = '<tr><th width="25%">日期/品种</th><th width="25%">购回金额</th><th width="25%">名称/代码</th><th width="25%">数量/单价</th></tr>';
		var bondHtml = "";
		var bondElements = "";
		var underline_tr = "<tr><td></td><td></td><td></td><td></td></tr>";
		if("undefined" != bondReDetailList && null != bondReDetailList && "" != bondReDetailList){
			for(var b=0;b<bondReDetailList.length;b++){
				if(bondReDetailList[b].bb_date == "" && bondReDetailList[b].trd_behavior_desc == "" 
					&& bondReDetailList[b].bb_amt == "" && bondReDetailList[b].stkcode == "" 
					&& bondReDetailList[b].secu_code == "" && bondReDetailList[b].bb_qty == "" 
					&& bondReDetailList[b].bb_price == ""){
					bondHtml = "";	
				}
				else{
					var bb_date = bondReDetailList[b].bb_date;									//成交日期
					var trd_behavior_desc = bondReDetailList[b].trd_behavior_desc;				//品种说明
					var bb_amt = bondReDetailList[b].bb_amt == undefined || bondReDetailList[b].bb_amt == null || bondReDetailList[b].bb_amt == "" ? "0.0" : common.formatMoney(bondReDetailList[b].bb_amt);				//成交金额
					var stkcode = bondReDetailList[b].stkcode;									//证券名称
					var secu_code = bondReDetailList[b].secu_code;								//证券代码
					var bb_qty = bondReDetailList[b].bb_qty == undefined || bondReDetailList[b].bb_qty == null || bondReDetailList[b].bb_qty == "" ? "0" : common.formatMoney(bondReDetailList[b].bb_qty);									//成交数量
					var bb_price = bondReDetailList[b].bb_price == undefined || bondReDetailList[b].bb_price == null || bondReDetailList[b].bb_price == ""  ? "0.0" : common.formatMoney(bondReDetailList[b].bb_price);						//单价
					if(bb_amt < 0){
						bondHtml += "<tr class=\"redcol\"><td><h5>"+bb_date+"</h5><p>"+trd_behavior_desc+"</p></td><td><h5>"+bb_amt+"</h5></td><td><h5>"+stkcode+"</h5><p>"+secu_code+"</p></td><td><h5>"+bb_qty+"</h5><p>"+bb_price+"</p></td></tr>";
					}
					else{
						bondHtml += "<tr><td><h5>"+bb_date+"</h5><p>"+trd_behavior_desc+"</p></td><td><h5>"+bb_amt+"</h5></td><td><h5>"+stkcode+"</h5><p>"+secu_code+"</p></td><td><h5>"+bb_qty+"</h5><p>"+bb_price+"</p></td></tr>";
					}
				}
			}
		}
		bondElements = bondHead+bondHtml+underline_tr;
		if(money_type == "0"){
			$(_pageId+" #rmb_category #bond_back_detail").html(bondElements);
		}else if(money_type == "1"){
			$(_pageId+" #hkd_category #bond_back_detail").html(bondElements);
		}else if(money_type == "2"){
			$(_pageId+" #usd_category #bond_back_detail").html(bondElements);
		}
	}
	
	//bus调用出错页面显示
	function dealBusExc(money_type){
	    //1、显示资金明细
	    var headElement ='<tr><th width="40%">资金账号/银行</th><th width="32%">可用/可取</th><th width="28%">操作</th></tr>';
		//2、显示股票明细
		var stockHead = '<tr><th width="25%">证券/代码</th><th width="25%">持仓/市值</th><th width="25%">盈亏/比例</th><th width="25%">成本/市价</th></tr>';
		//3、显示场外基金
		var fundHead = '<tr><th width="25%">产品名称</th><th width="25%">公司/代码</th><th width="25%">余额/可用</th><th width="25%">净值/市值</th></tr>';
		//4、显示债券回购
		var bondHead = '<tr><th width="25%">日期/品种</th><th width="25%">购回金额</th><th width="25%">名称/代码</th><th width="25%">数量/单价</th></tr>';
		if(money_type == "0"){
		   $(_pageId+" #rmb_category #fund_detail").html(headElement);
		   $(_pageId+" #rmb_category #block_detail").html(stockHead);
		   $(_pageId+" #rmb_category #out_fund_detail").html(fundHead);
		   $(_pageId+" #rmb_category #bond_back_detail").html(bondHead);
		}else if(money_type == "1"){
		   $(_pageId+" #hkd_category #fund_detail").html(headElement);
		   $(_pageId+" #hkd_category #block_detail").html(stockHead);
		   $(_pageId+" #hkd_category #out_fund_detail").html(fundHead);
		   $(_pageId+" #hkd_category #bond_back_detail").html(bondHead);
		}else if(money_type == "2"){
		   $(_pageId+" #usd_category #fund_detail").html(headElement);
		   $(_pageId+" #usd_category #block_detail").html(stockHead);
		   $(_pageId+" #usd_category #out_fund_detail").html(fundHead);
		   $(_pageId+" #usd_category #bond_back_detail").html(bondHead);
		}
	}
	
	function bindPageEvent() {
		// 绑定返回
		appUtils.bindEvent($(_pageId+" .icon_back"), function(e){
			if(appUtils.getSStorageInfo("_prePageCode") == "myAccount/index"){
				//跳转到我的账户首页
				appUtils.pageInit("asset/index", "myAccount/index", {});
			}else{
				common.showTabBar();
				var param = {
					"funcNo":"50101",
					"moduleName":"home"
				};
				external.callMessage(param);
			}
		});
		
		// 绑定刷新按钮
		appUtils.bindEvent($(_pageId+" .icon_refresh"), function(e){
			init();
		});

		//证券交易
		appUtils.bindEvent($(_pageId+" #zqjy"), function(e){
			appUtils.setSStorageInfo("tab_type","stock_tab");
            external.callMessage({"funcNo": "50040", "key": "ygt_module", "value": "stock"});
			//普通交易首页模块
			external.callMessage({"funcNo": "50040", "key": "trade_module", "value": "stock"});
			var stock_account = nativePluginService.function50041({"key":"COMMON_LOGIN_STATE"}).results[0].value;		//1、已登录
			if("1" == stock_account){
				appUtils.pageInit("asset/index", "asset/index", {});
			}
		});

		// 绑定融资融券
		appUtils.bindEvent($(_pageId+" #rzrq"), function(){
			appUtils.setSStorageInfo("tab_type","credit_tab");
			//信用首页模块
			external.callMessage({"funcNo": "50040", "key": "trade_module", "value": "credit"});
			external.callMessage({"funcNo": "50040", "key": "ygt_module", "value": "credit"});
			var credit_accouont = nativePluginService.function50041({"key":"CREDIT_LOGIN_STATE"}).results[0].value;     	//1、已登录
			if("1" == credit_accouont){
				appUtils.pageInit("asset/index", "credit/creditAsset", {});
			}else{
//				layerUtils.iAlert("您还没有登录信用账户，请先登录！","0",function(){
					appUtils.pageInit("asset/index", "credit/creditAsset", {});
//				});
			}
		});
		
		// 绑定人民币切换
		appUtils.bindEvent($(_pageId+" #RMB"), function(){
			$(this).addClass("active").siblings().removeClass("active");
			$(_pageId+" #rmb_category #li_blockDetail").addClass("active").siblings().removeClass("active");
			$(_pageId+" #rmb_category  #block_detail").show();
			$(_pageId+" #rmb_category #fund_detail").hide();
			$(_pageId+" #rmb_category #out_fund_detail").hide();
			$(_pageId+" #rmb_category #bond_back_detail").hide();
			queryAssetList("0");
		});
		
		// 绑定港币切换
		appUtils.bindEvent($(_pageId+" #HKD"), function(){
			$(this).addClass("active").siblings().removeClass("active");
			$(_pageId+" #hkd_category #li_blockDetail").addClass("active").siblings().removeClass("active");
			$(_pageId+" #hkd_category #block_detail").show();
			$(_pageId+" #hkd_category #fund_detail").hide();
			$(_pageId+" #hkd_category #out_fund_detail").hide();
			$(_pageId+" #hkd_category #bond_back_detail").hide();
			queryAssetList("1");
		});
		
		// 绑定美元切换
		appUtils.bindEvent($(_pageId+" #USD"), function(){
			$(this).addClass("active").siblings().removeClass("active");
			$(_pageId+" #usd_category #li_blockDetail").addClass("active").siblings().removeClass("active");
			$(_pageId+" #usd_category #block_detail").show();
			$(_pageId+" #usd_category #fund_detail").hide();
			$(_pageId+" #usd_category #out_fund_detail").hide();
			$(_pageId+" #usd_category #bond_back_detail").hide();
			queryAssetList("2");
		});
		
		/******************人民币下股票明细等类别信息分割线****************/
		//股票明细切换
		appUtils.bindEvent($(_pageId + " #rmb_category #li_blockDetail"), function(){
			 $(this).addClass("active").siblings().removeClass("active");
			 $(_pageId+" #rmb_category #block_detail").show();
			 $(_pageId+" #rmb_category #fund_detail").hide();
			 $(_pageId+" #rmb_category #out_fund_detail").hide();
			 $(_pageId+" #rmb_category #bond_back_detail").hide();
		});

		//场外基金切换
		appUtils.bindEvent($(_pageId + " #rmb_category #li_outFundDetail"), function(){
			 $(this).addClass("active").siblings().removeClass("active");
			 $(_pageId+" #rmb_category #out_fund_detail").show();
			 $(_pageId+" #rmb_category #block_detail").hide();
			 $(_pageId+" #rmb_category #fund_detail").hide();
			 $(_pageId+" #rmb_category #bond_back_detail").hide();
		});

		//债券回购切换
		appUtils.bindEvent($(_pageId + " #rmb_category #li_bondReDetail"), function(){
			 $(this).addClass("active").siblings().removeClass("active");
			 $(_pageId+" #rmb_category #bond_back_detail").show();
			 $(_pageId+" #rmb_category #block_detail").hide();
			 $(_pageId+" #rmb_category #fund_detail").hide();
			 $(_pageId+" #rmb_category #out_fund_detail").hide();
		});

		//资金明细切换
		appUtils.bindEvent($(_pageId + " #rmb_category #li_fundDetail"), function(){
			 $(this).addClass("active").siblings().removeClass("active");
			 $(_pageId+" #rmb_category #fund_detail").show();
			 $(_pageId+" #rmb_category #block_detail").hide();
			 $(_pageId+" #rmb_category #out_fund_detail").hide();
             $(_pageId+" #rmb_category #bond_back_detail").hide();
		});
		
		/******************港币下股票明细等类别信息分割线****************/
		//股票明细切换
		appUtils.bindEvent($(_pageId + " #hkd_category #li_blockDetail"), function(){
			 $(this).addClass("active").siblings().removeClass("active");
			 $(_pageId+" #hkd_category #block_detail").show();
			 $(_pageId+" #hkd_category #fund_detail").hide();
			 $(_pageId+" #hkd_category #out_fund_detail").hide();
			 $(_pageId+" #hkd_category #bond_back_detail").hide();
		});

		//场外基金切换
		appUtils.bindEvent($(_pageId + " #hkd_category #li_outFundDetail"), function(){
			 $(this).addClass("active").siblings().removeClass("active");
			 $(_pageId+" #hkd_category #out_fund_detail").show();
			 $(_pageId+" #hkd_category #block_detail").hide();
			 $(_pageId+" #hkd_category #fund_detail").hide();
			 $(_pageId+" #hkd_category #bond_back_detail").hide();
		});

		//债券回购切换
		appUtils.bindEvent($(_pageId + " #hkd_category #li_bondReDetail"), function(){
			 $(this).addClass("active").siblings().removeClass("active");
			 $(_pageId+" #hkd_category #bond_back_detail").show();
			 $(_pageId+" #hkd_category #block_detail").hide();
			 $(_pageId+" #hkd_category #fund_detail").hide();
			 $(_pageId+" #hkd_category #out_fund_detail").hide();
		});

		//资金明细切换
		appUtils.bindEvent($(_pageId + " #hkd_category #li_fundDetail"), function(){
			 $(this).addClass("active").siblings().removeClass("active");
			 $(_pageId+" #hkd_category #fund_detail").show();
			 $(_pageId+" #hkd_category #block_detail").hide();
			 $(_pageId+" #hkd_category #out_fund_detail").hide();
             $(_pageId+" #hkd_category #bond_back_detail").hide();
		});
		
		/******************美元下股票明细等类别信息分割线****************/
		//股票明细切换
		appUtils.bindEvent($(_pageId + " #usd_category #li_blockDetail"), function(){
			 $(this).addClass("active").siblings().removeClass("active");
			 $(_pageId+" #usd_category #block_detail").show();
			 $(_pageId+" #usd_category #fund_detail").hide();
			 $(_pageId+" #usd_category #out_fund_detail").hide();
			 $(_pageId+" #usd_category #bond_back_detail").hide();
		});

		//场外基金切换
		appUtils.bindEvent($(_pageId + " #usd_category #li_outFundDetail"), function(){
			 $(this).addClass("active").siblings().removeClass("active");
			 $(_pageId+" #usd_category #out_fund_detail").show();
			 $(_pageId+" #usd_category #block_detail").hide();
			 $(_pageId+" #usd_category #fund_detail").hide();
			 $(_pageId+" #usd_category #bond_back_detail").hide();
		});

		//债券回购切换
		appUtils.bindEvent($(_pageId + " #usd_category #li_bondReDetail"), function(){
			 $(this).addClass("active").siblings().removeClass("active");
			 $(_pageId+" #usd_category #bond_back_detail").show();
			 $(_pageId+" #usd_category #block_detail").hide();
			 $(_pageId+" #usd_category #fund_detail").hide();
			 $(_pageId+" #usd_category #out_fund_detail").hide();
		});

		//资金明细切换
		appUtils.bindEvent($(_pageId + " #usd_category #li_fundDetail"), function(){
			 $(this).addClass("active").siblings().removeClass("active");
			 $(_pageId+" #usd_category #fund_detail").show();
			 $(_pageId+" #usd_category #block_detail").hide();
			 $(_pageId+" #usd_category #out_fund_detail").hide();
             $(_pageId+" #usd_category #bond_back_detail").hide();
		});
	}

	function destroy(){
		external.callMessage({"funcNo": "50040", "key": "trade_module", "value": ""});
		external.callMessage({"funcNo": "50040", "key": "ygt_module", "value": ""});
		mobileService.destroy();
	}
	
	var index = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = index;
});
