define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var validata = require("validatorUtil");
	var layerUtils = require("layerUtils");
	var _pageId ="#cashTreasure_cashTreasureInfo";
	var mobileService = require("mobileService");
	var external = require("external");
	

	function init() {
		cleanPageElement();
		queryCashTreaInfo();
	}
	
	function cleanPageElement(){ 
		$(_pageId+" #fund_limit").html("");
		$(_pageId+" #product_limit").html("");
		$(_pageId+" #state").html("正常开放");
		$(_pageId+" #startDate").html("");
		$(_pageId+" #productCode").html("");
		$(_pageId+" #productName").html("");
		$(_pageId+" #bankingAccount").html(appUtils.getSStorageInfo("curr_loginid"));
		$(_pageId+" #tradeAccount").html("");	
	}
	
	/*查询现金宝信息*/
	function queryCashTreaInfo(){
		var param = {
			"user_id" : appUtils.getSStorageInfo("user_id"),
			"fund_account" : appUtils.getSStorageInfo("curr_loginid")
		};
		mobileService.queryCashTreasureInfo(param,function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no == "0" && data.results != undefined){
				var query_flag = data.results[0].query_flag;		//是否查询到数据:0：否，1：是
				if(query_flag == "0"){
					appUtils.setSStorageInfo("caseInfo","");
					layerUtils.iAlert("您还未开通现金宝，请先开通！","0",function(){
						appUtils.pageInit("cashTreasure/cashTreasureInfo","cashTreasure/fundRiskAssessment");
					});
				}else{
					appUtils.setSStorageInfo("caseInfo",JSON.stringify(data.results[0]));
					var capital_limit = data.results[0].capital_limit;	//保留金额度
					var sign_date = data.results[0].sign_date;			//签署日期
					var fund_code= data.results[0].fund_code;			//基金代码
					var fund_name = data.results[0].fund_name;			//基金名称
	//				var query_flag = data.results[0].query_flag;		//理财账户
	//				var query_flag = data.results[0].query_flag;		//交易账户
					$(_pageId+" #title_code").html(fund_code);
					$(_pageId+" #fund_limit").html(capital_limit);
					$(_pageId+" #state").html();
					$(_pageId+" #startDate").html(sign_date);
					$(_pageId+" #productCode").html(fund_code);
					$(_pageId+" #productName").html(fund_name);
					$(_pageId+" #tradeAccount").html();
					queryCashShare();
				}
			}else {
				layerUtils.iLoading(false);
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
				return false;
			}
		},{isShowWait:false});
	}
	
	//查询现金宝份额
	function queryCashShare(){
		var param = {
			"user_id" : appUtils.getSStorageInfo("user_id"),
			"fund_account" : appUtils.getSStorageInfo("curr_loginid")
		};
		mobileService.queryCashTreaShare(param,function(data){
			var query_flag = data.results[0].query_flag;		//是否查询到数据:0：否，1：是
			if(query_flag == "0"){
				$(_pageId+" #product_limit").html("0");
			}else{
				var fund_avl = data.results[0].fund_avl;			//基金份额
				$(_pageId+" #product_limit").html(fund_avl);
			}
		},{isShowWait:false});
	}
	
	//现金宝解约
	function caseUnwind(){
		var param = {
			"user_id" : appUtils.getSStorageInfo("user_id"),
			"fund_account" : appUtils.getSStorageInfo("curr_loginid")
		};
		mobileService.cashTreasureTerm(param,function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no == "0"){
				layerUtils.iAlert("解约成功！");
			}else {
				layerUtils.iLoading(false);
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
				return false;
			}
		});
	}
	
	function bindPageEvent() {
		// 绑定返回
		appUtils.bindEvent($(_pageId+" .icon_back"), function(){
			appUtils.pageBack();
		});
		
		//解约
		appUtils.bindEvent($(_pageId + " #unwind"), function(e) {
			layerUtils.iConfirm("您确定要解约吗？",function(){
				caseUnwind();
			}); 
		});
		
		//额度设置
		appUtils.bindEvent($(_pageId + " #limitSet"), function(e) {
			appUtils.pageInit("cashTreasure/cashTreasureInfo", "cashTreasure/limitSet"); 
		});
		
		//预约取款
		appUtils.bindEvent($(_pageId + " #subscribe"), function(e) {
			appUtils.pageInit("cashTreasure/cashTreasureInfo", "cashTreasure/subscribeWithMoney"); 
		});
	}
	
	function destroy(){
		mobileService.destroy();
	}
	
	var cashTreasureInfo = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = cashTreasureInfo;
});
