/**
 * 签署协议
 */
define(function(require, exports, module){ 
	/* 私有业务模块的全局变量 begin */
	var appUtils = require("appUtils"),
		global = require("gconfig").global,
		layerUtils = require("layerUtils"),
		Map = require("map"),
		fristMap = null,  //  存放所有相关协议
	    protocolArray = new Array(),  // 存放协议签名值
	    countProtocol = 0, // 计算签署成功的数量
		_pageId = "#cashTreasure_electronicSign";
	var mobileService = require("mobileService");
	var external = require("external");
	
	function init()
	{
		getProtocolInfo();
	}
	
	//获取协议
	function getProtocolInfo(){
		var param = {
			"category_englishname":"",
			"category_no":"ygt_dzqmydsxy_type",
			"econtract_no":""
		};
		mobileService.getSign(param,function(data){
			var error_no = data.error_no,
				error_info = data.error_info,
				result = data.results;
			if(error_no == "0" && result.length != 0){
				fristMap = new Map();
				var results = data.results,
					  allProtocols = "";
				var protocolMap = null;
				for(var i=0;i<results.length;i++)
				{
					protocolMap = new Map();
					protocolMap.put("protocolid",results[i].agree_no);	//协议id
					protocolMap.put("protocolname",results[i].agree_name);	//协议名
					protocolMap.put("summary",results[i].md5_content);	//协议内容MD5,签名摘要信息
					allProtocols += "<ul><li><a href=\"javascript:void(0);\" protocol-id=\""+results[i].agree_no+"\" id=\"protocol0"+i+"\">《"+
						results[i].agree_name+"》</a></li><ul>";
					// 预绑定查看协议的事件
					appUtils.preBindEvent($(_pageId+" .rule_list"),"#protocol0"+i,function(e){
						appUtils.setSStorageInfo("protocol_id",$(this).attr("protocol-id"));
						appUtils.pageInit("cashTreasure/electronicSign","cashTreasure/showCashTreasureProtocol",{"protocol_id" : $(this).attr("protocol-id")});
						e.stopPropagation();
					});
					fristMap.put(i,protocolMap);
				}
				$(_pageId+" .rule_list").html(allProtocols);
			}else{
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
			}
		},{isShowWait:false});
	}
	
	/* 获取签名值 */
	function getSignProtocl()
	{
		layerUtils.iLoading(true);  // 开启等待层。。。
		var keys = fristMap.keys();  // 协议的数量
		var oneData  = fristMap.get(keys[countProtocol]); // 取出一个协议
		var protocolid = oneData.get("protocolid"); // 协议ID
		var summary = oneData.get("summary");  // 协议内容MD5,签名摘要信息
		// 添加值到数组中
		var protocol = {
			"protocol_id" : protocolid,
			"summary" : summary
		};
		protocolArray.push(protocol);
		countProtocol++;
		if(countProtocol < keys.length)  // 通过比较，获取每个协议的签名值
		{
			getSignProtocl();  
		}else{
			submitProtocol();  //提交协议
		}
	}
	
	// 提交协议
	function submitProtocol(){
		countProtocol = 0;  // 将签署协议的计数器置为 0
		var signProtocolParam = {
			"user_id" : appUtils.getSStorageInfo("user_id"),
			"fund_account" : appUtils.getSStorageInfo("curr_loginid"),
			"jsondata" : JSON.stringify(protocolArray),
			"ipaddr" : "",
			"macaddr" : "",
			"checksign" : "0",
			"sign_source_flag" : "1",
			"certType" : ""
		};
		mobileService.signCaseProtocol(signProtocolParam,function(data){
			var error_no = data.error_no,
				error_info = data.error_info;
			if(error_no == "0"){
				queryCashRiskStatus();
			}else{
				protocolArray = new Array();
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
				return false;
			}
		});
	}

	/* 查询到现金宝是否做过基金风险测评 */
	function queryCashRiskStatus(){
		var param = {
			"user_id" : appUtils.getSStorageInfo("user_id"),
			"fund_account" : appUtils.getSStorageInfo("curr_loginid")
		};
		mobileService.queryCashRiskState(param,function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			var results = data.results;
			if(error_no == "0" && results.length!=0){
				var status = data.results[0].status;							//基金风险测评开通状态:-1 已过期，0 未提交过 1 正常
				var message = data.results[0].message;							//状态描述:0：开通失败，1：开通成功
				var grade_status = data.results[0].grade_status;				//0：用户风险等级小于基金风险等级 1：用户风险等级大于或等于基金风险等级
				//判断是否做过风险测评，状态是否是正常并且满足等级的
				if("1" == status && "1" == grade_status){
					queryIsOpenFund();
				}else{
					appUtils.pageInit("index/index", "cashTreasure/fundRiskAssessment", {});
				}
			}else {
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
				return false;
			}
		},{isShowWait:false});
	}

	/* 判断是否开过98基金  */
	function queryIsOpenFund(){
		 var param = {
			"user_id" : appUtils.getSStorageInfo("user_id"),
			"fund_account" : appUtils.getSStorageInfo("curr_loginid")
		};
		mobileService.queryIsOpenFundAccount(param,function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			var results = data.results;
			if(error_no == "0" && results.length!=0){
				var flag = data.results[0].flag;							//0：未开通  1：已开通
				//已开通则直接去签署现金宝协议
				if("1" == flag){
					appUtils.setSStorageInfo("isOpenFundAccount","1")
					appUtils.pageInit("index/index", "cashTreasure/signCashTreaProtocol", {});
				}else{
					appUtils.setSStorageInfo("isOpenFundAccount","0")
					//否则先去开98基金
					appUtils.pageInit("index/index", "fund/signFundProtocol", {});
				}
			}else {
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
				return false;
			}
		},{isShowWait:false});
	}

	//绑定
	function bindPageEvent(){
		/* 绑定签署协议*/
		appUtils.bindEvent($(_pageId+" .rule_check span"),function(){
			$(this).toggleClass("checked"); //  切换勾选样式
		});
		
		//绑定提交申请
		appUtils.bindEvent($(_pageId+" .ce_btn"),function(){
			if(!$(_pageId+" .icon_check").hasClass("checked")) {
				layerUtils.iMsg(-1, "请阅读并勾选以上全部协议！");
				return false;
			} else {
				getSignProtocl();
			}
		});
		
		//绑定返回按钮
		appUtils.bindEvent($(_pageId+" .icon_back"),function(){
			appUtils.pageInit("cashTreasure/electronicSign","index/index",{});
		});
	}
	
	function destroy()
	{
		mobileService.destroy();
	}
	
	var electronicSign = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
		
	module.exports = electronicSign;
});