define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var validata = require("validatorUtil");
	var layerUtils = require("layerUtils");
	var _pageId ="#cashTreasure_limitSet";
	var mobileService = require("mobileService");
	var external = require("external");
	var utils = require("utils");
	var caseInfo = "";			//现金宝信息
	

	function init() {
		 window.selDateCallback = selDateCallback;
		 caseInfo = JSON.parse(appUtils.getSStorageInfo("caseInfo"));
		 $(_pageId+" #productCode").val(caseInfo.fund_code);
		 $(_pageId+" #productName").val(caseInfo.fund_name);
		 $(_pageId+" #saveLimit").val(caseInfo.capital_limit);
		 $(_pageId+" #saveDate").val(caseInfo.expiry_date);
		 queryShareInfo();
	}
	
	/* 日历的回调函数 */
	function selDateCallback(data) {
		// 回调数据中的 data 是字符串，需解析
		if (typeof(data) == "string") {
			data = JSON.parse(data);
		}
		$(_pageId + " #"+data.selector).val(data.date);
	}
	
	/*查询额度设置信息*/
	function queryShareInfo(){
		var param = {
			"user_id" : appUtils.getSStorageInfo("user_id"),
			"fund_account" : appUtils.getSStorageInfo("curr_loginid")
		};
		mobileService.queryCashTreasureInfo(param,function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			var innerHtml = "";
			if(error_no == "0" && data.results != undefined){
				var query_flag = data.results[0].query_flag;		//是否查询到数据:0：否，1：是
				if(query_flag == "0"){
					layerUtils.iAlert("您还未开通现金宝，请先开通！","0",function(){
						appUtils.pageInit("cashTreasure/limitSet","cashTreasure/fundRiskAssessment");
					});
				}else{
					var fund_code= data.results[0].fund_code;			//基金代码
					var fund_name = data.results[0].fund_name;			//基金名称
					var expiry_date = data.results[0].expiry_date;		//保留日期
					var capital_limit = data.results[0].capital_limit;	//保留金额度
					innerHtml = "<li><span>"+fund_code+"</span><span class=\"center\">"+fund_name+"</span><span class=\"center\">"+capital_limit+"</span><span>"+expiry_date+"</span></li>";
					$(_pageId+" #share_list").html(innerHtml);
				}
			}else {
				layerUtils.iLoading(false);
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
				return false;
			}
		},{isShowWait:false});	
	}
	
	//额度设置
	function cashLimitSet(){
		var param = {
			"user_id" : appUtils.getSStorageInfo("user_id"),
			"fund_account" : appUtils.getSStorageInfo("curr_loginid"),
			"expiry_date" : $(_pageId+" #saveDate").val(),
			"reserve_money" : $(_pageId+" #saveLimit").val(),
			"operation_type" : "1"
		};
		mobileService.limitSet(param,function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no == "0"){
				layerUtils.iAlert("委托已提交！","0",function(){
					queryShareInfo();
				});
			}else {
				layerUtils.iLoading(false);
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
				return false;
			}
		});
	}
	
	function bindPageEvent() {
		// 绑定返回
		appUtils.bindEvent($(_pageId+" .icon_back"), function(){
			appUtils.pageBack();
		});

		/* 绑定选择日期的事件 */
		appUtils.bindEvent($(_pageId+" input[date-plugin='true']"),function(e){
			utils.selectDate(this);  // 通过壳子调用系统的日历插件
		});

		//额度设置
		appUtils.bindEvent($(_pageId + " .ce_btn"), function(e) {
			var saveLimit = $(_pageId+" #saveLimit").val();
			var date = new Date().format("yyyy-MM-dd"); //得到当前日期
			var saveDate = $(_pageId+" #saveDate").val();
			if(saveLimit.length == 0 || saveLimit == 0){
				layerUtils.iAlert("额度设置不正确");
                return false;
			}
			if(saveDate <= date){
				layerUtils.iAlert("保留日期不能小于等于当前日期");
				return false;
			}
			cashLimitSet();
		});
	}
	
	function destroy(){
		mobileService.destroy();
	}
	
	var limitSet = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = limitSet;
});
