define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var validata = require("validatorUtil");
	var layerUtils = require("layerUtils");
	var _pageId ="#cashTreasure_subscribeWithMoney";
	var mobileService = require("mobileService");
	var external = require("external");
	var utils = require("utils");
	var caseInfo = "";				//现金宝信息
	var dateArray = null;


	function init() {
		dateArray = new Array();
		caseInfo = JSON.parse(appUtils.getSStorageInfo("caseInfo"));
		$(_pageId+" #product_description").val(caseInfo.fund_name);
        var date = new Date().format("yyyy-MM-dd"); 		//得到当前日期
        $(_pageId+" #handler").val(date);
		queryWithdrawingInfo();
		querySubcribeDate();
	}

	/* 自定义日历的回调函数 */
	function selCustomDateCallback(data) {
		// 回调数据中的 data 是字符串，需解析
		if (typeof(data) == "string") {
			data = JSON.parse(data);
		}
		$(_pageId + " #"+data.selector).val(data.date);
	}

	/* 查询预约取款日期 */
	function querySubcribeDate(){
		var param = {
			"user_id" : appUtils.getSStorageInfo("user_id")
		};
		mobileService.queryPhysDate(param,function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no == "0" && data.results.length!=0){
				for(var i=0;i<data.results.length;i++){
					var is_trd_day = data.results[i].is_trd_day;		//是否交易日 0非交易日 1交易日
					var day_status = data.results[i].day_status;		//0.正常
					if("1" == is_trd_day && "0" == day_status){
						dateArray.push(data.results[i].phys_date);	   //预约日期
					}
				}
			}else {
				layerUtils.iLoading(false);
				layerUtils.iAlert(error_info);
				return false;
			}
		});
	}

	/*查询现金宝信息*/
	function queryWithdrawingInfo(){
		var param = {
			"user_id" : appUtils.getSStorageInfo("user_id"),
			"fund_account" : appUtils.getSStorageInfo("curr_loginid")
		};
		mobileService.queryWithdrawingRecord(param,function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			var innerHtml = "";
			var fund_account = appUtils.getSStorageInfo("curr_loginid");
			if(error_no == "0" && data.results != undefined){
				var results = data.results;
				if(results.length!=0){
					for(var i = 0;i<results.length;i++){
						var record_no= data.results[i].record_no;					//记录流水号
						var operate_time = data.results[i].operate_time;			//操作时间
						var reserve_date= data.results[i].reserve_date;				//预约取款日
						var reserve_money = data.results[i].reserve_money;			//预约取款金额
						var fund_code = data.results[i].fund_code;					//基金代码
						var fund_intl = data.results[i].fund_intl;					//基金内码
						var ta_code = data.results[i].ta_code;						//基金公司代码
						innerHtml += "<li><span>"+fund_account+"</span><span class=\"center\">"+caseInfo.fund_name+"</span><span class=\"center\">"+reserve_money+"</span><span>"+reserve_date+"</span><div class=\"td_opea\"><a id=\"update\" class=\"lk01\" href=\"javascript:void(0);\">修改</a><a id=\"delete\" class=\"lk02\" href=\"javascript:void(0);\">删除</a></li></div>";
					}
					appUtils.preBindEvent($(_pageId+" #withdrawing"),"li",function(e){
						var productDes = $(this).find("span:eq(1)").html();
						var withMoney = $(this).find("span:eq(2)").html();
						var subscribeTime = $(this).find("span:eq(3)").html();
						if($(this).hasClass("active")){
							$(this).removeClass("active");
						}else{
							$(this).addClass("active").siblings().removeClass("active");
							appUtils.preBindEvent($(_pageId+" #withdrawing"),"#update",function(e){
								updateSubcribe(productDes,withMoney,subscribeTime);
							});
							appUtils.preBindEvent($(_pageId+" #withdrawing"),"#delete",function(e){
								deleteSubcribe(withMoney,subscribeTime);
							});
						}
						e.stopPropagation();	// 阻止冒泡
					},"touchstart");
					appUtils.preBindEvent($(_pageId+" #withdrawing"),"li",function(e){
						$(this).removeClass("active");
						e.stopPropagation();	// 阻止冒泡
					},"end");
					$(_pageId+" #withdrawing").html(innerHtml);
				}else{
					$(_pageId+" #withdrawing").html("");
				}
			}else {
				layerUtils.iLoading(false);
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
				return false;
			}
		},{isShowWait:false});	
	}

	//修改预约
	function updateSubcribe(productDes,withMoney,subscribeTime){
		$(_pageId+" #update_shadow").show();
		$(_pageId+" #update_shadow #productDes").val(productDes);
		$(_pageId+" #update_shadow #withMoney").val(withMoney);
		$(_pageId+" #update_shadow #subscribeTime").val(subscribeTime);
		appUtils.bindEvent($(_pageId+" #submitApply"), function(){
			var withMoney = $(_pageId+" #update_shadow #withMoney").val();
			var date = new Date().format("yyyy-MM-dd");					//得到当前日期
			var subscribeTime = $(_pageId+" #update_shadow #subscribeTime").val();
			$(_pageId+" #update_shadow").hide();
			if(withMoney.length == 0 || withMoney == 0){
				layerUtils.iAlert("预约取款金额必须大于0!");
				return false;
			}
			if(subscribeTime <= date){
				layerUtils.iAlert("预约时间不能小于等于当前日期");
				return false;
			}
			var param = {
				"user_id" : appUtils.getSStorageInfo("user_id"),
				"fund_account" : appUtils.getSStorageInfo("curr_loginid"),
				"reserve_date" : $(_pageId+" #update_shadow #subscribeTime").val(),
				"operation_type" : "1",
				"capital_limit" : $(_pageId+" #update_shadow #withMoney").val()
			};
			mobileService.subscribeWithdrawing(param,function(data){
				var error_no = data.error_no;
				var error_info = data.error_info;
				if(error_no == "0"){
					layerUtils.iAlert("修改成功！","0",function(){
						queryWithdrawingInfo();
					});
				}else {
					layerUtils.iLoading(false);
//					layerUtils.iAlert(error_info);
					layerUtils.iMsg(-1, error_info);
					return false;
				}
			});
		});
	}

	//删除预约
	function deleteSubcribe(withMoney,subscribeTime){
		var param = {
			"user_id" : appUtils.getSStorageInfo("user_id"),
			"fund_account" : appUtils.getSStorageInfo("curr_loginid"),
			"reserve_date" : subscribeTime,
			"operation_type" : "2",
			"capital_limit" : withMoney
		};
		mobileService.subscribeWithdrawing(param,function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no == "0"){
				layerUtils.iAlert("删除成功！","0",function(){
					queryWithdrawingInfo();
				});
			}else {
				layerUtils.iLoading(false);
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
				return false;
			}
		});
    }

	//申请预约取款
	function applyForSubcribe(){
		var withMoney = $(_pageId+" #withMoney").val();				//取款金额
		var date = new Date().format("yyyy-MM-dd");					//得到当前日期
		var handler = $(_pageId+" #handler").val();
		if(withMoney.length == 0 || withMoney == 0){
			layerUtils.iAlert("预约取款金额必须大于0!");
			return false;
		}
		if(handler <= date){
			layerUtils.iAlert("预约时间不能小于等于当前日期");
			return false;
		}
		var param = {
			"user_id" : appUtils.getSStorageInfo("user_id"),
			"fund_account" : appUtils.getSStorageInfo("curr_loginid"),
			"reserve_date" : $(_pageId+" #handler").val(),
			"operation_type" : "0",
			"capital_limit" : $(_pageId+" #withMoney").val()
		};
		mobileService.subscribeWithdrawing(param,function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no == "0"){
				layerUtils.iAlert("委托已提交！","0",function(){
					queryWithdrawingInfo();
				});
			}else {
				layerUtils.iLoading(false);
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
				return false;
			}
		});
	}
	
	function bindPageEvent() {
		// 绑定返回
		appUtils.bindEvent($(_pageId+" .icon_back"), function(){
			appUtils.pageBack();
		});

		/* 绑定选择日期的事件 */
		appUtils.bindEvent($(_pageId+" input[date-plugin='true']"),function(e){
			utils.selectCustomDate(dateArray,$(this).attr("id")); // 通过壳子调用自定义的日历插件
		});

		//预约取款
		appUtils.bindEvent($(_pageId+" #applyWithdrawing"), function(e) {
			 applyForSubcribe();
		});
	}
	
	function destroy(){
		mobileService.destroy();
	}
	
	var subscribeWithMoney = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"selCustomDateCallback" : selCustomDateCallback
	};
	module.exports = subscribeWithMoney;
});
