define(function(require, exports, module) {
	
	var appUtils = require("appUtils");
	var gconfig = require("gconfig");
    var global = gconfig.global;
	var layerUtils = require("layerUtils");
	var external = require("external");
	var nativePluginService = require("nativePluginService");
	var check_login_time = null;
	
	/**
	 * 微信起始过渡页特殊的pageInit方法
	 * 这里没有prePageCode，而是负载元素pageCode
	 */
	function wxTransPageInit(parentPageCode, pageCode, param)
	{
		$("#stepLoadingDiv").hide();
		//增加过渡页面的标志位，兼容普通见面跳转过来
		if(!param){
			param = {};
		}
		param._isWxTransFlag = true;
		
		var pageUrl = gconfig.viewsPath + pageCode + ".html",
			pageId = pageCode.replaceAll("/", "_"),
			parentPageId = parentPageCode.replaceAll("/", "_"); //负载父元素ID
		
		try {
			if($("#"+pageId).length < 1) {
				require("ajax").loadHtml(pageUrl, function(htmlContent) {
					document.title = $(htmlContent).attr("data-pageTitle");
					$("#"+parentPageId).append(htmlContent); //保存这个page到parentPageCode
					$("#"+pageId+" img").each(function() { //设置图片scr地址，防止出错
						var src = $(this).attr("src");
						if(src && $(this).attr("data-serverImg")!="true") {
							$(this).attr("src", gconfig.imagesPath + src.substring(src.indexOf("images")+7));
						}
					});
					require.async(gconfig.scriptsPath+pageCode, function(page) {
						appUtils.setSStorageInfo("wxTransPage_pageParam", JSON.stringify(param));
						page.init(); //页面初始化
						page.bindPageEvent(); //事件绑定
					});
				}, true, false, false);
			} else {
				require.async(gconfig.scriptsPath+pageCode, function(page) {
					appUtils.setSStorageInfo("wxTransPage_pageParam", JSON.stringify(param));
					page.init(); //页面初始化
					page.bindPageEvent(); //事件绑定
				});
			}
		} catch(e) {
			console.printStackTrace(e);
		}
	}
	
	/**
	 * 微信起始过渡页特殊的getPageParam方法
	 */
	function wxGetPageParam(paramName) 
	{
		 //根据_isWxTransFlag判断，兼容普通见面跳转过来
		var jsonParam = appUtils.getSStorageInfo("wxTransPage_pageParam");
		jsonParam = JSON.parse(jsonParam);
		if(jsonParam && jsonParam._isWxTransFlag){
			if(paramName) {
				return jsonParam[paramName];
			} else {
				return jsonParam;
			}
		} else {
			return appUtils.getPageParam(paramName);
		}
	}
	
	function firstLoadFunc() {
		getURL(); //获取原生url
		//重置登录注销时间
		//2016-03-24 apprPageBind();
	}
	
	function filterLoginOut(data){
		var error_no = data.error_no;
		var error_info = data.error_info;
		if(error_no == "-999") {
			appUtils.clearSStorage("_isLoginIn");
			appUtils.clearSStorage("_loginInPageCode");
			appUtils.clearSStorage("_loginInPageParam");
			//其他清理工作...
			
			//appUtils.pageInit(appUtils.getSStorageInfo("_curPageCode"), gconfig.loginPage.pageCode, gconfig.loginPage.jsonParam);
			//跳到首页
			var param = {
				"funcNo":"50101",
				"moduleName":"login"
			};
			external.callMessage(param);
		}
	}
	
	/**
	 * 权限校验
	 * @param checkInParam 校验判断依据
	 * "checkInParam": {
	 * 		"prePageCode": prePageCode,
	 * 		"pageCode": pageCode,
	 * 		"param": param,
	 * 		"isLastReq": isLastReq,
	 * 		"isShowWait": isShowWait,
	 * 		"isShowOverLay": isShowOverLay
	 *	}
	 */
	function checkPermission(checkInParam) {
		return true;
	}
       
       
    /**
      * 保存用户信息
     */
    function saveSessionUserInfo(userInfo)
    {
    	 var result = userInfo[0];
       //普通资金账户
	   if(result.curr_loginid) {
		   appUtils.setSStorageInfo("userInfo",JSON.stringify(userInfo[0]));
	       //user_id保存到session
	       if(result.user_id) {
	          appUtils.setSStorageInfo("user_id", result.user_id);
	       }
	       //登陆账号保存到session
	       if(result.login_id) {
	          appUtils.setSStorageInfo("login_id", result.login_id);
	       }
	       //证件类型保存到session
	       if(result.identity_type) {
	          appUtils.setSStorageInfo("identity_type", result.identity_type);
	       }
	       //证件号码保存到session
	       if(result.identity_num) {
	          appUtils.setSStorageInfo("identity_num", result.identity_num);
	       }
	       //姓名保存到session
	       if(result.name) {
	          appUtils.setSStorageInfo("name", result.name);
	       }
	       //是否是交易用户 保存到session
	       if(result.is_trade) {
	          appUtils.setSStorageInfo("is_trade", result.is_trade);
	       }
	       //交易账户保存到session
	       if(result.trade_account) {
	          appUtils.setSStorageInfo("trade_account", result.trade_account);
	       }
	       //昵称保存到session
	       if(result.nick_name) {
	          appUtils.setSStorageInfo("nick_name", result.nick_name);
	       }
	       //sex性别保存到session
	       if(result.sex) {
	          appUtils.setSStorageInfo("sex", result.sex);
	       }
	       //birthday生日保存到session
	       if(result.birthday) {
	          appUtils.setSStorageInfo("birthday", result.birthday);
	       }
	       //mobile手机保存到session
	       if(result.mobile) {
	          appUtils.setSStorageInfo("mobile", result.mobile);
	       }
	       //login_by_mobile手机绑定保存到session
	       if(result.login_by_mobile) {
	          appUtils.setSStorageInfo("login_by_mobile", result.login_by_mobile);
	       }
	       //email邮箱保存到session
	       if(result.email) {
	          appUtils.setSStorageInfo("email", result.email);
	       }
	       //login_by_email绑定邮箱保存到session
	       if(result.login_by_email) {
	          appUtils.setSStorageInfo("login_by_email", result.login_by_email);
	       }
	       //telephone固定电话绑定到session
	       if(result.telephone) {
	          appUtils.setSStorageInfo("telephone", result.telephone);
	       }
	       //address通信住址保存到session
	       if(result.address) {
	          appUtils.setSStorageInfo("address", result.address);
	       }
	       //post_code邮编保存到session
	       if(result.post_code) {
	          appUtils.setSStorageInfo("post_code", result.post_code);
	       }
	       //qq_microblog QQ微博账号保存到session
	       if(result.qq_microblog) {
	          appUtils.setSStorageInfo("qq_microblog", result.qq_microblog);
	       }
	       //sina_microblog 新浪微博账号保存到session
	       if(result.sina_microblog) {
	          appUtils.setSStorageInfo("sina_microblog", result.sina_microblog);
	       }
	       //QQ号保存到session
	       if(result.qq) {
	          appUtils.setSStorageInfo("qq", result.qq);
	       }
	       //wechat号保存到session
	       if(result.wechat) {
	          appUtils.setSStorageInfo("wechat", result.wechat);
	       }
	       //recommend_person推荐人保存到session
	       if(result.recommend_person) {
	          appUtils.setSStorageInfo("recommend_person", result.recommend_person);
	       }
	       //last_login_time上次登录时间保存到session
	       if(result.last_login_time) {
	          appUtils.setSStorageInfo("last_login_time", result.last_login_time);
	       }
	       //occupational职业保存到session
	       if(result.occupational) {
	          appUtils.setSStorageInfo("occupational", result.occupational);
	       }
	       //adapter学历保存到session
	       if(result.adapter) {
	          appUtils.setSStorageInfo("adapter", result.adapter);
	       }
	       //certuid证书用户id保存到session
	       if(result.certuid) {
	          appUtils.setSStorageInfo("certuid", result.certuid);
	       }
	       //branch_no营业部保存到session
	       if(result.branch_no) {
	          appUtils.setSStorageInfo("branch_no", result.branch_no);
	       }
	       //emergency_name应急联系人姓名保存到session
	       if(result.emergency_name) {
	          appUtils.setSStorageInfo("emergency_name", result.emergency_name);
	       }
	       //emergency_relation与应急联系人关系保存到session
	       if(result.emergency_relation) {
	          appUtils.setSStorageInfo("emergency_relation", result.emergency_relation);
	       }
	       //emergency_tel应急联系人固定电话保存到session
	       if(result.emergency_tel) {
	          appUtils.setSStorageInfo("emergency_tel", result.emergency_tel);
	       }
	       //emergency_mobile应急联系人手机保存到session
	       if(result.emergency_mobile) {
	          appUtils.setSStorageInfo("emergency_mobile", result.emergency_mobile);
	       }
	       //emergency_email应急联系人邮箱保存到session
	       if(result.emergency_email) {
	          appUtils.setSStorageInfo("emergency_email", result.emergency_email);
	       }
	       //authentication_state实名认证,绑定银行卡 保存到session
	       if(result.authentication_state) {
	          appUtils.setSStorageInfo("authentication_state", result.authentication_state);
	       }
	       //org_id机构ID(第三方接口)保存到session
	       if(result.org_id) {
	          appUtils.setSStorageInfo("org_id", result.org_id);
	       }
	       //emergency_address应急联系人联系地址保存到session
	       if(result.emergency_address) {
	          appUtils.setSStorageInfo("emergency_address", result.emergency_address);
	       }
	       //type_code类别代码保存到session
	       if(result.type_code) {
	          appUtils.setSStorageInfo("type_code", result.type_code);
	       }
	       //type_name类别名称保存到session
	       if(result.type_name) {
	          appUtils.setSStorageInfo("type_name", result.type_name);
	       }
	       //vip_level会员等级保存到session
	       if(result.vip_level) {
	          appUtils.setSStorageInfo("vip_level", result.vip_level);
	       }
	       //total_integration用户总积分保存到session
	       if(result.total_integration) {
	          appUtils.setSStorageInfo("total_integration", result.total_integration);
	       }
	       // 将jsessionid保存到session
	       if(result.jsessionid) {
	          appUtils.setSStorageInfo("jsessionid", result.jsessionid);
	          external.callMessage({"funcNo": "50040", "key": "jsessionid", "value": result.jsessionid});
	       }
	       // 将client_id保存到session
	       if(result.client_id) {
	          appUtils.setSStorageInfo("client_id", result.client_id);
	       }
	       
         external.callMessage({"funcNo": "50040", "key": "common_user_id", "value": result.user_id});
         external.callMessage({"funcNo": "50040", "key": "curr_loginid", "value": result.curr_loginid});
         external.callMessage({"funcNo": "50040", "key": "client_id", "value": result.client_id});
	   }
	   //信用资金账号
	   if(result.credit_account) {
		   
         external.callMessage({"funcNo": "50040", "key": "credit_user_id", "value": result.user_id});
         external.callMessage({"funcNo": "50040", "key": "credit_account", "value": result.credit_account});
         external.callMessage({"funcNo": "50040", "key": "credit_client_id", "value": result.client_id});
	   }
	   //启动登录状态计时器
	   apprPageBind();
    }
	
		/**
     * 删除用户信息
     */
    function clearSessionUserInfo()
    {
        appUtils.clearSStorage();
    }
       
    /**
     *处理模拟登陆失败
     *  增加了一个入参 pageCode  再次登录时 用来作登录的入参 刘宝-hsj -16-02-26
     */
	function ssoLoginFailed(data,pageCode)
    {
       //这里可以加一些逻辑处理，根据返回的错误号，目前，我这里默认处理是：弹出提示信息，跳到登陆页面
       //弹出提示信息，跳到登陆页面
       layerUtils.iAlert(data.error_info);
       require.async("sso",function(module){
            if(module.checkLoginRight())
            {
                module.goTologin(pageCode);
            }
        });
    }


	// 自定义弹出层
	function btnConfirm(conMsg, yesFunc, noFunc, yesBtnWords, noBtnWords){
	    var iAlertIdx = -9999;
	    //弹出层的DIV的定义
		var viewContent ="<div class=\"backdrop\" style=\"display:block;\"></div>";
		viewContent +="<div class=\"pop_box pop_cancel pop\" id=\"pop_tip_confirm\" style=\"top:40%;display:block\">";
		viewContent += conMsg;
		viewContent +="    <div class=\"pop_footer\">";
		viewContent +="   	<div class=\"pop_btn two\">";
		viewContent +="  		<a href=\"javascript:void(0);\" id=\"pop_tip_confirm_yes\">"+(yesBtnWords||"确 定")+"</a><a href=\"javascript:void(0);\" id=\"pop_tip_confirm_no\">"+(noBtnWords||"取消")+"</a>";
		viewContent +="     </div>";
		viewContent +="   </div>";
		viewContent +="</div>";
		
		
		var iConfirmLayer = function(){
			//弹出层插件的用法
			return $.layer({
				type: 1,
				title: false,
				closeBtn: false,
				shade : [0.5 , '#000' , true],
				border: [5, 0.5, '', true],
				area: ['310px','auto'],
				offset: [($(window).height()*0.3)+'px', ''],
				page: {
					html: viewContent
				},
				success: function(iLayer) {
					window.ontouchmove = stopDefaultAction;
					var eType = gconfig.triggerEventName;
					$x("pop_tip_confirm", "pop_tip_confirm_yes").off(eType);
					$x("pop_tip_confirm", "pop_tip_confirm_yes").on(eType, function() {
						try{layer.close(iAlertIdx);}catch(e){};
						p = -9999;
						if(yesFunc){ yesFunc(); }
					});
					$x("pop_tip_confirm", "pop_tip_confirm_no").off(eType);
					$x("pop_tip_confirm", "pop_tip_confirm_no").on(eType, function() {
						try{layer.close(iAlertIdx);}catch(e){};
						p = -9999;
						if(noFunc){ noFunc(); }
					});
					$("#pop_tip_confirm").css("margin-top","-"+($("#pop_tip_confirm").height()/2)+"px");
				},
				end: function() {window.ontouchmove = null;}
			});
		};
		if(iAlertIdx == -9999) { //如果没有iConfirm层
			iAlertIdx = iConfirmLayer();
		} else { //存在iConfirm层，先关闭前面那个iConfirm层，再弹出新的iConfirm层
			try{layer.close(iAlertIdx);}catch(e){};
			iAlertIdx = iConfirmLayer();
		}
	}
	
	/**
	 * 阻止默认事件的行为
	 * @param e
	 */
	function stopDefaultAction(e)
	{
		if(e && e.preventDefault) {
			e.preventDefault();
		} else {
			window.event.returnValue = false;
		}
	}

	/*格式化金额*/
	function formatMoney(s, n) {
		n = n >= 0 && n <= 20 ? n : 2;
		if(n == 0){
			s = parseFloat((s + "").replace(/[^\d\.-]/g, ""))+ "";
		}
		else{
			s = parseFloat((s + "").replace(/[^\d\.-]/g, "")).toFixed(n) + "";
		}
		var l = s.split(".")[0].split("").reverse(), r = s.split(".")[1];
		t = "";
		for (i = 0; i < l.length; i++) {
			if(l[i+1]=="-"){
				t += l[i] + ((i + 1) % 3 == 0 && (i + 1) != l.length ? "" : "");
			}else{
				t += l[i] + ((i + 1) % 3 == 0 && (i + 1) != l.length ? "," : "");
			}
		}
		if(n == 0){
			return t.split("").reverse().join("");
		}
		else{
			return t.split("").reverse().join("") + "." + r;
		}
	}
	
	function cleanPageElement(_pageId){
		var hg = $(window).height() - 44; //页面高度减去需要固定部分的高度
		$(_pageId + " .main").css("height", hg + "px");
		$(_pageId + " .main").css("overflow-y", "auto");
	}
	
	/**
	 * 画饼图 资金分布
	 */
	function myChart(id,percent,color,total,describe) {
		var cxt;  
		var c=document.getElementById(id);
		cxt=c.getContext("2d");
		//白色底
		draw(cxt,0,100,100,100,0,Math.PI*2,true,"#FFFFFF");
		var start = Math.PI*1.5;var percents = 0;
		for(var i = 0; i < percent.length; i++){
			percents = percent[i] < 0 ? 0 : percent[i];
			//彩色圆环
	        draw(cxt,-1,100,100,98,start,Math.PI*2*percents+start,false,color[i]);
	        //圆环白色间隔
//	        drawCircle(cxt,-1,100,100,98,start,Math.PI*2*0.005+start,false,"#FFFFFF");
	        start = Math.PI*2*percents+start;
		}
		//灰色中心外圈 白色
		draw(cxt,0,100,100,70,0,Math.PI*2,true,"#FFFFFF");
		cxt.font="20px Arial";
		cxt.fillStyle="black";
		//total为接口查询计算出的账户总资产
		cxt.fillText(total,40,100);
		cxt.font="10px Arial";
		cxt.fillStyle="black";
		cxt.fillText(describe,60,120);
	}
	
	/**
	 * @param cxt 画笔对象
	 * @param type 结束画笔类型
	 * @param x x坐标
	 * @param y y坐标
	 * @param r 半径
	 * @param start 画圆起始位置
	 * @param end 画圆结束位置
	 * @param direction flase 逆时针画 true 顺时针画
	 * @param style 样式
	 */
	function draw(cxt,type,x,y,r,start,end,direction,style){
		cxt.fillStyle=style;
		cxt.beginPath();
		cxt.arc(x,y,r,start,end,direction);
		if(type == 0){
			cxt.closePath();
		}else{
			cxt.lineTo(x,y);
		}
		cxt.fill();
	}
	
	/**
	 * 执行正则表达式
	 * @param pattern 校验的正则表达式
	 * @param strValue 校验的值
	 * @returns {boolean}
	 */
	function executeExp(pattern, strValue)
	{
	    return pattern.test(strValue);
	}
	
	/**
	* 判断是否为中文
	* @param strValue 校验的值
	* @returns {boolean}
	*/
	function isCn(strValue)
	{
		var pattern = /^[\u4E00-\u9FA5]+$/;  
		return executeExp(pattern, strValue);
	}

	//显示底部导航栏
	function showTabBar(){
		if (gconfig.platform == "1"){
			external.callMessage({"funcNo": "50108", "moduleName": "main", "flag": "1"});
		} else if (gconfig.platform == "2") {
			external.callMessage({"funcNo": "50108", "moduleName": "system", "flag": "1"});
		}
	}

	//二级页面隐藏底部导航栏
	function hideTabBar(){
		if (gconfig.platform == "1"){
			external.callMessage({"funcNo": "50108", "moduleName": "main", "flag": "0"});
		} else if (gconfig.platform == "2") {
			external.callMessage({"funcNo": "50108", "moduleName": "system", "flag": "0"});
		}
	}

	/**
	 * 获取原生url
	 * */
	function  getURL(){
		//调原生获取最快的IP
		var ygtURL = external.callMessage({"moduleName":"ygt","serverName":"YGT_URL","funcNo": "50112"});

		//当前表示获取到了IP，并且没有报错得到回调数据
		if(ygtURL && (ygtURL.error_no == 0)){
			//得到回调数据中的URL
			var result = ygtURL.results[0].url;
			//得到URL后进行完整地址的拼接，拼接上的"/servlet/json"表示的是本机的访问路径
			global.serverPath = result+"/servlet/json";							//sso地址
		}
	}

	//扑捉页面操作事件
	function apprPageBind(){
		_resetLoginTime();
		_checkLoginTime();
		appUtils.bindEvent($("#afui"), function(e){
			//add 2016-03-23 by _resetLoginTime();
			/*start by 2016-03-23*/
			var param={};
			    param["funcNo"]="60608";
			    param["out_time_flag"]=true;
			    param["moduleName"]="ygt";
			    external.callMessage(param);
			/*end by 2016-03-23*/
			e.stopPropagation();
		}, "touchstart");
	}

	// 重置登录状态时间
	function _resetLoginTime(){
		if (appUtils.getSStorageInfo("userInfo")){
			// 重置登录注销时间
			console.log("重置登录状态时间：" + global.logoutTimeNum * 60 * 1000);
			nativePluginService.function50040({"key": "logining_time", "value": global.logoutTimeNum * 60 * 1000});
		}
	}

	//激活登录状态
	function _checkLoginTime(){
		if (!check_login_time){
			_timingCheckLoginS();
		}
	}

	//定时检测登录状态
	function _timingCheckLoginS(){
		if (appUtils.getSStorageInfo("userInfo")){
			check_login_time = setTimeout(function(){
				var logining_time = nativePluginService.function50041({"key": "logining_time"}).results[0].value;
					//显示当前模块
//				    isbottom = nativePluginService.function50041({"key": "isbottom"}).results[0].value;
				var isbottom = document.hasFocus();
				if (+logining_time <= 0){
					if ((+logining_time === -20000.5)){
						clearTimeout(check_login_time);
						check_login_time = null;
					} else {
						appUtils.clearSStorage(true);
						appUtils.setSStorageInfo("_isLoginIn", false);
						layerUtils.iLayerClose();
						$(".top_title .logout").hide();
//						appUtils.pageInit($("body #content div.page[data-display=block]").attr("id").replaceAll("_","/"), "account/index");
						if(isbottom){
							layerUtils.iAlert("登录超时，请重新登录!","0",_loginTimeOut);
						}else{
							_loginTimeOut();
						}
					}
					nativePluginService.function50040({"key": "logining_time", "value": ""});
				} else {
					if(isbottom){
						logining_time = logining_time - 6000;
						nativePluginService.function50040({"key": "logining_time", "value": logining_time});
						console.log("刷新登录状态时间：" + logining_time);
					}
					_timingCheckLoginS();
				}
			}, 6000);
		} else {
			if (check_login_time){
				clearTimeout(check_login_time);
				check_login_time = null;
			}
			nativePluginService.function50040({"key": "logining_time", "value": ""});
		}
	}

	function _loginTimeOut(){
		clearTimeout(check_login_time);
		check_login_time = null;
		require.async("sso", function(module){
			module.ssoLoginOut();
		});
	}

	//去左空格;
    function ltrim(s){
        return s.replace(/(^\s*)/g, "");
    }
    //去右空格;
    function rtrim(s){
        return s.replace(/(\s*$)/g, "");
    }
    //去左右空格;
    function trim(s){
        return s.replace(/(^\s*)|(\s*$)/g, "");
    }

	var common = {
		"firstLoadFunc": firstLoadFunc,
		"checkPermission": checkPermission,
		"wxTransPageInit": wxTransPageInit,
		"wxGetPageParam": wxGetPageParam,
        "saveSessionUserInfo": saveSessionUserInfo,
        "btnConfirm":   btnConfirm,
        "clearSessionUserInfo": clearSessionUserInfo,
        "ssoLoginFailed": ssoLoginFailed,
        "formatMoney" : formatMoney,
        "cleanPageElement" : cleanPageElement,
        "myChart" : myChart,
        "isCn" : isCn,
        "showTabBar" : showTabBar,
        "hideTabBar" : hideTabBar,
        "trim" : trim,
        "apprPageBind" : apprPageBind
	};
	//暴露对外的接口
	module.exports = common;
});
