define(function (require, exports, module) {
	require("highcharts");
	//收入资金饼状图
	function drawIncomePie(container_id,income_data,options,totalSellOut,totalTransferIncome,totalOtherIn,totalRedeem,totalInterest)
	{
		$(container_id).highcharts({
	        chart: {
				type: 'pie',
	            plotBackgroundColor: null,		//主图表区背景色，即X轴与Y轴围成的区域的背景色
	            plotBorderWidth: null,			//主图表区边框的宽度
	            plotShadow: false,				//是否设置阴影
	            alignTicks : false,
	            borderColor : 'red'
	        },
			legend: {
			 	layout: 'vertical',
				backgroundColor: '#FFFFFF',
				floating: true,
				align: 'left',
				verticalAlign: 'top',
				x: 90,
				y: 45,
				labelFormatter: function () {
					return this.name + '('+this.percentage+'%)';//在名称后面追加百分比数据
				},
				title : {
					style : { "color": "#394a5a", "fontSize": "12px","fontWeight": "normal"}
				} 
			},
	        title: {
	            text: options.m_title,			//图表标题
	            verticalAlign : 'middle',
	            y : 0,
	//          useHTML : true,
	//          fontFamily : '微软雅黑',
	//          style : { "color": "#333333", "fontSize": "12px" }
	        },
		    subtitle: {
		        text: options.f_title			//指定图表副标题
		    },
		    credits: {
	            text: ''					//去掉右下方版权信息：highchart.com
	        },
	        tooltip: {
		    	enabled: options.over_show,		//鼠标悬浮时，是否显示数据，默认true
	    	    pointFormat: '{series.name}: <b>{point.percentage:.1f}%</b>'		//鼠标悬浮显示信息
	        },
	        plotOptions: {
	            pie: {
	            	size: 128,
	            	borderWidth: 0,
	                allowPointSelect: false,
	                cursor: 'pointer',
	                overflow : 'justify',
	                dataLabels: {
//	                	x : '217',
//	                	y : '46',
	                    enabled: true,
	                    color: '#394a5a',
	                    connectorPadding:0,				//设置线条与文字之间的距离
	                    distance: options.distance,		// 标签与图像元素之间的间距
	                    connectorColor: '#394a5a',
						formatter: function() {
	                    	if(this.point.name == '卖出'){
	                    		return "<span style='color:#B5CA92;'>"+ this.point.name +':'+ Highcharts.numberFormat(this.percentage, 2) +'%</span><br/><span>'+totalSellOut+'</span>';
					        }else if(this.point.name == '转入'){	
	                    		return "<span style='color:#B5CA92'>"+ this.point.name +':'+ Highcharts.numberFormat(this.percentage, 2) +'%</span><br/><span>'+totalTransferIncome+'</span>';
	                    	}else if(this.point.name == '其他'){
	                    		return "<span style='color:#B5CA92'>"+ this.point.name +':'+  Highcharts.numberFormat(this.percentage, 2) +'%</span><br/><span>'+totalOtherIn+'</span>';
	                    	}else if(this.point.name == '基金赎回'){
	                    		return "<span style='color:#B5CA92'>"+ this.point.name +':'+  Highcharts.numberFormat(this.percentage, 2) +'%</span><br/><span>'+totalRedeem+'</span>';
	                    	}else if(this.point.name == '利息'){
	                    		return "<span style='color:#B5CA92'>"+ this.point.name +':'+  Highcharts.numberFormat(this.percentage, 2) +'%</span><br/><span>'+totalInterest+'</span>';
	                    	} 
	                	},
	                    style : { "color": "#394a5a", "fontSize": "12px","fontWeight": "normal","font-family": "Microsoft YaHei"}
	                },
	                innerSize: 86
	            },
	            series: {
	                states: {
	                	//去掉饼图的点击事件
	                    hover: {
	                        enabled: false
	                    }
	                }
	            }
	        },
	        series: [{
	            	name: '交易类型',
	            	data: income_data,
	            	xAxis : '',
	            	yAxis : ''
	     	}]
	    });
	}
	
	//收入资金饼状图
	function drawExpenditurePie(container_id,data,options,totalPurchase,totalTransferOut,totalApplyPurchase,totalOtherOut)
	{
		$(container_id).highcharts({
	        chart: {
				type: 'pie',
	            plotBackgroundColor: null,		//主图表区背景色，即X轴与Y轴围成的区域的背景色
	            plotBorderWidth: null,			//主图表区边框的宽度
	            plotShadow: false				//是否设置阴影
	        },
			legend: {
			 	layout: 'vertical',
				backgroundColor: '#FFFFFF',
				floating: true,
				align: 'left',
				verticalAlign: 'top',
				x: 90,
				y: 45,
				labelFormatter: function () {
					return this.name + '('+this.percentage+'%)';//在名称后面追加百分比数据
				},
				title : {
					style : { "color": "#394a5a", "fontSize": "12px","fontWeight": "normal"}
				} 
			},
	        title: {
	            text: options.m_title,			//图表标题
	            verticalAlign : 'middle',
	            y : 0,
	//          useHTML : true,
	//          fontFamily : '微软雅黑',
	//          style : { "color": "#333333", "fontSize": "12px" }
	        },
		    subtitle: {
		        text: options.f_title			//指定图表副标题
		    },
		    credits: {
	            text: ''					//去掉右下方版权信息：highchart.com
	        },
	        tooltip: {
		    	enabled: options.over_show,		//鼠标悬浮时，是否显示数据，默认true
	    	    pointFormat: '{series.name}: <b>{point.percentage:.1f}%</b>'		//鼠标悬浮显示信息
	        },
	        plotOptions: {
	            pie: {
	            	size: 128,
	            	borderWidth: 0,
	                allowPointSelect: false,
	                cursor: 'pointer',
	                overflow : 'justify',
	                dataLabels: {
	                    enabled: true,
	                    color: '#394a5a',
	                    connectorPadding:0,				//设置线条与文字之间的距离
	                    distance: options.distance,		// 标签与图像元素之间的间距
	                    connectorColor: '#394a5a',
						formatter: function() {
	                    	if(this.point.name == '买入'){
	                    		return "<span style='color:#B5CA92'>"+ this.point.name +':'+ Highcharts.numberFormat(this.percentage, 2) +'%<br/>'+totalPurchase+'</span>';
					        }else if(this.point.name == '转出'){	
	                    		return "<span style='color:#B5CA92'>"+ this.point.name +':'+ Highcharts.numberFormat(this.percentage, 2) +'%<br/>'+totalTransferOut+'</span>';
	                    	}else if(this.point.name == '基金认申'){
	                    		return "<span style='color:#B5CA92'>"+ this.point.name +':'+  Highcharts.numberFormat(this.percentage, 2) +'%<br/>'+totalApplyPurchase+'</span>';
	                    	}else if(this.point.name == '其他'){
	                    		return "<span style='color:#B5CA92'>"+ this.point.name +':'+  Highcharts.numberFormat(this.percentage, 2) +'%<br/>'+totalOtherOut+'</span>';
	                    	} 
	                	},
//	                	x: '3',
//	                	y: '20',
	                    style : { "color": "#394a5a", "fontSize": "12px","fontWeight": "normal","font-family": "Microsoft YaHei"}
	                },
	                column :{
	                	
	                },
	                innerSize: 86
	            },
	            series: {
	                states: {
	                	//去掉饼图的点击事件
	                    hover: {
	                        enabled: false
	                    }
	                }
	            }
	        },
	        series: [{
	            	name: '交易类型',
	            	data: data,
	            	xAxis : '20',
	            	yAxis : '20'
	     	}]
	    }) 
	}
	
	var chartsUtils = {
		"drawIncomePie":drawIncomePie,
		"drawExpenditurePie" : drawExpenditurePie
	};
	module.exports = chartsUtils;
});