define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var external = require("external");
	var _pageId ="#credit_creditAccount";
	var common = require("common");
	var mobileService = require("mobileService");
	var layerUtils = require("layerUtils");
	var nativePluginService = require("nativePluginService");
	var gconfig = require("gconfig");

	function init() {
		common.cleanPageElement(_pageId);
		common.showTabBar();
		cleanPageElement();
		getUserInfo();
	}

	function cleanPageElement(){
		appUtils.setSStorageInfo("tab_type","credit_tab");
		// 信用首页模块
        external.callMessage({"funcNo": "50040", "key": "trade_module", "value": "credit"});
		$(_pageId+" #rzrq").addClass("active").siblings().removeClass("active");
		if(gconfig.platform != "0"){
			var credit_user_id = external.callMessage({"key":"credit_user_id","funcNo": "50041"}).results[0].value;
			if("" != credit_user_id &&  null != credit_user_id && undefined != credit_user_id){
				appUtils.setSStorageInfo("credit_user_id",credit_user_id);
			}
			var credit_account = external.callMessage({"key":"credit_account","funcNo": "50041"}).results[0].value;
			if("" != credit_account &&  null != credit_account && undefined != credit_account){
				appUtils.setSStorageInfo("credit_account",credit_account);
			}
		}
		var credit_account = appUtils.getSStorageInfo("credit_account");					//登录账号
		$(_pageId+" #creditAccount").html(credit_account);
	}
	
	function getUserInfo() {
		// 同步用户交易账号
		var param = {
			"user_id":appUtils.getSStorageInfo("credit_user_id"),
			"zj_account":appUtils.getSStorageInfo("credit_account")
		};
		mobileService.syncTradeAccount(param, function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no == "0") {
				queryBindBank();
			} else {
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
				return false;
			}
		},{isShowWait:false});
	}
	
	//查询三方存管信息
	function queryBindBank(){
		var param = {
			"user_id":appUtils.getSStorageInfo("credit_user_id"),
			"zj_account":appUtils.getSStorageInfo("credit_account"),
			"flag_status":"0",
            "account_type":"3"
		};
		mobileService.getBankList(param, function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			var results = data.results;
			var element = "";
			if(error_no == "0"){
				if(undefined == results || "" == results || "0" == results.length){
					$(_pageId+" #depositoryBank").html("未配置");
					queryCreditAccountInfo();
				}else{
					var fund_account = "";
					var bank_name = "";
					for(var i=0;i<results.length;i++){
						var is_main_card = results[i].is_main_card;		//0主卡,1辅卡
						var cardtype = "";
						fund_account = results[i].fund_account;		//资金账号
						if("1" == is_main_card){
							bank_name = data.results[i].bank_name == null || data.results[i].bank_name == undefined || data.results[i].bank_name == "" ? "未配置" : data.results[i].bank_name;		//存管银行名称
						}else{
							bank_name = "未配置";
						}
					}
					$(_pageId+" #depositoryBank").html(bank_name);
					queryCreditAccountInfo();
				}
			} else {
				$(_pageId+" #depositoryBank").html("未配置");
				queryCreditAccountInfo();
				layerUtils.iLoading(false);  // 关闭等待层。。。
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
				return false;
			}
		},{isShowWait:false});
	}
	
	//查询信用账户等信息
	function queryCreditAccountInfo(){
		var param ={
			"user_id" : appUtils.getSStorageInfo("credit_user_id"),
			"fund_account":appUtils.getSStorageInfo("credit_account")
		};
		mobileService.queryCreditAccountInfo(param,function(data){
			var error_no = data.error_no;
		    var error_info = data.error_info;
			var results = data.results;										//统计数据		
			if(error_no == 0){
				var sha_account = "";
				var sza_account = "";
				var credit_lvl = data.creditData[0].credit_lvl;				//信用等级
				var credits = Number(data.creditData[0].credits);			//信用额度
				if(credits && credits>100){
					credits = (common.formatMoney((credits/10000).toFixed(2)))+"万";
				}
				var stockList = data.stockList;								//信用交易账号列表
				for(var i=0;i<stockList.length;i++){
					var trdacct = stockList[i].trdacct;						//股东代码
					var market = stockList[i].market;						//交易市场		
				 	if("10" == market){
				 		sha_account = trdacct;
				 	}else if("00" == market){
				 		sza_account = trdacct;
				 	}
				}
				$(_pageId+" #shAccount").html(sha_account);
				$(_pageId+" #szAccount").html(sza_account);
				$(_pageId+" #creditLevel").html(credit_lvl);
				$(_pageId+" #creditSet").html(credits);
				queryBranch();
			}
			else{
				queryBranch();
//				layerUtils.iAlert(error_info,-1);
				layerUtils.iMsg(-1, error_info);
				return false;
			}
		},{isShowWait:false});
	}
	
	/*查询营业部信息*/
	function queryBranch(){
		var param = {"user_id":appUtils.getSStorageInfo("credit_user_id")};
		mobileService.queryUserInfo(param,function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			var results = data.results;
			if(error_no == "0" && undefined != results){
				var branchname = results[0].branchname == "" || results[0].branchname == null || results[0].branchname == undefined ? "无" : results[0].branchname;
				$(_pageId+" #branch").html(branchname);
			}
			else{
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
				$(_pageId+" #branch").html("无");
			}
		},{isShowWait:false});
	}
	
	function bindPageEvent() {
		// 绑定返回
		appUtils.bindEvent($(_pageId+" .icon_back"), function(e){
			var _prePageCode = appUtils.getSStorageInfo("_prePageCode");
			if("" != _prePageCode && undefined != _prePageCode && null != _prePageCode && "credit/creditAsset" != _prePageCode){
				appUtils.pageInit("credit/creditAccount",_prePageCode,{});
			}else{
				external.callMessage({"moduleName":"home","funcNo": "50101"});
			}
		});
		
		//证券交易
		appUtils.bindEvent($(_pageId+" #securitiesTrading"), function(e){
			appUtils.setSStorageInfo("tab_type","stock_tab");
			// 信用首页模块
            external.callMessage({"funcNo": "50040", "key": "trade_module", "value": "stock"});
			var stock_accouont = nativePluginService.function50041({"key":"COMMON_LOGIN_STATE"}).results[0].value;		//1、已登录
			if("1" == stock_accouont){
				appUtils.pageInit("credit/creditAccount", "myAccount/index", {});
			}else{
//				layerUtils.iAlert("您还没有登录证券账户，请先登录！","0",function(){
					appUtils.pageInit("credit/creditAccount", "myAccount/index", {});
//				});
			}
		});
		
		// 绑定个股期权
		appUtils.bindEvent($(_pageId+" #ggqq"), function(){
//			layerUtils.iMsg(-1, "敬请期待！");
		});
		
		// 绑定otc
		appUtils.bindEvent($(_pageId+" #otc"), function(){
//			layerUtils.iMsg(-1, "敬请期待！");
		});
		
		// 绑定交割单查询
		appUtils.bindEvent($(_pageId+" #deliveryOrder"), function(){
			common.hideTabBar();
			var param = {
				"funcNo":"50101",
				"moduleName":"trade",
				"params" :{
					"topage" : "credit/query/deliveryOrderQuery.html"				//跳转url
				}
			};
			external.callMessage(param);
		});
		
		// 绑定风险通知
		appUtils.bindEvent($(_pageId+" #riskInform"), function(){
			common.hideTabBar();
			var param = {
				"funcNo":"50101",
				"moduleName":"trade",
				"params" :{
					"topage" : "credit/query/riskNotification.html"				//跳转url
				}
			};
			external.callMessage(param);
		});
		
		// 绑定消息
		appUtils.bindEvent($(_pageId+" #message"), function(){
			appUtils.pageInit("credit/creditAccount", "myAccount/message", {});
		});
		
		//信用资产
		appUtils.bindEvent($(_pageId+" #creditAsset"), function(e){
			 common.hideTabBar();
			 //跳转到信用资产页面
			 appUtils.pageInit("credit/creditAccount", "credit/creditAsset", {});
		});
		
		// 绑定设置
		appUtils.bindEvent($(_pageId+" #set"), function(){
			//打开原生设置模块
            var param = {
            	"funcNo":"50101",
            	"moduleName":"setting"
            };
            external.callMessage(param);
		});
		
		//注销事件
		appUtils.bindEvent($(_pageId +" .top_title #logout"), function(e){
			var tipStr = "<div class=\"pop_main\" style=\"height: 50px;margin-top: 20px;font-size:0.15rem\"><div>确定退出当前登录账号?</div></div>";
			common.btnConfirm(tipStr,function success(){
			   	layerUtils.iLoading(false);  // 关闭等待层。。。
				appUtils.clearRequest();
				appUtils.clearSStorage(true);
				nativePluginService.function50040({"key": "logining_time", "value": -20000.5});
				require("sso").ssoLoginOut();
			},function fail(){
			});
		});
	}

	function destroy(){
		external.callMessage({"funcNo": "50040", "key": "trade_module", "value": ""});
		$(_pageId+" #creditAccount").html("无");
		$(_pageId+" #depositoryBank").html("无");
	    $(_pageId+" #shAccount").html("无");
		$(_pageId+" #szAccount").html("无");
		$(_pageId+" #creditLevel").html("无");
		$(_pageId+" #creditSet").html("无");
		$(_pageId+" #precautiousLine").html("150%");
		$(_pageId+" #percentCover").html("130%");
		$(_pageId+" #branch").html("");
		mobileService.destroy();
	}
	
	var creditAccount = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = creditAccount;
});
