define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var layerUtils = require("layerUtils");
	var _pageId ="#credit_creditAsset";
	var mobileService = require("mobileService");
	var common = require("common");
	var external = require("external");
	var nativePluginService = require("nativePluginService");
	var gconfig = require("gconfig");
	
	var positionHead = "";
	var debtFinancingHead = "";
	var securitiesLiabilityHead = "";
	var toMark = "";
	

	//账单页面
	function init() {
		//去掉框架中的display的block样式，本身css已经处理了
		$("#content .page").each(function(){
			if($(this).attr("data-display") == "block"){
				$(this).css({"display":""});
			}
		});
		common.cleanPageElement(_pageId);
		common.hideTabBar();
		initData();
		showCreditAssetInfo();
	}
	
	function initData(){
		appUtils.setSStorageInfo("tab_type","credit_tab");
		//信用首页模块
        external.callMessage({"funcNo": "50040", "key": "trade_module", "value": "credit"});
		external.callMessage({"funcNo": "50040", "key": "ygt_module", "value": "credit"});
		//初始化状态信息
		$(_pageId+" #rzrq").addClass("active").siblings().removeClass("active");
		//1、持仓明细默认显示
		positionHead = '<tr><th width="20%">证券<br>代码</th><th width="20%">担保可卖<br>可卖</th><th width="20%">市值<br>持仓</th><th width="20%">盈亏<br>比例</th><th width="20%">成本<br>现价</th></tr>';
		$(_pageId+" #positionDetails table").html(positionHead);
		//2、融资负债默认显示
		debtFinancingHead = '<tr><th width="25%">开仓日期<br>到期日期</th><th width="25%">证券<br>代码</th><th width="25%">合约编号<br>合约数量</th><th width="25%">合约金额<br>待偿金额</th></tr>';
		$(_pageId+" #debtFinancing table").html(debtFinancingHead);
		//3、融券负债默认显示
		securitiesLiabilityHead = '<tr><th width="25%">开仓日期<br>到期日期</th><th width="25%">证券<br>代码</th><th width="25%">合约编号<br>合约数量</th><th width="25%">待偿数量<br>待偿息费</th></tr>';
		$(_pageId+" #securitiesLiability table").html(securitiesLiabilityHead);
		if(appUtils.getSStorageInfo("_prePageCode") != "credit/creditAccount"){
			if(gconfig.platform != "0"){
				var credit_user_id = external.callMessage({"key":"credit_user_id","funcNo": "50041"}).results[0].value;
				if("" != credit_user_id &&  null != credit_user_id && undefined != credit_user_id){
					appUtils.setSStorageInfo("credit_user_id",credit_user_id);
				}
				var credit_account = external.callMessage({"key":"credit_account","funcNo": "50041"}).results[0].value;
				if("" != credit_account &&  null != credit_account && undefined != credit_account){
					appUtils.setSStorageInfo("credit_account",credit_account);
				}
			}
		}
	}

	/*查询信用资产信息*/
	function showCreditAssetInfo(){
		var param ={
			"user_id" : appUtils.getSStorageInfo("credit_user_id"),
			"fund_account":appUtils.getSStorageInfo("credit_account")
		};
		mobileService.queryCreditAssetInfo(param,function(data){
			var error_no = data.error_no;
		    var error_info = data.error_info;
			var creditAssetList = data.creditAssetList;											//统计数据		
			var positionList = data.positionList;												//持仓明细
			var assetInfoList = data.assetInfoList;											    //资金明细	
			var contractList = data.contractList;											    //合约查询
			if(error_no == 0){
				showCountData(creditAssetList);
				showPostionList(positionList);
				showFundList(assetInfoList);
				showContractList(contractList);
			}
			else{
//				layerUtils.iAlert(error_info,-1);
				layerUtils.iMsg(-1, error_info);
				return false;
			}
		},{isShowWait:false});
	}
	
	//1、显示统计数据
	function showCountData(creditAssetList){
		if("undefined" != creditAssetList && null != creditAssetList && "" != creditAssetList){
			var total_assets = common.formatMoney(creditAssetList[0].total_assets);				//资产总值
			var total_debt_amt = common.formatMoney(creditAssetList[0].total_debt_amt);			//负债总值
			var cptl_avl = common.formatMoney(creditAssetList[0].cptl_avl);						//可用资金
			var mkt_val = common.formatMoney(creditAssetList[0].mkt_val);						//证券市值
			var maint_cptlavl = common.formatMoney(creditAssetList[0].maint_cptlavl);		    //自由可有资金
			var maint_ratio = creditAssetList[0].maint_ratio;									//维持担保比例
			var credit_avl = common.formatMoney(creditAssetList[0].credit_avl);				    //可用信用额度
			var margin_avl = common.formatMoney(creditAssetList[0].margin_avl);				    //可用保证金
			$(_pageId+" #totalFund span").html(total_assets);
			$(_pageId+" #totalDebt span").html(total_debt_amt);
			$(_pageId+" #fundsAvailable h5").html(cptl_avl);
			$(_pageId+" #securityMarket h5").html(mkt_val);
			$(_pageId+" #ownFundsAvailable h5").html(maint_cptlavl);
			$(_pageId+" #maintRatio h5").html((Number(maint_ratio)*100).toFixed(2)+"%");
			$(_pageId+" #availableCreditLine h5").html(credit_avl);
			$(_pageId+" #usableMargin h5").html(margin_avl);
		}

	}
	
	//2、显示持仓明细
	function showPostionList(positionList){
		if("undefined" != positionList && null != positionList && "" != positionList){
			var positionHead = '<tr><th>证券<br>代码</th><th>担保可卖<br>可卖</th><th>市值<br>持仓</th><th>盈亏<br>比例</th><th>成本<br>现价</th></tr>';
            $(_pageId+" #positionDetails table").html(positionHead);
			var innerHtml = "";
			var elments = "";
			for(var i=0;i<positionList.length;i++){
				var secu_name = positionList[i].secu_name;										//证券名称
				var secu_code = positionList[i].secu_code;			   							//证券代码
				var ownshare_avl = Number(positionList[i].ownshare_avl);						//担保可卖
				var share_avl = Number(positionList[i].share_avl);								//可卖
				var old_mkt_val = Number(positionList[i].mkt_val);
				var mkt_val = common.formatMoney(positionList[i].mkt_val);						//市值
				var mkt_qty = positionList[i].mkt_qty;											//持仓
				var cost_price = Number(positionList[i].cost_price).toFixed(3);				    //成本（成本价）
				var curr_price = Number(positionList[i].curr_price).toFixed(2);					//现价
				var current_cost = positionList[i].current_cost;								//一笔持仓的成本
				//盈亏（MKT_VAL- CURRENT_COST）、
				var old_income = old_mkt_val - current_cost;
				var income = common.formatMoney(old_income);									//盈亏
				//比例（ (MKT_VAL- CURRENT_COST)/ CURRENT_COST）
				var incomeRate = (old_income/current_cost*100).toFixed(2);						//盈亏率
				if(old_income <0){
					innerHtml += "<tr><td><strong>"+secu_name+"</strong><small>"+secu_code+"</small></td><td><h5>"+ownshare_avl+"</h5><p>"+share_avl+"</p></td><td><h5>"+mkt_val+"</h5><p>"+mkt_qty+"</p></td><td><h5 class=\"agreen\">"+income+"</h5><p class=\"agreen\">"+incomeRate+"%</p></td><td><h5>"+cost_price+"</h5><p>"+curr_price+"</p></td></tr>";
				}else{
					innerHtml += "<tr><td><strong>"+secu_name+"</strong><small>"+secu_code+"</small></td><td><h5>"+ownshare_avl+"</h5><p>"+share_avl+"</p></td><td><h5>"+mkt_val+"</h5><p>"+mkt_qty+"</p></td><td><h5 class=\"ared\">"+income+"</h5><p class=\"ared\">"+incomeRate+"%</p></td><td><h5>"+cost_price+"</h5><p>"+curr_price+"</p></td></tr>";
				}
			}
			elments = positionHead+innerHtml;
			if(!innerHtml){
				$(_pageId+" #positionDetails table").html(elments);
				$(_pageId+" #positionDetails .no_data").show();
			}else{
				$(_pageId+" #positionDetails table").html(elments);
			}
		}
	}
	
	//对齐 的方法
	function Align(){
	   $(_pageId+"#positionDetails table").find("th").each(function(){ 
	        var idx = $(this).index();         
	        var td=$(_pageId+"#positionDetails table tr").children('td').eq(idx);
	        if(td.width()>40){
	        	$(this).width(td.width());
	        }else{
	        	 $(this).width() > td.width() ? td.width($(this).width()) : $(this).width(td.width());
	        }
       }); 
       $(_pageId+" .mx_tablist").width(($(_pageId+" #positionDetails tr:eq(0)").width()));
	}
	
	//3、显示资金明细
	function showFundList(assetInfoList){
		if("undefined" != assetInfoList && null != assetInfoList && "" != assetInfoList){
			var fundbal = common.formatMoney(assetInfoList[0].fundbal);											//资金余额
			var frozen = common.formatMoney(assetInfoList[0].frozen);			   							    //异常冻结资金
			var available_balance = common.formatMoney(assetInfoList[0].available_balance);						//可用资金
			var fetch_balance = common.formatMoney(assetInfoList[0].fetch_balance);								//可取资金
			var ficontract_cptl = common.formatMoney(assetInfoList[0].ficontract_cptl);						    //自有可用
			var trd_frz = common.formatMoney(assetInfoList[0].trd_frz);									        //交易冻结资金
			var hk_available = common.formatMoney(assetInfoList[0].hk_available);								//还款可用
			var hq_available = common.formatMoney(assetInfoList[0].hq_available);								//还券可用
			$(_pageId+" #fundDetails ul li:eq(0) span").html(fundbal);
			$(_pageId+" #fundDetails ul li:eq(1) span").html(frozen);
			$(_pageId+" #fundDetails ul li:eq(2) span").html(available_balance);
			$(_pageId+" #fundDetails ul li:eq(3) span").html(fetch_balance);
			$(_pageId+" #fundDetails ul li:eq(4) span").html(ficontract_cptl);
			$(_pageId+" #fundDetails ul li:eq(5) span").html(trd_frz);
			$(_pageId+" #fundDetails ul li:eq(6) span").html(hk_available);
			$(_pageId+" #fundDetails ul li:eq(7) span").html(hq_available);
		}
	}
	
	//4、显示融资负债、融券负债
	function showContractList(contractList){
		if("undefined" != contractList && null != contractList && "" != contractList){
			var financing_innerHtml = "";
			var liability_innerHtml = "";
			var financing_elments = "";
			var liability_elments = "";
			for(var i=0;i<contractList.length;i++){
				var trd_id = contractList[i].trd_id;											 
				var contract_type = contractList[i].contract_type;								//合约类型  0融资1融券
				if("0" == contract_type){
					var opening_date = contractList[i].opening_date;							//开仓日期
					var expiration_data = contractList[i].expiration_data;						//合同约定到期日
					var stkname = contractList[i].stkname;										//证券名称
					var stkcode = contractList[i].stkcode;										//证券代码
					var order_id = contractList[i].order_id;									//合约序列
					var contract_qty = contractList[i].contract_qty;							//合约数量
					var contract_amt = common.formatMoney(contractList[i].contract_amt);		//合约金额
					var left_amt = common.formatMoney(contractList[i].left_amt);				//代偿金额
					financing_innerHtml += "<tr><td><p>"+opening_date+"</p><p>"+expiration_data+"</p></td><td><h5>"+stkname+"</h5><small>"+stkcode+"</small></td><td><p>"+order_id+"</p><p>"+contract_qty+"</p></td><td><p>"+contract_amt+"</p><p>"+left_amt+"</p></td></tr>";
				}else if("1" == contract_type){
					var opening_date = contractList[i].opening_date;							//开仓日期
					var expiration_data = contractList[i].expiration_data;						//合同约定到期日
					var stkname = contractList[i].stkname;										//证券名称
					var stkcode = contractList[i].stkcode;										//证券代码
					var order_id = contractList[i].order_id;									//合约序列
					var contract_qty = contractList[i].contract_qty;							//合约数量
					var left_qty = contractList[i].left_qty;									//代偿数量
					var left_int = contractList[i].left_int;									//代偿息费
					liability_innerHtml += "<tr><td><p>"+opening_date+"</p><p>"+expiration_data+"</p></td><td><h5>"+stkname+"</h5><small>"+stkcode+"</small></td><td><p>"+order_id+"</p><p>"+contract_qty+"</p></td><td><p>"+left_qty+"</p><p>"+left_int+"</p></td></tr>";
				}
			}
			financing_elments = debtFinancingHead+financing_innerHtml;
			liability_elments = securitiesLiabilityHead+liability_innerHtml;
			if(!financing_innerHtml){
				$(_pageId+" #debtFinancing table").html(financing_elments);
				$(_pageId+" #debtFinancing .no_data").show();
			}else{
				$(_pageId+" #debtFinancing table").html(financing_elments);
			}
			if(!liability_innerHtml){
				$(_pageId+" #securitiesLiability table").html(liability_elments);
				$(_pageId+" #securitiesLiability .no_data").show();
			}else{
				$(_pageId+" #securitiesLiability table").html(liability_elments);
			}
		}
	}
	
	function bindPageEvent() {
		//返回
		appUtils.bindEvent($(_pageId + " .icon_back"), function(){
			if(gconfig.platform != "0"){
				toMark = external.callMessage({"key":"toMark","funcNo": "50041"}).results[0].value;
			}
			if(toMark == "tradeCreditIndex"){
				nativePluginService.function50040({"key":"toMark","value":""});
				var param = {
					"funcNo":"50101",
					"moduleName":"trade",
					"params" :{
						"topage" : "credit/index.html"
					}
				};
				external.callMessage(param);
			}else if(toMark == "tradeFinancingQuery"){
				nativePluginService.function50040({"key":"toMark","value":""});
				var param = {
					"funcNo":"50101",
					"moduleName":"trade",
					"params" :{
						"topage" : "credit/query/financingQuery.html"
					}
				};
				external.callMessage(param);
            }else if(appUtils.getSStorageInfo("_prePageCode") == "credit/creditAccount"){
				appUtils.pageInit("credit/creditAsset","credit/creditAccount",{});
			}else{
				var param = {
					"funcNo":"50101",
					"moduleName":"home"
				};
				external.callMessage(param);
				common.showTabBar();
			}
		});
		
		//证券交易
		appUtils.bindEvent($(_pageId+" #securitiesTrading"), function(e){
			appUtils.setSStorageInfo("tab_type","stock_tab");
			//普通首页模块
			external.callMessage({"funcNo": "50040", "key": "trade_module", "value": "stock"});
			external.callMessage({"funcNo": "50040", "key": "ygt_module", "value": "stock"});
			var stock_accouont = nativePluginService.function50041({"key":"COMMON_LOGIN_STATE"}).results[0].value;		//1、已登录
			if("1" == stock_accouont){
				appUtils.pageInit("credit/creditAsset", "asset/index", {});
			}else{
//				layerUtils.iAlert("您还没有登录证券账户，请先登录！","0",function(){
					appUtils.pageInit("credit/creditAsset", "asset/index", {});
//				});
			}
		});
		
		// 绑定融资融券
		appUtils.bindEvent($(_pageId+" #rzrq"), function(){
			$(this).addClass("active").siblings().removeClass("active");
		});
		
		// 绑定个股期权
		appUtils.bindEvent($(_pageId+" #ggqq"), function(){
//			layerUtils.iMsg(-1, "敬请期待！");
		});
		
		// 绑定otc
		appUtils.bindEvent($(_pageId+" #otc"), function(){
//			layerUtils.iMsg(-1, "敬请期待！");
		});
		
		//持仓明细
		appUtils.bindEvent($(_pageId +" #li_positionDetails"), function(){
			$(this).addClass("active").siblings().removeClass("active");
			$(_pageId+" #positionDetails").show();
			$(_pageId+" #fundDetails").hide();
			$(_pageId+" #debtFinancing").hide();
			$(_pageId+" #securitiesLiability").hide();
		});
		
		//资金明细
		appUtils.bindEvent($(_pageId + " #li_fundDetails"), function(){
			$(this).addClass("active").siblings().removeClass("active");
			$(_pageId+" #fundDetails").show();
			$(_pageId+" #debtFinancing").hide();
			$(_pageId+" #positionDetails").hide();
			$(_pageId+" #securitiesLiability").hide();
		});
		
		//融资负债
		appUtils.bindEvent($(_pageId +" #li_debtFinancing"), function(){
			$(this).addClass("active").siblings().removeClass("active");
			$(_pageId+" #debtFinancing").show();
			$(_pageId+" #positionDetails").hide();
			$(_pageId+" #fundDetails").hide();
			$(_pageId+" #securitiesLiability").hide();
		});
		
		//融券负债
		appUtils.bindEvent($(_pageId + " #li_securitiesLiability"), function(){
			$(this).addClass("active").siblings().removeClass("active");
			$(_pageId+" #securitiesLiability").show();
			$(_pageId+" #positionDetails").hide();
			$(_pageId+" #fundDetails").hide();
			$(_pageId+" #debtFinancing").hide();
		});

		// 绑定刷新按钮
		appUtils.bindEvent($(_pageId+" .icon_refresh"), function(e){
			init();
		});
	}

	function destroy(){
		external.callMessage({"funcNo": "50040", "key": "ygt_module", "value": ""});
		external.callMessage({"funcNo": "50040", "key": "trade_module", "value": ""});
		$(_pageId+" #totalFund span").html("0.00");
		$(_pageId+" #totalDebt span").html("0.00");
		$(_pageId+" #fundsAvailable h5").html("0.00");
		$(_pageId+" #securityMarket h5").html("0.00");
		$(_pageId+" #ownFundsAvailable h5").html("0.00");
		$(_pageId+" #maintRatio h5").html("100%");
		$(_pageId+" #availableCreditLine h5").html("0.00");
		$(_pageId+" #usableMargin h5").html("0.00");
		$(_pageId+" #positionDetails .no_data").hide();
		$(_pageId+" #debtFinancing .no_data").hide();
		$(_pageId+" #securitiesLiability .no_data").hide();
		mobileService.destroy();
	}
	
	var creditAsset = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = creditAsset;
});
