﻿/**
 * 创业板
 */
define(function(require, exports, module){ 
	/* 私有业务模块的全局变量 begin */
	var appUtils = require("appUtils"),
		layerUtils = require("layerUtils"),
		gconfig = require("gconfig"),
		global = gconfig.global,
		_pageId = "#cyb_index";
	var mobileService = require("mobileService");
	var validatorUtil = require("validatorUtil");
	var userInfo;
	var external = require("external");
	var common = require("common");
	var accountInfoList = null;
	var otherInfo = null;
	/* 私有业务模块的全局变量 end */
	
	function init()
	{
		common.hideTabBar();
		queryCybInfo();
	}
	
	function bindPageEvent(){
		
		//绑定返回
		appUtils.bindEvent($(_pageId+" .icon_back"), function(){
			// 跳转到首页
//			appUtils.pageInit("cyb/index", "index/index",{});
			appUtils.pageBack();
		});
		
		//绑定提示界面的确认按钮
		appUtils.bindEvent($(_pageId+" #notice_confirm"),function(){
			// 跳转到首页
			appUtils.pageInit("cyb/index", "index/index",{});
		});
		
		//绑定提示界面的确认按钮
		appUtils.bindEvent($(_pageId+" #fail_notice_confirm"),function(){
			layerUtils.iAlert("暂时无法开通深A！","0",function(){
				// 跳转到首页
				appUtils.pageInit("cyb/index", "index/index",{});
			});
		});
		
		//绑定联系人界面的确认按钮
		appUtils.bindEvent($(_pageId+" #contact_confirm"),function(){
			var name = $(_pageId+" .name").val();
			var mobileNo = $(_pageId+" .mobileNo").val();
			var relation = $(_pageId+" .relation").val();
			if(name == ""){
				layerUtils.iAlert("姓名不能为空！");
				return false;
			}
			if(!common.isCn(name)){
				layerUtils.iAlert("姓名只能填写中文汉字！");
				return false;
			}
			if(mobileNo == ""){
				layerUtils.iAlert("联系电话不能为空！");
				return false;
			}
			if(!validatorUtil.isMobile(mobileNo) && !validatorUtil.isTel(mobileNo)){
				layerUtils.iAlert("联系电话格式不正确！");
               	return false;
			}
			if(relation == ""){
				layerUtils.iAlert("第二联系人不能为空！");
				return false;
			}
			var cyb_state = appUtils.getSStorageInfo("cyb_state");		//1、已开通创业板，走创业板转签 3、未开通，走创业板开通
			//已开通创业板，走创业板转签流程
			if("1" == cyb_state){
				//修改“是否需要创业板转签”标识
				var alterCybSign = {
					"user_id":appUtils.getSStorageInfo("user_id"),
					"trdaccount":appUtils.getSStorageInfo("sza_account")
				};
				mobileService.alterCybSign(alterCybSign, function(data){
					var error_no = data.error_no;
					var error_info = data.error_info;
					if(error_no == "0") {
						// 提交创业板转签请求
						var submitCyb = {
							"user_id":appUtils.getSStorageInfo("user_id"),
							"name":$(_pageId+" .name").val(),
							"mobile_no":$(_pageId+" .mobileNo").val(),
							"trdaccount":appUtils.getSStorageInfo("sza_account"),
							"relation":relation
						};
						mobileService.submitCyb(submitCyb, function(data){
							var error_no = data.error_no;
							var error_info = data.error_info;
							if(error_no == "0") {
								submitCyb_result = data.results[0];
								//创业板转签开通结果
								if(submitCyb_result.openState) {
									appUtils.setSStorageInfo("open_state", submitCyb_result.openState);
									appUtils.pageInit("cyb/index", "cyb/result", {});
								} else {
//									layerUtils.iAlert(error_info,-1);
									layerUtils.iMsg(-1, error_info);
									return false;
								}
							}
							else {
//								layerUtils.iAlert(error_info,-1);
								layerUtils.iMsg(-1, error_info);
								return false;
							}
						});
					} else {
//						layerUtils.iAlert(error_info,-1);
						layerUtils.iMsg(-1, error_info);
						return false;
					}
				});
			}
			else if("3" == cyb_state){
				// 提交创业板开通请求
				var submitCybOpen = {
					"user_id":appUtils.getSStorageInfo("user_id"),
					"name":$(_pageId+" .name").val(),
					"mobile_no":$(_pageId+" .mobileNo").val(),
					"trdaccount":appUtils.getSStorageInfo("sza_account"),
					"relation" : relation
				};
				mobileService.openCyb(submitCybOpen, function(data){
					var error_no = data.error_no;
					var error_info = data.error_info;
					if(error_no == "0") {
						appUtils.pageInit("cyb/index", "cyb/signProtocol", {});
					}
					else {
//						layerUtils.iAlert(error_info,-1);
						layerUtils.iMsg(-1, error_info);
						return false;
					}
				});
			}
		});
	}
	
	function queryCybInfo(){
		// 获取深A和创业板权限开通数据，是否满足开通创业板条件（开通深A且该深A有创业板）
		var cybInfo = {
			"user_id":appUtils.getSStorageInfo("user_id"),
			"isbind":"1",			//0：查询所有深A，1：查询已指定券商的沪深
			"fundid":appUtils.getSStorageInfo("curr_loginid")
		};
		mobileService.getCybInfo(cybInfo, function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no == "0"){
				accountInfoList = data.accountInfoList;
				otherInfo = data.otherInfo;
				// 是否为交易时间
				if(otherInfo[0].isTradeTime) {
					appUtils.setSStorageInfo("isTradeTime", otherInfo[0].isTradeTime);
				}
				// 没有获取到深A或者创业板权限集合信息
				if(undefined == accountInfoList || accountInfoList == "") {
					$(_pageId+" #fail_notice").show();
					$(_pageId+" #notice").hide();
					$(_pageId+" #contact").hide();
					$(_pageId+" .icon").hide();
					$(_pageId+" .login_pop").hide();

				} else {
					// 是否已开通深圳A股东账户
					if(accountInfoList[0].sza_open) {
						appUtils.setSStorageInfo("sza_open", accountInfoList[0].sza_open);
					}
					// 深A股东帐户是否已下挂在券商
					if(accountInfoList[0].sza_bind) {
						appUtils.setSStorageInfo("sza_bind", accountInfoList[0].sza_bind);
					}
					// 深A股东账号
					if(accountInfoList[0].sza_account) {
						appUtils.setSStorageInfo("sza_account", accountInfoList[0].sza_account);
					}
					// 是否已开通创业板权限
					if(accountInfoList[0].cyb_open) {
						appUtils.setSStorageInfo("cyb_open", accountInfoList[0].cyb_open);
					}
					// 券商处是否已开通了创业板权限
					if(accountInfoList[0].cyb_bind) {
						appUtils.setSStorageInfo("cyb_bind", accountInfoList[0].cyb_bind);
					}
					//没有开通深A或者深A没有在该券商加挂
					if((accountInfoList[0].sza_open == "" || accountInfoList[0].sza_open == "0")
					|| (accountInfoList[0].sza_open == "1" && accountInfoList[0].sza_bind == "0")) {
						$(_pageId+" #fail_notice").show();
						$(_pageId+" #notice").hide();
						$(_pageId+" #contact").hide();
						$(_pageId+" .login_pop").hide();
					} 
					else if(accountInfoList[0].cyb_open == "1" && accountInfoList[0].cyb_bind == "1" ) {
						$(_pageId+" #notice").show();
						$(_pageId+" #contact").hide();
						$(_pageId+" .success_main h5").html("创业板已开通并转签");
						$(_pageId+" .success_main p").hide();
						$(_pageId+" .login_pop").hide();
					}else{
						// 先查询创业板转签办理的状态
						var cybStatus = {
							"user_id":appUtils.getSStorageInfo("user_id"),
							"trdaccount":accountInfoList[0].sza_account
						};
						mobileService.getCybStatus(cybStatus, function(data){
							var error_no = data.error_no;
							var error_info = data.error_info;
							if(error_no == "0") {
								var cyb_result = data.results[0];
								// 创业板转签业务状态
								if(cyb_result.sign_state) {
									appUtils.setSStorageInfo("sign_state", cyb_result.sign_state);
								}
								// 创业板开通类型
								if(cyb_result.open_type) {
									appUtils.setSStorageInfo("open_type", cyb_result.open_type);
								}
								// 签署协议日期 开通创业板标志
								if(cyb_result.sign_date) {
									appUtils.setSStorageInfo("sign_date", cyb_result.sign_date);
								}
								// 是否需要转签
								if(cyb_result.istoadd) {
									appUtils.setSStorageInfo("istoadd", cyb_result.istoadd);
								}
								// 应急联系人姓名
								if(cyb_result.emergency_name) {
									appUtils.setSStorageInfo("emergency_name", cyb_result.emergency_name);
								}
								// 与应急联系人关系
								if(cyb_result.emergency_relation) {
									appUtils.setSStorageInfo("emergency_relation", cyb_result.emergency_relation);
								}
								// 应急联系人固定电话
								if(cyb_result.emergency_tel) {
									appUtils.setSStorageInfo("emergency_tel", cyb_result.emergency_tel);
								}
								// 应急联系人手机
								if(cyb_result.emergency_mobile) {
									appUtils.setSStorageInfo("emergency_mobile", cyb_result.emergency_mobile);
								}
								// 应急联系人地址
								if(cyb_result.emergency_address) {
									appUtils.setSStorageInfo("emergency_address", cyb_result.emergency_address);
								}
								// 是否已有数字证书
								if(cyb_result.hascert) {
									appUtils.setSStorageInfo("hascert", cyb_result.hascert);
								}
								// 是否已有托管证书
								if(cyb_result.hasTgcert) {
									appUtils.setSStorageInfo("hasTgcert", cyb_result.hasTgcert);
								}
								// 创业板开通状态
								if(cyb_result.cyb_exist) {
									appUtils.setSStorageInfo("cyb_exist", cyb_result.cyb_exist);
								}
								// 是否为交易时间
								if(otherInfo[0].isTradeTime == "0") {
									// 非交易时间，也可办理
									$(_pageId+" #contact").show();
									$(_pageId+" #fail_notice").hide();
									$(_pageId+" #notice").hide();
									$(_pageId+" .login_pop").hide();
									appUtils.setSStorageInfo("cyb_state", "1");
								} else {
									// 交易时间,查询该深A是否已经开通了创业板权限
									if(accountInfoList[0].cyb_open == "0" || accountInfoList[0].cyb_open == ""
									 || accountInfoList[0].cyb_open == null) {
//										 查询用户其他深A账户是否开通创业板
										var cybAllInfo = {
											"user_id":appUtils.getSStorageInfo("user_id"),
											"isbind":"0",
											"fundid":appUtils.getSStorageInfo("curr_loginid")	
										};
										mobileService.getCybInfo(cybAllInfo, function(data){
											var error_no = data.error_no;
											var error_info = data.error_info;
											accountInfoList = data.accountInfoList;
											otherInfo = data.otherInfo;
											if(undefined != accountInfoList || "" != accountInfoList
											|| null != accountInfoList){
												for(var i=0; i<accountInfoList.length; i++) {
													accountInfoList[i].cyb_open = "1";
													// 如果返回的结果集中cyb_open等于1，就代表这个账户开通过创业板，走创业板转签的流程
													if(accountInfoList[i].cyb_open == "1") {
														// 查询创业板深A账户是否正常
														var sza_state = accountInfoList[i].sza_state;
														if(sza_state == "4") {
															// 已开通创业板，深A小额休眠
															$(_pageId+" #contact").show();
															$(_pageId+" #fail_notice").hide();
															$(_pageId+" #notice").hide();
															$(_pageId+" .login_pop").hide();
															//走创业板开通流程
															appUtils.setSStorageInfo("cyb_state", "3");
															
														} else {
															//该用户有深A且该深A有创业板
															$(_pageId+" #contact").show();
															$(_pageId+" #fail_notice").hide();
															$(_pageId+" #notice").hide();
															$(_pageId+" .login_pop").hide();
															//走创业板转签流程
															appUtils.setSStorageInfo("cyb_state", "1");
														}
													} else {
														$(_pageId+" #contact").show();
														$(_pageId+" #fail_notice").hide();
														$(_pageId+" #notice").hide();
														$(_pageId+" .login_pop").hide();
														//走创业板开通流程
														appUtils.setSStorageInfo("cyb_state", "3");
													}
												}
											}
											else{
												//未开通深A
												$(_pageId+" #fail_notice").show();
												$(_pageId+" #notice").hide();
												$(_pageId+" #contact").hide();
												$(_pageId+" .icon").hide();
												$(_pageId+" .login_pop").hide();
											}
										},{isShowWait:false});
									} else if(accountInfoList[0].cyb_open == "1" && (accountInfoList[0].cyb_bind == "0"
									|| accountInfoList[0].cyb_bind == "" || accountInfoList[0].cyb_bind == null)) {
										// 该深A开通了创业板，但是没有在该券商开通，走创业板转签
										$(_pageId+" #contact").show();
										$(_pageId+" #notice").hide();
										$(_pageId+" #fail_notice").hide();
										$(_pageId+" .login_pop").hide();
										appUtils.setSStorageInfo("cyb_state", "1");
									} else if(accountInfoList[0].cyb_open == "1" && accountInfoList[0].cyb_bind == "1" ) {
										$(_pageId+" #notice").show();
										$(_pageId+" #contact").hide();
										$(_pageId+" .success_main h5").html("创业板已开通并转签");
										$(_pageId+" .success_main p").hide();
										$(_pageId+" .login_pop").hide();
									}
								}
								// 未办理创业板转签业务，且非中登时间，无法获得创业板开通数据
								if(cyb_result.cyb_exist == "2") {
									$(_pageId+" #contact").show();
									$(_pageId+" #notice").hide();
									$(_pageId+" .login_pop").hide();
									$(_pageId+" #fail_notice").hide();
								}else if(cyb_result.cyb_exist == "3") {	//3：已经转签
									$(_pageId+" #notice").show();
									$(_pageId+" #contact").hide();
									$(_pageId+" .success_main h5").html("创业板已开通并转签");
									$(_pageId+" .success_main p").hide();
									$(_pageId+" .login_pop").hide();
								}else if(cyb_result.cyb_exist == "4") {	//4：转签失败
									$(_pageId+" #notice").show();
									$(_pageId+" #fail_notice").hide();
									$(_pageId+" #contact").hide();
									$(_pageId+" .login_pop").hide();
									$(_pageId+" .success_main h5").html("你的创业板转签失败了");
									$(_pageId+" .success_main p").html("").hide()
									$(_pageId+" .success_main .icon").hide();
								} else if(cyb_result.cyb_exist == "5") {	//5：已提交备注人信息
									$(_pageId+" #notice").show();
									$(_pageId+" #contact").hide();
									$(_pageId+" #fail_notice").hide();
									$(_pageId+" .login_pop").hide();
									$(_pageId+" .success_main h5").html("您的申请已成功提交");
									$(_pageId+" .success_main p").html("我们将在一个工作日内告知您申请结果").show();
								}
							} else {
								$(_pageId+" .login_pop").hide();
//								layerUtils.iAlert(error_info,-1);
								layerUtils.iMsg(-1, error_info);
								return false;
							}
						},{isShowWait: false, timeOutFunc: handleTimeout});
					}
				}
			} else {
				$(_pageId+" .login_pop").hide();
//				layerUtils.iAlert(error_info,-1);
				layerUtils.iMsg(-1, error_info);
				return false;
			}
		},{isShowWait: false, timeOutFunc: handleTimeout});
	}
	
	/* 处理请求超时 */
	function handleTimeout()
	{
		layerUtils.iConfirm("请求超时，是否重新加载？",function(){
			queryCybInfo();  // 再次获取创业板开通权限
		});
	}
	
	function destroy(){}
	
	var index = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
	
	module.exports = index;
});
