/**
* 结果页
*/
define(function(require,exports,module){
	var appUtils = require("appUtils"),
		global = require("gconfig").global,
		_pageId = "#cyb_result";
	var mobileService = require("mobileService");
	var external = require("external");
	var common = require("common");
	
	function init(){
		common.hideTabBar();
		cleanPageInfo();
		//初始化页面
		initPage();
	}
	
	function bindPageEvent(){
		//绑定确认按钮
		appUtils.bindEvent($(_pageId+" .ce_btn"), function(){
			appUtils.pageInit("cyb/index", "index/index",{});
		});

		//绑定返回按钮
		appUtils.bindEvent($(_pageId+" .icon_back"), function(){
			appUtils.pageBack();
		});

		//绑定home键 跳转到主界面
		appUtils.bindEvent($(_pageId+" .icon_home"), function(){
			var param = {
				"funcNo":"50101",
				"moduleName":"main"
			};
			external.callMessage(param);
		});
	}
	
	//初始化页面
	function initPage() {
		var _prePageCode = appUtils.getSStorageInfo("_prePageCode");
		//创业板转签提交返回状态：1：开通成功 0：非交易时间未开通，进入跑批  创业板开通返回标识
		var open_state = appUtils.getSStorageInfo("open_state");
		//创业板转签
		if("cyb/index" == _prePageCode){
			// 开通成功
			if(open_state == "1") {
				$(_pageId+" .header h3").html("创业板转签");
				$(_pageId+" .success_main h5").html("恭喜您创业板转签成功！");
				$(_pageId+" .success_main p").hide();
			} else {
				$(_pageId+" .header h3").html("创业板转签");
				$(_pageId+" .success_main h5").html("您的申请已成功提交");
				$(_pageId+" .success_main p").html("我们将在一个工作日内告知您申请结果").show();
			}
		}//创业板开通
		else if("cyb/signProtocol" == _prePageCode){
			$(_pageId+" .header h3").html("创业板开通");
			$(_pageId+" .success_main h5").html("您的申请已成功提交");
			$(_pageId+" .success_main p").html("我们将在一个工作日内告知您申请结果").show();
		}
		else{
			$(_pageId+" .success_main h5").html("您的申请已成功提交");
			$(_pageId+" .success_main p").html("我们将在一个工作日内告知您申请结果").show();
		}
	}
	
	function cleanPageInfo() {
		$(_pageId+" .success_main h5").html("您的申请已成功提交");
		$(_pageId+" .success_main p").show();
	}
	
	function destroy(){
		mobileService.destroy();
	}
	
	var result = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
	
	module.exports = result;
});