/**
 * 签署协议
 */
define(function(require, exports, module){ 
	/* 私有业务模块的全局变量 begin */
	var appUtils = require("appUtils"),
		global = require("gconfig").global,
		layerUtils = require("layerUtils"),
		Map = require("map"),
		fristMap = null,  //  存放所有相关协议
	    protocolArray = new Array(),  // 存放协议签名值
	    countProtocol = 0, // 计算签署成功的数量
	    signFlag = "",  //1代表签了协议，2代表未签协议
		_pageId = "#cyb_signProtocol";
	var mobileService = require("mobileService");
	var external = require("external");
	var common = require("common");
	var protocol = "";	//存放协议
	var isSubmitInfo = "0";
	
	function init()
	{
		common.hideTabBar();
		isSubmitInfo = appUtils.getSStorageInfo("submited");
		if(appUtils.getSStorageInfo("signFlag") != "1") {
			signFlag = "2";
			appUtils.setSStorageInfo("signFlag",signFlag);
		}
		//查询协议
		getSign();
	}
	
	//绑定
	function bindPageEvent(){
		/* 绑定签署协议*/
		appUtils.bindEvent($(_pageId+" .rule_check span"),function(){
			$(this).toggleClass("checked"); //  切换勾选样式
		});
		
		//绑定提交申请
		appUtils.bindEvent($(_pageId+" .ce_btn"),function(){
			if(!$(_pageId+" .icon_check").hasClass("checked")) {
				layerUtils.iMsg(-1, "请阅读并勾选同意签署以上协议！");
				return false;
			} else {
				//验签
				getSignProtocol();
			}
		});
		
		//绑定返回按钮
		appUtils.bindEvent($(_pageId+" .icon_back"),function(){
			if(isSubmitInfo == "1"){
				appUtils.pageInit("cyb/signProtocol","index/index");
			}else{
				appUtils.pageInit("cyb/signProtocol","cyb/index");
			}
		});
		
		//绑定home键 跳转到主界面
		appUtils.bindEvent($(_pageId+" .icon_home"), function(){
			var param = {
				"funcNo":"50101",
				"moduleName":"main"
			};
			external.callMessage(param);
		});
	}
	
	function destroy()
	{
		mobileService.destroy();
	}
	
	//获取协议
	function getSign(){
		var param = {
			"category_englishname":"",
			"category_no":"ygt_cybOpenProtcl",
			"econtract_no":""
		};
		mobileService.getSign(param,function(data){
			var error_no = data.error_no,
				error_info = data.error_info,
				results = data.results;
			if(error_no == "0"){
				if(undefined != results){
					fristMap = new Map();
					var protocolMap = null;
					for(var i=0;i<results.length;i++)
					{
						protocolMap = new Map();
						protocolMap.put("protocolid",results[i].agree_no);	//协议id
						protocolMap.put("protocolname",results[i].agree_name);	//协议名
						protocolMap.put("summary",results[i].md5_content);	//协议内容MD5,签名摘要信息
						fristMap.put(i,protocolMap);
					}
					$(_pageId+" .rule_cont h2").text(results[0].agree_name);
					var param = {
						"agree_no" : results[0].agree_no,
						"version":""
					};
					//查询协议内容
					mobileService.getProtocolInfo(param,function(data){
						if(error_no = data.error_no)
						{
							$(_pageId+" .rule_cont p").html(data.results[0].content);
						}
						else
						{
//							layerUtils.iAlert(data.error_info);
							layerUtils.iMsg(-1, error_info);
						}
					});
				}
				else{
				}
			}else{
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
			}
		},true,true,handleTimeout);
	}
	
	/* 处理请求超时 */
	function handleTimeout()
	{
		layerUtils.iConfirm("请求超时，是否重新加载？",function(){
			getSign();  // 再次获取协议
		});
	}
	
	/* 获取签名值 */
	function getSignProtocol()
	{
		var keys = fristMap.keys();  // 协议的数量
		// 检查是否勾选签署协议
		if($(_pageId+" .rule_check span").hasClass("checked"))
		{
			layerUtils.iLoading(true);  // 开启等待层。。。
			var oneData  = fristMap.get(keys[countProtocol]); // 取出一个协议
			var protocolid = oneData.get("protocolid"); // 协议ID
			var protocolname = oneData.get("protocolname");  //协议名称
			var summary = oneData.get("summary");  // 协议内容MD5,签名摘要信息
			// 添加值到数组中
			var protocol = {
				"protocol_id" : protocolid,
				"summary" : summary
			}
			protocolArray.push(protocol);
			countProtocol++;
			if(countProtocol < keys.length)  // 通过比较，获取每个协议的签名值
			{
				getSignProtocol();  
			}else{
				submitProtocol();  //提交协议
			}
		}
		else
		{
			layerUtils.iAlert("请阅读并勾选同意签署以上全部协议！");
			return false;
		}
	}
	
	// 提交协议
	function submitProtocol(){
		countProtocol = 0;  // 将签署协议的计数器置为 0
		var signProtocolParam = {
			"user_id" : appUtils.getSStorageInfo("user_id"),
			"jsondata" : JSON.stringify(protocolArray),
			"ipaddr" : "",
			"macaddr" : "",
			"checksign" : "0",
			"trdaccount" : appUtils.getSStorageInfo("sza_account"),
			"sign_source_flag" : "1"
		};
		mobileService.checkSign(signProtocolParam,function(data){
			var error_no = data.error_no,
				error_info = data.error_info;
			if(error_no == "0"){
				signFlag = "1";
				appUtils.setSStorageInfo("signFlag",signFlag);
				appUtils.pageInit("cyb/signProtocol","cyb/result",{});
			}else{
				protocolArray = new Array();
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
				return false;
			}
		});
	}
	
	var signProtocol = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
		
	module.exports = signProtocol;
});