define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var validata = require("validatorUtil");
	var layerUtils = require("layerUtils");
	var _pageId = "#editDelegate_editDelegate";
	var mobileService = require("mobileService");
	var openArray = new Array();  // 存放委托方式状态
	var number = 0;	//记录委托方式个数
	var err_i = 0;		//记录提交失败次数
	var userInfo;
//	var platform = gconfig.platform;
	var external = require("external");
	var common = require("common");
	var Map = require("map");
	var fristMap = null;  //  存放所有相关协议

	function init() {
		common.hideTabBar();
		number = 0;
		// 初始化页面
		initPage();
	}

	function bindPageEvent() {
		// 绑定返回
		appUtils.bindEvent($(_pageId+" .icon_back"), function(){
			appUtils.pageBack();
		});
	}

	function destroy(){

	}
	
	// 初始化页面，获取委托方式信息
	function initPage() {
		var getDelegate = {
			"user_id":appUtils.getSStorageInfo("user_id"),
			"zj_account":appUtils.getSStorageInfo("curr_loginid")
		};
		mobileService.getDelegate(getDelegate, function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no == "0") {
				var results = data.results;
				if(undefined != results){
					var length = results.length;
					var itemElement = "";
					for(var i =0; i<length; i++) {
						var item = results[i],
							entrust_name = item.entrust_name,  // 委托方式名称
							remark = item.remark,  // 委托方式描述
							entrust_status = item.entrust_status, // 开通状态：0未开通,1已开通
							image_data  = item.image_data,  // 图片数据
							image_url = item.image_url, // 图片路径
							create_date = item.create_date, // 创建时间
							order_line = item.order_line, // 排序
							entrust_code = item.entrust_code, // 委托方式代码
							agree_id = item.agree_id; //协议编号
						// 如果开通状态是未开通的时候
						if(entrust_status == "0") {
							itemElement +="<li><span entrust_code='"+entrust_code+"' entrust_status='"+entrust_status+"'>"+entrust_name+"<a class='sele_icon' href='javascript:void(0);'></a></li>";
						} else if(entrust_status == "1") {
							itemElement +="<li><span entrust_code='"+entrust_code+"' entrust_status='"+entrust_status+"'>"+entrust_name+"<a class='sele_icon open' href='javascript:void(0);'></a></li>";
						}
					}
					$(_pageId+" .wtclass_list").html(itemElement);
					queryAgreement();
					//绑定选择是否开通某个委托方式
					appUtils.bindEvent($(_pageId+" .sele_icon"), function(){
						var change_type = "0";		//0：取消 1：开通
						var entrust_code = "";		//委托方式代码
						//取消开通
						if($(this).hasClass("open")) {
							change_type = 0;	
							entrust_code = $(this).parent().attr("entrust_code");
							var ele = $(this);
							var submitOpen = {
								"user_id":appUtils.getSStorageInfo("user_id"),
								"change_type":change_type,
								"zj_account":appUtils.getSStorageInfo("curr_loginid"),
								"entrust_code":entrust_code
							};
							mobileService.editDelegate(submitOpen, function(data){
								var error_no = data.error_no;
								var error_info = data.error_info;
								if(error_no == "0"){
									ele.removeClass("open");
									$(this).removeClass("open");
								}else{
									ele.addClass("open");
//									layerUtils.iAlert(error_info);
									layerUtils.iMsg(-1, error_info);
									return false;
								}
							},{isShowWait:false});
						} else { 	//开通
							change_type = 1;	
							entrust_code = $(this).parent().attr("entrust_code");
							var ele = $(this);
							var submitOpen = {
								"user_id":appUtils.getSStorageInfo("user_id"),
								"change_type":change_type,
								"zj_account":appUtils.getSStorageInfo("curr_loginid"),
								"entrust_code":entrust_code
							};
							mobileService.editDelegate(submitOpen, function(data){
								var error_no = data.error_no;
								var error_info = data.error_info;
								if(error_no == "0"){
									ele.addClass("open");
								}else{
									ele.removeClass("open");
//									layerUtils.iAlert(error_info);
									layerUtils.iMsg(-1, error_info);
									return false;
								}
							},{isShowWait:false});
						}
					});
				}
				else{
				}
			} else {
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
				return false;
			}
		},{isShowWait:false});
	}
	
	//获取协议
	function queryAgreement(){
		var param = {
				"category_englishname":"",
				"category_no":"ygt_update_wtfs",
				"econtract_no":""
			};
		mobileService.getSign(param,function(data){
			var error_no = data.error_no,
				error_info = data.error_info,
				result = data.results;
			if(error_no == "0" && result.length != 0){
				fristMap = new Map();
				var results = data.results,
					  allProtocols = "";
				var protocolMap = null;
				for(var i=0;i<results.length;i++)
				{
					protocolMap = new Map();
					protocolMap.put("protocolid",results[i].agree_no);	//协议id
					protocolMap.put("protocolname",results[i].agree_name);	//协议名
					protocolMap.put("summary",results[i].md5_content);	//协议内容MD5,签名摘要信息
					allProtocols += "<p style=\"padding-top: 0.1rem;\"><a href=\"javascript:void(0);\" protocol-id=\""+results[i].agree_no+"\" id=\"protocol0"+i+"\">("+(i+1)+")《"+
						results[i].agree_name+"》</a></p>";
					// 预绑定查看协议的事件
					appUtils.preBindEvent($(_pageId+" .tips"),"#protocol0"+i,function(e){
						appUtils.setSStorageInfo("protocol_id",$(this).attr("protocol-id"));
						appUtils.pageInit("editDelegate/editDelegate","editDelegate/showProtocol",{"protocol_id" : $(this).attr("protocol-id")});
						e.stopPropagation();
					});
					fristMap.put(i,protocolMap);
				}
				$(_pageId+" .tips").html("<p style=\"text-indent: 2em;\">操作渠道开通/取消，即为相应委托方式的变更，也是您业务受理渠道的变更，存在一定的风险性，请您仔细阅读相应渠道委托协议书，您的任何渠道变更操作都表明您已经同意接受相应委托渠道的委托协议书内容。</p>"+allProtocols);
			}else{
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
			}
		},{isShowWait:false});
	}
	
	var editDelegate = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = editDelegate;
});
