define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var validata = require("validatorUtil");
	var layerUtils = require("layerUtils");
	var _pageId ="#fund_fundOpenInfo";
	var mobileService = require("mobileService");
	var external = require("external");
	var fundParam={"fund_id" : "","bill_id" : ""};  //基金公司代码,账单方式编号
	var common = require("common");
	var openFundState = "0";
	

	function init() {
		common.hideTabBar();
		initPage();
		queryCompany();
	}
	
	function initPage() {
		$(_pageId).css("display","");
		openFundState = appUtils.getSStorageInfo("isOpenFundAccount");
		if(openFundState == "0"){
			fundParam.fund_id = "98";
			$(_pageId+" #selectCompany").html("深圳登记结算公司");
			/* 绑定选择基金公司 */
			appUtils.bindEvent($(_pageId + " .input_form #selectCompany"), function(e) {
				 
			});
		}else{
			$(_pageId+" #selectCompany").html("请选择基金公司");
			bindSelectCompany();
		}
		fundParam.bill_id = "1";
		$(_pageId+" #fundAccount").val(appUtils.getSStorageInfo("curr_loginid"));
		$(_pageId+" #custname").val(appUtils.getSStorageInfo("name"));
		$(_pageId+" #selectBillWay").html("不寄送");
		$(_pageId+" #address").val(appUtils.getSStorageInfo("address"));
		$(_pageId+" #post").val(appUtils.getSStorageInfo("post_code"));
		$(_pageId+" #phone").val(common.trim(appUtils.getSStorageInfo("mobile")));
	}
	
	/*查询基金公司*/
	function queryCompany(){
		var param = {"user_id" : appUtils.getSStorageInfo("user_id")};
		mobileService.queryFundOpenState(param,function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			var companys = data.results;
			var com_str = "",
				ta_code = "",
				ta_name = "",
				open_flag = "",
				ta_acct = "",
				open_date = "",
				state = "";
			if(error_no == "0" && companys.length!=0){
				for (var i = 0; i < companys.length; i++) {
					ta_code = companys[i].ta_code; 					// 基金公司代码
					ta_name = companys[i].ta_name; 					// 基金公司名称
					open_flag = companys[i].open_flag; 				// 开通状态：0：未开通，1：已开通
					if("0" == open_flag){
						com_str += "<li tid='" + ta_code + "' state = ='" + open_flag + "'><span>" + ta_name + "</span></li>";
					}
					else{
						state = "已开通";
						com_str += "<li tid='" + ta_code + "' state = ='" + open_flag + "'><span>" + ta_name + "("+state+")</span></li>";
					}
					ta_acct = companys[i].ta_acct; 					// 基金帐号
					open_date = companys[i].open_date; 				// 开通日期
				}
				$(_pageId + " #fundCompany ul").html(com_str); // 填充省份下拉框
				bindCompany(); //点击省份
				queryBillWay();
			}else {
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
				return false;
			}
		},{isShowWait:false});	
	}
	
	/*查询账单方式*/
	function queryBillWay(){
		var param = {
			"enum_type": "DELIVER_TYPE"
		};
		mobileService.queryFundation(param, function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			var item_results = data.results;
			var item_str = "";
			if(error_no == "0" && undefined != item_results){
				 for(var k=0;k<item_results.length;k++){
					var item_name = item_results[k].item_name;
					var item_value = item_results[k].item_value;
					item_str += "<li bid='" + item_value + "'><span>" + item_name + "</span></li>";
				}
				$(_pageId+" #billWay ul").html(item_str);
				bindBill();
			} else {
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
				return false;
			}
		},{isShowWait:false});	
	}
	
	/* 控制是否可以选择基金公司 */
	function bindSelectCompany(){
		/* 绑定选择基金公司 */
		appUtils.bindEvent($(_pageId + " .input_form #selectCompany"), function(e) {
			$(_pageId + " #billWay").hide(); //隐藏账单方式列表
			$(_pageId + " #fundCompany ul li").removeClass("active");
			$(_pageId + " #fundCompany").slideToggle("fast"); // 显示选择基金公司的下拉列表
			e.stopPropagation(); // 阻止冒泡
		});
	}
	
	/* 选中基金公司事件处理 */
	function bindCompany() {
		appUtils.bindEvent($(_pageId + " #fundCompany ul li"), function(e) {
			var tid = $(this).attr("tid");
			$(this).addClass("active").siblings().removeClass("active");
			var company_name = $(this).text(); //当前选中省份的值
			var sel_cname = $(_pageId + " .selectCompany").text(); //上一次选中省份的值
			$(_pageId + " #selectCompany").text(company_name); //将选中值赋给选择框
			$(_pageId + " #fundCompany").slideUp("fast"); //隐藏下拉框
			fundParam.fund_id = tid;
			e.stopPropagation(); // 阻止冒泡
		});
	}
	
	/* 选中账单方式事件处理 */
	function bindBill() {
		appUtils.bindEvent($(_pageId + " #billWay ul li"), function(e) {
			var bid = $(this).attr("bid");
			$(this).addClass("active").siblings().removeClass("active");
			var bill_name = $(this).text(); //当前选中省份的值
			var sel_bname = $(_pageId + " .selectBillWay").text(); //上一次选中省份的值
			$(_pageId + " #selectBillWay").text(bill_name); //将选中值赋给选择框
			$(_pageId + " #billWay").slideUp("fast"); //隐藏下拉框
			fundParam.bill_id = bid;
			e.stopPropagation(); // 阻止冒泡
		});
	}
	
	function bindPageEvent() {
		// 绑定返回
		appUtils.bindEvent($(_pageId+" .icon_back"), function(){
			//跳转到业务办理首页
            appUtils.pageInit("fund/fundOpenInfo", "index/index",{});
		});
		
		/* 点击页面其他元素隐藏下拉列表 */
		appUtils.bindEvent($(_pageId), function(e) {
			$(_pageId + " .ly_shadow").slideUp("fast"); // 隐藏下拉列表
			$(_pageId + " .main").css("height", "");
			e.stopPropagation(); // 阻止冒泡
		});
		
		/* 绑定选择账单方式 */
		appUtils.bindEvent($(_pageId + " .input_form #selectBillWay"), function(e) {
			$(_pageId + " #fundCompany").hide(); //隐藏省份列表
			$(_pageId + " #billWay ul li").removeClass("active");
			$(_pageId + " #billWay").slideToggle("fast"); // 显示选择账单方式的下拉列表
			e.stopPropagation(); // 阻止冒泡
		});
		
		/* 绑定基金开户 */
		appUtils.bindEvent($(_pageId + " .ce_btn"), function(e) {
			if(validateInput()){
				openFundAccount();  //开立基金账号
			}
			e.stopPropagation(); // 阻止冒泡
		});
	}
	
	/*校验输入参数*/
	function validateInput(){
		var selectCompany = $(_pageId+" #selectCompany").text();
		var selectBillWay = $(_pageId+" #selectBillWay").text();
		var address = $(_pageId+" #address").val();
		var post = $(_pageId+" #post").val();
		var phone = $(_pageId+" #phone").val();
		var email = $(_pageId+" #email").val();
		if (selectCompany == "请选择基金公司") {
			layerUtils.iMsg(-1, "请先选择基金公司");
			return false;
		}
		if (selectBillWay == "请选择") {
			layerUtils.iMsg(-1, "请先选择账单方式");
			return false;
		}
		if (address == "") {
			layerUtils.iMsg(-1, "请先填写您的详细地址");
			return false;
		}
		if (post == "") {
			layerUtils.iMsg(-1, "请先填写您的邮编");
			return false;
		}
		if (post.length != "6") {
			layerUtils.iMsg(-1, "您的邮编格式输入不正确");
			return false;
		}
		if (phone == "") {
			layerUtils.iMsg(-1, "请先填写您的手机号码");
			return false;
		}
		if(!validata.isMobile(phone)){
			layerUtils.iMsg(-1, "您的手机号码格式不正确");
			return false;
		}
		if(email!="" && !validata.isEmail(email)){
			layerUtils.iMsg(-1, "您的邮箱格式不正确!");
			return false;
		}
		return true;
	}
	
	/*开通基金账号*/
	function openFundAccount(){
		var param = {
			"user_id" : appUtils.getSStorageInfo("user_id"),
			"address" : $(_pageId+" #address").val(),
			"postcode" : $(_pageId+" #post").val(),
			"mobile" : $(_pageId+" #phone").val(),
			"email" : $(_pageId+" #email").val(),
			"deliver_type" : fundParam.bill_id,
			"tacodes" : fundParam.fund_id,
		};
		mobileService.openFundAccount(param,function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no == "0"){
				var open_flag = data.results[0].open_flag;		//0：开通失败，1：开通成功
				var open_msg = data.results[0].open_msg;		//开通结果描述
				//TA98
				if(openFundState == "0"){
					if(open_flag == "0"){							
						layerUtils.iMsg(-1,open_msg);
					}else{
						layerUtils.iAlert("开通成功!","0",function(){
							appUtils.pageInit("fund/fundOpenInfo", "cashTreasure/signCashTreaProtocol",{});
						});
					}
				}else{
					if(open_flag == "0"){							
						layerUtils.iMsg(-1,open_msg);
					}else{
						layerUtils.iAlert("开通成功!","0",function(){
							appUtils.pageInit("fund/fundOpenInfo", "index/index",{});
						});
					}
				}
			}else {
				layerUtils.iAlert(error_info);
				return false;
			}
		});
	}
	
	function destroy(){
		mobileService.destroy();
	}
	
	var fundOpenInfo = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = fundOpenInfo;
});
