/**
 * 签署协议
 */
define(function(require, exports, module){ 
	/* 私有业务模块的全局变量 begin */
	var appUtils = require("appUtils"),
		global = require("gconfig").global,
		layerUtils = require("layerUtils"),
		Map = require("map"),
		fristMap = null,  //  存放所有相关协议
	    protocolArray = new Array(),  // 存放协议签名值
	    countProtocol = 0, // 计算签署成功的数量
	    signFlag = "",  //1代表签了协议，2代表未签协议
		_pageId = "#fund_signFundProtocol";
	var mobileService = require("mobileService");
	var external = require("external");
	var common = require("common");
	
	function init()
	{
		common.hideTabBar();
		//查询协议
		getSign();
	}
	
	//获取协议
	function getSign(){
		var param = {
			"category_englishname":"",
			"category_no":"jjxy",
			"econtract_no":""
		};
		mobileService.getSign(param,function(data){
			var error_no = data.error_no,
				error_info = data.error_info,
				result = data.results;
			if(error_no == "0" && result.length != 0){
				fristMap = new Map();
				var results = data.results,
					  allProtocols = "";
				var protocolMap = null;
				for(var i=0;i<results.length;i++)
				{
					protocolMap = new Map();
					protocolMap.put("protocolid",results[i].agree_no);	//协议id
					protocolMap.put("protocolname",results[i].agree_name);	//协议名
					protocolMap.put("summary",results[i].md5_content);	//协议内容MD5,签名摘要信息
					allProtocols += "<ul><li><a href=\"javascript:void(0);\" protocol-id=\""+results[i].agree_no+"\" id=\"protocol0"+i+"\">《"+
						results[i].agree_name+"》</a></li><ul>";
					// 预绑定查看协议的事件
					appUtils.preBindEvent($(_pageId+" .rule_list"),"#protocol0"+i,function(e){
						appUtils.setSStorageInfo("protocol_id",$(this).attr("protocol-id"));
						appUtils.pageInit("fund/signFundProtocol","fund/showFundProtocol",{"protocol_id" : $(this).attr("protocol-id")});
						e.stopPropagation();
					});
					fristMap.put(i,protocolMap);
				}
				$(_pageId+" .rule_list").html(allProtocols);
			}else{
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
			}
		},{isShowWait:false});
	}
	
	/* 处理请求超时 */
	function handleTimeout()
	{
		layerUtils.iConfirm("请求超时，是否重新加载？",function(){
			getSign();  // 再次获取协议
		});
	}
	
	//绑定
	function bindPageEvent(){
		/* 绑定签署协议*/
		appUtils.bindEvent($(_pageId+" .rule_check span"),function(){
			$(this).toggleClass("checked"); //  切换勾选样式
		});
		
		//绑定提交申请
		appUtils.bindEvent($(_pageId+" .ce_btn"),function(){
			if(!$(_pageId+" .icon_check").hasClass("checked")) {
				layerUtils.iMsg(-1, "请阅读并勾选以上全部协议！");
				return false;
			} else {
				appUtils.pageInit("fund/signFundProtocol","fund/fundOpenInfo",{});
			}
		});
		
		//绑定返回按钮
		appUtils.bindEvent($(_pageId+" .icon_back"),function(){
			appUtils.pageInit("fund/signFundProtocol","index/index",{});
		});
		
		//绑定home键 跳转到主界面
		appUtils.bindEvent($(_pageId+" .icon_home"), function(){
			var param = {
				"funcNo":"50101",
				"moduleName":"main"
			};
			external.callMessage(param);
		});
	}
	
	function destroy()
	{
		mobileService.destroy();
	}
	
	var signFundProtocol = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
		
	module.exports = signFundProtocol;
});