define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var layerUtils = require("layerUtils");
	var Map = require("map"),
		fristMap = null,  				  //  存放所有相关协议
	    protocolArray = new Array(), 	 // 存放协议签名值
	    countProtocol = 0; 				// 计算签署成功的数量
	var _pageId ="#fxjs_stockTradeDredge";
	var mobileService = require("mobileService");
	var common = require("common");
	

	function init() {
		common.hideTabBar();
		getProtocolInfo();
	}
	
	//获取协议
	function getProtocolInfo(){
		var param = {
			"category_englishname":"",
			"category_no":"jyktxy",
			"econtract_no":""
		};
		mobileService.getSign(param,function(data){
			var error_no = data.error_no,
				error_info = data.error_info,
				result = data.results;
			if(error_no == "0" && result.length != 0){
				fristMap = new Map();
				var results = data.results,
					  allProtocols = "";
				var protocolMap = null;
				for(var i=0;i<results.length;i++)
				{
					protocolMap = new Map();
					protocolMap.put("protocolid",results[i].agree_no);	//协议id
					protocolMap.put("protocolname",results[i].agree_name);	//协议名
					protocolMap.put("summary",results[i].md5_content);	//协议内容MD5,签名摘要信息
					allProtocols += "<ul><li><span class=\"icon_radio checked\"></span><a href=\"javascript:void(0);\" protocol-id=\""+results[i].agree_no+"\" id=\"protocol0"+i+"\">《"+
						results[i].agree_name+"》</a></li><ul>";
					// 预绑定查看协议的事件
					appUtils.preBindEvent($(_pageId+" .risk_list"),"#protocol0"+i,function(e){
						appUtils.setSStorageInfo("protocol_id",$(this).attr("protocol-id"));
						appUtils.pageInit("fxjs/stockTradeDredge","fxjs/showFXJSProtocol",{"protocol_id" : $(this).attr("protocol-id")});
						e.stopPropagation();
					});
					fristMap.put(i,protocolMap);
				}
				$(_pageId+" .risk_list").html(allProtocols);
			}else{
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
			}
		},{isShowWait:false});
	}
	
	function bindPageEvent() {
	   //绑定返回
       appUtils.bindEvent($(_pageId+" .icon_back"), function(){
       		appUtils.pageBack();
        });
        
        //切换协议勾选样式
		appUtils.bindEvent($(_pageId+" .rule_check span"),function(){
			$(this).toggleClass("checked"); 
		});
		
		//绑定提交申请
		appUtils.bindEvent($(_pageId+" .ce_btn"),function(){
			if(!$(_pageId+" .icon_check").hasClass("checked")) {
				layerUtils.iMsg(-1, "请阅读并勾选以上全部协议！");
				return false;
			} else {
 				getSignProtocl();
			}
		});
	}
    
    /* 获取签名值 */
	function getSignProtocl()
	{
		var keys = fristMap.keys();  // 协议的数量
		// 检查是否勾选签署协议
		if($(_pageId+" .rule_check span").hasClass("checked"))
		{
			layerUtils.iLoading(true);  // 开启等待层。。。
			var oneData  = fristMap.get(keys[countProtocol]); // 取出一个协议
			var protocolid = oneData.get("protocolid"); // 协议ID
//			var protocolname = oneData.get("protocolname");  //协议名称
			var summary = oneData.get("summary");  // 协议内容MD5,签名摘要信息
			// 添加值到数组中
			var protocol = {
				"protocol_id" : protocolid,
				"summary" : summary
			};
			protocolArray.push(protocol);
			countProtocol++;
			if(countProtocol < keys.length)  // 通过比较，获取每个协议的签名值
			{
				getSignProtocl();  
			}else{
				submitProtocol();  //提交协议
			}
		}
		else
		{
			layerUtils.iAlert("请阅读并勾选同意签署以上全部协议！");
			return false;
		}
	}
	
	// 提交协议
	function submitProtocol(){
		countProtocol = 0;  // 将签署协议的计数器置为 0
		var signProtocolParam = {
			"user_id" : appUtils.getSStorageInfo("user_id"),
			"jsondata" : JSON.stringify(protocolArray),
			"macaddr" : "",
			"ipaddr" : "",
			"checksign" : "0",
			"sign_source_flag" : "1",
			"certType" : ""
		};
		mobileService.setSTPermission(signProtocolParam,function(data){
			var error_no = data.error_no,
				error_info = data.error_info;
			if(error_no == "0" && "undefined"!=data.results){
				var status = data.results[0].status;				//开通状态
				var description = data.results[0].description;		//开通状态描述
				appUtils.pageInit("fxjs/stockTradeDredge","fxjs/result",{"status":status,"description":description});
			}else{
				protocolArray = new Array();
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
				return false;
			}
		});
	}
	
	function destroy(){
		mobileService.destroy();
	}
	
	var stockTradeDredge = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = stockTradeDredge;
});
