/**
 * 账户资金信息
 */
define(function(require, exports, module){ 
	/* 私有业务模块的全局变量 begin */
	var appUtils = require("appUtils"),
		global = require("gconfig").global,
		layerUtils = require("layerUtils"),
		marketvalue = "", //账户资金
		fundsFlag = "", //资金判断状态，1代表满足状态了 ,2代表资金状态不满足
		_pageId = "#ggt_fundsInfo";
	var mobileService = require("mobileService");
	var external = require("external");
	/* 私有业务模块的全局变量 end */
	
	function init()
	{
		//cleanPageElement();
		marketvalue = appUtils.getSStorageInfo("marketvalue");
		$(_pageId+" .value_box h5").html(marketvalue+"<small>/元</small>");
		if(marketvalue >= 500000){
			$(_pageId+" .ver_notice h5 span").html("已满足");
			$(_pageId+" .ver_notice h5 span").removeClass("error");
			$(_pageId+" .ver_notice h5 span").addClass("over");
			$(_pageId+" .ver_notice p").html("您的证券账户资产已满足≥50万要求，请继续满足其他条件。");
			//$(_pageId+" .ct_btn a").html("确认");
			$(_pageId+" #confirm").show();
			$(_pageId+" #netInfo").hide();
			fundsFlag = "1";
		}else{
			fundsFlag = "2";
		}
		appUtils.setSStorageInfo("fundsFlag",fundsFlag);
	}
	
	function bindPageEvent()
	{
		appUtils.bindEvent($(_pageId+" #net"),function(){
			appUtils.pageInit("ggt/fundsInfo","ggt/netLogin",{});
		});
		
		//如果资产大于500000
		appUtils.bindEvent($(_pageId+" #confirm"),function(){
			appUtils.pageInit("ggt/fundsInfo","ggt/mainPage",{});
		});
		
		//信用资产按钮点击
		appUtils.bindEvent($(_pageId+" #netInfo"),function(){
			appUtils.pageInit("ggt/fundsInfo","ggt/netLogin",{});
		});
		
		//绑定返回按钮
		appUtils.bindEvent($(_pageId+" .icon_back"),function(){
			appUtils.setSStorageInfo("value",marketvalue);
			appUtils.pageInit("ggt/fundsInfo","ggt/mainPage",{});
		});
		
		//绑定home键 跳转到主界面
		appUtils.bindEvent($(_pageId+" .icon_home"), function(){
			var param = {
				"funcNo":"50101",
				"moduleName":"main"
			};
			external.callMessage(param);
		});
	}
	
	function destroy()
	{
		mobileService.destroy();
	}

	
	/* 清理界面元素*/
	function cleanPageElement()
	{
		$(_pageId+" .ver_notice h5 span").html("抱歉");
		$(_pageId+" .ver_notice h5 span").removeClass("over");
		$(_pageId+" .ver_notice h5 span").addClass("error");
		$(_pageId+" .ver_notice p").html("您的证券账户资产未满足≥50万要求，暂时无法开通港股通业务，登陆<a href='javascript:void(0);' id='net' style='color:#00acee;'>信用账户</a>试试。");
		$(_pageId+" .ce_btn").hide();
	}
	
	var fundsInfo = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
	
	module.exports = fundsInfo;
});