/*
 * 知识测评信息
 */
define(function(require, exports, module){ 
	/* 私有业务模块的全局变量 begin */
	var appUtils = require("appUtils"),
		global = require("gconfig").global,
		layerUtils = require("layerUtils"),
		knowledge_score = "",  //风险等级数字评分
		knowledgeFlag = "",  //1表示满足风险评测等级，2表示不满足
		knowledge_lvl_name = "",  //风险评测等级
		_pageId = "#ggt_knowledgeInfo";
	var mobileService = require("mobileService");
	var external = require("external");
	/* 私有业务模块的全局变量 end */
	
	function init()
	{
		cleanPageElement();
		//初始化处理
		initHandle();
	}
	
	function bindPageEvent()
	{
		//绑定确认键
		appUtils.bindEvent($(_pageId+" #confirm"),function(){
			appUtils.clearSStorage("knowledgeScore");
			appUtils.setSStorageInfo("knowledgeScore",knowledge_score);
			appUtils.pageInit("ggt/knowledgeInfo","ggt/mainPage",{});
		});
		
		//绑定重新评测按钮
		appUtils.bindEvent($(_pageId+" .center"),function(){
			appUtils.pageInit("ggt/knowledgeInfo","ggt/knowledge",{});
		});
		
		//绑定重新评测按钮
		appUtils.bindEvent($(_pageId+" #reTest"),function(){
			appUtils.pageInit("ggt/knowledgeInfo","ggt/knowledge",{});
		});
		
		//绑定返回按钮
		appUtils.bindEvent($(_pageId+" .icon_back"),function(){
			appUtils.clearSStorage("knowledgeScore");
			appUtils.setSStorageInfo("knowledgeScore",knowledge_score);
			appUtils.pageInit("ggt/knowledgeInfo","ggt/knowledge",{});
		});
		
		//绑定home键 跳转到主界面
		appUtils.bindEvent($(_pageId+" .icon_home"), function(){
			var param = {
				"funcNo":"50101",
				"moduleName":"main"
			};
			external.callMessage(param);
		});
	}
	
	function destroy()
	{
		mobileService.destroy();
	}

	//初始化处理
	function initHandle(){
		knowledge_score = appUtils.getPageParam("remark");
		knowledge_lvl_name = appUtils.getPageParam("riskdesc");
		$(_pageId+" .test_level span").html(knowledge_score);
		var ele = "";
		if(knowledge_score >= 70){
			//$(_pageId+" .retry").show();
			$(_pageId+" .center").show();
			ele = "您的港股通交易适当性测评得分已达到70分，<span class=\"ared\">满足</span>开通条件。";
			$(_pageId+" .notice").show().html(ele);
			$(_pageId+" #confirm").show();
			$(_pageId+" #reTest").hide();
			knowledgeFlag = "1";
		}else{
			$(_pageId+" .center").hide();
			ele = "港股通交易适当性测评得分未达到70分，<span class=\"ared\">不满足</span>开通条件。";
			$(_pageId+" .notice").show().html(ele);
			$(_pageId+" #confirm").hide();
			$(_pageId+" #reTest").show();
			knowledgeFlag = "2";
		}
		appUtils.clearSStorage("knowledgeFlag");
		appUtils.setSStorageInfo("knowledgeFlag",knowledgeFlag);
	}
	
	/* 清理界面元素*/
	function cleanPageElement()
	{
		//$(_pageId+" .retry").hide();
		$(_pageId+" .center").hide();
		$(_pageId+" .notice").hide();
		$(_pageId+" #confirm").hide();
		$(_pageId+" #reTest").show();
	}
	
	var knowledgeInfo = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
	
	module.exports = knowledgeInfo;
});