/**
 * 主菜单
 */
define(function(require, exports, module){ 
	/* 私有业务模块的全局变量 begin */
	var appUtils = require("appUtils"),
		global = require("gconfig").global,
		layerUtils = require("layerUtils"),
		fundsFlag = "",  //资金状况 1 满足  2 不满足
		riskFlag = "",   //风险评测状况 1 满足  2 不满足 
		knowledgeFlag = "", //知识评测状况 1 满足  2 不满足
		shaFlag = "",	//沪A开立情况 1 满足  2 不满足
		_pageId = "#ggt_mainPage";
	var mobileService = require("mobileService");
	var external = require("external");
	var gconfig = require("gconfig");
	var common = require("common");
	var userInfo;
	var layerUtils = require("layerUtils");
	/* 私有业务模块的全局变量 end */
	
	function init()
	{
		common.hideTabBar();
		initHandle();
	}

	function initHandle(){
	   if(appUtils.getSStorageInfo("_prePageCode") != "index/index"){
			if(gconfig.platform != "0"){
				var user_id = external.callMessage({"key":"common_user_id","funcNo": "50041"}).results[0].value;
				if("" != user_id && null != user_id && undefined != user_id){
					appUtils.setSStorageInfo("user_id",user_id);
				}
				var curr_loginid = external.callMessage({"key":"curr_loginid","funcNo": "50041"}).results[0].value;
				if("" != curr_loginid && null != curr_loginid && undefined != curr_loginid){
					appUtils.setSStorageInfo("curr_loginid",curr_loginid);
				}
			}
		}
       queryGGTState();
  	}

	//查询沪港通满足条件的状态
	function queryGGTState(){
		var param = {
			"user_id":appUtils.getSStorageInfo("user_id"),
			"fundid":appUtils.getSStorageInfo("curr_loginid"),
			"isbind":"1"
		};
		mobileService.getGgtAuthority(param,function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no == "0") {
				accountInfoList = data.accountInfoList;
				zjList = data.zjList;
				otherInfo = data.otherInfo;
				getRiskInfo(accountInfoList,zjList);
				// 把是否是交易时间存到H5缓存中
				if(otherInfo[0].isTradeTime) {
					appUtils.setSStorageInfo("isTradeTime", otherInfo[0].isTradeTime);
				}
				// 把身份证状态是否可用存到H5缓存中
				if(otherInfo[0].idenddate_valid) {
					appUtils.setSStorageInfo("idenddate_valid", otherInfo[0].idenddate_valid);
				}
				// 总资产
				if(otherInfo[0].marketvalue) {
					appUtils.setSStorageInfo("totalValue", otherInfo[0].marketvalue);
				}
			}
			else{
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
				return false;
			}
		},{isShowWait:false});
	}

	//1----------------显示证券资产
	function showZqMoney(zjList){
		//查询证券总资产状况
		for(var i=0; i<zjList.length; i++) {
			//信用账户
			if(zjList[i].type == "3") {
				// 把资产总值存到H5缓存中
				if(zjList[0].marketvalue) {
					appUtils.setSStorageInfo("net_asset", zjList[0].net_asset);
				} else {
					appUtils.setSStorageInfo("net_asset", "0");
				}
			} else {
				appUtils.setSStorageInfo("net_asset", "0");
			}
			//证券账户
			if(zjList[i].type == "4"){
//				zjList[0].marketvalue = "500000";
				// 把资产总值存到H5缓存中
				if(zjList[0].marketvalue) {
					if(500000 > zjList[0].marketvalue){
						$(_pageId+" .must_list ul li:eq(0)").removeClass("over");
						$(_pageId+" .must_list ul li:eq(0)").addClass("lost");
						$(_pageId+" .must_list #funds").html("<span>"+zjList[0].marketvalue+"</span>证券类资产不足50万元人民币");
						$(_pageId+" #funds span").addClass("ared");
						fundsFlag = "2";
					}//资产总值大于等于500000
					else{
						$(_pageId+" .must_list ul li:eq(0)").removeClass("lost");
						$(_pageId+" .must_list ul li:eq(0)").addClass("over");
						$(_pageId+" .must_list #funds").html("<span>"+zjList[0].marketvalue+"</span>资金余额已满足");
						$(_pageId+" #funds span").removeClass("ared");
						fundsFlag = "1";
					}
					appUtils.setSStorageInfo("inter_marketvalue", zjList[0].marketvalue);
				} else {
					appUtils.setSStorageInfo("inter_marketvalue", "0");
				}
			}
		}
	}

	function getRiskInfo(accountInfoList,zjList){
		//接口未返回accountInfoList集合，默认没开沪A
		if(undefined == accountInfoList || "" == accountInfoList){
			$(_pageId+" .must_list").show();
			$(_pageId+" .success_main").hide();
			$(_pageId+" .must_list #openSha").html("上海A股证券账户未开立");
			$(_pageId+" .must_list ul li:eq(2)").removeClass("over");
			$(_pageId+" .must_list ul li:eq(2)").addClass("lost");
			$(_pageId+" #openSha span").addClass("ared");
			showZqMoney(zjList);
			getRiskAssessment();
		}
		else{
			// 把是否已有沪A股东户存到H5缓存中
			if(accountInfoList[0].sha_open) {
				appUtils.setSStorageInfo("sha_open", accountInfoList[0].sha_open);
			}
			// 把是否指定沪A存到H5缓存中
			if(accountInfoList[0].sha_bind) {
				appUtils.setSStorageInfo("sha_bind", accountInfoList[0].sha_bind);
			}
			// 把是否已开通沪港通权限存到H5缓存中
			if(accountInfoList[0].ggt_open) {
				appUtils.setSStorageInfo("ggt_open", accountInfoList[0].ggt_open);
			}
			// 把沪A股东帐号存到H5缓存中
			if(accountInfoList[0].sha_account) {
				appUtils.setSStorageInfo("sha_account", accountInfoList[0].sha_account);
			}
			if(accountInfoList[0].ggt_open == "1" && accountInfoList[0].ggt_bind == "1"){
				$(_pageId+" .must_list").hide();
				$(_pageId+ " .main .success_main").show();
				$(_pageId+ " .success_main .icon").show();
				$(_pageId+ " .success_main h5").html("开通成功");
				$(_pageId+ " .success_main p").hide();
				$(_pageId+ " #confirm").show();
				$(_pageId+" .top_title h3").html("港股通");
			}
			// 3--------显示沪A状态，没有沪A或者有沪A但是没有指定到券 跳转到失败页面
			else if(accountInfoList[0].sha_open == "0") {
				$(_pageId+" .must_list").show();
                $(_pageId+" .success_main").hide();
				$(_pageId+" .must_list #openSha").html("上海A股证券账户未开立");
				$(_pageId+" .must_list ul li:eq(2)").removeClass("over");
				$(_pageId+" .must_list ul li:eq(2)").addClass("lost");
				$(_pageId+" #openSha span").addClass("ared");
				shaFlag = "2";
				showZqMoney(zjList);
                getRiskAssessment();
			} else if(accountInfoList[0].sha_open == "1" && accountInfoList[0].sha_bind == "0") {
				$(_pageId+" .must_list").show();
                $(_pageId+" .success_main").hide();
				$(_pageId+" .must_list #openSha").html("上海A股证券账户未开立");
				$(_pageId+" .must_list ul li:eq(2)").removeClass("over");
				$(_pageId+" .must_list ul li:eq(2)").addClass("lost");
				$(_pageId+" #openSha span").addClass("ared");
				shaFlag = "2";
				showZqMoney(zjList);
                getRiskAssessment();
			} else {
				shaFlag = "1";
				//获取业务办理过程中的所有步骤的数据
				var ggtParam = {
					"user_id":appUtils.getSStorageInfo("user_id"),
					"trdaccount":accountInfoList[0].sha_account
				};
				mobileService.getGgtAllInfo(ggtParam, function(data) {
					var error_no = data.error_no;
					var error_info = data.error_info;
					var businessInfo = "";
					if(data.businessInfo !=undefined){
						businessInfo = data.businessInfo;
					}
					var fxcpInfo = data.fxcpInfo;
					var zscpInfo = data.zscpInfo;
					if(error_no == "0") {
						// 业务办理ID
						if(businessInfo[0].id) {
							appUtils.setSStorageInfo("businessId", businessInfo[0].id);
						}
						//港股通开立标志
						if(businessInfo[0].ggtopen_flag){
							appUtils.setSStorageInfo("ggtopen_flag",businessInfo[0].ggtopen_flag);
						}
						//开通港股通备注
						if(businessInfo[0].ggtopen_remark){
							appUtils.setSStorageInfo("ggtopen_remark",businessInfo[0].ggtopen_remark);
						}
						//开通港股通流水号
						if(businessInfo[0].order_no){
							appUtils.setSStorageInfo("order_no",businessInfo[0].order_no);
						}
						//业务办理状态
						if(businessInfo[0].state){
							appUtils.setSStorageInfo("state",businessInfo[0].state);
						}
						//协议签署
						if(businessInfo[0].sign){
							appUtils.setSStorageInfo("sign",businessInfo[0].sign);
						}
						//问卷回访
						if(businessInfo[0].return_visit){
							appUtils.setSStorageInfo("return_visit",businessInfo[0].return_visit);
						}
						//风险测评
						if(businessInfo[0].risk){
							appUtils.setSStorageInfo("risk",businessInfo[0].risk);
						}
						//诚信评测
						if(businessInfo[0].sincerity){
							appUtils.setSStorageInfo("sincerity",businessInfo[0].sincerity);
						}
						//知识评测
						if(businessInfo[0].knowledge){
							appUtils.setSStorageInfo("knowledge",businessInfo[0].knowledge);
						}
						//上传身份证
						if(businessInfo[0].upload_state){
							appUtils.setSStorageInfo("upload_state",businessInfo[0].upload_state);
						}
						//2------------显示风险评测等级
						if(fxcpInfo[0].risklevel) {
							appUtils.setSStorageInfo("risklevel",fxcpInfo[0].risklevel);
						}
						//业务办理状态
						var state = businessInfo[0].state;
						//state：1、前端流程走完，提交申请
						if("1" == state){
							$(_pageId+" .must_list").hide();
							$(_pageId+ " .main .success_main").show();
							$(_pageId+ " .success_main .icon").show();
							$(_pageId+ " .success_main h5").html("您的申请已提交，正在办理中");
							$(_pageId+ " .success_main p").hide();
							$(_pageId+ " #confirm").show();
							$(_pageId+" .top_title h3").html("港股通");
						}
						//state：2、后台审核未通过
						else if("2" == state){
							$(_pageId+" .must_list").hide();
							$(_pageId+ " .main .success_main").show();
							$(_pageId+ " .success_main .icon").hide();
							$(_pageId+ " .success_main h5").html("您的申请审核未通过");
							$(_pageId+ " .success_main p").hide();
							$(_pageId+ " #confirm").show();
							$(_pageId+" .top_title h3").html("港股通");
						}
						//state：4：业务办理失败
						else if("4" == state){
							$(_pageId+" .must_list").hide();
							$(_pageId+ " .main .success_main").show();
							$(_pageId+ " .success_main .icon").hide();
							$(_pageId+ " .success_main h5").html("港股通业务办理失败");
							$(_pageId+ " .success_main p").html("失败原因:"+businessInfo[0].ggtopen_remark);
							$(_pageId+ " #confirm").show();
							$(_pageId+" .top_title h3").html("港股通");
						}
						//state：5：业务办理通过
						else if("5" == state){
							$(_pageId+" .must_list").hide();
							$(_pageId+ " .main .success_main").show();
							$(_pageId+ " .success_main .icon").show();
							$(_pageId+ " .success_main h5").html("开通成功");
							$(_pageId+ " .success_main p").hide();
							$(_pageId+ " #confirm").show();
							$(_pageId+" .top_title h3").html("港股通");
						}
						else{
							//state：0或者返回对应流程的步骤，代表未开通港股通，未走完全部流程
							$(_pageId+" .must_list").show();
							$(_pageId+ " .main .success_main").hide();
							showZqMoney(zjList);
							$(_pageId+" .must_list #openSha").html("上海A股证券账户已开立");
							$(_pageId+" .must_list ul li:eq(2)").removeClass("lost");
							$(_pageId+" .must_list ul li:eq(2)").addClass("over");
							$(_pageId+" #openSha span").removeClass("ared");
							getKnowledgeRisk();
							var subitemname = fxcpInfo[0].subitemname;
							//4---------------显示风险测评等级名称
							if("" == subitemname || undefined == subitemname){
								appUtils.setSStorageInfo("inter_subitemname","");
								$(_pageId+" .must_list #riskTest").html("您还未做风险测评");
								riskFlag = "0";
							}
							else if("抗风险属性中" == subitemname || "抗风险属性高" == subitemname || "抗风险属性较高" == subitemname){
								appUtils.setSStorageInfo("inter_subitemname",subitemname);
								$(_pageId+" .must_list ul li:eq(3)").removeClass("lost");
								$(_pageId+" .must_list ul li:eq(3)").addClass("over");
								$(_pageId+" .must_list #riskTest").html("<span>"+subitemname+"</span>风险承受能力测评结果");
								riskFlag = "1";
							}
							else{
								appUtils.setSStorageInfo("inter_subitemname",subitemname);
								$(_pageId+" .must_list ul li:eq(3)").removeClass("over");
								$(_pageId+" .must_list ul li:eq(3)").addClass("lost");
								$(_pageId+" .must_list #riskTest").html("<span class=\"ared\">"+subitemname+"</span>风险承受能力测评结果");
								riskFlag = "2";
							}
						}
						//风险测评分数
						if(fxcpInfo[0].riskvalue) {
							appUtils.setSStorageInfo("riskvalue",fxcpInfo[0].riskvalue);
						}
						//风险评测状态
						if(fxcpInfo[0].status) {
							appUtils.setSStorageInfo("status",fxcpInfo[0].status);
						}
					} else {
//						layerUtils.iAlert(error_info,-1);
						layerUtils.iMsg(-1, error_info);
						return false;
					}
				},{isShowWait:false});
			}
			appUtils.setSStorageInfo("shaFlag",shaFlag);
		}
	}

	function getRiskAssessment(){
		var riskParam = {
			"user_id":appUtils.getSStorageInfo("user_id"),
			"fundid":appUtils.getSStorageInfo("curr_loginid"),
			"sub_id" :"1"		//1：风险测评
		};
		//查询风险测评结果
		mobileService.getSurveyInfo(riskParam,function(data){
			var results = data.results;
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no == "0") {
				var subitemname = results[0].subitemname;	//级别名称
				var riskvalue = results[0].riskvalue;	//分数
				appUtils.setSStorageInfo("inter_subitemname",subitemname);
				if("" == riskvalue || undefined == riskvalue){
					$(_pageId+" .must_list #riskTest").html("您还未做风险测评");
					riskFlag = "0";
				}
				else if("抗风险属性中" == subitemname || "抗风险属性高" == subitemname || "抗风险属性较高" == subitemname){
					$(_pageId+" .must_list ul li:eq(3)").removeClass("lost");
					$(_pageId+" .must_list ul li:eq(3)").addClass("over");
					$(_pageId+" .must_list #riskTest").html("<span>"+subitemname+"</span>风险承受能力测评结果");
					riskFlag = "1";
				}
				else{
					$(_pageId+" .must_list ul li:eq(3)").removeClass("over");
					$(_pageId+" .must_list ul li:eq(3)").addClass("lost");
					$(_pageId+" .must_list #riskTest").html("<span class=\"ared\">"+subitemname+"</span>风险承受能力测评结果");
					riskFlag = "2";
				}
				getKnowledgeRisk();
			}
			else{
				layerUtils.iMsg(-1,error_info);
				return false;
			}
		},{isShowWait:false});
	}


	//查询知识测评信息
	function getKnowledgeRisk(){
		var zsParam = {
			"user_id":appUtils.getSStorageInfo("user_id"),
			"fundid":appUtils.getSStorageInfo("curr_loginid"),
			"sub_id" :"3"		//3：沪港通业务知识测评
		};
		//查询知识测评结果
		mobileService.getSurveyInfo(zsParam,function(data){
			var results = data.results;
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no == "0") {
				var subitemname = results[0].results;	//级别名称
				var riskvalue = results[0].riskvalue;	//分数
//				var riskvalue = "80";	//分数
				if("" == riskvalue || undefined == riskvalue){
					$(_pageId+" .must_list #knowledgeTest").html("您还未做适当性测评");
					knowledgeFlag = "0";
					appUtils.clearSStorage("knowledgeFlag");
					appUtils.setSStorageInfo("knowledgeFlag","");
				}
				else if(70>riskvalue){
					$(_pageId+" .must_list ul li:eq(1)").addClass("lost");
					$(_pageId+" .must_list ul li:eq(1)").removeClass("over");
					$(_pageId+" #knowledgeTest span").addClass("ared");
					$(_pageId+" .must_list #knowledgeTest").html("<span class=\"ared\">"+riskvalue+"</span>适当性测评结果得分小于70");
					knowledgeFlag = "2";
					appUtils.clearSStorage("knowledgeFlag");
					appUtils.setSStorageInfo("knowledgeFlag","2");
				}
				else{
					$(_pageId+" .must_list ul li:eq(1)").removeClass("lost");
					$(_pageId+" .must_list ul li:eq(1)").addClass("over");
					$(_pageId+" #knowledgeTest span").removeClass("ared");
					$(_pageId+" .must_list #knowledgeTest").html("<span>"+riskvalue+"</span>适当性测评结果得分大于70分");
					$(_pageId+" .must_list #knowledgeTest").parent().addClass("over");
					knowledgeFlag = "1";
					appUtils.clearSStorage("knowledgeFlag");
					appUtils.setSStorageInfo("knowledgeFlag","1");
				}
				appUtils.clearSStorage("inter_knowledgeScore");
				appUtils.setSStorageInfo("inter_knowledgeScore",riskvalue);
				//判断提交沪港通权限按钮的功能
				if(fundsFlag == "1" && riskFlag == "1" && knowledgeFlag == "1" && shaFlag == "1"){
					changeStep();
					changeKnowStep();
					$(_pageId+" #submit").removeClass("disable");
					//绑定提交按钮,当所有条件都满足时，跳转到签署协议页面去签署协议
					appUtils.bindEvent($(_pageId+" #submit"),function(){
						appUtils.pageInit("ggt/mainPage","ggt/signProtocol",{});
					});
				}
			}
			else{
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
				return false;
			}
		},{isShowWait:false});
	}

	function changeKnowStep(){
		var param = {
			"user_id" : appUtils.getSStorageInfo("user_id"),
			"survey_type" : "2",
			"trdaccount" : appUtils.getSStorageInfo("sha_account")
		};
		//改变风险测评步骤
		mobileService.modifyQuesStep(param,function(data){
			var errorNo = data.error_no;
			var errorInfo = data.error_info;
			if(errorNo==0)	//调用成功,跳转到风险测评页面
			{
//				appUtils.pageInit("ggt/knowledge","ggt/knowledgeInfo",{"remark":riskvalue,"riskdesc":subitemname,"define_value":risklevel});
			}
			else
			{
				layerUtils.iMsg("-1",errorInfo);
				return false;
			}
		});
	}
	
	function changeStep(){
		var param = {
			"user_id" : appUtils.getSStorageInfo("user_id"),
			"survey_type" : "1",
			"trdaccount" : appUtils.getSStorageInfo("sha_account")
		};
		//改变风险测评步骤
		mobileService.modifyQuesStep(param,function(data){
			var errorNo = data.error_no;
			var errorInfo = data.error_info;
			if(errorNo==0)	//调用成功,跳转到风险测评页面
			{
//				appUtils.pageInit("ggt/riskAssessment","ggt/riskInfo",{"remark":riskvalue,"riskdesc":subitemname,"define_value":risklevel});
			}
			else
			{
				layerUtils.iMsg("-1",errorInfo);
				return false;
			}
		});	
	}
	
	function bindPageEvent()
	{
		//绑定资金菜单
		appUtils.bindEvent($(_pageId+" #funds"),function(){
			appUtils.pageInit("ggt/mainPage","ggt/netInfo",{});
		});
		//绑定风险等级测试
		appUtils.bindEvent($(_pageId+" #riskTest"),function(){
			if(!$(_pageId+" .must_list ul li:eq(2)").hasClass("over")){
				layerUtils.iAlert("您没有沪A或者沪A没有指定到券商，不能进行风险测评！");
				return false;
			}
			appUtils.pageInit("ggt/mainPage","ggt/riskAssessment",{});
		});
		//绑定知识测评
		appUtils.bindEvent($(_pageId+" #knowledgeTest"),function(){
			if(!$(_pageId+" .must_list ul li:eq(2)").hasClass("over")){
				layerUtils.iAlert("您没有沪A或者沪A没有指定到券商，不能进行适当性测评！");
				return false;
			}
			appUtils.pageInit("ggt/mainPage","ggt/knowledge",{});
		});

		//绑定确认按钮
		appUtils.bindEvent($(_pageId+" #confirm"), function(){
			appUtils.pageInit("ggt/mainPage", "index/index",{});
		});

		//绑定申请沪A
		appUtils.bindEvent($(_pageId+" #openSha"),function(){
//			appUtils.pageInit("ggt/mainPage","ggt/mainPage",{});
			if(!$(_pageId+" .must_list ul li:eq(2)").hasClass("over")){
				layerUtils.iAlert("敬请期待！");
			}
		});

		//处理返回
		appUtils.bindEvent($(_pageId+" .icon_back"),function(){
			if(appUtils.getSStorageInfo("_prePageCode") == "myAccount/index"){
				appUtils.pageInit("ggt/mainPage","myAccount/index",{});
			}else if(appUtils.getSStorageInfo("_prePageCode") == "index/index"){
				appUtils.pageInit("ggt/mainPage","index/index",{});
			}else{
				var param = {
					"funcNo":"50101",
					"moduleName":"home"
				};
				external.callMessage(param);
				common.showTabBar();
			}
		});

		//处理刷新按钮
		appUtils.bindEvent($(_pageId+" .icon_refresh"),function(){
			initHandle();
		});
	}
	
	function destroy()
	{
		mobileService.destroy();
	}

	
	/* 清理界面元素*/
	/*function cleanPageElement()
	{
		
	}*/
	
	var mainPage = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
	
	module.exports = mainPage;
});
