/**
 * 信用资产审核
 */
define(function(require, exports, module){ 
	/* 私有业务模块的全局变量 begin */
	var appUtils = require("appUtils"),
		global = require("gconfig").global,
		layerUtils = require("layerUtils"),
		marketvalue = "",  //证券账户资产
		net_asset = "",  //信用账户资产
		totalValue = "", //账户总资产
		fundsFlag = "",  //等于1的时候满足资金条件   等于2的时候不满足资金条件
		_pageId = "#ggt_netInfo";
	var mobileService = require("mobileService");
	var external = require("external");
	/* 私有业务模块的全局变量 end */
	
	function init()
	{
		var _prePageCode = appUtils.getSStorageInfo("_prePageCode");
		//港股通首页
		if("ggt/mainPage" == _prePageCode){
			marketvalue = appUtils.getSStorageInfo("inter_marketvalue") == "" ? 0 : appUtils.getSStorageInfo("inter_marketvalue");   //证券账户资产
			net_asset = appUtils.getSStorageInfo("net_asset") == "" ? 0 : appUtils.getSStorageInfo("net_asset");   //信用账户资产
			totalValue = appUtils.getSStorageInfo("totalValue") == "" ? 0 : appUtils.getSStorageInfo("totalValue"); //总资产
		}//充值结果页
		else if("ggt/rechargeResult" == _prePageCode){
			marketvalue = appUtils.getSStorageInfo("final_totalValue") == "" ? 0 : appUtils.getSStorageInfo("final_totalValue");   //证券账户资产
			net_asset = appUtils.getSStorageInfo("net_asset") == "" ? 0 : appUtils.getSStorageInfo("net_asset");   //信用账户资产
			totalValue = parseFloat(marketvalue) + parseFloat(net_asset);   //总资产
		}
		appUtils.setSStorageInfo("final_totalValue",totalValue);
		$(_pageId+" .ver_value ul li:eq(0) strong").html(marketvalue);
		$(_pageId+" .ver_value ul li:eq(1) strong").html(net_asset);
		$(_pageId+" .value_box h5").html(totalValue);
		if(totalValue >= 500000){
			$(_pageId+" .ver_notice p").html("您的总资产已满足≥50万要求，请继续满足其他条件。");
			$(_pageId+" #confirm").show();
			$(_pageId+" #addFund").hide();
			fundsFlag = "1";
		}else{
			$(_pageId+" .ver_notice p").html("您的总资产未满足≥50万要求，暂时无法开通港股通业务。");
			$(_pageId+" #addFund").show();
			$(_pageId+" #confirm").hide();
			fundsFlag = "2";
		}
		appUtils.setSStorageInfo("fundsFlag",fundsFlag);
	}
	
	function bindPageEvent()
	{
		//绑定确认按钮
		appUtils.bindEvent($(_pageId+" #confirm"),function(){
			appUtils.setSStorageInfo("totalValue",totalValue);
			appUtils.pageInit("ggt/netInfo","ggt/mainPage",{});
		});
		
		//绑定返回按钮
		appUtils.bindEvent($(_pageId+" #cancel"),function(){
			appUtils.setSStorageInfo("totalValue",totalValue);
			appUtils.pageInit("ggt/netInfo","ggt/mainPage",{});
		});
		
		//绑定返回
		appUtils.bindEvent($(_pageId+" .icon_back"),function(){
			appUtils.pageInit("ggt/netInfo","ggt/mainPage");
		});
		
		//绑定home键 跳转到主界面
		appUtils.bindEvent($(_pageId+" .icon_home"), function(){
			var param = {
				"funcNo":"50101",
				"moduleName":"main"
			};
			external.callMessage(param);
		});
		
		//绑定转入资金
		appUtils.bindEvent($(_pageId+" #addFund"),function(){
			appUtils.pageInit("ggt/netInfo","ggt/recharge",{});
		});
	}
	
	function destroy()
	{
		mobileService.destroy();
	}

	
	/* 清理界面元素*/
	function cleanPageElement()
	{
		
	}
	
	var netInfo = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
	
	module.exports = netInfo;
});
