define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var validatorUtil = require("validatorUtil");
	var layerUtils = require("layerUtils");
	var _pageId ="#ggt_recharge";
	var mobileService = require("mobileService");
	var external = require("external");
	var fund_account = null;

	function init() {
		//获取三方存管银行
		getThirdBank();
	}

	function bindPageEvent() {
		//绑定返回
		appUtils.bindEvent($(_pageId+" .icon_back"), function(){
			appUtils.pageBack();
		});
		// 提交密码
		appUtils.bindEvent($(_pageId+" .ce_btn"), function(){
			var money = $(_pageId+" #money").val();
			var pass = $(_pageId+" #bankcardPwd").val();
			if(money == ""){
				layerUtils.iAlert("转入金额不能为空！");
				return false;
			}
			if(!validatorUtil.isNumeric(money)){
				layerUtils.iAlert("转入金额格式不正确！");
				return false;
			}
			if(pass == ""){
				layerUtils.iAlert("银行密码不能为空！");
				return false;
			}
			mobileService.getRSAKey({}, function(data) {
				if( data.error_no==0)	//请求获取rsa公钥成功
				{
					//密码采用rsa加密
					var results = data.results[0];
					var modulus = results.modulus;
					var publicExponent =  results.publicExponent;
					var endecryptUtils = require("endecryptUtils");
					
					var bankpwd = endecryptUtils.rsaEncrypt(modulus, publicExponent, $(_pageId+" #bankcardPwd").val().trim());
					var handleMoney = {
						"user_id":appUtils.getSStorageInfo("user_id"),
						"zj_account":appUtils.getSStorageInfo("curr_loginid"), // 资金账号
						"bankNum":appUtils.getSStorageInfo("selectBankCard"), //银行卡号
						"money":$(_pageId+" #money").val(), //金额
						"password":bankpwd, //银行卡密码
						"flag":"0"  // 0充值 1提现
					};
					mobileService.handleMoney(handleMoney, function(data){
						var error_no = data.error_no;
						var error_info = data.error_info;
						if(error_no == "0") {
							appUtils.pageInit("ggt/recharge", "ggt/rechargeResult",{});
						}
						else{
//							layerUtils.iAlert(error_info);
							layerUtils.iMsg(-1, error_info);
							return false;
						}
					},false);
				}
				else
				{
					layerUtils.iLoading(false);
//					layerUtils.iAlert(data.error_info);
					layerUtils.iMsg(-1, error_info);
				}
			}, false);
		});
	}
	
	function destroy(){

	}
	
	//获取三方存管银行
	function getThirdBank(){
		var getBankList = {
			"user_id":appUtils.getSStorageInfo("user_id"),
			"zj_account":appUtils.getSStorageInfo("curr_loginid"),
			"flag_status":"1"
		};
		var itemElement = "";
		mobileService.getBankList(getBankList, function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			var results = data.results;
			if(undefined == results || "" == results || null == results){
				itemElement += "<div class=\"sele_bkvalue\"><a><img src="+"images/"+bankUrl+">未配置</a></div>";
				//显示资金账号绑定的主三方存管账号
				$(_pageId+" .sele_bank").html(itemElement);
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
				return false;
			}
			else{
				var length = results.length;
				if(error_no == "0" && length!=0){
					for(var i=0; i<length; i++) {
						var item = results[i];
	//						bank_code = item.bank_code,  // 银行代码
	//						bank_name = item.bank_name, //银行名称
	//						bank_url = item.bank_url, //银行图标的链接地址
	//						fund_account = item.fund_account, //资金账号
	//						account = item.account, //银行卡号
	//						bankid = item.id;//主键
						//0主卡,1辅卡
						if(item.is_main_card == "1") {
							var bankUrl = results[0].bank_url;
							var bank_account = results[0].account;
							appUtils.setSStorageInfo("selectBankCard",bank_account);
							itemElement += "<div class=\"sele_bkvalue\"><a><img src="+"images/"+bankUrl+">"+bank_account+"</a></div>";
	//						itemElement += "<li><div class='card_bg'> </div><div class='card_cont'><span class='card_spel'>主卡</span><dl class='card_info'> <dt> <img src="+"images/"+bank_url+"></dt> <dd><h5>"+bank_name+"</h5></dd></dl><div class='card_number'>"+account+"</div></div></li>";
						}  
					}
					//显示资金账号绑定的主三方存管账号
					$(_pageId+" .sele_bank").html(itemElement);
				} else {
//					layerUtils.iAlert(error_info);
					layerUtils.iMsg(-1, error_info);
					return false;
				}
			}
		});
	} 
	
	var recharge = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = recharge;
});
