/**
* 结果页
*/
define(function(require,exports,module){
	var appUtils = require("appUtils"),
		_pageId = "#ggt_rechargeResult";
	var mobileService = require("mobileService");
	var external = require("external");
	var layerUtils = require("layerUtils");
	
	function init(){
		var param = {
			"user_id":appUtils.getSStorageInfo("user_id"),
			"fundid":appUtils.getSStorageInfo("curr_loginid"),
			"isbind":"1"
		};
		//查询证券总资产
		mobileService.getGgtAuthority(param,function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no == "0") {
				accountInfoList = data.accountInfoList;
				zjList = data.zjList;
				otherInfo = data.otherInfo;
				// 总资产
				if(otherInfo[0].marketvalue) {
					appUtils.setSStorageInfo("final_totalValue",otherInfo[0].marketvalue);
					$(_pageId+" .left").html("您当前的证券账户总资产为："+otherInfo[0].marketvalue+"元。");
				}
			}
			else{
				layerUtils.iAlert(error_info);
				return false;
			}
		});
	}
	
	function bindPageEvent(){
		appUtils.bindEvent($(_pageId+" .ce_btn"),function(){
			appUtils.pageInit("ggt/rechargeResult","ggt/netInfo",{});
		});
		
		//绑定home键 跳转到主界面
		appUtils.bindEvent($(_pageId+" .icon_home"), function(){
			var param = {
				"funcNo":"50101",
				"moduleName":"main"
			};
			external.callMessage(param);
		});
	}
	
	function destroy(){
		mobileService.destroy();
	}
	
	var rechargeResult = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
	
	module.exports = rechargeResult;
});