/**
* 结果页
*/
define(function(require,exports,module){
	var appUtils = require("appUtils"),
		global = require("gconfig").global,
		_pageId = "#ggt_result";
	var mobileService = require("mobileService");
	var external = require("external");
	
	function init(){
		//初始化页面
		initPage();
	}
	
	function bindPageEvent(){
		//绑定确认按钮
		appUtils.bindEvent($(_pageId+" #confirm"), function(){
			appUtils.pageInit("ggt/result", "index/index",{});
		});

		//绑定返回按钮
		appUtils.bindEvent($(_pageId+" .icon_back"), function(){
			 appUtils.pageInit("ggt/result", "index/index",{});
		});

		//绑定home键 跳转到主界面
		appUtils.bindEvent($(_pageId+" .icon_home"), function(){
			var param = {
				"funcNo":"50101",
				"moduleName":"index"
			};
			external.callMessage(param);
		});
	}
	
	//初始化页面
	function initPage() {
		//获取业务办理过程中的所有步骤的数据
		var ggtParam = {
			"user_id":appUtils.getSStorageInfo("user_id"),
			"trdaccount":appUtils.getSStorageInfo("sha_account")
		};
		mobileService.getGgtAllInfo(ggtParam, function(data) {
			var error_no = data.error_no;
			var error_info = data.error_info;
			businessInfo = data.businessInfo;
			if(error_no == "0") {
				//业务办理状态
				var state = businessInfo[0].state;
				//state：1、前端流程走完，提交申请
				if("1" == state){
					$(_pageId+" .must_list").hide();
					$(_pageId+ " .main .success_main").show();
					$(_pageId+ " .success_main .icon").show();
					$(_pageId+ " .success_main h5").html("您的申请已提交，正在办理中");
					$(_pageId+ " .success_main p").hide();
					$(_pageId+ " #confirm").show();
				}
				//state：2、后台审核未通过
				else if("2" == state){
					$(_pageId+" .must_list").hide();
					$(_pageId+ " .main .success_main").show();
					$(_pageId+ " .success_main .icon").hide();
					$(_pageId+ " .success_main h5").html("您的申请审核未通过");
					$(_pageId+ " .success_main p").hide();
					$(_pageId+ " #confirm").show();
				}
				//state：4：业务办理失败
				else if("4" == state){
					$(_pageId+" .must_list").hide();
					$(_pageId+ " .main .success_main").show();
					$(_pageId+ " .success_main .icon").hide();
					$(_pageId+ " .success_main h5").html("港股通业务办理失败");
					$(_pageId+ " .success_main p").html("失败原因:"+businessInfo[0].ggtopen_remark);
					$(_pageId+ " #confirm").show();
				}
				//state：5：业务办理通过
				else if("5" == state){
					$(_pageId+" .must_list").hide();
					$(_pageId+ " .main .success_main").show();
					$(_pageId+ " .success_main .icon").show();
					$(_pageId+ " .success_main h5").html("开通成功");
					$(_pageId+ " .success_main p").hide();
					$(_pageId+ " #confirm").show();
				}
			} else {
				layerUtils.iAlert(error_info,-1);
				return false;
			}
		},{isShowWait:false});
	}
	
//	function cleanPageInfo() {
//		$(_pageId+" .result_main h5").html("提交成功");
//		$(_pageId+" .result_main p").show();
//	}
	
	function destroy(){
		mobileService.destroy();
	}
	
	var result = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
	
	module.exports = result;
});