/*
 * 风险测评信息
 */
define(function(require, exports, module){ 
	/* 私有业务模块的全局变量 begin */
	var appUtils = require("appUtils"),
		global = require("gconfig").global,
		layerUtils = require("layerUtils"),
		survey_score = "",  //风险等级数字评分
		riskFlag = "",  //1表示满足风险评测等级，2表示不满足
		rating_lvl_name = "",  //风险评测等级
		_pageId = "#ggt_riskInfo";
	var mobileService = require("mobileService");
	var external = require("external");
	/* 私有业务模块的全局变量 end */
	
	function init()
	{
		cleanPageElement();
		//初始化处理
		initHandle();
	}
	
	function bindPageEvent()
	{
		//绑定确认键
		appUtils.bindEvent($(_pageId+" #confirm"),function(){
			if(!$(this).hasClass("disable")){
				appUtils.setSStorageInfo("subitemname",rating_lvl_name);
				appUtils.pageInit("ggt/riskInfo","ggt/mainPage",{});
			}
		});
		
		//绑定重新评测按钮
		appUtils.bindEvent($(_pageId+" #reTest"),function(){
			appUtils.pageInit("ggt/riskInfo","ggt/riskAssessment",{});
		});

		//绑定重新评测按钮
		appUtils.bindEvent($(_pageId+" .center"),function(){
			appUtils.pageInit("ggt/riskInfo","ggt/riskAssessment",{});
		});

		//绑定返回按钮
		appUtils.bindEvent($(_pageId+" .icon_back"),function(){
			appUtils.setSStorageInfo("subitemname",rating_lvl_name);
			appUtils.pageInit("ggt/riskInfo","ggt/riskAssessment",{});
		});

		//绑定重新评测按钮
		appUtils.bindEvent($(_pageId+" #testAgain"),function(){
			appUtils.pageInit("ggt/riskInfo","ggt/riskAssessment",{});
		});
		
		//绑定home键 跳转到主界面
		appUtils.bindEvent($(_pageId+" .icon_home"), function(){
			var param = {
				"funcNo":"50101",
				"moduleName":"main"
			};
			external.callMessage(param);
		});
	}
	
	function destroy()
	{
		mobileService.destroy();
	}

	//初始化处理
	function initHandle(){
		var _prePageCode = appUtils.getSStorageInfo("_prePageCode");
		survey_score = appUtils.getSStorageInfo("riskvalue"); //风险评测分数
		rating_lvl_name = appUtils.getSStorageInfo("subitemname");  //风险评测等级
		if(_prePageCode == "ggt/riskAssessment"){
			survey_score = appUtils.getPageParam("remark");
//			survey_score = "85";
			rating_lvl_name = appUtils.getPageParam("riskdesc");
		}
//		$(_pageId+" .chart_pic strong").html(survey_score);
//		$(_pageId+" .test_chart h1").html(rating_lvl_name);
		$(_pageId+" .test_level span").html(survey_score);
		var risk_level = "";
		//70-100抗风险属性高 65-70（含70）抗风险属性较高 60-65抗风险属性中 55-60（含60）抗风险属性较低 55（含55）抗风险属性低
		if("抗风险属性高" == rating_lvl_name){
			risk_level = "高";
		}else if("抗风险属性较高" == rating_lvl_name){
			risk_level = "较高";
		}else if("抗风险属性中" == rating_lvl_name){
			risk_level = "中";
		}
		else if("抗风险属性较低" == rating_lvl_name){
			risk_level = "较低";
		}else if("抗风险属性低" == rating_lvl_name){
			risk_level = "低";
		}
		$(_pageId+" .test_result h2").html("您的风险承受能力级别："+risk_level);
		//抗风险属性高，抗风险属性较高，抗风险属性中
		if("抗风险属性中" == rating_lvl_name || "抗风险属性高" == rating_lvl_name || "抗风险属性较高" == rating_lvl_name){
//			$(_pageId+" .retry").show();
			$(_pageId+" .center").show();
			$(_pageId+" .notice").hide();
			$(_pageId+" #confirm").show();
			if($(_pageId+" #confirm").hasClass("disable")){
				$(_pageId+" #confirm").removeClass("disable");
			}
			riskFlag = "1";
		}else{
			$(_pageId+" .notice").show();
			$(_pageId+" #confirm").show();
			$(_pageId+" #confirm").addClass("disable");
			$(_pageId+" .notice").html("您好，你的测评等级为"+rating_lvl_name+"，不利于后面综合评分，<a href='javascript:void(0);' id='testAgain'>请重新测评 ></a>");
			riskFlag = "2";
			appUtils.preBindEvent($(_pageId+" .notice"),$(_pageId+" .notice a"),function(e){
				appUtils.pageInit("ggt/riskInfo","ggt/riskAssessment",{});
				e.stopPropagation();
			});
		}
		appUtils.setSStorageInfo("riskFlag",riskFlag);
	}
	
	/* 清理界面元素*/
	function cleanPageElement()
	{
//		$(_pageId+" .retry").hide();
		$(_pageId+" .center").hide();
		$(_pageId+" .notice").show();
		$(_pageId+" #confirm").hide();
		$(_pageId+" #reTest").show();
	}
	
	var riskInfo = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
	
	module.exports = riskInfo;
});
