define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var validata = require("validatorUtil");
	var layerUtils = require("layerUtils");
	var _pageId ="#index_index";
	var mobileService = require("mobileService");
	var external = require("external");
	var common = require("common");
	var state = "";		//基金风险测评状态
	var isSign = "";	//电子签名约定书状态

	function init() {
		common.hideTabBar();
		$(_pageId+" .login_pop").hide();
		if(appUtils.getSStorageInfo("_prePageCode") != "myAccount/index"){
			if(gconfig.platform != "0"){
				var user_id = external.callMessage({"key":"common_user_id","funcNo": "50041"}).results[0].value;
				if("" != user_id && null != user_id && undefined != user_id){
					appUtils.setSStorageInfo("user_id",user_id);
				}
				var curr_loginid = external.callMessage({"key":"curr_loginid","funcNo": "50041"}).results[0].value;
				if("" != curr_loginid && null != curr_loginid && undefined != curr_loginid){
					appUtils.setSStorageInfo("curr_loginid",curr_loginid);
				}
			}
		}
	}
	
	function queryRiskState(){
		$(_pageId+" .login_pop").show();
		var param = {"user_id" : appUtils.getSStorageInfo("user_id")};
		mobileService.queryFundRiskState(param,function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			var results = data.results;
			if(error_no == "0" && results.length!=0){
				var status = data.results[0].status;				//基金风险测评开通状态:-1 已过期，0 未提交过 1-正常
				state = status;
				var message = data.results[0].message;				//状态描述:0：开通失败，1：开通成功
				$(_pageId+" .login_pop").hide();
				if("1" == state){
					appUtils.pageInit("index/index", "fund/signFundProtocol", {});
				}
				else if("0" == state){
					appUtils.pageInit("index/index", "fund/fundRiskAssessment", {});
				}
				else{
					appUtils.pageInit("index/index", "fund/fundRiskAssessment", {});
				}
			}else {
				$(_pageId+" .login_pop").hide();
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
				return false;
			}
		},{isShowWait:false});	
	}
	
	/* 查询是否开通现金宝 */
	function queryCashTreaInfo(){
		$(_pageId+" .login_pop").show();
		var param = {
			"user_id" : appUtils.getSStorageInfo("user_id"),
			"fund_account" : appUtils.getSStorageInfo("curr_loginid")
		};
		mobileService.queryCashTreasureInfo(param,function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no == "0" && data.results != undefined){
				var query_flag = data.results[0].query_flag;		//是否查询到数据:0：否，1：是
				//未开通现金宝则判断开通现金宝的条件是否满足
				if(query_flag == "0"){
					queryIsSignCasePro();
				}else{
					$(_pageId+" .login_pop").hide();
					//开通则直接跳到现金宝信息页面
					appUtils.pageInit("index/index","cashTreasure/cashTreasureInfo");
				}
			}else {
				$(_pageId+" .login_pop").hide();
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
				return false;
			}
		},{isShowWait:false});
	}
	
	/* 查询是否签署电子签名约定书 */
	function queryIsSignCasePro(){
		var param = {
			"user_id" : appUtils.getSStorageInfo("user_id"),
			"fund_account" : appUtils.getSStorageInfo("curr_loginid")
		};
		mobileService.queryIsSignCasePro(param,function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			var results = data.results;
			if(error_no == "0" && results.length!=0){
				var flag = data.results[0].flag;				//0、未签署  1、签署了
				//已签署，再判断是否做基金风险测评，没做过直接跳到风险测评页面，做过再判断是否开通98
				if("1" == flag){
					queryCashRiskStatus();
				}//未签署，先去签署电子签名约定书
				else if("0" == flag){
					$(_pageId+" .login_pop").hide();
					appUtils.pageInit("index/index", "cashTreasure/electronicSign", {}); 
				}else{
					$(_pageId+" .login_pop").hide();
					appUtils.pageInit("index/index", "cashTreasure/electronicSign", {});
				}
			}else{
				$(_pageId+" .login_pop").hide();
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
				return false;
			}
		},{isShowWait:false});	
	}
	
	/* 查询到现金宝是否做过基金风险测评 */
	function queryCashRiskStatus(){
		var param = {
			"user_id" : appUtils.getSStorageInfo("user_id"),
			"fund_account" : appUtils.getSStorageInfo("curr_loginid")
		};
		mobileService.queryCashRiskState(param,function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			var results = data.results;
			if(error_no == "0" && results.length!=0){
				var status = data.results[0].status;							//基金风险测评开通状态:-1 已过期，0 未提交过 1 正常
				var message = data.results[0].message;							//状态描述:0：开通失败，1：开通成功
				var grade_status = data.results[0].grade_status;				//0：用户风险等级小于基金风险等级 1：用户风险等级大于或等于基金风险等级
				//判断是否做过风险测评，状态是否是正常并且满足等级的
				if("1" == status && "1" == grade_status){
					queryIsOpenFund();
				}else{
					$(_pageId+" .login_pop").hide();
					appUtils.pageInit("index/index", "cashTreasure/fundRiskAssessment", {});
				}
			}else {
				$(_pageId+" .login_pop").hide();
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
				return false;
			}
		},{isShowWait:false});
	}
	
	/* 判断是否开过98基金  */
	function queryIsOpenFund(){
		 var param = {
			"user_id" : appUtils.getSStorageInfo("user_id"),
			"fund_account" : appUtils.getSStorageInfo("curr_loginid")
		};
		mobileService.queryIsOpenFundAccount(param,function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			var results = data.results;
			if(error_no == "0" && results.length!=0){
				$(_pageId+" .login_pop").hide();
				var flag = data.results[0].flag;							//0：未开通  1：已开通
				//已开通则直接去签署现金宝协议
				if("1" == flag){
					appUtils.setSStorageInfo("isOpenFundAccount","1")
					appUtils.pageInit("index/index", "cashTreasure/signCashTreaProtocol", {});
				}else{
					appUtils.setSStorageInfo("isOpenFundAccount","0")
					//否则先去开98基金
					appUtils.pageInit("index/index", "fund/signFundProtocol", {});
				}
			}else {
				$(_pageId+" .login_pop").hide();
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
				return false;
			}
		},{isShowWait:false});
	}
	
	function bindPageEvent() {
		  //绑定返回
       appUtils.bindEvent($(_pageId+" .icon_back"), function(){
       		$(_pageId+" .login_pop").hide();
       		if(appUtils.getSStorageInfo("_prePageCode") == "myAccount/index"){
				//跳转到我的账户首页
                appUtils.pageInit("index/index", "myAccount/index", {});
			}else{
				var param = {
					"funcNo":"50101",
					"moduleName":"home"
				};
				external.callMessage(param);
				common.showTabBar();
			}
        });
        
		//绑定港股通
		appUtils.bindEvent($(_pageId + " .ggt"), function(){
			common.hideTabBar();
			$(_pageId+" .login_pop").hide();
			appUtils.pageInit("index/index", "ggt/mainPage", {});
		});
		
		//绑定创业板
		appUtils.bindEvent($(_pageId + " .cyb"), function(){
			common.hideTabBar();
			$(_pageId+" .login_pop").hide();
			appUtils.pageInit("index/index", "cyb/index", {});
		});
		
		//绑定交易开通，判断是否登录，未登录跳到登录页面，已登录直接跳转至交易开通首页
		appUtils.bindEvent($(_pageId+" .tradeOpen"), function(){
			common.hideTabBar();
			$(_pageId+" .login_pop").hide();
			appUtils.pageInit("index/index", "editDelegate/editDelegate", {});
		});
		
		//绑定基金开户，判断是否做过基金风险测评，是则展示基金协议，否则做基金风险测评
		appUtils.bindEvent($(_pageId+" .fundOpen"), function(){
			common.hideTabBar();
			$(_pageId+" .login_pop").hide();
			appUtils.setSStorageInfo("identify","fund");
			queryRiskState();
		});
		
		// 绑定修改资金密码
		appUtils.bindEvent($(_pageId+" #alterFundPass"), function(){
			common.hideTabBar();
			$(_pageId+" .login_pop").hide();
			appUtils.setSStorageInfo("passType","fund");
			appUtils.pageInit("index/index", "myAccount/modifyPassword",{});
		});
		
		// 绑定修改交易密码
		appUtils.bindEvent($(_pageId+" #alterTradePass"), function(){
			common.hideTabBar();
			$(_pageId+" .login_pop").hide();
			appUtils.setSStorageInfo("passType","trade");
			appUtils.pageInit("index/index", "myAccount/modifyPassword",{});
		});

		// 绑定资料修改
		appUtils.bindEvent($(_pageId+" #modifyInfo"), function(){
			common.hideTabBar();
			$(_pageId+" .login_pop").hide();
			appUtils.pageInit("index/index", "myAccount/modifyPersonInfo",{});
		});

		// 绑定现金宝
		appUtils.bindEvent($(_pageId+" #cashTreasure"), function(){
			common.hideTabBar();
			$(_pageId+" .login_pop").hide();
			queryCashTreaInfo();
		});
	}

	function destroy(){
		mobileService.destroy();
	}
	
	var index = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = index;
});
