define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var layerUtils = require("layerUtils");
	var _pageId = "#login_login";
	var mobileService = require("mobileService");
	var external = require("external");
	var validatorUtil = require("validatorUtil");
	var moduleName = "";

	function init() {
		//var footer_height = $(_pageId + " footer").height();
		cleanPageElement();
//		$(_pageId+" .input_text .code_pic").attr("src",global.serverUrl+"/nImgServlet?key=1");
		var window_height = $(window).height();
		var main_height = window_height;
		$(_pageId + " .main").height(main_height);
		layerUtils.iLoading(false);  // 关闭等待层。。。
	}

	function bindPageEvent() {
		
		/* 点击页面其他元素隐藏下拉列表 */
		appUtils.bindEvent($(_pageId), function(e) {
			$(_pageId + " .ly_shadow").slideUp("fast"); // 隐藏下拉列表
			$(_pageId + " .main").css("height", "");
			e.stopPropagation(); // 阻止冒泡
		});
		
		appUtils.bindEvent($(_pageId + " .input_form #selectType"), function(e) {
			$(_pageId + " #loginWay ul li").removeClass("active");
			$(_pageId + " #loginWay").slideToggle("fast"); // 显示选择基金公司的下拉列表
			e.stopPropagation(); // 阻止冒泡
		});
		
		appUtils.bindEvent($(_pageId + " #loginWay ul li"), function(e) {
			$(this).addClass("active").siblings().removeClass("active");
			var bill_name = $(this).text(); //当前选中省份的值
			$(_pageId + " #selectType").text(bill_name); //将选中值赋给选择框
			$(_pageId + " #selectType").attr("loginId",$(this).attr("loginId")); //将选中值赋给选择框
			$(_pageId + " #loginWay").slideUp("fast"); //隐藏下拉框
			e.stopPropagation(); // 阻止冒泡
		});
		
		appUtils.bindEvent($(_pageId + " .btn_refresh"), function(){
			$(_pageId+" .input_text .code_pic").attr("src",global.serverUrl+"/nImgServlet?key="+Math.random());
		});
		
		appUtils.bindEvent($(_pageId + " .mobileNo"), function(){
			$(_pageId+" .txt:eq(0)").addClass("focus_txt");
			$(_pageId+" .txt:eq(1)").removeClass("focus_txt");
		});
		
		appUtils.bindEvent($(_pageId + " .password"), function(){
			$(_pageId+" .txt:eq(0)").removeClass("focus_txt");
			$(_pageId+" .txt:eq(1)").addClass("focus_txt");
		});
		
		//绑定删除已经输入的电话号码
		appUtils.bindEvent($(_pageId + " .txt_close"), function(){
			$(_pageId+" .mobileNo").attr("value","");
		});
		
		//点取消按钮跳转至业务办理首页
		appUtils.bindEvent($(_pageId + " .header .top_title"), function(){
			var param = {
				"funcNo":"50101",
				"moduleName":"index"
			};
			external.callMessage(param);
		});
		
		//绑定登陆
		appUtils.bindEvent($(_pageId + " .ce_btn a"), function(){
			var verify_code = $(_pageId+" .input_text .pic_code").val();
			var account = $(_pageId+" .mobileNo").val();
			var pass = $(_pageId+" .password").val();
			if("" == account){
				layerUtils.iMsg(-1,"资金账号不能为空！");
				return false;
			}
			if(!validatorUtil.isNumeric(account)){
				layerUtils.iMsg(-1,"资金账号不合法！");
				return false;
			}
			if("" == pass ){
				layerUtils.iMsg(-1,"密码不能为空！");
				return false;
			}
			if(pass.length!=6){
				layerUtils.iMsg(-1,"密码长度必须为6位！");
				return false;
			}
			var param = {
				"login_id":$(_pageId+" .mobileNo").val(),
				"pwd_value":$(_pageId+" .password").val(),
				"identity_num":"",
				"pwd_type":"4",
				"login_uid":"",
				"login_type":"4",
				"account_type" : $(_pageId + " .input_form #selectType").attr("loginId")				//登录账号类型
			}; 
			mobileService.login(param, function(data){
				var error_no = data.error_no;
				var error_info = data.error_info;
				if(error_no == "0") {
					var result = data.results[0];
					appUtils.setSStorageInfo("userInfo",JSON.stringify(data.results[0]));
					//user_id保存到session
					if(result.user_id) {
						appUtils.setSStorageInfo("user_id", result.user_id);
					}
					//登陆账号保存到session
					if(result.login_id) {
						appUtils.setSStorageInfo("login_id", result.login_id);
					}
					//证件类型保存到session
					if(result.identity_type) {
						appUtils.setSStorageInfo("identity_type", result.identity_type);
					}
					//证件号码保存到session
					if(result.identity_num) {
						appUtils.setSStorageInfo("identity_num", result.identity_num);
					}
					//姓名保存到session
					if(result.name) {
						appUtils.setSStorageInfo("name", result.name);
					}
					//是否是交易用户 保存到session
					if(result.is_trade) {
						appUtils.setSStorageInfo("is_trade", result.is_trade);
					}
					//交易账户保存到session
					if(result.trade_account) {
						appUtils.setSStorageInfo("trade_account", result.trade_account);
					}
					//昵称保存到session
					if(result.nick_name) {
						appUtils.setSStorageInfo("nick_name", result.nick_name);
					}
					//sex性别保存到session
					if(result.sex) {
						appUtils.setSStorageInfo("sex", result.sex);
					}
					//birthday生日保存到session
					if(result.birthday) {
						appUtils.setSStorageInfo("birthday", result.birthday);
					}
					//mobile手机保存到session
					if(result.mobile) {
						appUtils.setSStorageInfo("mobile", result.mobile);
					}
					//login_by_mobile手机绑定保存到session
					if(result.login_by_mobile) {
						appUtils.setSStorageInfo("login_by_mobile", result.login_by_mobile);
					}
					//email邮箱保存到session
					if(result.email) {
						appUtils.setSStorageInfo("email", result.email);
					}
					//login_by_email绑定邮箱保存到session
					if(result.login_by_email) {
						appUtils.setSStorageInfo("login_by_email", result.login_by_email);
					}
					//telephone固定电话绑定到session
					if(result.telephone) {
						appUtils.setSStorageInfo("telephone", result.telephone);
					}
					//address通信住址保存到session
					if(result.address) {
						appUtils.setSStorageInfo("address", result.address);
					}
					//post_code邮编保存到session
					if(result.post_code) {
						appUtils.setSStorageInfo("post_code", result.post_code);
					}
					//qq_microblog QQ微博账号保存到session
					if(result.qq_microblog) {
						appUtils.setSStorageInfo("qq_microblog", result.qq_microblog);
					}
					//sina_microblog 新浪微博账号保存到session
					if(result.sina_microblog) {
						appUtils.setSStorageInfo("sina_microblog", result.sina_microblog);
					}
					//QQ号保存到session
					if(result.qq) {
						appUtils.setSStorageInfo("qq", result.qq);
					}
					//wechat号保存到session
					if(result.wechat) {
						appUtils.setSStorageInfo("wechat", result.wechat);
					}
					//recommend_person推荐人保存到session
					if(result.recommend_person) {
						appUtils.setSStorageInfo("recommend_person", result.recommend_person);
					}
					//last_login_time上次登录时间保存到session
					if(result.last_login_time) {
						appUtils.setSStorageInfo("last_login_time", result.last_login_time);
					}
					//occupational职业保存到session
					if(result.occupational) {
						appUtils.setSStorageInfo("occupational", result.occupational);
					}
					//adapter学历保存到session
					if(result.adapter) {
						appUtils.setSStorageInfo("adapter", result.adapter);
					}
					//certuid证书用户id保存到session
					if(result.certuid) {
						appUtils.setSStorageInfo("certuid", result.certuid);
					}
					//branch_no营业部保存到session
					if(result.branch_no) {
						appUtils.setSStorageInfo("branch_no", result.branch_no);
					}
					//emergency_name应急联系人姓名保存到session
					if(result.emergency_name) {
						appUtils.setSStorageInfo("emergency_name", result.emergency_name);
					}
					//emergency_relation与应急联系人关系保存到session
					if(result.emergency_relation) {
						appUtils.setSStorageInfo("emergency_relation", result.emergency_relation);
					}
					//emergency_tel应急联系人固定电话保存到session
					if(result.emergency_tel) {
						appUtils.setSStorageInfo("emergency_tel", result.emergency_tel);
					}
					//emergency_mobile应急联系人手机保存到session
					if(result.emergency_mobile) {
						appUtils.setSStorageInfo("emergency_mobile", result.emergency_mobile);
					}
					//emergency_email应急联系人邮箱保存到session
					if(result.emergency_email) {
						appUtils.setSStorageInfo("emergency_email", result.emergency_email);
					}
					//authentication_state实名认证,绑定银行卡 保存到session
					if(result.authentication_state) {
						appUtils.setSStorageInfo("authentication_state", result.authentication_state);
					}
					//org_id机构ID(第三方接口)保存到session
					if(result.org_id) {
						appUtils.setSStorageInfo("org_id", result.org_id);
					}
					//emergency_address应急联系人联系地址保存到session
					if(result.emergency_address) {
						appUtils.setSStorageInfo("emergency_address", result.emergency_address);
					}
					//type_code类别代码保存到session
					if(result.type_code) {
						appUtils.setSStorageInfo("type_code", result.type_code);
					}
					//type_name类别名称保存到session
					if(result.type_name) {
						appUtils.setSStorageInfo("type_name", result.type_name);
					}
					//vip_level会员等级保存到session
					if(result.vip_level) {
						appUtils.setSStorageInfo("vip_level", result.vip_level);
					}
					//total_integration用户总积分保存到session
					if(result.total_integration) {
						appUtils.setSStorageInfo("total_integration", result.total_integration);
					}
					// curr_loginid 登录的证券资金账号
					if(result.curr_loginid) {
						appUtils.setSStorageInfo("curr_loginid", result.curr_loginid);
					}
					// curr_loginid 登录的信用资金账号
					if(result.credit_account) {
						appUtils.setSStorageInfo("credit_account", result.credit_account);
					}
					// 将jsessionid保存到session
					if(result.jsessionid) {
						appUtils.setSStorageInfo("jsessionid", result.jsessionid);
					}
					var loginId = $(_pageId + " #selectType").attr("loginId");
					if(loginId == "4"){
						appUtils.pageInit("login/login", "myAccount/index",{});
					}else if(loginId == "3"){
						appUtils.pageInit("login/login", "credit/creditAccount",{});
					}
				} else {
					layerUtils.iLoading(false);  // 关闭等待层。。。
					layerUtils.iAlert(error_info);
					return false;
				}
			});
		});
	}

	//初始化页面元素
	function cleanPageElement() {
		$(_pageId+" .mobileNo").attr("value","");
		$(_pageId+" .password").attr("value","");
	}

	function destroy(){
		$(_pageId+" .txt").removeClass("focus_txt");
		$(_pageId+" .mobileNo").val("");
		$(_pageId+" .password").val("");
	}
	
	var login = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = login;
});
