define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var gconfig = require("gconfig");
	var external = require("external");
	var _pageId ="#myAccount_index";
	var common = require("common");
	var mobileService = require("mobileService");
	var layerUtils = require("layerUtils");
	var sso = require("sso");
	var nativePluginService = require("nativePluginService");
	var gconfig = require("gconfig");
	var Map = require("map");
	var fundAccountMap = null;
	var isExsitSzaFund = false;
	var isExsitShaFund = false;
	var szaAccount = "";
	var shaAccount = "";

	function init() {
		fundAccountMap = new Map();
		common.showTabBar();
		cleanPageElement();
		getUserInfo();
	}

	function getUserInfo() {
		// 同步用户交易账号
		var param = {
			"user_id":appUtils.getSStorageInfo("user_id"),
			"zj_account":appUtils.getSStorageInfo("curr_loginid")
		};
		mobileService.syncTradeAccount(param, function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no == "0") {
				queryFundInfo();
			} else {
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
				errorDetailShow();
				return false;
			}
		},{isShowWait:false});
	}

	//报错页面信息显示--
	function errorDetailShow(){
		$(_pageId+" .fundaccount p").html("--");
		$(_pageId+" .shaacount p").html("--");
		$(_pageId+" .szaacount p").html("--");
		$(_pageId+" .jjaccount p").html("--");
		$(_pageId+" .lcaccount p:eq(0)").html("上海登记：--");
		$(_pageId+" .lcaccount p:eq(1)").html("深圳登记：--");
		$(_pageId+" .ggopen p").html("--");
		$(_pageId+" .branch p").html("--");
		$(_pageId+" .risk p").html("--");
		$(_pageId+" .kt_ul").html("<li>--</li>");
		$(_pageId+" .wk_ul").html("<li>--</li>");
	}

	//查询主辅资金账号信息
	function queryFundInfo(){
		var param = {
			"user_id":appUtils.getSStorageInfo("user_id"),
			"zj_account":appUtils.getSStorageInfo("curr_loginid"),
			"flag_status":"0",
			"account_type":"4"
		};
		mobileService.getBankList(param, function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			var results = data.results;
			var element = "";
			if(error_no == "0"){
				if(undefined == results || "" == results || "0" == results.length){
					element += "<p>"+appUtils.getSStorageInfo("curr_loginid")+"（未配置）存管银行：未配置</p>";
					$(_pageId+" .fundaccount:eq(0)").html("<span class=\"tit\">资金账户：</span>"+element);
					queryTradeInfo();
				}else{
					var fund_account = "";
					for(var i=0;i<results.length;i++){
						var is_main_card = results[i].is_main_card;		//0主卡,1辅卡
						var cardtype = "";
						fund_account = results[i].fund_account;		//资金账号
						var bank_name = data.results[i].bank_name == undefined || data.results[i].bank_name == "" ? "未配置" : data.results[i].bank_name;		//存管银行名称
						if("1" == is_main_card){
							cardtype = "主";
						}
						else if("0" == is_main_card){
							cardtype = "辅";
						}
						element += "<p>"+fund_account+"（"+cardtype+"） 存管银行："+bank_name+"</p>";
					}
					if(""!=fund_account){
						$(_pageId+" .fundaccount:eq(0)").show();
						$(_pageId+" .fundaccount:eq(0)").html("<span class=\"tit\">资金账户：</span>"+element);
					}
					queryTradeInfo();
				}
			} else {
//				element += "<p>"+appUtils.getSStorageInfo("curr_loginid")+"（未配置）存管银行：未配置</p>";
//				$(_pageId+" .fundaccount:eq(0)").html("<span class=\"tit\">资金账户：</span>"+element);
				$(_pageId+" .fundaccount p").html("--");
				queryTradeInfo();
				layerUtils.iLoading(false);  // 关闭等待层。。。
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
				return false;
			}
		},{isShowWait:false});
	}
	
	//查询证券交易信息
	function queryTradeInfo(){
		var param = {"user_id" : appUtils.getSStorageInfo("user_id")};
		mobileService.queryTradeInfo(param,function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			//证券账号信息
			var zqAccount = data.zqAccount;
			if(error_no == "0"){
				if(undefined == zqAccount || null == zqAccount || "" == zqAccount){
					queryBusinessInfo();
				}
				else{
					for(var i=0;i<zqAccount.length;i++){
						var stkbd = zqAccount[i].stkbd;			//交易板块类型
						var trdacct = zqAccount[i].trdacct;		//交易市场板块 （账号）
						//00=深圳A,01=深圳B,10=上海A,11=上海BG ：港股通  C：创业板
						if("00" == stkbd){
							$(_pageId+" .szaacount").show();
							$(_pageId+" .szaacount p").html(trdacct);
						}else if("10" == stkbd){
							$(_pageId+" .shaacount").show();
							$(_pageId+" .shaacount p").html(trdacct);
						}else if("G" == stkbd){
							$(_pageId+" .ggopen").show();
							$(_pageId+" .ggopen p").html(trdacct);
						}
					}
					queryBusinessInfo();
				}
			}
			else{
				layerUtils.iLoading(false);  // 关闭等待层。。。
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
				$(_pageId+" .shaacount p").html("--");
                $(_pageId+" .szaacount p").html("--");
                $(_pageId+" .ggopen p").html("--");
				return false;
			}
			//理财账号信息
			var lcAccount = data.lcAccount;
			if(error_no == "0"){
				if(undefined == lcAccount || null == lcAccount || "" == lcAccount){
				}
				else{
					for(var j=0;j<lcAccount.length;j++){
						var lc_stkbd = lcAccount[j].stkbd;						//交易板块类型
						var lc_trdacct = lcAccount[j].trdacct;					//交易市场板块 （账号）
						//98 ：深圳登记  99：上海登记
						if("99" == lc_stkbd){         				
							isExsitShaFund = true;
							shaAccount = lc_trdacct;
						}else if("98" == lc_stkbd){
							isExsitSzaFund = true;
							szaAccount = lc_trdacct; 							
						}
						//当板块类型不为98或者99的时候，再调查询数据字典接口匹配理财账户list里的基金账户信息
						else if("99" != lc_stkbd && "98" != lc_stkbd){
							fundAccountMap.put(lc_stkbd,lc_trdacct);
						}
					}
					showLcAccount();
					queryFundAccount(fundAccountMap);
				}
			}else{
				layerUtils.iLoading(false);  // 关闭等待层。。。
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
				$(_pageId+" .lcaccount p:eq(0)").html("上海登记：--");
                $(_pageId+" .lcaccount p:eq(1)").html("深圳登记：--");
				return false;
			}
		},{isShowWait:false});
	}
	
	function showLcAccount(){
		var headHtml = '<span class="tit">理财账户：</span>';
		var shaHtml = '<p>上海登记：无</p>';
		var szaHtml = '<p>深圳登记：无</p>';
		var innerHtml = "";
		if(isExsitShaFund){
			shaHtml = "<p>上海登记："+shaAccount+"</p>";
		}
		if(isExsitSzaFund){
			szaHtml = "<p>深圳登记："+szaAccount+"</p>";
		}
		var innerHtml = headHtml+shaHtml+szaHtml;
		$(_pageId+" .lcaccount").html(innerHtml);
		$(_pageId+" .lcaccount").show();
	}
	
	function queryFundAccount(fundAccountMap){
		var param = {
			"enum_type": "ygt_lc_trade_account"
		};
		mobileService.queryFundation(param, function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			var results = data.results;
			var innerHead = '<span class="tit">基金账户：</span>';
            var fundHtml = '<p>无</p>';
			var element = "";
			if(error_no == "0"){
				if(undefined !=  results){
					for(var k=0;k<results.length;k++){
						for(var account in fundAccountMap.keys()){
							if(results[k].item_value == fundAccountMap.keys()[account]){
								fundHtml = '';
								fundHtml += "<p>"+results[k].item_name+"："+fundAccountMap.get(fundAccountMap.keys()[account])+"</p>";
							}
						}
					}
					element = innerHead+fundHtml;
					$(_pageId+" .jjaccount").html(element);
					$(_pageId+" .jjaccount").show();
				}
			} else {
//				layerUtils.iAlert(error_info,-1);
				layerUtils.iMsg(-1, error_info);
				$(_pageId+" .jjaccount p").html("--");
				return false;
			}
		},{isShowWait:false});	
	}
	
	//查询已开通业务和未开通业务
	function queryBusinessInfo(){
		var param = {
			"enum_type": "ygt_limiit_third_type"
		};
		mobileService.queryFundation(param, function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			var item_results = data.results;
			var item_str = "";
			var finally_str = "";
			if(error_no == "0" && undefined != item_results){
				for(var i=0;i<item_results.length;i++){
					item_str += item_results[i].item_value+"_";
					finally_str = item_str.substring(0,item_str.length-1);
				}
				var param = {
					"user_id":appUtils.getSStorageInfo("user_id"),
					"fundid": appUtils.getSStorageInfo("curr_loginid"),
					"agmt_type_str":finally_str
				};
				mobileService.queryOpenLimit(param, function(data){
					var error_no = data.error_no;
					var error_info = data.error_info;
					var results = data.results;
					var kt_ele = "";
					var wkt_ele = "";
					if(error_no == "0"){
						if(undefined != results && results.length!=0){
							for(var k=0;k<item_results.length;k++){
								var item_name = item_results[k].item_name;
								var item_value = item_results[k].item_value;
								for(var j=0;j<results.length;j++){
									//先查询到已开通权限的类型编号，再去匹配数据字典中的类型名称
									var cust_agmt_type = results[j].cust_agmt_type; 			//开通类型
									if(cust_agmt_type == item_value){
										kt_ele +="<li business-id=\""+item_value+"\"><h5>"+item_name+"</h5><span class=\"opend\">已开通</span></li>";
										break;
									}
									else if(j == results.length -1){
										wkt_ele +="<li id=\"business"+item_value+"\" business-id=\""+item_value+"\"><h5>"+item_name+"</h5><span class=\"no_opend\">未开通</span></li>";
									}
									// 预绑定已有业务的未开通业务
									appUtils.preBindEvent($(_pageId+" .wk_ul"),"#business"+item_value,function(e){
										//港股通
										if("0l" == $(this).attr("business-id")){
											appUtils.pageInit("myAccount/index","ggt/mainPage");
										}else if("0A" == $(this).attr("business-id")){
											appUtils.pageInit("myAccount/index","cyb/index");
										}else if("0e" == $(this).attr("business-id")){
											appUtils.pageInit("myAccount/index","fxjs/stockTradeDredge");
										}
									});
								}
							}
							$(_pageId+" .kt_ul").html(kt_ele);
							$(_pageId+" .wk_ul").html(wkt_ele);
						}
						else{
							var all_wkt_ele = "";
							for(var k=0;k<item_results.length;k++){
								var item_name = item_results[k].item_name;
								var item_value = item_results[k].item_value;
								all_wkt_ele +="<li id=\"business"+item_value+"\" business-id=\""+item_value+"\"><h5>"+item_name+"</h5><span class=\"no_opend\">未开通</span></li>";
								// 预绑定已有业务的未开通业务
								appUtils.preBindEvent($(_pageId+" .wk_ul"),"#business"+item_value,function(e){
									//沪港通
									if("0l" == $(this).attr("business-id")){
										appUtils.pageInit("myAccount/index","ggt/mainPage");
									}else if("0A" == $(this).attr("business-id")){
										appUtils.pageInit("myAccount/index","cyb/index");
									}else if("0e" == $(this).attr("business-id")){
										appUtils.pageInit("myAccount/index","fxjs/stockTradeDredge");
									}
								});
							}
							$(_pageId+" .wk_ul").html(all_wkt_ele);
						}
					} else {
						layerUtils.iLoading(false);  // 关闭等待层。。。
//						layerUtils.iAlert(error_info);
						layerUtils.iMsg(-1, error_info);
						$(_pageId+" .kt_ul").html("<li>--</li>");
                        $(_pageId+" .wk_ul").html("<li>--</li>");
						return false;
					}
				},{isShowWait:false});
				queryBranch();
			} else {
				queryBranch();
				layerUtils.iLoading(false);  // 关闭等待层。。。
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
				$(_pageId+" .kt_ul").html("<li>--</li>");
                $(_pageId+" .wk_ul").html("<li>--</li>");
				return false;
			}
		},{isShowWait:false});
	}

	/*查询营业部信息*/
	function queryBranch(){
		var param = {"user_id":appUtils.getSStorageInfo("user_id")};
		mobileService.queryUserInfo(param,function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			var results = data.results;
			if(error_no == "0" && undefined != results){
				var branchname = results[0].branchname == "" || results[0].branchname == null || results[0].branchname == undefined ? "无" : results[0].branchname;
				$(_pageId+" .branch p").html(branchname);
				queryRiskInfo();
			}
			else{
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
				$(_pageId+" .branch p").html("--");
				queryRiskInfo();
			}
		},{isShowWait:false});
	}

	/*查询风险测评信息*/
	function queryRiskInfo(){
		var riskParam = {
			"user_id":appUtils.getSStorageInfo("user_id"),
			"fundid":appUtils.getSStorageInfo("curr_loginid"),
			"sub_id" :"1"		//1：风险测评
		};
		mobileService.getSurveyInfo(riskParam,function(data){
			var results = data.results;
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no == "0" && undefined != results) {
				var subitemname = results[0].subitemname;	//级别名称
				var riskvalue = results[0].riskvalue;	//分数
				if(null == subitemname || "" == subitemname || undefined == subitemname){
					$(_pageId+" .risk p").html("您还未做风险测评");
				}
				else{
					$(_pageId+" .risk p").html(subitemname);
				}
			}
			else{
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
				$(_pageId+" .risk p").html("--");
				return false;
			}
		},{isShowWait:false});
	}
	 
	function bindPageEvent() {
		//已开通业务
		appUtils.bindEvent($(_pageId + " .ykli"), function(){
			 $(this).children("").addClass("active");
			 $(_pageId + " .wkli a").removeClass("active");
			 $(_pageId+" .kt_ul").show();
			 $(_pageId+" .wk_ul").hide();
		});
		
		//未开通业务
		appUtils.bindEvent($(_pageId + " .wkli"), function(){
			 $(this).children("").addClass("active");
			 $(_pageId + " .ykli a").removeClass("active");
			 $(_pageId+" .wk_ul").show();
			 $(_pageId+" .kt_ul").hide();
		});
		
		// 绑定返回
		appUtils.bindEvent($(_pageId+" .icon_back"), function(e){
			external.callMessage({"moduleName":"home","funcNo": "50101"});
			e.stopPropagation();
		});
		
		// 绑定我的头像
		appUtils.bindEvent($(_pageId+" .sm_head img"), function(){
			common.hideTabBar();
			appUtils.pageInit("myAccount/index", "myAccount/personInfoIndex",{});
		});
		
		// 绑定业务办理
		appUtils.bindEvent($(_pageId+" .busiTransact"), function(){
			common.hideTabBar();
			appUtils.pageInit("myAccount/index", "index/index",{});
		});
		
		// 绑定修改委托方式
		appUtils.bindEvent($(_pageId+" .wtfs"), function(){
			common.hideTabBar();
			appUtils.pageInit("myAccount/index", "editDelegate/editDelegate", {});
		});
		
		// 绑定我的资产
		appUtils.bindEvent($(_pageId+" #myAsset"), function(){
			common.hideTabBar();
			appUtils.pageInit("myAccount/index", "asset/index", {});
		});
		
		// 绑定对账单
		appUtils.bindEvent($(_pageId+" #bill"), function(){
			common.hideTabBar();
			appUtils.pageInit("myAccount/index", "asset/bills", {});
		});
		
		// 绑定风险测评
		appUtils.bindEvent($(_pageId+" .risk"), function(){
			common.hideTabBar();
			appUtils.pageInit("myAccount/index", "myAccount/riskAssessment", {});
		});
		
		// 绑定消息
		appUtils.bindEvent($(_pageId+" #message"), function(){
			external.callMessage({"funcNo": "50040", "key": "index_model", "value": "me"});
			common.hideTabBar();
			appUtils.pageInit("myAccount/index", "myAccount/message", {});
		});
		
		// 绑定设置
		appUtils.bindEvent($(_pageId+" #set"), function(){
			//打开原生设置模块
            var param = {
            	"funcNo":"50101",
            	"moduleName":"setting"
            };
            external.callMessage(param);
		});

		//证券交易
		appUtils.bindEvent($(_pageId+" #zqjy"), function(e){
			appUtils.setSStorageInfo("tab_type","stock_tab");
			//普通交易首页模块
			external.callMessage({"funcNo": "50040", "key": "trade_module", "value": "stock"});
			var stock_account = nativePluginService.function50041({"key":"COMMON_LOGIN_STATE"}).results[0].value;		//1、已登录
			if("1" == stock_account){
				appUtils.pageInit("myAccount/index", "myAccount/index", {});
			}
		});

		// 绑定融资融券
		appUtils.bindEvent($(_pageId+" #rzrq"), function(){
			appUtils.setSStorageInfo("tab_type","credit_tab");
			// 信用首页模块
            external.callMessage({"funcNo": "50040", "key": "trade_module", "value": "credit"});
		  	var credit_accouont = nativePluginService.function50041({"key":"CREDIT_LOGIN_STATE"}).results[0].value;     	//1、已登录
		  	if("1" == credit_accouont){
				appUtils.pageInit("myAccount/index", "credit/creditAccount", {});
		 	}else{
//				layerUtils.iAlert("您还没有登录信用账户，请先登录！","0",function(){
					appUtils.pageInit("myAccount/index", "credit/creditAccount", {});
//				});
		  	}
		});
		
		// 绑定个股期权
		appUtils.bindEvent($(_pageId+" #gg"), function(){
			//layerUtils.iMsg(-1, "敬请期待！");
		});
		
		// 绑定otc
		appUtils.bindEvent($(_pageId+" #otc"), function(){
			//layerUtils.iMsg(-1, "敬请期待！");
		});
		
		//注销事件
		appUtils.bindEvent($(_pageId +" .top_title #logout"), function(e){
			var tipStr = "<div class=\"pop_main\" style=\"height: 50px;margin-top: 20px;font-size:0.15rem\"><div>确定退出当前登录账号?</div></div>";
			common.btnConfirm(tipStr,function success(){
			   	layerUtils.iLoading(false);  // 关闭等待层。。。
				appUtils.clearRequest();
				appUtils.clearSStorage(true);
				nativePluginService.function50040({"key": "logining_time", "value": -20000.5});
				require("sso").ssoLoginOut();
			},function fail(){
			});
		});
	}

	function cleanPageElement(){
		appUtils.setSStorageInfo("tab_type","stock_tab");
		//普通首页模块
        external.callMessage({"funcNo": "50040", "key": "trade_module", "value": "stock"});
		var hg = $(window).height() - 44; //页面高度减去需要固定部分的高度
		$(_pageId + " .main").css("height", hg + "px");
		$(_pageId + " .main").css("overflow-y", "auto");
		$(_pageId+" .kt_ul").html("");
        $(_pageId+" .wk_ul").html("");
        if(gconfig.platform != "0"){
			var user_id = external.callMessage({"key":"common_user_id","funcNo": "50041"}).results[0].value;
			if("" != user_id && null != user_id && undefined != user_id){
				appUtils.setSStorageInfo("user_id",user_id);
			}
			var curr_loginid = external.callMessage({"key":"curr_loginid","funcNo": "50041"}).results[0].value;
			if("" != curr_loginid && null != curr_loginid && undefined != curr_loginid){
				appUtils.setSStorageInfo("curr_loginid",curr_loginid);
			}
		}
	}

	function destroy(){
		external.callMessage({"funcNo": "50040", "key": "trade_module", "value": ""});
		mobileService.destroy();
	}
	
	var index = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = index;
});
