define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var layerUtils = require("layerUtils");
	var _pageId ="#myAccount_messageDetail";
	var mobileService = require("mobileService");
	var common = require("common");
	var title_id = "";
	var messageSign = "";
	var external = require("external");
	 
	function init() {
		common.cleanPageElement(_pageId);
		var _prePageCode = appUtils.getSStorageInfo("_prePageCode");
		if("myAccount/message" == _prePageCode){
			title_id = appUtils.getPageParam("title_id");
			messageSign = appUtils.getPageParam("messageSign");
		}
		else{
			title_id = appUtils.getSStorageInfo("title_id");
			messageSign = appUtils.getSStorageInfo("messageSign");
		}
		//显示相对应的内容
		if("notice" == messageSign){
			showNoticeContent();
		}else if("inform" == messageSign){
			showInformContent();
		}
		else if("priLetter" == messageSign){
			showPrivateLetterContent();
		}
	}
	
	//查询公告内容
	function showNoticeContent(){
		var param = {
			"id" : title_id,
		}
		mobileService.queryNoticeContent(param,function(data){
			if(data.error_no == "0")
			{
				var create_date = data.results[0].create_date;	//创建时间
				var final_date = create_date.split(" ")[0];	//创建日期
				var final_time = (create_date.split(" ")[1]).substr(0,5);	//创建日期
				$(_pageId+" #title").text(data.results[0].title);
				$(_pageId+" #date span:eq(0)").html(final_date);
				$(_pageId+" #date span:eq(1)").html(final_time);
				$(_pageId+" #content").html(data.results[0].content);
			}
			else
			{
//				layerUtils.iAlert(data.error_info);
				layerUtils.iMsg(-1, data.error_info);
			}
		},{isShowWait:false});		
	}
	
	//查询通知内容
	function showInformContent(){
		var param = {
			"id" : title_id,
		}
		mobileService.queryInformContent(param,function(data){
			if(data.error_no == "0")
			{
				var create_date = data.results[0].create_date;	//创建时间
				var final_date = create_date.split(" ")[0];	//创建日期
				var final_time = (create_date.split(" ")[1]).substr(0,5);	//创建日期
				$(_pageId+" #title").text(data.results[0].title);
				$(_pageId+" #date span:eq(0)").html(final_date);
				$(_pageId+" #date span:eq(1)").html(final_time);
				$(_pageId+" #content").html(data.results[0].content);
			}
			else
			{
//				layerUtils.iAlert(data.error_info);
				layerUtils.iMsg(-1, data.error_info);
			}
		},{isShowWait:false});		
	}
	
	//查询私信内容
	function showPrivateLetterContent(){
		var param = {
			"id" : title_id,
		}
		mobileService.queryPriLetter(param,function(data){
			if(data.error_no == "0")
			{
				var create_date = data.results[0].create_date;	//创建时间
				var final_date = create_date.split(" ")[0];	//创建日期
				var final_time = (create_date.split(" ")[1]).substr(0,5);	//创建日期
				$(_pageId+" #title").text(data.results[0].title);
				$(_pageId+" #date span:eq(0)").html(final_date);
				$(_pageId+" #date span:eq(1)").html(final_time);
				$(_pageId+" #content").html(data.results[0].content);
			}
			else
			{
//				layerUtils.iAlert(data.error_info);
				layerUtils.iMsg(-1, data.error_info);
			}
		},{isShowWait:false});		
	}
	
	function bindPageEvent() {
		//绑定返回
		appUtils.bindEvent($(_pageId+" .icon_back"), function(){
			appUtils.pageBack();
		});
		//绑定刷新
		appUtils.bindEvent($(_pageId+" .icon_refresh"), function(){
			init();
		});
	}
	
	function destroy() {

	}
	 
	var messageDetail = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = messageDetail;
});
