define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var validata = require("validatorUtil");
	var layerUtils = require("layerUtils");
	var _pageId ="#myAccount_modifyAddress";
	var mobileService = require("mobileService");
	var external = require("external");
	var	provinceList = "", //省份
		cityList = ""; //城市

	function init() {
		cleanPageElement();
		getBranch();
	}
	
	/* 获取营业部List */
	function getBranch() {
		mobileService.queryBrachInfo({}, function(data) {
			var error_no = data.error_no;
			var error_info = data.error_info;
			if (error_no == "0" && data.dsName) {
				provinceList = data.provinceList; //省份集合
				cityList = data.cityList; 		  //城市集合
				var plen = provinceList.length,
					clen = cityList.length;
				var pro_str = "",
					provinceno = "",
					provincename = "";
				// 遍历省份集合
				for (var i = 0; i < plen; i++) {
					provinceno = provinceList[i].provinceno; // 省份id
					provincename = provinceList[i].provincename; // 省份名称
					pro_str += "<li pid='" + provinceno + "'><span>" + provincename + "</span></li>";
					var city_str = "",
						pid = "",
						cityno = "",
						cityname = "";
					for (var j = 0; j < clen; j++) {
						pid = cityList[j].provincenno;
						cityno = cityList[j].cityno;
						cityname = cityList[j].cityname;
						if (pid == provinceno) {
							city_str += "<li cid='" + cityno + "'><span>" + cityname + "</span></li>";
						}
					}
					$(_pageId + " .city ul").html(city_str); // 填充城市下拉框
					bindCity(); //点击城市
				}
				$(_pageId + " .province ul").html(pro_str); // 填充省份下拉框
				bindProvince(); //点击省份
			} else {
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
				return false;
			}
		},{isShowWait:false});
	}
	
	/* 选中省份事件处理 */
	function bindProvince() {
		appUtils.bindEvent($(_pageId + " .province ul li"), function(e) {
			var pid = $(this).attr("pid");
			$(this).addClass("active").siblings().removeClass("active");
			var provincename = $(this).text(); //当前选中省份的值
			var sel_pname = $(_pageId + " .sel_province").text(); //上一次选中省份的值
			$(_pageId + " .sel_province").text(provincename); //将选中值赋给选择框
			appUtils.setSStorageInfo("provincename", provincename);
			$(_pageId + " .province").slideUp("fast"); //隐藏下拉框
			//再次点击相同省份,下级菜单不改变，否则重置
			if (provincename != sel_pname) {
				$(_pageId + " .sel_city").text("请选择城市");
			}
			var provincenno = ""; //省份ID
			var city_str = "";
			//选中省份立即填充相应城市
			for (var i = 0; i < cityList.length; i++) {
				provincenno = cityList[i].provincenno;
				cityno = cityList[i].cityno;
				cityname = cityList[i].cityname;
				if (pid == provincenno) //填充当前省份下的城市列表
				{
					city_str += "<li cid='" + cityno + "'><span>" + cityname + "</span></li>";
				}
			}
			$(_pageId + " .city ul").html(city_str); //填充城市下拉框
			e.stopPropagation(); // 阻止冒泡
			bindCity(); //点击城市
		});
	}

	/* 选中城市事件绑定 */
	function bindCity() {
		appUtils.bindEvent($(_pageId + " .city ul li"), function(e) {
			var cid = $(this).attr("cid");
			$(this).addClass("active").siblings().removeClass("active");
			var cityname = $(this).text(); //当前选择城市的值
			var sel_cname = $(_pageId + " .sel_city").text(); //上次选择城市的值
			$(_pageId + " .sel_city").text(cityname); //选中值赋给选择框
			appUtils.setSStorageInfo("cityname", cityname);
			$(_pageId + " .city").slideUp("fast"); //隐藏下拉框
		});
	}
	
	function bindPageEvent() {
		appUtils.bindEvent($(_pageId+" .icon_back"), function(){
			appUtils.pageBack();
		});
		
		/* 点击页面其他元素隐藏下拉列表 */
		appUtils.bindEvent($(_pageId), function(e) {
			$(_pageId + " .ly_shadow").slideUp("fast"); // 隐藏下拉列表
			e.stopPropagation(); // 阻止冒泡
		});

		/* 绑定选择省份 */
		appUtils.bindEvent($(_pageId + " .input_form .sel_province"), function(e) {
			$(_pageId + " .city").hide(); //隐藏城市列表
			$(_pageId + " .province ul li").removeClass("active");
			$(_pageId + " .province").slideToggle("fast"); // 显示选择省份的下拉列表
			e.stopPropagation(); // 阻止冒泡
		});

		/* 绑定选择城市 */
		appUtils.bindEvent($(_pageId + " .input_form .sel_city"), function(e) {
			$(_pageId + " .province").hide(); //隐藏省份列表
			$(_pageId + " .city ul li").removeClass("active");
			$(_pageId + " .city").slideToggle("fast"); // 显示选择城市的下拉列表
			e.stopPropagation(); // 阻止冒泡
		});
		
		/* 绑定下一步 */
		appUtils.bindEvent($(_pageId + " .ce_btn"), function() {
			var province_name = $(_pageId + " .input_form .sel_province").text();
			var city_name = $(_pageId + " .input_form .sel_city").text();
			var address = $(_pageId + " .input_form .address").val();
			if (province_name == "请选择省份") {
				layerUtils.iMsg(-1, "请先选择开户省份部");
				return false;
			}
			if (city_name == "请选择城市") {
				layerUtils.iMsg(-1, "请先选择开户城市");
				return false;
			}
			if (address == "") {
				layerUtils.iMsg(-1, "请先填写您的详细地址");
				return false;
			}
			//修改联系地址
			var param = {
				"user_id" : appUtils.getSStorageInfo("user_id"),		//user_id
				"post_code" : "",
				"address" : province_name+city_name+address,									//通信住址
				"update_third" : "1",									//提交第三方接口:0：不提交，1：提交
				"fundid" : appUtils.getSStorageInfo("curr_loginid")     //资金帐号:如果update_third为‘1’，则为必传参数
			};
			mobileService.modifyUserInfo(param, function(data){
				var error_no = data.error_no;
				var error_info = data.error_info;
				if(error_no == "0") {
					appUtils.clearSStorage("address");
					appUtils.setSStorageInfo("address",province_name+city_name+address);
					layerUtils.iAlert("您的联系地址已经修改成功!","0",function(){
						appUtils.pageInit("myAccount/modifyAddress", "myAccount/modifyPersonInfo",{});
					});	
				} else {
//					layerUtils.iAlert(error_info);
					layerUtils.iMsg(-1, error_info);
					return false;
				}
			});
		});
	}

	function cleanPageElement(){
		$(_pageId + " .input_form .sel_province").text("请选择省份");
		$(_pageId + " .input_form .sel_city").text("请选择城市");
		$(_pageId + " .input_form .address").val("");
	}
	
	function destroy(){
		mobileService.destroy();
	}
	
	var modifyAddress = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = modifyAddress;
});
