define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var validatorUtil = require("validatorUtil");
	var layerUtils = require("layerUtils");
	var _pageId ="#myAccount_modifyLinkMan";
	var mobileService = require("mobileService");
	var external = require("external");
	var common = require("common");
	var modifyParam={"idtype" : "","sex" : "","imetype":""};  //联系人证件类型,联系人性别,通讯类型
	

	function init() {
		cleanPageElement();
		queryIdType();
	}
	
	/* 获取证件类型、性别、通讯类型列表*/
	function queryIdType()
	{
		var param = {
			"enum_type": "idtype"
		};
		mobileService.queryFundation(param, function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			var item_results = data.results;
			var item_str = "";
			if(error_no == "0" && undefined != item_results){
				 for(var k=0;k<item_results.length;k++){
					var item_name = item_results[k].item_name;
					var item_value = item_results[k].item_value;
					item_str += "<li idtype='" + item_value + "'><span>" + item_name + "</span></li>";
				}
				$(_pageId+" #idType ul").html(item_str);
				bindIdType();
				querySex();
			} else {
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
				return false;
			}
		},{isShowWait:false});	
	}
	
	/* 选中证件类型事件处理 */
	function bindIdType() {
		appUtils.bindEvent($(_pageId + " #idType ul li"), function(e) {
			var idtype = $(this).attr("idtype");
			$(this).addClass("active").siblings().removeClass("active");
			var sel_iname = $(this).text(); //当前选中证件类型的值
			$(_pageId + " #selectIdType").text(sel_iname); //将选中值赋给选择框
			$(_pageId + " #idType").slideUp("fast"); //隐藏下拉框
			modifyParam.idtype = idtype;
			e.stopPropagation(); // 阻止冒泡
		});
	}
	
	/* 获取证件类型、性别、通讯类型列表*/
	function querySex()
	{
		var param = {
			"enum_type": "sex"
		};
		mobileService.queryFundation(param, function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			var item_results = data.results;
			var item_str = "";
			if(error_no == "0" && undefined != item_results){
				 for(var k=0;k<item_results.length;k++){
					var item_name = item_results[k].item_name;
					var item_value = item_results[k].item_value;
					item_str += "<li sex_id='" + item_value + "'><span>" + item_name + "</span></li>";
				}
				$(_pageId+" #sex ul").html(item_str);
				bindSelectSex();
			} else {
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
				return false;
			}
		},{isShowWait:false});	
	}
	
	/* 选中性别事件处理 */
	function bindSelectSex() {
		appUtils.bindEvent($(_pageId + " #sex ul li"), function(e) {
			var sex_id = $(this).attr("sex_id");
			$(this).addClass("active").siblings().removeClass("active");
			var sex_name = $(this).text(); //当前选中省份的值
			$(_pageId + " #selectSex").text(sex_name); //将选中值赋给选择框
			$(_pageId + " #sex").slideUp("fast"); //隐藏下拉框
			modifyParam.sex = sex_id;
			e.stopPropagation(); // 阻止冒泡
		});
	}
	
	/* 获取证件类型、性别、通讯类型列表*/
	function queryImeType()
	{
		var param = {
			"enum_type": "sex"
		};
		mobileService.queryFundation(param, function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			var item_results = data.results;
			var item_str = "";
			if(error_no == "0" && undefined != item_results){
				 for(var k=0;k<item_results.length;k++){
					var item_name = item_results[k].item_name;
					var item_value = item_results[k].item_value;
					item_str += "<li imetype='" + item_value + "'><span>" + item_name + "</span></li>";
				}
				$(_pageId+" #communication ul").html(item_str);
				bindImeType();
			} else {
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
				return false;
			}
		},{isShowWait:false});	
	}
	
	/* 选中通讯类型事件处理 */
	function bindImeType() {
		appUtils.bindEvent($(_pageId + " #communication ul li"), function(e) {
			var imetype = $(this).attr("imetype");
			$(this).addClass("active").siblings().removeClass("active");
			var inme_name = $(this).text(); //当前选中省份的值
			$(_pageId + " #selectCommunication").text(inme_name); //将选中值赋给选择框
			$(_pageId + " #communication").slideUp("fast"); //隐藏下拉框
			modifyParam.imetype = imetype;
			e.stopPropagation(); // 阻止冒泡
		});
	}
	
	function bindPageEvent() {
		// 绑定返回
		appUtils.bindEvent($(_pageId+" .icon_back"), function(){
			appUtils.pageBack();
		});

		/* 点击页面其他元素隐藏下拉列表 */
		appUtils.bindEvent($(_pageId), function(e) {
			$(_pageId + " .ly_shadow").slideUp("fast"); // 隐藏下拉列表
			e.stopPropagation(); // 阻止冒泡
		});
		
		/* 绑定选择证件类型 */
		appUtils.bindEvent($(_pageId + " .input_form #selectIdType"), function(e) {
			$(_pageId + " #sex").hide(); 			//隐藏性别列表
			$(_pageId + " #communication").hide(); //隐藏通讯类型
			$(_pageId + " #idType ul li").removeClass("active");
			$(_pageId + " #idType").slideToggle("fast"); // 显示证件类型的下拉列表
			e.stopPropagation(); // 阻止冒泡
		});

		/* 绑定选择性别 */
		appUtils.bindEvent($(_pageId + " .input_form #selectSex"), function(e) {
			$(_pageId + " #communication").hide(); //隐藏通讯类型
			$(_pageId + " #idType").hide(); 	   //隐藏证件类型
			$(_pageId + " #sex ul li").removeClass("active");
			$(_pageId + " #sex").slideToggle("fast"); // 显示性别的下拉列表
			e.stopPropagation(); // 阻止冒泡
		});
		
		/* 绑定选择即时通讯类型 */
		appUtils.bindEvent($(_pageId + " .input_form #selectCommunication"), function(e) {
			$(_pageId + " #idType").hide(); 	 //隐藏证件类型
			$(_pageId + " #sex").hide(); 		//隐藏性别列表
			$(_pageId + " #communication ul li").removeClass("active");
			$(_pageId + " #communication").slideToggle("fast"); // 显示选择城市的下拉列表
			e.stopPropagation(); // 阻止冒泡
		});
		
		/* 绑定联系人变更 */
		appUtils.bindEvent($(_pageId + " .ce_btn"), function(e) {
			if(validateInput()){
				submitLinkMan();  
			}
			e.stopPropagation(); // 阻止冒泡
		});
	}
	
	function cleanPageElement(){
		//设置证件类型默认为身份证
        modifyParam.idtype = "00";
		$(_pageId).css("display","");
		$(_pageId+" #name").val("");
		$(_pageId+" #selectIdType").text("身份证");
		$(_pageId+" #idCard").val("");
		$(_pageId+" #selectSex").text("请选择性别");
		$(_pageId+" #phone").val("");
		$(_pageId+" #email").val("");
		$(_pageId+" #address").val("");
		$(_pageId+" #postid").val("");
	}
	
	/*校验输入参数*/
	function validateInput(){
		var name = $(_pageId+" #name").val();
		var selectIdType = $(_pageId+" #selectIdType").text();
		var idCard = $(_pageId+" #idCard").val();
		var selectSex = $(_pageId+" #selectSex").text();
		var phone = $(_pageId+" #phone").val();
		var email = $(_pageId+" #email").val();
		var address = $(_pageId+" #address").val();
		var postid = $(_pageId+" #postid").val();
		var selectCommunication = $(_pageId+" #selectCommunication").text();
		var comPhone = $(_pageId+" #comPhone").val();
		if (name == "") {
			layerUtils.iMsg(-1, "请先填写联系人姓名!");
			return false;
		}
		if(!common.isCn(name)){
			layerUtils.iAlert("只能填写中文汉字！");
			return false;
		}
		if (selectIdType == "请选择证件类型") {
			layerUtils.iMsg(-1, "请先选择证件类型!");
			return false;
		}
		if (idCard == "") {
			layerUtils.iMsg(-1, "请先填写证件号码!");
			return false;
		}
		if (selectIdType == "身份证" && !validatorUtil.isCardID(idCard)) {
			layerUtils.iMsg(-1,"请输入正确的身份证号码!");
			return false;
		}
		if(phone!="" && !validatorUtil.isMobile(phone)){
			layerUtils.iMsg(-1, "您的手机号码格式不正确!");
			return false;
		}
		if(email!="" && !validatorUtil.isEmail(email)){
			layerUtils.iMsg(-1, "您的邮箱格式不正确!");
			return false;
		}
		return true;
	}
	
	/*开通基金账号*/
	function submitLinkMan(){ 
		var param = {
			"user_id" : appUtils.getSStorageInfo("user_id"),									//user_id
			"emergency_name" : $(_pageId+" #name").val(),										//联系人名称
			"emergency_idtype" : modifyParam.idtype, 											//证件类型
			"emergency_idno" : $(_pageId+" #idCard").val(),										//证件号码
			"emergency_sex" : modifyParam.sex,													//性别
			"emergency_mobile" : $(_pageId+" #phone").val(),									//手机号码
			"emergency_email" : $(_pageId+" #email").val(),										//邮箱
			"emergency_address" : $(_pageId+" #address").val(),									//地址
			"emergency_zip" : $(_pageId+" #postid").val(),										//邮编
			"emergency_imetype" : modifyParam.imetype,											//通讯类型
			"emergency_imename" : $(_pageId+" #comPhone").val(),								//通讯号码
		};
		mobileService.modifyUserInfo(param,function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no == "0"){
				appUtils.clearSStorage("emergency_name");
				appUtils.setSStorageInfo("emergency_name",param.emergency_name);
			 	layerUtils.iAlert("联系人变更成功!","0",function(){
					appUtils.pageInit("myAccount/modifyLinkMan", "myAccount/modifyPersonInfo",{});
				});	
			}else {
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
				return false;
			}
		},{isShowWait:false});	
	}
	
	function destroy(){
		mobileService.destroy();
	}
	
	var modifyLinkMan = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = modifyLinkMan;
});
