define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var platform = gconfig.platform;
	var validatorUtil = require("validatorUtil");
	var layerUtils = require("layerUtils");
	var passType = "fund";
	var typeName = "";
	var _pageId ="#myAccount_modifyPassword";
	var pageId = "myAccount_modifyPassword";
	var mobileService = require("mobileService");
	var external = require("external");

	function init() {
		if(platform == '0'){
			$(_pageId+" .input_form input").removeAttr("readonly");
		}
		passType = appUtils.getSStorageInfo("passType");
		var zj_account = appUtils.getSStorageInfo("curr_loginid");
		if("fund" == passType){
			typeName = "资金";
			$(_pageId+" .oriPass").attr("placeholder","请输入原资金密码");
			$(_pageId+" .newPass").attr("placeholder","请设置资金密码");
			$(_pageId+" .aginPass").attr("placeholder","请再次输入资金密码");
			$(_pageId+" .top_title h3").html("设置资金密码");
		}else if("trade" == passType){
			typeName = "交易";
			$(_pageId+" .oriPass").attr("placeholder","请输入原交易密码");
			$(_pageId+" .newPass").attr("placeholder","请设置交易密码");
			$(_pageId+" .aginPass").attr("placeholder","请再次输入交易密码");
			$(_pageId+" .top_title h3").html("设置交易密码");
		}
		cleanPageElement();
//		$(_pageId+" .phone_tips").html("您正在修改"+zj_account+typeName+"密码");
	}

	function bindPageEvent() {
		// 绑定返回
		appUtils.bindEvent($(_pageId+" .icon_back"), function(){
			appUtils.pageBack();
		});

		//原来密码
		appUtils.bindEvent($(_pageId+" #oldPassword"),function(e){
			window.customKeyboardEvent = {
				keyBoardFinishFunction: function(){},
				keyBoardInputFunction: function(){
					if($(_pageId+" #oldPassword").val().length > 6){
						$(_pageId+" #oldPassword").val($(_pageId+" #oldPassword").val().substring(0,6));
					}
				}
			};
			external.callMessage({"moduleName":"ygt","funcNo": "50210", "pageId":"myAccount_modifyPassword", "eleId":"oldPassword", "doneLable":"done", "keyboardType":"3"});
			e.stopPropagation();
		},"click");

		//新密码
		appUtils.bindEvent($(_pageId+" #newPassword"),function(e){
			window.customKeyboardEvent = {
				keyBoardFinishFunction: function(){},
				keyBoardInputFunction: function(){
					if($(_pageId+" #newPassword").val().length > 6){
						$(_pageId+" #newPassword").val($(_pageId+" #newPassword").val().substring(0,6));
					}
				}
			};
			external.callMessage({"moduleName":"ygt","funcNo": "50210", "pageId":"myAccount_modifyPassword", "eleId":"newPassword", "doneLable":"done", "keyboardType":"3"});
			e.stopPropagation();
		},"click");

		//新密码确认
		appUtils.bindEvent($(_pageId+" #confirmPassword"),function(e){
			window.customKeyboardEvent = {
				keyBoardFinishFunction: function(){},
				keyBoardInputFunction: function(){
					if($(_pageId+" #confirmPassword").val().length > 6){
						$(_pageId+" #confirmPassword").val($(_pageId+" #confirmPassword").val().substring(0,6));
					}
				}
			};
			external.callMessage({"moduleName":"ygt","funcNo": "50210", "pageId":"myAccount_modifyPassword", "eleId":"confirmPassword", "doneLable":"done", "keyboardType":"3"});
			e.stopPropagation();
		},"click");

		//在点击非密码输入框关闭键盘
		appUtils.bindEvent($(_pageId),function(e){
			var tag = e.srcElement || e.target;
			if(tag.id!="oldPassword" && tag.id!="newPassword" && tag.id!="confirmPassword"){
				external.callMessage({"moduleName":"ygt","funcNo": "50211"});
			}
		  e.stopPropagation();
		},"click");

		// 提交密码
		appUtils.bindEvent($(_pageId+" .ce_btn"), function(){
			//提交密码之前先关闭数字键盘
			external.callMessage({"moduleName":"ygt","funcNo": "50211"});
			if(!validatePassword()){
				return false;
			}
			submitPass();
		});
	}


	/* 验证密码 6位数字 */
	function validatePassword()
	{
		var oriPass = $(_pageId+" .oriPass").val();
		var newPass = $(_pageId+" .newPass").val();
		var aginPass = $(_pageId+" .aginPass").val();
		if(oriPass == ""){
			layerUtils.iMsg(-1,"请输入原"+typeName+"密码！");
			return false;
		}
		if(!validatorUtil.isNumeric(oriPass)){
			layerUtils.iMsg(-1,"原"+typeName+"密码为6位数字！");
			return false;
		}
		if(oriPass.length!=6){
			layerUtils.iMsg(-1,"原"+typeName+"密码长度必须为6位！");
			return false;
		}
//		if(!validateCount(oriPass)){
//			return false;
//		}
		if(newPass == ""){
			layerUtils.iMsg(-1,"请输入新"+typeName+"密码！");
			return false;
		}
		if(!validatorUtil.isNumeric(newPass)){
			layerUtils.iMsg(-1,"新"+typeName+"密码为6位数字！");
			return false;
		}
		if(newPass.length!=6){
			layerUtils.iMsg(-1,"新"+typeName+"密码长度必须为6位！");
			return false;
		}
		if(!validateCount(newPass)){
			return false;
		}
		if(aginPass == ""){
			layerUtils.iMsg(-1,"确认"+typeName+"密码不能为空！");
			return false;
		}
		if(!validatorUtil.isNumeric(aginPass)){
			layerUtils.iMsg(-1,"确认"+typeName+"密码为6位数字！");
			return false;
		}
		if(aginPass.length!=6){
			layerUtils.iMsg(-1,"确认"+typeName+"密码长度必须为6位！");
			return false;
		}
		if(!validateCount(aginPass)){
			return false;
		}
		//原始密码和新密码一致
		if(oriPass == newPass){
			layerUtils.iMsg(-1,"新密码和原密码相同！");
			return false;
		}
		if(aginPass != newPass){
			layerUtils.iMsg(-1,"两次密码输入不一致！");
			return false;
		}
		return true;
	}

	function validateCount(password){
		// 判断某一字符出现的次数
		for(var i=0;i<password.length;i++)
		{
			var oneChar = password.charAt(i),
				count = 0;
			var firstPosition = 0;
			for(var j=0;j<password.length;j++)
			{
				if(oneChar == password.charAt(j))
				{
					count++;
				}
			}
			if(count >= 3)
			{
				layerUtils.iAlert("密码中&nbsp;"+oneChar+"&nbsp;出现的次数超过了三次！",-1);
				// 将密码清除
				return false;
			}

		}
		// 判断顺序递增或者递减
		var orderArray = [012345,123456,234567,345678,456789,987654,876543,765432,654321,543210];
		if(orderArray.indexOf(password) != -1)
		{
			layerUtils.iAlert("密码不能是顺序递增或者递减！",-1);
			// 将密码清除
			return false;
		}
		return true;
	}

	function submitPass(){
		var oriPass = $(_pageId+" .oriPass").val();
		var newPass = $(_pageId+" .newPass").val();
		mobileService.getRSAKey({}, function(data) {
			if( data.error_no==0)	//请求获取rsa公钥成功
			{
				//密码采用rsa加密
				var results = data.results[0];
				var modulus = results.modulus;
				var publicExponent =  results.publicExponent;
				var endecryptUtils = require("endecryptUtils");
				
				var oldFundPass = endecryptUtils.rsaEncrypt(modulus, publicExponent, oriPass);  //原资金密码
				var newFunPass = endecryptUtils.rsaEncrypt(modulus, publicExponent,newPass);  //新资金密码
				var userid = appUtils.getSStorageInfo("user_id");
				var zj_account = appUtils.getSStorageInfo("curr_loginid");
				var fundPasswordParam  = {"user_id":userid,"zj_account":zj_account,"oldPassword":oldFundPass,"zj_password":newFunPass};
				var tradePasswordParam = {"user_id":userid,"zj_account":zj_account,"oldPassword":oldFundPass,"jy_password":newFunPass};
				//当密码类型为资金密码时
				if ("fund" == passType){
					mobileService.modifyFundPwd(fundPasswordParam, function(data){
						layerUtils.iLoading(true);
						var errorNo   = data.error_no;
						var errorInfo = data.error_info;
						if(errorNo==0)	//交易密码设置成功，锁定交易密码设置框
						{	
							layerUtils.iAlert("您的资金密码已经修改成功!","0",function(){
								appUtils.pageInit("myAccount/modifyPassword", "index/index",{});
							});
						}
						else
						{
							layerUtils.iLoading(false);
//							layerUtils.iAlert(errorInfo);
							layerUtils.iMsg(-1, errorInfo);
							return false;
						}
					},false);
				}
				else if("trade" == passType){
					mobileService.modifyTradePwd(tradePasswordParam, function(data){
						var errorNo   = data.error_no;
						var errorInfo = data.error_info;
						if(errorNo==0)	//交易密码设置成功，锁定交易密码设置框
						{	
							layerUtils.iAlert("您的交易密码已经修改成功!","0",function(){
								require("sso").ssoLoginOut();
							});
						}
						else
						{
							layerUtils.iLoading(false);
//							layerUtils.iAlert(errorInfo);
							layerUtils.iMsg(-1, errorInfo);
							return false;
						}
					},false);
				}
			}
			else
			{
				layerUtils.iLoading(false);
//				layerUtils.iAlert(data.error_info);
				layerUtils.iMsg(-1,data.error_info);
			}
		}, {isLastReq: true});
	}

	function cleanPageElement(){
		$(_pageId+" .oriPass").val("");
		$(_pageId+" .newPass").val("");
		$(_pageId+" .aginPass").val("");
	}

	function destroy(){

	}
	
	var modifyPassword = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = modifyPassword;
});
