define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var validata = require("validatorUtil");
	var layerUtils = require("layerUtils");
	var _pageId ="#myAccount_modifyPersonInfo";
	var mobileService = require("mobileService");
	var external = require("external");
	

	function init() {
		initPage();
	}

	function bindPageEvent() {
		// 绑定返回
		appUtils.bindEvent($(_pageId+" .icon_back"), function(){
			appUtils.pageInit("myAccount/modifyPersonInfo", "index/index",{});
		});

		// 绑定修改上传头像
		appUtils.bindEvent($(_pageId+" #uploadImg"), function(){
//			 layerUtils.iAlert("敬请期待！");
		});

		// 绑定修改手机号码
		appUtils.bindEvent($(_pageId+" #modifyMobile"), function(){
			appUtils.pageInit("myAccount/modifyPersonInfo", "myAccount/modifyMobile",{});
		});

		// 绑定修改联系地址
		appUtils.bindEvent($(_pageId+" #modifyAddress"), function(){
			appUtils.pageInit("myAccount/modifyPersonInfo", "myAccount/modifyAddress",{});
		});

		// 绑定修改联系人
		appUtils.bindEvent($(_pageId+" #modifyPerson"), function(){
			appUtils.pageInit("myAccount/modifyPersonInfo", "myAccount/modifyLinkMan",{});
		});
	}

	function destroy(){
		mobileService.destroy();
	}
	
	function initPage() {
		$(_pageId+" #mobile").html(appUtils.getSStorageInfo("mobile"));
		$(_pageId+" #address").html(appUtils.getSStorageInfo("address"));
		if(appUtils.getSStorageInfo("emergency_name") == undefined || appUtils.getSStorageInfo("emergency_name") == null){
			$(_pageId+" #emergency_name").html("未添加");
		} else {
			$(_pageId+" #emergency_name").html(appUtils.getSStorageInfo("emergency_name"));
		}
	}
	
	/* 处理请求超时 */
	function handleTimeout() {
		layerUtils.iConfirm("请求超时，是否重新加载？",function(){
			initPage();  // 再次获取银行列表
		});
	}
	
	var modifyPersonInfo = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = modifyPersonInfo;
});
