define(function(require, exports, module) {
	var appUtils = require("appUtils");
	var gconfig = require("gconfig");
	var global = gconfig.global;
	var validata = require("validatorUtil");
	var layerUtils = require("layerUtils");
	var _pageId ="#myAccount_personInfoIndex";
	var mobileService = require("mobileService");
	var external = require("external");
	

	function init() {
		initPage();
		queryRiskInfo();
	}
	
	function initPage() {
		$(_pageId+" #mobile").html(appUtils.getSStorageInfo("mobile"));
		$(_pageId+" #name").html(appUtils.getSStorageInfo("name"));
		$(_pageId+" #idCard").html(appUtils.getSStorageInfo("identity_num"));
		$(_pageId+" #address").html(appUtils.getSStorageInfo("address"));
		var sex = appUtils.getSStorageInfo("sex");
		var sex_name = "女";
		if("0" == sex){
		  	sex_name = "男";
		}else{
			sex_name = "女";
		}
		$(_pageId+" #sex").html(sex_name);
		if(appUtils.getSStorageInfo("telephone") == undefined || appUtils.getSStorageInfo("telephone") == null) {
			$(_pageId+" #telephone").html("未设置");
		} else {
			$(_pageId+" #telephone").html(appUtils.getSStorageInfo("telephone"));
		}
		if(appUtils.getSStorageInfo("emergency_name") == undefined || appUtils.getSStorageInfo("emergency_name") == null){
			$(_pageId+" #emergency_name").html("未添加");
		} else {
			$(_pageId+" #emergency_name").html(appUtils.getSStorageInfo("emergency_name"));
		}
		$(_pageId+" #adapter").html(appUtils.getSStorageInfo("adapter"));
		$(_pageId+" #occupation").html(appUtils.getSStorageInfo("occupational"));
	}
		
	function queryRiskInfo() {
		var getRiskInfo = {
			"user_id":appUtils.getSStorageInfo("user_id"),
			"fundid":appUtils.getSStorageInfo("curr_loginid")
		};
		mobileService.getSurveyInfo(getRiskInfo, function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no == "0"){
				queryThirdDep();
				var subitemname = data.results[0].subitemname;
				$(_pageId+" #name").html(appUtils.getSStorageInfo("name"));
				$(_pageId+" #mobile").html(appUtils.getSStorageInfo("mobile"));
				var risk_level = "";
				//70-100抗风险属性高 65-70（含70）抗风险属性较高 60-65抗风险属性中 55-60（含60）抗风险属性较低 55（含55）抗风险属性低
				if("抗风险属性高" == subitemname){
					risk_level = "高";
				}else if("抗风险属性较高" == subitemname){
					risk_level = "较高";
				}else if("抗风险属性中" == subitemname){
					risk_level = "中";
				}
				else if("抗风险属性较低" == subitemname){
					risk_level = "较低";
				}else if("抗风险属性低" == subitemname){
					risk_level = "低";
				}
				else{
					risk_level = "无";
				}
				$(_pageId+" #risk").html("风险等级承受能力级别："+risk_level);
				
			} else {
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
				return false;
			}
		},{isShowWait:false});
	}
	
	//查询存管银行信息
	function queryThirdDep(){
		var param = {
			"user_id":appUtils.getSStorageInfo("user_id"),
			"zj_account":appUtils.getSStorageInfo("curr_loginid"),
			"flag_status":"0"
		};
		mobileService.getBankList(param, function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no == "0"){
				if(undefined != data.results){
					//显示主资金账号的银行卡和银行
					if("1" == data.results[0].is_main_card){
						//银行名称
						var bank_name = data.results[0].bank_name == undefined || data.results[0].bank_name == "" || data.results[0].bank_name == null ? "未配置" : data.results[0].bank_name;
						var account = data.results[0].account == undefined || data.results[0].account == "" || data.results[0].account == null ? "无" : data.results[0].account;
						$(_pageId+" #bankName").html(bank_name+"   "+account);
					}
				}
				else{
					$(_pageId+" #bankName").html("未配置");
				}
			} else {
//				layerUtils.iAlert(error_info);
				layerUtils.iMsg(-1, error_info);
				return false;
			}
		},{isShowWait:false});
	}
	
	function bindPageEvent() {
		// 绑定返回
		appUtils.bindEvent($(_pageId+" .icon_back"), function(){
			//跳转到我的账户首页
			appUtils.pageInit("myAccount/personInfoIndex", "myAccount/index",{});
		});
		
		// 绑定头像
		appUtils.bindEvent($(_pageId+" #img_form"), function(){
//			appUtils.pageInit("myAccount/personInfoIndex", "myAccount/personInfo",{});
		});
		
		// 绑定三方存管
		appUtils.bindEvent($(_pageId+" #thirdDepos"), function(){
//			layerUtils.iMsg(-1, "敬请期待！");
		});
		
		// 绑定风险测评
		appUtils.bindEvent($(_pageId+" #risks"), function(){
			appUtils.pageInit("myAccount/personInfoIndex", "myAccount/riskAssessment",{});
		});
	}

	function destroy(){

	}
	
	var personInfo = {
		"init" : init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = personInfo;
});
