/**
 * 选择营业部
 */
define(function(require, exports, module) {
	/* 私有业务模块的全局变量 begin */
	var appUtils = require("appUtils"),
		service = require("investService").getInstance(), //业务层接口，请求数据
		global = require("gconfig").global,
		layerUtils = require("layerUtils"),
		shellPlugin = require("shellPlugin"),
		provinceList = "", //省份
		cityList = "", //城市
		branchList = "", //营业部
		commissionList = "", //佣金套餐
		localPro = "", // 本地省份
		localCity = "", // 本地城市
		localBranch = "", // 本地营业部
		branchParam = {
			"branchno": "",
			"commission": ""
		}, //营业部编号
		hasbranch = true, // 判断定位的城市是否拥有营业部
		_pageId = "#account_selDepartment",
		// 填写资料的页面入参
		fillInformationInParam = {
			"idno": "", // 身份证号
			"custname": "", // 客户姓名
			"ethnicname": "", // 民族
			"native": "", // 证件地址
			"policeorg": "", // 签发机关
			"birthday": "", // 出生日期
			"idbegindate": "", // 证件开始日期
			"idenddate": "", // 证件结束日期
			"gender": "", // 用户性别
			"imgPath": "", // 图片的显示地址
			"imgId": "", // 图片 id 
			"branchno": "", //营业部Id
			"commission": "", //佣金套餐
			"postid": "" //邮编
		};
	var external = require("external");
	var platform = require("gconfig").platform;
	/* 私有业务模块的全局变量 end */

	function init() {
		//initPage();  // 初始化页面
		cleanPageElement(); // 清理页面元素值
		getBranch(); // 获取营业部List
	}

	function bindPageEvent() {
		/* 绑定返回 */
		appUtils.bindEvent($(_pageId + " .header .icon_back"), function() {
//			appUtils.clearSStorage("personInfo");
//			appUtils.pageBack();
			appUtils.pageInit("account/selDepartment","account/msgVerify",{});
		});
		/* 点击页面其他元素隐藏下拉列表 */
		appUtils.bindEvent($(_pageId), function(e) {
			$(_pageId + " .sel_list").slideUp("fast"); // 隐藏下拉列表
			e.stopPropagation(); // 阻止冒泡
		});

		/* 绑定选择省份 */
		appUtils.bindEvent($(_pageId + " .mobile_form .sel_province"), function(e) {
			$(_pageId + " .city").hide(); //隐藏城市列表
			$(_pageId + " .branch").hide(); //隐藏营业部列表
			$(_pageId + " .commission").hide(); //隐藏佣金列表
			$(_pageId + " .province ul li").removeClass("active");
			$(_pageId + " .province").slideToggle("fast"); // 显示选择省份的下拉列表
			e.stopPropagation(); // 阻止冒泡
		});

		/* 绑定选择城市 */
		appUtils.bindEvent($(_pageId + " .mobile_form .sel_city"), function(e) {
			$(_pageId + " .province").hide(); //隐藏省份列表
			$(_pageId + " .branch").hide(); //隐藏营业部列表
			$(_pageId + " .commission").hide(); //隐藏佣金列表
			$(_pageId + " .city ul li").removeClass("active");
			$(_pageId + " .city").slideToggle("fast"); // 显示选择城市的下拉列表
			e.stopPropagation(); // 阻止冒泡
		});

		/* 绑定选择营业部 */
		appUtils.bindEvent($(_pageId + " .mobile_form .sel_branch"), function(e) {
			$(_pageId + " .province").hide(); //隐藏省份列表
			$(_pageId + " .city").hide(); //隐藏城市列表
			$(_pageId + " .commission").hide(); //隐藏佣金列表
			$(_pageId + " .branch ul li").removeClass("active");
			$(_pageId + " .branch").slideToggle("fast"); // 显示选择营业厅的下拉列表
			e.stopPropagation(); // 阻止冒泡
		});

		/* 绑定选择佣金套餐 */
		appUtils.bindEvent($(_pageId + " .mobile_form .sel_commission"), function(e) {
			$(_pageId + " .province").hide(); //隐藏省份列表
			$(_pageId + " .city").hide(); //隐藏城市列表
			$(_pageId + " .branch").hide(); //隐藏营业部列表
			$(_pageId + " .commission ul li").removeClass("active");
			$(_pageId + " .commission").slideToggle("fast"); // 显示选择营业厅的下拉列表
			e.stopPropagation(); // 阻止冒泡
		});

		/* 绑定下一步 */
		appUtils.bindEvent($(_pageId + " .fix_bot .ct_btn"), function() {
			var province_name = $(_pageId + " .mobile_form .sel_province").text();
			var city_name = $(_pageId + " .mobile_form .sel_city").text();
			var branch_name = $(_pageId + " .mobile_form .sel_branch").text();
			var imgType = "4,5";
            if (appUtils.getSStorageInfo("openChannel") == "change") {
            	imgType = "4,5,3";
            }
			appUtils.setSStorageInfo("branchno", branchParam.branchno); // 营业部id保存在session
			appUtils.setSStorageInfo("commission", branchParam.commission); // 佣金保存在session
			if (province_name == "请选择省份") {
				layerUtils.iMsg(-1, "请先选择开户省份部");
				return false;
			}
			if (city_name == "请选择城市") {
				layerUtils.iMsg(-1, "请先选择开户城市");
				return false;
			}
			if (branch_name == "请选择营业部") {
				layerUtils.iMsg(-1, "请选择开户营业部");
				return false;
			}
			var phoneConfig = {
				"funcNum": "501525",
				"isBack":0,// 0 正常流程上传调用501526，1 驳回流程上传调用501932
				"uuid": "index",
				"r": Math.random(),
				"userId": appUtils.getSStorageInfo("user_id"),
				"photoType": "身份证", // 影像名称
				"action": "phone", // 照片来源类别，phone 相册，pai 相机
				"imgType": imgType, //需上传图片类型   4 身份证正面  5 反面   3大头照
				"key": "index", // key 和 uuid 只需要写一个
				"url": global.serverPath + ";jsessionid=" + appUtils.getSStorageInfo("jsessionid"),
				"clientInfo": appUtils.getSStorageInfo("clientinfo"), // 从 session 中将 clientinfo 取出
				"funcNo": "60013",
				"moduleName": "open"
			};
			external.callMessage(phoneConfig);
		});
	}

	function destroy() {
		service.destroy();
	}

	/* 初始化页面 */
	function initPage() {
		cleanPageElement(); // 清理页面元素值
		var Commission = appUtils.getSStorageInfo("commission"); // 用户已选佣金id
		var Commission_name = appUtils.getSStorageInfo("commissionname"); // 用户已选佣金值
		var Branch_no = appUtils.getSStorageInfo("branchno"); // 用户已选营业部id
		var Branch_name = appUtils.getSStorageInfo("branchname"); // 用户已选营业部名称
		var Province_name = appUtils.getSStorageInfo("provincename"); // 用户已选省份
		appUtils.iAlert("Province_name"+Province_name);
		var City_name = appUtils.getSStorageInfo("cityname"); // 用户已选城市
		//  用户如果已选择了营业部，就不需要定位
		if (Province_name && City_name && Branch_name) {
			hasbranch = true;
			localPro = Province_name;
			localCity = City_name;
			localBranch = Branch_name;
			branchParam.branchno = Branch_no;
			$(_pageId + " .sel_province").html(Province_name);
			$(_pageId + " .sel_city").html(City_name);
			$(_pageId + " .sel_branch").html(Branch_name);
			if (Commission) {
				branchParam.commission = Commission;
				$(_pageId + " .sel_commission").html(Commission_name);
			}
			getBranch(); // 获取营业部List
		} else {
			getPosition(); // 进行地理定位
		}
	}

	/* 定位本地地址 */
	function getPosition() {
		var positionSign = "";
		layerUtils.iAlert("正在定位中，请稍后....", -1, function() {
			layerUtils.iLayerClose();
			positionSign = "1";
			if (positionSign == "1") {
				getBranch(); // 获取营业部List
			}
		}, "取消");
		var param = {
			"funcNo": "50023"
		};
		var result = external.callMessage(param);
		if (result.error_no == "0" || result.error_no == "1") {
			ip = result.results[0].ip;
			//获取定位省份和城市
			service.getProvCity({
				"ip": ip
			}, function(data) {
				layerUtils.iLayerClose(); // 关闭定位提示
				if (positionSign == "") {
					positionSign = "2";
				}
				if (positionSign == "2") {
					if (data.error_no == 0 && data.results.length != 0) {
						hasbranch = false;
						localPro = data.results[0].province;
						localCity = data.results[0].city;
						$(_pageId + " .sel_province").text(localPro);
						$(_pageId + " .sel_city").text(localCity);
					} else {
						hasbranch = true;
						layerUtils.iMsg(-1, "定位附近营业部失败，请您手动选择", 2);
					}
					getBranch(); // 获取营业部List
				}
			}, false, false);
		} else {
			layerUtils.iAlert(result.error_info);
		}
	}

	/* 获取营业部List */
	function getBranch() {
		service.queryBranch({}, function(data) {
			var error_no = data.error_no;
			var error_info = data.error_info;
			if (error_no == "0" && data.dsName) {
				provinceList = data.provinceList; //省份集合
				cityList = data.cityList; //城市集合
				branchList = data.branchList; //营业部集合
				commissionList = data.commissionList; //佣金集合
				var plen = provinceList.length,
					clen = cityList.length,
					blen = branchList.length,
					colen = commissionList.length;
				var pro_str = "",
					provinceno = "",
					provincename = "";
				// 遍历省份集合
				for (var i = 0; i < plen; i++) {
					provinceno = provinceList[i].provinceno; // 省份id
					provincename = provinceList[i].provincename; // 省份名称
					pro_str += "<li pid='" + provinceno + "'><span>" + provincename + "</span></li>";
					if (localPro != "") // 若定位省份存在，进行填充
					{
						// 填充定位省份下的所有城市
						if (provincename == localPro) {
							var city_str = "",
								pid = "",
								cityno = "",
								cityname = "";
							for (var j = 0; j < clen; j++) {
								pid = cityList[j].provincenno;
								cityno = cityList[j].cityno;
								cityname = cityList[j].cityname;
								if (pid == provinceno) {
									city_str += "<li cid='" + cityno + "'><span>" + cityname + "</span></li>";
								}
							}
							$(_pageId + " .city ul").html(city_str); // 填充城市下拉框
							bindCity(); //点击城市
						}
					}
				}
				$(_pageId + " .province ul").html(pro_str); // 填充省份下拉框
				bindProvince(); //点击省份

				// 存在localCity则遍历所有城市集合
				if (localCity != "") {
					for (var i = 0; i < clen; i++) {
						var cityno = cityList[i].cityno; // 城市id
						var cityname = cityList[i].cityname; // 城市名称
						// 填充定位城市下的所有营业部名称
						if (cityname == localCity) {
							hasbranch = true; // 定位的城市拥有营业部
							var branch_str = "",
								cno = "",
								branchcode = "",
								branchname = "";
							for (var j = 0; j < blen; j++) {
								cno = branchList[j].cityno;
								branchcode = branchList[j].branchcode,
									branchname = branchList[j].branchname;
								if (cno == cityno) {
									branch_str += "<li bid='" + branchcode + "'><span>" + branchname + "</span></li>";
								}
							}
							$(_pageId + " .branch ul").html(branch_str); // 填充对应城市的营业部
							bindBranch(); //点击营业部
						}
					}
					if (!hasbranch) // 定位的城市没有相关营业部
					{
						layerUtils.iMsg(-1, "您当前所处城市无相关营业部，请手动选择", 4);
					}
				}

				// 存在localBranch则遍历所有营业部集合
				if (localBranch != "") {
					for (var i = 0; i < blen; i++) {
						var branchcode = branchList[i].branchcode;
						var branchname = branchList[i].branchname;
						// 填充该营业部下的所有佣金套餐
						if (branchname == localBranch) {
							var commission_str = "",
								bno = "",
								commission = "",
								sortno = "";
							for (var j = 0; j < colen; j++) {
								bno = commissionList[j].branchcode;
								sortno = commissionList[j].sortno,
									commission = commissionList[j].commission;
								if (bno == branchcode) {
									commission_str += "<li yid='" + sortno + "'><span>" + commission + "</span></li>";
								}
							}
							$(_pageId + " .commission ul").html(commission_str); // 填充对应城市的营业部
							bindCommission(); //点击营业部
						}
					}
				}
			} else {
				layerUtils.iMsg(-1, "营业部获取失败"); //提示错误信息
			}
		}, true, true, handleTimeout);
	}

	/* 处理请求超时 */
	function handleTimeout() {
		layerUtils.iConfirm("请求超时，是否重新加载？", function() {
			getBranch(); // 再次获取营业部
		});
	}

	/* 选中省份事件处理 */
	function bindProvince() {
		appUtils.bindEvent($(_pageId + " .province ul li"), function(e) {
			var pid = $(this).attr("pid");
			$(this).addClass("active").siblings().removeClass("active");
			var provincename = $(this).text(); //当前选中省份的值
			var sel_pname = $(_pageId + " .sel_province").text(); //上一次选中省份的值
			$(_pageId + " .sel_province").text(provincename); //将选中值赋给选择框
			appUtils.setSStorageInfo("provincename", provincename);
			$(_pageId + " .province").slideUp("fast"); //隐藏下拉框
			//再次点击相同省份,下级菜单不改变，否则重置
			if (provincename != sel_pname) {
				$(_pageId + " .sel_city").text("请选择城市");
				$(_pageId + " .sel_branch").text("请选择营业部");
				$(_pageId + " .sel_commission").text("请选择佣金套餐");
				$(_pageId + " .branch ul").html("");
				$(_pageId + " .commission ul").html("");
			}
			var provincenno = ""; //省份ID
			var city_str = "";
			//选中省份立即填充相应城市
			for (var i = 0; i < cityList.length; i++) {
				provincenno = cityList[i].provincenno;
				cityno = cityList[i].cityno;
				cityname = cityList[i].cityname;
				if (pid == provincenno) //填充当前省份下的城市列表
				{
					city_str += "<li cid='" + cityno + "'><span>" + cityname + "</span></li>";
				}
			}
			$(_pageId + " .city ul").html(city_str); //填充城市下拉框
			e.stopPropagation(); // 阻止冒泡
			bindCity(); //点击城市
		});
	}

	/* 选中城市事件绑定 */
	function bindCity() {
		appUtils.bindEvent($(_pageId + " .city ul li"), function(e) {
			var cid = $(this).attr("cid");
			$(this).addClass("active").siblings().removeClass("active");
			var cityname = $(this).text(); //当前选择城市的值
			var sel_cname = $(_pageId + " .sel_city").text(); //上次选择城市的值
			$(_pageId + " .sel_city").text(cityname); //选中值赋给选择框
			appUtils.setSStorageInfo("cityname", cityname);
			$(_pageId + " .city").slideUp("fast"); //隐藏下拉框
			//再次点击相同城市,下级菜单不改变，否则重置
			if (sel_cname != cityname) {
				$(_pageId + " .sel_branch").text("请选择营业部");
				$(_pageId + " .sel_commission").text("请选择佣金套餐");
				$(_pageId + " .commission ul").html("");
			}
			//选中城市立即填充相应营业部
			var cityno = ""; //城市ID
			var branch_str = "";
			for (var i = 0; i < branchList.length; i++) {
				cityno = branchList[i].cityno;
				branchcode = branchList[i].branchcode;
				branchname = branchList[i].branchname;
				if (cid == cityno) //填充当前城市下的营业部列表
				{
					branch_str += "<li bid='" + branchcode + "'><span>" + branchname + "</span></li>";
				}
			}
			$(_pageId + " .branch ul").html(branch_str); //填充营业部下拉框
			e.stopPropagation(); // 阻止冒泡
			bindBranch(); //点击营业部
		});
	}

	/* 选中营业部事件绑定*/
	function bindBranch() {
		appUtils.bindEvent($(_pageId + " .branch ul li"), function(e) {
			var bid = $(this).attr("bid");
			$(this).addClass("active").siblings().removeClass("active");
			branchParam.branchno = bid;
			var branchname = $(this).text(); //当前选中营业部的值
			var sel_bname = $(_pageId + " .sel_branch").text(); //上一次选中营业部的值
			$(_pageId + " .sel_branch").attr("branchcode", bid);
			$(_pageId + " .sel_branch").text(branchname); //选中值赋给选择框
			appUtils.setSStorageInfo("branchname", branchname);
			$(_pageId + " .branch").slideUp("fast"); //隐藏下拉框
			//再次点击相同城市,下级菜单不改变，否则重置
			if (sel_bname != branchname) {
				$(_pageId + " .sel_commission").text("请选择佣金套餐");
			}
			// 选中营业部立即填充对应的佣金套餐
			var branchcode = ""; //营业部ID
			var commission_str = "";
			for (var i = 0; i < commissionList.length; i++) {
				branchcode = commissionList[i].branchcode;
				commission = commissionList[i].commission;
				sortno = commissionList[i].sortno;
				if (bid == branchcode) {
					commission_str += "<li yid='" + sortno + "'><span>" + commission + "</span></li>";
				}
			}
			$(_pageId + " .commission ul").html(commission_str); //填充佣金套餐下拉框
			e.stopPropagation(); // 阻止冒泡
			bindCommission(); //点击佣金套餐
		});
	}

	/* 选中佣金事件绑定*/
	function bindCommission() {
			appUtils.bindEvent($(_pageId + " .commission ul li"), function(e) {
				var yid = $(this).attr("yid");
				$(this).addClass("active").siblings().removeClass("active");
				branchParam.commission = yid;
				var commissionname = $(this).text(); //当前选中的佣金值
				$(_pageId + " .sel_commission").attr("commissionname", yid);
				$(_pageId + " .sel_commission").text(commissionname); //选中值赋给选择框
				appUtils.setSStorageInfo("commissionname", commissionname);
				$(_pageId + " .commission").slideUp("fast"); //隐藏下拉框
				e.stopPropagation(); // 阻止冒泡
			});
		}
		/**
		 * 照片上传完成后，会自动调用 imgState 方法，但是该方法只能写在 m/index.html
		 * 或者暴露给 window ，否则无法调用
		 * 已在 init 中暴露给 window
		 */

	function imgState(data) {
			fillInformationInParam.idno = data.idNo; // 身份证号
			appUtils.setSStorageInfo("frestIdCardNo",data.idNo);//保存识别后的身份证号
			fillInformationInParam.custname = data.custName; // 客户姓名
			fillInformationInParam.native = data.native; // 证件地址
			fillInformationInParam.addr = data.native; // 联系地址默认为证件地址
			fillInformationInParam.ethnicname = data.ethnicName; // 民族
			appUtils.setSStorageInfo("ethnicname", data.ethnicName);
			fillInformationInParam.birthday = data.birthday; // 出生日期
			fillInformationInParam.gender = data.userSex; // 用户性别
			fillInformationInParam.policeorg = data.policeOrg; // 签发机关
			fillInformationInParam.idbegindate = data.idbeginDate; // 证件开始日期
			fillInformationInParam.idenddate = data.idendDate; // 证件结束日期
			fillInformationInParam.branchno = branchParam.branchno;
			//校验识别结果
//			if (fillInformationInParam.idno == "") {
//				layerUtils.iMsg(-1, "身份证正面不清晰，请重新上传");
//				return false;
//			}
//			if (fillInformationInParam.custname == "") {
//				layerUtils.iMsg(-1, "身份证正面不清晰，请重新上传");
//				return false;
//			}
//			if (fillInformationInParam.gender == "") {
//				layerUtils.iMsg(-1, "身份证正面不清晰，请重新上传");
//				return false;
//			}
//			if (fillInformationInParam.birthday == "") {
//				layerUtils.iMsg(-1, "身份证正面不清晰，请重新上传");
//				return false;
//			}
//			if (fillInformationInParam.native == "") {
//				layerUtils.iMsg(-1, "身份证正面不清晰，请重新上传");
//				return false;
//			}
//			if (fillInformationInParam.idbegindate == "") {
//				layerUtils.iMsg(-1, "身份证反面不清晰，请重新上传");
//				return false;
//			}
//			if (fillInformationInParam.idenddate == "") {
//				layerUtils.iMsg(-1, "身份证反面不清晰，请重新上传");
//				return false;
//			}
//			if (fillInformationInParam.policeorg == "") {
//				layerUtils.iMsg(-1, "身份证反面不清晰，请重新上传");
//				return false;
//			}
			submitPhoto(); //下一步提交照片
		}
		
		
		/* 提交照片 */
	function submitPhoto() {
			// 提交照片
			fillInformationInParam.user_id = appUtils.getSStorageInfo("user_id");
			fillInformationInParam.infocolect_channel = iBrowser.pc ? 0 : 3, //信息来源渠道 0：PC  3：手机
				fillInformationInParam.idtype = "00";
			fillInformationInParam.idcardmodify = "0";
			fillInformationInParam.nationality = "156";
			fillInformationInParam.edu = "";
			fillInformationInParam.profession_code = "";
			fillInformationInParam.recommendno = "";
			fillInformationInParam.ipaddr = appUtils.getSStorageInfo("ip");
			fillInformationInParam.macaddr = appUtils.getSStorageInfo("mac");
			service.submitPhoto(fillInformationInParam, function(data) {
				var error_no = data.error_no;
				var error_info = data.error_info;
				if (error_no == 0) {
					// 获取邮编
					var postnumParam = {
						"addr": fillInformationInParam.native
					};
					service.queryPostid(postnumParam, function(data) {
						var error_no = data.error_no;
						var postnum = ""; //邮编号码
						if (error_no == 0 && data.results.length != 0) {
							postnum = data.results[0].post;
							fillInformationInParam.postid = postnum;
						}
						// 将数据保存到 session 中
						appUtils.setSStorageInfo("custname", fillInformationInParam.custname);
						appUtils.setSStorageInfo("idCardNo", fillInformationInParam.idno);
						appUtils.setSStorageInfo("policeorg", fillInformationInParam.policeorg);
						appUtils.setSStorageInfo("native", fillInformationInParam.native);
						appUtils.setSStorageInfo("addr", fillInformationInParam.native);
						appUtils.setSStorageInfo("postid", fillInformationInParam.postid);
						appUtils.setSStorageInfo("idbegindate", fillInformationInParam.idbegindate);
						appUtils.setSStorageInfo("idenddate", fillInformationInParam.idenddate);
						setTimeout(function() {
							appUtils.pageInit("account/selDepartment", "account/personInfo", fillInformationInParam);
						}, 300);
						appUtils.clearSStorage("personInfo"); // 清除资料提交步骤标记
						appUtils.clearSStorage("currentStep"); // 清除用户步骤记录
					}, false);
				} else {
					layerUtils.iLoading(false);
					layerUtils.iAlert(data.error_info, -1);
				}
			}, false);
		}
		/* 清理界面元素 */

	function cleanPageElement() {
		hasbranch = false;
//		$(_pageId + " .header .icon_back").hide(); //隐藏返回按钮
		$(_pageId + " .sel_province").text("请选择省份");
		$(_pageId + " .sel_city").text("请选择城市");
		$(_pageId + " .sel_branch").text("请选择营业部");
		$(_pageId + " .sel_commssion").text("请选择佣金套餐");
	}
	var selDepartment = {
		"init": init,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"imgState": imgState
	};

	// 暴露对外的接口
	module.exports = selDepartment;
});